/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull,requireInstance}from"../assert";import{MathUtil}from"../MathUtil";import{LocalDate}from"../LocalDate";import{Instant}from"../Instant";import{ZoneOffset}from"../ZoneOffset";import{ChronoUnit}from"../temporal/ChronoUnit";import{ChronoField}from"../temporal/ChronoField";import{Temporal}from"../temporal/Temporal";import{TemporalQueries}from"../temporal/TemporalQueries";export class ChronoLocalDateTime extends Temporal{chronology(){return this.toLocalDate().chronology()}query(query){return query===TemporalQueries.chronology()?this.chronology():query===TemporalQueries.precision()?ChronoUnit.NANOS:query===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toLocalDate().toEpochDay()):query===TemporalQueries.localTime()?this.toLocalTime():query===TemporalQueries.zone()||query===TemporalQueries.zoneId()||query===TemporalQueries.offset()?null:super.query(query)}adjustInto(temporal){return temporal.with(ChronoField.EPOCH_DAY,this.toLocalDate().toEpochDay()).with(ChronoField.NANO_OF_DAY,this.toLocalTime().toNanoOfDay())}toInstant(offset){return requireInstance(offset,ZoneOffset,"zoneId"),Instant.ofEpochSecond(this.toEpochSecond(offset),this.toLocalTime().nano())}toEpochSecond(offset){requireNonNull(offset,"offset");let secs=86400*this.toLocalDate().toEpochDay()+this.toLocalTime().toSecondOfDay();return secs-=offset.totalSeconds(),MathUtil.safeToInt(secs)}}