"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var coreRestPipeline=require("@azure/core-rest-pipeline"),logger$1=require("@azure/logger");function encodeByteArray(value){return(value instanceof Buffer?value:Buffer.from(value.buffer)).toString("base64")}function decodeString(value){return Buffer.from(value,"base64")}function decodeStringToString(value){return Buffer.from(value,"base64").toString()}const XML_ATTRKEY="$",XML_CHARKEY="_";function isPrimitiveBody(value,mapperTypeName){return"Composite"!==mapperTypeName&&"Dictionary"!==mapperTypeName&&("string"==typeof value||"number"==typeof value||"boolean"==typeof value||null!==(null==mapperTypeName?void 0:mapperTypeName.match(/^(Date|DateTime|DateTimeRfc1123|UnixTime|ByteArray|Base64Url)$/i))||null==value)}const validateISODuration=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function isDuration(value){return validateISODuration.test(value)}const validUuidRegex=/^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/i;function isValidUuid(uuid){return validUuidRegex.test(uuid)}function handleNullableResponseAndWrappableBody(responseObject){const combinedHeadersAndBody=Object.assign(Object.assign({},responseObject.headers),responseObject.body);return responseObject.hasNullableType&&0===Object.getOwnPropertyNames(combinedHeadersAndBody).length?responseObject.shouldWrapBody?{body:null}:null:responseObject.shouldWrapBody?Object.assign(Object.assign({},responseObject.headers),{body:responseObject.body}):combinedHeadersAndBody}function flattenResponse(fullResponse,responseSpec){var _a,_b;const parsedHeaders=fullResponse.parsedHeaders;if("HEAD"===fullResponse.request.method)return Object.assign(Object.assign({},parsedHeaders),{body:fullResponse.parsedBody});const bodyMapper=responseSpec&&responseSpec.bodyMapper,isNullable=Boolean(null==bodyMapper?void 0:bodyMapper.nullable),expectedBodyTypeName=null==bodyMapper?void 0:bodyMapper.type.name;if("Stream"===expectedBodyTypeName)return Object.assign(Object.assign({},parsedHeaders),{blobBody:fullResponse.blobBody,readableStreamBody:fullResponse.readableStreamBody});const modelProperties="Composite"===expectedBodyTypeName&&bodyMapper.type.modelProperties||{},isPageableResponse=Object.keys(modelProperties).some((k=>""===modelProperties[k].serializedName));if("Sequence"===expectedBodyTypeName||isPageableResponse){const arrayResponse=null!==(_a=fullResponse.parsedBody)&&void 0!==_a?_a:[];for(const key of Object.keys(modelProperties))modelProperties[key].serializedName&&(arrayResponse[key]=null===(_b=fullResponse.parsedBody)||void 0===_b?void 0:_b[key]);if(parsedHeaders)for(const key of Object.keys(parsedHeaders))arrayResponse[key]=parsedHeaders[key];return!isNullable||fullResponse.parsedBody||parsedHeaders||0!==Object.getOwnPropertyNames(modelProperties).length?arrayResponse:null}return handleNullableResponseAndWrappableBody({body:fullResponse.parsedBody,headers:parsedHeaders,hasNullableType:isNullable,shouldWrapBody:isPrimitiveBody(fullResponse.parsedBody,expectedBodyTypeName)})}class SerializerImpl{constructor(modelMappers={},isXML=!1){this.modelMappers=modelMappers,this.isXML=isXML}validateConstraints(mapper,value,objectName){const failValidation=(constraintName,constraintValue)=>{throw new Error(`"${objectName}" with value "${value}" should satisfy the constraint "${constraintName}": ${constraintValue}.`)};if(mapper.constraints&&null!=value){const{ExclusiveMaximum:ExclusiveMaximum,ExclusiveMinimum:ExclusiveMinimum,InclusiveMaximum:InclusiveMaximum,InclusiveMinimum:InclusiveMinimum,MaxItems:MaxItems,MaxLength:MaxLength,MinItems:MinItems,MinLength:MinLength,MultipleOf:MultipleOf,Pattern:Pattern,UniqueItems:UniqueItems}=mapper.constraints;if(void 0!==ExclusiveMaximum&&value>=ExclusiveMaximum&&failValidation("ExclusiveMaximum",ExclusiveMaximum),void 0!==ExclusiveMinimum&&value<=ExclusiveMinimum&&failValidation("ExclusiveMinimum",ExclusiveMinimum),void 0!==InclusiveMaximum&&value>InclusiveMaximum&&failValidation("InclusiveMaximum",InclusiveMaximum),void 0!==InclusiveMinimum&&value<InclusiveMinimum&&failValidation("InclusiveMinimum",InclusiveMinimum),void 0!==MaxItems&&value.length>MaxItems&&failValidation("MaxItems",MaxItems),void 0!==MaxLength&&value.length>MaxLength&&failValidation("MaxLength",MaxLength),void 0!==MinItems&&value.length<MinItems&&failValidation("MinItems",MinItems),void 0!==MinLength&&value.length<MinLength&&failValidation("MinLength",MinLength),void 0!==MultipleOf&&value%MultipleOf!=0&&failValidation("MultipleOf",MultipleOf),Pattern){const pattern="string"==typeof Pattern?new RegExp(Pattern):Pattern;"string"==typeof value&&null!==value.match(pattern)||failValidation("Pattern",Pattern)}UniqueItems&&value.some(((item,i,ar)=>ar.indexOf(item)!==i))&&failValidation("UniqueItems",UniqueItems)}}serialize(mapper,object,objectName,options={xml:{}}){var _a,_b,_c;const updatedOptions={xml:{rootName:null!==(_a=options.xml.rootName)&&void 0!==_a?_a:"",includeRoot:null!==(_b=options.xml.includeRoot)&&void 0!==_b&&_b,xmlCharKey:null!==(_c=options.xml.xmlCharKey)&&void 0!==_c?_c:XML_CHARKEY}};let payload={};const mapperType=mapper.type.name;objectName||(objectName=mapper.serializedName),null!==mapperType.match(/^Sequence$/i)&&(payload=[]),mapper.isConstant&&(object=mapper.defaultValue);const{required:required,nullable:nullable}=mapper;if(required&&nullable&&void 0===object)throw new Error(`${objectName} cannot be undefined.`);if(required&&!nullable&&null==object)throw new Error(`${objectName} cannot be null or undefined.`);if(!required&&!1===nullable&&null===object)throw new Error(`${objectName} cannot be null.`);if(null==object)payload=object;else if(null!==mapperType.match(/^any$/i))payload=object;else if(null!==mapperType.match(/^(Number|String|Boolean|Object|Stream|Uuid)$/i))payload=serializeBasicTypes(mapperType,objectName,object);else if(null!==mapperType.match(/^Enum$/i)){payload=serializeEnumType(objectName,mapper.type.allowedValues,object)}else null!==mapperType.match(/^(Date|DateTime|TimeSpan|DateTimeRfc1123|UnixTime)$/i)?payload=serializeDateTypes(mapperType,object,objectName):null!==mapperType.match(/^ByteArray$/i)?payload=serializeByteArrayType(objectName,object):null!==mapperType.match(/^Base64Url$/i)?payload=serializeBase64UrlType(objectName,object):null!==mapperType.match(/^Sequence$/i)?payload=serializeSequenceType(this,mapper,object,objectName,Boolean(this.isXML),updatedOptions):null!==mapperType.match(/^Dictionary$/i)?payload=serializeDictionaryType(this,mapper,object,objectName,Boolean(this.isXML),updatedOptions):null!==mapperType.match(/^Composite$/i)&&(payload=serializeCompositeType(this,mapper,object,objectName,Boolean(this.isXML),updatedOptions));return payload}deserialize(mapper,responseBody,objectName,options={xml:{}}){var _a,_b,_c,_d;const updatedOptions={xml:{rootName:null!==(_a=options.xml.rootName)&&void 0!==_a?_a:"",includeRoot:null!==(_b=options.xml.includeRoot)&&void 0!==_b&&_b,xmlCharKey:null!==(_c=options.xml.xmlCharKey)&&void 0!==_c?_c:XML_CHARKEY},ignoreUnknownProperties:null!==(_d=options.ignoreUnknownProperties)&&void 0!==_d&&_d};if(null==responseBody)return this.isXML&&"Sequence"===mapper.type.name&&!mapper.xmlIsWrapped&&(responseBody=[]),void 0!==mapper.defaultValue&&(responseBody=mapper.defaultValue),responseBody;let payload;const mapperType=mapper.type.name;if(objectName||(objectName=mapper.serializedName),null!==mapperType.match(/^Composite$/i))payload=deserializeCompositeType(this,mapper,responseBody,objectName,updatedOptions);else{if(this.isXML){const xmlCharKey=updatedOptions.xml.xmlCharKey;void 0!==responseBody[XML_ATTRKEY]&&void 0!==responseBody[xmlCharKey]&&(responseBody=responseBody[xmlCharKey])}null!==mapperType.match(/^Number$/i)?(payload=parseFloat(responseBody),isNaN(payload)&&(payload=responseBody)):null!==mapperType.match(/^Boolean$/i)?payload="true"===responseBody||"false"!==responseBody&&responseBody:null!==mapperType.match(/^(String|Enum|Object|Stream|Uuid|TimeSpan|any)$/i)?payload=responseBody:null!==mapperType.match(/^(Date|DateTime|DateTimeRfc1123)$/i)?payload=new Date(responseBody):null!==mapperType.match(/^UnixTime$/i)?payload=unixTimeToDate(responseBody):null!==mapperType.match(/^ByteArray$/i)?payload=decodeString(responseBody):null!==mapperType.match(/^Base64Url$/i)?payload=base64UrlToByteArray(responseBody):null!==mapperType.match(/^Sequence$/i)?payload=deserializeSequenceType(this,mapper,responseBody,objectName,updatedOptions):null!==mapperType.match(/^Dictionary$/i)&&(payload=deserializeDictionaryType(this,mapper,responseBody,objectName,updatedOptions))}return mapper.isConstant&&(payload=mapper.defaultValue),payload}}function createSerializer(modelMappers={},isXML=!1){return new SerializerImpl(modelMappers,isXML)}function trimEnd(str,ch){let len=str.length;for(;len-1>=0&&str[len-1]===ch;)--len;return str.substr(0,len)}function bufferToBase64Url(buffer){if(!buffer)return;if(!(buffer instanceof Uint8Array))throw new Error("Please provide an input of type Uint8Array for converting to Base64Url.");return trimEnd(encodeByteArray(buffer),"=").replace(/\+/g,"-").replace(/\//g,"_")}function base64UrlToByteArray(str){if(str){if(str&&"string"!=typeof str.valueOf())throw new Error("Please provide an input of type string for converting to Uint8Array");return decodeString(str=str.replace(/-/g,"+").replace(/_/g,"/"))}}function splitSerializeName(prop){const classes=[];let partialclass="";if(prop){const subwords=prop.split(".");for(const item of subwords)"\\"===item.charAt(item.length-1)?partialclass+=item.substr(0,item.length-1)+".":(partialclass+=item,classes.push(partialclass),partialclass="")}return classes}function dateToUnixTime(d){if(d)return"string"==typeof d.valueOf()&&(d=new Date(d)),Math.floor(d.getTime()/1e3)}function unixTimeToDate(n){if(n)return new Date(1e3*n)}function serializeBasicTypes(typeName,objectName,value){if(null!=value)if(null!==typeName.match(/^Number$/i)){if("number"!=typeof value)throw new Error(`${objectName} with value ${value} must be of type number.`)}else if(null!==typeName.match(/^String$/i)){if("string"!=typeof value.valueOf())throw new Error(`${objectName} with value "${value}" must be of type string.`)}else if(null!==typeName.match(/^Uuid$/i)){if("string"!=typeof value.valueOf()||!isValidUuid(value))throw new Error(`${objectName} with value "${value}" must be of type string and a valid uuid.`)}else if(null!==typeName.match(/^Boolean$/i)){if("boolean"!=typeof value)throw new Error(`${objectName} with value ${value} must be of type boolean.`)}else if(null!==typeName.match(/^Stream$/i)){const objectType=typeof value;if(!("string"===objectType||"function"==typeof value.pipe||value instanceof ArrayBuffer||ArrayBuffer.isView(value)||("function"==typeof Blob||"object"==typeof Blob)&&value instanceof Blob||"function"===objectType))throw new Error(`${objectName} must be a string, Blob, ArrayBuffer, ArrayBufferView, NodeJS.ReadableStream, or () => NodeJS.ReadableStream.`)}return value}function serializeEnumType(objectName,allowedValues,value){if(!allowedValues)throw new Error(`Please provide a set of allowedValues to validate ${objectName} as an Enum Type.`);if(!allowedValues.some((item=>"string"==typeof item.valueOf()?item.toLowerCase()===value.toLowerCase():item===value)))throw new Error(`${value} is not a valid value for ${objectName}. The valid values are: ${JSON.stringify(allowedValues)}.`);return value}function serializeByteArrayType(objectName,value){if(null!=value){if(!(value instanceof Uint8Array))throw new Error(`${objectName} must be of type Uint8Array.`);value=encodeByteArray(value)}return value}function serializeBase64UrlType(objectName,value){if(null!=value){if(!(value instanceof Uint8Array))throw new Error(`${objectName} must be of type Uint8Array.`);value=bufferToBase64Url(value)}return value}function serializeDateTypes(typeName,value,objectName){if(null!=value)if(null!==typeName.match(/^Date$/i)){if(!(value instanceof Date||"string"==typeof value.valueOf()&&!isNaN(Date.parse(value))))throw new Error(`${objectName} must be an instanceof Date or a string in ISO8601 format.`);value=value instanceof Date?value.toISOString().substring(0,10):new Date(value).toISOString().substring(0,10)}else if(null!==typeName.match(/^DateTime$/i)){if(!(value instanceof Date||"string"==typeof value.valueOf()&&!isNaN(Date.parse(value))))throw new Error(`${objectName} must be an instanceof Date or a string in ISO8601 format.`);value=value instanceof Date?value.toISOString():new Date(value).toISOString()}else if(null!==typeName.match(/^DateTimeRfc1123$/i)){if(!(value instanceof Date||"string"==typeof value.valueOf()&&!isNaN(Date.parse(value))))throw new Error(`${objectName} must be an instanceof Date or a string in RFC-1123 format.`);value=value instanceof Date?value.toUTCString():new Date(value).toUTCString()}else if(null!==typeName.match(/^UnixTime$/i)){if(!(value instanceof Date||"string"==typeof value.valueOf()&&!isNaN(Date.parse(value))))throw new Error(`${objectName} must be an instanceof Date or a string in RFC-1123/ISO8601 format for it to be serialized in UnixTime/Epoch format.`);value=dateToUnixTime(value)}else if(null!==typeName.match(/^TimeSpan$/i)&&!isDuration(value))throw new Error(`${objectName} must be a string in ISO 8601 format. Instead was "${value}".`);return value}function serializeSequenceType(serializer,mapper,object,objectName,isXml,options){var _a;if(!Array.isArray(object))throw new Error(`${objectName} must be of type Array.`);let elementType=mapper.type.element;if(!elementType||"object"!=typeof elementType)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${objectName}.`);"Composite"===elementType.type.name&&elementType.type.className&&(elementType=null!==(_a=serializer.modelMappers[elementType.type.className])&&void 0!==_a?_a:elementType);const tempArray=[];for(let i=0;i<object.length;i++){const serializedValue=serializer.serialize(elementType,object[i],objectName,options);if(isXml&&elementType.xmlNamespace){const xmlnsKey=elementType.xmlNamespacePrefix?`xmlns:${elementType.xmlNamespacePrefix}`:"xmlns";"Composite"===elementType.type.name?(tempArray[i]=Object.assign({},serializedValue),tempArray[i][XML_ATTRKEY]={[xmlnsKey]:elementType.xmlNamespace}):(tempArray[i]={},tempArray[i][options.xml.xmlCharKey]=serializedValue,tempArray[i][XML_ATTRKEY]={[xmlnsKey]:elementType.xmlNamespace})}else tempArray[i]=serializedValue}return tempArray}function serializeDictionaryType(serializer,mapper,object,objectName,isXml,options){if("object"!=typeof object)throw new Error(`${objectName} must be of type object.`);const valueType=mapper.type.value;if(!valueType||"object"!=typeof valueType)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${objectName}.`);const tempDictionary={};for(const key of Object.keys(object)){const serializedValue=serializer.serialize(valueType,object[key],objectName,options);tempDictionary[key]=getXmlObjectValue(valueType,serializedValue,isXml,options)}if(isXml&&mapper.xmlNamespace){const xmlnsKey=mapper.xmlNamespacePrefix?`xmlns:${mapper.xmlNamespacePrefix}`:"xmlns",result=tempDictionary;return result[XML_ATTRKEY]={[xmlnsKey]:mapper.xmlNamespace},result}return tempDictionary}function resolveAdditionalProperties(serializer,mapper,objectName){const additionalProperties=mapper.type.additionalProperties;if(!additionalProperties&&mapper.type.className){const modelMapper=resolveReferencedMapper(serializer,mapper,objectName);return null==modelMapper?void 0:modelMapper.type.additionalProperties}return additionalProperties}function resolveReferencedMapper(serializer,mapper,objectName){const className=mapper.type.className;if(!className)throw new Error(`Class name for model "${objectName}" is not provided in the mapper "${JSON.stringify(mapper,void 0,2)}".`);return serializer.modelMappers[className]}function resolveModelProperties(serializer,mapper,objectName){let modelProps=mapper.type.modelProperties;if(!modelProps){const modelMapper=resolveReferencedMapper(serializer,mapper,objectName);if(!modelMapper)throw new Error(`mapper() cannot be null or undefined for model "${mapper.type.className}".`);if(modelProps=null==modelMapper?void 0:modelMapper.type.modelProperties,!modelProps)throw new Error(`modelProperties cannot be null or undefined in the mapper "${JSON.stringify(modelMapper)}" of type "${mapper.type.className}" for object "${objectName}".`)}return modelProps}function serializeCompositeType(serializer,mapper,object,objectName,isXml,options){if(getPolymorphicDiscriminatorRecursively(serializer,mapper)&&(mapper=getPolymorphicMapper(serializer,mapper,object,"clientName")),null!=object){const payload={},modelProps=resolveModelProperties(serializer,mapper,objectName);for(const key of Object.keys(modelProps)){const propertyMapper=modelProps[key];if(propertyMapper.readOnly)continue;let propName,parentObject=payload;if(serializer.isXML)propName=propertyMapper.xmlIsWrapped?propertyMapper.xmlName:propertyMapper.xmlElementName||propertyMapper.xmlName;else{const paths=splitSerializeName(propertyMapper.serializedName);propName=paths.pop();for(const pathName of paths){const childObject=parentObject[pathName];null==childObject&&(void 0!==object[key]&&null!==object[key]||void 0!==propertyMapper.defaultValue)&&(parentObject[pathName]={}),parentObject=parentObject[pathName]}}if(null!=parentObject){if(isXml&&mapper.xmlNamespace){const xmlnsKey=mapper.xmlNamespacePrefix?`xmlns:${mapper.xmlNamespacePrefix}`:"xmlns";parentObject[XML_ATTRKEY]=Object.assign(Object.assign({},parentObject[XML_ATTRKEY]),{[xmlnsKey]:mapper.xmlNamespace})}const propertyObjectName=""!==propertyMapper.serializedName?objectName+"."+propertyMapper.serializedName:objectName;let toSerialize=object[key];const polymorphicDiscriminator=getPolymorphicDiscriminatorRecursively(serializer,mapper);polymorphicDiscriminator&&polymorphicDiscriminator.clientName===key&&null==toSerialize&&(toSerialize=mapper.serializedName);const serializedValue=serializer.serialize(propertyMapper,toSerialize,propertyObjectName,options);if(void 0!==serializedValue&&null!=propName){const value=getXmlObjectValue(propertyMapper,serializedValue,isXml,options);isXml&&propertyMapper.xmlIsAttribute?(parentObject[XML_ATTRKEY]=parentObject[XML_ATTRKEY]||{},parentObject[XML_ATTRKEY][propName]=serializedValue):isXml&&propertyMapper.xmlIsWrapped?parentObject[propName]={[propertyMapper.xmlElementName]:value}:parentObject[propName]=value}}}const additionalPropertiesMapper=resolveAdditionalProperties(serializer,mapper,objectName);if(additionalPropertiesMapper){const propNames=Object.keys(modelProps);for(const clientPropName in object){propNames.every((pn=>pn!==clientPropName))&&(payload[clientPropName]=serializer.serialize(additionalPropertiesMapper,object[clientPropName],objectName+'["'+clientPropName+'"]',options))}}return payload}return object}function getXmlObjectValue(propertyMapper,serializedValue,isXml,options){if(!isXml||!propertyMapper.xmlNamespace)return serializedValue;const xmlNamespace={[propertyMapper.xmlNamespacePrefix?`xmlns:${propertyMapper.xmlNamespacePrefix}`:"xmlns"]:propertyMapper.xmlNamespace};if(["Composite"].includes(propertyMapper.type.name)){if(serializedValue[XML_ATTRKEY])return serializedValue;{const result=Object.assign({},serializedValue);return result[XML_ATTRKEY]=xmlNamespace,result}}const result={};return result[options.xml.xmlCharKey]=serializedValue,result[XML_ATTRKEY]=xmlNamespace,result}function isSpecialXmlProperty(propertyName,options){return[XML_ATTRKEY,options.xml.xmlCharKey].includes(propertyName)}function deserializeCompositeType(serializer,mapper,responseBody,objectName,options){var _a,_b;const xmlCharKey=null!==(_a=options.xml.xmlCharKey)&&void 0!==_a?_a:XML_CHARKEY;getPolymorphicDiscriminatorRecursively(serializer,mapper)&&(mapper=getPolymorphicMapper(serializer,mapper,responseBody,"serializedName"));const modelProps=resolveModelProperties(serializer,mapper,objectName);let instance={};const handledPropertyNames=[];for(const key of Object.keys(modelProps)){const propertyMapper=modelProps[key],paths=splitSerializeName(modelProps[key].serializedName);handledPropertyNames.push(paths[0]);const{serializedName:serializedName,xmlName:xmlName,xmlElementName:xmlElementName}=propertyMapper;let propertyObjectName=objectName;""!==serializedName&&void 0!==serializedName&&(propertyObjectName=objectName+"."+serializedName);const headerCollectionPrefix=propertyMapper.headerCollectionPrefix;if(headerCollectionPrefix){const dictionary={};for(const headerKey of Object.keys(responseBody))headerKey.startsWith(headerCollectionPrefix)&&(dictionary[headerKey.substring(headerCollectionPrefix.length)]=serializer.deserialize(propertyMapper.type.value,responseBody[headerKey],propertyObjectName,options)),handledPropertyNames.push(headerKey);instance[key]=dictionary}else if(serializer.isXML)if(propertyMapper.xmlIsAttribute&&responseBody[XML_ATTRKEY])instance[key]=serializer.deserialize(propertyMapper,responseBody[XML_ATTRKEY][xmlName],propertyObjectName,options);else if(propertyMapper.xmlIsMsText)void 0!==responseBody[xmlCharKey]?instance[key]=responseBody[xmlCharKey]:"string"==typeof responseBody&&(instance[key]=responseBody);else{const propertyName=xmlElementName||xmlName||serializedName;if(propertyMapper.xmlIsWrapped){const wrapped=responseBody[xmlName],elementList=null!==(_b=null==wrapped?void 0:wrapped[xmlElementName])&&void 0!==_b?_b:[];instance[key]=serializer.deserialize(propertyMapper,elementList,propertyObjectName,options),handledPropertyNames.push(xmlName)}else{const property=responseBody[propertyName];instance[key]=serializer.deserialize(propertyMapper,property,propertyObjectName,options),handledPropertyNames.push(propertyName)}}else{let propertyInstance,res=responseBody,steps=0;for(const item of paths){if(!res)break;steps++,res=res[item]}null===res&&steps<paths.length&&(res=void 0),propertyInstance=res;const polymorphicDiscriminator=mapper.type.polymorphicDiscriminator;let serializedValue;if(polymorphicDiscriminator&&key===polymorphicDiscriminator.clientName&&null==propertyInstance&&(propertyInstance=mapper.serializedName),Array.isArray(responseBody[key])&&""===modelProps[key].serializedName){propertyInstance=responseBody[key];const arrayInstance=serializer.deserialize(propertyMapper,propertyInstance,propertyObjectName,options);for(const[k,v]of Object.entries(instance))Object.prototype.hasOwnProperty.call(arrayInstance,k)||(arrayInstance[k]=v);instance=arrayInstance}else void 0===propertyInstance&&void 0===propertyMapper.defaultValue||(serializedValue=serializer.deserialize(propertyMapper,propertyInstance,propertyObjectName,options),instance[key]=serializedValue)}}const additionalPropertiesMapper=mapper.type.additionalProperties;if(additionalPropertiesMapper){const isAdditionalProperty=responsePropName=>{for(const clientPropName in modelProps){if(splitSerializeName(modelProps[clientPropName].serializedName)[0]===responsePropName)return!1}return!0};for(const responsePropName in responseBody)isAdditionalProperty(responsePropName)&&(instance[responsePropName]=serializer.deserialize(additionalPropertiesMapper,responseBody[responsePropName],objectName+'["'+responsePropName+'"]',options))}else if(responseBody&&!options.ignoreUnknownProperties)for(const key of Object.keys(responseBody))void 0!==instance[key]||handledPropertyNames.includes(key)||isSpecialXmlProperty(key,options)||(instance[key]=responseBody[key]);return instance}function deserializeDictionaryType(serializer,mapper,responseBody,objectName,options){const value=mapper.type.value;if(!value||"object"!=typeof value)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${objectName}`);if(responseBody){const tempDictionary={};for(const key of Object.keys(responseBody))tempDictionary[key]=serializer.deserialize(value,responseBody[key],objectName,options);return tempDictionary}return responseBody}function deserializeSequenceType(serializer,mapper,responseBody,objectName,options){var _a;let element=mapper.type.element;if(!element||"object"!=typeof element)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${objectName}`);if(responseBody){Array.isArray(responseBody)||(responseBody=[responseBody]),"Composite"===element.type.name&&element.type.className&&(element=null!==(_a=serializer.modelMappers[element.type.className])&&void 0!==_a?_a:element);const tempArray=[];for(let i=0;i<responseBody.length;i++)tempArray[i]=serializer.deserialize(element,responseBody[i],`${objectName}[${i}]`,options);return tempArray}return responseBody}function getIndexDiscriminator(discriminators,discriminatorValue,typeName){const typeNamesToCheck=[typeName];for(;typeNamesToCheck.length;){const currentName=typeNamesToCheck.shift(),indexDiscriminator=discriminatorValue===currentName?discriminatorValue:currentName+"."+discriminatorValue;if(Object.prototype.hasOwnProperty.call(discriminators,indexDiscriminator))return discriminators[indexDiscriminator];for(const[name,mapper]of Object.entries(discriminators))name.startsWith(currentName+".")&&mapper.type.uberParent===currentName&&mapper.type.className&&typeNamesToCheck.push(mapper.type.className)}}function getPolymorphicMapper(serializer,mapper,object,polymorphicPropertyName){var _a;const polymorphicDiscriminator=getPolymorphicDiscriminatorRecursively(serializer,mapper);if(polymorphicDiscriminator){let discriminatorName=polymorphicDiscriminator[polymorphicPropertyName];if(discriminatorName){"serializedName"===polymorphicPropertyName&&(discriminatorName=discriminatorName.replace(/\\/gi,""));const discriminatorValue=object[discriminatorName],typeName=null!==(_a=mapper.type.uberParent)&&void 0!==_a?_a:mapper.type.className;if("string"==typeof discriminatorValue&&typeName){const polymorphicMapper=getIndexDiscriminator(serializer.modelMappers.discriminators,discriminatorValue,typeName);polymorphicMapper&&(mapper=polymorphicMapper)}}}return mapper}function getPolymorphicDiscriminatorRecursively(serializer,mapper){return mapper.type.polymorphicDiscriminator||getPolymorphicDiscriminatorSafely(serializer,mapper.type.uberParent)||getPolymorphicDiscriminatorSafely(serializer,mapper.type.className)}function getPolymorphicDiscriminatorSafely(serializer,typeName){return typeName&&serializer.modelMappers[typeName]&&serializer.modelMappers[typeName].type.polymorphicDiscriminator}const MapperTypeNames={Base64Url:"Base64Url",Boolean:"Boolean",ByteArray:"ByteArray",Composite:"Composite",Date:"Date",DateTime:"DateTime",DateTimeRfc1123:"DateTimeRfc1123",Dictionary:"Dictionary",Enum:"Enum",Number:"Number",Object:"Object",Sequence:"Sequence",String:"String",Stream:"Stream",TimeSpan:"TimeSpan",UnixTime:"UnixTime"};function getOperationArgumentValueFromParameter(operationArguments,parameter,fallbackObject){let parameterPath=parameter.parameterPath;const parameterMapper=parameter.mapper;let value;if("string"==typeof parameterPath&&(parameterPath=[parameterPath]),Array.isArray(parameterPath)){if(parameterPath.length>0)if(parameterMapper.isConstant)value=parameterMapper.defaultValue;else{let propertySearchResult=getPropertyFromParameterPath(operationArguments,parameterPath);!propertySearchResult.propertyFound&&fallbackObject&&(propertySearchResult=getPropertyFromParameterPath(fallbackObject,parameterPath));let useDefaultValue=!1;propertySearchResult.propertyFound||(useDefaultValue=parameterMapper.required||"options"===parameterPath[0]&&2===parameterPath.length),value=useDefaultValue?parameterMapper.defaultValue:propertySearchResult.propertyValue}}else{parameterMapper.required&&(value={});for(const propertyName in parameterPath){const propertyMapper=parameterMapper.type.modelProperties[propertyName],propertyValue=getOperationArgumentValueFromParameter(operationArguments,{parameterPath:parameterPath[propertyName],mapper:propertyMapper},fallbackObject);void 0!==propertyValue&&(value||(value={}),value[propertyName]=propertyValue)}}return value}function getPropertyFromParameterPath(parent,parameterPath){const result={propertyFound:!1};let i=0;for(;i<parameterPath.length;++i){const parameterPathPart=parameterPath[i];if(!parent||!(parameterPathPart in parent))break;parent=parent[parameterPathPart]}return i===parameterPath.length&&(result.propertyValue=parent,result.propertyFound=!0),result}const operationRequestMap=new WeakMap,originalRequestSymbol=Symbol.for("@azure/core-client original request");function hasOriginalRequest(request){return originalRequestSymbol in request}function getOperationRequestInfo(request){if(hasOriginalRequest(request))return getOperationRequestInfo(request[originalRequestSymbol]);let info=operationRequestMap.get(request);return info||(info={},operationRequestMap.set(request,info)),info}const defaultJsonContentTypes=["application/json","text/json"],defaultXmlContentTypes=["application/xml","application/atom+xml"],deserializationPolicyName="deserializationPolicy";function deserializationPolicy(options={}){var _a,_b,_c,_d,_e,_f,_g;const jsonContentTypes=null!==(_b=null===(_a=options.expectedContentTypes)||void 0===_a?void 0:_a.json)&&void 0!==_b?_b:defaultJsonContentTypes,xmlContentTypes=null!==(_d=null===(_c=options.expectedContentTypes)||void 0===_c?void 0:_c.xml)&&void 0!==_d?_d:defaultXmlContentTypes,parseXML=options.parseXML,serializerOptions=options.serializerOptions,updatedOptions={xml:{rootName:null!==(_e=null==serializerOptions?void 0:serializerOptions.xml.rootName)&&void 0!==_e?_e:"",includeRoot:null!==(_f=null==serializerOptions?void 0:serializerOptions.xml.includeRoot)&&void 0!==_f&&_f,xmlCharKey:null!==(_g=null==serializerOptions?void 0:serializerOptions.xml.xmlCharKey)&&void 0!==_g?_g:XML_CHARKEY}};return{name:deserializationPolicyName,async sendRequest(request,next){const response=await next(request);return deserializeResponseBody(jsonContentTypes,xmlContentTypes,response,updatedOptions,parseXML)}}}function getOperationResponseMap(parsedResponse){let result;const operationInfo=getOperationRequestInfo(parsedResponse.request),operationSpec=null==operationInfo?void 0:operationInfo.operationSpec;return operationSpec&&(result=(null==operationInfo?void 0:operationInfo.operationResponseGetter)?null==operationInfo?void 0:operationInfo.operationResponseGetter(operationSpec,parsedResponse):operationSpec.responses[parsedResponse.status]),result}function shouldDeserializeResponse(parsedResponse){const operationInfo=getOperationRequestInfo(parsedResponse.request),shouldDeserialize=null==operationInfo?void 0:operationInfo.shouldDeserialize;let result;return result=void 0===shouldDeserialize||("boolean"==typeof shouldDeserialize?shouldDeserialize:shouldDeserialize(parsedResponse)),result}async function deserializeResponseBody(jsonContentTypes,xmlContentTypes,response,options,parseXML){const parsedResponse=await parse(jsonContentTypes,xmlContentTypes,response,options,parseXML);if(!shouldDeserializeResponse(parsedResponse))return parsedResponse;const operationInfo=getOperationRequestInfo(parsedResponse.request),operationSpec=null==operationInfo?void 0:operationInfo.operationSpec;if(!operationSpec||!operationSpec.responses)return parsedResponse;const responseSpec=getOperationResponseMap(parsedResponse),{error:error,shouldReturnResponse:shouldReturnResponse}=handleErrorResponse(parsedResponse,operationSpec,responseSpec,options);if(error)throw error;if(shouldReturnResponse)return parsedResponse;if(responseSpec){if(responseSpec.bodyMapper){let valueToDeserialize=parsedResponse.parsedBody;operationSpec.isXML&&responseSpec.bodyMapper.type.name===MapperTypeNames.Sequence&&(valueToDeserialize="object"==typeof valueToDeserialize?valueToDeserialize[responseSpec.bodyMapper.xmlElementName]:[]);try{parsedResponse.parsedBody=operationSpec.serializer.deserialize(responseSpec.bodyMapper,valueToDeserialize,"operationRes.parsedBody",options)}catch(deserializeError){throw new coreRestPipeline.RestError(`Error ${deserializeError} occurred in deserializing the responseBody - ${parsedResponse.bodyAsText}`,{statusCode:parsedResponse.status,request:parsedResponse.request,response:parsedResponse})}}else"HEAD"===operationSpec.httpMethod&&(parsedResponse.parsedBody=response.status>=200&&response.status<300);responseSpec.headersMapper&&(parsedResponse.parsedHeaders=operationSpec.serializer.deserialize(responseSpec.headersMapper,parsedResponse.headers.toJSON(),"operationRes.parsedHeaders",{xml:{},ignoreUnknownProperties:!0}))}return parsedResponse}function isOperationSpecEmpty(operationSpec){const expectedStatusCodes=Object.keys(operationSpec.responses);return 0===expectedStatusCodes.length||1===expectedStatusCodes.length&&"default"===expectedStatusCodes[0]}function handleErrorResponse(parsedResponse,operationSpec,responseSpec,options){var _a;const isSuccessByStatus=200<=parsedResponse.status&&parsedResponse.status<300;if(isOperationSpecEmpty(operationSpec)?isSuccessByStatus:!!responseSpec){if(!responseSpec)return{error:null,shouldReturnResponse:!1};if(!responseSpec.isError)return{error:null,shouldReturnResponse:!1}}const errorResponseSpec=null!=responseSpec?responseSpec:operationSpec.responses.default,initialErrorMessage=(null===(_a=parsedResponse.request.streamResponseStatusCodes)||void 0===_a?void 0:_a.has(parsedResponse.status))?`Unexpected status code: ${parsedResponse.status}`:parsedResponse.bodyAsText,error=new coreRestPipeline.RestError(initialErrorMessage,{statusCode:parsedResponse.status,request:parsedResponse.request,response:parsedResponse});if(!errorResponseSpec)throw error;const defaultBodyMapper=errorResponseSpec.bodyMapper,defaultHeadersMapper=errorResponseSpec.headersMapper;try{if(parsedResponse.parsedBody){const parsedBody=parsedResponse.parsedBody;let deserializedError;if(defaultBodyMapper){let valueToDeserialize=parsedBody;if(operationSpec.isXML&&defaultBodyMapper.type.name===MapperTypeNames.Sequence){valueToDeserialize=[];const elementName=defaultBodyMapper.xmlElementName;"object"==typeof parsedBody&&elementName&&(valueToDeserialize=parsedBody[elementName])}deserializedError=operationSpec.serializer.deserialize(defaultBodyMapper,valueToDeserialize,"error.response.parsedBody",options)}const internalError=parsedBody.error||deserializedError||parsedBody;error.code=internalError.code,internalError.message&&(error.message=internalError.message),defaultBodyMapper&&(error.response.parsedBody=deserializedError)}parsedResponse.headers&&defaultHeadersMapper&&(error.response.parsedHeaders=operationSpec.serializer.deserialize(defaultHeadersMapper,parsedResponse.headers.toJSON(),"operationRes.parsedHeaders"))}catch(defaultError){error.message=`Error "${defaultError.message}" occurred in deserializing the responseBody - "${parsedResponse.bodyAsText}" for the default response.`}return{error:error,shouldReturnResponse:!1}}async function parse(jsonContentTypes,xmlContentTypes,operationResponse,opts,parseXML){var _a;if(!(null===(_a=operationResponse.request.streamResponseStatusCodes)||void 0===_a?void 0:_a.has(operationResponse.status))&&operationResponse.bodyAsText){const text=operationResponse.bodyAsText,contentType=operationResponse.headers.get("Content-Type")||"",contentComponents=contentType?contentType.split(";").map((component=>component.toLowerCase())):[];try{if(0===contentComponents.length||contentComponents.some((component=>-1!==jsonContentTypes.indexOf(component))))return operationResponse.parsedBody=JSON.parse(text),operationResponse;if(contentComponents.some((component=>-1!==xmlContentTypes.indexOf(component)))){if(!parseXML)throw new Error("Parsing XML not supported.");const body=await parseXML(text,opts.xml);return operationResponse.parsedBody=body,operationResponse}}catch(err){const msg=`Error "${err}" occurred while parsing the response body - ${operationResponse.bodyAsText}.`,errCode=err.code||coreRestPipeline.RestError.PARSE_ERROR;throw new coreRestPipeline.RestError(msg,{code:errCode,statusCode:operationResponse.status,request:operationResponse.request,response:operationResponse})}}return operationResponse}function getStreamingResponseStatusCodes(operationSpec){const result=new Set;for(const statusCode in operationSpec.responses){const operationResponse=operationSpec.responses[statusCode];operationResponse.bodyMapper&&operationResponse.bodyMapper.type.name===MapperTypeNames.Stream&&result.add(Number(statusCode))}return result}function getPathStringFromParameter(parameter){const{parameterPath:parameterPath,mapper:mapper}=parameter;let result;return result="string"==typeof parameterPath?parameterPath:Array.isArray(parameterPath)?parameterPath.join("."):mapper.serializedName,result}const serializationPolicyName="serializationPolicy";function serializationPolicy(options={}){const stringifyXML=options.stringifyXML;return{name:serializationPolicyName,async sendRequest(request,next){const operationInfo=getOperationRequestInfo(request),operationSpec=null==operationInfo?void 0:operationInfo.operationSpec,operationArguments=null==operationInfo?void 0:operationInfo.operationArguments;return operationSpec&&operationArguments&&(serializeHeaders(request,operationArguments,operationSpec),serializeRequestBody(request,operationArguments,operationSpec,stringifyXML)),next(request)}}}function serializeHeaders(request,operationArguments,operationSpec){var _a,_b;if(operationSpec.headerParameters)for(const headerParameter of operationSpec.headerParameters){let headerValue=getOperationArgumentValueFromParameter(operationArguments,headerParameter);if(null!=headerValue||headerParameter.mapper.required){headerValue=operationSpec.serializer.serialize(headerParameter.mapper,headerValue,getPathStringFromParameter(headerParameter));const headerCollectionPrefix=headerParameter.mapper.headerCollectionPrefix;if(headerCollectionPrefix)for(const key of Object.keys(headerValue))request.headers.set(headerCollectionPrefix+key,headerValue[key]);else request.headers.set(headerParameter.mapper.serializedName||getPathStringFromParameter(headerParameter),headerValue)}}const customHeaders=null===(_b=null===(_a=operationArguments.options)||void 0===_a?void 0:_a.requestOptions)||void 0===_b?void 0:_b.customHeaders;if(customHeaders)for(const customHeaderName of Object.keys(customHeaders))request.headers.set(customHeaderName,customHeaders[customHeaderName])}function serializeRequestBody(request,operationArguments,operationSpec,stringifyXML=function(){throw new Error("XML serialization unsupported!")}){var _a,_b,_c,_d,_e;const serializerOptions=null===(_a=operationArguments.options)||void 0===_a?void 0:_a.serializerOptions,updatedOptions={xml:{rootName:null!==(_b=null==serializerOptions?void 0:serializerOptions.xml.rootName)&&void 0!==_b?_b:"",includeRoot:null!==(_c=null==serializerOptions?void 0:serializerOptions.xml.includeRoot)&&void 0!==_c&&_c,xmlCharKey:null!==(_d=null==serializerOptions?void 0:serializerOptions.xml.xmlCharKey)&&void 0!==_d?_d:XML_CHARKEY}},xmlCharKey=updatedOptions.xml.xmlCharKey;if(operationSpec.requestBody&&operationSpec.requestBody.mapper){request.body=getOperationArgumentValueFromParameter(operationArguments,operationSpec.requestBody);const bodyMapper=operationSpec.requestBody.mapper,{required:required,serializedName:serializedName,xmlName:xmlName,xmlElementName:xmlElementName,xmlNamespace:xmlNamespace,xmlNamespacePrefix:xmlNamespacePrefix,nullable:nullable}=bodyMapper,typeName=bodyMapper.type.name;try{if(void 0!==request.body&&null!==request.body||nullable&&null===request.body||required){const requestBodyParameterPathString=getPathStringFromParameter(operationSpec.requestBody);request.body=operationSpec.serializer.serialize(bodyMapper,request.body,requestBodyParameterPathString,updatedOptions);const isStream=typeName===MapperTypeNames.Stream;if(operationSpec.isXML){const xmlnsKey=xmlNamespacePrefix?`xmlns:${xmlNamespacePrefix}`:"xmlns",value=getXmlValueWithNamespace(xmlNamespace,xmlnsKey,typeName,request.body,updatedOptions);typeName===MapperTypeNames.Sequence?request.body=stringifyXML(prepareXMLRootList(value,xmlElementName||xmlName||serializedName,xmlnsKey,xmlNamespace),{rootName:xmlName||serializedName,xmlCharKey:xmlCharKey}):isStream||(request.body=stringifyXML(value,{rootName:xmlName||serializedName,xmlCharKey:xmlCharKey}))}else{if(typeName===MapperTypeNames.String&&((null===(_e=operationSpec.contentType)||void 0===_e?void 0:_e.match("text/plain"))||"text"===operationSpec.mediaType))return;isStream||(request.body=JSON.stringify(request.body))}}}catch(error){throw new Error(`Error "${error.message}" occurred in serializing the payload - ${JSON.stringify(serializedName,void 0,"  ")}.`)}}else if(operationSpec.formDataParameters&&operationSpec.formDataParameters.length>0){request.formData={};for(const formDataParameter of operationSpec.formDataParameters){const formDataParameterValue=getOperationArgumentValueFromParameter(operationArguments,formDataParameter);if(null!=formDataParameterValue){const formDataParameterPropertyName=formDataParameter.mapper.serializedName||getPathStringFromParameter(formDataParameter);request.formData[formDataParameterPropertyName]=operationSpec.serializer.serialize(formDataParameter.mapper,formDataParameterValue,getPathStringFromParameter(formDataParameter),updatedOptions)}}}}function getXmlValueWithNamespace(xmlNamespace,xmlnsKey,typeName,serializedValue,options){if(xmlNamespace&&!["Composite","Sequence","Dictionary"].includes(typeName)){const result={};return result[options.xml.xmlCharKey]=serializedValue,result[XML_ATTRKEY]={[xmlnsKey]:xmlNamespace},result}return serializedValue}function prepareXMLRootList(obj,elementName,xmlNamespaceKey,xmlNamespace){if(Array.isArray(obj)||(obj=[obj]),!xmlNamespaceKey||!xmlNamespace)return{[elementName]:obj};const result={[elementName]:obj};return result[XML_ATTRKEY]={[xmlNamespaceKey]:xmlNamespace},result}function createClientPipeline(options={}){const pipeline=coreRestPipeline.createPipelineFromOptions(null!=options?options:{});return options.credentialOptions&&pipeline.addPolicy(coreRestPipeline.bearerTokenAuthenticationPolicy({credential:options.credentialOptions.credential,scopes:options.credentialOptions.credentialScopes})),pipeline.addPolicy(serializationPolicy(options.serializationOptions),{phase:"Serialize"}),pipeline.addPolicy(deserializationPolicy(options.deserializationOptions),{phase:"Deserialize"}),pipeline}let cachedHttpClient;function getCachedDefaultHttpClient(){return cachedHttpClient||(cachedHttpClient=coreRestPipeline.createDefaultHttpClient()),cachedHttpClient}const CollectionFormatToDelimiterMap={CSV:",",SSV:" ",Multi:"Multi",TSV:"\t",Pipes:"|"};function getRequestUrl(baseUri,operationSpec,operationArguments,fallbackObject){const urlReplacements=calculateUrlReplacements(operationSpec,operationArguments,fallbackObject);let isAbsolutePath=!1,requestUrl=replaceAll(baseUri,urlReplacements);if(operationSpec.path){let path=replaceAll(operationSpec.path,urlReplacements);"/{nextLink}"===operationSpec.path&&path.startsWith("/")&&(path=path.substring(1)),isAbsoluteUrl(path)?(requestUrl=path,isAbsolutePath=!0):requestUrl=appendPath(requestUrl,path)}const{queryParams:queryParams,sequenceParams:sequenceParams}=calculateQueryParameters(operationSpec,operationArguments,fallbackObject);return requestUrl=appendQueryParams(requestUrl,queryParams,sequenceParams,isAbsolutePath),requestUrl}function replaceAll(input,replacements){let result=input;for(const[searchValue,replaceValue]of replacements)result=result.split(searchValue).join(replaceValue);return result}function calculateUrlReplacements(operationSpec,operationArguments,fallbackObject){var _a;const result=new Map;if(null===(_a=operationSpec.urlParameters)||void 0===_a?void 0:_a.length)for(const urlParameter of operationSpec.urlParameters){let urlParameterValue=getOperationArgumentValueFromParameter(operationArguments,urlParameter,fallbackObject);const parameterPathString=getPathStringFromParameter(urlParameter);urlParameterValue=operationSpec.serializer.serialize(urlParameter.mapper,urlParameterValue,parameterPathString),urlParameter.skipEncoding||(urlParameterValue=encodeURIComponent(urlParameterValue)),result.set(`{${urlParameter.mapper.serializedName||parameterPathString}}`,urlParameterValue)}return result}function isAbsoluteUrl(url){return url.includes("://")}function appendPath(url,pathToAppend){if(!pathToAppend)return url;const parsedUrl=new URL(url);let newPath=parsedUrl.pathname;newPath.endsWith("/")||(newPath=`${newPath}/`),pathToAppend.startsWith("/")&&(pathToAppend=pathToAppend.substring(1));const searchStart=pathToAppend.indexOf("?");if(-1!==searchStart){const path=pathToAppend.substring(0,searchStart),search=pathToAppend.substring(searchStart+1);newPath+=path,search&&(parsedUrl.search=parsedUrl.search?`${parsedUrl.search}&${search}`:search)}else newPath+=pathToAppend;return parsedUrl.pathname=newPath,parsedUrl.toString()}function calculateQueryParameters(operationSpec,operationArguments,fallbackObject){var _a;const result=new Map,sequenceParams=new Set;if(null===(_a=operationSpec.queryParameters)||void 0===_a?void 0:_a.length)for(const queryParameter of operationSpec.queryParameters){"Sequence"===queryParameter.mapper.type.name&&queryParameter.mapper.serializedName&&sequenceParams.add(queryParameter.mapper.serializedName);let queryParameterValue=getOperationArgumentValueFromParameter(operationArguments,queryParameter,fallbackObject);if(null!=queryParameterValue||queryParameter.mapper.required){queryParameterValue=operationSpec.serializer.serialize(queryParameter.mapper,queryParameterValue,getPathStringFromParameter(queryParameter));const delimiter=queryParameter.collectionFormat?CollectionFormatToDelimiterMap[queryParameter.collectionFormat]:"";if(Array.isArray(queryParameterValue)&&(queryParameterValue=queryParameterValue.map((item=>null==item?"":item))),"Multi"===queryParameter.collectionFormat&&0===queryParameterValue.length)continue;!Array.isArray(queryParameterValue)||"SSV"!==queryParameter.collectionFormat&&"TSV"!==queryParameter.collectionFormat||(queryParameterValue=queryParameterValue.join(delimiter)),queryParameter.skipEncoding||(queryParameterValue=Array.isArray(queryParameterValue)?queryParameterValue.map((item=>encodeURIComponent(item))):encodeURIComponent(queryParameterValue)),!Array.isArray(queryParameterValue)||"CSV"!==queryParameter.collectionFormat&&"Pipes"!==queryParameter.collectionFormat||(queryParameterValue=queryParameterValue.join(delimiter)),result.set(queryParameter.mapper.serializedName||getPathStringFromParameter(queryParameter),queryParameterValue)}}return{queryParams:result,sequenceParams:sequenceParams}}function simpleParseQueryParams(queryString){const result=new Map;if(!queryString||"?"!==queryString[0])return result;const pairs=(queryString=queryString.slice(1)).split("&");for(const pair of pairs){const[name,value]=pair.split("=",2),existingValue=result.get(name);existingValue?Array.isArray(existingValue)?existingValue.push(value):result.set(name,[existingValue,value]):result.set(name,value)}return result}function appendQueryParams(url,queryParams,sequenceParams,noOverwrite=!1){if(0===queryParams.size)return url;const parsedUrl=new URL(url),combinedParams=simpleParseQueryParams(parsedUrl.search);for(const[name,value]of queryParams){const existingValue=combinedParams.get(name);if(Array.isArray(existingValue))if(Array.isArray(value)){existingValue.push(...value);const valueSet=new Set(existingValue);combinedParams.set(name,Array.from(valueSet))}else existingValue.push(value);else existingValue?(Array.isArray(value)?value.unshift(existingValue):sequenceParams.has(name)&&combinedParams.set(name,[existingValue,value]),noOverwrite||combinedParams.set(name,value)):combinedParams.set(name,value)}const searchPieces=[];for(const[name,value]of combinedParams)if("string"==typeof value)searchPieces.push(`${name}=${value}`);else if(Array.isArray(value))for(const subValue of value)searchPieces.push(`${name}=${subValue}`);else searchPieces.push(`${name}=${value}`);return parsedUrl.search=searchPieces.length?`?${searchPieces.join("&")}`:"",parsedUrl.toString()}const logger=logger$1.createClientLogger("core-client");class ServiceClient{constructor(options={}){var _a,_b;if(this._requestContentType=options.requestContentType,this._endpoint=null!==(_a=options.endpoint)&&void 0!==_a?_a:options.baseUri,options.baseUri&&logger.warning("The baseUri option for SDK Clients has been deprecated, please use endpoint instead."),this._allowInsecureConnection=options.allowInsecureConnection,this._httpClient=options.httpClient||getCachedDefaultHttpClient(),this.pipeline=options.pipeline||createDefaultPipeline(options),null===(_b=options.additionalPolicies)||void 0===_b?void 0:_b.length)for(const{policy:policy,position:position}of options.additionalPolicies){const afterPhase="perRetry"===position?"Sign":void 0;this.pipeline.addPolicy(policy,{afterPhase:afterPhase})}}async sendRequest(request){return this.pipeline.sendRequest(this._httpClient,request)}async sendOperationRequest(operationArguments,operationSpec){const endpoint=operationSpec.baseUrl||this._endpoint;if(!endpoint)throw new Error("If operationSpec.baseUrl is not specified, then the ServiceClient must have a endpoint string property that contains the base URL to use.");const url=getRequestUrl(endpoint,operationSpec,operationArguments,this),request=coreRestPipeline.createPipelineRequest({url:url});request.method=operationSpec.httpMethod;const operationInfo=getOperationRequestInfo(request);operationInfo.operationSpec=operationSpec,operationInfo.operationArguments=operationArguments;const contentType=operationSpec.contentType||this._requestContentType;contentType&&operationSpec.requestBody&&request.headers.set("Content-Type",contentType);const options=operationArguments.options;if(options){const requestOptions=options.requestOptions;requestOptions&&(requestOptions.timeout&&(request.timeout=requestOptions.timeout),requestOptions.onUploadProgress&&(request.onUploadProgress=requestOptions.onUploadProgress),requestOptions.onDownloadProgress&&(request.onDownloadProgress=requestOptions.onDownloadProgress),void 0!==requestOptions.shouldDeserialize&&(operationInfo.shouldDeserialize=requestOptions.shouldDeserialize),requestOptions.allowInsecureConnection&&(request.allowInsecureConnection=!0)),options.abortSignal&&(request.abortSignal=options.abortSignal),options.tracingOptions&&(request.tracingOptions=options.tracingOptions)}this._allowInsecureConnection&&(request.allowInsecureConnection=!0),void 0===request.streamResponseStatusCodes&&(request.streamResponseStatusCodes=getStreamingResponseStatusCodes(operationSpec));try{const rawResponse=await this.sendRequest(request),flatResponse=flattenResponse(rawResponse,operationSpec.responses[rawResponse.status]);return(null==options?void 0:options.onResponse)&&options.onResponse(rawResponse,flatResponse),flatResponse}catch(error){if("object"==typeof error&&(null==error?void 0:error.response)){const rawResponse=error.response,flatResponse=flattenResponse(rawResponse,operationSpec.responses[error.statusCode]||operationSpec.responses.default);error.details=flatResponse,(null==options?void 0:options.onResponse)&&options.onResponse(rawResponse,flatResponse,error)}throw error}}}function createDefaultPipeline(options){const credentialScopes=getCredentialScopes(options),credentialOptions=options.credential&&credentialScopes?{credentialScopes:credentialScopes,credential:options.credential}:void 0;return createClientPipeline(Object.assign(Object.assign({},options),{credentialOptions:credentialOptions}))}function getCredentialScopes(options){if(options.credentialScopes)return options.credentialScopes;if(options.endpoint)return`${options.endpoint}/.default`;if(options.baseUri)return`${options.baseUri}/.default`;if(options.credential&&!options.credentialScopes)throw new Error("When using credentials, the ServiceClientOptions must contain either a endpoint or a credentialScopes. Unable to create a bearerTokenAuthenticationPolicy")}function parseCAEChallenge(challenges){return`, ${challenges.trim()}`.split(", Bearer ").filter((x=>x)).map((challenge=>`${challenge.trim()}, `.split('", ').filter((x=>x)).map((keyValue=>(([key,value])=>({[key]:value}))(keyValue.trim().split('="')))).reduce(((a,b)=>Object.assign(Object.assign({},a),b)),{})))}async function authorizeRequestOnClaimChallenge(onChallengeOptions){const{scopes:scopes,response:response}=onChallengeOptions,logger$1=onChallengeOptions.logger||logger,challenge=response.headers.get("WWW-Authenticate");if(!challenge)return logger$1.info("The WWW-Authenticate header was missing. Failed to perform the Continuous Access Evaluation authentication flow."),!1;const parsedChallenge=(parseCAEChallenge(challenge)||[]).find((x=>x.claims));if(!parsedChallenge)return logger$1.info('The WWW-Authenticate header was missing the necessary "claims" to perform the Continuous Access Evaluation authentication flow.'),!1;const accessToken=await onChallengeOptions.getAccessToken(parsedChallenge.scope?[parsedChallenge.scope]:scopes,{claims:decodeStringToString(parsedChallenge.claims)});return!!accessToken&&(onChallengeOptions.request.headers.set("Authorization",`Bearer ${accessToken.token}`),!0)}const Constants={DefaultScope:"/.default",HeaderConstants:{AUTHORIZATION:"authorization"}},authorizeRequestOnTenantChallenge=async challengeOptions=>{const requestOptions=requestToOptions(challengeOptions.request),challenge=getChallenge(challengeOptions.response);if(challenge){const challengeInfo=parseChallenge(challenge),challengeScopes=buildScopes(challengeOptions,challengeInfo),tenantId=extractTenantId(challengeInfo),accessToken=await challengeOptions.getAccessToken(challengeScopes,Object.assign(Object.assign({},requestOptions),{tenantId:tenantId}));return!!accessToken&&(challengeOptions.request.headers.set(Constants.HeaderConstants.AUTHORIZATION,`Bearer ${accessToken.token}`),!0)}return!1};function extractTenantId(challengeInfo){return new URL(challengeInfo.authorization_uri).pathname.split("/")[1]}function buildScopes(challengeOptions,challengeInfo){if(!challengeInfo.resource_uri)return challengeOptions.scopes;const challengeScopes=new URL(challengeInfo.resource_uri);return challengeScopes.pathname=Constants.DefaultScope,[challengeScopes.toString()]}function getChallenge(response){const challenge=response.headers.get("WWW-Authenticate");if(401===response.status&&challenge)return challenge}function parseChallenge(challenge){return`${challenge.slice("Bearer ".length).trim()} `.split(" ").filter((x=>x)).map((keyValue=>(([key,value])=>({[key]:value}))(keyValue.trim().split("=")))).reduce(((a,b)=>Object.assign(Object.assign({},a),b)),{})}function requestToOptions(request){return{abortSignal:request.abortSignal,requestOptions:{timeout:request.timeout},tracingOptions:request.tracingOptions}}exports.MapperTypeNames=MapperTypeNames,exports.ServiceClient=ServiceClient,exports.XML_ATTRKEY=XML_ATTRKEY,exports.XML_CHARKEY=XML_CHARKEY,exports.authorizeRequestOnClaimChallenge=authorizeRequestOnClaimChallenge,exports.authorizeRequestOnTenantChallenge=authorizeRequestOnTenantChallenge,exports.createClientPipeline=createClientPipeline,exports.createSerializer=createSerializer,exports.deserializationPolicy=deserializationPolicy,exports.deserializationPolicyName=deserializationPolicyName,exports.serializationPolicy=serializationPolicy,exports.serializationPolicyName=serializationPolicyName;