import{logger}from"../logger";import{terminalStates}from"./constants";export function deserializeState(serializedState){try{return JSON.parse(serializedState).state}catch(e){throw new Error(`Unable to deserialize input state: ${serializedState}`)}}function setStateError(inputs){const{state:state,stateProxy:stateProxy,isOperationError:isOperationError}=inputs;return error=>{throw isOperationError(error)&&(stateProxy.setError(state,error),stateProxy.setFailed(state)),error}}function appendReadableErrorMessage(currentMessage,innerMessage){let message=currentMessage;return"."!==message.slice(-1)&&(message+="."),message+" "+innerMessage}function simplifyError(err){let message=err.message,code=err.code,curErr=err;for(;curErr.innererror;)curErr=curErr.innererror,code=curErr.code,message=appendReadableErrorMessage(message,curErr.message);return{code:code,message:message}}function processOperationStatus(result){const{state:state,stateProxy:stateProxy,status:status,isDone:isDone,processResult:processResult,getError:getError,response:response,setErrorAsResult:setErrorAsResult}=result;switch(status){case"succeeded":stateProxy.setSucceeded(state);break;case"failed":{const err=null==getError?void 0:getError(response);let postfix="";if(err){const{code:code,message:message}=simplifyError(err);postfix=`. ${code}. ${message}`}const errStr=`The long-running operation has failed${postfix}`;stateProxy.setError(state,new Error(errStr)),stateProxy.setFailed(state),logger.warning(errStr);break}case"canceled":stateProxy.setCanceled(state)}((null==isDone?void 0:isDone(response,state))||void 0===isDone&&["succeeded","canceled"].concat(setErrorAsResult?[]:["failed"]).includes(status))&&stateProxy.setResult(state,buildResult({response:response,state:state,processResult:processResult}))}function buildResult(inputs){const{processResult:processResult,response:response,state:state}=inputs;return processResult?processResult(response,state):response}export async function initOperation(inputs){const{init:init,stateProxy:stateProxy,processResult:processResult,getOperationStatus:getOperationStatus,withOperationLocation:withOperationLocation,setErrorAsResult:setErrorAsResult}=inputs,{operationLocation:operationLocation,resourceLocation:resourceLocation,metadata:metadata,response:response}=await init();operationLocation&&(null==withOperationLocation||withOperationLocation(operationLocation,!1));const config={metadata:metadata,operationLocation:operationLocation,resourceLocation:resourceLocation};logger.verbose("LRO: Operation description:",config);const state=stateProxy.initState(config);return processOperationStatus({state:state,status:getOperationStatus({response:response,state:state,operationLocation:operationLocation}),stateProxy:stateProxy,response:response,setErrorAsResult:setErrorAsResult,processResult:processResult}),state}async function pollOperationHelper(inputs){const{poll:poll,state:state,stateProxy:stateProxy,operationLocation:operationLocation,getOperationStatus:getOperationStatus,getResourceLocation:getResourceLocation,isOperationError:isOperationError,options:options}=inputs,response=await poll(operationLocation,options).catch(setStateError({state:state,stateProxy:stateProxy,isOperationError:isOperationError})),status=getOperationStatus(response,state);if(logger.verbose(`LRO: Status:\n\tPolling from: ${state.config.operationLocation}\n\tOperation status: ${status}\n\tPolling status: ${terminalStates.includes(status)?"Stopped":"Running"}`),"succeeded"===status){const resourceLocation=getResourceLocation(response,state);if(void 0!==resourceLocation)return{response:await poll(resourceLocation).catch(setStateError({state:state,stateProxy:stateProxy,isOperationError:isOperationError})),status:status}}return{response:response,status:status}}export async function pollOperation(inputs){const{poll:poll,state:state,stateProxy:stateProxy,options:options,getOperationStatus:getOperationStatus,getResourceLocation:getResourceLocation,getOperationLocation:getOperationLocation,isOperationError:isOperationError,withOperationLocation:withOperationLocation,getPollingInterval:getPollingInterval,processResult:processResult,getError:getError,updateState:updateState,setDelay:setDelay,isDone:isDone,setErrorAsResult:setErrorAsResult}=inputs,{operationLocation:operationLocation}=state.config;if(void 0!==operationLocation){const{response:response,status:status}=await pollOperationHelper({poll:poll,getOperationStatus:getOperationStatus,state:state,stateProxy:stateProxy,operationLocation:operationLocation,getResourceLocation:getResourceLocation,isOperationError:isOperationError,options:options});if(processOperationStatus({status:status,response:response,state:state,stateProxy:stateProxy,isDone:isDone,processResult:processResult,getError:getError,setErrorAsResult:setErrorAsResult}),!terminalStates.includes(status)){const intervalInMs=null==getPollingInterval?void 0:getPollingInterval(response);intervalInMs&&setDelay(intervalInMs);const location=null==getOperationLocation?void 0:getOperationLocation(response,state);if(void 0!==location){const isUpdated=operationLocation!==location;state.config.operationLocation=location,null==withOperationLocation||withOperationLocation(location,isUpdated)}else null==withOperationLocation||withOperationLocation(operationLocation,!1)}null==updateState||updateState(state,response)}}