"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var logger$1=require("@azure/logger"),abortController=require("@azure/abort-controller"),coreUtil=require("@azure/core-util");const logger=logger$1.createClientLogger("core-lro"),POLL_INTERVAL_IN_MS=2e3,terminalStates=["succeeded","canceled","failed"];function deserializeState(serializedState){try{return JSON.parse(serializedState).state}catch(e){throw new Error(`Unable to deserialize input state: ${serializedState}`)}}function setStateError(inputs){const{state:state,stateProxy:stateProxy,isOperationError:isOperationError}=inputs;return error=>{throw isOperationError(error)&&(stateProxy.setError(state,error),stateProxy.setFailed(state)),error}}function appendReadableErrorMessage(currentMessage,innerMessage){let message=currentMessage;return"."!==message.slice(-1)&&(message+="."),message+" "+innerMessage}function simplifyError(err){let message=err.message,code=err.code,curErr=err;for(;curErr.innererror;)curErr=curErr.innererror,code=curErr.code,message=appendReadableErrorMessage(message,curErr.message);return{code:code,message:message}}function processOperationStatus(result){const{state:state,stateProxy:stateProxy,status:status,isDone:isDone,processResult:processResult,getError:getError,response:response,setErrorAsResult:setErrorAsResult}=result;switch(status){case"succeeded":stateProxy.setSucceeded(state);break;case"failed":{const err=null==getError?void 0:getError(response);let postfix="";if(err){const{code:code,message:message}=simplifyError(err);postfix=`. ${code}. ${message}`}const errStr=`The long-running operation has failed${postfix}`;stateProxy.setError(state,new Error(errStr)),stateProxy.setFailed(state),logger.warning(errStr);break}case"canceled":stateProxy.setCanceled(state)}((null==isDone?void 0:isDone(response,state))||void 0===isDone&&["succeeded","canceled"].concat(setErrorAsResult?[]:["failed"]).includes(status))&&stateProxy.setResult(state,buildResult({response:response,state:state,processResult:processResult}))}function buildResult(inputs){const{processResult:processResult,response:response,state:state}=inputs;return processResult?processResult(response,state):response}async function initOperation(inputs){const{init:init,stateProxy:stateProxy,processResult:processResult,getOperationStatus:getOperationStatus,withOperationLocation:withOperationLocation,setErrorAsResult:setErrorAsResult}=inputs,{operationLocation:operationLocation,resourceLocation:resourceLocation,metadata:metadata,response:response}=await init();operationLocation&&(null==withOperationLocation||withOperationLocation(operationLocation,!1));const config={metadata:metadata,operationLocation:operationLocation,resourceLocation:resourceLocation};logger.verbose("LRO: Operation description:",config);const state=stateProxy.initState(config);return processOperationStatus({state:state,status:getOperationStatus({response:response,state:state,operationLocation:operationLocation}),stateProxy:stateProxy,response:response,setErrorAsResult:setErrorAsResult,processResult:processResult}),state}async function pollOperationHelper(inputs){const{poll:poll,state:state,stateProxy:stateProxy,operationLocation:operationLocation,getOperationStatus:getOperationStatus,getResourceLocation:getResourceLocation,isOperationError:isOperationError,options:options}=inputs,response=await poll(operationLocation,options).catch(setStateError({state:state,stateProxy:stateProxy,isOperationError:isOperationError})),status=getOperationStatus(response,state);if(logger.verbose(`LRO: Status:\n\tPolling from: ${state.config.operationLocation}\n\tOperation status: ${status}\n\tPolling status: ${terminalStates.includes(status)?"Stopped":"Running"}`),"succeeded"===status){const resourceLocation=getResourceLocation(response,state);if(void 0!==resourceLocation)return{response:await poll(resourceLocation).catch(setStateError({state:state,stateProxy:stateProxy,isOperationError:isOperationError})),status:status}}return{response:response,status:status}}async function pollOperation(inputs){const{poll:poll,state:state,stateProxy:stateProxy,options:options,getOperationStatus:getOperationStatus,getResourceLocation:getResourceLocation,getOperationLocation:getOperationLocation,isOperationError:isOperationError,withOperationLocation:withOperationLocation,getPollingInterval:getPollingInterval,processResult:processResult,getError:getError,updateState:updateState,setDelay:setDelay,isDone:isDone,setErrorAsResult:setErrorAsResult}=inputs,{operationLocation:operationLocation}=state.config;if(void 0!==operationLocation){const{response:response,status:status}=await pollOperationHelper({poll:poll,getOperationStatus:getOperationStatus,state:state,stateProxy:stateProxy,operationLocation:operationLocation,getResourceLocation:getResourceLocation,isOperationError:isOperationError,options:options});if(processOperationStatus({status:status,response:response,state:state,stateProxy:stateProxy,isDone:isDone,processResult:processResult,getError:getError,setErrorAsResult:setErrorAsResult}),!terminalStates.includes(status)){const intervalInMs=null==getPollingInterval?void 0:getPollingInterval(response);intervalInMs&&setDelay(intervalInMs);const location=null==getOperationLocation?void 0:getOperationLocation(response,state);if(void 0!==location){const isUpdated=operationLocation!==location;state.config.operationLocation=location,null==withOperationLocation||withOperationLocation(location,isUpdated)}else null==withOperationLocation||withOperationLocation(operationLocation,!1)}null==updateState||updateState(state,response)}}function getOperationLocationPollingUrl(inputs){const{azureAsyncOperation:azureAsyncOperation,operationLocation:operationLocation}=inputs;return null!=operationLocation?operationLocation:azureAsyncOperation}function getLocationHeader(rawResponse){return rawResponse.headers.location}function getOperationLocationHeader(rawResponse){return rawResponse.headers["operation-location"]}function getAzureAsyncOperationHeader(rawResponse){return rawResponse.headers["azure-asyncoperation"]}function findResourceLocation(inputs){const{location:location,requestMethod:requestMethod,requestPath:requestPath,resourceLocationConfig:resourceLocationConfig}=inputs;switch(requestMethod){case"PUT":return requestPath;case"DELETE":return;default:switch(resourceLocationConfig){case"azure-async-operation":return;case"original-uri":return requestPath;default:return location}}}function inferLroMode(inputs){const{rawResponse:rawResponse,requestMethod:requestMethod,requestPath:requestPath,resourceLocationConfig:resourceLocationConfig}=inputs,pollingUrl=getOperationLocationPollingUrl({operationLocation:getOperationLocationHeader(rawResponse),azureAsyncOperation:getAzureAsyncOperationHeader(rawResponse)}),location=getLocationHeader(rawResponse),normalizedRequestMethod=null==requestMethod?void 0:requestMethod.toLocaleUpperCase();return void 0!==pollingUrl?{mode:"OperationLocation",operationLocation:pollingUrl,resourceLocation:findResourceLocation({requestMethod:normalizedRequestMethod,location:location,requestPath:requestPath,resourceLocationConfig:resourceLocationConfig})}:void 0!==location?{mode:"ResourceLocation",operationLocation:location}:"PUT"===normalizedRequestMethod&&requestPath?{mode:"Body",operationLocation:requestPath}:void 0}function transformStatus(inputs){const{status:status,statusCode:statusCode}=inputs;if("string"!=typeof status&&void 0!==status)throw new Error(`Polling was unsuccessful. Expected status to have a string value or no value but it has instead: ${status}. This doesn't necessarily indicate the operation has failed. Check your Azure subscription or resource status for more information.`);switch(null==status?void 0:status.toLocaleLowerCase()){case void 0:return toOperationStatus(statusCode);case"succeeded":return"succeeded";case"failed":return"failed";case"running":case"accepted":case"started":case"canceling":case"cancelling":return"running";case"canceled":case"cancelled":return"canceled";default:return logger.verbose(`LRO: unrecognized operation status: ${status}`),status}}function getStatus(rawResponse){var _a;const{status:status}=null!==(_a=rawResponse.body)&&void 0!==_a?_a:{};return transformStatus({status:status,statusCode:rawResponse.statusCode})}function getProvisioningState(rawResponse){var _a,_b;const{properties:properties,provisioningState:provisioningState}=null!==(_a=rawResponse.body)&&void 0!==_a?_a:{};return transformStatus({status:null!==(_b=null==properties?void 0:properties.provisioningState)&&void 0!==_b?_b:provisioningState,statusCode:rawResponse.statusCode})}function toOperationStatus(statusCode){return 202===statusCode?"running":statusCode<300?"succeeded":"failed"}function parseRetryAfter({rawResponse:rawResponse}){const retryAfter=rawResponse.headers["retry-after"];if(void 0!==retryAfter){const retryAfterInSeconds=parseInt(retryAfter);return isNaN(retryAfterInSeconds)?calculatePollingIntervalFromDate(new Date(retryAfter)):1e3*retryAfterInSeconds}}function getErrorFromResponse(response){const error=response.flatResponse.error;if(error){if(error.code&&error.message)return error;logger.warning("The long-running operation failed but the error property in the response's body doesn't contain code or message")}else logger.warning("The long-running operation failed but there is no error property in the response's body")}function calculatePollingIntervalFromDate(retryAfterDate){const timeNow=Math.floor((new Date).getTime()),retryAfterTime=retryAfterDate.getTime();if(timeNow<retryAfterTime)return retryAfterTime-timeNow}function getStatusFromInitialResponse(inputs){const{response:response,state:state,operationLocation:operationLocation}=inputs;function helper(){var _a;switch(null===(_a=state.config.metadata)||void 0===_a?void 0:_a.mode){case void 0:return toOperationStatus(response.rawResponse.statusCode);case"Body":return getOperationStatus(response,state);default:return"running"}}const status=helper();return"running"===status&&void 0===operationLocation?"succeeded":status}async function initHttpOperation(inputs){const{stateProxy:stateProxy,resourceLocationConfig:resourceLocationConfig,processResult:processResult,lro:lro,setErrorAsResult:setErrorAsResult}=inputs;return initOperation({init:async()=>{const response=await lro.sendInitialRequest(),config=inferLroMode({rawResponse:response.rawResponse,requestPath:lro.requestPath,requestMethod:lro.requestMethod,resourceLocationConfig:resourceLocationConfig});return Object.assign({response:response,operationLocation:null==config?void 0:config.operationLocation,resourceLocation:null==config?void 0:config.resourceLocation},(null==config?void 0:config.mode)?{metadata:{mode:config.mode}}:{})},stateProxy:stateProxy,processResult:processResult?({flatResponse:flatResponse},state)=>processResult(flatResponse,state):({flatResponse:flatResponse})=>flatResponse,getOperationStatus:getStatusFromInitialResponse,setErrorAsResult:setErrorAsResult})}function getOperationLocation({rawResponse:rawResponse},state){var _a;switch(null===(_a=state.config.metadata)||void 0===_a?void 0:_a.mode){case"OperationLocation":return getOperationLocationPollingUrl({operationLocation:getOperationLocationHeader(rawResponse),azureAsyncOperation:getAzureAsyncOperationHeader(rawResponse)});case"ResourceLocation":return getLocationHeader(rawResponse);default:return}}function getOperationStatus({rawResponse:rawResponse},state){var _a;const mode=null===(_a=state.config.metadata)||void 0===_a?void 0:_a.mode;switch(mode){case"OperationLocation":return getStatus(rawResponse);case"ResourceLocation":return toOperationStatus(rawResponse.statusCode);case"Body":return getProvisioningState(rawResponse);default:throw new Error(`Internal error: Unexpected operation mode: ${mode}`)}}function getResourceLocation({flatResponse:flatResponse},state){if("object"==typeof flatResponse){const resourceLocation=flatResponse.resourceLocation;void 0!==resourceLocation&&(state.config.resourceLocation=resourceLocation)}return state.config.resourceLocation}function isOperationError(e){return"RestError"===e.name}async function pollHttpOperation(inputs){const{lro:lro,stateProxy:stateProxy,options:options,processResult:processResult,updateState:updateState,setDelay:setDelay,state:state,setErrorAsResult:setErrorAsResult}=inputs;return pollOperation({state:state,stateProxy:stateProxy,setDelay:setDelay,processResult:processResult?({flatResponse:flatResponse},inputState)=>processResult(flatResponse,inputState):({flatResponse:flatResponse})=>flatResponse,getError:getErrorFromResponse,updateState:updateState,getPollingInterval:parseRetryAfter,getOperationLocation:getOperationLocation,getOperationStatus:getOperationStatus,isOperationError:isOperationError,getResourceLocation:getResourceLocation,options:options,poll:async(location,inputOptions)=>lro.sendPollRequest(location,inputOptions),setErrorAsResult:setErrorAsResult})}const createStateProxy$1=()=>({initState:config=>({status:"running",config:config}),setCanceled:state=>state.status="canceled",setError:(state,error)=>state.error=error,setResult:(state,result)=>state.result=result,setRunning:state=>state.status="running",setSucceeded:state=>state.status="succeeded",setFailed:state=>state.status="failed",getError:state=>state.error,getResult:state=>state.result,isCanceled:state=>"canceled"===state.status,isFailed:state=>"failed"===state.status,isRunning:state=>"running"===state.status,isSucceeded:state=>"succeeded"===state.status});function buildCreatePoller(inputs){const{getOperationLocation:getOperationLocation,getStatusFromInitialResponse:getStatusFromInitialResponse,getStatusFromPollResponse:getStatusFromPollResponse,isOperationError:isOperationError,getResourceLocation:getResourceLocation,getPollingInterval:getPollingInterval,getError:getError,resolveOnUnsuccessful:resolveOnUnsuccessful}=inputs;return async({init:init,poll:poll},options)=>{const{processResult:processResult,updateState:updateState,withOperationLocation:withOperationLocationCallback,intervalInMs:intervalInMs=POLL_INTERVAL_IN_MS,restoreFrom:restoreFrom}=options||{},stateProxy=createStateProxy$1(),withOperationLocation=withOperationLocationCallback?(()=>{let called=!1;return(operationLocation,isUpdated)=>{isUpdated?withOperationLocationCallback(operationLocation):called||withOperationLocationCallback(operationLocation),called=!0}})():void 0,state=restoreFrom?deserializeState(restoreFrom):await initOperation({init:init,stateProxy:stateProxy,processResult:processResult,getOperationStatus:getStatusFromInitialResponse,withOperationLocation:withOperationLocation,setErrorAsResult:!resolveOnUnsuccessful});let resultPromise;const abortController$1=new abortController.AbortController,handlers=new Map,handleProgressEvents=async()=>handlers.forEach((h=>h(state))),cancelErrMsg="Operation was canceled";let currentPollIntervalInMs=intervalInMs;const poller={getOperationState:()=>state,getResult:()=>state.result,isDone:()=>["succeeded","failed","canceled"].includes(state.status),isStopped:()=>void 0===resultPromise,stopPolling:()=>{abortController$1.abort()},toString:()=>JSON.stringify({state:state}),onProgress:callback=>{const s=Symbol();return handlers.set(s,callback),()=>handlers.delete(s)},pollUntilDone:pollOptions=>null!=resultPromise?resultPromise:resultPromise=(async()=>{const{abortSignal:inputAbortSignal}=pollOptions||{},{signal:abortSignal}=inputAbortSignal?new abortController.AbortController([inputAbortSignal,abortController$1.signal]):abortController$1;if(!poller.isDone())for(await poller.poll({abortSignal:abortSignal});!poller.isDone();)await coreUtil.delay(currentPollIntervalInMs,{abortSignal:abortSignal}),await poller.poll({abortSignal:abortSignal});if(resolveOnUnsuccessful)return poller.getResult();switch(state.status){case"succeeded":return poller.getResult();case"canceled":throw new Error(cancelErrMsg);case"failed":throw state.error;case"notStarted":case"running":throw new Error("Polling completed without succeeding or failing")}})().finally((()=>{resultPromise=void 0})),async poll(pollOptions){if(resolveOnUnsuccessful){if(poller.isDone())return}else switch(state.status){case"succeeded":return;case"canceled":throw new Error(cancelErrMsg);case"failed":throw state.error}if(await pollOperation({poll:poll,state:state,stateProxy:stateProxy,getOperationLocation:getOperationLocation,isOperationError:isOperationError,withOperationLocation:withOperationLocation,getPollingInterval:getPollingInterval,getOperationStatus:getStatusFromPollResponse,getResourceLocation:getResourceLocation,processResult:processResult,getError:getError,updateState:updateState,options:pollOptions,setDelay:pollIntervalInMs=>{currentPollIntervalInMs=pollIntervalInMs},setErrorAsResult:!resolveOnUnsuccessful}),await handleProgressEvents(),!resolveOnUnsuccessful)switch(state.status){case"canceled":throw new Error(cancelErrMsg);case"failed":throw state.error}}};return poller}}async function createHttpPoller(lro,options){const{resourceLocationConfig:resourceLocationConfig,intervalInMs:intervalInMs,processResult:processResult,restoreFrom:restoreFrom,updateState:updateState,withOperationLocation:withOperationLocation,resolveOnUnsuccessful:resolveOnUnsuccessful=!1}=options||{};return buildCreatePoller({getStatusFromInitialResponse:getStatusFromInitialResponse,getStatusFromPollResponse:getOperationStatus,isOperationError:isOperationError,getOperationLocation:getOperationLocation,getResourceLocation:getResourceLocation,getPollingInterval:parseRetryAfter,getError:getErrorFromResponse,resolveOnUnsuccessful:resolveOnUnsuccessful})({init:async()=>{const response=await lro.sendInitialRequest(),config=inferLroMode({rawResponse:response.rawResponse,requestPath:lro.requestPath,requestMethod:lro.requestMethod,resourceLocationConfig:resourceLocationConfig});return Object.assign({response:response,operationLocation:null==config?void 0:config.operationLocation,resourceLocation:null==config?void 0:config.resourceLocation},(null==config?void 0:config.mode)?{metadata:{mode:config.mode}}:{})},poll:lro.sendPollRequest},{intervalInMs:intervalInMs,withOperationLocation:withOperationLocation,restoreFrom:restoreFrom,updateState:updateState,processResult:processResult?({flatResponse:flatResponse},state)=>processResult(flatResponse,state):({flatResponse:flatResponse})=>flatResponse})}const createStateProxy=()=>({initState:config=>({config:config,isStarted:!0}),setCanceled:state=>state.isCancelled=!0,setError:(state,error)=>state.error=error,setResult:(state,result)=>state.result=result,setRunning:state=>state.isStarted=!0,setSucceeded:state=>state.isCompleted=!0,setFailed:()=>{},getError:state=>state.error,getResult:state=>state.result,isCanceled:state=>!!state.isCancelled,isFailed:state=>!!state.error,isRunning:state=>!!state.isStarted,isSucceeded:state=>Boolean(state.isCompleted&&!state.isCancelled&&!state.error)});class GenericPollOperation{constructor(state,lro,setErrorAsResult,lroResourceLocationConfig,processResult,updateState,isDone){this.state=state,this.lro=lro,this.setErrorAsResult=setErrorAsResult,this.lroResourceLocationConfig=lroResourceLocationConfig,this.processResult=processResult,this.updateState=updateState,this.isDone=isDone}setPollerConfig(pollerConfig){this.pollerConfig=pollerConfig}async update(options){var _a;const stateProxy=createStateProxy();this.state.isStarted||(this.state=Object.assign(Object.assign({},this.state),await initHttpOperation({lro:this.lro,stateProxy:stateProxy,resourceLocationConfig:this.lroResourceLocationConfig,processResult:this.processResult,setErrorAsResult:this.setErrorAsResult})));const updateState=this.updateState,isDone=this.isDone;return this.state.isCompleted||void 0!==this.state.error||await pollHttpOperation({lro:this.lro,state:this.state,stateProxy:stateProxy,processResult:this.processResult,updateState:updateState?(state,{rawResponse:rawResponse})=>updateState(state,rawResponse):void 0,isDone:isDone?({flatResponse:flatResponse},state)=>isDone(flatResponse,state):void 0,options:options,setDelay:intervalInMs=>{this.pollerConfig.intervalInMs=intervalInMs},setErrorAsResult:this.setErrorAsResult}),null===(_a=null==options?void 0:options.fireProgress)||void 0===_a||_a.call(options,this.state),this}async cancel(){return logger.error("`cancelOperation` is deprecated because it wasn't implemented"),this}toString(){return JSON.stringify({state:this.state})}}class PollerStoppedError extends Error{constructor(message){super(message),this.name="PollerStoppedError",Object.setPrototypeOf(this,PollerStoppedError.prototype)}}class PollerCancelledError extends Error{constructor(message){super(message),this.name="PollerCancelledError",Object.setPrototypeOf(this,PollerCancelledError.prototype)}}class Poller{constructor(operation){this.resolveOnUnsuccessful=!1,this.stopped=!0,this.pollProgressCallbacks=[],this.operation=operation,this.promise=new Promise(((resolve,reject)=>{this.resolve=resolve,this.reject=reject})),this.promise.catch((()=>{}))}async startPolling(pollOptions={}){for(this.stopped&&(this.stopped=!1);!this.isStopped()&&!this.isDone();)await this.poll(pollOptions),await this.delay()}async pollOnce(options={}){this.isDone()||(this.operation=await this.operation.update({abortSignal:options.abortSignal,fireProgress:this.fireProgress.bind(this)})),this.processUpdatedState()}fireProgress(state){for(const callback of this.pollProgressCallbacks)callback(state)}async cancelOnce(options={}){this.operation=await this.operation.cancel(options)}poll(options={}){if(!this.pollOncePromise){this.pollOncePromise=this.pollOnce(options);const clearPollOncePromise=()=>{this.pollOncePromise=void 0};this.pollOncePromise.then(clearPollOncePromise,clearPollOncePromise).catch(this.reject)}return this.pollOncePromise}processUpdatedState(){if(this.operation.state.error&&(this.stopped=!0,!this.resolveOnUnsuccessful))throw this.reject(this.operation.state.error),this.operation.state.error;if(this.operation.state.isCancelled&&(this.stopped=!0,!this.resolveOnUnsuccessful)){const error=new PollerCancelledError("Operation was canceled");throw this.reject(error),error}this.isDone()&&this.resolve&&this.resolve(this.getResult())}async pollUntilDone(pollOptions={}){return this.stopped&&this.startPolling(pollOptions).catch(this.reject),this.processUpdatedState(),this.promise}onProgress(callback){return this.pollProgressCallbacks.push(callback),()=>{this.pollProgressCallbacks=this.pollProgressCallbacks.filter((c=>c!==callback))}}isDone(){const state=this.operation.state;return Boolean(state.isCompleted||state.isCancelled||state.error)}stopPolling(){this.stopped||(this.stopped=!0,this.reject&&this.reject(new PollerStoppedError("This poller is already stopped")))}isStopped(){return this.stopped}cancelOperation(options={}){if(this.cancelPromise){if(options.abortSignal)throw new Error("A cancel request is currently pending")}else this.cancelPromise=this.cancelOnce(options);return this.cancelPromise}getOperationState(){return this.operation.state}getResult(){return this.operation.state.result}toString(){return this.operation.toString()}}class LroEngine extends Poller{constructor(lro,options){const{intervalInMs:intervalInMs=POLL_INTERVAL_IN_MS,resumeFrom:resumeFrom,resolveOnUnsuccessful:resolveOnUnsuccessful=!1,isDone:isDone,lroResourceLocationConfig:lroResourceLocationConfig,processResult:processResult,updateState:updateState}=options||{},state=resumeFrom?deserializeState(resumeFrom):{},operation=new GenericPollOperation(state,lro,!resolveOnUnsuccessful,lroResourceLocationConfig,processResult,updateState,isDone);super(operation),this.resolveOnUnsuccessful=resolveOnUnsuccessful,this.config={intervalInMs:intervalInMs},operation.setPollerConfig(this.config)}delay(){return new Promise((resolve=>setTimeout((()=>resolve()),this.config.intervalInMs)))}}exports.LroEngine=LroEngine,exports.Poller=Poller,exports.PollerCancelledError=PollerCancelledError,exports.PollerStoppedError=PollerStoppedError,exports.createHttpPoller=createHttpPoller;