const ValidPhaseNames=new Set(["Deserialize","Serialize","Retry","Sign"]);class HttpPipeline{constructor(policies){var _a;this._policies=[],this._policies=null!==(_a=null==policies?void 0:policies.slice(0))&&void 0!==_a?_a:[],this._orderedPolicies=void 0}addPolicy(policy,options={}){if(options.phase&&options.afterPhase)throw new Error("Policies inside a phase cannot specify afterPhase.");if(options.phase&&!ValidPhaseNames.has(options.phase))throw new Error(`Invalid phase name: ${options.phase}`);if(options.afterPhase&&!ValidPhaseNames.has(options.afterPhase))throw new Error(`Invalid afterPhase name: ${options.afterPhase}`);this._policies.push({policy:policy,options:options}),this._orderedPolicies=void 0}removePolicy(options){const removedPolicies=[];return this._policies=this._policies.filter((policyDescriptor=>!(options.name&&policyDescriptor.policy.name===options.name||options.phase&&policyDescriptor.options.phase===options.phase)||(removedPolicies.push(policyDescriptor.policy),!1))),this._orderedPolicies=void 0,removedPolicies}sendRequest(httpClient,request){return this.getOrderedPolicies().reduceRight(((next,policy)=>req=>policy.sendRequest(req,next)),(req=>httpClient.sendRequest(req)))(request)}getOrderedPolicies(){return this._orderedPolicies||(this._orderedPolicies=this.orderPolicies()),this._orderedPolicies}clone(){return new HttpPipeline(this._policies)}static create(){return new HttpPipeline}orderPolicies(){const result=[],policyMap=new Map;function createPhase(name){return{name:name,policies:new Set,hasRun:!1,hasAfterPolicies:!1}}const serializePhase=createPhase("Serialize"),noPhase=createPhase("None"),deserializePhase=createPhase("Deserialize"),retryPhase=createPhase("Retry"),signPhase=createPhase("Sign"),orderedPhases=[serializePhase,noPhase,deserializePhase,retryPhase,signPhase];function getPhase(phase){return"Retry"===phase?retryPhase:"Serialize"===phase?serializePhase:"Deserialize"===phase?deserializePhase:"Sign"===phase?signPhase:noPhase}for(const descriptor of this._policies){const policy=descriptor.policy,options=descriptor.options,policyName=policy.name;if(policyMap.has(policyName))throw new Error("Duplicate policy names not allowed in pipeline");const node={policy:policy,dependsOn:new Set,dependants:new Set};options.afterPhase&&(node.afterPhase=getPhase(options.afterPhase),node.afterPhase.hasAfterPolicies=!0),policyMap.set(policyName,node);getPhase(options.phase).policies.add(node)}for(const descriptor of this._policies){const{policy:policy,options:options}=descriptor,policyName=policy.name,node=policyMap.get(policyName);if(!node)throw new Error(`Missing node for policy ${policyName}`);if(options.afterPolicies)for(const afterPolicyName of options.afterPolicies){const afterNode=policyMap.get(afterPolicyName);afterNode&&(node.dependsOn.add(afterNode),afterNode.dependants.add(node))}if(options.beforePolicies)for(const beforePolicyName of options.beforePolicies){const beforeNode=policyMap.get(beforePolicyName);beforeNode&&(beforeNode.dependsOn.add(node),node.dependants.add(beforeNode))}}function walkPhase(phase){phase.hasRun=!0;for(const node of phase.policies)if((!node.afterPhase||node.afterPhase.hasRun&&!node.afterPhase.policies.size)&&0===node.dependsOn.size){result.push(node.policy);for(const dependant of node.dependants)dependant.dependsOn.delete(node);policyMap.delete(node.policy.name),phase.policies.delete(node)}}function walkPhases(){for(const phase of orderedPhases){if(walkPhase(phase),phase.policies.size>0&&phase!==noPhase)return void(noPhase.hasRun||walkPhase(noPhase));phase.hasAfterPolicies&&walkPhase(noPhase)}}let iteration=0;for(;policyMap.size>0;){iteration++;const initialResultLength=result.length;if(walkPhases(),result.length<=initialResultLength&&iteration>1)throw new Error("Cannot satisfy policy dependencies due to requirements cycle.")}return result}}export function createEmptyPipeline(){return HttpPipeline.create()}