import{AbortError}from"@azure/abort-controller";import{createHttpHeaders}from"./httpHeaders";import{RestError}from"./restError";function isNodeReadableStream(body){return body&&"function"==typeof body.pipe}function isReadableStream(body){return Boolean(body&&"function"==typeof body.getReader&&"function"==typeof body.tee)}class XhrHttpClient{async sendRequest(request){var _a;if("https:"!==new URL(request.url).protocol&&!request.allowInsecureConnection)throw new Error(`Cannot connect to ${request.url} while allowInsecureConnection is false.`);const xhr=new XMLHttpRequest;if(request.proxySettings)throw new Error("HTTP proxy is not supported in browser environment");const abortSignal=request.abortSignal;if(abortSignal){if(abortSignal.aborted)throw new AbortError("The operation was aborted.");const listener=()=>{xhr.abort()};abortSignal.addEventListener("abort",listener),xhr.addEventListener("readystatechange",(()=>{xhr.readyState===XMLHttpRequest.DONE&&abortSignal.removeEventListener("abort",listener)}))}addProgressListener(xhr.upload,request.onUploadProgress),addProgressListener(xhr,request.onDownloadProgress),xhr.open(request.method,request.url),xhr.timeout=request.timeout,xhr.withCredentials=request.withCredentials;for(const[name,value]of request.headers)xhr.setRequestHeader(name,value);xhr.responseType=(null===(_a=request.streamResponseStatusCodes)||void 0===_a?void 0:_a.size)?"blob":"text";const body="function"==typeof request.body?request.body():request.body;if(isNodeReadableStream(body)||isReadableStream(body))throw new Error("streams are not supported in XhrHttpClient.");return xhr.send(void 0===body?null:body),"blob"===xhr.responseType?new Promise(((resolve,reject)=>{handleBlobResponse(xhr,request,resolve,reject),rejectOnTerminalEvent(request,xhr,reject)})):new Promise((function(resolve,reject){xhr.addEventListener("load",(()=>resolve({request:request,status:xhr.status,headers:parseHeaders(xhr),bodyAsText:xhr.responseText}))),rejectOnTerminalEvent(request,xhr,reject)}))}}function handleBlobResponse(xhr,request,res,rej){xhr.addEventListener("readystatechange",(()=>{var _a,_b;if(xhr.readyState===XMLHttpRequest.HEADERS_RECEIVED)if((null===(_a=request.streamResponseStatusCodes)||void 0===_a?void 0:_a.has(Number.POSITIVE_INFINITY))||(null===(_b=request.streamResponseStatusCodes)||void 0===_b?void 0:_b.has(xhr.status))){const blobBody=new Promise(((resolve,reject)=>{xhr.addEventListener("load",(()=>{resolve(xhr.response)})),rejectOnTerminalEvent(request,xhr,reject)}));res({request:request,status:xhr.status,headers:parseHeaders(xhr),blobBody:blobBody})}else xhr.addEventListener("load",(()=>{xhr.response?xhr.response.text().then((text=>{res({request:request,status:xhr.status,headers:parseHeaders(xhr),bodyAsText:text})})).catch((e=>{rej(e)})):res({request:request,status:xhr.status,headers:parseHeaders(xhr)})}))}))}function addProgressListener(xhr,listener){listener&&xhr.addEventListener("progress",(rawEvent=>listener({loadedBytes:rawEvent.loaded})))}function parseHeaders(xhr){const responseHeaders=createHttpHeaders(),headerLines=xhr.getAllResponseHeaders().trim().split(/[\r\n]+/);for(const line of headerLines){const index=line.indexOf(":"),headerName=line.slice(0,index),headerValue=line.slice(index+2);responseHeaders.set(headerName,headerValue)}return responseHeaders}function rejectOnTerminalEvent(request,xhr,reject){xhr.addEventListener("error",(()=>reject(new RestError(`Failed to send request to ${request.url}`,{code:RestError.REQUEST_SEND_ERROR,request:request}))));const abortError=new AbortError("The operation was aborted.");xhr.addEventListener("abort",(()=>reject(abortError))),xhr.addEventListener("timeout",(()=>reject(abortError)))}export function createXhrHttpClient(){return new XhrHttpClient}