"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var logger$1=require("@azure/logger"),coreUtil=require("@azure/core-util"),os=require("os"),abortController=require("@azure/abort-controller"),FormData=require("form-data"),httpsProxyAgent=require("https-proxy-agent"),httpProxyAgent=require("http-proxy-agent"),coreTracing=require("@azure/core-tracing"),util=require("util"),http=require("http"),https=require("https"),zlib=require("zlib"),stream=require("stream");function _interopDefaultLegacy(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function _interopNamespace(e){if(e&&e.__esModule)return e;var n=Object.create(null);return e&&Object.keys(e).forEach((function(k){if("default"!==k){var d=Object.getOwnPropertyDescriptor(e,k);Object.defineProperty(n,k,d.get?d:{enumerable:!0,get:function(){return e[k]}})}})),n.default=e,Object.freeze(n)}var os__namespace=_interopNamespace(os),FormData__default=_interopDefaultLegacy(FormData),http__namespace=_interopNamespace(http),https__namespace=_interopNamespace(https),zlib__namespace=_interopNamespace(zlib);const ValidPhaseNames=new Set(["Deserialize","Serialize","Retry","Sign"]);class HttpPipeline{constructor(policies){var _a;this._policies=[],this._policies=null!==(_a=null==policies?void 0:policies.slice(0))&&void 0!==_a?_a:[],this._orderedPolicies=void 0}addPolicy(policy,options={}){if(options.phase&&options.afterPhase)throw new Error("Policies inside a phase cannot specify afterPhase.");if(options.phase&&!ValidPhaseNames.has(options.phase))throw new Error(`Invalid phase name: ${options.phase}`);if(options.afterPhase&&!ValidPhaseNames.has(options.afterPhase))throw new Error(`Invalid afterPhase name: ${options.afterPhase}`);this._policies.push({policy:policy,options:options}),this._orderedPolicies=void 0}removePolicy(options){const removedPolicies=[];return this._policies=this._policies.filter((policyDescriptor=>!(options.name&&policyDescriptor.policy.name===options.name||options.phase&&policyDescriptor.options.phase===options.phase)||(removedPolicies.push(policyDescriptor.policy),!1))),this._orderedPolicies=void 0,removedPolicies}sendRequest(httpClient,request){return this.getOrderedPolicies().reduceRight(((next,policy)=>req=>policy.sendRequest(req,next)),(req=>httpClient.sendRequest(req)))(request)}getOrderedPolicies(){return this._orderedPolicies||(this._orderedPolicies=this.orderPolicies()),this._orderedPolicies}clone(){return new HttpPipeline(this._policies)}static create(){return new HttpPipeline}orderPolicies(){const result=[],policyMap=new Map;function createPhase(name){return{name:name,policies:new Set,hasRun:!1,hasAfterPolicies:!1}}const serializePhase=createPhase("Serialize"),noPhase=createPhase("None"),deserializePhase=createPhase("Deserialize"),retryPhase=createPhase("Retry"),signPhase=createPhase("Sign"),orderedPhases=[serializePhase,noPhase,deserializePhase,retryPhase,signPhase];function getPhase(phase){return"Retry"===phase?retryPhase:"Serialize"===phase?serializePhase:"Deserialize"===phase?deserializePhase:"Sign"===phase?signPhase:noPhase}for(const descriptor of this._policies){const policy=descriptor.policy,options=descriptor.options,policyName=policy.name;if(policyMap.has(policyName))throw new Error("Duplicate policy names not allowed in pipeline");const node={policy:policy,dependsOn:new Set,dependants:new Set};options.afterPhase&&(node.afterPhase=getPhase(options.afterPhase),node.afterPhase.hasAfterPolicies=!0),policyMap.set(policyName,node);getPhase(options.phase).policies.add(node)}for(const descriptor of this._policies){const{policy:policy,options:options}=descriptor,policyName=policy.name,node=policyMap.get(policyName);if(!node)throw new Error(`Missing node for policy ${policyName}`);if(options.afterPolicies)for(const afterPolicyName of options.afterPolicies){const afterNode=policyMap.get(afterPolicyName);afterNode&&(node.dependsOn.add(afterNode),afterNode.dependants.add(node))}if(options.beforePolicies)for(const beforePolicyName of options.beforePolicies){const beforeNode=policyMap.get(beforePolicyName);beforeNode&&(beforeNode.dependsOn.add(node),node.dependants.add(beforeNode))}}function walkPhase(phase){phase.hasRun=!0;for(const node of phase.policies)if((!node.afterPhase||node.afterPhase.hasRun&&!node.afterPhase.policies.size)&&0===node.dependsOn.size){result.push(node.policy);for(const dependant of node.dependants)dependant.dependsOn.delete(node);policyMap.delete(node.policy.name),phase.policies.delete(node)}}function walkPhases(){for(const phase of orderedPhases){if(walkPhase(phase),phase.policies.size>0&&phase!==noPhase)return void(noPhase.hasRun||walkPhase(noPhase));phase.hasAfterPolicies&&walkPhase(noPhase)}}let iteration=0;for(;policyMap.size>0;){iteration++;const initialResultLength=result.length;if(walkPhases(),result.length<=initialResultLength&&iteration>1)throw new Error("Cannot satisfy policy dependencies due to requirements cycle.")}return result}}function createEmptyPipeline(){return HttpPipeline.create()}const logger=logger$1.createClientLogger("core-rest-pipeline"),RedactedString="REDACTED",defaultAllowedHeaderNames=["x-ms-client-request-id","x-ms-return-client-request-id","x-ms-useragent","x-ms-correlation-request-id","x-ms-request-id","client-request-id","ms-cv","return-client-request-id","traceparent","Access-Control-Allow-Credentials","Access-Control-Allow-Headers","Access-Control-Allow-Methods","Access-Control-Allow-Origin","Access-Control-Expose-Headers","Access-Control-Max-Age","Access-Control-Request-Headers","Access-Control-Request-Method","Origin","Accept","Accept-Encoding","Cache-Control","Connection","Content-Length","Content-Type","Date","ETag","Expires","If-Match","If-Modified-Since","If-None-Match","If-Unmodified-Since","Last-Modified","Pragma","Request-Id","Retry-After","Server","Transfer-Encoding","User-Agent","WWW-Authenticate"],defaultAllowedQueryParameters=["api-version"];class Sanitizer{constructor({additionalAllowedHeaderNames:allowedHeaderNames=[],additionalAllowedQueryParameters:allowedQueryParameters=[]}={}){allowedHeaderNames=defaultAllowedHeaderNames.concat(allowedHeaderNames),allowedQueryParameters=defaultAllowedQueryParameters.concat(allowedQueryParameters),this.allowedHeaderNames=new Set(allowedHeaderNames.map((n=>n.toLowerCase()))),this.allowedQueryParameters=new Set(allowedQueryParameters.map((p=>p.toLowerCase())))}sanitize(obj){const seen=new Set;return JSON.stringify(obj,((key,value)=>{if(value instanceof Error)return Object.assign(Object.assign({},value),{name:value.name,message:value.message});if("headers"===key)return this.sanitizeHeaders(value);if("url"===key)return this.sanitizeUrl(value);if("query"===key)return this.sanitizeQuery(value);if("body"!==key&&"response"!==key&&"operationSpec"!==key){if(Array.isArray(value)||coreUtil.isObject(value)){if(seen.has(value))return"[Circular]";seen.add(value)}return value}}),2)}sanitizeHeaders(obj){const sanitized={};for(const key of Object.keys(obj))this.allowedHeaderNames.has(key.toLowerCase())?sanitized[key]=obj[key]:sanitized[key]=RedactedString;return sanitized}sanitizeQuery(value){if("object"!=typeof value||null===value)return value;const sanitized={};for(const k of Object.keys(value))this.allowedQueryParameters.has(k.toLowerCase())?sanitized[k]=value[k]:sanitized[k]=RedactedString;return sanitized}sanitizeUrl(value){if("string"!=typeof value||null===value)return value;const url=new URL(value);if(!url.search)return value;for(const[key]of url.searchParams)this.allowedQueryParameters.has(key.toLowerCase())||url.searchParams.set(key,RedactedString);return url.toString()}}const logPolicyName="logPolicy";function logPolicy(options={}){var _a;const logger$1=null!==(_a=options.logger)&&void 0!==_a?_a:logger.info,sanitizer=new Sanitizer({additionalAllowedHeaderNames:options.additionalAllowedHeaderNames,additionalAllowedQueryParameters:options.additionalAllowedQueryParameters});return{name:logPolicyName,async sendRequest(request,next){if(!logger$1.enabled)return next(request);logger$1(`Request: ${sanitizer.sanitize(request)}`);const response=await next(request);return logger$1(`Response status code: ${response.status}`),logger$1(`Headers: ${sanitizer.sanitize(response.headers)}`),response}}}const redirectPolicyName="redirectPolicy",allowedRedirect=["GET","HEAD"];function redirectPolicy(options={}){const{maxRetries:maxRetries=20}=options;return{name:redirectPolicyName,async sendRequest(request,next){const response=await next(request);return handleRedirect(next,response,maxRetries)}}}async function handleRedirect(next,response,maxRetries,currentRetries=0){const{request:request,status:status,headers:headers}=response,locationHeader=headers.get("location");if(locationHeader&&(300===status||301===status&&allowedRedirect.includes(request.method)||302===status&&allowedRedirect.includes(request.method)||303===status&&"POST"===request.method||307===status)&&currentRetries<maxRetries){const url=new URL(locationHeader,request.url);request.url=url.toString(),303===status&&(request.method="GET",request.headers.delete("Content-Length"),delete request.body),request.headers.delete("Authorization");const res=await next(request);return handleRedirect(next,res,maxRetries,currentRetries+1)}return response}function getHeaderName(){return"User-Agent"}function setPlatformSpecificData(map){map.set("Node",process.version),map.set("OS",`(${os__namespace.arch()}-${os__namespace.type()}-${os__namespace.release()})`)}const SDK_VERSION="1.11.0",DEFAULT_RETRY_POLICY_COUNT=3;function getUserAgentString(telemetryInfo){const parts=[];for(const[key,value]of telemetryInfo){const token=value?`${key}/${value}`:key;parts.push(token)}return parts.join(" ")}function getUserAgentHeaderName(){return getHeaderName()}function getUserAgentValue(prefix){const runtimeInfo=new Map;runtimeInfo.set("core-rest-pipeline",SDK_VERSION),setPlatformSpecificData(runtimeInfo);const defaultAgent=getUserAgentString(runtimeInfo);return prefix?`${prefix} ${defaultAgent}`:defaultAgent}const UserAgentHeaderName=getUserAgentHeaderName(),userAgentPolicyName="userAgentPolicy";function userAgentPolicy(options={}){const userAgentValue=getUserAgentValue(options.userAgentPrefix);return{name:userAgentPolicyName,sendRequest:async(request,next)=>(request.headers.has(UserAgentHeaderName)||request.headers.set(UserAgentHeaderName,userAgentValue),next(request))}}const decompressResponsePolicyName="decompressResponsePolicy";function decompressResponsePolicy(){return{name:decompressResponsePolicyName,sendRequest:async(request,next)=>("HEAD"!==request.method&&request.headers.set("Accept-Encoding","gzip,deflate"),next(request))}}const StandardAbortMessage="The operation was aborted.";function delay(delayInMs,value,options){return new Promise(((resolve,reject)=>{let timer,onAborted;const rejectOnAbort=()=>reject(new abortController.AbortError((null==options?void 0:options.abortErrorMsg)?null==options?void 0:options.abortErrorMsg:StandardAbortMessage)),removeListeners=()=>{(null==options?void 0:options.abortSignal)&&onAborted&&options.abortSignal.removeEventListener("abort",onAborted)};if(onAborted=()=>(timer&&clearTimeout(timer),removeListeners(),rejectOnAbort()),(null==options?void 0:options.abortSignal)&&options.abortSignal.aborted)return rejectOnAbort();timer=setTimeout((()=>{removeListeners(),resolve(value)}),delayInMs),(null==options?void 0:options.abortSignal)&&options.abortSignal.addEventListener("abort",onAborted)}))}function parseHeaderValueAsNumber(response,headerName){const value=response.headers.get(headerName);if(!value)return;const valueAsNum=Number(value);return Number.isNaN(valueAsNum)?void 0:valueAsNum}const RetryAfterHeader="Retry-After",AllRetryAfterHeaders=["retry-after-ms","x-ms-retry-after-ms",RetryAfterHeader];function getRetryAfterInMs(response){if(response&&[429,503].includes(response.status))try{for(const header of AllRetryAfterHeaders){const retryAfterValue=parseHeaderValueAsNumber(response,header);if(0===retryAfterValue||retryAfterValue){return retryAfterValue*(header===RetryAfterHeader?1e3:1)}}const retryAfterHeader=response.headers.get(RetryAfterHeader);if(!retryAfterHeader)return;const diff=Date.parse(retryAfterHeader)-Date.now();return Number.isFinite(diff)?Math.max(0,diff):void 0}catch(e){return}}function isThrottlingRetryResponse(response){return Number.isFinite(getRetryAfterInMs(response))}function throttlingRetryStrategy(){return{name:"throttlingRetryStrategy",retry({response:response}){const retryAfterInMs=getRetryAfterInMs(response);return Number.isFinite(retryAfterInMs)?{retryAfterInMs:retryAfterInMs}:{skipStrategy:!0}}}}const DEFAULT_CLIENT_RETRY_INTERVAL=1e3,DEFAULT_CLIENT_MAX_RETRY_INTERVAL=64e3;function exponentialRetryStrategy(options={}){var _a,_b;const retryInterval=null!==(_a=options.retryDelayInMs)&&void 0!==_a?_a:DEFAULT_CLIENT_RETRY_INTERVAL,maxRetryInterval=null!==(_b=options.maxRetryDelayInMs)&&void 0!==_b?_b:DEFAULT_CLIENT_MAX_RETRY_INTERVAL;let retryAfterInMs=retryInterval;return{name:"exponentialRetryStrategy",retry({retryCount:retryCount,response:response,responseError:responseError}){const matchedSystemError=isSystemError(responseError),ignoreSystemErrors=matchedSystemError&&options.ignoreSystemErrors,isExponential=isExponentialRetryResponse(response),ignoreExponentialResponse=isExponential&&options.ignoreHttpStatusCodes;if(response&&(isThrottlingRetryResponse(response)||!isExponential)||ignoreExponentialResponse||ignoreSystemErrors)return{skipStrategy:!0};if(responseError&&!matchedSystemError&&!isExponential)return{errorToThrow:responseError};const exponentialDelay=retryAfterInMs*Math.pow(2,retryCount),clampedExponentialDelay=Math.min(maxRetryInterval,exponentialDelay);return retryAfterInMs=clampedExponentialDelay/2+coreUtil.getRandomIntegerInclusive(0,clampedExponentialDelay/2),{retryAfterInMs:retryAfterInMs}}}}function isExponentialRetryResponse(response){return Boolean(response&&void 0!==response.status&&(response.status>=500||408===response.status)&&501!==response.status&&505!==response.status)}function isSystemError(err){return!!err&&("ETIMEDOUT"===err.code||"ESOCKETTIMEDOUT"===err.code||"ECONNREFUSED"===err.code||"ECONNRESET"===err.code||"ENOENT"===err.code)}const retryPolicyLogger=logger$1.createClientLogger("core-rest-pipeline retryPolicy"),retryPolicyName="retryPolicy";function retryPolicy(strategies,options={maxRetries:DEFAULT_RETRY_POLICY_COUNT}){const logger=options.logger||retryPolicyLogger;return{name:retryPolicyName,async sendRequest(request,next){var _a,_b;let response,responseError,retryCount=-1;retryRequest:for(;;){retryCount+=1,response=void 0,responseError=void 0;try{logger.info(`Retry ${retryCount}: Attempting to send request`,request.requestId),response=await next(request),logger.info(`Retry ${retryCount}: Received a response from request`,request.requestId)}catch(e){if(logger.error(`Retry ${retryCount}: Received an error from request`,request.requestId),responseError=e,!e||"RestError"!==responseError.name)throw e;response=responseError.response}if(null===(_a=request.abortSignal)||void 0===_a?void 0:_a.aborted){logger.error(`Retry ${retryCount}: Request aborted.`);throw new abortController.AbortError}if(retryCount>=(null!==(_b=options.maxRetries)&&void 0!==_b?_b:DEFAULT_RETRY_POLICY_COUNT)){if(logger.info(`Retry ${retryCount}: Maximum retries reached. Returning the last received response, or throwing the last received error.`),responseError)throw responseError;if(response)return response;throw new Error("Maximum retries reached with no response or error to throw")}logger.info(`Retry ${retryCount}: Processing ${strategies.length} retry strategies.`);strategiesLoop:for(const strategy of strategies){const strategyLogger=strategy.logger||retryPolicyLogger;strategyLogger.info(`Retry ${retryCount}: Processing retry strategy ${strategy.name}.`);const modifiers=strategy.retry({retryCount:retryCount,response:response,responseError:responseError});if(modifiers.skipStrategy){strategyLogger.info(`Retry ${retryCount}: Skipped.`);continue strategiesLoop}const{errorToThrow:errorToThrow,retryAfterInMs:retryAfterInMs,redirectTo:redirectTo}=modifiers;if(errorToThrow)throw strategyLogger.error(`Retry ${retryCount}: Retry strategy ${strategy.name} throws error:`,errorToThrow),errorToThrow;if(retryAfterInMs||0===retryAfterInMs){strategyLogger.info(`Retry ${retryCount}: Retry strategy ${strategy.name} retries after ${retryAfterInMs}`),await delay(retryAfterInMs,void 0,{abortSignal:request.abortSignal});continue retryRequest}if(redirectTo){strategyLogger.info(`Retry ${retryCount}: Retry strategy ${strategy.name} redirects to ${redirectTo}`),request.url=redirectTo;continue retryRequest}}if(responseError)throw logger.info("None of the retry strategies could work with the received error. Throwing it."),responseError;if(response)return logger.info("None of the retry strategies could work with the received response. Returning it."),response}}}}const defaultRetryPolicyName="defaultRetryPolicy";function defaultRetryPolicy(options={}){var _a;return{name:defaultRetryPolicyName,sendRequest:retryPolicy([throttlingRetryStrategy(),exponentialRetryStrategy(options)],{maxRetries:null!==(_a=options.maxRetries)&&void 0!==_a?_a:DEFAULT_RETRY_POLICY_COUNT}).sendRequest}}const formDataPolicyName="formDataPolicy";function formDataPolicy(){return{name:formDataPolicyName,async sendRequest(request,next){if(request.formData){const contentType=request.headers.get("Content-Type");contentType&&-1!==contentType.indexOf("application/x-www-form-urlencoded")?(request.body=wwwFormUrlEncode(request.formData),request.formData=void 0):await prepareFormData(request.formData,request)}return next(request)}}}function wwwFormUrlEncode(formData){const urlSearchParams=new URLSearchParams;for(const[key,value]of Object.entries(formData))if(Array.isArray(value))for(const subValue of value)urlSearchParams.append(key,subValue.toString());else urlSearchParams.append(key,value.toString());return urlSearchParams.toString()}async function prepareFormData(formData,request){const requestForm=new FormData__default.default;for(const formKey of Object.keys(formData)){const formValue=formData[formKey];if(Array.isArray(formValue))for(const subValue of formValue)requestForm.append(formKey,subValue);else requestForm.append(formKey,formValue)}request.body=requestForm,request.formData=void 0;const contentType=request.headers.get("Content-Type");contentType&&-1!==contentType.indexOf("multipart/form-data")&&request.headers.set("Content-Type",`multipart/form-data; boundary=${requestForm.getBoundary()}`);try{const contentLength=await new Promise(((resolve,reject)=>{requestForm.getLength(((err,length)=>{err?reject(err):resolve(length)}))}));request.headers.set("Content-Length",contentLength)}catch(e){}}const HTTPS_PROXY="HTTPS_PROXY",HTTP_PROXY="HTTP_PROXY",ALL_PROXY="ALL_PROXY",NO_PROXY="NO_PROXY",proxyPolicyName="proxyPolicy",globalNoProxyList=[];let noProxyListLoaded=!1;const globalBypassedMap=new Map;function getEnvironmentValue(name){return process.env[name]?process.env[name]:process.env[name.toLowerCase()]?process.env[name.toLowerCase()]:void 0}function loadEnvironmentProxyValue(){if(!process)return;const httpsProxy=getEnvironmentValue(HTTPS_PROXY),allProxy=getEnvironmentValue(ALL_PROXY),httpProxy=getEnvironmentValue(HTTP_PROXY);return httpsProxy||allProxy||httpProxy}function isBypassed(uri,noProxyList,bypassedMap){if(0===noProxyList.length)return!1;const host=new URL(uri).hostname;if(null==bypassedMap?void 0:bypassedMap.has(host))return bypassedMap.get(host);let isBypassedFlag=!1;for(const pattern of noProxyList)"."===pattern[0]?(host.endsWith(pattern)||host.length===pattern.length-1&&host===pattern.slice(1))&&(isBypassedFlag=!0):host===pattern&&(isBypassedFlag=!0);return null==bypassedMap||bypassedMap.set(host,isBypassedFlag),isBypassedFlag}function loadNoProxy(){const noProxy=getEnvironmentValue(NO_PROXY);return noProxyListLoaded=!0,noProxy?noProxy.split(",").map((item=>item.trim())).filter((item=>item.length)):[]}function getDefaultProxySettings(proxyUrl){if(!proxyUrl&&!(proxyUrl=loadEnvironmentProxyValue()))return;const parsedUrl=new URL(proxyUrl);return{host:(parsedUrl.protocol?parsedUrl.protocol+"//":"")+parsedUrl.hostname,port:Number.parseInt(parsedUrl.port||"80"),username:parsedUrl.username,password:parsedUrl.password}}function getProxyAgentOptions(proxySettings,{headers:headers,tlsSettings:tlsSettings}){let parsedProxyUrl;try{parsedProxyUrl=new URL(proxySettings.host)}catch(_error){throw new Error(`Expecting a valid host string in proxy settings, but found "${proxySettings.host}".`)}tlsSettings&&logger.warning("TLS settings are not supported in combination with custom Proxy, certificates provided to the client will be ignored.");const proxyAgentOptions={hostname:parsedProxyUrl.hostname,port:proxySettings.port,protocol:parsedProxyUrl.protocol,headers:headers.toJSON()};return proxySettings.username&&proxySettings.password?proxyAgentOptions.auth=`${proxySettings.username}:${proxySettings.password}`:proxySettings.username&&(proxyAgentOptions.auth=`${proxySettings.username}`),proxyAgentOptions}function setProxyAgentOnRequest(request,cachedAgents){if(request.agent)return;const isInsecure="https:"!==new URL(request.url).protocol,proxySettings=request.proxySettings;if(proxySettings)if(isInsecure){if(!cachedAgents.httpProxyAgent){const proxyAgentOptions=getProxyAgentOptions(proxySettings,request);cachedAgents.httpProxyAgent=new httpProxyAgent.HttpProxyAgent(proxyAgentOptions)}request.agent=cachedAgents.httpProxyAgent}else{if(!cachedAgents.httpsProxyAgent){const proxyAgentOptions=getProxyAgentOptions(proxySettings,request);cachedAgents.httpsProxyAgent=new httpsProxyAgent.HttpsProxyAgent(proxyAgentOptions)}request.agent=cachedAgents.httpsProxyAgent}}function proxyPolicy(proxySettings=getDefaultProxySettings(),options){noProxyListLoaded||globalNoProxyList.push(...loadNoProxy());const cachedAgents={};return{name:proxyPolicyName,async sendRequest(request,next){var _a;return request.proxySettings||isBypassed(request.url,null!==(_a=null==options?void 0:options.customNoProxyList)&&void 0!==_a?_a:globalNoProxyList,(null==options?void 0:options.customNoProxyList)?void 0:globalBypassedMap)||(request.proxySettings=proxySettings),request.proxySettings&&setProxyAgentOnRequest(request,cachedAgents),next(request)}}}const setClientRequestIdPolicyName="setClientRequestIdPolicy";function setClientRequestIdPolicy(requestIdHeaderName="x-ms-client-request-id"){return{name:setClientRequestIdPolicyName,sendRequest:async(request,next)=>(request.headers.has(requestIdHeaderName)||request.headers.set(requestIdHeaderName,request.requestId),next(request))}}const tlsPolicyName="tlsPolicy";function tlsPolicy(tlsSettings){return{name:tlsPolicyName,sendRequest:async(req,next)=>(req.tlsSettings||(req.tlsSettings=tlsSettings),next(req))}}const custom=util.inspect.custom,errorSanitizer=new Sanitizer;class RestError extends Error{constructor(message,options={}){super(message),this.name="RestError",this.code=options.code,this.statusCode=options.statusCode,this.request=options.request,this.response=options.response,Object.setPrototypeOf(this,RestError.prototype)}[custom](){return`RestError: ${this.message} \n ${errorSanitizer.sanitize(this)}`}}function isRestError(e){return e instanceof RestError||coreUtil.isError(e)&&"RestError"===e.name}RestError.REQUEST_SEND_ERROR="REQUEST_SEND_ERROR",RestError.PARSE_ERROR="PARSE_ERROR";const tracingPolicyName="tracingPolicy";function tracingPolicy(options={}){const userAgent=getUserAgentValue(options.userAgentPrefix),tracingClient=tryCreateTracingClient();return{name:tracingPolicyName,async sendRequest(request,next){var _a,_b;if(!tracingClient||!(null===(_a=request.tracingOptions)||void 0===_a?void 0:_a.tracingContext))return next(request);const{span:span,tracingContext:tracingContext}=null!==(_b=tryCreateSpan(tracingClient,request,userAgent))&&void 0!==_b?_b:{};if(!span||!tracingContext)return next(request);try{const response=await tracingClient.withContext(tracingContext,next,request);return tryProcessResponse(span,response),response}catch(err){throw tryProcessError(span,err),err}}}}function tryCreateTracingClient(){try{return coreTracing.createTracingClient({namespace:"",packageName:"@azure/core-rest-pipeline",packageVersion:SDK_VERSION})}catch(e){return void logger.warning(`Error when creating the TracingClient: ${coreUtil.getErrorMessage(e)}`)}}function tryCreateSpan(tracingClient,request,userAgent){try{const{span:span,updatedOptions:updatedOptions}=tracingClient.startSpan(`HTTP ${request.method}`,{tracingOptions:request.tracingOptions},{spanKind:"client",spanAttributes:{"http.method":request.method,"http.url":request.url,requestId:request.requestId}});if(!span.isRecording())return void span.end();userAgent&&span.setAttribute("http.user_agent",userAgent);const headers=tracingClient.createRequestHeaders(updatedOptions.tracingOptions.tracingContext);for(const[key,value]of Object.entries(headers))request.headers.set(key,value);return{span:span,tracingContext:updatedOptions.tracingOptions.tracingContext}}catch(e){return void logger.warning(`Skipping creating a tracing span due to an error: ${coreUtil.getErrorMessage(e)}`)}}function tryProcessError(span,error){try{span.setStatus({status:"error",error:coreUtil.isError(error)?error:void 0}),isRestError(error)&&error.statusCode&&span.setAttribute("http.status_code",error.statusCode),span.end()}catch(e){logger.warning(`Skipping tracing span processing due to an error: ${coreUtil.getErrorMessage(e)}`)}}function tryProcessResponse(span,response){try{span.setAttribute("http.status_code",response.status);const serviceRequestId=response.headers.get("x-ms-request-id");serviceRequestId&&span.setAttribute("serviceRequestId",serviceRequestId),span.setStatus({status:"success"}),span.end()}catch(e){logger.warning(`Skipping tracing span processing due to an error: ${coreUtil.getErrorMessage(e)}`)}}function createPipelineFromOptions(options){const pipeline=createEmptyPipeline();return coreUtil.isNode&&(options.tlsOptions&&pipeline.addPolicy(tlsPolicy(options.tlsOptions)),pipeline.addPolicy(proxyPolicy(options.proxyOptions)),pipeline.addPolicy(decompressResponsePolicy())),pipeline.addPolicy(formDataPolicy()),pipeline.addPolicy(userAgentPolicy(options.userAgentOptions)),pipeline.addPolicy(setClientRequestIdPolicy()),pipeline.addPolicy(defaultRetryPolicy(options.retryOptions),{phase:"Retry"}),pipeline.addPolicy(tracingPolicy(options.userAgentOptions),{afterPhase:"Retry"}),coreUtil.isNode&&pipeline.addPolicy(redirectPolicy(options.redirectOptions),{afterPhase:"Retry"}),pipeline.addPolicy(logPolicy(options.loggingOptions),{afterPhase:"Sign"}),pipeline}function normalizeName(name){return name.toLowerCase()}function*headerIterator(map){for(const entry of map.values())yield[entry.name,entry.value]}class HttpHeadersImpl{constructor(rawHeaders){if(this._headersMap=new Map,rawHeaders)for(const headerName of Object.keys(rawHeaders))this.set(headerName,rawHeaders[headerName])}set(name,value){this._headersMap.set(normalizeName(name),{name:name,value:String(value)})}get(name){var _a;return null===(_a=this._headersMap.get(normalizeName(name)))||void 0===_a?void 0:_a.value}has(name){return this._headersMap.has(normalizeName(name))}delete(name){this._headersMap.delete(normalizeName(name))}toJSON(options={}){const result={};if(options.preserveCase)for(const entry of this._headersMap.values())result[entry.name]=entry.value;else for(const[normalizedName,entry]of this._headersMap)result[normalizedName]=entry.value;return result}toString(){return JSON.stringify(this.toJSON({preserveCase:!0}))}[Symbol.iterator](){return headerIterator(this._headersMap)}}function createHttpHeaders(rawHeaders){return new HttpHeadersImpl(rawHeaders)}const DEFAULT_TLS_SETTINGS={};function isReadableStream(body){return body&&"function"==typeof body.pipe}function isStreamComplete(stream){return new Promise((resolve=>{stream.on("close",resolve),stream.on("end",resolve),stream.on("error",resolve)}))}function isArrayBuffer(body){return body&&"number"==typeof body.byteLength}class ReportTransform extends stream.Transform{_transform(chunk,_encoding,callback){this.push(chunk),this.loadedBytes+=chunk.length;try{this.progressCallback({loadedBytes:this.loadedBytes}),callback()}catch(e){callback(e)}}constructor(progressCallback){super(),this.loadedBytes=0,this.progressCallback=progressCallback}}class NodeHttpClient{constructor(){this.cachedHttpsAgents=new WeakMap}async sendRequest(request){var _a,_b,_c;const abortController$1=new abortController.AbortController;let abortListener;if(request.abortSignal){if(request.abortSignal.aborted)throw new abortController.AbortError("The operation was aborted.");abortListener=event=>{"abort"===event.type&&abortController$1.abort()},request.abortSignal.addEventListener("abort",abortListener)}request.timeout>0&&setTimeout((()=>{abortController$1.abort()}),request.timeout);const acceptEncoding=request.headers.get("Accept-Encoding"),shouldDecompress=(null==acceptEncoding?void 0:acceptEncoding.includes("gzip"))||(null==acceptEncoding?void 0:acceptEncoding.includes("deflate"));let responseStream,body="function"==typeof request.body?request.body():request.body;if(body&&!request.headers.has("Content-Length")){const bodyLength=getBodyLength(body);null!==bodyLength&&request.headers.set("Content-Length",bodyLength)}try{if(body&&request.onUploadProgress){const onUploadProgress=request.onUploadProgress,uploadReportStream=new ReportTransform(onUploadProgress);uploadReportStream.on("error",(e=>{logger.error("Error in upload progress",e)})),isReadableStream(body)?body.pipe(uploadReportStream):uploadReportStream.end(body),body=uploadReportStream}const res=await this.makeRequest(request,abortController$1,body),headers=getResponseHeaders(res),response={status:null!==(_a=res.statusCode)&&void 0!==_a?_a:0,headers:headers,request:request};if("HEAD"===request.method)return res.resume(),response;responseStream=shouldDecompress?getDecodedResponseStream(res,headers):res;const onDownloadProgress=request.onDownloadProgress;if(onDownloadProgress){const downloadReportStream=new ReportTransform(onDownloadProgress);downloadReportStream.on("error",(e=>{logger.error("Error in download progress",e)})),responseStream.pipe(downloadReportStream),responseStream=downloadReportStream}return(null===(_b=request.streamResponseStatusCodes)||void 0===_b?void 0:_b.has(Number.POSITIVE_INFINITY))||(null===(_c=request.streamResponseStatusCodes)||void 0===_c?void 0:_c.has(response.status))?response.readableStreamBody=responseStream:response.bodyAsText=await streamToText(responseStream),response}finally{if(request.abortSignal&&abortListener){let uploadStreamDone=Promise.resolve();isReadableStream(body)&&(uploadStreamDone=isStreamComplete(body));let downloadStreamDone=Promise.resolve();isReadableStream(responseStream)&&(downloadStreamDone=isStreamComplete(responseStream)),Promise.all([uploadStreamDone,downloadStreamDone]).then((()=>{var _a;abortListener&&(null===(_a=request.abortSignal)||void 0===_a||_a.removeEventListener("abort",abortListener))})).catch((e=>{logger.warning("Error when cleaning up abortListener on httpRequest",e)}))}}}makeRequest(request,abortController$1,body){var _a;const url=new URL(request.url),isInsecure="https:"!==url.protocol;if(isInsecure&&!request.allowInsecureConnection)throw new Error(`Cannot connect to ${request.url} while allowInsecureConnection is false.`);const options={agent:null!==(_a=request.agent)&&void 0!==_a?_a:this.getOrCreateAgent(request,isInsecure),hostname:url.hostname,path:`${url.pathname}${url.search}`,port:url.port,method:request.method,headers:request.headers.toJSON({preserveCase:!0})};return new Promise(((resolve,reject)=>{const req=isInsecure?http__namespace.request(options,resolve):https__namespace.request(options,resolve);req.once("error",(err=>{var _a;reject(new RestError(err.message,{code:null!==(_a=err.code)&&void 0!==_a?_a:RestError.REQUEST_SEND_ERROR,request:request}))})),abortController$1.signal.addEventListener("abort",(()=>{const abortError=new abortController.AbortError("The operation was aborted.");req.destroy(abortError),reject(abortError)})),body&&isReadableStream(body)?body.pipe(req):body?"string"==typeof body||Buffer.isBuffer(body)?req.end(body):isArrayBuffer(body)?req.end(ArrayBuffer.isView(body)?Buffer.from(body.buffer):Buffer.from(body)):(logger.error("Unrecognized body type",body),reject(new RestError("Unrecognized body type"))):req.end()}))}getOrCreateAgent(request,isInsecure){var _a;const disableKeepAlive=request.disableKeepAlive;if(isInsecure)return disableKeepAlive?http__namespace.globalAgent:(this.cachedHttpAgent||(this.cachedHttpAgent=new http__namespace.Agent({keepAlive:!0})),this.cachedHttpAgent);{if(disableKeepAlive&&!request.tlsSettings)return https__namespace.globalAgent;const tlsSettings=null!==(_a=request.tlsSettings)&&void 0!==_a?_a:DEFAULT_TLS_SETTINGS;let agent=this.cachedHttpsAgents.get(tlsSettings);return agent&&agent.options.keepAlive===!disableKeepAlive||(logger.info("No cached TLS Agent exist, creating a new Agent"),agent=new https__namespace.Agent(Object.assign({keepAlive:!disableKeepAlive},tlsSettings)),this.cachedHttpsAgents.set(tlsSettings,agent)),agent}}}function getResponseHeaders(res){const headers=createHttpHeaders();for(const header of Object.keys(res.headers)){const value=res.headers[header];Array.isArray(value)?value.length>0&&headers.set(header,value[0]):value&&headers.set(header,value)}return headers}function getDecodedResponseStream(stream,headers){const contentEncoding=headers.get("Content-Encoding");if("gzip"===contentEncoding){const unzip=zlib__namespace.createGunzip();return stream.pipe(unzip),unzip}if("deflate"===contentEncoding){const inflate=zlib__namespace.createInflate();return stream.pipe(inflate),inflate}return stream}function streamToText(stream){return new Promise(((resolve,reject)=>{const buffer=[];stream.on("data",(chunk=>{Buffer.isBuffer(chunk)?buffer.push(chunk):buffer.push(Buffer.from(chunk))})),stream.on("end",(()=>{resolve(Buffer.concat(buffer).toString("utf8"))})),stream.on("error",(e=>{e&&"AbortError"===(null==e?void 0:e.name)?reject(e):reject(new RestError(`Error reading response as text: ${e.message}`,{code:RestError.PARSE_ERROR}))}))}))}function getBodyLength(body){return body?Buffer.isBuffer(body)?body.length:isReadableStream(body)?null:isArrayBuffer(body)?body.byteLength:"string"==typeof body?Buffer.from(body).length:null:0}function createNodeHttpClient(){return new NodeHttpClient}function createDefaultHttpClient(){return createNodeHttpClient()}class PipelineRequestImpl{constructor(options){var _a,_b,_c,_d,_e,_f,_g;this.url=options.url,this.body=options.body,this.headers=null!==(_a=options.headers)&&void 0!==_a?_a:createHttpHeaders(),this.method=null!==(_b=options.method)&&void 0!==_b?_b:"GET",this.timeout=null!==(_c=options.timeout)&&void 0!==_c?_c:0,this.formData=options.formData,this.disableKeepAlive=null!==(_d=options.disableKeepAlive)&&void 0!==_d&&_d,this.proxySettings=options.proxySettings,this.streamResponseStatusCodes=options.streamResponseStatusCodes,this.withCredentials=null!==(_e=options.withCredentials)&&void 0!==_e&&_e,this.abortSignal=options.abortSignal,this.tracingOptions=options.tracingOptions,this.onUploadProgress=options.onUploadProgress,this.onDownloadProgress=options.onDownloadProgress,this.requestId=options.requestId||coreUtil.randomUUID(),this.allowInsecureConnection=null!==(_f=options.allowInsecureConnection)&&void 0!==_f&&_f,this.enableBrowserStreams=null!==(_g=options.enableBrowserStreams)&&void 0!==_g&&_g}}function createPipelineRequest(options){return new PipelineRequestImpl(options)}const exponentialRetryPolicyName="exponentialRetryPolicy";function exponentialRetryPolicy(options={}){var _a;return retryPolicy([exponentialRetryStrategy(Object.assign(Object.assign({},options),{ignoreSystemErrors:!0}))],{maxRetries:null!==(_a=options.maxRetries)&&void 0!==_a?_a:DEFAULT_RETRY_POLICY_COUNT})}const systemErrorRetryPolicyName="systemErrorRetryPolicy";function systemErrorRetryPolicy(options={}){var _a;return{name:systemErrorRetryPolicyName,sendRequest:retryPolicy([exponentialRetryStrategy(Object.assign(Object.assign({},options),{ignoreHttpStatusCodes:!0}))],{maxRetries:null!==(_a=options.maxRetries)&&void 0!==_a?_a:DEFAULT_RETRY_POLICY_COUNT}).sendRequest}}const throttlingRetryPolicyName="throttlingRetryPolicy";function throttlingRetryPolicy(options={}){var _a;return{name:throttlingRetryPolicyName,sendRequest:retryPolicy([throttlingRetryStrategy()],{maxRetries:null!==(_a=options.maxRetries)&&void 0!==_a?_a:DEFAULT_RETRY_POLICY_COUNT}).sendRequest}}const DEFAULT_CYCLER_OPTIONS={forcedRefreshWindowInMs:1e3,retryIntervalInMs:3e3,refreshWindowInMs:12e4};async function beginRefresh(getAccessToken,retryIntervalInMs,refreshTimeout){async function tryGetAccessToken(){if(!(Date.now()<refreshTimeout)){const finalToken=await getAccessToken();if(null===finalToken)throw new Error("Failed to refresh access token.");return finalToken}try{return await getAccessToken()}catch(_a){return null}}let token=await tryGetAccessToken();for(;null===token;)await delay(retryIntervalInMs),token=await tryGetAccessToken();return token}function createTokenCycler(credential,tokenCyclerOptions){let tenantId,refreshWorker=null,token=null;const options=Object.assign(Object.assign({},DEFAULT_CYCLER_OPTIONS),tokenCyclerOptions),cycler={get isRefreshing(){return null!==refreshWorker},get shouldRefresh(){var _a;return!cycler.isRefreshing&&(null!==(_a=null==token?void 0:token.expiresOnTimestamp)&&void 0!==_a?_a:0)-options.refreshWindowInMs<Date.now()},get mustRefresh(){return null===token||token.expiresOnTimestamp-options.forcedRefreshWindowInMs<Date.now()}};function refresh(scopes,getTokenOptions){var _a;if(!cycler.isRefreshing){refreshWorker=beginRefresh((()=>credential.getToken(scopes,getTokenOptions)),options.retryIntervalInMs,null!==(_a=null==token?void 0:token.expiresOnTimestamp)&&void 0!==_a?_a:Date.now()).then((_token=>(refreshWorker=null,token=_token,tenantId=getTokenOptions.tenantId,token))).catch((reason=>{throw refreshWorker=null,token=null,tenantId=void 0,reason}))}return refreshWorker}return async(scopes,tokenOptions)=>tenantId!==tokenOptions.tenantId||Boolean(tokenOptions.claims)||cycler.mustRefresh?refresh(scopes,tokenOptions):(cycler.shouldRefresh&&refresh(scopes,tokenOptions),token)}const bearerTokenAuthenticationPolicyName="bearerTokenAuthenticationPolicy";async function defaultAuthorizeRequest(options){const{scopes:scopes,getAccessToken:getAccessToken,request:request}=options,getTokenOptions={abortSignal:request.abortSignal,tracingOptions:request.tracingOptions},accessToken=await getAccessToken(scopes,getTokenOptions);accessToken&&options.request.headers.set("Authorization",`Bearer ${accessToken.token}`)}function getChallenge(response){const challenge=response.headers.get("WWW-Authenticate");if(401===response.status&&challenge)return challenge}function bearerTokenAuthenticationPolicy(options){var _a;const{credential:credential,scopes:scopes,challengeCallbacks:challengeCallbacks}=options,logger$1=options.logger||logger,callbacks=Object.assign({authorizeRequest:null!==(_a=null==challengeCallbacks?void 0:challengeCallbacks.authorizeRequest)&&void 0!==_a?_a:defaultAuthorizeRequest,authorizeRequestOnChallenge:null==challengeCallbacks?void 0:challengeCallbacks.authorizeRequestOnChallenge},challengeCallbacks),getAccessToken=credential?createTokenCycler(credential):()=>Promise.resolve(null);return{name:bearerTokenAuthenticationPolicyName,async sendRequest(request,next){if(!request.url.toLowerCase().startsWith("https://"))throw new Error("Bearer token authentication is not permitted for non-TLS protected (non-https) URLs.");let response,error;await callbacks.authorizeRequest({scopes:Array.isArray(scopes)?scopes:[scopes],request:request,getAccessToken:getAccessToken,logger:logger$1});try{response=await next(request)}catch(err){error=err,response=err.response}if(callbacks.authorizeRequestOnChallenge&&401===(null==response?void 0:response.status)&&getChallenge(response)){if(await callbacks.authorizeRequestOnChallenge({scopes:Array.isArray(scopes)?scopes:[scopes],request:request,response:response,getAccessToken:getAccessToken,logger:logger$1}))return next(request)}if(error)throw error;return response}}}const ndJsonPolicyName="ndJsonPolicy";function ndJsonPolicy(){return{name:ndJsonPolicyName,async sendRequest(request,next){if("string"==typeof request.body&&request.body.startsWith("[")){const body=JSON.parse(request.body);Array.isArray(body)&&(request.body=body.map((item=>JSON.stringify(item)+"\n")).join(""))}return next(request)}}}const auxiliaryAuthenticationHeaderPolicyName="auxiliaryAuthenticationHeaderPolicy",AUTHORIZATION_AUXILIARY_HEADER="x-ms-authorization-auxiliary";async function sendAuthorizeRequest(options){var _a,_b;const{scopes:scopes,getAccessToken:getAccessToken,request:request}=options,getTokenOptions={abortSignal:request.abortSignal,tracingOptions:request.tracingOptions};return null!==(_b=null===(_a=await getAccessToken(scopes,getTokenOptions))||void 0===_a?void 0:_a.token)&&void 0!==_b?_b:""}function auxiliaryAuthenticationHeaderPolicy(options){const{credentials:credentials,scopes:scopes}=options,logger$1=options.logger||logger,tokenCyclerMap=new WeakMap;return{name:auxiliaryAuthenticationHeaderPolicyName,async sendRequest(request,next){if(!request.url.toLowerCase().startsWith("https://"))throw new Error("Bearer token authentication for auxiliary header is not permitted for non-TLS protected (non-https) URLs.");if(!credentials||0===credentials.length)return logger$1.info(`${auxiliaryAuthenticationHeaderPolicyName} header will not be set due to empty credentials.`),next(request);const tokenPromises=[];for(const credential of credentials){let getAccessToken=tokenCyclerMap.get(credential);getAccessToken||(getAccessToken=createTokenCycler(credential),tokenCyclerMap.set(credential,getAccessToken)),tokenPromises.push(sendAuthorizeRequest({scopes:Array.isArray(scopes)?scopes:[scopes],request:request,getAccessToken:getAccessToken,logger:logger$1}))}const auxiliaryTokens=(await Promise.all(tokenPromises)).filter((token=>Boolean(token)));return 0===auxiliaryTokens.length?(logger$1.warning(`None of the auxiliary tokens are valid. ${AUTHORIZATION_AUXILIARY_HEADER} header will not be set.`),next(request)):(request.headers.set(AUTHORIZATION_AUXILIARY_HEADER,auxiliaryTokens.map((token=>`Bearer ${token}`)).join(", ")),next(request))}}}exports.RestError=RestError,exports.auxiliaryAuthenticationHeaderPolicy=auxiliaryAuthenticationHeaderPolicy,exports.auxiliaryAuthenticationHeaderPolicyName=auxiliaryAuthenticationHeaderPolicyName,exports.bearerTokenAuthenticationPolicy=bearerTokenAuthenticationPolicy,exports.bearerTokenAuthenticationPolicyName=bearerTokenAuthenticationPolicyName,exports.createDefaultHttpClient=createDefaultHttpClient,exports.createEmptyPipeline=createEmptyPipeline,exports.createHttpHeaders=createHttpHeaders,exports.createPipelineFromOptions=createPipelineFromOptions,exports.createPipelineRequest=createPipelineRequest,exports.decompressResponsePolicy=decompressResponsePolicy,exports.decompressResponsePolicyName=decompressResponsePolicyName,exports.defaultRetryPolicy=defaultRetryPolicy,exports.exponentialRetryPolicy=exponentialRetryPolicy,exports.exponentialRetryPolicyName=exponentialRetryPolicyName,exports.formDataPolicy=formDataPolicy,exports.formDataPolicyName=formDataPolicyName,exports.getDefaultProxySettings=getDefaultProxySettings,exports.isRestError=isRestError,exports.logPolicy=logPolicy,exports.logPolicyName=logPolicyName,exports.ndJsonPolicy=ndJsonPolicy,exports.ndJsonPolicyName=ndJsonPolicyName,exports.proxyPolicy=proxyPolicy,exports.proxyPolicyName=proxyPolicyName,exports.redirectPolicy=redirectPolicy,exports.redirectPolicyName=redirectPolicyName,exports.retryPolicy=retryPolicy,exports.setClientRequestIdPolicy=setClientRequestIdPolicy,exports.setClientRequestIdPolicyName=setClientRequestIdPolicyName,exports.systemErrorRetryPolicy=systemErrorRetryPolicy,exports.systemErrorRetryPolicyName=systemErrorRetryPolicyName,exports.throttlingRetryPolicy=throttlingRetryPolicy,exports.throttlingRetryPolicyName=throttlingRetryPolicyName,exports.tlsPolicy=tlsPolicy,exports.tlsPolicyName=tlsPolicyName,exports.tracingPolicy=tracingPolicy,exports.tracingPolicyName=tracingPolicyName,exports.userAgentPolicy=userAgentPolicy,exports.userAgentPolicyName=userAgentPolicyName;