import{tracingClient}from"../util/tracing";import{CredentialUnavailableError}from"../errors";import{credentialLogger,formatError,formatSuccess}from"../util/logging";import child_process from"child_process";import{ensureValidScope,getScopeResource}from"../util/scopeUtils";import{processMultiTenantRequest}from"../util/validateMultiTenant";import{checkTenantId}from"../util/checkTenantId";export const cliCredentialInternals={getSafeWorkingDir(){if("win32"===process.platform){if(!process.env.SystemRoot)throw new Error("Azure CLI credential expects a 'SystemRoot' environment variable");return process.env.SystemRoot}return"/bin"},async getAzureCliAccessToken(resource,tenantId){let tenantSection=[];return tenantId&&(tenantSection=["--tenant",tenantId]),new Promise(((resolve,reject)=>{try{child_process.execFile("az",["account","get-access-token","--output","json","--resource",resource,...tenantSection],{cwd:cliCredentialInternals.getSafeWorkingDir(),shell:!0},((error,stdout,stderr)=>{resolve({stdout:stdout,stderr:stderr,error:error})}))}catch(err){reject(err)}}))}};const logger=credentialLogger("AzureCliCredential");export class AzureCliCredential{constructor(options){this.tenantId=null==options?void 0:options.tenantId}async getToken(scopes,options={}){const tenantId=processMultiTenantRequest(this.tenantId,options);tenantId&&checkTenantId(logger,tenantId);const scope="string"==typeof scopes?scopes:scopes[0];logger.getToken.info(`Using the scope ${scope}`),ensureValidScope(scope,logger);const resource=getScopeResource(scope);return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async()=>{var _a,_b,_c,_d;try{const obj=await cliCredentialInternals.getAzureCliAccessToken(resource,tenantId),specificScope=null===(_a=obj.stderr)||void 0===_a?void 0:_a.match("(.*)az login --scope(.*)"),isLoginError=(null===(_b=obj.stderr)||void 0===_b?void 0:_b.match("(.*)az login(.*)"))&&!specificScope;if((null===(_c=obj.stderr)||void 0===_c?void 0:_c.match("az:(.*)not found"))||(null===(_d=obj.stderr)||void 0===_d?void 0:_d.startsWith("'az' is not recognized"))){const error=new CredentialUnavailableError("Azure CLI could not be found. Please visit https://aka.ms/azure-cli for installation instructions and then, once installed, authenticate to your Azure account using 'az login'.");throw logger.getToken.info(formatError(scopes,error)),error}if(isLoginError){const error=new CredentialUnavailableError("Please run 'az login' from a command prompt to authenticate before using this credential.");throw logger.getToken.info(formatError(scopes,error)),error}try{const responseData=obj.stdout,response=JSON.parse(responseData);logger.getToken.info(formatSuccess(scopes));return{token:response.accessToken,expiresOnTimestamp:new Date(response.expiresOn).getTime()}}catch(e){if(obj.stderr)throw new CredentialUnavailableError(obj.stderr);throw e}}catch(err){const error="CredentialUnavailableError"===err.name?err:new CredentialUnavailableError(err.message||"Unknown error while trying to retrieve the access token");throw logger.getToken.info(formatError(scopes,error)),error}}))}}