import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{credentialLogger,formatError,formatSuccess}from"../util/logging";import{getIdentityTokenEndpointSuffix}from"../util/identityTokenEndpoint";import{IdentityClient}from"../client/identityClient";import{tracingClient}from"../util/tracing";const logger=credentialLogger("ClientSecretCredential");export class ClientSecretCredential{constructor(tenantId,clientId,clientSecret,options){this.identityClient=new IdentityClient(options),this.tenantId=tenantId,this.clientId=clientId,this.clientSecret=clientSecret}async getToken(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async newOptions=>{const query=new URLSearchParams({response_type:"token",grant_type:"client_credentials",client_id:this.clientId,client_secret:this.clientSecret,scope:"string"==typeof scopes?scopes:scopes.join(" ")});try{const urlSuffix=getIdentityTokenEndpointSuffix(this.tenantId),request=createPipelineRequest({url:`${this.identityClient.authorityHost}/${this.tenantId}/${urlSuffix}`,method:"POST",body:query.toString(),headers:createHttpHeaders({Accept:"application/json","Content-Type":"application/x-www-form-urlencoded"}),abortSignal:options&&options.abortSignal,tracingOptions:null==newOptions?void 0:newOptions.tracingOptions}),tokenResponse=await this.identityClient.sendTokenRequest(request);return logger.getToken.info(formatSuccess(scopes)),tokenResponse&&tokenResponse.accessToken||null}catch(err){throw logger.getToken.info(formatError(scopes,err)),err}}))}}