import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{readFile}from"fs";import{AuthenticationError}from"../../errors";import{credentialLogger}from"../../util/logging";import{mapScopesToResource}from"./utils";import{azureArcAPIVersion}from"./constants";const msiName="ManagedIdentityCredential - Azure Arc MSI",logger=credentialLogger(msiName);function prepareRequestOptions(scopes,clientId,resourceId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName}: Multiple scopes are not supported.`);const queryParameters={resource:resource,"api-version":azureArcAPIVersion};if(clientId&&(queryParameters.client_id=clientId),resourceId&&(queryParameters.msi_res_id=resourceId),!process.env.IDENTITY_ENDPOINT)throw new Error(`${msiName}: Missing environment variable: IDENTITY_ENDPOINT`);const query=new URLSearchParams(queryParameters);return createPipelineRequest({url:`${process.env.IDENTITY_ENDPOINT}?${query.toString()}`,method:"GET",headers:createHttpHeaders({Accept:"application/json",Metadata:"true"})})}function readFileAsync(path,options){return new Promise(((resolve,reject)=>readFile(path,options,((err,data)=>{err&&reject(err),resolve(data)}))))}async function filePathRequest(identityClient,requestPrepareOptions){const response=await identityClient.sendRequest(createPipelineRequest(requestPrepareOptions));if(401!==response.status){let message="";throw response.bodyAsText&&(message=` Response: ${response.bodyAsText}`),new AuthenticationError(response.status,`${msiName}: To authenticate with Azure Arc MSI, status code 401 is expected on the first request. ${message}`)}const authHeader=response.headers.get("www-authenticate")||"";try{return authHeader.split("=").slice(1)[0]}catch(e){throw Error(`Invalid www-authenticate header format: ${authHeader}`)}}export const arcMsi={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;const result=Boolean(process.env.IMDS_ENDPOINT&&process.env.IDENTITY_ENDPOINT);return result||logger.info(`${msiName}: The environment variables needed are: IMDS_ENDPOINT and IDENTITY_ENDPOINT`),result},async getToken(configuration,getTokenOptions={}){var _a;const{identityClient:identityClient,scopes:scopes,clientId:clientId,resourceId:resourceId}=configuration;clientId&&logger.warning(`${msiName}: user-assigned identities not supported. The argument clientId might be ignored by the service.`),resourceId&&logger.warning(`${msiName}: user defined managed Identity by resource Id is not supported. Argument resourceId will be ignored.`),logger.info(`${msiName}: Authenticating.`);const requestOptions=Object.assign(Object.assign({disableJsonStringifyOnBody:!0,deserializationMapper:void 0,abortSignal:getTokenOptions.abortSignal},prepareRequestOptions(scopes,clientId,resourceId)),{allowInsecureConnection:!0}),filePath=await filePathRequest(identityClient,requestOptions);if(!filePath)throw new Error(`${msiName}: Failed to find the token file.`);const key=await readFileAsync(filePath,{encoding:"utf-8"});null===(_a=requestOptions.headers)||void 0===_a||_a.set("Authorization",`Basic ${key}`);const request=createPipelineRequest(Object.assign(Object.assign({},requestOptions),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request);return tokenResponse&&tokenResponse.accessToken||null}};