import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{credentialLogger}from"../../util/logging";import{mapScopesToResource}from"./utils";const msiName="ManagedIdentityCredential - CloudShellMSI";export const logger=credentialLogger(msiName);function prepareRequestOptions(scopes,clientId,resourceId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName}: Multiple scopes are not supported.`);const body={resource:resource};if(clientId&&(body.client_id=clientId),resourceId&&(body.msi_res_id=resourceId),!process.env.MSI_ENDPOINT)throw new Error(`${msiName}: Missing environment variable: MSI_ENDPOINT`);const params=new URLSearchParams(body);return{url:process.env.MSI_ENDPOINT,method:"POST",body:params.toString(),headers:createHttpHeaders({Accept:"application/json",Metadata:"true","Content-Type":"application/x-www-form-urlencoded"})}}export const cloudShellMsi={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;const result=Boolean(process.env.MSI_ENDPOINT);return result||logger.info(`${msiName}: Unavailable. The environment variable MSI_ENDPOINT is needed.`),result},async getToken(configuration,getTokenOptions={}){const{identityClient:identityClient,scopes:scopes,clientId:clientId,resourceId:resourceId}=configuration;clientId&&logger.warning(`${msiName}: user-assigned identities not supported. The argument clientId might be ignored by the service.`),resourceId&&logger.warning(`${msiName}: user defined managed Identity by resource Id not supported. The argument resourceId might be ignored by the service.`),logger.info(`${msiName}: Using the endpoint coming form the environment variable MSI_ENDPOINT = ${process.env.MSI_ENDPOINT}.`);const request=createPipelineRequest(Object.assign(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions(scopes,clientId,resourceId)),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request);return tokenResponse&&tokenResponse.accessToken||null}};