import fs from"fs";import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{promisify}from"util";import{DefaultAuthorityHost}from"../../constants";import{credentialLogger}from"../../util/logging";const msiName="ManagedIdentityCredential - Token Exchange",logger=credentialLogger(msiName),readFileAsync=promisify(fs.readFile);function prepareRequestOptions(scopes,clientAssertion,clientId){var _a;const bodyParams={scope:Array.isArray(scopes)?scopes.join(" "):scopes,client_assertion:clientAssertion,client_assertion_type:"urn:ietf:params:oauth:client-assertion-type:jwt-bearer",client_id:clientId,grant_type:"client_credentials"},urlParams=new URLSearchParams(bodyParams);return{url:new URL(`${process.env.AZURE_TENANT_ID}/oauth2/v2.0/token`,null!==(_a=process.env.AZURE_AUTHORITY_HOST)&&void 0!==_a?_a:DefaultAuthorityHost).toString(),method:"POST",body:urlParams.toString(),headers:createHttpHeaders({Accept:"application/json"})}}export function tokenExchangeMsi(){const azureFederatedTokenFilePath=process.env.AZURE_FEDERATED_TOKEN_FILE;let azureFederatedTokenFileContent,cacheDate;async function readAssertion(){if(void 0!==cacheDate&&Date.now()-cacheDate>=3e5&&(azureFederatedTokenFileContent=void 0),!azureFederatedTokenFileContent){const value=(await readFileAsync(azureFederatedTokenFilePath,"utf8")).trim();if(!value)throw new Error(`No content on the file ${azureFederatedTokenFilePath}, indicated by the environment variable AZURE_FEDERATED_TOKEN_FILE`);azureFederatedTokenFileContent=value,cacheDate=Date.now()}return azureFederatedTokenFileContent}return{async isAvailable({clientId:clientId}){const env=process.env,result=Boolean((clientId||env.AZURE_CLIENT_ID)&&env.AZURE_TENANT_ID&&azureFederatedTokenFilePath);return result||logger.info(`${msiName}: Unavailable. The environment variables needed are: AZURE_CLIENT_ID (or the client ID sent through the parameters), AZURE_TENANT_ID and AZURE_FEDERATED_TOKEN_FILE`),result},async getToken(configuration,getTokenOptions={}){const{identityClient:identityClient,scopes:scopes,clientId:clientId}=configuration;let assertion;logger.info(`${msiName}: Using the client assertion coming from environment variables.`);try{assertion=await readAssertion()}catch(err){throw new Error(`${msiName}: Failed to read ${azureFederatedTokenFilePath}, indicated by the environment variable AZURE_FEDERATED_TOKEN_FILE`)}const request=createPipelineRequest(Object.assign(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions(scopes,assertion,clientId||process.env.AZURE_CLIENT_ID)),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request);return tokenResponse&&tokenResponse.accessToken||null}}}