import{readFile}from"fs";import{createHash}from"crypto";import{promisify}from"util";import{MsalNode}from"./msalNodeCommon";import{formatError}from"../../util/logging";const readFileAsync=promisify(readFile);export async function parseCertificate(configuration,sendCertificateChain){const certificateParts={},certificate=configuration.certificate,certificatePath=configuration.certificatePath;certificateParts.certificateContents=certificate||await readFileAsync(certificatePath,"utf8"),sendCertificateChain&&(certificateParts.x5c=certificateParts.certificateContents);const certificatePattern=/(-+BEGIN CERTIFICATE-+)(\n\r?|\r\n?)([A-Za-z0-9+/\n\r]+=*)(\n\r?|\r\n?)(-+END CERTIFICATE-+)/g,publicKeys=[];let match;do{match=certificatePattern.exec(certificateParts.certificateContents),match&&publicKeys.push(match[3])}while(match);if(0===publicKeys.length)throw new Error("The file at the specified path does not contain a PEM-encoded certificate.");return certificateParts.thumbprint=createHash("sha1").update(Buffer.from(publicKeys[0],"base64")).digest("hex").toUpperCase(),certificateParts}export class MsalClientCertificate extends MsalNode{constructor(options){super(options),this.requiresConfidential=!0,this.configuration=options.configuration,this.sendCertificateChain=options.sendCertificateChain}async init(options){try{const parts=await parseCertificate(this.configuration,this.sendCertificateChain);this.msalConfig.auth.clientCertificate={thumbprint:parts.thumbprint,privateKey:parts.certificateContents,x5c:parts.x5c}}catch(error){throw this.logger.info(formatError("",error)),error}return super.init(options)}async doGetToken(scopes,options={}){try{const clientCredReq={scopes:scopes,correlationId:options.correlationId,azureRegion:this.azureRegion,authority:options.authority,claims:options.claims},result=await this.confidentialApp.acquireTokenByClientCredential(clientCredReq);return this.handleResult(scopes,this.clientId,result||void 0)}catch(err){throw this.handleError(scopes,err,options)}}}