"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var msalNode=require("@azure/msal-node"),coreClient=require("@azure/core-client"),coreUtil=require("@azure/core-util"),coreRestPipeline=require("@azure/core-rest-pipeline"),abortController=require("@azure/abort-controller"),coreTracing=require("@azure/core-tracing"),logger$m=require("@azure/logger"),msalCommon=require("@azure/msal-common"),uuid=require("uuid"),fs=require("fs"),os=require("os"),path=require("path"),child_process=require("child_process"),crypto=require("crypto"),util=require("util"),https=require("https"),http=require("http"),open=require("open"),stoppable=require("stoppable");function _interopDefaultLegacy(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function _interopNamespace(e){if(e&&e.__esModule)return e;var n=Object.create(null);return e&&Object.keys(e).forEach((function(k){if("default"!==k){var d=Object.getOwnPropertyDescriptor(e,k);Object.defineProperty(n,k,d.get?d:{enumerable:!0,get:function(){return e[k]}})}})),n.default=e,Object.freeze(n)}var msalNode__namespace=_interopNamespace(msalNode),msalCommon__namespace=_interopNamespace(msalCommon),fs__default=_interopDefaultLegacy(fs),os__default=_interopDefaultLegacy(os),path__default=_interopDefaultLegacy(path),child_process__default=_interopDefaultLegacy(child_process),child_process__namespace=_interopNamespace(child_process),https__default=_interopDefaultLegacy(https),http__default=_interopDefaultLegacy(http),open__default=_interopDefaultLegacy(open),stoppable__default=_interopDefaultLegacy(stoppable);function isErrorResponse(errorResponse){return errorResponse&&"string"==typeof errorResponse.error&&"string"==typeof errorResponse.error_description}const CredentialUnavailableErrorName="CredentialUnavailableError";class CredentialUnavailableError extends Error{constructor(message){super(message),this.name=CredentialUnavailableErrorName}}const AuthenticationErrorName="AuthenticationError";class AuthenticationError extends Error{constructor(statusCode,errorBody){let errorResponse={error:"unknown",errorDescription:"An unknown error occurred and no additional details are available."};if(isErrorResponse(errorBody))errorResponse=convertOAuthErrorResponseToErrorResponse(errorBody);else if("string"==typeof errorBody)try{errorResponse=convertOAuthErrorResponseToErrorResponse(JSON.parse(errorBody))}catch(e){errorResponse=400===statusCode?{error:"authority_not_found",errorDescription:"The specified authority URL was not found."}:{error:"unknown_error",errorDescription:`An unknown error has occurred. Response body:\n\n${errorBody}`}}else errorResponse={error:"unknown_error",errorDescription:"An unknown error occurred and no additional details are available."};super(`${errorResponse.error} Status code: ${statusCode}\nMore details:\n${errorResponse.errorDescription}`),this.statusCode=statusCode,this.errorResponse=errorResponse,this.name=AuthenticationErrorName}}const AggregateAuthenticationErrorName="AggregateAuthenticationError";class AggregateAuthenticationError extends Error{constructor(errors,errorMessage){super(`${errorMessage}\n${errors.join("\n")}`),this.errors=errors,this.name=AggregateAuthenticationErrorName}}function convertOAuthErrorResponseToErrorResponse(errorBody){return{error:errorBody.error,errorDescription:errorBody.error_description,correlationId:errorBody.correlation_id,errorCodes:errorBody.error_codes,timestamp:errorBody.timestamp,traceId:errorBody.trace_id}}class AuthenticationRequiredError extends Error{constructor(options){super(options.message),this.scopes=options.scopes,this.getTokenOptions=options.getTokenOptions,this.name="AuthenticationRequiredError"}}function getIdentityTokenEndpointSuffix(tenantId){return"adfs"===tenantId?"oauth2/token":"oauth2/v2.0/token"}const SDK_VERSION="2.1.0",DeveloperSignOnClientId="04b07795-8ddb-461a-bbee-02f9e1bf7b46",DefaultTenantId="common";exports.AzureAuthorityHosts=void 0,function(AzureAuthorityHosts){AzureAuthorityHosts.AzureChina="https://login.chinacloudapi.cn",AzureAuthorityHosts.AzureGermany="https://login.microsoftonline.de",AzureAuthorityHosts.AzureGovernment="https://login.microsoftonline.us",AzureAuthorityHosts.AzurePublicCloud="https://login.microsoftonline.com"}(exports.AzureAuthorityHosts||(exports.AzureAuthorityHosts={}));const DefaultAuthorityHost=exports.AzureAuthorityHosts.AzurePublicCloud,tracingClient=coreTracing.createTracingClient({namespace:"Microsoft.AAD",packageName:"@azure/identity",packageVersion:SDK_VERSION}),logger$l=logger$m.createClientLogger("identity");function processEnvVars(supportedEnvVars){return supportedEnvVars.reduce(((acc,envVariable)=>(process.env[envVariable]?acc.assigned.push(envVariable):acc.missing.push(envVariable),acc)),{missing:[],assigned:[]})}function formatSuccess(scope){return`SUCCESS. Scopes: ${Array.isArray(scope)?scope.join(", "):scope}.`}function formatError(scope,error){let message="ERROR.";return(null==scope?void 0:scope.length)&&(message+=` Scopes: ${Array.isArray(scope)?scope.join(", "):scope}.`),`${message} Error message: ${"string"==typeof error?error:error.message}.`}function credentialLoggerInstance(title,parent,log=logger$l){const fullTitle=parent?`${parent.fullTitle} ${title}`:title;function info(message){log.info(`${fullTitle} =>`,message)}function warning(message){log.warning(`${fullTitle} =>`,message)}return{title:title,fullTitle:fullTitle,info:info,warning:warning}}function credentialLogger(title,log=logger$l){const credLogger=credentialLoggerInstance(title,void 0,log);return Object.assign(Object.assign({},credLogger),{parent:log,getToken:credentialLoggerInstance("=> getToken()",credLogger,log)})}const noCorrelationId="noCorrelationId";function getIdentityClientAuthorityHost(options){let authorityHost=null==options?void 0:options.authorityHost;return coreUtil.isNode&&(authorityHost=null!=authorityHost?authorityHost:process.env.AZURE_AUTHORITY_HOST),null!=authorityHost?authorityHost:DefaultAuthorityHost}class IdentityClient extends coreClient.ServiceClient{constructor(options){var _a,_b;const packageDetails=`azsdk-js-identity/${SDK_VERSION}`,userAgentPrefix=(null===(_a=null==options?void 0:options.userAgentOptions)||void 0===_a?void 0:_a.userAgentPrefix)?`${options.userAgentOptions.userAgentPrefix} ${packageDetails}`:`${packageDetails}`,baseUri=getIdentityClientAuthorityHost(options);if(!baseUri.startsWith("https:"))throw new Error("The authorityHost address must use the 'https' protocol.");super(Object.assign(Object.assign({requestContentType:"application/json; charset=utf-8",retryOptions:{maxRetries:3}},options),{userAgentOptions:{userAgentPrefix:userAgentPrefix},baseUri:baseUri})),this.authorityHost=baseUri,this.abortControllers=new Map,this.allowLoggingAccountIdentifiers=null===(_b=null==options?void 0:options.loggingOptions)||void 0===_b?void 0:_b.allowLoggingAccountIdentifiers}async sendTokenRequest(request,expiresOnParser){logger$l.info(`IdentityClient: sending token request to [${request.url}]`);const response=await this.sendRequest(request);if(expiresOnParser=expiresOnParser||(responseBody=>Date.now()+1e3*responseBody.expires_in),!response.bodyAsText||200!==response.status&&201!==response.status){const error=new AuthenticationError(response.status,response.bodyAsText);throw logger$l.warning(`IdentityClient: authentication error. HTTP status: ${response.status}, ${error.errorResponse.errorDescription}`),error}{const parsedBody=JSON.parse(response.bodyAsText);if(!parsedBody.access_token)return null;this.logIdentifiers(response);const token={accessToken:{token:parsedBody.access_token,expiresOnTimestamp:expiresOnParser(parsedBody)},refreshToken:parsedBody.refresh_token};return logger$l.info(`IdentityClient: [${request.url}] token acquired, expires on ${token.accessToken.expiresOnTimestamp}`),token}}async refreshAccessToken(tenantId,clientId,scopes,refreshToken,clientSecret,expiresOnParser,options={}){if(void 0===refreshToken)return null;logger$l.info(`IdentityClient: refreshing access token with client ID: ${clientId}, scopes: ${scopes} started`);const refreshParams={grant_type:"refresh_token",client_id:clientId,refresh_token:refreshToken,scope:scopes};void 0!==clientSecret&&(refreshParams.client_secret=clientSecret);const query=new URLSearchParams(refreshParams);return tracingClient.withSpan("IdentityClient.refreshAccessToken",options,(async updatedOptions=>{try{const urlSuffix=getIdentityTokenEndpointSuffix(tenantId),request=coreRestPipeline.createPipelineRequest({url:`${this.authorityHost}/${tenantId}/${urlSuffix}`,method:"POST",body:query.toString(),abortSignal:options.abortSignal,headers:coreRestPipeline.createHttpHeaders({Accept:"application/json","Content-Type":"application/x-www-form-urlencoded"}),tracingOptions:updatedOptions.tracingOptions}),response=await this.sendTokenRequest(request,expiresOnParser);return logger$l.info(`IdentityClient: refreshed token for client ID: ${clientId}`),response}catch(err){if(err.name===AuthenticationErrorName&&"interaction_required"===err.errorResponse.error)return logger$l.info(`IdentityClient: interaction required for client ID: ${clientId}`),null;throw logger$l.warning(`IdentityClient: failed refreshing token for client ID: ${clientId}: ${err}`),err}}))}generateAbortSignal(correlationId){const controller=new abortController.AbortController,controllers=this.abortControllers.get(correlationId)||[];controllers.push(controller),this.abortControllers.set(correlationId,controllers);const existingOnAbort=controller.signal.onabort;return controller.signal.onabort=(...params)=>{this.abortControllers.set(correlationId,void 0),existingOnAbort&&existingOnAbort(...params)},controller.signal}abortRequests(correlationId){const key=correlationId||noCorrelationId,controllers=[...this.abortControllers.get(key)||[],...this.abortControllers.get(noCorrelationId)||[]];if(controllers.length){for(const controller of controllers)controller.abort();this.abortControllers.set(key,void 0)}}getCorrelationId(options){var _a;const parameter=null===(_a=null==options?void 0:options.body)||void 0===_a?void 0:_a.split("&").map((part=>part.split("="))).find((([key])=>"client-request-id"===key));return parameter&&parameter.length&&parameter[1]||noCorrelationId}async sendGetRequestAsync(url,options){const request=coreRestPipeline.createPipelineRequest({url:url,method:"GET",body:null==options?void 0:options.body,headers:coreRestPipeline.createHttpHeaders(null==options?void 0:options.headers),abortSignal:this.generateAbortSignal(noCorrelationId)}),response=await this.sendRequest(request);return this.logIdentifiers(response),{body:response.bodyAsText?JSON.parse(response.bodyAsText):void 0,headers:response.headers.toJSON(),status:response.status}}async sendPostRequestAsync(url,options){const request=coreRestPipeline.createPipelineRequest({url:url,method:"POST",body:null==options?void 0:options.body,headers:coreRestPipeline.createHttpHeaders(null==options?void 0:options.headers),abortSignal:this.generateAbortSignal(this.getCorrelationId(options))}),response=await this.sendRequest(request);return this.logIdentifiers(response),{body:response.bodyAsText?JSON.parse(response.bodyAsText):void 0,headers:response.headers.toJSON(),status:response.status}}logIdentifiers(response){if(!this.allowLoggingAccountIdentifiers||!response.bodyAsText)return;const unavailableUpn="No User Principal Name available";try{const accessToken=(response.parsedBody||JSON.parse(response.bodyAsText)).access_token;if(!accessToken)return;const base64Metadata=accessToken.split(".")[1],{appid:appid,upn:upn,tid:tid,oid:oid}=JSON.parse(Buffer.from(base64Metadata,"base64").toString("utf8"));logger$l.info(`[Authenticated account] Client ID: ${appid}. Tenant ID: ${tid}. User Principal Name: ${upn||unavailableUpn}. Object ID (user): ${oid}`)}catch(e){logger$l.warning("allowLoggingAccountIdentifiers was set, but we couldn't log the account information. Error:",e.message)}}}function checkTenantId(logger,tenantId){if(!tenantId.match(/^[0-9a-zA-Z-.:/]+$/)){const error=new Error("Invalid tenant id provided. You can locate your tenant id by following the instructions listed here: https://docs.microsoft.com/partner-center/find-ids-and-domain-names.");throw logger.info(formatError("",error)),error}}function resolveTenantId(logger,tenantId,clientId){return tenantId?(checkTenantId(logger,tenantId),tenantId):(clientId||(clientId=DeveloperSignOnClientId),clientId!==DeveloperSignOnClientId?"common":"organizations")}const LatestAuthenticationRecordVersion="1.0";function ensureValidMsalToken(scopes,logger,msalToken,getTokenOptions){const error=message=>(logger.getToken.info(message),new AuthenticationRequiredError({scopes:Array.isArray(scopes)?scopes:[scopes],getTokenOptions:getTokenOptions,message:message}));if(!msalToken)throw error("No response");if(!msalToken.expiresOn)throw error('Response had no "expiresOn" property.');if(!msalToken.accessToken)throw error('Response had no "accessToken" property.')}function getAuthority(tenantId,host){return host||(host=DefaultAuthorityHost),new RegExp(`${tenantId}/?$`).test(host)?host:host.endsWith("/")?host+tenantId:`${host}/${tenantId}`}function getKnownAuthorities(tenantId,authorityHost){return"adfs"===tenantId&&authorityHost?[authorityHost]:[]}const defaultLoggerCallback=(logger,platform=(coreUtil.isNode?"Node":"Browser"))=>(level,message,containsPii)=>{if(!containsPii)switch(level){case msalCommon__namespace.LogLevel.Error:return void logger.info(`MSAL ${platform} V2 error: ${message}`);case msalCommon__namespace.LogLevel.Info:return void logger.info(`MSAL ${platform} V2 info message: ${message}`);case msalCommon__namespace.LogLevel.Verbose:return void logger.info(`MSAL ${platform} V2 verbose message: ${message}`);case msalCommon__namespace.LogLevel.Warning:return void logger.info(`MSAL ${platform} V2 warning: ${message}`)}};class MsalBaseUtilities{constructor(options){this.logger=options.logger,this.account=options.authenticationRecord}generateUuid(){return uuid.v4()}handleResult(scopes,clientId,result,getTokenOptions){return(null==result?void 0:result.account)&&(this.account=msalToPublic(clientId,result.account)),ensureValidMsalToken(scopes,this.logger,result,getTokenOptions),this.logger.getToken.info(formatSuccess(scopes)),{token:result.accessToken,expiresOnTimestamp:result.expiresOn.getTime()}}handleError(scopes,error,getTokenOptions){if("AuthError"===error.name||"ClientAuthError"===error.name||"BrowserAuthError"===error.name){const msalError=error;switch(msalError.errorCode){case"endpoints_resolution_error":return this.logger.info(formatError(scopes,error.message)),new CredentialUnavailableError(error.message);case"device_code_polling_cancelled":return new abortController.AbortError("The authentication has been aborted by the caller.");case"consent_required":case"interaction_required":case"login_required":this.logger.info(formatError(scopes,`Authentication returned errorCode ${msalError.errorCode}`));break;default:this.logger.info(formatError(scopes,`Failed to acquire token: ${error.message}`))}}return"ClientConfigurationError"===error.name||"BrowserConfigurationAuthError"===error.name||"AbortError"===error.name?error:new AuthenticationRequiredError({scopes:scopes,getTokenOptions:getTokenOptions,message:error.message})}}function publicToMsal(account){const[environment]=account.authority.match(/([a-z]*\.[a-z]*\.[a-z]*)/)||[];return Object.assign(Object.assign({},account),{localAccountId:account.homeAccountId,environment:environment})}function msalToPublic(clientId,account){return{authority:getAuthority(account.tenantId,account.environment),homeAccountId:account.homeAccountId,tenantId:account.tenantId||DefaultTenantId,username:account.username,clientId:clientId,version:LatestAuthenticationRecordVersion}}function serializeAuthenticationRecord(record){return JSON.stringify(record)}function deserializeAuthenticationRecord(serializedRecord){const parsed=JSON.parse(serializedRecord);if(parsed.version&&parsed.version!==LatestAuthenticationRecordVersion)throw Error("Unsupported AuthenticationRecord version");return parsed}const multiTenantDisabledErrorMessage="A getToken request was attempted with a tenant different than the tenant configured at the initialization of the credential, but multi-tenant authentication has been disabled by the environment variable AZURE_IDENTITY_DISABLE_MULTITENANTAUTH.",multiTenantADFSErrorMessage="A new tenant Id can't be assigned through the GetTokenOptions when a credential has been originally configured to use the tenant `adfs`.";function processMultiTenantRequest(tenantId,getTokenOptions){if(!(null==getTokenOptions?void 0:getTokenOptions.tenantId))return tenantId;if(process.env.AZURE_IDENTITY_DISABLE_MULTITENANTAUTH)throw new Error(multiTenantDisabledErrorMessage);if("adfs"===tenantId)throw new Error(multiTenantADFSErrorMessage);return null==getTokenOptions?void 0:getTokenOptions.tenantId}var RegionalAuthority;let persistenceProvider;!function(RegionalAuthority){RegionalAuthority.AutoDiscoverRegion="AutoDiscoverRegion",RegionalAuthority.USWest="westus",RegionalAuthority.USWest2="westus2",RegionalAuthority.USCentral="centralus",RegionalAuthority.USEast="eastus",RegionalAuthority.USEast2="eastus2",RegionalAuthority.USNorthCentral="northcentralus",RegionalAuthority.USSouthCentral="southcentralus",RegionalAuthority.USWestCentral="westcentralus",RegionalAuthority.CanadaCentral="canadacentral",RegionalAuthority.CanadaEast="canadaeast",RegionalAuthority.BrazilSouth="brazilsouth",RegionalAuthority.EuropeNorth="northeurope",RegionalAuthority.EuropeWest="westeurope",RegionalAuthority.UKSouth="uksouth",RegionalAuthority.UKWest="ukwest",RegionalAuthority.FranceCentral="francecentral",RegionalAuthority.FranceSouth="francesouth",RegionalAuthority.SwitzerlandNorth="switzerlandnorth",RegionalAuthority.SwitzerlandWest="switzerlandwest",RegionalAuthority.GermanyNorth="germanynorth",RegionalAuthority.GermanyWestCentral="germanywestcentral",RegionalAuthority.NorwayWest="norwaywest",RegionalAuthority.NorwayEast="norwayeast",RegionalAuthority.AsiaEast="eastasia",RegionalAuthority.AsiaSouthEast="southeastasia",RegionalAuthority.JapanEast="japaneast",RegionalAuthority.JapanWest="japanwest",RegionalAuthority.AustraliaEast="australiaeast",RegionalAuthority.AustraliaSouthEast="australiasoutheast",RegionalAuthority.AustraliaCentral="australiacentral",RegionalAuthority.AustraliaCentral2="australiacentral2",RegionalAuthority.IndiaCentral="centralindia",RegionalAuthority.IndiaSouth="southindia",RegionalAuthority.IndiaWest="westindia",RegionalAuthority.KoreaSouth="koreasouth",RegionalAuthority.KoreaCentral="koreacentral",RegionalAuthority.UAECentral="uaecentral",RegionalAuthority.UAENorth="uaenorth",RegionalAuthority.SouthAfricaNorth="southafricanorth",RegionalAuthority.SouthAfricaWest="southafricawest",RegionalAuthority.ChinaNorth="chinanorth",RegionalAuthority.ChinaEast="chinaeast",RegionalAuthority.ChinaNorth2="chinanorth2",RegionalAuthority.ChinaEast2="chinaeast2",RegionalAuthority.GermanyCentral="germanycentral",RegionalAuthority.GermanyNorthEast="germanynortheast",RegionalAuthority.GovernmentUSVirginia="usgovvirginia",RegionalAuthority.GovernmentUSIowa="usgoviowa",RegionalAuthority.GovernmentUSArizona="usgovarizona",RegionalAuthority.GovernmentUSTexas="usgovtexas",RegionalAuthority.GovernmentUSDodEast="usdodeast",RegionalAuthority.GovernmentUSDodCentral="usdodcentral"}(RegionalAuthority||(RegionalAuthority={}));const msalNodeFlowCacheControl={setPersistence(pluginProvider){persistenceProvider=pluginProvider}};class MsalNode extends MsalBaseUtilities{constructor(options){var _a,_b,_c;if(super(options),this.requiresConfidential=!1,this.msalConfig=this.defaultNodeMsalConfig(options),this.tenantId=resolveTenantId(options.logger,options.tenantId,options.clientId),this.clientId=this.msalConfig.auth.clientId,(null==options?void 0:options.getAssertion)&&(this.getAssertion=options.getAssertion),void 0!==persistenceProvider&&(null===(_a=options.tokenCachePersistenceOptions)||void 0===_a?void 0:_a.enabled))this.createCachePlugin=()=>persistenceProvider(options.tokenCachePersistenceOptions);else if(null===(_b=options.tokenCachePersistenceOptions)||void 0===_b?void 0:_b.enabled)throw new Error(["Persistent token caching was requested, but no persistence provider was configured.","You must install the identity-cache-persistence plugin package (`npm install --save @azure/identity-cache-persistence`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(cachePersistencePlugin)` before using `tokenCachePersistenceOptions`."].join(" "));this.azureRegion=null!==(_c=options.regionalAuthority)&&void 0!==_c?_c:process.env.AZURE_REGIONAL_AUTHORITY_NAME,this.azureRegion===RegionalAuthority.AutoDiscoverRegion&&(this.azureRegion="AUTO_DISCOVER")}defaultNodeMsalConfig(options){const clientId=options.clientId||DeveloperSignOnClientId,tenantId=resolveTenantId(options.logger,options.tenantId,options.clientId);this.authorityHost=options.authorityHost||process.env.AZURE_AUTHORITY_HOST;const authority=getAuthority(tenantId,this.authorityHost);this.identityClient=new IdentityClient(Object.assign(Object.assign({},options.tokenCredentialOptions),{authorityHost:authority,loggingOptions:options.loggingOptions}));let clientCapabilities=["cp1"];return process.env.AZURE_IDENTITY_DISABLE_CP1&&(clientCapabilities=[]),{auth:{clientId:clientId,authority:authority,knownAuthorities:getKnownAuthorities(tenantId,authority),clientCapabilities:clientCapabilities},system:{networkClient:this.identityClient,loggerOptions:{loggerCallback:defaultLoggerCallback(options.logger)}}}}async init(options){if((null==options?void 0:options.abortSignal)&&options.abortSignal.addEventListener("abort",(()=>{this.identityClient.abortRequests(options.correlationId)})),!this.publicApp&&!this.confidentialApp)if(void 0!==this.createCachePlugin&&(this.msalConfig.cache={cachePlugin:await this.createCachePlugin()}),this.publicApp=new msalNode__namespace.PublicClientApplication(this.msalConfig),this.getAssertion&&(this.msalConfig.auth.clientAssertion=await this.getAssertion()),this.msalConfig.auth.clientSecret||this.msalConfig.auth.clientAssertion||this.msalConfig.auth.clientCertificate)this.confidentialApp=new msalNode__namespace.ConfidentialClientApplication(this.msalConfig);else if(this.requiresConfidential)throw new Error("Unable to generate the MSAL confidential client. Missing either the client's secret, certificate or assertion.")}withCancellation(promise,abortSignal,onCancel){return new Promise(((resolve,reject)=>{promise.then((msalToken=>resolve(msalToken))).catch(reject),abortSignal&&abortSignal.addEventListener("abort",(()=>{null==onCancel||onCancel()}))}))}async getActiveAccount(){var _a,_b,_c;if(this.account)return this.account;const cache=null!==(_b=null===(_a=this.confidentialApp)||void 0===_a?void 0:_a.getTokenCache())&&void 0!==_b?_b:null===(_c=this.publicApp)||void 0===_c?void 0:_c.getTokenCache(),accountsByTenant=await(null==cache?void 0:cache.getAllAccounts());if(accountsByTenant){if(1===accountsByTenant.length)return this.account=msalToPublic(this.clientId,accountsByTenant[0]),this.account;this.logger.info('More than one account was found authenticated for this Client ID and Tenant ID.\nHowever, no "authenticationRecord" has been provided for this credential,\ntherefore we\'re unable to pick between these accounts.\nA new login attempt will be requested, to ensure the correct account is picked.\nTo work with multiple accounts for the same Client ID and Tenant ID, please provide an "authenticationRecord" when initializing a credential to prevent this from happening.')}}async getTokenSilent(scopes,options){var _a,_b;if(await this.getActiveAccount(),!this.account)throw new AuthenticationRequiredError({scopes:scopes,getTokenOptions:options,message:"Silent authentication failed. We couldn't retrieve an active account from the cache."});const silentRequest={account:publicToMsal(this.account),correlationId:null==options?void 0:options.correlationId,scopes:scopes,authority:null==options?void 0:options.authority,claims:null==options?void 0:options.claims};try{this.logger.info("Attempting to acquire token silently");const response=null!==(_b=await(null===(_a=this.confidentialApp)||void 0===_a?void 0:_a.acquireTokenSilent(silentRequest)))&&void 0!==_b?_b:await this.publicApp.acquireTokenSilent(silentRequest);return this.handleResult(scopes,this.clientId,response||void 0)}catch(err){throw this.handleError(scopes,err,options)}}async getToken(scopes,options={}){const tenantId=processMultiTenantRequest(this.tenantId,options)||this.tenantId;options.authority=getAuthority(tenantId,this.authorityHost),options.correlationId=(null==options?void 0:options.correlationId)||this.generateUuid(),await this.init(options);try{const optionsClaims=options.claims;return optionsClaims&&(this.cachedClaims=optionsClaims),this.cachedClaims&&!optionsClaims&&(options.claims=this.cachedClaims),await this.getTokenSilent(scopes,options)}catch(err){if("AuthenticationRequiredError"!==err.name)throw err;if(null==options?void 0:options.disableAutomaticAuthentication)throw new AuthenticationRequiredError({scopes:scopes,getTokenOptions:options,message:"Automatic authentication has been disabled. You may call the authentication() method."});return this.logger.info("Silent authentication failed, falling back to interactive method."),this.doGetToken(scopes,options)}}}const CommonTenantId="common",AzureAccountClientId="aebc6443-996d-45c2-90f0-388ff96faa56",logger$k=credentialLogger("VisualStudioCodeCredential");let findCredentials;const vsCodeCredentialControl={setVsCodeCredentialFinder(finder){findCredentials=finder}},unsupportedTenantIds={adfs:"The VisualStudioCodeCredential does not support authentication with ADFS tenants."};function checkUnsupportedTenant(tenantId){const unsupportedTenantError=unsupportedTenantIds[tenantId];if(unsupportedTenantError)throw new CredentialUnavailableError(unsupportedTenantError)}const mapVSCodeAuthorityHosts={AzureCloud:exports.AzureAuthorityHosts.AzurePublicCloud,AzureChina:exports.AzureAuthorityHosts.AzureChina,AzureGermanCloud:exports.AzureAuthorityHosts.AzureGermany,AzureUSGovernment:exports.AzureAuthorityHosts.AzureGovernment};function getPropertyFromVSCode(property){const settingsPath=["User","settings.json"],vsCodeFolder="Code",homedir=os__default.default.homedir();function loadProperty(...pathSegments){const fullPath=path__default.default.join(...pathSegments,vsCodeFolder,...settingsPath);return JSON.parse(fs__default.default.readFileSync(fullPath,{encoding:"utf8"}))[property]}try{let appData;switch(process.platform){case"win32":return appData=process.env.APPDATA,appData?loadProperty(appData):void 0;case"darwin":return loadProperty(homedir,"Library","Application Support");case"linux":return loadProperty(homedir,".config");default:return}}catch(e){return void logger$k.info(`Failed to load the Visual Studio Code configuration file. Error: ${e.message}`)}}class VisualStudioCodeCredential{constructor(options){this.cloudName=getPropertyFromVSCode("azure.cloud")||"AzureCloud";const authorityHost=mapVSCodeAuthorityHosts[this.cloudName];this.identityClient=new IdentityClient(Object.assign({authorityHost:authorityHost},options)),options&&options.tenantId?(checkTenantId(logger$k,options.tenantId),this.tenantId=options.tenantId):this.tenantId=CommonTenantId,checkUnsupportedTenant(this.tenantId)}async prepare(){const settingsTenant=getPropertyFromVSCode("azure.tenant");settingsTenant&&(this.tenantId=settingsTenant),checkUnsupportedTenant(this.tenantId)}prepareOnce(){return this.preparePromise||(this.preparePromise=this.prepare()),this.preparePromise}async getToken(scopes,options){var _a,_b;await this.prepareOnce();const tenantId=processMultiTenantRequest(this.tenantId,options)||this.tenantId;if(void 0===findCredentials)throw new CredentialUnavailableError(["No implementation of `VisualStudioCodeCredential` is available.","You must install the identity-vscode plugin package (`npm install --save-dev @azure/identity-vscode`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(vsCodePlugin)` before creating a `VisualStudioCodeCredential`."].join(" "));let scopeString="string"==typeof scopes?scopes:scopes.join(" ");if(!scopeString.match(/^[0-9a-zA-Z-.:/]+$/)){const error=new Error("Invalid scope was specified by the user or calling client");throw logger$k.getToken.info(formatError(scopes,error)),error}scopeString.indexOf("offline_access")<0&&(scopeString+=" offline_access");const credentials=await findCredentials(),{password:refreshToken}=null!==(_b=null!==(_a=credentials.find((({account:account})=>account===this.cloudName)))&&void 0!==_a?_a:credentials[0])&&void 0!==_b?_b:{};if(refreshToken){const tokenResponse=await this.identityClient.refreshAccessToken(tenantId,AzureAccountClientId,scopeString,refreshToken,void 0);if(tokenResponse)return logger$k.getToken.info(formatSuccess(scopes)),tokenResponse.accessToken;{const error=new CredentialUnavailableError("Could not retrieve the token associated with Visual Studio Code. Have you connected using the 'Azure Account' extension recently? To troubleshoot, visit https://aka.ms/azsdk/js/identity/vscodecredential/troubleshoot.");throw logger$k.getToken.info(formatError(scopes,error)),error}}{const error=new CredentialUnavailableError("Could not retrieve the token associated with Visual Studio Code. Did you connect using the 'Azure Account' extension? To troubleshoot, visit https://aka.ms/azsdk/js/identity/vscodecredential/troubleshoot.");throw logger$k.getToken.info(formatError(scopes,error)),error}}}const pluginContext={cachePluginControl:msalNodeFlowCacheControl,vsCodeCredentialControl:vsCodeCredentialControl};function useIdentityPlugin(plugin){plugin(pluginContext)}const logger$j=credentialLogger("ChainedTokenCredential");class ChainedTokenCredential{constructor(...sources){this.UnavailableMessage="ChainedTokenCredential => failed to retrieve a token from the included credentials",this._sources=[],this._sources=sources}async getToken(scopes,options={}){let token=null,successfulCredentialName="";const errors=[];return tracingClient.withSpan("ChainedTokenCredential.getToken",options,(async updatedOptions=>{for(let i=0;i<this._sources.length&&null===token;i++)try{token=await this._sources[i].getToken(scopes,updatedOptions),successfulCredentialName=this._sources[i].constructor.name}catch(err){if("CredentialUnavailableError"!==err.name&&"AuthenticationRequiredError"!==err.name)throw logger$j.getToken.info(formatError(scopes,err)),err;errors.push(err)}if(!token&&errors.length>0){const err=new AggregateAuthenticationError(errors,"ChainedTokenCredential authentication failed.");throw logger$j.getToken.info(formatError(scopes,err)),err}if(logger$j.getToken.info(`Result for ${successfulCredentialName}: ${formatSuccess(scopes)}`),null===token)throw new CredentialUnavailableError("Failed to retrieve a valid token");return token}))}}function ensureValidScope(scope,logger){if(!scope.match(/^[0-9a-zA-Z-.:/]+$/)){const error=new Error("Invalid scope was specified by the user or calling client");throw logger.getToken.info(formatError(scope,error)),error}}function getScopeResource(scope){return scope.replace(/\/.default$/,"")}const cliCredentialInternals={getSafeWorkingDir(){if("win32"===process.platform){if(!process.env.SystemRoot)throw new Error("Azure CLI credential expects a 'SystemRoot' environment variable");return process.env.SystemRoot}return"/bin"},async getAzureCliAccessToken(resource,tenantId){let tenantSection=[];return tenantId&&(tenantSection=["--tenant",tenantId]),new Promise(((resolve,reject)=>{try{child_process__default.default.execFile("az",["account","get-access-token","--output","json","--resource",resource,...tenantSection],{cwd:cliCredentialInternals.getSafeWorkingDir(),shell:!0},((error,stdout,stderr)=>{resolve({stdout:stdout,stderr:stderr,error:error})}))}catch(err){reject(err)}}))}},logger$i=credentialLogger("AzureCliCredential");class AzureCliCredential{constructor(options){this.tenantId=null==options?void 0:options.tenantId}async getToken(scopes,options={}){const tenantId=processMultiTenantRequest(this.tenantId,options);tenantId&&checkTenantId(logger$i,tenantId);const scope="string"==typeof scopes?scopes:scopes[0];logger$i.getToken.info(`Using the scope ${scope}`),ensureValidScope(scope,logger$i);const resource=getScopeResource(scope);return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async()=>{var _a,_b,_c,_d;try{const obj=await cliCredentialInternals.getAzureCliAccessToken(resource,tenantId),specificScope=null===(_a=obj.stderr)||void 0===_a?void 0:_a.match("(.*)az login --scope(.*)"),isLoginError=(null===(_b=obj.stderr)||void 0===_b?void 0:_b.match("(.*)az login(.*)"))&&!specificScope;if((null===(_c=obj.stderr)||void 0===_c?void 0:_c.match("az:(.*)not found"))||(null===(_d=obj.stderr)||void 0===_d?void 0:_d.startsWith("'az' is not recognized"))){const error=new CredentialUnavailableError("Azure CLI could not be found. Please visit https://aka.ms/azure-cli for installation instructions and then, once installed, authenticate to your Azure account using 'az login'.");throw logger$i.getToken.info(formatError(scopes,error)),error}if(isLoginError){const error=new CredentialUnavailableError("Please run 'az login' from a command prompt to authenticate before using this credential.");throw logger$i.getToken.info(formatError(scopes,error)),error}try{const responseData=obj.stdout,response=JSON.parse(responseData);logger$i.getToken.info(formatSuccess(scopes));return{token:response.accessToken,expiresOnTimestamp:new Date(response.expiresOn).getTime()}}catch(e){if(obj.stderr)throw new CredentialUnavailableError(obj.stderr);throw e}}catch(err){const error="CredentialUnavailableError"===err.name?err:new CredentialUnavailableError(err.message||"Unknown error while trying to retrieve the access token");throw logger$i.getToken.info(formatError(scopes,error)),error}}))}}const processUtils={execFile:(file,params,options)=>new Promise(((resolve,reject)=>{child_process__namespace.execFile(file,params,options,((error,stdout,stderr)=>{Buffer.isBuffer(stdout)&&(stdout=stdout.toString("utf8")),Buffer.isBuffer(stderr)&&(stderr=stderr.toString("utf8")),stderr||error?reject(stderr?new Error(stderr):error):resolve(stdout)}))}))},logger$h=credentialLogger("AzurePowerShellCredential"),isWindows="win32"===process.platform;function formatCommand(commandName){return isWindows?`${commandName}.exe`:commandName}async function runCommands(commands){const results=[];for(const command of commands){const[file,...parameters]=command,result=await processUtils.execFile(file,parameters,{encoding:"utf8"});results.push(result)}return results}const powerShellErrors={login:"Run Connect-AzAccount to login",installed:"The specified module 'Az.Accounts' with version '2.2.0' was not loaded because no valid module file was found in any module directory"},powerShellPublicErrorMessages={login:"Please run 'Connect-AzAccount' from PowerShell to authenticate before using this credential.",installed:"The 'Az.Account' module >= 2.2.0 is not installed. Install the Azure Az PowerShell module with: \"Install-Module -Name Az -Scope CurrentUser -Repository PSGallery -Force\".",troubleshoot:"To troubleshoot, visit https://aka.ms/azsdk/js/identity/powershellcredential/troubleshoot."},isLoginError=err=>err.message.match(`(.*)${powerShellErrors.login}(.*)`),isNotInstalledError=err=>err.message.match(powerShellErrors.installed),commandStack=[formatCommand("pwsh")];isWindows&&commandStack.push(formatCommand("powershell"));class AzurePowerShellCredential{constructor(options){this.tenantId=null==options?void 0:options.tenantId}async getAzurePowerShellAccessToken(resource,tenantId){for(const powerShellCommand of[...commandStack]){try{await runCommands([[powerShellCommand,"/?"]])}catch(e){commandStack.shift();continue}let tenantSection="";tenantId&&(tenantSection=`-TenantId "${tenantId}"`);const result=(await runCommands([[powerShellCommand,"-Command","Import-Module Az.Accounts -MinimumVersion 2.2.0 -PassThru"],[powerShellCommand,"-Command",`Get-AzAccessToken ${tenantSection} -ResourceUrl "${resource}" | ConvertTo-Json`]]))[1];try{return JSON.parse(result)}catch(e){throw new Error(`Unable to parse the output of PowerShell. Received output: ${result}`)}}throw new Error("Unable to execute PowerShell. Ensure that it is installed in your system")}async getToken(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async()=>{const tenantId=processMultiTenantRequest(this.tenantId,options);tenantId&&checkTenantId(logger$h,tenantId);const scope="string"==typeof scopes?scopes:scopes[0];ensureValidScope(scope,logger$h),logger$h.getToken.info(`Using the scope ${scope}`);const resource=getScopeResource(scope);try{const response=await this.getAzurePowerShellAccessToken(resource,tenantId);return logger$h.getToken.info(formatSuccess(scopes)),{token:response.Token,expiresOnTimestamp:new Date(response.ExpiresOn).getTime()}}catch(err){if(isNotInstalledError(err)){const error=new CredentialUnavailableError(powerShellPublicErrorMessages.installed);throw logger$h.getToken.info(formatError(scope,error)),error}if(isLoginError(err)){const error=new CredentialUnavailableError(powerShellPublicErrorMessages.login);throw logger$h.getToken.info(formatError(scope,error)),error}const error=new CredentialUnavailableError(`${err}. ${powerShellPublicErrorMessages.troubleshoot}`);throw logger$h.getToken.info(formatError(scope,error)),error}}))}}class MsalClientSecret extends MsalNode{constructor(options){super(options),this.requiresConfidential=!0,this.msalConfig.auth.clientSecret=options.clientSecret}async doGetToken(scopes,options={}){try{const result=await this.confidentialApp.acquireTokenByClientCredential({scopes:scopes,correlationId:options.correlationId,azureRegion:this.azureRegion,authority:options.authority,claims:options.claims});return this.handleResult(scopes,this.clientId,result||void 0)}catch(err){throw this.handleError(scopes,err,options)}}}const logger$g=credentialLogger("ClientSecretCredential");class ClientSecretCredential{constructor(tenantId,clientId,clientSecret,options={}){if(!tenantId||!clientId||!clientSecret)throw new Error("ClientSecretCredential: tenantId, clientId, and clientSecret are required parameters. To troubleshoot, visit https://aka.ms/azsdk/js/identity/serviceprincipalauthentication/troubleshoot.");this.msalFlow=new MsalClientSecret(Object.assign(Object.assign({},options),{logger:logger$g,clientId:clientId,tenantId:tenantId,clientSecret:clientSecret,tokenCredentialOptions:options}))}async getToken(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return this.msalFlow.getToken(arrayScopes,newOptions)}))}}const readFileAsync$2=util.promisify(fs.readFile);async function parseCertificate(configuration,sendCertificateChain){const certificateParts={},certificate=configuration.certificate,certificatePath=configuration.certificatePath;certificateParts.certificateContents=certificate||await readFileAsync$2(certificatePath,"utf8"),sendCertificateChain&&(certificateParts.x5c=certificateParts.certificateContents);const certificatePattern=/(-+BEGIN CERTIFICATE-+)(\n\r?|\r\n?)([A-Za-z0-9+/\n\r]+=*)(\n\r?|\r\n?)(-+END CERTIFICATE-+)/g,publicKeys=[];let match;do{match=certificatePattern.exec(certificateParts.certificateContents),match&&publicKeys.push(match[3])}while(match);if(0===publicKeys.length)throw new Error("The file at the specified path does not contain a PEM-encoded certificate.");return certificateParts.thumbprint=crypto.createHash("sha1").update(Buffer.from(publicKeys[0],"base64")).digest("hex").toUpperCase(),certificateParts}class MsalClientCertificate extends MsalNode{constructor(options){super(options),this.requiresConfidential=!0,this.configuration=options.configuration,this.sendCertificateChain=options.sendCertificateChain}async init(options){try{const parts=await parseCertificate(this.configuration,this.sendCertificateChain);this.msalConfig.auth.clientCertificate={thumbprint:parts.thumbprint,privateKey:parts.certificateContents,x5c:parts.x5c}}catch(error){throw this.logger.info(formatError("",error)),error}return super.init(options)}async doGetToken(scopes,options={}){try{const clientCredReq={scopes:scopes,correlationId:options.correlationId,azureRegion:this.azureRegion,authority:options.authority,claims:options.claims},result=await this.confidentialApp.acquireTokenByClientCredential(clientCredReq);return this.handleResult(scopes,this.clientId,result||void 0)}catch(err){throw this.handleError(scopes,err,options)}}}const credentialName$2="ClientCertificateCredential",logger$f=credentialLogger(credentialName$2);class ClientCertificateCredential{constructor(tenantId,clientId,certificatePathOrConfiguration,options={}){if(!tenantId||!clientId)throw new Error(`${credentialName$2}: tenantId and clientId are required parameters.`);const configuration=Object.assign({},"string"==typeof certificatePathOrConfiguration?{certificatePath:certificatePathOrConfiguration}:certificatePathOrConfiguration),certificate=configuration.certificate,certificatePath=configuration.certificatePath;if(!configuration||!certificate&&!certificatePath)throw new Error(`${credentialName$2}: Provide either a PEM certificate in string form, or the path to that certificate in the filesystem. To troubleshoot, visit https://aka.ms/azsdk/js/identity/serviceprincipalauthentication/troubleshoot.`);if(certificate&&certificatePath)throw new Error(`${credentialName$2}: To avoid unexpected behaviors, providing both the contents of a PEM certificate and the path to a PEM certificate is forbidden. To troubleshoot, visit https://aka.ms/azsdk/js/identity/serviceprincipalauthentication/troubleshoot.`);this.msalFlow=new MsalClientCertificate(Object.assign(Object.assign({},options),{configuration:configuration,logger:logger$f,clientId:clientId,tenantId:tenantId,sendCertificateChain:options.sendCertificateChain,tokenCredentialOptions:options}))}async getToken(scopes,options={}){return tracingClient.withSpan(`${credentialName$2}.getToken`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return this.msalFlow.getToken(arrayScopes,newOptions)}))}}class MsalUsernamePassword extends MsalNode{constructor(options){super(options),this.username=options.username,this.password=options.password}async doGetToken(scopes,options){try{const requestOptions={scopes:scopes,username:this.username,password:this.password,correlationId:null==options?void 0:options.correlationId,authority:null==options?void 0:options.authority,claims:null==options?void 0:options.claims},result=await this.publicApp.acquireTokenByUsernamePassword(requestOptions);return this.handleResult(scopes,this.clientId,result||void 0)}catch(error){throw this.handleError(scopes,error,options)}}}const logger$e=credentialLogger("UsernamePasswordCredential");class UsernamePasswordCredential{constructor(tenantId,clientId,username,password,options={}){if(!(tenantId&&clientId&&username&&password))throw new Error("UsernamePasswordCredential: tenantId, clientId, username and password are required parameters. To troubleshoot, visit https://aka.ms/azsdk/js/identity/usernamepasswordcredential/troubleshoot.");this.msalFlow=new MsalUsernamePassword(Object.assign(Object.assign({},options),{logger:logger$e,clientId:clientId,tenantId:tenantId,username:username,password:password,tokenCredentialOptions:options||{}}))}async getToken(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return this.msalFlow.getToken(arrayScopes,newOptions)}))}}const AllSupportedEnvironmentVariables=["AZURE_TENANT_ID","AZURE_CLIENT_ID","AZURE_CLIENT_SECRET","AZURE_CLIENT_CERTIFICATE_PATH","AZURE_USERNAME","AZURE_PASSWORD"],credentialName$1="EnvironmentCredential",logger$d=credentialLogger(credentialName$1);class EnvironmentCredential{constructor(options){this._credential=void 0;const assigned=processEnvVars(AllSupportedEnvironmentVariables).assigned.join(", ");logger$d.info(`Found the following environment variables: ${assigned}`);const tenantId=process.env.AZURE_TENANT_ID,clientId=process.env.AZURE_CLIENT_ID,clientSecret=process.env.AZURE_CLIENT_SECRET;if(tenantId&&checkTenantId(logger$d,tenantId),tenantId&&clientId&&clientSecret)return logger$d.info(`Invoking ClientSecretCredential with tenant ID: ${tenantId}, clientId: ${clientId} and clientSecret: [REDACTED]`),void(this._credential=new ClientSecretCredential(tenantId,clientId,clientSecret,options));const certificatePath=process.env.AZURE_CLIENT_CERTIFICATE_PATH;if(tenantId&&clientId&&certificatePath)return logger$d.info(`Invoking ClientCertificateCredential with tenant ID: ${tenantId}, clientId: ${clientId} and certificatePath: ${certificatePath}`),void(this._credential=new ClientCertificateCredential(tenantId,clientId,{certificatePath:certificatePath},options));const username=process.env.AZURE_USERNAME,password=process.env.AZURE_PASSWORD;tenantId&&clientId&&username&&password&&(logger$d.info(`Invoking UsernamePasswordCredential with tenant ID: ${tenantId}, clientId: ${clientId} and username: ${username}`),this._credential=new UsernamePasswordCredential(tenantId,clientId,username,password,options))}async getToken(scopes,options={}){return tracingClient.withSpan(`${credentialName$1}.getToken`,options,(async newOptions=>{if(this._credential)try{const result=await this._credential.getToken(scopes,newOptions);return logger$d.getToken.info(formatSuccess(scopes)),result}catch(err){const authenticationError=new AuthenticationError(400,{error:`${credentialName$1} authentication failed. To troubleshoot, visit https://aka.ms/azsdk/js/identity/environmentcredential/troubleshoot.`,error_description:err.message.toString().split("More details:").join("")});throw logger$d.getToken.info(formatError(scopes,authenticationError)),authenticationError}throw new CredentialUnavailableError(`${credentialName$1} is unavailable. No underlying credential could be used. To troubleshoot, visit https://aka.ms/azsdk/js/identity/environmentcredential/troubleshoot.`)}))}}const DefaultScopeSuffix="/.default",imdsHost="http://169.254.169.254",imdsEndpointPath="/metadata/identity/oauth2/token",imdsApiVersion="2018-02-01",azureArcAPIVersion="2019-11-01",azureFabricVersion="2019-07-01-preview";function mapScopesToResource(scopes){let scope="";if(Array.isArray(scopes)){if(1!==scopes.length)return;scope=scopes[0]}else"string"==typeof scopes&&(scope=scopes);return scope.endsWith(DefaultScopeSuffix)?scope.substr(0,scope.lastIndexOf(DefaultScopeSuffix)):scope}const msiName$6="ManagedIdentityCredential - AppServiceMSI 2017",logger$c=credentialLogger(msiName$6);function expiresOnParser$3(requestBody){return Date.parse(requestBody.expires_on)}function prepareRequestOptions$6(scopes,clientId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName$6}: Multiple scopes are not supported.`);const queryParameters={resource:resource,"api-version":"2017-09-01"};clientId&&(queryParameters.clientid=clientId);const query=new URLSearchParams(queryParameters);if(!process.env.MSI_ENDPOINT)throw new Error(`${msiName$6}: Missing environment variable: MSI_ENDPOINT`);if(!process.env.MSI_SECRET)throw new Error(`${msiName$6}: Missing environment variable: MSI_SECRET`);return{url:`${process.env.MSI_ENDPOINT}?${query.toString()}`,method:"GET",headers:coreRestPipeline.createHttpHeaders({Accept:"application/json",secret:process.env.MSI_SECRET})}}const appServiceMsi2017={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger$c.info(`${msiName$6}: Unavailable. Multiple scopes are not supported.`),!1;const env=process.env,result=Boolean(env.MSI_ENDPOINT&&env.MSI_SECRET);return result||logger$c.info(`${msiName$6}: Unavailable. The environment variables needed are: MSI_ENDPOINT and MSI_SECRET.`),result},async getToken(configuration,getTokenOptions={}){const{identityClient:identityClient,scopes:scopes,clientId:clientId,resourceId:resourceId}=configuration;resourceId&&logger$c.warning(`${msiName$6}: managed Identity by resource Id is not supported. Argument resourceId might be ignored by the service.`),logger$c.info(`${msiName$6}: Using the endpoint and the secret coming form the environment variables: MSI_ENDPOINT=${process.env.MSI_ENDPOINT} and MSI_SECRET=[REDACTED].`);const request=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions$6(scopes,clientId)),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request,expiresOnParser$3);return tokenResponse&&tokenResponse.accessToken||null}},msiName$5="ManagedIdentityCredential - CloudShellMSI",logger$b=credentialLogger(msiName$5);function prepareRequestOptions$5(scopes,clientId,resourceId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName$5}: Multiple scopes are not supported.`);const body={resource:resource};if(clientId&&(body.client_id=clientId),resourceId&&(body.msi_res_id=resourceId),!process.env.MSI_ENDPOINT)throw new Error(`${msiName$5}: Missing environment variable: MSI_ENDPOINT`);const params=new URLSearchParams(body);return{url:process.env.MSI_ENDPOINT,method:"POST",body:params.toString(),headers:coreRestPipeline.createHttpHeaders({Accept:"application/json",Metadata:"true","Content-Type":"application/x-www-form-urlencoded"})}}const cloudShellMsi={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger$b.info(`${msiName$5}: Unavailable. Multiple scopes are not supported.`),!1;const result=Boolean(process.env.MSI_ENDPOINT);return result||logger$b.info(`${msiName$5}: Unavailable. The environment variable MSI_ENDPOINT is needed.`),result},async getToken(configuration,getTokenOptions={}){const{identityClient:identityClient,scopes:scopes,clientId:clientId,resourceId:resourceId}=configuration;clientId&&logger$b.warning(`${msiName$5}: user-assigned identities not supported. The argument clientId might be ignored by the service.`),resourceId&&logger$b.warning(`${msiName$5}: user defined managed Identity by resource Id not supported. The argument resourceId might be ignored by the service.`),logger$b.info(`${msiName$5}: Using the endpoint coming form the environment variable MSI_ENDPOINT = ${process.env.MSI_ENDPOINT}.`);const request=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions$5(scopes,clientId,resourceId)),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request);return tokenResponse&&tokenResponse.accessToken||null}},msiName$4="ManagedIdentityCredential - IMDS",logger$a=credentialLogger(msiName$4);function expiresOnParser$2(requestBody){if(requestBody.expires_on){const expires=1e3*+requestBody.expires_on;return logger$a.info(`${msiName$4}: Using expires_on: ${expires} (original value: ${requestBody.expires_on})`),expires}{const expires=Date.now()+1e3*requestBody.expires_in;return logger$a.info(`${msiName$4}: IMDS using expires_in: ${expires} (original value: ${requestBody.expires_in})`),expires}}function prepareRequestOptions$4(scopes,clientId,resourceId,options){var _a;const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName$4}: Multiple scopes are not supported.`);const{skipQuery:skipQuery,skipMetadataHeader:skipMetadataHeader}=options||{};let query="";if(!skipQuery){const queryParameters={resource:resource,"api-version":imdsApiVersion};clientId&&(queryParameters.client_id=clientId),resourceId&&(queryParameters.msi_res_id=resourceId);query=`?${new URLSearchParams(queryParameters).toString()}`}const url=new URL(imdsEndpointPath,null!==(_a=process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST)&&void 0!==_a?_a:imdsHost),rawHeaders={Accept:"application/json",Metadata:"true"};return skipMetadataHeader&&delete rawHeaders.Metadata,{url:`${url}${query}`,method:"GET",headers:coreRestPipeline.createHttpHeaders(rawHeaders)}}const imdsMsiRetryConfig={maxRetries:3,startDelayInMs:800,intervalIncrement:2},imdsMsi={async isAvailable({scopes:scopes,identityClient:identityClient,clientId:clientId,resourceId:resourceId,getTokenOptions:getTokenOptions={}}){const resource=mapScopesToResource(scopes);if(!resource)return logger$a.info(`${msiName$4}: Unavailable. Multiple scopes are not supported.`),!1;if(process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST)return!0;if(!identityClient)throw new Error("Missing IdentityClient");const requestOptions=prepareRequestOptions$4(resource,clientId,resourceId,{skipMetadataHeader:!0,skipQuery:!0});return tracingClient.withSpan("ManagedIdentityCredential-pingImdsEndpoint",getTokenOptions,(async options=>{var _a,_b;requestOptions.tracingOptions=options.tracingOptions;try{const request=coreRestPipeline.createPipelineRequest(requestOptions);request.timeout=null!==(_b=null===(_a=options.requestOptions)||void 0===_a?void 0:_a.timeout)&&void 0!==_b?_b:300,request.allowInsecureConnection=!0;try{logger$a.info(`${msiName$4}: Pinging the Azure IMDS endpoint`),await identityClient.sendRequest(request)}catch(err){if("RestError"===err.name&&err.code===coreRestPipeline.RestError.REQUEST_SEND_ERROR||"AbortError"===err.name||"ENETUNREACH"===err.code||"ECONNREFUSED"===err.code||"EHOSTDOWN"===err.code)return logger$a.info(`${msiName$4}: The Azure IMDS endpoint is unavailable`),!1}return logger$a.info(`${msiName$4}: The Azure IMDS endpoint is available`),!0}catch(err){throw logger$a.info(`${msiName$4}: Error when creating the WebResource for the Azure IMDS endpoint: ${err.message}`),err}}))},async getToken(configuration,getTokenOptions={}){const{identityClient:identityClient,scopes:scopes,clientId:clientId,resourceId:resourceId}=configuration;logger$a.info(`${msiName$4}: Using the Azure IMDS endpoint coming from the environment variable MSI_ENDPOINT=${process.env.MSI_ENDPOINT}, and using the cloud shell to proceed with the authentication.`);let nextDelayInMs=imdsMsiRetryConfig.startDelayInMs;for(let retries=0;retries<imdsMsiRetryConfig.maxRetries;retries++)try{const request=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions$4(scopes,clientId,resourceId)),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request,expiresOnParser$2);return tokenResponse&&tokenResponse.accessToken||null}catch(error){if(404===error.statusCode){await coreUtil.delay(nextDelayInMs),nextDelayInMs*=imdsMsiRetryConfig.intervalIncrement;continue}throw error}throw new AuthenticationError(404,`${msiName$4}: Failed to retrieve IMDS token after ${imdsMsiRetryConfig.maxRetries} retries.`)}},msiName$3="ManagedIdentityCredential - Azure Arc MSI",logger$9=credentialLogger(msiName$3);function prepareRequestOptions$3(scopes,clientId,resourceId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName$3}: Multiple scopes are not supported.`);const queryParameters={resource:resource,"api-version":azureArcAPIVersion};if(clientId&&(queryParameters.client_id=clientId),resourceId&&(queryParameters.msi_res_id=resourceId),!process.env.IDENTITY_ENDPOINT)throw new Error(`${msiName$3}: Missing environment variable: IDENTITY_ENDPOINT`);const query=new URLSearchParams(queryParameters);return coreRestPipeline.createPipelineRequest({url:`${process.env.IDENTITY_ENDPOINT}?${query.toString()}`,method:"GET",headers:coreRestPipeline.createHttpHeaders({Accept:"application/json",Metadata:"true"})})}function readFileAsync$1(path,options){return new Promise(((resolve,reject)=>fs.readFile(path,options,((err,data)=>{err&&reject(err),resolve(data)}))))}async function filePathRequest(identityClient,requestPrepareOptions){const response=await identityClient.sendRequest(coreRestPipeline.createPipelineRequest(requestPrepareOptions));if(401!==response.status){let message="";throw response.bodyAsText&&(message=` Response: ${response.bodyAsText}`),new AuthenticationError(response.status,`${msiName$3}: To authenticate with Azure Arc MSI, status code 401 is expected on the first request. ${message}`)}const authHeader=response.headers.get("www-authenticate")||"";try{return authHeader.split("=").slice(1)[0]}catch(e){throw Error(`Invalid www-authenticate header format: ${authHeader}`)}}const arcMsi={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger$9.info(`${msiName$3}: Unavailable. Multiple scopes are not supported.`),!1;const result=Boolean(process.env.IMDS_ENDPOINT&&process.env.IDENTITY_ENDPOINT);return result||logger$9.info(`${msiName$3}: The environment variables needed are: IMDS_ENDPOINT and IDENTITY_ENDPOINT`),result},async getToken(configuration,getTokenOptions={}){var _a;const{identityClient:identityClient,scopes:scopes,clientId:clientId,resourceId:resourceId}=configuration;clientId&&logger$9.warning(`${msiName$3}: user-assigned identities not supported. The argument clientId might be ignored by the service.`),resourceId&&logger$9.warning(`${msiName$3}: user defined managed Identity by resource Id is not supported. Argument resourceId will be ignored.`),logger$9.info(`${msiName$3}: Authenticating.`);const requestOptions=Object.assign(Object.assign({disableJsonStringifyOnBody:!0,deserializationMapper:void 0,abortSignal:getTokenOptions.abortSignal},prepareRequestOptions$3(scopes,clientId,resourceId)),{allowInsecureConnection:!0}),filePath=await filePathRequest(identityClient,requestOptions);if(!filePath)throw new Error(`${msiName$3}: Failed to find the token file.`);const key=await readFileAsync$1(filePath,{encoding:"utf-8"});null===(_a=requestOptions.headers)||void 0===_a||_a.set("Authorization",`Basic ${key}`);const request=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({},requestOptions),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request);return tokenResponse&&tokenResponse.accessToken||null}},msiName$2="ManagedIdentityCredential - Token Exchange",logger$8=credentialLogger(msiName$2),readFileAsync=util.promisify(fs__default.default.readFile);function prepareRequestOptions$2(scopes,clientAssertion,clientId){var _a;const bodyParams={scope:Array.isArray(scopes)?scopes.join(" "):scopes,client_assertion:clientAssertion,client_assertion_type:"urn:ietf:params:oauth:client-assertion-type:jwt-bearer",client_id:clientId,grant_type:"client_credentials"},urlParams=new URLSearchParams(bodyParams);return{url:new URL(`${process.env.AZURE_TENANT_ID}/oauth2/v2.0/token`,null!==(_a=process.env.AZURE_AUTHORITY_HOST)&&void 0!==_a?_a:DefaultAuthorityHost).toString(),method:"POST",body:urlParams.toString(),headers:coreRestPipeline.createHttpHeaders({Accept:"application/json"})}}function tokenExchangeMsi(){const azureFederatedTokenFilePath=process.env.AZURE_FEDERATED_TOKEN_FILE;let azureFederatedTokenFileContent,cacheDate;async function readAssertion(){if(void 0!==cacheDate&&Date.now()-cacheDate>=3e5&&(azureFederatedTokenFileContent=void 0),!azureFederatedTokenFileContent){const value=(await readFileAsync(azureFederatedTokenFilePath,"utf8")).trim();if(!value)throw new Error(`No content on the file ${azureFederatedTokenFilePath}, indicated by the environment variable AZURE_FEDERATED_TOKEN_FILE`);azureFederatedTokenFileContent=value,cacheDate=Date.now()}return azureFederatedTokenFileContent}return{async isAvailable({clientId:clientId}){const env=process.env,result=Boolean((clientId||env.AZURE_CLIENT_ID)&&env.AZURE_TENANT_ID&&azureFederatedTokenFilePath);return result||logger$8.info(`${msiName$2}: Unavailable. The environment variables needed are: AZURE_CLIENT_ID (or the client ID sent through the parameters), AZURE_TENANT_ID and AZURE_FEDERATED_TOKEN_FILE`),result},async getToken(configuration,getTokenOptions={}){const{identityClient:identityClient,scopes:scopes,clientId:clientId}=configuration;let assertion;logger$8.info(`${msiName$2}: Using the client assertion coming from environment variables.`);try{assertion=await readAssertion()}catch(err){throw new Error(`${msiName$2}: Failed to read ${azureFederatedTokenFilePath}, indicated by the environment variable AZURE_FEDERATED_TOKEN_FILE`)}const request=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions$2(scopes,assertion,clientId||process.env.AZURE_CLIENT_ID)),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request);return tokenResponse&&tokenResponse.accessToken||null}}}const msiName$1="ManagedIdentityCredential - Fabric MSI",logger$7=credentialLogger(msiName$1);function expiresOnParser$1(requestBody){return Number(requestBody.expires_on)}function prepareRequestOptions$1(scopes,clientId,resourceId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName$1}: Multiple scopes are not supported.`);const queryParameters={resource:resource,"api-version":azureFabricVersion};clientId&&(queryParameters.client_id=clientId),resourceId&&(queryParameters.msi_res_id=resourceId);const query=new URLSearchParams(queryParameters);if(!process.env.IDENTITY_ENDPOINT)throw new Error("Missing environment variable: IDENTITY_ENDPOINT");if(!process.env.IDENTITY_HEADER)throw new Error("Missing environment variable: IDENTITY_HEADER");return{url:`${process.env.IDENTITY_ENDPOINT}?${query.toString()}`,method:"GET",headers:coreRestPipeline.createHttpHeaders({Accept:"application/json",secret:process.env.IDENTITY_HEADER})}}const fabricMsi={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger$7.info(`${msiName$1}: Unavailable. Multiple scopes are not supported.`),!1;const env=process.env,result=Boolean(env.IDENTITY_ENDPOINT&&env.IDENTITY_HEADER&&env.IDENTITY_SERVER_THUMBPRINT);return result||logger$7.info(`${msiName$1}: Unavailable. The environment variables needed are: IDENTITY_ENDPOINT, IDENTITY_HEADER and IDENTITY_SERVER_THUMBPRINT`),result},async getToken(configuration,getTokenOptions={}){const{scopes:scopes,identityClient:identityClient,clientId:clientId,resourceId:resourceId}=configuration;resourceId&&logger$7.warning(`${msiName$1}: user defined managed Identity by resource Id is not supported. Argument resourceId might be ignored by the service.`),logger$7.info([`${msiName$1}:`,"Using the endpoint and the secret coming from the environment variables:",`IDENTITY_ENDPOINT=${process.env.IDENTITY_ENDPOINT},`,"IDENTITY_HEADER=[REDACTED] and","IDENTITY_SERVER_THUMBPRINT=[REDACTED]."].join(" "));const request=coreRestPipeline.createPipelineRequest(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions$1(scopes,clientId,resourceId)));request.agent=new https__default.default.Agent({rejectUnauthorized:!1});const tokenResponse=await identityClient.sendTokenRequest(request,expiresOnParser$1);return tokenResponse&&tokenResponse.accessToken||null}},msiName="ManagedIdentityCredential - AppServiceMSI 2019",logger$6=credentialLogger(msiName);function expiresOnParser(requestBody){return Date.parse(requestBody.expires_on)}function prepareRequestOptions(scopes,clientId,resourceId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName}: Multiple scopes are not supported.`);const queryParameters={resource:resource,"api-version":"2019-08-01"};clientId&&(queryParameters.client_id=clientId),resourceId&&(queryParameters.mi_res_id=resourceId);const query=new URLSearchParams(queryParameters);if(!process.env.IDENTITY_ENDPOINT)throw new Error(`${msiName}: Missing environment variable: IDENTITY_ENDPOINT`);if(!process.env.IDENTITY_HEADER)throw new Error(`${msiName}: Missing environment variable: IDENTITY_HEADER`);return{url:`${process.env.IDENTITY_ENDPOINT}?${query.toString()}`,method:"GET",headers:coreRestPipeline.createHttpHeaders({Accept:"application/json","X-IDENTITY-HEADER":process.env.IDENTITY_HEADER})}}const appServiceMsi2019={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger$6.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;const env=process.env,result=Boolean(env.IDENTITY_ENDPOINT&&env.IDENTITY_HEADER);return result||logger$6.info(`${msiName}: Unavailable. The environment variables needed are: IDENTITY_ENDPOINT and IDENTITY_HEADER.`),result},async getToken(configuration,getTokenOptions={}){const{identityClient:identityClient,scopes:scopes,clientId:clientId,resourceId:resourceId}=configuration;logger$6.info(`${msiName}: Using the endpoint and the secret coming form the environment variables: IDENTITY_ENDPOINT=${process.env.IDENTITY_ENDPOINT} and IDENTITY_HEADER=[REDACTED].`);const request=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions(scopes,clientId,resourceId)),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request,expiresOnParser);return tokenResponse&&tokenResponse.accessToken||null}},logger$5=credentialLogger("ManagedIdentityCredential");class ManagedIdentityCredential{constructor(clientIdOrOptions,options){let _options;if(this.isEndpointUnavailable=null,"string"==typeof clientIdOrOptions?(this.clientId=clientIdOrOptions,_options=options):(this.clientId=null==clientIdOrOptions?void 0:clientIdOrOptions.clientId,_options=clientIdOrOptions),this.resourceId=null==_options?void 0:_options.resourceId,this.clientId&&this.resourceId)throw new Error(`${ManagedIdentityCredential.name} - Client Id and Resource Id can't be provided at the same time.`);this.identityClient=new IdentityClient(_options),this.isAvailableIdentityClient=new IdentityClient(Object.assign(Object.assign({},_options),{retryOptions:{maxRetries:0}}))}async cachedAvailableMSI(scopes,getTokenOptions){if(this.cachedMSI)return this.cachedMSI;const MSIs=[arcMsi,fabricMsi,appServiceMsi2019,appServiceMsi2017,cloudShellMsi,tokenExchangeMsi(),imdsMsi];for(const msi of MSIs)if(await msi.isAvailable({scopes:scopes,identityClient:this.isAvailableIdentityClient,clientId:this.clientId,resourceId:this.resourceId,getTokenOptions:getTokenOptions}))return this.cachedMSI=msi,msi;throw new CredentialUnavailableError(`${ManagedIdentityCredential.name} - No MSI credential available`)}async authenticateManagedIdentity(scopes,getTokenOptions){const{span:span,updatedOptions:updatedOptions}=tracingClient.startSpan(`${ManagedIdentityCredential.name}.authenticateManagedIdentity`,getTokenOptions);try{return(await this.cachedAvailableMSI(scopes,updatedOptions)).getToken({identityClient:this.identityClient,scopes:scopes,clientId:this.clientId,resourceId:this.resourceId},updatedOptions)}catch(err){throw span.setStatus({status:"error",error:err}),err}finally{span.end()}}async getToken(scopes,options){let result=null;const{span:span,updatedOptions:updatedOptions}=tracingClient.startSpan(`${ManagedIdentityCredential.name}.getToken`,options);try{if(!0===this.isEndpointUnavailable){const error=new CredentialUnavailableError("The managed identity endpoint is not currently available");throw logger$5.getToken.info(formatError(scopes,error)),error}if(result=await this.authenticateManagedIdentity(scopes,updatedOptions),null===result){this.isEndpointUnavailable=!0;const error=new CredentialUnavailableError("The managed identity endpoint was reached, yet no tokens were received.");throw logger$5.getToken.info(formatError(scopes,error)),error}return this.isEndpointUnavailable=!1,logger$5.getToken.info(formatSuccess(scopes)),result}catch(err){if("AuthenticationRequiredError"===err.name)throw err;if(span.setStatus({status:"error",error:err}),"ENETUNREACH"===err.code){const error=new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Unavailable. Network unreachable. Message: ${err.message}`);throw logger$5.getToken.info(formatError(scopes,error)),error}if("EHOSTUNREACH"===err.code){const error=new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Unavailable. No managed identity endpoint found. Message: ${err.message}`);throw logger$5.getToken.info(formatError(scopes,error)),error}if(400===err.statusCode)throw new CredentialUnavailableError(`${ManagedIdentityCredential.name}: The managed identity endpoint is indicating there's no available identity. Message: ${err.message}`);if(void 0===err.statusCode)throw new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Authentication failed. Message ${err.message}`);throw new AuthenticationError(err.statusCode,{error:`${ManagedIdentityCredential.name} authentication failed.`,error_description:err.message})}finally{span.end()}}}class DefaultManagedIdentityCredential extends ManagedIdentityCredential{constructor(options){var _a;const managedIdentityClientId=null!==(_a=null==options?void 0:options.managedIdentityClientId)&&void 0!==_a?_a:process.env.AZURE_CLIENT_ID,managedResourceId=null==options?void 0:options.managedIdentityResourceId;if(managedResourceId){super(Object.assign(Object.assign({},options),{resourceId:managedResourceId}))}else if(managedIdentityClientId){super(Object.assign(Object.assign({},options),{clientId:managedIdentityClientId}))}else super(options)}}const defaultCredentials=[EnvironmentCredential,DefaultManagedIdentityCredential,VisualStudioCodeCredential,AzureCliCredential,AzurePowerShellCredential];class DefaultAzureCredential extends ChainedTokenCredential{constructor(options){super(...defaultCredentials.map((ctor=>new ctor(options)))),this.UnavailableMessage="DefaultAzureCredential => failed to retrieve a token from the included credentials. To troubleshoot, visit https://aka.ms/azsdk/js/identity/defaultazurecredential/troubleshoot."}}class MsalClientAssertion extends MsalNode{constructor(options){super(options),this.requiresConfidential=!0,this.getAssertion=options.getAssertion}async doGetToken(scopes,options={}){try{const assertion=await this.getAssertion(),result=await this.confidentialApp.acquireTokenByClientCredential({scopes:scopes,correlationId:options.correlationId,azureRegion:this.azureRegion,authority:options.authority,claims:options.claims,clientAssertion:assertion});return this.handleResult(scopes,this.clientId,result||void 0)}catch(err){let err2=err;throw err2=null==err?new Error(JSON.stringify(err)):coreUtil.isError(err)?err:new Error(String(err)),this.handleError(scopes,err2,options)}}}const logger$4=credentialLogger("ClientAssertionCredential");class ClientAssertionCredential{constructor(tenantId,clientId,getAssertion,options={}){if(!tenantId||!clientId||!getAssertion)throw new Error("ClientAssertionCredential: tenantId, clientId, and clientAssertion are required parameters.");this.tenantId=tenantId,this.clientId=clientId,this.options=options,this.msalFlow=new MsalClientAssertion(Object.assign(Object.assign({},options),{logger:logger$4,clientId:this.clientId,tenantId:this.tenantId,tokenCredentialOptions:this.options,getAssertion:getAssertion}))}async getToken(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return this.msalFlow.getToken(arrayScopes,newOptions)}))}}const interactiveBrowserMockable={open:open__default.default};class MsalOpenBrowser extends MsalNode{constructor(options){super(options),this.logger=credentialLogger("Node.js MSAL Open Browser"),this.redirectUri=options.redirectUri,this.loginHint=options.loginHint;const url=new URL(this.redirectUri);this.port=parseInt(url.port),isNaN(this.port)&&(this.port=80),this.hostname=url.hostname}async acquireTokenByCode(request){return this.publicApp.acquireTokenByCode(request)}doGetToken(scopes,options){return new Promise(((resolve,reject)=>{const socketToDestroy=[],requestListener=(req,res)=>{var _a;if(!req.url)return void reject(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'));let url;try{url=new URL(req.url,this.redirectUri)}catch(e){return void reject(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'))}const tokenRequest={code:url.searchParams.get("code"),redirectUri:this.redirectUri,scopes:scopes,authority:null==options?void 0:options.authority,codeVerifier:null===(_a=this.pkceCodes)||void 0===_a?void 0:_a.verifier};this.acquireTokenByCode(tokenRequest).then((authResponse=>{(null==authResponse?void 0:authResponse.account)&&(this.account=msalToPublic(this.clientId,authResponse.account));const successMessage="Authentication Complete. You can close the browser and return to the application.";if(authResponse&&authResponse.expiresOn){const expiresOnTimestamp=null==authResponse?void 0:authResponse.expiresOn.valueOf();res.writeHead(200),res.end(successMessage),this.logger.getToken.info(formatSuccess(scopes)),resolve({expiresOnTimestamp:expiresOnTimestamp,token:authResponse.accessToken})}else{const errorMessage=formatError(scopes,`${url.searchParams.get("error")}. ${url.searchParams.get("error_description")}`);res.writeHead(500),res.end(errorMessage),this.logger.getToken.info(errorMessage),reject(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'))}cleanup()})).catch((()=>{const errorMessage=formatError(scopes,`${url.searchParams.get("error")}. ${url.searchParams.get("error_description")}`);res.writeHead(500),res.end(errorMessage),this.logger.getToken.info(errorMessage),reject(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"')),cleanup()}))},app=http__default.default.createServer(requestListener),server=stoppable__default.default(app),listen=app.listen(this.port,this.hostname,(()=>this.logger.info(`InteractiveBrowserCredential listening on port ${this.port}!`)));function cleanup(){listen&&listen.close();for(const socket of socketToDestroy)socket.destroy();server&&(server.close(),server.stop())}app.on("connection",(socket=>socketToDestroy.push(socket))),app.on("error",(err=>{cleanup();const code=err.code;reject(new CredentialUnavailableError("EACCES"===code||"EADDRINUSE"===code?[`InteractiveBrowserCredential: Access denied to port ${this.port}.`,"Try sending a redirect URI with a different port, as follows:",'`new InteractiveBrowserCredential({ redirectUri: "http://localhost:1337" })`'].join(" "):`InteractiveBrowserCredential: Failed to start the necessary web server. Error: ${err.message}`))})),app.on("listening",(()=>{const openPromise=this.openAuthCodeUrl(scopes,options),abortSignal=null==options?void 0:options.abortSignal;abortSignal&&abortSignal.addEventListener("abort",(()=>{cleanup(),reject(new Error("Aborted"))})),openPromise.then().catch((e=>{cleanup(),reject(e)}))}))}))}async openAuthCodeUrl(scopeArray,options){const cryptoProvider=new msalNode__namespace.CryptoProvider;this.pkceCodes=await cryptoProvider.generatePkceCodes();const authCodeUrlParameters={scopes:scopeArray,correlationId:null==options?void 0:options.correlationId,redirectUri:this.redirectUri,authority:null==options?void 0:options.authority,claims:null==options?void 0:options.claims,loginHint:this.loginHint,codeChallenge:this.pkceCodes.challenge,codeChallengeMethod:"S256"},response=await this.publicApp.getAuthCodeUrl(authCodeUrlParameters);try{await interactiveBrowserMockable.open(response,{wait:!0,newInstance:!0})}catch(e){throw new CredentialUnavailableError(`InteractiveBrowserCredential: Could not open a browser window. Error: ${e.message}`)}}}const logger$3=credentialLogger("InteractiveBrowserCredential");class InteractiveBrowserCredential{constructor(options={}){const redirectUri="function"==typeof options.redirectUri?options.redirectUri():options.redirectUri||"http://localhost";this.msalFlow=new MsalOpenBrowser(Object.assign(Object.assign({},options),{tokenCredentialOptions:options,logger:logger$3,redirectUri:redirectUri})),this.disableAutomaticAuthentication=null==options?void 0:options.disableAutomaticAuthentication}async getToken(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return this.msalFlow.getToken(arrayScopes,Object.assign(Object.assign({},newOptions),{disableAutomaticAuthentication:this.disableAutomaticAuthentication}))}))}async authenticate(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.authenticate`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return await this.msalFlow.getToken(arrayScopes,newOptions),this.msalFlow.getActiveAccount()}))}}class MsalDeviceCode extends MsalNode{constructor(options){super(options),this.userPromptCallback=options.userPromptCallback}async doGetToken(scopes,options){try{const requestOptions={deviceCodeCallback:this.userPromptCallback,scopes:scopes,cancel:!1,correlationId:null==options?void 0:options.correlationId,authority:null==options?void 0:options.authority,claims:null==options?void 0:options.claims},promise=this.publicApp.acquireTokenByDeviceCode(requestOptions),deviceResponse=await this.withCancellation(promise,null==options?void 0:options.abortSignal,(()=>{requestOptions.cancel=!0}));return this.handleResult(scopes,this.clientId,deviceResponse||void 0)}catch(error){throw this.handleError(scopes,error,options)}}}const logger$2=credentialLogger("DeviceCodeCredential");function defaultDeviceCodePromptCallback(deviceCodeInfo){console.log(deviceCodeInfo.message)}class DeviceCodeCredential{constructor(options){this.msalFlow=new MsalDeviceCode(Object.assign(Object.assign({},options),{logger:logger$2,userPromptCallback:(null==options?void 0:options.userPromptCallback)||defaultDeviceCodePromptCallback,tokenCredentialOptions:options||{}})),this.disableAutomaticAuthentication=null==options?void 0:options.disableAutomaticAuthentication}async getToken(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return this.msalFlow.getToken(arrayScopes,Object.assign(Object.assign({},newOptions),{disableAutomaticAuthentication:this.disableAutomaticAuthentication}))}))}async authenticate(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.authenticate`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return await this.msalFlow.getToken(arrayScopes,newOptions),this.msalFlow.getActiveAccount()}))}}class MsalAuthorizationCode extends MsalNode{constructor(options){super(options),this.logger=credentialLogger("Node.js MSAL Authorization Code"),this.redirectUri=options.redirectUri,this.authorizationCode=options.authorizationCode,options.clientSecret&&(this.msalConfig.auth.clientSecret=options.clientSecret)}async getAuthCodeUrl(options){return await this.init(),(this.confidentialApp||this.publicApp).getAuthCodeUrl(options)}async doGetToken(scopes,options){var _a;try{const result=await(null===(_a=this.confidentialApp||this.publicApp)||void 0===_a?void 0:_a.acquireTokenByCode({scopes:scopes,redirectUri:this.redirectUri,code:this.authorizationCode,correlationId:null==options?void 0:options.correlationId,authority:null==options?void 0:options.authority,claims:null==options?void 0:options.claims}));return this.handleResult(scopes,this.clientId,result||void 0)}catch(err){throw this.handleError(scopes,err,options)}}}const logger$1=credentialLogger("AuthorizationCodeCredential");class AuthorizationCodeCredential{constructor(tenantId,clientId,clientSecretOrAuthorizationCode,authorizationCodeOrRedirectUri,redirectUriOrOptions,options){checkTenantId(logger$1,tenantId);let clientSecret=clientSecretOrAuthorizationCode;"string"==typeof redirectUriOrOptions?(this.authorizationCode=authorizationCodeOrRedirectUri,this.redirectUri=redirectUriOrOptions):(this.authorizationCode=clientSecretOrAuthorizationCode,this.redirectUri=authorizationCodeOrRedirectUri,clientSecret=void 0,options=redirectUriOrOptions),this.msalFlow=new MsalAuthorizationCode(Object.assign(Object.assign({},options),{clientSecret:clientSecret,clientId:clientId,tenantId:tenantId,tokenCredentialOptions:options||{},logger:logger$1,redirectUri:this.redirectUri,authorizationCode:this.authorizationCode}))}async getToken(scopes,options={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return this.msalFlow.getToken(arrayScopes,Object.assign(Object.assign({},newOptions),{disableAutomaticAuthentication:this.disableAutomaticAuthentication}))}))}}class MsalOnBehalfOf extends MsalNode{constructor(options){super(options),this.logger.info("Initialized MSAL's On-Behalf-Of flow"),this.requiresConfidential=!0,this.userAssertionToken=options.userAssertionToken,this.certificatePath=options.certificatePath,this.sendCertificateChain=options.sendCertificateChain,this.clientSecret=options.clientSecret}async init(options){if(this.certificatePath)try{const parts=await parseCertificate({certificatePath:this.certificatePath},this.sendCertificateChain);this.msalConfig.auth.clientCertificate={thumbprint:parts.thumbprint,privateKey:parts.certificateContents,x5c:parts.x5c}}catch(error){throw this.logger.info(formatError("",error)),error}else this.msalConfig.auth.clientSecret=this.clientSecret;return super.init(options)}async doGetToken(scopes,options={}){try{const result=await this.confidentialApp.acquireTokenOnBehalfOf({scopes:scopes,correlationId:options.correlationId,authority:options.authority,claims:options.claims,oboAssertion:this.userAssertionToken});return this.handleResult(scopes,this.clientId,result||void 0)}catch(err){throw this.handleError(scopes,err,options)}}}const credentialName="OnBehalfOfCredential",logger=credentialLogger(credentialName);class OnBehalfOfCredential{constructor(options){this.options=options;const{clientSecret:clientSecret}=options,{certificatePath:certificatePath}=options,{tenantId:tenantId,clientId:clientId,userAssertionToken:userAssertionToken}=options;if(!tenantId||!clientId||!clientSecret&&!certificatePath||!userAssertionToken)throw new Error(`${credentialName}: tenantId, clientId, clientSecret (or certificatePath) and userAssertionToken are required parameters.`);this.msalFlow=new MsalOnBehalfOf(Object.assign(Object.assign({},this.options),{logger:logger,tokenCredentialOptions:this.options}))}async getToken(scopes,options={}){return tracingClient.withSpan(`${credentialName}.getToken`,options,(async newOptions=>{const arrayScopes=Array.isArray(scopes)?scopes:[scopes];return this.msalFlow.getToken(arrayScopes,newOptions)}))}}function getDefaultAzureCredential(){return new DefaultAzureCredential}exports.AggregateAuthenticationError=AggregateAuthenticationError,exports.AggregateAuthenticationErrorName=AggregateAuthenticationErrorName,exports.AuthenticationError=AuthenticationError,exports.AuthenticationErrorName=AuthenticationErrorName,exports.AuthenticationRequiredError=AuthenticationRequiredError,exports.AuthorizationCodeCredential=AuthorizationCodeCredential,exports.AzureCliCredential=AzureCliCredential,exports.AzurePowerShellCredential=AzurePowerShellCredential,exports.ChainedTokenCredential=ChainedTokenCredential,exports.ClientAssertionCredential=ClientAssertionCredential,exports.ClientCertificateCredential=ClientCertificateCredential,exports.ClientSecretCredential=ClientSecretCredential,exports.CredentialUnavailableError=CredentialUnavailableError,exports.CredentialUnavailableErrorName=CredentialUnavailableErrorName,exports.DefaultAzureCredential=DefaultAzureCredential,exports.DeviceCodeCredential=DeviceCodeCredential,exports.EnvironmentCredential=EnvironmentCredential,exports.InteractiveBrowserCredential=InteractiveBrowserCredential,exports.ManagedIdentityCredential=ManagedIdentityCredential,exports.OnBehalfOfCredential=OnBehalfOfCredential,exports.UsernamePasswordCredential=UsernamePasswordCredential,exports.VisualStudioCodeCredential=VisualStudioCodeCredential,exports.deserializeAuthenticationRecord=deserializeAuthenticationRecord,exports.getDefaultAzureCredential=getDefaultAzureCredential,exports.logger=logger$l,exports.serializeAuthenticationRecord=serializeAuthenticationRecord,exports.useIdentityPlugin=useIdentityPlugin;