import*as crypto from"crypto";import{LocalCryptographyUnsupportedError}from"./models";export class AesCryptographyProvider{constructor(key){this.supportedAlgorithms={A128CBCPAD:{algorithm:"aes-128-cbc",keySizeInBytes:16},A192CBCPAD:{algorithm:"aes-192-cbc",keySizeInBytes:24},A256CBCPAD:{algorithm:"aes-256-cbc",keySizeInBytes:32}},this.supportedOperations=["encrypt","decrypt"],this.key=key}encrypt(encryptParameters,_options){const{algorithm:algorithm,keySizeInBytes:keySizeInBytes}=this.supportedAlgorithms[encryptParameters.algorithm],iv=encryptParameters.iv||crypto.randomBytes(16);this.ensureValid(keySizeInBytes);const cipher=crypto.createCipheriv(algorithm,this.key.k.subarray(0,keySizeInBytes),iv);let encrypted=cipher.update(Buffer.from(encryptParameters.plaintext));return encrypted=Buffer.concat([encrypted,cipher.final()]),Promise.resolve({algorithm:encryptParameters.algorithm,result:encrypted,iv:iv})}decrypt(decryptParameters,_options){const{algorithm:algorithm,keySizeInBytes:keySizeInBytes}=this.supportedAlgorithms[decryptParameters.algorithm];this.ensureValid(keySizeInBytes);const decipher=crypto.createDecipheriv(algorithm,this.key.k.subarray(0,keySizeInBytes),decryptParameters.iv);let dec=decipher.update(Buffer.from(decryptParameters.ciphertext));return dec=Buffer.concat([dec,decipher.final()]),Promise.resolve({algorithm:decryptParameters.algorithm,result:dec})}isSupported(algorithm,operation){return!!this.key.k&&(!!Object.keys(this.supportedAlgorithms).includes(algorithm)&&!!this.supportedOperations.includes(operation))}wrapKey(_algorithm,_keyToWrap,_options){throw new LocalCryptographyUnsupportedError("Wrapping a key using a local JsonWebKey is not supported for AES.")}unwrapKey(_algorithm,_encryptedKey,_options){throw new LocalCryptographyUnsupportedError("Unwrapping a key using a local JsonWebKey is not supported for AES.")}sign(_algorithm,_digest,_options){throw new LocalCryptographyUnsupportedError("Signing using a local JsonWebKey is not supported for AES.")}signData(_algorithm,_data,_options){throw new LocalCryptographyUnsupportedError("Signing using a local JsonWebKey is not supported for AES.")}verify(_algorithm,_digest,_signature,_options){throw new LocalCryptographyUnsupportedError("Verifying using a local JsonWebKey is not supported for AES.")}verifyData(_algorithm,_data,_signature,_updatedOptions){throw new LocalCryptographyUnsupportedError("Verifying using a local JsonWebKey is not supported for AES.")}ensureValid(keySizeInBytes){var _a,_b;if(this.key&&"OCT"!==(null===(_a=this.key.kty)||void 0===_a?void 0:_a.toUpperCase())&&"OCT-HSM"!==(null===(_b=this.key.kty)||void 0===_b?void 0:_b.toUpperCase()))throw new Error("Key type does not match the key type oct or oct-hsm");if(!this.key.k)throw new Error("Symmetric key is required");if(this.key.k.length<keySizeInBytes)throw new Error(`Key must be at least ${keySizeInBytes<<3} bits`)}}