import{RSA_PKCS1_OAEP_PADDING,RSA_PKCS1_PADDING}from"constants";import{publicEncrypt}from"crypto";import{createVerify}from"./crypto";import{convertJWKtoPEM}from"./conversions";import{LocalCryptographyUnsupportedError}from"./models";export class RsaCryptographyProvider{constructor(key){this.applicableAlgorithms=["RSA1_5","RSA-OAEP","PS256","RS256","PS384","RS384","PS512","RS512"],this.applicableOperations=["encrypt","wrapKey","verifyData"],this.signatureAlgorithmToHashAlgorithm={PS256:"SHA256",RS256:"SHA256",PS384:"SHA384",RS384:"SHA384",PS512:"SHA512",RS512:"SHA512"},this.key=key}isSupported(algorithm,operation){return this.applicableAlgorithms.includes(algorithm)&&this.applicableOperations.includes(operation)}encrypt(encryptParameters,_options){this.ensureValid();const keyPEM=convertJWKtoPEM(this.key),padding="RSA1_5"===encryptParameters.algorithm?RSA_PKCS1_PADDING:RSA_PKCS1_OAEP_PADDING;return Promise.resolve({algorithm:encryptParameters.algorithm,keyID:this.key.kid,result:publicEncrypt({key:keyPEM,padding:padding},Buffer.from(encryptParameters.plaintext))})}decrypt(_decryptParameters,_options){throw new LocalCryptographyUnsupportedError("Decrypting using a local JsonWebKey is not supported.")}wrapKey(algorithm,keyToWrap,_options){this.ensureValid();const keyPEM=convertJWKtoPEM(this.key),padding="RSA1_5"===algorithm?RSA_PKCS1_PADDING:RSA_PKCS1_OAEP_PADDING;return Promise.resolve({algorithm:algorithm,result:publicEncrypt({key:keyPEM,padding:padding},Buffer.from(keyToWrap)),keyID:this.key.kid})}unwrapKey(_algorithm,_encryptedKey,_options){throw new LocalCryptographyUnsupportedError("Unwrapping a key using a local JsonWebKey is not supported.")}sign(_algorithm,_digest,_options){throw new LocalCryptographyUnsupportedError("Signing a digest using a local JsonWebKey is not supported.")}signData(_algorithm,_data,_options){throw new LocalCryptographyUnsupportedError("Signing a block of data using a local JsonWebKey is not supported.")}async verify(_algorithm,_digest,_signature,_options){throw new LocalCryptographyUnsupportedError("Verifying a digest using a local JsonWebKey is not supported.")}verifyData(algorithm,data,signature,_options){this.ensureValid();const keyPEM=convertJWKtoPEM(this.key),verifier=createVerify(algorithm,data);return Promise.resolve({result:verifier.verify(keyPEM,Buffer.from(signature)),keyID:this.key.kid})}ensureValid(){var _a,_b;if(this.key&&"RSA"!==(null===(_a=this.key.kty)||void 0===_a?void 0:_a.toUpperCase())&&"RSA-HSM"!==(null===(_b=this.key.kty)||void 0===_b?void 0:_b.toUpperCase()))throw new Error("Key type does not match the algorithm RSA")}}