/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__awaiter,__generator}from"../../_virtual/_tslib.js";import{NativeConstants,NativeExtensionMethod}from"../../utils/BrowserConstants.js";import{AuthError,AuthenticationScheme,PerformanceEvents}from"@azure/msal-common";import{NativeAuthError}from"../../error/NativeAuthError.js";import{BrowserAuthError}from"../../error/BrowserAuthError.js";var NativeMessageHandler=function(){function NativeMessageHandler(logger,handshakeTimeoutMs,performanceClient,extensionId){this.logger=logger,this.handshakeTimeoutMs=handshakeTimeoutMs,this.extensionId=extensionId,this.resolvers=new Map,this.handshakeResolvers=new Map,this.responseId=0,this.messageChannel=new MessageChannel,this.windowListener=this.onWindowMessage.bind(this),this.performanceClient=performanceClient,this.handshakeEvent=performanceClient.startMeasurement(PerformanceEvents.NativeMessageHandlerHandshake)}return NativeMessageHandler.prototype.sendMessage=function(body){return __awaiter(this,void 0,void 0,(function(){var req,_this=this;return __generator(this,(function(_a){return this.logger.trace("NativeMessageHandler - sendMessage called."),req={channel:NativeConstants.CHANNEL_ID,extensionId:this.extensionId,responseId:this.responseId++,body:body},this.logger.trace("NativeMessageHandler - Sending request to browser extension"),this.logger.tracePii("NativeMessageHandler - Sending request to browser extension: "+JSON.stringify(req)),this.messageChannel.port1.postMessage(req),[2,new Promise((function(resolve,reject){_this.resolvers.set(req.responseId,{resolve:resolve,reject:reject})}))]}))}))},NativeMessageHandler.createProvider=function(logger,handshakeTimeoutMs,performanceClient){return __awaiter(this,void 0,void 0,(function(){var preferredProvider,backupProvider;return __generator(this,(function(_a){switch(_a.label){case 0:logger.trace("NativeMessageHandler - createProvider called."),_a.label=1;case 1:return _a.trys.push([1,3,,5]),[4,(preferredProvider=new NativeMessageHandler(logger,handshakeTimeoutMs,performanceClient,NativeConstants.PREFERRED_EXTENSION_ID)).sendHandshakeRequest()];case 2:return _a.sent(),[2,preferredProvider];case 3:return _a.sent(),[4,(backupProvider=new NativeMessageHandler(logger,handshakeTimeoutMs,performanceClient)).sendHandshakeRequest()];case 4:return _a.sent(),[2,backupProvider];case 5:return[2]}}))}))},NativeMessageHandler.prototype.sendHandshakeRequest=function(){return __awaiter(this,void 0,void 0,(function(){var req,_this=this;return __generator(this,(function(_a){return this.logger.trace("NativeMessageHandler - sendHandshakeRequest called."),window.addEventListener("message",this.windowListener,!1),req={channel:NativeConstants.CHANNEL_ID,extensionId:this.extensionId,responseId:this.responseId++,body:{method:NativeExtensionMethod.HandshakeRequest}},this.handshakeEvent.addStaticFields({extensionId:this.extensionId,extensionHandshakeTimeoutMs:this.handshakeTimeoutMs}),this.messageChannel.port1.onmessage=function(event){_this.onChannelMessage(event)},window.postMessage(req,window.origin,[this.messageChannel.port2]),[2,new Promise((function(resolve,reject){_this.handshakeResolvers.set(req.responseId,{resolve:resolve,reject:reject}),_this.timeoutId=window.setTimeout((function(){window.removeEventListener("message",_this.windowListener,!1),_this.messageChannel.port1.close(),_this.messageChannel.port2.close(),_this.handshakeEvent.endMeasurement({extensionHandshakeTimedOut:!0,success:!1}),reject(BrowserAuthError.createNativeHandshakeTimeoutError()),_this.handshakeResolvers.delete(req.responseId)}),_this.handshakeTimeoutMs)}))]}))}))},NativeMessageHandler.prototype.onWindowMessage=function(event){if(this.logger.trace("NativeMessageHandler - onWindowMessage called"),event.source===window){var request=event.data;if(request.channel&&request.channel===NativeConstants.CHANNEL_ID&&(!request.extensionId||request.extensionId===this.extensionId)&&request.body.method===NativeExtensionMethod.HandshakeRequest){this.logger.verbose(request.extensionId?"Extension with id: "+request.extensionId+" not installed":"No extension installed"),clearTimeout(this.timeoutId),this.messageChannel.port1.close(),this.messageChannel.port2.close(),window.removeEventListener("message",this.windowListener,!1);var handshakeResolver=this.handshakeResolvers.get(request.responseId);handshakeResolver&&(this.handshakeEvent.endMeasurement({success:!1,extensionInstalled:!1}),handshakeResolver.reject(BrowserAuthError.createNativeExtensionNotInstalledError()))}}},NativeMessageHandler.prototype.onChannelMessage=function(event){this.logger.trace("NativeMessageHandler - onChannelMessage called.");var request=event.data,resolver=this.resolvers.get(request.responseId),handshakeResolver=this.handshakeResolvers.get(request.responseId);try{var method=request.body.method;if(method===NativeExtensionMethod.Response){if(!resolver)return;var response=request.body.response;if(this.logger.trace("NativeMessageHandler - Received response from browser extension"),this.logger.tracePii("NativeMessageHandler - Received response from browser extension: "+JSON.stringify(response)),"Success"!==response.status)resolver.reject(NativeAuthError.createError(response.code,response.description,response.ext));else{if(!response.result)throw AuthError.createUnexpectedError("Event does not contain result.");response.result.code&&response.result.description?resolver.reject(NativeAuthError.createError(response.result.code,response.result.description,response.result.ext)):resolver.resolve(response.result)}this.resolvers.delete(request.responseId)}else if(method===NativeExtensionMethod.HandshakeResponse){if(!handshakeResolver)return;clearTimeout(this.timeoutId),window.removeEventListener("message",this.windowListener,!1),this.extensionId=request.extensionId,this.extensionVersion=request.body.version,this.logger.verbose("NativeMessageHandler - Received HandshakeResponse from extension: "+this.extensionId),this.handshakeEvent.endMeasurement({extensionInstalled:!0,success:!0}),handshakeResolver.resolve(),this.handshakeResolvers.delete(request.responseId)}}catch(err){this.logger.error("Error parsing response from WAM Extension"),this.logger.errorPii("Error parsing response from WAM Extension: "+err.toString()),this.logger.errorPii("Unable to parse "+event),resolver?resolver.reject(err):handshakeResolver&&handshakeResolver.reject(err)}},NativeMessageHandler.prototype.getExtensionId=function(){return this.extensionId},NativeMessageHandler.prototype.getExtensionVersion=function(){return this.extensionVersion},NativeMessageHandler.isNativeAvailable=function(config,logger,nativeExtensionProvider,authenticationScheme){if(logger.trace("isNativeAvailable called"),!config.system.allowNativeBroker)return logger.trace("isNativeAvailable: allowNativeBroker is not enabled, returning false"),!1;if(!nativeExtensionProvider)return logger.trace("isNativeAvailable: WAM extension provider is not initialized, returning false"),!1;if(authenticationScheme)switch(authenticationScheme){case AuthenticationScheme.BEARER:case AuthenticationScheme.POP:return logger.trace("isNativeAvailable: authenticationScheme is supported, returning true"),!0;default:return logger.trace("isNativeAvailable: authenticationScheme is not supported, returning false"),!1}return!0},NativeMessageHandler}();export{NativeMessageHandler};