/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__awaiter,__generator}from"../_virtual/_tslib.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";import{DB_NAME,DB_VERSION,DB_TABLE_NAME}from"../utils/BrowserConstants.js";var DatabaseStorage=function(){function DatabaseStorage(){this.dbName=DB_NAME,this.version=DB_VERSION,this.tableName=DB_TABLE_NAME,this.dbOpen=!1}return DatabaseStorage.prototype.open=function(){return __awaiter(this,void 0,void 0,(function(){var _this=this;return __generator(this,(function(_a){return[2,new Promise((function(resolve,reject){var openDB=window.indexedDB.open(_this.dbName,_this.version);openDB.addEventListener("upgradeneeded",(function(e){e.target.result.createObjectStore(_this.tableName)})),openDB.addEventListener("success",(function(e){var event=e;_this.db=event.target.result,_this.dbOpen=!0,resolve()})),openDB.addEventListener("error",(function(){return reject(BrowserAuthError.createDatabaseUnavailableError())}))}))]}))}))},DatabaseStorage.prototype.closeConnection=function(){var db=this.db;db&&this.dbOpen&&(db.close(),this.dbOpen=!1)},DatabaseStorage.prototype.validateDbIsOpen=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(_a){switch(_a.label){case 0:return this.dbOpen?[3,2]:[4,this.open()];case 1:return[2,_a.sent()];case 2:return[2]}}))}))},DatabaseStorage.prototype.getItem=function(key){return __awaiter(this,void 0,void 0,(function(){var _this=this;return __generator(this,(function(_a){switch(_a.label){case 0:return[4,this.validateDbIsOpen()];case 1:return _a.sent(),[2,new Promise((function(resolve,reject){if(!_this.db)return reject(BrowserAuthError.createDatabaseNotOpenError());var dbGet=_this.db.transaction([_this.tableName],"readonly").objectStore(_this.tableName).get(key);dbGet.addEventListener("success",(function(e){var event=e;_this.closeConnection(),resolve(event.target.result)})),dbGet.addEventListener("error",(function(e){_this.closeConnection(),reject(e)}))}))]}}))}))},DatabaseStorage.prototype.setItem=function(key,payload){return __awaiter(this,void 0,void 0,(function(){var _this=this;return __generator(this,(function(_a){switch(_a.label){case 0:return[4,this.validateDbIsOpen()];case 1:return _a.sent(),[2,new Promise((function(resolve,reject){if(!_this.db)return reject(BrowserAuthError.createDatabaseNotOpenError());var dbPut=_this.db.transaction([_this.tableName],"readwrite").objectStore(_this.tableName).put(payload,key);dbPut.addEventListener("success",(function(){_this.closeConnection(),resolve()})),dbPut.addEventListener("error",(function(e){_this.closeConnection(),reject(e)}))}))]}}))}))},DatabaseStorage.prototype.removeItem=function(key){return __awaiter(this,void 0,void 0,(function(){var _this=this;return __generator(this,(function(_a){switch(_a.label){case 0:return[4,this.validateDbIsOpen()];case 1:return _a.sent(),[2,new Promise((function(resolve,reject){if(!_this.db)return reject(BrowserAuthError.createDatabaseNotOpenError());var dbDelete=_this.db.transaction([_this.tableName],"readwrite").objectStore(_this.tableName).delete(key);dbDelete.addEventListener("success",(function(){_this.closeConnection(),resolve()})),dbDelete.addEventListener("error",(function(e){_this.closeConnection(),reject(e)}))}))]}}))}))},DatabaseStorage.prototype.getKeys=function(){return __awaiter(this,void 0,void 0,(function(){var _this=this;return __generator(this,(function(_a){switch(_a.label){case 0:return[4,this.validateDbIsOpen()];case 1:return _a.sent(),[2,new Promise((function(resolve,reject){if(!_this.db)return reject(BrowserAuthError.createDatabaseNotOpenError());var dbGetKeys=_this.db.transaction([_this.tableName],"readonly").objectStore(_this.tableName).getAllKeys();dbGetKeys.addEventListener("success",(function(e){var event=e;_this.closeConnection(),resolve(event.target.result)})),dbGetKeys.addEventListener("error",(function(e){_this.closeConnection(),reject(e)}))}))]}}))}))},DatabaseStorage.prototype.containsKey=function(key){return __awaiter(this,void 0,void 0,(function(){var _this=this;return __generator(this,(function(_a){switch(_a.label){case 0:return[4,this.validateDbIsOpen()];case 1:return _a.sent(),[2,new Promise((function(resolve,reject){if(!_this.db)return reject(BrowserAuthError.createDatabaseNotOpenError());var dbContainsKey=_this.db.transaction([_this.tableName],"readonly").objectStore(_this.tableName).count(key);dbContainsKey.addEventListener("success",(function(e){var event=e;_this.closeConnection(),resolve(1===event.target.result)})),dbContainsKey.addEventListener("error",(function(e){_this.closeConnection(),reject(e)}))}))]}}))}))},DatabaseStorage.prototype.deleteDatabase=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(_a){return this.db&&this.dbOpen&&this.closeConnection(),[2,new Promise((function(resolve,reject){var deleteDbRequest=window.indexedDB.deleteDatabase(DB_NAME);deleteDbRequest.addEventListener("success",(function(){return resolve(!0)})),deleteDbRequest.addEventListener("blocked",(function(){return resolve(!0)})),deleteDbRequest.addEventListener("error",(function(){return reject(!1)}))}))]}))}))},DatabaseStorage}();export{DatabaseStorage};