/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{AccountEntity,CacheManager}from"@azure/msal-common";import{EventType}from"./EventType.js";var EventHandler=function(){function EventHandler(logger,browserCrypto){this.eventCallbacks=new Map,this.logger=logger,this.browserCrypto=browserCrypto,this.listeningToStorageEvents=!1,this.handleAccountCacheChange=this.handleAccountCacheChange.bind(this)}return EventHandler.prototype.addEventCallback=function(callback){if("undefined"!=typeof window){var callbackId=this.browserCrypto.createNewGuid();return this.eventCallbacks.set(callbackId,callback),this.logger.verbose("Event callback registered with id: "+callbackId),callbackId}return null},EventHandler.prototype.removeEventCallback=function(callbackId){this.eventCallbacks.delete(callbackId),this.logger.verbose("Event callback "+callbackId+" removed.")},EventHandler.prototype.enableAccountStorageEvents=function(){"undefined"!=typeof window&&(this.listeningToStorageEvents?this.logger.verbose("Account storage listener already registered."):(this.logger.verbose("Adding account storage listener."),this.listeningToStorageEvents=!0,window.addEventListener("storage",this.handleAccountCacheChange)))},EventHandler.prototype.disableAccountStorageEvents=function(){"undefined"!=typeof window&&(this.listeningToStorageEvents?(this.logger.verbose("Removing account storage listener."),window.removeEventListener("storage",this.handleAccountCacheChange),this.listeningToStorageEvents=!1):this.logger.verbose("No account storage listener registered."))},EventHandler.prototype.emitEvent=function(eventType,interactionType,payload,error){var _this=this;if("undefined"!=typeof window){var message_1={eventType:eventType,interactionType:interactionType||null,payload:payload||null,error:error||null,timestamp:Date.now()};this.logger.info("Emitting event: "+eventType),this.eventCallbacks.forEach((function(callback,callbackId){_this.logger.verbose("Emitting event to callback "+callbackId+": "+eventType),callback.apply(null,[message_1])}))}},EventHandler.prototype.handleAccountCacheChange=function(e){try{var cacheValue=e.newValue||e.oldValue;if(!cacheValue)return;var parsedValue=JSON.parse(cacheValue);if("object"!=typeof parsedValue||!AccountEntity.isAccountEntity(parsedValue))return;var accountInfo=CacheManager.toObject(new AccountEntity,parsedValue).getAccountInfo();!e.oldValue&&e.newValue?(this.logger.info("Account was added to cache in a different window"),this.emitEvent(EventType.ACCOUNT_ADDED,void 0,accountInfo)):!e.newValue&&e.oldValue&&(this.logger.info("Account was removed from cache in a different window"),this.emitEvent(EventType.ACCOUNT_REMOVED,void 0,accountInfo))}catch(e){return}},EventHandler}();export{EventHandler};