/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{OIDC_DEFAULT_SCOPES,StringUtils,UrlString,Constants,AuthError,ThrottlingUtils,ProtocolUtils,PerformanceEvents}from"@azure/msal-common";import{StandardInteractionClient}from"./StandardInteractionClient.js";import{EventType}from"../event/EventType.js";import{BrowserConstants,InteractionType,ApiId}from"../utils/BrowserConstants.js";import{BrowserUtils}from"../utils/BrowserUtils.js";import{NativeInteractionClient}from"./NativeInteractionClient.js";import{NativeMessageHandler}from"../broker/nativeBroker/NativeMessageHandler.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";import{InteractionHandler}from"../interaction_handler/InteractionHandler.js";var PopupClient=function(_super){function PopupClient(config,storageImpl,browserCrypto,logger,eventHandler,navigationClient,performanceClient,nativeStorageImpl,nativeMessageHandler,correlationId){var _this=_super.call(this,config,storageImpl,browserCrypto,logger,eventHandler,navigationClient,performanceClient,nativeMessageHandler,correlationId)||this;return _this.unloadWindow=_this.unloadWindow.bind(_this),_this.nativeStorage=nativeStorageImpl,_this}return __extends(PopupClient,_super),PopupClient.prototype.acquireToken=function(request){try{var popupName=this.generatePopupName(request.scopes||OIDC_DEFAULT_SCOPES,request.authority||this.config.auth.authority),popupWindowAttributes=request.popupWindowAttributes||{};if(this.config.system.asyncPopups)return this.logger.verbose("asyncPopups set to true, acquiring token"),this.acquireTokenPopupAsync(request,popupName,popupWindowAttributes);this.logger.verbose("asyncPopup set to false, opening popup before acquiring token");var popup=this.openSizedPopup("about:blank",popupName,popupWindowAttributes);return this.acquireTokenPopupAsync(request,popupName,popupWindowAttributes,popup)}catch(e){return Promise.reject(e)}},PopupClient.prototype.logout=function(logoutRequest){try{this.logger.verbose("logoutPopup called");var validLogoutRequest=this.initializeLogoutRequest(logoutRequest),popupName=this.generateLogoutPopupName(validLogoutRequest),authority=logoutRequest&&logoutRequest.authority,mainWindowRedirectUri=logoutRequest&&logoutRequest.mainWindowRedirectUri,popupWindowAttributes=(null==logoutRequest?void 0:logoutRequest.popupWindowAttributes)||{};if(this.config.system.asyncPopups)return this.logger.verbose("asyncPopups set to true"),this.logoutPopupAsync(validLogoutRequest,popupName,popupWindowAttributes,authority,void 0,mainWindowRedirectUri);this.logger.verbose("asyncPopup set to false, opening popup");var popup=this.openSizedPopup("about:blank",popupName,popupWindowAttributes);return this.logoutPopupAsync(validLogoutRequest,popupName,popupWindowAttributes,authority,popup,mainWindowRedirectUri)}catch(e){return Promise.reject(e)}},PopupClient.prototype.acquireTokenPopupAsync=function(request,popupName,popupWindowAttributes,popup){return __awaiter(this,void 0,void 0,(function(){var serverTelemetryManager,validRequest,authCodeRequest,authClient,isNativeBroker,fetchNativeAccountIdMeasurement,navigateUrl,interactionHandler,popupParameters,popupWindow,hash,serverParams,state_1,nativeInteractionClient,userRequestState,e_1,_this=this;return __generator(this,(function(_a){switch(_a.label){case 0:return this.logger.verbose("acquireTokenPopupAsync called"),serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenPopup),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest,request.correlationId),[4,this.initializeAuthorizationRequest(request,InteractionType.Popup)];case 1:validRequest=_a.sent(),this.browserStorage.updateCacheEntries(validRequest.state,validRequest.nonce,validRequest.authority,validRequest.loginHint||Constants.EMPTY_STRING,validRequest.account||null),_a.label=2;case 2:return _a.trys.push([2,8,,9]),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationCodeRequest,request.correlationId),[4,this.initializeAuthorizationCodeRequest(validRequest)];case 3:return authCodeRequest=_a.sent(),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient,request.correlationId),[4,this.createAuthCodeClient(serverTelemetryManager,validRequest.authority,validRequest.azureCloudOptions)];case 4:return authClient=_a.sent(),this.logger.verbose("Auth code client created"),isNativeBroker=NativeMessageHandler.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,request.authenticationScheme),fetchNativeAccountIdMeasurement=void 0,isNativeBroker&&(fetchNativeAccountIdMeasurement=this.performanceClient.startMeasurement(PerformanceEvents.FetchAccountIdWithNativeBroker,request.correlationId)),[4,authClient.getAuthCodeUrl(__assign(__assign({},validRequest),{nativeBroker:isNativeBroker}))];case 5:return navigateUrl=_a.sent(),interactionHandler=new InteractionHandler(authClient,this.browserStorage,authCodeRequest,this.logger,this.performanceClient),popupParameters={popup:popup,popupName:popupName,popupWindowAttributes:popupWindowAttributes},popupWindow=this.initiateAuthRequest(navigateUrl,popupParameters),this.eventHandler.emitEvent(EventType.POPUP_OPENED,InteractionType.Popup,{popupWindow:popupWindow},null),[4,this.monitorPopupForHash(popupWindow)];case 6:if(hash=_a.sent(),serverParams=UrlString.getDeserializedHash(hash),state_1=this.validateAndExtractStateFromHash(serverParams,InteractionType.Popup,validRequest.correlationId),ThrottlingUtils.removeThrottle(this.browserStorage,this.config.auth.clientId,authCodeRequest),serverParams.accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),fetchNativeAccountIdMeasurement&&fetchNativeAccountIdMeasurement.endMeasurement({success:!0,isNativeBroker:!0}),!this.nativeMessageHandler)throw BrowserAuthError.createNativeConnectionNotEstablishedError();return nativeInteractionClient=new NativeInteractionClient(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,ApiId.acquireTokenPopup,this.performanceClient,this.nativeMessageHandler,serverParams.accountId,this.nativeStorage,validRequest.correlationId),userRequestState=ProtocolUtils.parseRequestState(this.browserCrypto,state_1).userRequestState,[2,nativeInteractionClient.acquireToken(__assign(__assign({},validRequest),{state:userRequestState,prompt:void 0})).finally((function(){_this.browserStorage.cleanRequestByState(state_1)}))]}return[4,interactionHandler.handleCodeResponseFromHash(hash,state_1,authClient.authority,this.networkClient)];case 7:return[2,_a.sent()];case 8:throw e_1=_a.sent(),popup&&popup.close(),e_1 instanceof AuthError&&e_1.setCorrelationId(this.correlationId),serverTelemetryManager.cacheFailedRequest(e_1),this.browserStorage.cleanRequestByState(validRequest.state),e_1;case 9:return[2]}}))}))},PopupClient.prototype.logoutPopupAsync=function(validRequest,popupName,popupWindowAttributes,requestAuthority,popup,mainWindowRedirectUri){return __awaiter(this,void 0,void 0,(function(){var serverTelemetryManager,authClient,logoutUri,popupWindow,navigationOptions,absoluteUrl,e_2;return __generator(this,(function(_a){switch(_a.label){case 0:this.logger.verbose("logoutPopupAsync called"),this.eventHandler.emitEvent(EventType.LOGOUT_START,InteractionType.Popup,validRequest),serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.logoutPopup),_a.label=1;case 1:return _a.trys.push([1,5,,6]),[4,this.clearCacheOnLogout(validRequest.account)];case 2:return _a.sent(),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient,validRequest.correlationId),[4,this.createAuthCodeClient(serverTelemetryManager,requestAuthority)];case 3:return authClient=_a.sent(),this.logger.verbose("Auth code client created"),logoutUri=authClient.getLogoutUri(validRequest),this.eventHandler.emitEvent(EventType.LOGOUT_SUCCESS,InteractionType.Popup,validRequest),popupWindow=this.openPopup(logoutUri,{popupName:popupName,popupWindowAttributes:popupWindowAttributes,popup:popup}),this.eventHandler.emitEvent(EventType.POPUP_OPENED,InteractionType.Popup,{popupWindow:popupWindow},null),[4,this.waitForLogoutPopup(popupWindow)];case 4:return _a.sent(),mainWindowRedirectUri?(navigationOptions={apiId:ApiId.logoutPopup,timeout:this.config.system.redirectNavigationTimeout,noHistory:!1},absoluteUrl=UrlString.getAbsoluteUrl(mainWindowRedirectUri,BrowserUtils.getCurrentUri()),this.logger.verbose("Redirecting main window to url specified in the request"),this.logger.verbosePii("Redirecting main window to: "+absoluteUrl),this.navigationClient.navigateInternal(absoluteUrl,navigationOptions)):this.logger.verbose("No main window navigation requested"),[3,6];case 5:throw e_2=_a.sent(),popup&&popup.close(),e_2 instanceof AuthError&&e_2.setCorrelationId(this.correlationId),this.browserStorage.setInteractionInProgress(!1),this.eventHandler.emitEvent(EventType.LOGOUT_FAILURE,InteractionType.Popup,null,e_2),this.eventHandler.emitEvent(EventType.LOGOUT_END,InteractionType.Popup),serverTelemetryManager.cacheFailedRequest(e_2),e_2;case 6:return this.eventHandler.emitEvent(EventType.LOGOUT_END,InteractionType.Popup),[2]}}))}))},PopupClient.prototype.initiateAuthRequest=function(requestUrl,params){if(StringUtils.isEmpty(requestUrl))throw this.logger.error("Navigate url is empty"),BrowserAuthError.createEmptyNavigationUriError();return this.logger.infoPii("Navigate to: "+requestUrl),this.openPopup(requestUrl,params)},PopupClient.prototype.monitorPopupForHash=function(popupWindow){var _this=this;return new Promise((function(resolve,reject){var maxTicks=_this.config.system.windowHashTimeout/_this.config.system.pollIntervalMilliseconds,ticks=0;_this.logger.verbose("PopupHandler.monitorPopupForHash - polling started");var intervalId=setInterval((function(){if(popupWindow.closed)return _this.logger.error("PopupHandler.monitorPopupForHash - window closed"),_this.cleanPopup(),clearInterval(intervalId),void reject(BrowserAuthError.createUserCancelledError());var href=Constants.EMPTY_STRING,hash=Constants.EMPTY_STRING;try{href=popupWindow.location.href,hash=popupWindow.location.hash}catch(e){}StringUtils.isEmpty(href)||"about:blank"===href||(_this.logger.verbose("PopupHandler.monitorPopupForHash - popup window is on same origin as caller"),ticks++,hash?(_this.logger.verbose("PopupHandler.monitorPopupForHash - found hash in url"),clearInterval(intervalId),_this.cleanPopup(popupWindow),UrlString.hashContainsKnownProperties(hash)?(_this.logger.verbose("PopupHandler.monitorPopupForHash - hash contains known properties, returning."),resolve(hash)):(_this.logger.error("PopupHandler.monitorPopupForHash - found hash in url but it does not contain known properties. Check that your router is not changing the hash prematurely."),_this.logger.errorPii("PopupHandler.monitorPopupForHash - hash found: "+hash),reject(BrowserAuthError.createHashDoesNotContainKnownPropertiesError()))):ticks>maxTicks&&(_this.logger.error("PopupHandler.monitorPopupForHash - unable to find hash in url, timing out"),clearInterval(intervalId),reject(BrowserAuthError.createMonitorPopupTimeoutError())))}),_this.config.system.pollIntervalMilliseconds)}))},PopupClient.prototype.waitForLogoutPopup=function(popupWindow){var _this=this;return new Promise((function(resolve){_this.logger.verbose("PopupHandler.waitForLogoutPopup - polling started");var intervalId=setInterval((function(){popupWindow.closed&&(_this.logger.error("PopupHandler.waitForLogoutPopup - window closed"),_this.cleanPopup(),clearInterval(intervalId),resolve());var href=Constants.EMPTY_STRING;try{href=popupWindow.location.href}catch(e){}StringUtils.isEmpty(href)||"about:blank"===href||(_this.logger.verbose("PopupHandler.waitForLogoutPopup - popup window is on same origin as caller, closing."),clearInterval(intervalId),_this.cleanPopup(popupWindow),resolve())}),_this.config.system.pollIntervalMilliseconds)}))},PopupClient.prototype.openPopup=function(urlNavigate,popupParams){try{var popupWindow=void 0;if(popupParams.popup?(popupWindow=popupParams.popup,this.logger.verbosePii("Navigating popup window to: "+urlNavigate),popupWindow.location.assign(urlNavigate)):void 0===popupParams.popup&&(this.logger.verbosePii("Opening popup window to: "+urlNavigate),popupWindow=this.openSizedPopup(urlNavigate,popupParams.popupName,popupParams.popupWindowAttributes)),!popupWindow)throw BrowserAuthError.createEmptyWindowCreatedError();return popupWindow.focus&&popupWindow.focus(),this.currentWindow=popupWindow,window.addEventListener("beforeunload",this.unloadWindow),popupWindow}catch(e){throw this.logger.error("error opening popup "+e.message),this.browserStorage.setInteractionInProgress(!1),BrowserAuthError.createPopupWindowError(e.toString())}},PopupClient.prototype.openSizedPopup=function(urlNavigate,popupName,popupWindowAttributes){var _a,_b,_c,_d,winLeft=window.screenLeft?window.screenLeft:window.screenX,winTop=window.screenTop?window.screenTop:window.screenY,winWidth=window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth,winHeight=window.innerHeight||document.documentElement.clientHeight||document.body.clientHeight,width=null===(_a=popupWindowAttributes.popupSize)||void 0===_a?void 0:_a.width,height=null===(_b=popupWindowAttributes.popupSize)||void 0===_b?void 0:_b.height,top=null===(_c=popupWindowAttributes.popupPosition)||void 0===_c?void 0:_c.top,left=null===(_d=popupWindowAttributes.popupPosition)||void 0===_d?void 0:_d.left;return(!width||width<0||width>winWidth)&&(this.logger.verbose("Default popup window width used. Window width not configured or invalid."),width=BrowserConstants.POPUP_WIDTH),(!height||height<0||height>winHeight)&&(this.logger.verbose("Default popup window height used. Window height not configured or invalid."),height=BrowserConstants.POPUP_HEIGHT),(!top||top<0||top>winHeight)&&(this.logger.verbose("Default popup window top position used. Window top not configured or invalid."),top=Math.max(0,winHeight/2-BrowserConstants.POPUP_HEIGHT/2+winTop)),(!left||left<0||left>winWidth)&&(this.logger.verbose("Default popup window left position used. Window left not configured or invalid."),left=Math.max(0,winWidth/2-BrowserConstants.POPUP_WIDTH/2+winLeft)),window.open(urlNavigate,popupName,"width="+width+", height="+height+", top="+top+", left="+left+", scrollbars=yes")},PopupClient.prototype.unloadWindow=function(e){this.browserStorage.cleanRequestByInteractionType(InteractionType.Popup),this.currentWindow&&this.currentWindow.close(),e.preventDefault()},PopupClient.prototype.cleanPopup=function(popupWindow){popupWindow&&popupWindow.close(),window.removeEventListener("beforeunload",this.unloadWindow),this.browserStorage.setInteractionInProgress(!1)},PopupClient.prototype.generatePopupName=function(scopes,authority){return BrowserConstants.POPUP_NAME_PREFIX+"."+this.config.auth.clientId+"."+scopes.join("-")+"."+authority+"."+this.correlationId},PopupClient.prototype.generateLogoutPopupName=function(request){var homeAccountId=request.account&&request.account.homeAccountId;return BrowserConstants.POPUP_NAME_PREFIX+"."+this.config.auth.clientId+"."+homeAccountId+"."+this.correlationId},PopupClient}(StandardInteractionClient);export{PopupClient};