/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{UrlString,AuthError,PerformanceEvents,Constants,ThrottlingUtils,ProtocolUtils}from"@azure/msal-common";import{StandardInteractionClient}from"./StandardInteractionClient.js";import{TemporaryCacheKeys,ApiId,InteractionType}from"../utils/BrowserConstants.js";import{RedirectHandler}from"../interaction_handler/RedirectHandler.js";import{BrowserUtils}from"../utils/BrowserUtils.js";import{EventType}from"../event/EventType.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";import{NativeInteractionClient}from"./NativeInteractionClient.js";import{NativeMessageHandler}from"../broker/nativeBroker/NativeMessageHandler.js";var RedirectClient=function(_super){function RedirectClient(config,storageImpl,browserCrypto,logger,eventHandler,navigationClient,performanceClient,nativeStorageImpl,nativeMessageHandler,correlationId){var _this=_super.call(this,config,storageImpl,browserCrypto,logger,eventHandler,navigationClient,performanceClient,nativeMessageHandler,correlationId)||this;return _this.nativeStorage=nativeStorageImpl,_this}return __extends(RedirectClient,_super),RedirectClient.prototype.acquireToken=function(request){return __awaiter(this,void 0,void 0,(function(){var validRequest,serverTelemetryManager,handleBackButton,authCodeRequest,authClient,interactionHandler,navigateUrl,redirectStartPage,e_1,_this=this;return __generator(this,(function(_a){switch(_a.label){case 0:return this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest,request.correlationId),[4,this.initializeAuthorizationRequest(request,InteractionType.Redirect)];case 1:validRequest=_a.sent(),this.browserStorage.updateCacheEntries(validRequest.state,validRequest.nonce,validRequest.authority,validRequest.loginHint||Constants.EMPTY_STRING,validRequest.account||null),serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenRedirect),handleBackButton=function(event){event.persisted&&(_this.logger.verbose("Page was restored from back/forward cache. Clearing temporary cache."),_this.browserStorage.cleanRequestByState(validRequest.state),_this.eventHandler.emitEvent(EventType.RESTORE_FROM_BFCACHE,InteractionType.Redirect))},_a.label=2;case 2:return _a.trys.push([2,7,,8]),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationCodeRequest,request.correlationId),[4,this.initializeAuthorizationCodeRequest(validRequest)];case 3:return authCodeRequest=_a.sent(),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient,request.correlationId),[4,this.createAuthCodeClient(serverTelemetryManager,validRequest.authority,validRequest.azureCloudOptions)];case 4:return authClient=_a.sent(),this.logger.verbose("Auth code client created"),interactionHandler=new RedirectHandler(authClient,this.browserStorage,authCodeRequest,this.logger,this.browserCrypto,this.performanceClient),[4,authClient.getAuthCodeUrl(__assign(__assign({},validRequest),{nativeBroker:NativeMessageHandler.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,request.authenticationScheme)}))];case 5:return navigateUrl=_a.sent(),redirectStartPage=this.getRedirectStartPage(request.redirectStartPage),this.logger.verbosePii("Redirect start page: "+redirectStartPage),window.addEventListener("pageshow",handleBackButton),[4,interactionHandler.initiateAuthRequest(navigateUrl,{navigationClient:this.navigationClient,redirectTimeout:this.config.system.redirectNavigationTimeout,redirectStartPage:redirectStartPage,onRedirectNavigate:request.onRedirectNavigate})];case 6:return[2,_a.sent()];case 7:throw(e_1=_a.sent())instanceof AuthError&&e_1.setCorrelationId(this.correlationId),window.removeEventListener("pageshow",handleBackButton),serverTelemetryManager.cacheFailedRequest(e_1),this.browserStorage.cleanRequestByState(validRequest.state),e_1;case 8:return[2]}}))}))},RedirectClient.prototype.handleRedirectPromise=function(hash){return __awaiter(this,void 0,void 0,(function(){var serverTelemetryManager,responseHash,state,serverParams,loginRequestUrl,loginRequestUrlNormalized,currentUrlNormalized,handleHashResult,navigationOptions,processHashOnRedirect,homepage,e_2;return __generator(this,(function(_a){switch(_a.label){case 0:serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.handleRedirectPromise),_a.label=1;case 1:if(_a.trys.push([1,10,,11]),!this.browserStorage.isInteractionInProgress(!0))return this.logger.info("handleRedirectPromise called but there is no interaction in progress, returning null."),[2,null];if(!(responseHash=this.getRedirectResponseHash(hash||window.location.hash)))return this.logger.info("handleRedirectPromise did not detect a response hash as a result of a redirect. Cleaning temporary cache."),this.browserStorage.cleanRequestByInteractionType(InteractionType.Redirect),[2,null];state=void 0;try{serverParams=UrlString.getDeserializedHash(responseHash),state=this.validateAndExtractStateFromHash(serverParams,InteractionType.Redirect),this.logger.verbose("State extracted from hash")}catch(e){return this.logger.info("handleRedirectPromise was unable to extract state due to: "+e),this.browserStorage.cleanRequestByInteractionType(InteractionType.Redirect),[2,null]}return loginRequestUrl=this.browserStorage.getTemporaryCache(TemporaryCacheKeys.ORIGIN_URI,!0)||Constants.EMPTY_STRING,loginRequestUrlNormalized=UrlString.removeHashFromUrl(loginRequestUrl),currentUrlNormalized=UrlString.removeHashFromUrl(window.location.href),loginRequestUrlNormalized===currentUrlNormalized&&this.config.auth.navigateToLoginRequestUrl?(this.logger.verbose("Current page is loginRequestUrl, handling hash"),[4,this.handleHash(responseHash,state,serverTelemetryManager)]):[3,3];case 2:return handleHashResult=_a.sent(),loginRequestUrl.indexOf("#")>-1&&BrowserUtils.replaceHash(loginRequestUrl),[2,handleHashResult];case 3:return this.config.auth.navigateToLoginRequestUrl?[3,4]:(this.logger.verbose("NavigateToLoginRequestUrl set to false, handling hash"),[2,this.handleHash(responseHash,state,serverTelemetryManager)]);case 4:return BrowserUtils.isInIframe()&&!this.config.system.allowRedirectInIframe?[3,9]:(this.browserStorage.setTemporaryCache(TemporaryCacheKeys.URL_HASH,responseHash,!0),navigationOptions={apiId:ApiId.handleRedirectPromise,timeout:this.config.system.redirectNavigationTimeout,noHistory:!0},processHashOnRedirect=!0,loginRequestUrl&&"null"!==loginRequestUrl?[3,6]:(homepage=BrowserUtils.getHomepage(),this.browserStorage.setTemporaryCache(TemporaryCacheKeys.ORIGIN_URI,homepage,!0),this.logger.warning("Unable to get valid login request url from cache, redirecting to home page"),[4,this.navigationClient.navigateInternal(homepage,navigationOptions)]));case 5:return processHashOnRedirect=_a.sent(),[3,8];case 6:return this.logger.verbose("Navigating to loginRequestUrl: "+loginRequestUrl),[4,this.navigationClient.navigateInternal(loginRequestUrl,navigationOptions)];case 7:processHashOnRedirect=_a.sent(),_a.label=8;case 8:if(!processHashOnRedirect)return[2,this.handleHash(responseHash,state,serverTelemetryManager)];_a.label=9;case 9:return[2,null];case 10:throw(e_2=_a.sent())instanceof AuthError&&e_2.setCorrelationId(this.correlationId),serverTelemetryManager.cacheFailedRequest(e_2),this.browserStorage.cleanRequestByInteractionType(InteractionType.Redirect),e_2;case 11:return[2]}}))}))},RedirectClient.prototype.getRedirectResponseHash=function(hash){if(this.logger.verbose("getRedirectResponseHash called"),UrlString.hashContainsKnownProperties(hash))return BrowserUtils.clearHash(window),this.logger.verbose("Hash contains known properties, returning response hash"),hash;var cachedHash=this.browserStorage.getTemporaryCache(TemporaryCacheKeys.URL_HASH,!0);return this.browserStorage.removeItem(this.browserStorage.generateCacheKey(TemporaryCacheKeys.URL_HASH)),this.logger.verbose("Hash does not contain known properties, returning cached hash"),cachedHash},RedirectClient.prototype.handleHash=function(hash,state,serverTelemetryManager){return __awaiter(this,void 0,void 0,(function(){var cachedRequest,serverParams,nativeInteractionClient,userRequestState,currentAuthority,authClient,_this=this;return __generator(this,(function(_a){switch(_a.label){case 0:if(cachedRequest=this.browserStorage.getCachedRequest(state,this.browserCrypto),this.logger.verbose("handleHash called, retrieved cached request"),(serverParams=UrlString.getDeserializedHash(hash)).accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),!this.nativeMessageHandler)throw BrowserAuthError.createNativeConnectionNotEstablishedError();return nativeInteractionClient=new NativeInteractionClient(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,ApiId.acquireTokenPopup,this.performanceClient,this.nativeMessageHandler,serverParams.accountId,this.nativeStorage,cachedRequest.correlationId),userRequestState=ProtocolUtils.parseRequestState(this.browserCrypto,state).userRequestState,[2,nativeInteractionClient.acquireToken(__assign(__assign({},cachedRequest),{state:userRequestState,prompt:void 0})).finally((function(){_this.browserStorage.cleanRequestByState(state)}))]}if(!(currentAuthority=this.browserStorage.getCachedAuthority(state)))throw BrowserAuthError.createNoCachedAuthorityError();return this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient,cachedRequest.correlationId),[4,this.createAuthCodeClient(serverTelemetryManager,currentAuthority)];case 1:return authClient=_a.sent(),this.logger.verbose("Auth code client created"),ThrottlingUtils.removeThrottle(this.browserStorage,this.config.auth.clientId,cachedRequest),[4,new RedirectHandler(authClient,this.browserStorage,cachedRequest,this.logger,this.browserCrypto,this.performanceClient).handleCodeResponseFromHash(hash,state,authClient.authority,this.networkClient)];case 2:return[2,_a.sent()]}}))}))},RedirectClient.prototype.logout=function(logoutRequest){return __awaiter(this,void 0,void 0,(function(){var validLogoutRequest,serverTelemetryManager,navigationOptions,authClient,logoutUri,e_3;return __generator(this,(function(_a){switch(_a.label){case 0:this.logger.verbose("logoutRedirect called"),validLogoutRequest=this.initializeLogoutRequest(logoutRequest),serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.logout),_a.label=1;case 1:return _a.trys.push([1,10,,11]),this.eventHandler.emitEvent(EventType.LOGOUT_START,InteractionType.Redirect,logoutRequest),[4,this.clearCacheOnLogout(validLogoutRequest.account)];case 2:return _a.sent(),navigationOptions={apiId:ApiId.logout,timeout:this.config.system.redirectNavigationTimeout,noHistory:!1},this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient,validLogoutRequest.correlationId),[4,this.createAuthCodeClient(serverTelemetryManager,logoutRequest&&logoutRequest.authority)];case 3:return authClient=_a.sent(),this.logger.verbose("Auth code client created"),logoutUri=authClient.getLogoutUri(validLogoutRequest),this.eventHandler.emitEvent(EventType.LOGOUT_SUCCESS,InteractionType.Redirect,validLogoutRequest),logoutRequest&&"function"==typeof logoutRequest.onRedirectNavigate?!1===logoutRequest.onRedirectNavigate(logoutUri)?[3,5]:(this.logger.verbose("Logout onRedirectNavigate did not return false, navigating"),this.browserStorage.getInteractionInProgress()||this.browserStorage.setInteractionInProgress(!0),[4,this.navigationClient.navigateExternal(logoutUri,navigationOptions)]):[3,7];case 4:return _a.sent(),[2];case 5:this.browserStorage.setInteractionInProgress(!1),this.logger.verbose("Logout onRedirectNavigate returned false, stopping navigation"),_a.label=6;case 6:return[3,9];case 7:return this.browserStorage.getInteractionInProgress()||this.browserStorage.setInteractionInProgress(!0),[4,this.navigationClient.navigateExternal(logoutUri,navigationOptions)];case 8:return _a.sent(),[2];case 9:return[3,11];case 10:throw(e_3=_a.sent())instanceof AuthError&&e_3.setCorrelationId(this.correlationId),serverTelemetryManager.cacheFailedRequest(e_3),this.eventHandler.emitEvent(EventType.LOGOUT_FAILURE,InteractionType.Redirect,null,e_3),this.eventHandler.emitEvent(EventType.LOGOUT_END,InteractionType.Redirect),e_3;case 11:return this.eventHandler.emitEvent(EventType.LOGOUT_END,InteractionType.Redirect),[2]}}))}))},RedirectClient.prototype.getRedirectStartPage=function(requestStartPage){var redirectStartPage=requestStartPage||window.location.href;return UrlString.getAbsoluteUrl(redirectStartPage,BrowserUtils.getCurrentUri())},RedirectClient}(StandardInteractionClient);export{RedirectClient};