/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{StandardInteractionClient}from"./StandardInteractionClient.js";import{AuthError,PerformanceEvents,SilentFlowClient}from"@azure/msal-common";import{ApiId}from"../utils/BrowserConstants.js";import{BrowserAuthError,BrowserAuthErrorMessage}from"../error/BrowserAuthError.js";var SilentCacheClient=function(_super){function SilentCacheClient(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(SilentCacheClient,_super),SilentCacheClient.prototype.acquireToken=function(silentRequest){return __awaiter(this,void 0,void 0,(function(){var acquireTokenMeasurement,serverTelemetryManager,silentAuthClient,cachedToken,error_1;return __generator(this,(function(_a){switch(_a.label){case 0:return acquireTokenMeasurement=this.performanceClient.startMeasurement(PerformanceEvents.SilentCacheClientAcquireToken,silentRequest.correlationId),serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenSilent_silentFlow),[4,this.createSilentFlowClient(serverTelemetryManager,silentRequest.authority,silentRequest.azureCloudOptions)];case 1:silentAuthClient=_a.sent(),this.logger.verbose("Silent auth client created"),_a.label=2;case 2:return _a.trys.push([2,4,,5]),[4,silentAuthClient.acquireCachedToken(silentRequest)];case 3:return cachedToken=_a.sent(),acquireTokenMeasurement.endMeasurement({success:!0,fromCache:!0}),[2,cachedToken];case 4:throw(error_1=_a.sent())instanceof BrowserAuthError&&error_1.errorCode===BrowserAuthErrorMessage.signingKeyNotFoundInStorage.code&&this.logger.verbose("Signing keypair for bound access token not found. Refreshing bound access token and generating a new crypto keypair."),acquireTokenMeasurement.endMeasurement({errorCode:error_1 instanceof AuthError&&error_1.errorCode||void 0,subErrorCode:error_1 instanceof AuthError&&error_1.subError||void 0,success:!1}),error_1;case 5:return[2]}}))}))},SilentCacheClient.prototype.logout=function(){return Promise.reject(BrowserAuthError.createSilentLogoutUnsupportedError())},SilentCacheClient.prototype.createSilentFlowClient=function(serverTelemetryManager,authorityUrl,azureCloudOptions){return __awaiter(this,void 0,void 0,(function(){var clientConfig;return __generator(this,(function(_a){switch(_a.label){case 0:return this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientGetClientConfiguration,this.correlationId),[4,this.getClientConfiguration(serverTelemetryManager,authorityUrl,azureCloudOptions)];case 1:return clientConfig=_a.sent(),[2,new SilentFlowClient(clientConfig,this.performanceClient)]}}))}))},SilentCacheClient.prototype.initializeSilentRequest=function(request,account){return __awaiter(this,void 0,void 0,(function(){var _a;return __generator(this,(function(_b){switch(_b.label){case 0:return this.performanceClient.addQueueMeasurement(PerformanceEvents.InitializeSilentRequest,this.correlationId),this.performanceClient.setPreQueueTime(PerformanceEvents.InitializeBaseRequest,this.correlationId),_a=[__assign({},request)],[4,this.initializeBaseRequest(request,account)];case 1:return[2,__assign.apply(void 0,[__assign.apply(void 0,_a.concat([_b.sent()])),{account:account,forceRefresh:request.forceRefresh||!1}])]}}))}))},SilentCacheClient}(StandardInteractionClient);export{SilentCacheClient};