/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{AuthError,PerformanceEvents,Constants,StringUtils,PromptValue,UrlString,ProtocolUtils}from"@azure/msal-common";import{StandardInteractionClient}from"./StandardInteractionClient.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";import{InteractionType}from"../utils/BrowserConstants.js";import{SilentHandler}from"../interaction_handler/SilentHandler.js";import{NativeMessageHandler}from"../broker/nativeBroker/NativeMessageHandler.js";import{NativeInteractionClient}from"./NativeInteractionClient.js";var SilentIframeClient=function(_super){function SilentIframeClient(config,storageImpl,browserCrypto,logger,eventHandler,navigationClient,apiId,performanceClient,nativeStorageImpl,nativeMessageHandler,correlationId){var _this=_super.call(this,config,storageImpl,browserCrypto,logger,eventHandler,navigationClient,performanceClient,nativeMessageHandler,correlationId)||this;return _this.apiId=apiId,_this.nativeStorage=nativeStorageImpl,_this}return __extends(SilentIframeClient,_super),SilentIframeClient.prototype.acquireToken=function(request){return __awaiter(this,void 0,void 0,(function(){var acquireTokenMeasurement,silentRequest,serverTelemetryManager,authClient,e_1;return __generator(this,(function(_a){switch(_a.label){case 0:if(this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentIframeClientAcquireToken,request.correlationId),this.logger.verbose("acquireTokenByIframe called"),acquireTokenMeasurement=this.performanceClient.startMeasurement(PerformanceEvents.SilentIframeClientAcquireToken,request.correlationId),StringUtils.isEmpty(request.loginHint)&&StringUtils.isEmpty(request.sid)&&(!request.account||StringUtils.isEmpty(request.account.username))&&this.logger.warning("No user hint provided. The authorization server may need more information to complete this request."),request.prompt&&request.prompt!==PromptValue.NONE&&request.prompt!==PromptValue.NO_SESSION)throw acquireTokenMeasurement.endMeasurement({success:!1}),BrowserAuthError.createSilentPromptValueError(request.prompt);return this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest,request.correlationId),[4,this.initializeAuthorizationRequest(__assign(__assign({},request),{prompt:request.prompt||PromptValue.NONE}),InteractionType.Silent)];case 1:silentRequest=_a.sent(),this.browserStorage.updateCacheEntries(silentRequest.state,silentRequest.nonce,silentRequest.authority,silentRequest.loginHint||Constants.EMPTY_STRING,silentRequest.account||null),serverTelemetryManager=this.initializeServerTelemetryManager(this.apiId),_a.label=2;case 2:return _a.trys.push([2,5,,6]),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientCreateAuthCodeClient,request.correlationId),[4,this.createAuthCodeClient(serverTelemetryManager,silentRequest.authority,silentRequest.azureCloudOptions)];case 3:return authClient=_a.sent(),this.logger.verbose("Auth code client created"),this.performanceClient.setPreQueueTime(PerformanceEvents.SilentIframeClientTokenHelper,request.correlationId),[4,this.silentTokenHelper(authClient,silentRequest).then((function(result){return acquireTokenMeasurement.endMeasurement({success:!0,fromCache:!1,requestId:result.requestId}),result}))];case 4:return[2,_a.sent()];case 5:throw(e_1=_a.sent())instanceof AuthError&&e_1.setCorrelationId(this.correlationId),serverTelemetryManager.cacheFailedRequest(e_1),this.browserStorage.cleanRequestByState(silentRequest.state),acquireTokenMeasurement.endMeasurement({errorCode:e_1 instanceof AuthError&&e_1.errorCode||void 0,subErrorCode:e_1 instanceof AuthError&&e_1.subError||void 0,success:!1}),e_1;case 6:return[2]}}))}))},SilentIframeClient.prototype.logout=function(){return Promise.reject(BrowserAuthError.createSilentLogoutUnsupportedError())},SilentIframeClient.prototype.silentTokenHelper=function(authClient,silentRequest){return __awaiter(this,void 0,void 0,(function(){var authCodeRequest,navigateUrl,silentHandler,msalFrame,hash,serverParams,state,nativeInteractionClient,userRequestState,_this=this;return __generator(this,(function(_a){switch(_a.label){case 0:return this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentIframeClientTokenHelper,silentRequest.correlationId),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationCodeRequest,silentRequest.correlationId),[4,this.initializeAuthorizationCodeRequest(silentRequest)];case 1:return authCodeRequest=_a.sent(),this.performanceClient.setPreQueueTime(PerformanceEvents.GetAuthCodeUrl,silentRequest.correlationId),[4,authClient.getAuthCodeUrl(__assign(__assign({},silentRequest),{nativeBroker:NativeMessageHandler.isNativeAvailable(this.config,this.logger,this.nativeMessageHandler,silentRequest.authenticationScheme)}))];case 2:return navigateUrl=_a.sent(),silentHandler=new SilentHandler(authClient,this.browserStorage,authCodeRequest,this.logger,this.config.system,this.performanceClient),this.performanceClient.setPreQueueTime(PerformanceEvents.SilentHandlerInitiateAuthRequest,silentRequest.correlationId),[4,silentHandler.initiateAuthRequest(navigateUrl)];case 3:return msalFrame=_a.sent(),this.performanceClient.setPreQueueTime(PerformanceEvents.SilentHandlerMonitorIframeForHash,silentRequest.correlationId),[4,silentHandler.monitorIframeForHash(msalFrame,this.config.system.iframeHashTimeout)];case 4:if(hash=_a.sent(),serverParams=UrlString.getDeserializedHash(hash),state=this.validateAndExtractStateFromHash(serverParams,InteractionType.Silent,authCodeRequest.correlationId),serverParams.accountId){if(this.logger.verbose("Account id found in hash, calling WAM for token"),!this.nativeMessageHandler)throw BrowserAuthError.createNativeConnectionNotEstablishedError();return nativeInteractionClient=new NativeInteractionClient(this.config,this.browserStorage,this.browserCrypto,this.logger,this.eventHandler,this.navigationClient,this.apiId,this.performanceClient,this.nativeMessageHandler,serverParams.accountId,this.browserStorage,this.correlationId),userRequestState=ProtocolUtils.parseRequestState(this.browserCrypto,state).userRequestState,[2,nativeInteractionClient.acquireToken(__assign(__assign({},silentRequest),{state:userRequestState,prompt:silentRequest.prompt||PromptValue.NONE})).finally((function(){_this.browserStorage.cleanRequestByState(state)}))]}return this.performanceClient.setPreQueueTime(PerformanceEvents.HandleCodeResponseFromHash,silentRequest.correlationId),[2,silentHandler.handleCodeResponseFromHash(hash,state,authClient.authority,this.networkClient)]}}))}))},SilentIframeClient}(StandardInteractionClient);export{SilentIframeClient};