/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{StandardInteractionClient}from"./StandardInteractionClient.js";import{PerformanceEvents,AuthError,RefreshTokenClient}from"@azure/msal-common";import{ApiId}from"../utils/BrowserConstants.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";var SilentRefreshClient=function(_super){function SilentRefreshClient(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(SilentRefreshClient,_super),SilentRefreshClient.prototype.acquireToken=function(request){return __awaiter(this,void 0,void 0,(function(){var silentRequest,_a,acquireTokenMeasurement,serverTelemetryManager,refreshTokenClient,_this=this;return __generator(this,(function(_b){switch(_b.label){case 0:return this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentRefreshClientAcquireToken,request.correlationId),this.performanceClient.setPreQueueTime(PerformanceEvents.InitializeBaseRequest,request.correlationId),_a=[__assign({},request)],[4,this.initializeBaseRequest(request,request.account)];case 1:return silentRequest=__assign.apply(void 0,_a.concat([_b.sent()])),acquireTokenMeasurement=this.performanceClient.startMeasurement(PerformanceEvents.SilentRefreshClientAcquireToken,silentRequest.correlationId),serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenSilent_silentFlow),[4,this.createRefreshTokenClient(serverTelemetryManager,silentRequest.authority,silentRequest.azureCloudOptions)];case 2:return refreshTokenClient=_b.sent(),this.logger.verbose("Refresh token client created"),this.performanceClient.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireTokenByRefreshToken,request.correlationId),[2,refreshTokenClient.acquireTokenByRefreshToken(silentRequest).then((function(result){return acquireTokenMeasurement.endMeasurement({success:!0,fromCache:result.fromCache,requestId:result.requestId}),result})).catch((function(e){throw e instanceof AuthError&&e.setCorrelationId(_this.correlationId),serverTelemetryManager.cacheFailedRequest(e),acquireTokenMeasurement.endMeasurement({errorCode:e.errorCode,subErrorCode:e.subError,success:!1}),e}))]}}))}))},SilentRefreshClient.prototype.logout=function(){return Promise.reject(BrowserAuthError.createSilentLogoutUnsupportedError())},SilentRefreshClient.prototype.createRefreshTokenClient=function(serverTelemetryManager,authorityUrl,azureCloudOptions){return __awaiter(this,void 0,void 0,(function(){var clientConfig;return __generator(this,(function(_a){switch(_a.label){case 0:return this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientGetClientConfiguration,this.correlationId),[4,this.getClientConfiguration(serverTelemetryManager,authorityUrl,azureCloudOptions)];case 1:return clientConfig=_a.sent(),[2,new RefreshTokenClient(clientConfig,this.performanceClient)]}}))}))},SilentRefreshClient}(StandardInteractionClient);export{SilentRefreshClient};