/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__assign}from"../_virtual/_tslib.js";import{PerformanceClient}from"@azure/msal-common";import{BrowserCrypto}from"../crypto/BrowserCrypto.js";import{GuidGenerator}from"../crypto/GuidGenerator.js";import{BrowserPerformanceMeasurement}from"./BrowserPerformanceMeasurement.js";var BrowserPerformanceClient=function(_super){function BrowserPerformanceClient(clientId,authority,logger,libraryName,libraryVersion,applicationTelemetry,cryptoOptions){var _this=_super.call(this,clientId,authority,logger,libraryName,libraryVersion,applicationTelemetry)||this;return _this.browserCrypto=new BrowserCrypto(_this.logger,cryptoOptions),_this.guidGenerator=new GuidGenerator(_this.browserCrypto),_this}return __extends(BrowserPerformanceClient,_super),BrowserPerformanceClient.prototype.startPerformanceMeasuremeant=function(measureName,correlationId){return new BrowserPerformanceMeasurement(measureName,correlationId)},BrowserPerformanceClient.prototype.generateId=function(){return this.guidGenerator.generateGuid()},BrowserPerformanceClient.prototype.getPageVisibility=function(){var _a;return(null===(_a=document.visibilityState)||void 0===_a?void 0:_a.toString())||null},BrowserPerformanceClient.prototype.deleteIncompleteSubMeasurements=function(inProgressEvent){var rootEvent=this.eventsByCorrelationId.get(inProgressEvent.event.correlationId),isRootEvent=rootEvent&&rootEvent.eventId===inProgressEvent.event.eventId,incompleteMeasurements=[];isRootEvent&&(null==rootEvent?void 0:rootEvent.incompleteSubMeasurements)&&rootEvent.incompleteSubMeasurements.forEach((function(subMeasurement){incompleteMeasurements.push(__assign({},subMeasurement))})),incompleteMeasurements.length>0&&BrowserPerformanceMeasurement.flushMeasurements(inProgressEvent.event.correlationId,incompleteMeasurements)},BrowserPerformanceClient.prototype.supportsBrowserPerformanceNow=function(){return"undefined"!=typeof window&&void 0!==window.performance&&"function"==typeof window.performance.now},BrowserPerformanceClient.prototype.startMeasurement=function(measureName,correlationId){var _this=this,startPageVisibility=this.getPageVisibility(),inProgressEvent=_super.prototype.startMeasurement.call(this,measureName,correlationId);return __assign(__assign({},inProgressEvent),{endMeasurement:function(event){var res=inProgressEvent.endMeasurement(__assign({startPageVisibility:startPageVisibility,endPageVisibility:_this.getPageVisibility()},event));return _this.deleteIncompleteSubMeasurements(inProgressEvent),res},discardMeasurement:function(){inProgressEvent.discardMeasurement(),_this.deleteIncompleteSubMeasurements(inProgressEvent),inProgressEvent.measurement.flushMeasurement()}})},BrowserPerformanceClient.prototype.setPreQueueTime=function(eventName,correlationId){if(this.supportsBrowserPerformanceNow())if(correlationId){var preQueueEvent=this.preQueueTimeByCorrelationId.get(correlationId);preQueueEvent&&(this.logger.trace("BrowserPerformanceClient: Incomplete pre-queue "+preQueueEvent.name+" found",correlationId),this.addQueueMeasurement(preQueueEvent.name,correlationId,void 0,!0)),this.preQueueTimeByCorrelationId.set(correlationId,{name:eventName,time:window.performance.now()})}else this.logger.trace("BrowserPerformanceClient: correlationId for "+eventName+" not provided, unable to set telemetry queue time");else this.logger.trace("BrowserPerformanceClient: window performance API not available, unable to set telemetry queue time for "+eventName)},BrowserPerformanceClient.prototype.addQueueMeasurement=function(eventName,correlationId,queueTime,manuallyCompleted){if(this.supportsBrowserPerformanceNow())if(correlationId){var preQueueTime=_super.prototype.getPreQueueTime.call(this,eventName,correlationId);if(preQueueTime){var currentTime=window.performance.now(),resQueueTime=queueTime||_super.prototype.calculateQueuedTime.call(this,preQueueTime,currentTime);return _super.prototype.addQueueMeasurement.call(this,eventName,correlationId,resQueueTime,manuallyCompleted)}}else this.logger.trace("BrowserPerformanceClient: correlationId for "+eventName+" not provided, unable to add queue measurement");else this.logger.trace("BrowserPerformanceClient: window performance API not available, unable to add queue measurement for "+eventName)},BrowserPerformanceClient}(PerformanceClient);export{BrowserPerformanceClient};