/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{CredentialType,CacheType,Separators,Constants,AuthenticationScheme}from"../../utils/Constants.js";import{ClientAuthError}from"../../error/ClientAuthError.js";var CredentialEntity=function(){function CredentialEntity(){}return CredentialEntity.prototype.generateAccountId=function(){return CredentialEntity.generateAccountIdForCacheKey(this.homeAccountId,this.environment)},CredentialEntity.prototype.generateCredentialId=function(){return CredentialEntity.generateCredentialIdForCacheKey(this.credentialType,this.clientId,this.realm,this.familyId)},CredentialEntity.prototype.generateTarget=function(){return CredentialEntity.generateTargetForCacheKey(this.target)},CredentialEntity.prototype.generateCredentialKey=function(){return CredentialEntity.generateCredentialCacheKey(this.homeAccountId,this.environment,this.credentialType,this.clientId,this.realm,this.target,this.familyId,this.tokenType,this.requestedClaimsHash)},CredentialEntity.prototype.generateType=function(){switch(this.credentialType){case CredentialType.ID_TOKEN:return CacheType.ID_TOKEN;case CredentialType.ACCESS_TOKEN:case CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME:return CacheType.ACCESS_TOKEN;case CredentialType.REFRESH_TOKEN:return CacheType.REFRESH_TOKEN;default:throw ClientAuthError.createUnexpectedCredentialTypeError()}},CredentialEntity.generateCredentialCacheKey=function(homeAccountId,environment,credentialType,clientId,realm,target,familyId,tokenType,requestedClaimsHash){return[this.generateAccountIdForCacheKey(homeAccountId,environment),this.generateCredentialIdForCacheKey(credentialType,clientId,realm,familyId),this.generateTargetForCacheKey(target),this.generateClaimsHashForCacheKey(requestedClaimsHash),this.generateSchemeForCacheKey(tokenType)].join(Separators.CACHE_KEY_SEPARATOR).toLowerCase()},CredentialEntity.generateAccountIdForCacheKey=function(homeAccountId,environment){return[homeAccountId,environment].join(Separators.CACHE_KEY_SEPARATOR).toLowerCase()},CredentialEntity.generateCredentialIdForCacheKey=function(credentialType,clientId,realm,familyId){return[credentialType,credentialType===CredentialType.REFRESH_TOKEN&&familyId||clientId,realm||Constants.EMPTY_STRING].join(Separators.CACHE_KEY_SEPARATOR).toLowerCase()},CredentialEntity.generateTargetForCacheKey=function(scopes){return(scopes||Constants.EMPTY_STRING).toLowerCase()},CredentialEntity.generateClaimsHashForCacheKey=function(requestedClaimsHash){return(requestedClaimsHash||Constants.EMPTY_STRING).toLowerCase()},CredentialEntity.generateSchemeForCacheKey=function(tokenType){return tokenType&&tokenType.toLowerCase()!==AuthenticationScheme.BEARER.toLowerCase()?tokenType.toLowerCase():Constants.EMPTY_STRING},CredentialEntity}();export{CredentialEntity};