/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{BaseClient}from"./BaseClient.js";import{RequestParameterBuilder}from"../request/RequestParameterBuilder.js";import{AuthenticationScheme,GrantType,HeaderNames,Errors}from"../utils/Constants.js";import{ResponseHandler}from"../response/ResponseHandler.js";import{PopTokenGenerator}from"../crypto/PopTokenGenerator.js";import{StringUtils}from"../utils/StringUtils.js";import{ClientConfigurationError}from"../error/ClientConfigurationError.js";import{ClientAuthError}from"../error/ClientAuthError.js";import{ServerError}from"../error/ServerError.js";import{TimeUtils}from"../utils/TimeUtils.js";import{UrlString}from"../url/UrlString.js";import{CcsCredentialType}from"../account/CcsCredential.js";import{buildClientInfoFromHomeAccountId}from"../account/ClientInfo.js";import{InteractionRequiredAuthError,InteractionRequiredAuthErrorMessage}from"../error/InteractionRequiredAuthError.js";import{PerformanceEvents}from"../telemetry/performance/PerformanceEvent.js";var RefreshTokenClient=function(_super){function RefreshTokenClient(configuration,performanceClient){return _super.call(this,configuration,performanceClient)||this}return __extends(RefreshTokenClient,_super),RefreshTokenClient.prototype.acquireToken=function(request){var _a,_b,_c,_d,_e,_f,_g;return __awaiter(this,void 0,void 0,(function(){var atsMeasurement,reqTimestamp,response,httpVerToken,requestId,responseHandler,_this=this;return __generator(this,(function(_h){switch(_h.label){case 0:return null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientAcquireToken,request.correlationId),atsMeasurement=null===(_b=this.performanceClient)||void 0===_b?void 0:_b.startMeasurement(PerformanceEvents.RefreshTokenClientAcquireToken,request.correlationId),this.logger.verbose("RefreshTokenClientAcquireToken called",request.correlationId),reqTimestamp=TimeUtils.nowSeconds(),null===(_c=this.performanceClient)||void 0===_c||_c.setPreQueueTime(PerformanceEvents.RefreshTokenClientExecuteTokenRequest,request.correlationId),[4,this.executeTokenRequest(request,this.authority)];case 1:return response=_h.sent(),httpVerToken=null===(_d=response.headers)||void 0===_d?void 0:_d[HeaderNames.X_MS_HTTP_VERSION],null==atsMeasurement||atsMeasurement.addStaticFields({refreshTokenSize:(null===(_e=response.body.refresh_token)||void 0===_e?void 0:_e.length)||0}),httpVerToken&&(null==atsMeasurement||atsMeasurement.addStaticFields({httpVerToken:httpVerToken})),requestId=null===(_f=response.headers)||void 0===_f?void 0:_f[HeaderNames.X_MS_REQUEST_ID],(responseHandler=new ResponseHandler(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin)).validateTokenResponse(response.body),null===(_g=this.performanceClient)||void 0===_g||_g.setPreQueueTime(PerformanceEvents.HandleServerTokenResponse,request.correlationId),[2,responseHandler.handleServerTokenResponse(response.body,this.authority,reqTimestamp,request,void 0,void 0,!0,request.forceCache,requestId).then((function(result){return null==atsMeasurement||atsMeasurement.endMeasurement({success:!0}),result})).catch((function(error){throw _this.logger.verbose("Error in fetching refresh token",request.correlationId),null==atsMeasurement||atsMeasurement.endMeasurement({errorCode:error.errorCode,subErrorCode:error.subError,success:!1}),error}))]}}))}))},RefreshTokenClient.prototype.acquireTokenByRefreshToken=function(request){var _a,_b,_c,_d;return __awaiter(this,void 0,void 0,(function(){var noFamilyRTInCache,clientMismatchErrorWithFamilyRT;return __generator(this,(function(_e){if(!request)throw ClientConfigurationError.createEmptyTokenRequestError();if(null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientAcquireTokenByRefreshToken,request.correlationId),!request.account)throw ClientAuthError.createNoAccountInSilentRequestError();if(this.cacheManager.isAppMetadataFOCI(request.account.environment))try{return null===(_b=this.performanceClient)||void 0===_b||_b.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken,request.correlationId),[2,this.acquireTokenWithCachedRefreshToken(request,!0)]}catch(e){if(noFamilyRTInCache=e instanceof InteractionRequiredAuthError&&e.errorCode===InteractionRequiredAuthErrorMessage.noTokensFoundError.code,clientMismatchErrorWithFamilyRT=e instanceof ServerError&&e.errorCode===Errors.INVALID_GRANT_ERROR&&e.subError===Errors.CLIENT_MISMATCH_ERROR,noFamilyRTInCache||clientMismatchErrorWithFamilyRT)return null===(_c=this.performanceClient)||void 0===_c||_c.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken,request.correlationId),[2,this.acquireTokenWithCachedRefreshToken(request,!1)];throw e}return null===(_d=this.performanceClient)||void 0===_d||_d.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken,request.correlationId),[2,this.acquireTokenWithCachedRefreshToken(request,!1)]}))}))},RefreshTokenClient.prototype.acquireTokenWithCachedRefreshToken=function(request,foci){var _a,_b,_c;return __awaiter(this,void 0,void 0,(function(){var atsMeasurement,refreshToken,refreshTokenRequest;return __generator(this,(function(_d){if(null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken,request.correlationId),atsMeasurement=null===(_b=this.performanceClient)||void 0===_b?void 0:_b.startMeasurement(PerformanceEvents.RefreshTokenClientAcquireTokenWithCachedRefreshToken,request.correlationId),this.logger.verbose("RefreshTokenClientAcquireTokenWithCachedRefreshToken called",request.correlationId),!(refreshToken=this.cacheManager.getRefreshToken(request.account,foci)))throw null==atsMeasurement||atsMeasurement.discardMeasurement(),InteractionRequiredAuthError.createNoTokensFoundError();return null==atsMeasurement||atsMeasurement.endMeasurement({success:!0}),refreshTokenRequest=__assign(__assign({},request),{refreshToken:refreshToken.secret,authenticationScheme:request.authenticationScheme||AuthenticationScheme.BEARER,ccsCredential:{credential:request.account.homeAccountId,type:CcsCredentialType.HOME_ACCOUNT_ID}}),null===(_c=this.performanceClient)||void 0===_c||_c.setPreQueueTime(PerformanceEvents.RefreshTokenClientAcquireToken,request.correlationId),[2,this.acquireToken(refreshTokenRequest)]}))}))},RefreshTokenClient.prototype.executeTokenRequest=function(request,authority){var _a,_b,_c;return __awaiter(this,void 0,void 0,(function(){var acquireTokenMeasurement,queryParametersString,endpoint,requestBody,headers,thumbprint;return __generator(this,(function(_d){switch(_d.label){case 0:return null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientExecuteTokenRequest,request.correlationId),acquireTokenMeasurement=null===(_b=this.performanceClient)||void 0===_b?void 0:_b.startMeasurement(PerformanceEvents.RefreshTokenClientExecuteTokenRequest,request.correlationId),null===(_c=this.performanceClient)||void 0===_c||_c.setPreQueueTime(PerformanceEvents.RefreshTokenClientCreateTokenRequestBody,request.correlationId),queryParametersString=this.createTokenQueryParameters(request),endpoint=UrlString.appendQueryString(authority.tokenEndpoint,queryParametersString),[4,this.createTokenRequestBody(request)];case 1:return requestBody=_d.sent(),headers=this.createTokenRequestHeaders(request.ccsCredential),thumbprint={clientId:this.config.authOptions.clientId,authority:authority.canonicalAuthority,scopes:request.scopes,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},[2,this.executePostToTokenEndpoint(endpoint,requestBody,headers,thumbprint).then((function(result){return null==acquireTokenMeasurement||acquireTokenMeasurement.endMeasurement({success:!0}),result})).catch((function(error){throw null==acquireTokenMeasurement||acquireTokenMeasurement.endMeasurement({success:!1}),error}))]}}))}))},RefreshTokenClient.prototype.createTokenRequestBody=function(request){var _a,_b,_c;return __awaiter(this,void 0,void 0,(function(){var correlationId,acquireTokenMeasurement,parameterBuilder,clientAssertion,popTokenGenerator,reqCnfData,clientInfo;return __generator(this,(function(_d){switch(_d.label){case 0:return null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.RefreshTokenClientCreateTokenRequestBody,request.correlationId),correlationId=request.correlationId,acquireTokenMeasurement=null===(_b=this.performanceClient)||void 0===_b?void 0:_b.startMeasurement(PerformanceEvents.BaseClientCreateTokenRequestHeaders,correlationId),(parameterBuilder=new RequestParameterBuilder).addClientId(this.config.authOptions.clientId),parameterBuilder.addScopes(request.scopes),parameterBuilder.addGrantType(GrantType.REFRESH_TOKEN_GRANT),parameterBuilder.addClientInfo(),parameterBuilder.addLibraryInfo(this.config.libraryInfo),parameterBuilder.addApplicationTelemetry(this.config.telemetry.application),parameterBuilder.addThrottling(),this.serverTelemetryManager&&parameterBuilder.addServerTelemetry(this.serverTelemetryManager),parameterBuilder.addCorrelationId(correlationId),parameterBuilder.addRefreshToken(request.refreshToken),this.config.clientCredentials.clientSecret&&parameterBuilder.addClientSecret(this.config.clientCredentials.clientSecret),this.config.clientCredentials.clientAssertion&&(clientAssertion=this.config.clientCredentials.clientAssertion,parameterBuilder.addClientAssertion(clientAssertion.assertion),parameterBuilder.addClientAssertionType(clientAssertion.assertionType)),request.authenticationScheme!==AuthenticationScheme.POP?[3,2]:(popTokenGenerator=new PopTokenGenerator(this.cryptoUtils,this.performanceClient),null===(_c=this.performanceClient)||void 0===_c||_c.setPreQueueTime(PerformanceEvents.PopTokenGenerateCnf,request.correlationId),[4,popTokenGenerator.generateCnf(request)]);case 1:return reqCnfData=_d.sent(),parameterBuilder.addPopToken(reqCnfData.reqCnfString),[3,3];case 2:if(request.authenticationScheme===AuthenticationScheme.SSH){if(!request.sshJwk)throw null==acquireTokenMeasurement||acquireTokenMeasurement.endMeasurement({success:!1}),ClientConfigurationError.createMissingSshJwkError();parameterBuilder.addSshJwk(request.sshJwk)}_d.label=3;case 3:if((!StringUtils.isEmptyObj(request.claims)||this.config.authOptions.clientCapabilities&&this.config.authOptions.clientCapabilities.length>0)&&parameterBuilder.addClaims(request.claims,this.config.authOptions.clientCapabilities),this.config.systemOptions.preventCorsPreflight&&request.ccsCredential)switch(request.ccsCredential.type){case CcsCredentialType.HOME_ACCOUNT_ID:try{clientInfo=buildClientInfoFromHomeAccountId(request.ccsCredential.credential),parameterBuilder.addCcsOid(clientInfo)}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case CcsCredentialType.UPN:parameterBuilder.addCcsUpn(request.ccsCredential.credential)}return null==acquireTokenMeasurement||acquireTokenMeasurement.endMeasurement({success:!0}),[2,parameterBuilder.createQueryString()]}}))}))},RefreshTokenClient}(BaseClient);export{RefreshTokenClient};