/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{__assign}from"../../_virtual/_tslib.js";import{IntFields,PerformanceEventStatus}from"./PerformanceEvent.js";var PerformanceClient=function(){function PerformanceClient(clientId,authority,logger,libraryName,libraryVersion,applicationTelemetry){this.authority=authority,this.libraryName=libraryName,this.libraryVersion=libraryVersion,this.applicationTelemetry=applicationTelemetry,this.clientId=clientId,this.logger=logger,this.callbacks=new Map,this.eventsByCorrelationId=new Map,this.queueMeasurements=new Map,this.preQueueTimeByCorrelationId=new Map}return PerformanceClient.prototype.startPerformanceMeasurement=function(measureName,correlationId){return{}},PerformanceClient.prototype.startPerformanceMeasuremeant=function(measureName,correlationId){return{}},PerformanceClient.prototype.getIntFields=function(){return IntFields},PerformanceClient.prototype.getPreQueueTime=function(eventName,correlationId){var preQueueEvent=this.preQueueTimeByCorrelationId.get(correlationId);if(preQueueEvent){if(preQueueEvent.name===eventName)return preQueueEvent.time;this.logger.trace("PerformanceClient.getPreQueueTime: no pre-queue time found for "+eventName+", unable to add queue measurement")}else this.logger.trace("PerformanceClient.getPreQueueTime: no pre-queue times found for correlationId: "+correlationId+", unable to add queue measurement")},PerformanceClient.prototype.calculateQueuedTime=function(preQueueTime,currentTime){return preQueueTime<1?(this.logger.trace("PerformanceClient: preQueueTime should be a positive integer and not "+preQueueTime),0):currentTime<1?(this.logger.trace("PerformanceClient: currentTime should be a positive integer and not "+currentTime),0):currentTime<preQueueTime?(this.logger.trace("PerformanceClient: currentTime is less than preQueueTime, check how time is being retrieved"),0):currentTime-preQueueTime},PerformanceClient.prototype.addQueueMeasurement=function(eventName,correlationId,queueTime,manuallyCompleted){if(correlationId){if(0===queueTime)this.logger.trace("PerformanceClient.addQueueMeasurement: queue time provided for "+eventName+" is "+queueTime);else if(!queueTime)return void this.logger.trace("PerformanceClient.addQueueMeasurement: no queue time provided for "+eventName);var queueMeasurement={eventName:eventName,queueTime:queueTime,manuallyCompleted:manuallyCompleted},existingMeasurements=this.queueMeasurements.get(correlationId);if(existingMeasurements)existingMeasurements.push(queueMeasurement),this.queueMeasurements.set(correlationId,existingMeasurements);else{this.logger.trace("PerformanceClient.addQueueMeasurement: adding correlationId "+correlationId+" to queue measurements");var measurementArray=[queueMeasurement];this.queueMeasurements.set(correlationId,measurementArray)}this.preQueueTimeByCorrelationId.delete(correlationId)}else this.logger.trace("PerformanceClient.addQueueMeasurement: correlationId not provided for "+eventName+", cannot add queue measurement")},PerformanceClient.prototype.startMeasurement=function(measureName,correlationId){var _a,_b,_this=this,eventCorrelationId=correlationId||this.generateId();correlationId||this.logger.info("PerformanceClient: No correlation id provided for "+measureName+", generating",eventCorrelationId),this.logger.trace("PerformanceClient: Performance measurement started for "+measureName,eventCorrelationId);var performanceMeasurement=this.startPerformanceMeasuremeant(measureName,eventCorrelationId);performanceMeasurement.startMeasurement();var inProgressEvent={eventId:this.generateId(),status:PerformanceEventStatus.InProgress,authority:this.authority,libraryName:this.libraryName,libraryVersion:this.libraryVersion,clientId:this.clientId,name:measureName,startTimeMs:Date.now(),correlationId:eventCorrelationId,appName:null===(_a=this.applicationTelemetry)||void 0===_a?void 0:_a.appName,appVersion:null===(_b=this.applicationTelemetry)||void 0===_b?void 0:_b.appVersion};return this.cacheEventByCorrelationId(inProgressEvent),{endMeasurement:function(event){return _this.endMeasurement(__assign(__assign({},inProgressEvent),event),performanceMeasurement)},discardMeasurement:function(){return _this.discardMeasurements(inProgressEvent.correlationId)},addStaticFields:function(fields){return _this.addStaticFields(fields,inProgressEvent.correlationId)},increment:function(counters){return _this.increment(counters,inProgressEvent.correlationId)},measurement:performanceMeasurement,event:inProgressEvent}},PerformanceClient.prototype.endMeasurement=function(event,measurement){var _a,_b,_this=this,rootEvent=this.eventsByCorrelationId.get(event.correlationId);if(!rootEvent)return this.logger.trace("PerformanceClient: Measurement not found for "+event.eventId,event.correlationId),null;var isRoot=event.eventId===rootEvent.eventId,queueInfo={totalQueueTime:0,totalQueueCount:0,manuallyCompletedCount:0};isRoot?(queueInfo=this.getQueueInfo(event.correlationId),this.discardCache(rootEvent.correlationId)):null===(_a=rootEvent.incompleteSubMeasurements)||void 0===_a||_a.delete(event.eventId),null==measurement||measurement.endMeasurement();var durationMs=null==measurement?void 0:measurement.flushMeasurement();if(!durationMs)return this.logger.trace("PerformanceClient: Performance measurement not taken",rootEvent.correlationId),null;if(this.logger.trace("PerformanceClient: Performance measurement ended for "+event.name+": "+durationMs+" ms",event.correlationId),!isRoot)return rootEvent[event.name+"DurationMs"]=Math.floor(durationMs),__assign({},rootEvent);var finalEvent=__assign(__assign({},rootEvent),event),incompleteSubsCount=0;return null===(_b=finalEvent.incompleteSubMeasurements)||void 0===_b||_b.forEach((function(subMeasurement){_this.logger.trace("PerformanceClient: Incomplete submeasurement "+subMeasurement.name+" found for "+event.name,finalEvent.correlationId),incompleteSubsCount++})),finalEvent.incompleteSubMeasurements=void 0,finalEvent=__assign(__assign({},finalEvent),{durationMs:Math.round(durationMs),queuedTimeMs:queueInfo.totalQueueTime,queuedCount:queueInfo.totalQueueCount,queuedManuallyCompletedCount:queueInfo.manuallyCompletedCount,status:PerformanceEventStatus.Completed,incompleteSubsCount:incompleteSubsCount}),this.truncateIntegralFields(finalEvent,this.getIntFields()),this.emitEvents([finalEvent],event.correlationId),finalEvent},PerformanceClient.prototype.addStaticFields=function(fields,correlationId){this.logger.trace("PerformanceClient: Updating static fields");var event=this.eventsByCorrelationId.get(correlationId);event?this.eventsByCorrelationId.set(correlationId,__assign(__assign({},event),fields)):this.logger.trace("PerformanceClient: Event not found for",correlationId)},PerformanceClient.prototype.increment=function(counters,correlationId){this.logger.trace("PerformanceClient: Updating counters");var event=this.eventsByCorrelationId.get(correlationId);if(event)for(var counter in counters)event.hasOwnProperty(counter)||(event[counter]=0),event[counter]+=counters[counter];else this.logger.trace("PerformanceClient: Event not found for",correlationId)},PerformanceClient.prototype.cacheEventByCorrelationId=function(event){var rootEvent=this.eventsByCorrelationId.get(event.correlationId);rootEvent?(this.logger.trace("PerformanceClient: Performance measurement for "+event.name+" added/updated",event.correlationId),rootEvent.incompleteSubMeasurements=rootEvent.incompleteSubMeasurements||new Map,rootEvent.incompleteSubMeasurements.set(event.eventId,{name:event.name,startTimeMs:event.startTimeMs})):(this.logger.trace("PerformanceClient: Performance measurement for "+event.name+" started",event.correlationId),this.eventsByCorrelationId.set(event.correlationId,__assign({},event)))},PerformanceClient.prototype.getQueueInfo=function(correlationId){var queueMeasurementForCorrelationId=this.queueMeasurements.get(correlationId);queueMeasurementForCorrelationId||this.logger.trace("PerformanceClient: no queue measurements found for for correlationId: "+correlationId);var totalQueueTime=0,totalQueueCount=0,manuallyCompletedCount=0;return null==queueMeasurementForCorrelationId||queueMeasurementForCorrelationId.forEach((function(measurement){totalQueueTime+=measurement.queueTime,totalQueueCount++,manuallyCompletedCount+=measurement.manuallyCompleted?1:0})),{totalQueueTime:totalQueueTime,totalQueueCount:totalQueueCount,manuallyCompletedCount:manuallyCompletedCount}},PerformanceClient.prototype.discardMeasurements=function(correlationId){this.logger.trace("PerformanceClient: Performance measurements discarded",correlationId),this.eventsByCorrelationId.delete(correlationId)},PerformanceClient.prototype.discardCache=function(correlationId){this.discardMeasurements(correlationId),this.logger.trace("PerformanceClient: QueueMeasurements discarded",correlationId),this.queueMeasurements.delete(correlationId),this.logger.trace("PerformanceClient: Pre-queue times discarded",correlationId),this.preQueueTimeByCorrelationId.delete(correlationId)},PerformanceClient.prototype.addPerformanceCallback=function(callback){var callbackId=this.generateId();return this.callbacks.set(callbackId,callback),this.logger.verbose("PerformanceClient: Performance callback registered with id: "+callbackId),callbackId},PerformanceClient.prototype.removePerformanceCallback=function(callbackId){var result=this.callbacks.delete(callbackId);return result?this.logger.verbose("PerformanceClient: Performance callback "+callbackId+" removed."):this.logger.verbose("PerformanceClient: Performance callback "+callbackId+" not removed."),result},PerformanceClient.prototype.emitEvents=function(events,correlationId){var _this=this;this.logger.verbose("PerformanceClient: Emitting performance events",correlationId),this.callbacks.forEach((function(callback,callbackId){_this.logger.trace("PerformanceClient: Emitting event to callback "+callbackId,correlationId),callback.apply(null,[events])}))},PerformanceClient.prototype.truncateIntegralFields=function(event,intFields){intFields.forEach((function(key){key in event&&"number"==typeof event[key]&&(event[key]=Math.floor(event[key]))}))},PerformanceClient}();export{PerformanceClient};