/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{ClientAuthError}from"../error/ClientAuthError.js";import{StringUtils}from"../utils/StringUtils.js";import{Separators,Constants}from"../utils/Constants.js";function buildClientInfo(rawClientInfo,crypto){if(StringUtils.isEmpty(rawClientInfo))throw ClientAuthError.createClientInfoEmptyError();try{var decodedClientInfo=crypto.base64Decode(rawClientInfo);return JSON.parse(decodedClientInfo)}catch(e){throw ClientAuthError.createClientInfoDecodingError(e.message)}}function buildClientInfoFromHomeAccountId(homeAccountId){if(StringUtils.isEmpty(homeAccountId))throw ClientAuthError.createClientInfoDecodingError("Home account ID was empty.");var clientInfoParts=homeAccountId.split(Separators.CLIENT_INFO_SEPARATOR,2);return{uid:clientInfoParts[0],utid:clientInfoParts.length<2?Constants.EMPTY_STRING:clientInfoParts[1]}}export{buildClientInfo,buildClientInfoFromHomeAccountId};