/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{AuthorityType}from"./AuthorityType.js";import{isOpenIdConfigResponse}from"./OpenIdConfigResponse.js";import{UrlString}from"../url/UrlString.js";import{ClientAuthError}from"../error/ClientAuthError.js";import{Constants,AuthorityMetadataSource,RegionDiscoveryOutcomes}from"../utils/Constants.js";import{EndpointMetadata,InstanceDiscoveryMetadata}from"./AuthorityMetadata.js";import{ClientConfigurationError}from"../error/ClientConfigurationError.js";import{ProtocolMode}from"./ProtocolMode.js";import{AuthorityMetadataEntity}from"../cache/entities/AuthorityMetadataEntity.js";import{AzureCloudInstance}from"./AuthorityOptions.js";import{isCloudInstanceDiscoveryResponse}from"./CloudInstanceDiscoveryResponse.js";import{RegionDiscovery}from"./RegionDiscovery.js";var Authority=function(){function Authority(authority,networkInterface,cacheManager,authorityOptions,proxyUrl){this.canonicalAuthority=authority,this._canonicalAuthority.validateAsUri(),this.networkInterface=networkInterface,this.cacheManager=cacheManager,this.authorityOptions=authorityOptions,this.regionDiscovery=new RegionDiscovery(networkInterface),this.regionDiscoveryMetadata={region_used:void 0,region_source:void 0,region_outcome:void 0},this.proxyUrl=proxyUrl||Constants.EMPTY_STRING}return Object.defineProperty(Authority.prototype,"authorityType",{get:function(){var pathSegments=this.canonicalAuthorityUrlComponents.PathSegments;if(pathSegments.length)switch(pathSegments[0].toLowerCase()){case Constants.ADFS:return AuthorityType.Adfs;case Constants.DSTS:return AuthorityType.Dsts}return AuthorityType.Default},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"protocolMode",{get:function(){return this.authorityOptions.protocolMode},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"options",{get:function(){return this.authorityOptions},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"canonicalAuthority",{get:function(){return this._canonicalAuthority.urlString},set:function(url){this._canonicalAuthority=new UrlString(url),this._canonicalAuthority.validateAsUri(),this._canonicalAuthorityUrlComponents=null},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"canonicalAuthorityUrlComponents",{get:function(){return this._canonicalAuthorityUrlComponents||(this._canonicalAuthorityUrlComponents=this._canonicalAuthority.getUrlComponents()),this._canonicalAuthorityUrlComponents},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"hostnameAndPort",{get:function(){return this.canonicalAuthorityUrlComponents.HostNameAndPort.toLowerCase()},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"tenant",{get:function(){return this.canonicalAuthorityUrlComponents.PathSegments[0]},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"authorizationEndpoint",{get:function(){if(this.discoveryComplete()){var endpoint=this.replacePath(this.metadata.authorization_endpoint);return this.replaceTenant(endpoint)}throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"tokenEndpoint",{get:function(){if(this.discoveryComplete()){var endpoint=this.replacePath(this.metadata.token_endpoint);return this.replaceTenant(endpoint)}throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"deviceCodeEndpoint",{get:function(){if(this.discoveryComplete()){var endpoint=this.replacePath(this.metadata.token_endpoint.replace("/token","/devicecode"));return this.replaceTenant(endpoint)}throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"endSessionEndpoint",{get:function(){if(this.discoveryComplete()){if(!this.metadata.end_session_endpoint)throw ClientAuthError.createLogoutNotSupportedError();var endpoint=this.replacePath(this.metadata.end_session_endpoint);return this.replaceTenant(endpoint)}throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"selfSignedJwtAudience",{get:function(){if(this.discoveryComplete()){var endpoint=this.replacePath(this.metadata.issuer);return this.replaceTenant(endpoint)}throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Object.defineProperty(Authority.prototype,"jwksUri",{get:function(){if(this.discoveryComplete()){var endpoint=this.replacePath(this.metadata.jwks_uri);return this.replaceTenant(endpoint)}throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},enumerable:!1,configurable:!0}),Authority.prototype.replaceTenant=function(urlString){return urlString.replace(/{tenant}|{tenantid}/g,this.tenant)},Authority.prototype.replacePath=function(urlString){var endpoint=urlString,cachedAuthorityParts=new UrlString(this.metadata.canonical_authority).getUrlComponents().PathSegments;return this.canonicalAuthorityUrlComponents.PathSegments.forEach((function(currentPart,index){var cachedPart=cachedAuthorityParts[index];currentPart!==cachedPart&&(endpoint=endpoint.replace("/"+cachedPart+"/","/"+currentPart+"/"))})),endpoint},Object.defineProperty(Authority.prototype,"defaultOpenIdConfigurationEndpoint",{get:function(){return this.authorityType===AuthorityType.Adfs||this.authorityType===AuthorityType.Dsts||this.protocolMode===ProtocolMode.OIDC?this.canonicalAuthority+".well-known/openid-configuration":this.canonicalAuthority+"v2.0/.well-known/openid-configuration"},enumerable:!1,configurable:!0}),Authority.prototype.discoveryComplete=function(){return!!this.metadata},Authority.prototype.resolveEndpointsAsync=function(){return __awaiter(this,void 0,void 0,(function(){var metadataEntity,cloudDiscoverySource,endpointSource,cacheKey;return __generator(this,(function(_a){switch(_a.label){case 0:return(metadataEntity=this.cacheManager.getAuthorityMetadataByAlias(this.hostnameAndPort))||(metadataEntity=new AuthorityMetadataEntity).updateCanonicalAuthority(this.canonicalAuthority),[4,this.updateCloudDiscoveryMetadata(metadataEntity)];case 1:return cloudDiscoverySource=_a.sent(),this.canonicalAuthority=this.canonicalAuthority.replace(this.hostnameAndPort,metadataEntity.preferred_network),[4,this.updateEndpointMetadata(metadataEntity)];case 2:return endpointSource=_a.sent(),cloudDiscoverySource!==AuthorityMetadataSource.CACHE&&endpointSource!==AuthorityMetadataSource.CACHE&&(metadataEntity.resetExpiresAt(),metadataEntity.updateCanonicalAuthority(this.canonicalAuthority)),cacheKey=this.cacheManager.generateAuthorityMetadataCacheKey(metadataEntity.preferred_cache),this.cacheManager.setAuthorityMetadata(cacheKey,metadataEntity),this.metadata=metadataEntity,[2]}}))}))},Authority.prototype.updateEndpointMetadata=function(metadataEntity){var _a,_b;return __awaiter(this,void 0,void 0,(function(){var metadata,harcodedMetadata;return __generator(this,(function(_c){switch(_c.label){case 0:return(metadata=this.getEndpointMetadataFromConfig())?(metadataEntity.updateEndpointMetadata(metadata,!1),[2,AuthorityMetadataSource.CONFIG]):this.isAuthoritySameType(metadataEntity)&&metadataEntity.endpointsFromNetwork&&!metadataEntity.isExpired()?[2,AuthorityMetadataSource.CACHE]:(harcodedMetadata=this.getEndpointMetadataFromHardcodedValues(),[4,this.getEndpointMetadataFromNetwork()]);case 1:return(metadata=_c.sent())?(null===(_a=this.authorityOptions.azureRegionConfiguration)||void 0===_a?void 0:_a.azureRegion)?[4,this.updateMetadataWithRegionalInformation(metadata)]:[3,3]:[3,4];case 2:metadata=_c.sent(),_c.label=3;case 3:return metadataEntity.updateEndpointMetadata(metadata,!0),[2,AuthorityMetadataSource.NETWORK];case 4:return!harcodedMetadata||this.authorityOptions.skipAuthorityMetadataCache?[3,7]:(null===(_b=this.authorityOptions.azureRegionConfiguration)||void 0===_b?void 0:_b.azureRegion)?[4,this.updateMetadataWithRegionalInformation(harcodedMetadata)]:[3,6];case 5:harcodedMetadata=_c.sent(),_c.label=6;case 6:return metadataEntity.updateEndpointMetadata(harcodedMetadata,!1),[2,AuthorityMetadataSource.HARDCODED_VALUES];case 7:throw ClientAuthError.createUnableToGetOpenidConfigError(this.defaultOpenIdConfigurationEndpoint)}}))}))},Authority.prototype.isAuthoritySameType=function(metadataEntity){return new UrlString(metadataEntity.canonical_authority).getUrlComponents().PathSegments.length===this.canonicalAuthorityUrlComponents.PathSegments.length},Authority.prototype.getEndpointMetadataFromConfig=function(){if(this.authorityOptions.authorityMetadata)try{return JSON.parse(this.authorityOptions.authorityMetadata)}catch(e){throw ClientConfigurationError.createInvalidAuthorityMetadataError()}return null},Authority.prototype.getEndpointMetadataFromNetwork=function(){return __awaiter(this,void 0,void 0,(function(){var options,response;return __generator(this,(function(_a){switch(_a.label){case 0:options={},this.proxyUrl&&(options.proxyUrl=this.proxyUrl),_a.label=1;case 1:return _a.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(this.defaultOpenIdConfigurationEndpoint,options)];case 2:return response=_a.sent(),[2,isOpenIdConfigResponse(response.body)?response.body:null];case 3:return _a.sent(),[2,null];case 4:return[2]}}))}))},Authority.prototype.getEndpointMetadataFromHardcodedValues=function(){return this.canonicalAuthority in EndpointMetadata?EndpointMetadata[this.canonicalAuthority]:null},Authority.prototype.updateMetadataWithRegionalInformation=function(metadata){var _a,_b,_c,_d,_e;return __awaiter(this,void 0,void 0,(function(){var autodetectedRegionName,azureRegion;return __generator(this,(function(_f){switch(_f.label){case 0:return[4,this.regionDiscovery.detectRegion(null===(_a=this.authorityOptions.azureRegionConfiguration)||void 0===_a?void 0:_a.environmentRegion,this.regionDiscoveryMetadata,this.proxyUrl)];case 1:return autodetectedRegionName=_f.sent(),azureRegion=(null===(_b=this.authorityOptions.azureRegionConfiguration)||void 0===_b?void 0:_b.azureRegion)===Constants.AZURE_REGION_AUTO_DISCOVER_FLAG?autodetectedRegionName:null===(_c=this.authorityOptions.azureRegionConfiguration)||void 0===_c?void 0:_c.azureRegion,(null===(_d=this.authorityOptions.azureRegionConfiguration)||void 0===_d?void 0:_d.azureRegion)===Constants.AZURE_REGION_AUTO_DISCOVER_FLAG?this.regionDiscoveryMetadata.region_outcome=autodetectedRegionName?RegionDiscoveryOutcomes.AUTO_DETECTION_REQUESTED_SUCCESSFUL:RegionDiscoveryOutcomes.AUTO_DETECTION_REQUESTED_FAILED:this.regionDiscoveryMetadata.region_outcome=autodetectedRegionName?(null===(_e=this.authorityOptions.azureRegionConfiguration)||void 0===_e?void 0:_e.azureRegion)===autodetectedRegionName?RegionDiscoveryOutcomes.CONFIGURED_MATCHES_DETECTED:RegionDiscoveryOutcomes.CONFIGURED_NOT_DETECTED:RegionDiscoveryOutcomes.CONFIGURED_NO_AUTO_DETECTION,azureRegion?(this.regionDiscoveryMetadata.region_used=azureRegion,[2,Authority.replaceWithRegionalInformation(metadata,azureRegion)]):[2,metadata]}}))}))},Authority.prototype.updateCloudDiscoveryMetadata=function(metadataEntity){return __awaiter(this,void 0,void 0,(function(){var metadata,harcodedMetadata;return __generator(this,(function(_a){switch(_a.label){case 0:return(metadata=this.getCloudDiscoveryMetadataFromConfig())?(metadataEntity.updateCloudDiscoveryMetadata(metadata,!1),[2,AuthorityMetadataSource.CONFIG]):this.isAuthoritySameType(metadataEntity)&&metadataEntity.aliasesFromNetwork&&!metadataEntity.isExpired()?[2,AuthorityMetadataSource.CACHE]:(harcodedMetadata=this.getCloudDiscoveryMetadataFromHarcodedValues(),[4,this.getCloudDiscoveryMetadataFromNetwork()]);case 1:if(metadata=_a.sent())return metadataEntity.updateCloudDiscoveryMetadata(metadata,!0),[2,AuthorityMetadataSource.NETWORK];if(harcodedMetadata&&!this.options.skipAuthorityMetadataCache)return metadataEntity.updateCloudDiscoveryMetadata(harcodedMetadata,!1),[2,AuthorityMetadataSource.HARDCODED_VALUES];throw ClientConfigurationError.createUntrustedAuthorityError()}}))}))},Authority.prototype.getCloudDiscoveryMetadataFromConfig=function(){if(this.authorityOptions.cloudDiscoveryMetadata)try{var parsedResponse=JSON.parse(this.authorityOptions.cloudDiscoveryMetadata),metadata=Authority.getCloudDiscoveryMetadataFromNetworkResponse(parsedResponse.metadata,this.hostnameAndPort);if(metadata)return metadata}catch(e){throw ClientConfigurationError.createInvalidCloudDiscoveryMetadataError()}return this.isInKnownAuthorities()?Authority.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort):null},Authority.prototype.getCloudDiscoveryMetadataFromNetwork=function(){return __awaiter(this,void 0,void 0,(function(){var instanceDiscoveryEndpoint,options,match,response,metadata;return __generator(this,(function(_a){switch(_a.label){case 0:instanceDiscoveryEndpoint=""+Constants.AAD_INSTANCE_DISCOVERY_ENDPT+this.canonicalAuthority+"oauth2/v2.0/authorize",options={},this.proxyUrl&&(options.proxyUrl=this.proxyUrl),match=null,_a.label=1;case 1:return _a.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(instanceDiscoveryEndpoint,options)];case 2:return response=_a.sent(),0===(metadata=isCloudInstanceDiscoveryResponse(response.body)?response.body.metadata:[]).length?[2,null]:(match=Authority.getCloudDiscoveryMetadataFromNetworkResponse(metadata,this.hostnameAndPort),[3,4]);case 3:return _a.sent(),[2,null];case 4:return match||(match=Authority.createCloudDiscoveryMetadataFromHost(this.hostnameAndPort)),[2,match]}}))}))},Authority.prototype.getCloudDiscoveryMetadataFromHarcodedValues=function(){return this.canonicalAuthority in InstanceDiscoveryMetadata?InstanceDiscoveryMetadata[this.canonicalAuthority]:null},Authority.prototype.isInKnownAuthorities=function(){var _this=this;return this.authorityOptions.knownAuthorities.filter((function(authority){return UrlString.getDomainFromUrl(authority).toLowerCase()===_this.hostnameAndPort})).length>0},Authority.generateAuthority=function(authorityString,azureCloudOptions){var authorityAzureCloudInstance;if(azureCloudOptions&&azureCloudOptions.azureCloudInstance!==AzureCloudInstance.None){var tenant=azureCloudOptions.tenant?azureCloudOptions.tenant:Constants.DEFAULT_COMMON_TENANT;authorityAzureCloudInstance=azureCloudOptions.azureCloudInstance+"/"+tenant+"/"}return authorityAzureCloudInstance||authorityString},Authority.createCloudDiscoveryMetadataFromHost=function(host){return{preferred_network:host,preferred_cache:host,aliases:[host]}},Authority.getCloudDiscoveryMetadataFromNetworkResponse=function(response,authority){for(var i=0;i<response.length;i++){var metadata=response[i];if(metadata.aliases.indexOf(authority)>-1)return metadata}return null},Authority.prototype.getPreferredCache=function(){if(this.discoveryComplete())return this.metadata.preferred_cache;throw ClientAuthError.createEndpointDiscoveryIncompleteError("Discovery incomplete.")},Authority.prototype.isAlias=function(host){return this.metadata.aliases.indexOf(host)>-1},Authority.isPublicCloudAuthority=function(host){return Constants.KNOWN_PUBLIC_CLOUDS.indexOf(host)>=0},Authority.buildRegionalAuthorityString=function(host,region,queryString){var authorityUrlInstance=new UrlString(host);authorityUrlInstance.validateAsUri();var authorityUrlParts=authorityUrlInstance.getUrlComponents(),hostNameAndPort=region+"."+authorityUrlParts.HostNameAndPort;this.isPublicCloudAuthority(authorityUrlParts.HostNameAndPort)&&(hostNameAndPort=region+"."+Constants.REGIONAL_AUTH_PUBLIC_CLOUD_SUFFIX);var url=UrlString.constructAuthorityUriFromObject(__assign(__assign({},authorityUrlInstance.getUrlComponents()),{HostNameAndPort:hostNameAndPort})).urlString;return queryString?url+"?"+queryString:url},Authority.replaceWithRegionalInformation=function(metadata,azureRegion){return metadata.authorization_endpoint=Authority.buildRegionalAuthorityString(metadata.authorization_endpoint,azureRegion),metadata.token_endpoint=Authority.buildRegionalAuthorityString(metadata.token_endpoint,azureRegion,Constants.REGIONAL_AUTH_NON_MSI_QUERY_STRING),metadata.end_session_endpoint&&(metadata.end_session_endpoint=Authority.buildRegionalAuthorityString(metadata.end_session_endpoint,azureRegion)),metadata},Authority}();export{Authority};