/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{__extends,__awaiter,__generator}from"../_virtual/_tslib.js";import{BaseClient}from"./BaseClient.js";import{RequestParameterBuilder}from"../request/RequestParameterBuilder.js";import{ScopeSet}from"../request/ScopeSet.js";import{Constants,CredentialType,GrantType,CacheOutcome,AuthenticationScheme}from"../utils/Constants.js";import{ResponseHandler}from"../response/ResponseHandler.js";import{TimeUtils}from"../utils/TimeUtils.js";import{StringUtils}from"../utils/StringUtils.js";import{ClientAuthError}from"../error/ClientAuthError.js";var ClientCredentialClient=function(_super){function ClientCredentialClient(configuration,appTokenProvider){var _this=_super.call(this,configuration)||this;return _this.appTokenProvider=appTokenProvider,_this}return __extends(ClientCredentialClient,_super),ClientCredentialClient.prototype.acquireToken=function(request){return __awaiter(this,void 0,void 0,(function(){var cachedAuthenticationResult;return __generator(this,(function(_a){switch(_a.label){case 0:return this.scopeSet=new ScopeSet(request.scopes||[]),request.skipCache?[4,this.executeTokenRequest(request,this.authority)]:[3,2];case 1:case 5:return[2,_a.sent()];case 2:return[4,this.getCachedAuthenticationResult(request)];case 3:return(cachedAuthenticationResult=_a.sent())?[2,cachedAuthenticationResult]:[3,4];case 4:return[4,this.executeTokenRequest(request,this.authority)]}}))}))},ClientCredentialClient.prototype.getCachedAuthenticationResult=function(request){var _a,_b;return __awaiter(this,void 0,void 0,(function(){var cachedAccessToken;return __generator(this,(function(_c){switch(_c.label){case 0:return(cachedAccessToken=this.readAccessTokenFromCache())?TimeUtils.isTokenExpired(cachedAccessToken.expiresOn,this.config.systemOptions.tokenRenewalOffsetSeconds)?(null===(_b=this.serverTelemetryManager)||void 0===_b||_b.setCacheOutcome(CacheOutcome.CACHED_ACCESS_TOKEN_EXPIRED),[2,null]):[4,ResponseHandler.generateAuthenticationResult(this.cryptoUtils,this.authority,{account:null,idToken:null,accessToken:cachedAccessToken,refreshToken:null,appMetadata:null},!0,request)]:(null===(_a=this.serverTelemetryManager)||void 0===_a||_a.setCacheOutcome(CacheOutcome.NO_CACHED_ACCESS_TOKEN),[2,null]);case 1:return[2,_c.sent()]}}))}))},ClientCredentialClient.prototype.readAccessTokenFromCache=function(){var accessTokenFilter={homeAccountId:Constants.EMPTY_STRING,environment:this.authority.canonicalAuthorityUrlComponents.HostNameAndPort,credentialType:CredentialType.ACCESS_TOKEN,clientId:this.config.authOptions.clientId,realm:this.authority.tenant,target:this.scopeSet.printScopesLowerCase()},credentialCache=this.cacheManager.getCredentialsFilteredBy(accessTokenFilter),accessTokens=Object.keys(credentialCache.accessTokens).map((function(key){return credentialCache.accessTokens[key]}));if(accessTokens.length<1)return null;if(accessTokens.length>1)throw ClientAuthError.createMultipleMatchingTokensInCacheError();return accessTokens[0]},ClientCredentialClient.prototype.executeTokenRequest=function(request,authority){return __awaiter(this,void 0,void 0,(function(){var serverTokenResponse,reqTimestamp,appTokenPropviderParameters,appTokenProviderResult,requestBody,headers,thumbprint,response,responseHandler;return __generator(this,(function(_a){switch(_a.label){case 0:return this.appTokenProvider?(this.logger.info("Using appTokenProvider extensibility."),appTokenPropviderParameters={correlationId:request.correlationId,tenantId:this.config.authOptions.authority.tenant,scopes:request.scopes,claims:request.claims},reqTimestamp=TimeUtils.nowSeconds(),[4,this.appTokenProvider(appTokenPropviderParameters)]):[3,2];case 1:return appTokenProviderResult=_a.sent(),serverTokenResponse={access_token:appTokenProviderResult.accessToken,expires_in:appTokenProviderResult.expiresInSeconds,refresh_in:appTokenProviderResult.refreshInSeconds,token_type:AuthenticationScheme.BEARER},[3,4];case 2:return requestBody=this.createTokenRequestBody(request),headers=this.createTokenRequestHeaders(),thumbprint={clientId:this.config.authOptions.clientId,authority:request.authority,scopes:request.scopes,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},reqTimestamp=TimeUtils.nowSeconds(),[4,this.executePostToTokenEndpoint(authority.tokenEndpoint,requestBody,headers,thumbprint)];case 3:response=_a.sent(),serverTokenResponse=response.body,_a.label=4;case 4:return(responseHandler=new ResponseHandler(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin)).validateTokenResponse(serverTokenResponse),[4,responseHandler.handleServerTokenResponse(serverTokenResponse,this.authority,reqTimestamp,request)];case 5:return[2,_a.sent()]}}))}))},ClientCredentialClient.prototype.createTokenRequestBody=function(request){var parameterBuilder=new RequestParameterBuilder;parameterBuilder.addClientId(this.config.authOptions.clientId),parameterBuilder.addScopes(request.scopes,!1),parameterBuilder.addGrantType(GrantType.CLIENT_CREDENTIALS_GRANT),parameterBuilder.addLibraryInfo(this.config.libraryInfo),parameterBuilder.addApplicationTelemetry(this.config.telemetry.application),parameterBuilder.addThrottling(),this.serverTelemetryManager&&parameterBuilder.addServerTelemetry(this.serverTelemetryManager);var correlationId=request.correlationId||this.config.cryptoInterface.createNewGuid();parameterBuilder.addCorrelationId(correlationId),this.config.clientCredentials.clientSecret&&parameterBuilder.addClientSecret(this.config.clientCredentials.clientSecret);var clientAssertion=request.clientAssertion||this.config.clientCredentials.clientAssertion;return clientAssertion&&(parameterBuilder.addClientAssertion(clientAssertion.assertion),parameterBuilder.addClientAssertionType(clientAssertion.assertionType)),(!StringUtils.isEmptyObj(request.claims)||this.config.authOptions.clientCapabilities&&this.config.authOptions.clientCapabilities.length>0)&&parameterBuilder.addClaims(request.claims,this.config.authOptions.clientCapabilities),parameterBuilder.createQueryString()},ClientCredentialClient}(BaseClient);export{ClientCredentialClient};