/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{__extends,__awaiter,__generator}from"../_virtual/_tslib.js";import{BaseClient}from"./BaseClient.js";import{ClientAuthError}from"../error/ClientAuthError.js";import{RequestParameterBuilder}from"../request/RequestParameterBuilder.js";import{GrantType,Constants}from"../utils/Constants.js";import{TimeUtils}from"../utils/TimeUtils.js";import{ResponseHandler}from"../response/ResponseHandler.js";import{StringUtils}from"../utils/StringUtils.js";import{ServerError}from"../error/ServerError.js";var DeviceCodeClient=function(_super){function DeviceCodeClient(configuration){return _super.call(this,configuration)||this}return __extends(DeviceCodeClient,_super),DeviceCodeClient.prototype.acquireToken=function(request){return __awaiter(this,void 0,void 0,(function(){var deviceCodeResponse,reqTimestamp,response,responseHandler;return __generator(this,(function(_a){switch(_a.label){case 0:return[4,this.getDeviceCode(request)];case 1:return deviceCodeResponse=_a.sent(),request.deviceCodeCallback(deviceCodeResponse),reqTimestamp=TimeUtils.nowSeconds(),[4,this.acquireTokenWithDeviceCode(request,deviceCodeResponse)];case 2:return response=_a.sent(),(responseHandler=new ResponseHandler(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin)).validateTokenResponse(response),[4,responseHandler.handleServerTokenResponse(response,this.authority,reqTimestamp,request)];case 3:return[2,_a.sent()]}}))}))},DeviceCodeClient.prototype.getDeviceCode=function(request){return __awaiter(this,void 0,void 0,(function(){var queryString,headers,thumbprint;return __generator(this,(function(_a){return queryString=this.createQueryString(request),headers=this.createTokenRequestHeaders(),thumbprint={clientId:this.config.authOptions.clientId,authority:request.authority,scopes:request.scopes,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},[2,this.executePostRequestToDeviceCodeEndpoint(this.authority.deviceCodeEndpoint,queryString,headers,thumbprint)]}))}))},DeviceCodeClient.prototype.executePostRequestToDeviceCodeEndpoint=function(deviceCodeEndpoint,queryString,headers,thumbprint){return __awaiter(this,void 0,void 0,(function(){var _a,userCode,deviceCode,verificationUri,expiresIn,interval,message;return __generator(this,(function(_b){switch(_b.label){case 0:return[4,this.networkManager.sendPostRequest(thumbprint,deviceCodeEndpoint,{body:queryString,headers:headers,proxyUrl:this.config.systemOptions.proxyUrl})];case 1:return _a=_b.sent().body,userCode=_a.user_code,deviceCode=_a.device_code,verificationUri=_a.verification_uri,expiresIn=_a.expires_in,interval=_a.interval,message=_a.message,[2,{userCode:userCode,deviceCode:deviceCode,verificationUri:verificationUri,expiresIn:expiresIn,interval:interval,message:message}]}}))}))},DeviceCodeClient.prototype.createQueryString=function(request){var parameterBuilder=new RequestParameterBuilder;return parameterBuilder.addScopes(request.scopes),parameterBuilder.addClientId(this.config.authOptions.clientId),(!StringUtils.isEmpty(request.claims)||this.config.authOptions.clientCapabilities&&this.config.authOptions.clientCapabilities.length>0)&&parameterBuilder.addClaims(request.claims,this.config.authOptions.clientCapabilities),parameterBuilder.createQueryString()},DeviceCodeClient.prototype.continuePolling=function(deviceCodeExpirationTime,userSpecifiedTimeout,userSpecifiedCancelFlag){if(userSpecifiedCancelFlag)throw this.logger.error("Token request cancelled by setting DeviceCodeRequest.cancel = true"),ClientAuthError.createDeviceCodeCancelledError();if(userSpecifiedTimeout&&userSpecifiedTimeout<deviceCodeExpirationTime&&TimeUtils.nowSeconds()>userSpecifiedTimeout)throw this.logger.error("User defined timeout for device code polling reached. The timeout was set for "+userSpecifiedTimeout),ClientAuthError.createUserTimeoutReachedError();if(TimeUtils.nowSeconds()>deviceCodeExpirationTime)throw userSpecifiedTimeout&&this.logger.verbose("User specified timeout ignored as the device code has expired before the timeout elapsed. The user specified timeout was set for "+userSpecifiedTimeout),this.logger.error("Device code expired. Expiration time of device code was "+deviceCodeExpirationTime),ClientAuthError.createDeviceCodeExpiredError();return!0},DeviceCodeClient.prototype.acquireTokenWithDeviceCode=function(request,deviceCodeResponse){return __awaiter(this,void 0,void 0,(function(){var requestBody,headers,userSpecifiedTimeout,deviceCodeExpirationTime,pollingIntervalMilli,thumbprint,response;return __generator(this,(function(_a){switch(_a.label){case 0:requestBody=this.createTokenRequestBody(request,deviceCodeResponse),headers=this.createTokenRequestHeaders(),userSpecifiedTimeout=request.timeout?TimeUtils.nowSeconds()+request.timeout:void 0,deviceCodeExpirationTime=TimeUtils.nowSeconds()+deviceCodeResponse.expiresIn,pollingIntervalMilli=1e3*deviceCodeResponse.interval,_a.label=1;case 1:return this.continuePolling(deviceCodeExpirationTime,userSpecifiedTimeout,request.cancel)?(thumbprint={clientId:this.config.authOptions.clientId,authority:request.authority,scopes:request.scopes,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},[4,this.executePostToTokenEndpoint(this.authority.tokenEndpoint,requestBody,headers,thumbprint)]):[3,8];case 2:return(response=_a.sent()).body&&response.body.error?response.body.error!==Constants.AUTHORIZATION_PENDING?[3,4]:(this.logger.info("Authorization pending. Continue polling."),[4,TimeUtils.delay(pollingIntervalMilli)]):[3,6];case 3:return _a.sent(),[3,5];case 4:throw this.logger.info("Unexpected error in polling from the server"),ServerError.createPostRequestFailed(response.body.error);case 5:return[3,7];case 6:return this.logger.verbose("Authorization completed successfully. Polling stopped."),[2,response.body];case 7:return[3,1];case 8:throw this.logger.error("Polling stopped for unknown reasons."),ClientAuthError.createDeviceCodeUnknownError()}}))}))},DeviceCodeClient.prototype.createTokenRequestBody=function(request,deviceCodeResponse){var requestParameters=new RequestParameterBuilder;requestParameters.addScopes(request.scopes),requestParameters.addClientId(this.config.authOptions.clientId),requestParameters.addGrantType(GrantType.DEVICE_CODE_GRANT),requestParameters.addDeviceCode(deviceCodeResponse.deviceCode);var correlationId=request.correlationId||this.config.cryptoInterface.createNewGuid();return requestParameters.addCorrelationId(correlationId),requestParameters.addClientInfo(),requestParameters.addLibraryInfo(this.config.libraryInfo),requestParameters.addApplicationTelemetry(this.config.telemetry.application),requestParameters.addThrottling(),this.serverTelemetryManager&&requestParameters.addServerTelemetry(this.serverTelemetryManager),(!StringUtils.isEmptyObj(request.claims)||this.config.authOptions.clientCapabilities&&this.config.authOptions.clientCapabilities.length>0)&&requestParameters.addClaims(request.claims,this.config.authOptions.clientCapabilities),requestParameters.createQueryString()},DeviceCodeClient}(BaseClient);export{DeviceCodeClient};