/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{StringUtils}from"../utils/StringUtils.js";import{Constants}from"../utils/Constants.js";var LogLevel;!function(LogLevel){LogLevel[LogLevel.Error=0]="Error",LogLevel[LogLevel.Warning=1]="Warning",LogLevel[LogLevel.Info=2]="Info",LogLevel[LogLevel.Verbose=3]="Verbose",LogLevel[LogLevel.Trace=4]="Trace"}(LogLevel||(LogLevel={}));var Logger=function(){function Logger(loggerOptions,packageName,packageVersion){this.level=LogLevel.Info;var defaultLoggerCallback=function(){};this.localCallback=loggerOptions.loggerCallback||defaultLoggerCallback,this.piiLoggingEnabled=loggerOptions.piiLoggingEnabled||!1,this.level="number"==typeof loggerOptions.logLevel?loggerOptions.logLevel:LogLevel.Info,this.correlationId=loggerOptions.correlationId||Constants.EMPTY_STRING,this.packageName=packageName||Constants.EMPTY_STRING,this.packageVersion=packageVersion||Constants.EMPTY_STRING}return Logger.prototype.clone=function(packageName,packageVersion,correlationId){return new Logger({loggerCallback:this.localCallback,piiLoggingEnabled:this.piiLoggingEnabled,logLevel:this.level,correlationId:correlationId||this.correlationId},packageName,packageVersion)},Logger.prototype.logMessage=function(logMessage,options){if(!(options.logLevel>this.level||!this.piiLoggingEnabled&&options.containsPii)){var timestamp=(new Date).toUTCString(),log=(StringUtils.isEmpty(options.correlationId)?StringUtils.isEmpty(this.correlationId)?"["+timestamp+"]":"["+timestamp+"] : ["+this.correlationId+"]":"["+timestamp+"] : ["+options.correlationId+"]")+" : "+this.packageName+"@"+this.packageVersion+" : "+LogLevel[options.logLevel]+" - "+logMessage;this.executeCallback(options.logLevel,log,options.containsPii||!1)}},Logger.prototype.executeCallback=function(level,message,containsPii){this.localCallback&&this.localCallback(level,message,containsPii)},Logger.prototype.error=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Error,containsPii:!1,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.errorPii=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Error,containsPii:!0,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.warning=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Warning,containsPii:!1,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.warningPii=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Warning,containsPii:!0,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.info=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Info,containsPii:!1,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.infoPii=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Info,containsPii:!0,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.verbose=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Verbose,containsPii:!1,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.verbosePii=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Verbose,containsPii:!0,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.trace=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Trace,containsPii:!1,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.tracePii=function(message,correlationId){this.logMessage(message,{logLevel:LogLevel.Trace,containsPii:!0,correlationId:correlationId||Constants.EMPTY_STRING})},Logger.prototype.isPiiLoggingEnabled=function(){return this.piiLoggingEnabled||!1},Logger}();export{LogLevel,Logger};