/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{ThrottlingConstants,CacheSchemaType,Constants,HeaderNames}from"../utils/Constants.js";import{ServerError}from"../error/ServerError.js";var ThrottlingUtils=function(){function ThrottlingUtils(){}return ThrottlingUtils.generateThrottlingStorageKey=function(thumbprint){return ThrottlingConstants.THROTTLING_PREFIX+"."+JSON.stringify(thumbprint)},ThrottlingUtils.preProcess=function(cacheManager,thumbprint){var _a,key=ThrottlingUtils.generateThrottlingStorageKey(thumbprint),value=cacheManager.getThrottlingCache(key);if(value){if(value.throttleTime<Date.now())return void cacheManager.removeItem(key,CacheSchemaType.THROTTLING);throw new ServerError((null===(_a=value.errorCodes)||void 0===_a?void 0:_a.join(" "))||Constants.EMPTY_STRING,value.errorMessage,value.subError)}},ThrottlingUtils.postProcess=function(cacheManager,thumbprint,response){if(ThrottlingUtils.checkResponseStatus(response)||ThrottlingUtils.checkResponseForRetryAfter(response)){var thumbprintValue={throttleTime:ThrottlingUtils.calculateThrottleTime(parseInt(response.headers[HeaderNames.RETRY_AFTER])),error:response.body.error,errorCodes:response.body.error_codes,errorMessage:response.body.error_description,subError:response.body.suberror};cacheManager.setThrottlingCache(ThrottlingUtils.generateThrottlingStorageKey(thumbprint),thumbprintValue)}},ThrottlingUtils.checkResponseStatus=function(response){return 429===response.status||response.status>=500&&response.status<600},ThrottlingUtils.checkResponseForRetryAfter=function(response){return!!response.headers&&(response.headers.hasOwnProperty(HeaderNames.RETRY_AFTER)&&(response.status<200||response.status>=300))},ThrottlingUtils.calculateThrottleTime=function(throttleTime){var time=throttleTime<=0?0:throttleTime,currentSeconds=Date.now()/1e3;return Math.floor(1e3*Math.min(currentSeconds+(time||ThrottlingConstants.DEFAULT_THROTTLE_TIME_SECONDS),currentSeconds+ThrottlingConstants.DEFAULT_MAX_THROTTLE_TIME_SECONDS))},ThrottlingUtils.removeThrottle=function(cacheManager,clientId,request,homeAccountIdentifier){var thumbprint={clientId:clientId,authority:request.authority,scopes:request.scopes,homeAccountIdentifier:homeAccountIdentifier,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},key=this.generateThrottlingStorageKey(thumbprint);return cacheManager.removeItem(key,CacheSchemaType.THROTTLING)},ThrottlingUtils}();export{ThrottlingUtils};