/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{__spreadArrays}from"../_virtual/_tslib.js";import{AADServerParamKeys,Constants,ResponseMode,OIDC_DEFAULT_SCOPES,SSOTypes,HeaderNames,CLIENT_INFO,ClaimsRequestKeys,PasswordGrantConstants,AuthenticationScheme,ThrottlingConstants}from"../utils/Constants.js";import{ScopeSet}from"./ScopeSet.js";import{ClientConfigurationError}from"../error/ClientConfigurationError.js";import{RequestValidator}from"./RequestValidator.js";import{StringUtils}from"../utils/StringUtils.js";var RequestParameterBuilder=function(){function RequestParameterBuilder(){this.parameters=new Map}return RequestParameterBuilder.prototype.addResponseTypeCode=function(){this.parameters.set(AADServerParamKeys.RESPONSE_TYPE,encodeURIComponent(Constants.CODE_RESPONSE_TYPE))},RequestParameterBuilder.prototype.addResponseTypeForTokenAndIdToken=function(){this.parameters.set(AADServerParamKeys.RESPONSE_TYPE,encodeURIComponent(Constants.TOKEN_RESPONSE_TYPE+" "+Constants.ID_TOKEN_RESPONSE_TYPE))},RequestParameterBuilder.prototype.addResponseMode=function(responseMode){this.parameters.set(AADServerParamKeys.RESPONSE_MODE,encodeURIComponent(responseMode||ResponseMode.QUERY))},RequestParameterBuilder.prototype.addNativeBroker=function(){this.parameters.set(AADServerParamKeys.NATIVE_BROKER,encodeURIComponent("1"))},RequestParameterBuilder.prototype.addScopes=function(scopes,addOidcScopes){void 0===addOidcScopes&&(addOidcScopes=!0);var requestScopes=addOidcScopes?__spreadArrays(scopes||[],OIDC_DEFAULT_SCOPES):scopes||[],scopeSet=new ScopeSet(requestScopes);this.parameters.set(AADServerParamKeys.SCOPE,encodeURIComponent(scopeSet.printScopes()))},RequestParameterBuilder.prototype.addClientId=function(clientId){this.parameters.set(AADServerParamKeys.CLIENT_ID,encodeURIComponent(clientId))},RequestParameterBuilder.prototype.addRedirectUri=function(redirectUri){RequestValidator.validateRedirectUri(redirectUri),this.parameters.set(AADServerParamKeys.REDIRECT_URI,encodeURIComponent(redirectUri))},RequestParameterBuilder.prototype.addPostLogoutRedirectUri=function(redirectUri){RequestValidator.validateRedirectUri(redirectUri),this.parameters.set(AADServerParamKeys.POST_LOGOUT_URI,encodeURIComponent(redirectUri))},RequestParameterBuilder.prototype.addIdTokenHint=function(idTokenHint){this.parameters.set(AADServerParamKeys.ID_TOKEN_HINT,encodeURIComponent(idTokenHint))},RequestParameterBuilder.prototype.addDomainHint=function(domainHint){this.parameters.set(SSOTypes.DOMAIN_HINT,encodeURIComponent(domainHint))},RequestParameterBuilder.prototype.addLoginHint=function(loginHint){this.parameters.set(SSOTypes.LOGIN_HINT,encodeURIComponent(loginHint))},RequestParameterBuilder.prototype.addCcsUpn=function(loginHint){this.parameters.set(HeaderNames.CCS_HEADER,encodeURIComponent("UPN:"+loginHint))},RequestParameterBuilder.prototype.addCcsOid=function(clientInfo){this.parameters.set(HeaderNames.CCS_HEADER,encodeURIComponent("Oid:"+clientInfo.uid+"@"+clientInfo.utid))},RequestParameterBuilder.prototype.addSid=function(sid){this.parameters.set(SSOTypes.SID,encodeURIComponent(sid))},RequestParameterBuilder.prototype.addClaims=function(claims,clientCapabilities){var mergedClaims=this.addClientCapabilitiesToClaims(claims,clientCapabilities);RequestValidator.validateClaims(mergedClaims),this.parameters.set(AADServerParamKeys.CLAIMS,encodeURIComponent(mergedClaims))},RequestParameterBuilder.prototype.addCorrelationId=function(correlationId){this.parameters.set(AADServerParamKeys.CLIENT_REQUEST_ID,encodeURIComponent(correlationId))},RequestParameterBuilder.prototype.addLibraryInfo=function(libraryInfo){this.parameters.set(AADServerParamKeys.X_CLIENT_SKU,libraryInfo.sku),this.parameters.set(AADServerParamKeys.X_CLIENT_VER,libraryInfo.version),libraryInfo.os&&this.parameters.set(AADServerParamKeys.X_CLIENT_OS,libraryInfo.os),libraryInfo.cpu&&this.parameters.set(AADServerParamKeys.X_CLIENT_CPU,libraryInfo.cpu)},RequestParameterBuilder.prototype.addApplicationTelemetry=function(appTelemetry){(null==appTelemetry?void 0:appTelemetry.appName)&&this.parameters.set(AADServerParamKeys.X_APP_NAME,appTelemetry.appName),(null==appTelemetry?void 0:appTelemetry.appVersion)&&this.parameters.set(AADServerParamKeys.X_APP_VER,appTelemetry.appVersion)},RequestParameterBuilder.prototype.addPrompt=function(prompt){RequestValidator.validatePrompt(prompt),this.parameters.set(""+AADServerParamKeys.PROMPT,encodeURIComponent(prompt))},RequestParameterBuilder.prototype.addState=function(state){StringUtils.isEmpty(state)||this.parameters.set(AADServerParamKeys.STATE,encodeURIComponent(state))},RequestParameterBuilder.prototype.addNonce=function(nonce){this.parameters.set(AADServerParamKeys.NONCE,encodeURIComponent(nonce))},RequestParameterBuilder.prototype.addCodeChallengeParams=function(codeChallenge,codeChallengeMethod){if(RequestValidator.validateCodeChallengeParams(codeChallenge,codeChallengeMethod),!codeChallenge||!codeChallengeMethod)throw ClientConfigurationError.createInvalidCodeChallengeParamsError();this.parameters.set(AADServerParamKeys.CODE_CHALLENGE,encodeURIComponent(codeChallenge)),this.parameters.set(AADServerParamKeys.CODE_CHALLENGE_METHOD,encodeURIComponent(codeChallengeMethod))},RequestParameterBuilder.prototype.addAuthorizationCode=function(code){this.parameters.set(AADServerParamKeys.CODE,encodeURIComponent(code))},RequestParameterBuilder.prototype.addDeviceCode=function(code){this.parameters.set(AADServerParamKeys.DEVICE_CODE,encodeURIComponent(code))},RequestParameterBuilder.prototype.addRefreshToken=function(refreshToken){this.parameters.set(AADServerParamKeys.REFRESH_TOKEN,encodeURIComponent(refreshToken))},RequestParameterBuilder.prototype.addCodeVerifier=function(codeVerifier){this.parameters.set(AADServerParamKeys.CODE_VERIFIER,encodeURIComponent(codeVerifier))},RequestParameterBuilder.prototype.addClientSecret=function(clientSecret){this.parameters.set(AADServerParamKeys.CLIENT_SECRET,encodeURIComponent(clientSecret))},RequestParameterBuilder.prototype.addClientAssertion=function(clientAssertion){StringUtils.isEmpty(clientAssertion)||this.parameters.set(AADServerParamKeys.CLIENT_ASSERTION,encodeURIComponent(clientAssertion))},RequestParameterBuilder.prototype.addClientAssertionType=function(clientAssertionType){StringUtils.isEmpty(clientAssertionType)||this.parameters.set(AADServerParamKeys.CLIENT_ASSERTION_TYPE,encodeURIComponent(clientAssertionType))},RequestParameterBuilder.prototype.addOboAssertion=function(oboAssertion){this.parameters.set(AADServerParamKeys.OBO_ASSERTION,encodeURIComponent(oboAssertion))},RequestParameterBuilder.prototype.addRequestTokenUse=function(tokenUse){this.parameters.set(AADServerParamKeys.REQUESTED_TOKEN_USE,encodeURIComponent(tokenUse))},RequestParameterBuilder.prototype.addGrantType=function(grantType){this.parameters.set(AADServerParamKeys.GRANT_TYPE,encodeURIComponent(grantType))},RequestParameterBuilder.prototype.addClientInfo=function(){this.parameters.set(CLIENT_INFO,"1")},RequestParameterBuilder.prototype.addExtraQueryParameters=function(eQparams){var _this=this;RequestValidator.sanitizeEQParams(eQparams,this.parameters),Object.keys(eQparams).forEach((function(key){_this.parameters.set(key,eQparams[key])}))},RequestParameterBuilder.prototype.addClientCapabilitiesToClaims=function(claims,clientCapabilities){var mergedClaims;if(claims)try{mergedClaims=JSON.parse(claims)}catch(e){throw ClientConfigurationError.createInvalidClaimsRequestError()}else mergedClaims={};return clientCapabilities&&clientCapabilities.length>0&&(mergedClaims.hasOwnProperty(ClaimsRequestKeys.ACCESS_TOKEN)||(mergedClaims[ClaimsRequestKeys.ACCESS_TOKEN]={}),mergedClaims[ClaimsRequestKeys.ACCESS_TOKEN][ClaimsRequestKeys.XMS_CC]={values:clientCapabilities}),JSON.stringify(mergedClaims)},RequestParameterBuilder.prototype.addUsername=function(username){this.parameters.set(PasswordGrantConstants.username,encodeURIComponent(username))},RequestParameterBuilder.prototype.addPassword=function(password){this.parameters.set(PasswordGrantConstants.password,encodeURIComponent(password))},RequestParameterBuilder.prototype.addPopToken=function(cnfString){StringUtils.isEmpty(cnfString)||(this.parameters.set(AADServerParamKeys.TOKEN_TYPE,AuthenticationScheme.POP),this.parameters.set(AADServerParamKeys.REQ_CNF,encodeURIComponent(cnfString)))},RequestParameterBuilder.prototype.addSshJwk=function(sshJwkString){StringUtils.isEmpty(sshJwkString)||(this.parameters.set(AADServerParamKeys.TOKEN_TYPE,AuthenticationScheme.SSH),this.parameters.set(AADServerParamKeys.REQ_CNF,encodeURIComponent(sshJwkString)))},RequestParameterBuilder.prototype.addServerTelemetry=function(serverTelemetryManager){this.parameters.set(AADServerParamKeys.X_CLIENT_CURR_TELEM,serverTelemetryManager.generateCurrentRequestHeaderValue()),this.parameters.set(AADServerParamKeys.X_CLIENT_LAST_TELEM,serverTelemetryManager.generateLastRequestHeaderValue())},RequestParameterBuilder.prototype.addThrottling=function(){this.parameters.set(AADServerParamKeys.X_MS_LIB_CAPABILITY,ThrottlingConstants.X_MS_LIB_CAPABILITY_VALUE)},RequestParameterBuilder.prototype.addLogoutHint=function(logoutHint){this.parameters.set(AADServerParamKeys.LOGOUT_HINT,encodeURIComponent(logoutHint))},RequestParameterBuilder.prototype.createQueryString=function(){var queryParameterArray=new Array;return this.parameters.forEach((function(value,key){queryParameterArray.push(key+"="+value)})),queryParameterArray.join("&")},RequestParameterBuilder}();export{RequestParameterBuilder};