/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{SERVER_TELEM_CONSTANTS,CacheOutcome,Constants,Separators}from"../../utils/Constants.js";import{ServerTelemetryEntity}from"../../cache/entities/ServerTelemetryEntity.js";import{StringUtils}from"../../utils/StringUtils.js";var ServerTelemetryManager=function(){function ServerTelemetryManager(telemetryRequest,cacheManager){this.cacheOutcome=CacheOutcome.NO_CACHE_HIT,this.cacheManager=cacheManager,this.apiId=telemetryRequest.apiId,this.correlationId=telemetryRequest.correlationId,this.wrapperSKU=telemetryRequest.wrapperSKU||Constants.EMPTY_STRING,this.wrapperVer=telemetryRequest.wrapperVer||Constants.EMPTY_STRING,this.telemetryCacheKey=SERVER_TELEM_CONSTANTS.CACHE_KEY+Separators.CACHE_KEY_SEPARATOR+telemetryRequest.clientId}return ServerTelemetryManager.prototype.generateCurrentRequestHeaderValue=function(){var request=""+this.apiId+SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR+this.cacheOutcome,platformFields=[this.wrapperSKU,this.wrapperVer].join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR),requestWithRegionDiscoveryFields=[request,this.getRegionDiscoveryFields()].join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR);return[SERVER_TELEM_CONSTANTS.SCHEMA_VERSION,requestWithRegionDiscoveryFields,platformFields].join(SERVER_TELEM_CONSTANTS.CATEGORY_SEPARATOR)},ServerTelemetryManager.prototype.generateLastRequestHeaderValue=function(){var lastRequests=this.getLastRequests(),maxErrors=ServerTelemetryManager.maxErrorsToSend(lastRequests),failedRequests=lastRequests.failedRequests.slice(0,2*maxErrors).join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR),errors=lastRequests.errors.slice(0,maxErrors).join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR),errorCount=lastRequests.errors.length,platformFields=[errorCount,maxErrors<errorCount?SERVER_TELEM_CONSTANTS.OVERFLOW_TRUE:SERVER_TELEM_CONSTANTS.OVERFLOW_FALSE].join(SERVER_TELEM_CONSTANTS.VALUE_SEPARATOR);return[SERVER_TELEM_CONSTANTS.SCHEMA_VERSION,lastRequests.cacheHits,failedRequests,errors,platformFields].join(SERVER_TELEM_CONSTANTS.CATEGORY_SEPARATOR)},ServerTelemetryManager.prototype.cacheFailedRequest=function(error){var lastRequests=this.getLastRequests();lastRequests.errors.length>=SERVER_TELEM_CONSTANTS.MAX_CACHED_ERRORS&&(lastRequests.failedRequests.shift(),lastRequests.failedRequests.shift(),lastRequests.errors.shift()),lastRequests.failedRequests.push(this.apiId,this.correlationId),StringUtils.isEmpty(error.subError)?StringUtils.isEmpty(error.errorCode)?error&&error.toString()?lastRequests.errors.push(error.toString()):lastRequests.errors.push(SERVER_TELEM_CONSTANTS.UNKNOWN_ERROR):lastRequests.errors.push(error.errorCode):lastRequests.errors.push(error.subError),this.cacheManager.setServerTelemetry(this.telemetryCacheKey,lastRequests)},ServerTelemetryManager.prototype.incrementCacheHits=function(){var lastRequests=this.getLastRequests();return lastRequests.cacheHits+=1,this.cacheManager.setServerTelemetry(this.telemetryCacheKey,lastRequests),lastRequests.cacheHits},ServerTelemetryManager.prototype.getLastRequests=function(){var initialValue=new ServerTelemetryEntity;return this.cacheManager.getServerTelemetry(this.telemetryCacheKey)||initialValue},ServerTelemetryManager.prototype.clearTelemetryCache=function(){var lastRequests=this.getLastRequests(),numErrorsFlushed=ServerTelemetryManager.maxErrorsToSend(lastRequests);if(numErrorsFlushed===lastRequests.errors.length)this.cacheManager.removeItem(this.telemetryCacheKey);else{var serverTelemEntity=new ServerTelemetryEntity;serverTelemEntity.failedRequests=lastRequests.failedRequests.slice(2*numErrorsFlushed),serverTelemEntity.errors=lastRequests.errors.slice(numErrorsFlushed),this.cacheManager.setServerTelemetry(this.telemetryCacheKey,serverTelemEntity)}},ServerTelemetryManager.maxErrorsToSend=function(serverTelemetryEntity){var i,maxErrors=0,dataSize=0,errorCount=serverTelemetryEntity.errors.length;for(i=0;i<errorCount;i++){var apiId=serverTelemetryEntity.failedRequests[2*i]||Constants.EMPTY_STRING,correlationId=serverTelemetryEntity.failedRequests[2*i+1]||Constants.EMPTY_STRING,errorCode=serverTelemetryEntity.errors[i]||Constants.EMPTY_STRING;if(!((dataSize+=apiId.toString().length+correlationId.toString().length+errorCode.length+3)<SERVER_TELEM_CONSTANTS.MAX_LAST_HEADER_BYTES))break;maxErrors+=1}return maxErrors},ServerTelemetryManager.prototype.getRegionDiscoveryFields=function(){var regionDiscoveryFields=[];return regionDiscoveryFields.push(this.regionUsed||Constants.EMPTY_STRING),regionDiscoveryFields.push(this.regionSource||Constants.EMPTY_STRING),regionDiscoveryFields.push(this.regionOutcome||Constants.EMPTY_STRING),regionDiscoveryFields.join(",")},ServerTelemetryManager.prototype.updateRegionDiscoveryMetadata=function(regionDiscoveryMetadata){this.regionUsed=regionDiscoveryMetadata.region_used,this.regionSource=regionDiscoveryMetadata.region_source,this.regionOutcome=regionDiscoveryMetadata.region_outcome},ServerTelemetryManager.prototype.setCacheOutcome=function(cacheOutcome){this.cacheOutcome=cacheOutcome},ServerTelemetryManager}();export{ServerTelemetryManager};