"use strict";function _interopDefault(ex){return ex&&"object"==typeof ex&&"default"in ex?ex.default:ex}Object.defineProperty(exports,"__esModule",{value:!0});var HttpMethod,HttpStatus,ProxyStatus,msalCommon=require("@azure/msal-common"),http=require("http"),http__default=_interopDefault(http),https=_interopDefault(require("https")),uuid=require("uuid"),crypto=_interopDefault(require("crypto")),jsonwebtoken=require("jsonwebtoken");!function(HttpMethod){HttpMethod.GET="get",HttpMethod.POST="post"}(HttpMethod||(HttpMethod={})),function(HttpStatus){HttpStatus[HttpStatus.SUCCESS_RANGE_START=200]="SUCCESS_RANGE_START",HttpStatus[HttpStatus.SUCCESS_RANGE_END=299]="SUCCESS_RANGE_END",HttpStatus[HttpStatus.REDIRECT=302]="REDIRECT",HttpStatus[HttpStatus.CLIENT_ERROR_RANGE_START=400]="CLIENT_ERROR_RANGE_START",HttpStatus[HttpStatus.CLIENT_ERROR_RANGE_END=499]="CLIENT_ERROR_RANGE_END",HttpStatus[HttpStatus.SERVER_ERROR_RANGE_START=500]="SERVER_ERROR_RANGE_START",HttpStatus[HttpStatus.SERVER_ERROR_RANGE_END=599]="SERVER_ERROR_RANGE_END"}(HttpStatus||(HttpStatus={})),function(ProxyStatus){ProxyStatus[ProxyStatus.SUCCESS_RANGE_START=200]="SUCCESS_RANGE_START",ProxyStatus[ProxyStatus.SUCCESS_RANGE_END=299]="SUCCESS_RANGE_END",ProxyStatus[ProxyStatus.SERVER_ERROR=500]="SERVER_ERROR"}(ProxyStatus||(ProxyStatus={}));const REGION_ENVIRONMENT_VARIABLE="REGION_NAME",RANDOM_OCTET_SIZE=32,Hash={SHA256:"sha256"},CharSet={CV_CHARSET:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-._~"},Constants={MSAL_SKU:"msal.js.node",JWT_BEARER_ASSERTION_TYPE:"urn:ietf:params:oauth:client-assertion-type:jwt-bearer",AUTHORIZATION_PENDING:"authorization_pending",HTTP_PROTOCOL:"http://",LOCALHOST:"localhost"};var ApiId;!function(ApiId){ApiId[ApiId.acquireTokenSilent=62]="acquireTokenSilent",ApiId[ApiId.acquireTokenByUsernamePassword=371]="acquireTokenByUsernamePassword",ApiId[ApiId.acquireTokenByDeviceCode=671]="acquireTokenByDeviceCode",ApiId[ApiId.acquireTokenByClientCredential=771]="acquireTokenByClientCredential",ApiId[ApiId.acquireTokenByCode=871]="acquireTokenByCode",ApiId[ApiId.acquireTokenByRefreshToken=872]="acquireTokenByRefreshToken"}(ApiId||(ApiId={}));const JwtConstants={ALGORITHM:"alg",RSA_256:"RS256",X5T:"x5t",X5C:"x5c",AUDIENCE:"aud",EXPIRATION_TIME:"exp",ISSUER:"iss",SUBJECT:"sub",NOT_BEFORE:"nbf",JWT_ID:"jti"},LOOPBACK_SERVER_CONSTANTS={INTERVAL_MS:100,TIMEOUT_MS:5e3};class NetworkUtils{static getNetworkResponse(headers,body,statusCode){return{headers:headers,body:body,status:statusCode}}static urlToHttpOptions(url){const options={protocol:url.protocol,hostname:url.hostname&&url.hostname.startsWith("[")?url.hostname.slice(1,-1):url.hostname,hash:url.hash,search:url.search,pathname:url.pathname,path:`${url.pathname||""}${url.search||""}`,href:url.href};return""!==url.port&&(options.port=Number(url.port)),(url.username||url.password)&&(options.auth=`${decodeURIComponent(url.username)}:${decodeURIComponent(url.password)}`),options}}class HttpClient{constructor(proxyUrl,customAgentOptions){this.proxyUrl=proxyUrl||"",this.customAgentOptions=customAgentOptions||{}}async sendGetRequestAsync(url,options){return this.proxyUrl?networkRequestViaProxy(url,this.proxyUrl,HttpMethod.GET,options,this.customAgentOptions):networkRequestViaHttps(url,HttpMethod.GET,options,this.customAgentOptions)}async sendPostRequestAsync(url,options,cancellationToken){return this.proxyUrl?networkRequestViaProxy(url,this.proxyUrl,HttpMethod.POST,options,this.customAgentOptions,cancellationToken):networkRequestViaHttps(url,HttpMethod.POST,options,this.customAgentOptions,cancellationToken)}}const networkRequestViaProxy=(destinationUrlString,proxyUrlString,httpMethod,options,agentOptions,timeout)=>{const destinationUrl=new URL(destinationUrlString),proxyUrl=new URL(proxyUrlString),headers=(null==options?void 0:options.headers)||{},tunnelRequestOptions={host:proxyUrl.hostname,port:proxyUrl.port,method:"CONNECT",path:destinationUrl.hostname,headers:headers};timeout&&(tunnelRequestOptions.timeout=timeout),agentOptions&&Object.keys(agentOptions).length&&(tunnelRequestOptions.agent=new http__default.Agent(agentOptions));let postRequestStringContent="";if(httpMethod===HttpMethod.POST){const body=(null==options?void 0:options.body)||"";postRequestStringContent=`Content-Type: application/x-www-form-urlencoded\r\nContent-Length: ${body.length}\r\n\r\n${body}`}const outgoingRequestString=`${httpMethod.toUpperCase()} ${destinationUrl.href} HTTP/1.1\r\nHost: ${destinationUrl.host}\r\nConnection: close\r\n`+postRequestStringContent+"\r\n";return new Promise(((resolve,reject)=>{const request=http__default.request(tunnelRequestOptions);tunnelRequestOptions.timeout&&request.on("timeout",(()=>{request.destroy(),reject(new Error("Request time out"))})),request.end(),request.on("connect",((response,socket)=>{const proxyStatusCode=(null==response?void 0:response.statusCode)||ProxyStatus.SERVER_ERROR;(proxyStatusCode<ProxyStatus.SUCCESS_RANGE_START||proxyStatusCode>ProxyStatus.SUCCESS_RANGE_END)&&(request.destroy(),socket.destroy(),reject(new Error(`Error connecting to proxy. Http status code: ${response.statusCode}. Http status message: ${(null==response?void 0:response.statusMessage)||"Unknown"}`))),tunnelRequestOptions.timeout&&(socket.setTimeout(tunnelRequestOptions.timeout),socket.on("timeout",(()=>{request.destroy(),socket.destroy(),reject(new Error("Request time out"))}))),socket.write(outgoingRequestString);const data=[];socket.on("data",(chunk=>{data.push(chunk)})),socket.on("end",(()=>{const dataStringArray=Buffer.concat([...data]).toString().split("\r\n"),httpStatusCode=parseInt(dataStringArray[0].split(" ")[1]),statusMessage=dataStringArray[0].split(" ").slice(2).join(" "),body=dataStringArray[dataStringArray.length-1],headersArray=dataStringArray.slice(1,dataStringArray.length-2),entries=new Map;headersArray.forEach((header=>{const headerKeyValue=header.split(new RegExp(/:\s(.*)/s)),headerKey=headerKeyValue[0];let headerValue=headerKeyValue[1];try{const object=JSON.parse(headerValue);object&&"object"==typeof object&&(headerValue=object)}catch(e){}entries.set(headerKey,headerValue)}));const parsedHeaders=Object.fromEntries(entries),networkResponse=NetworkUtils.getNetworkResponse(parsedHeaders,parseBody(httpStatusCode,statusMessage,parsedHeaders,body),httpStatusCode);(httpStatusCode<HttpStatus.SUCCESS_RANGE_START||httpStatusCode>HttpStatus.SUCCESS_RANGE_END)&&networkResponse.body.error!==Constants.AUTHORIZATION_PENDING&&request.destroy(),resolve(networkResponse)})),socket.on("error",(chunk=>{request.destroy(),socket.destroy(),reject(new Error(chunk.toString()))}))})),request.on("error",(chunk=>{request.destroy(),reject(new Error(chunk.toString()))}))}))},networkRequestViaHttps=(urlString,httpMethod,options,agentOptions,timeout)=>{const isPostRequest=httpMethod===HttpMethod.POST,body=(null==options?void 0:options.body)||"",url=new URL(urlString),customOptions={method:httpMethod,headers:(null==options?void 0:options.headers)||{},...NetworkUtils.urlToHttpOptions(url)};return timeout&&(customOptions.timeout=timeout),agentOptions&&Object.keys(agentOptions).length&&(customOptions.agent=new https.Agent(agentOptions)),isPostRequest&&(customOptions.headers={...customOptions.headers,"Content-Length":body.length}),new Promise(((resolve,reject)=>{const request=https.request(customOptions);timeout&&request.on("timeout",(()=>{request.destroy(),reject(new Error("Request time out"))})),isPostRequest&&request.write(body),request.end(),request.on("response",(response=>{const headers=response.headers,statusCode=response.statusCode,statusMessage=response.statusMessage,data=[];response.on("data",(chunk=>{data.push(chunk)})),response.on("end",(()=>{const body=Buffer.concat([...data]).toString(),parsedHeaders=headers,networkResponse=NetworkUtils.getNetworkResponse(parsedHeaders,parseBody(statusCode,statusMessage,parsedHeaders,body),statusCode);(statusCode<HttpStatus.SUCCESS_RANGE_START||statusCode>HttpStatus.SUCCESS_RANGE_END)&&networkResponse.body.error!==Constants.AUTHORIZATION_PENDING&&request.destroy(),resolve(networkResponse)}))})),request.on("error",(chunk=>{request.destroy(),reject(new Error(chunk.toString()))}))}))},parseBody=(statusCode,statusMessage,headers,body)=>{let parsedBody;try{parsedBody=JSON.parse(body)}catch(error){let errorType,errorDescriptionHelper;statusCode>=HttpStatus.CLIENT_ERROR_RANGE_START&&statusCode<=HttpStatus.CLIENT_ERROR_RANGE_END?(errorType="client_error",errorDescriptionHelper="A client"):statusCode>=HttpStatus.SERVER_ERROR_RANGE_START&&statusCode<=HttpStatus.SERVER_ERROR_RANGE_END?(errorType="server_error",errorDescriptionHelper="A server"):(errorType="unknown_error",errorDescriptionHelper="An unknown"),parsedBody={error:errorType,error_description:`${errorDescriptionHelper} error occured.\nHttp status code: ${statusCode}\nHttp status message: ${statusMessage||"Unknown"}\nHeaders: ${JSON.stringify(headers)}`}}return parsedBody},DEFAULT_AUTH_OPTIONS={clientId:msalCommon.Constants.EMPTY_STRING,authority:msalCommon.Constants.DEFAULT_AUTHORITY,clientSecret:msalCommon.Constants.EMPTY_STRING,clientAssertion:msalCommon.Constants.EMPTY_STRING,clientCertificate:{thumbprint:msalCommon.Constants.EMPTY_STRING,privateKey:msalCommon.Constants.EMPTY_STRING,x5c:msalCommon.Constants.EMPTY_STRING},knownAuthorities:[],cloudDiscoveryMetadata:msalCommon.Constants.EMPTY_STRING,authorityMetadata:msalCommon.Constants.EMPTY_STRING,clientCapabilities:[],protocolMode:msalCommon.ProtocolMode.AAD,azureCloudOptions:{azureCloudInstance:msalCommon.AzureCloudInstance.None,tenant:msalCommon.Constants.EMPTY_STRING},skipAuthorityMetadataCache:!1},DEFAULT_CACHE_OPTIONS={},DEFAULT_LOGGER_OPTIONS={loggerCallback:()=>{},piiLoggingEnabled:!1,logLevel:msalCommon.LogLevel.Info},DEFAULT_SYSTEM_OPTIONS={loggerOptions:DEFAULT_LOGGER_OPTIONS,networkClient:new HttpClient,proxyUrl:msalCommon.Constants.EMPTY_STRING,customAgentOptions:{}},DEFAULT_TELEMETRY_OPTIONS={application:{appName:msalCommon.Constants.EMPTY_STRING,appVersion:msalCommon.Constants.EMPTY_STRING}};function buildAppConfiguration({auth:auth,broker:broker,cache:cache,system:system,telemetry:telemetry}){const systemOptions={...DEFAULT_SYSTEM_OPTIONS,networkClient:new HttpClient(null==system?void 0:system.proxyUrl,null==system?void 0:system.customAgentOptions),loggerOptions:(null==system?void 0:system.loggerOptions)||DEFAULT_LOGGER_OPTIONS};return{auth:{...DEFAULT_AUTH_OPTIONS,...auth},broker:{...broker},cache:{...DEFAULT_CACHE_OPTIONS,...cache},system:{...systemOptions,...system},telemetry:{...DEFAULT_TELEMETRY_OPTIONS,...telemetry}}}class GuidGenerator{generateGuid(){return uuid.v4()}isGuid(guid){return/^[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(guid)}}class EncodingUtils{static base64Encode(str,encoding){return Buffer.from(str,encoding).toString("base64")}static base64EncodeUrl(str,encoding){return EncodingUtils.base64Encode(str,encoding).replace(/=/g,msalCommon.Constants.EMPTY_STRING).replace(/\+/g,"-").replace(/\//g,"_")}static base64Decode(base64Str){return Buffer.from(base64Str,"base64").toString("utf8")}static base64DecodeUrl(base64Str){let str=base64Str.replace(/-/g,"+").replace(/_/g,"/");for(;str.length%4;)str+="=";return EncodingUtils.base64Decode(str)}}class HashUtils{sha256(buffer){return crypto.createHash(Hash.SHA256).update(buffer).digest()}}class PkceGenerator{constructor(){this.hashUtils=new HashUtils}async generatePkceCodes(){const verifier=this.generateCodeVerifier();return{verifier:verifier,challenge:this.generateCodeChallengeFromVerifier(verifier)}}generateCodeVerifier(){const charArr=[],maxNumber=256-256%CharSet.CV_CHARSET.length;for(;charArr.length<=RANDOM_OCTET_SIZE;){const byte=crypto.randomBytes(1)[0];if(byte>=maxNumber)continue;const index=byte%CharSet.CV_CHARSET.length;charArr.push(CharSet.CV_CHARSET[index])}const verifier=charArr.join(msalCommon.Constants.EMPTY_STRING);return EncodingUtils.base64EncodeUrl(verifier)}generateCodeChallengeFromVerifier(codeVerifier){return EncodingUtils.base64EncodeUrl(this.hashUtils.sha256(codeVerifier).toString("base64"),"base64")}}class CryptoProvider{constructor(){this.pkceGenerator=new PkceGenerator,this.guidGenerator=new GuidGenerator,this.hashUtils=new HashUtils}createNewGuid(){return this.guidGenerator.generateGuid()}base64Encode(input){return EncodingUtils.base64Encode(input)}base64Decode(input){return EncodingUtils.base64Decode(input)}generatePkceCodes(){return this.pkceGenerator.generatePkceCodes()}getPublicKeyThumbprint(){throw new Error("Method not implemented.")}removeTokenBindingKey(){throw new Error("Method not implemented.")}clearKeystore(){throw new Error("Method not implemented.")}signJwt(){throw new Error("Method not implemented.")}async hashString(plainText){return EncodingUtils.base64EncodeUrl(this.hashUtils.sha256(plainText).toString("base64"),"base64")}}class Deserializer{static deserializeJSONBlob(jsonFile){return msalCommon.StringUtils.isEmpty(jsonFile)?{}:JSON.parse(jsonFile)}static deserializeAccounts(accounts){const accountObjects={};return accounts&&Object.keys(accounts).map((function(key){const serializedAcc=accounts[key],mappedAcc={homeAccountId:serializedAcc.home_account_id,environment:serializedAcc.environment,realm:serializedAcc.realm,localAccountId:serializedAcc.local_account_id,username:serializedAcc.username,authorityType:serializedAcc.authority_type,name:serializedAcc.name,clientInfo:serializedAcc.client_info,lastModificationTime:serializedAcc.last_modification_time,lastModificationApp:serializedAcc.last_modification_app},account=new msalCommon.AccountEntity;msalCommon.CacheManager.toObject(account,mappedAcc),accountObjects[key]=account})),accountObjects}static deserializeIdTokens(idTokens){const idObjects={};return idTokens&&Object.keys(idTokens).map((function(key){const serializedIdT=idTokens[key],mappedIdT={homeAccountId:serializedIdT.home_account_id,environment:serializedIdT.environment,credentialType:serializedIdT.credential_type,clientId:serializedIdT.client_id,secret:serializedIdT.secret,realm:serializedIdT.realm},idToken=new msalCommon.IdTokenEntity;msalCommon.CacheManager.toObject(idToken,mappedIdT),idObjects[key]=idToken})),idObjects}static deserializeAccessTokens(accessTokens){const atObjects={};return accessTokens&&Object.keys(accessTokens).map((function(key){const serializedAT=accessTokens[key],mappedAT={homeAccountId:serializedAT.home_account_id,environment:serializedAT.environment,credentialType:serializedAT.credential_type,clientId:serializedAT.client_id,secret:serializedAT.secret,realm:serializedAT.realm,target:serializedAT.target,cachedAt:serializedAT.cached_at,expiresOn:serializedAT.expires_on,extendedExpiresOn:serializedAT.extended_expires_on,refreshOn:serializedAT.refresh_on,keyId:serializedAT.key_id,tokenType:serializedAT.token_type,requestedClaims:serializedAT.requestedClaims,requestedClaimsHash:serializedAT.requestedClaimsHash,userAssertionHash:serializedAT.userAssertionHash},accessToken=new msalCommon.AccessTokenEntity;msalCommon.CacheManager.toObject(accessToken,mappedAT),atObjects[key]=accessToken})),atObjects}static deserializeRefreshTokens(refreshTokens){const rtObjects={};return refreshTokens&&Object.keys(refreshTokens).map((function(key){const serializedRT=refreshTokens[key],mappedRT={homeAccountId:serializedRT.home_account_id,environment:serializedRT.environment,credentialType:serializedRT.credential_type,clientId:serializedRT.client_id,secret:serializedRT.secret,familyId:serializedRT.family_id,target:serializedRT.target,realm:serializedRT.realm},refreshToken=new msalCommon.RefreshTokenEntity;msalCommon.CacheManager.toObject(refreshToken,mappedRT),rtObjects[key]=refreshToken})),rtObjects}static deserializeAppMetadata(appMetadata){const appMetadataObjects={};return appMetadata&&Object.keys(appMetadata).map((function(key){const serializedAmdt=appMetadata[key],mappedAmd={clientId:serializedAmdt.client_id,environment:serializedAmdt.environment,familyId:serializedAmdt.family_id},amd=new msalCommon.AppMetadataEntity;msalCommon.CacheManager.toObject(amd,mappedAmd),appMetadataObjects[key]=amd})),appMetadataObjects}static deserializeAllCache(jsonCache){return{accounts:jsonCache.Account?this.deserializeAccounts(jsonCache.Account):{},idTokens:jsonCache.IdToken?this.deserializeIdTokens(jsonCache.IdToken):{},accessTokens:jsonCache.AccessToken?this.deserializeAccessTokens(jsonCache.AccessToken):{},refreshTokens:jsonCache.RefreshToken?this.deserializeRefreshTokens(jsonCache.RefreshToken):{},appMetadata:jsonCache.AppMetadata?this.deserializeAppMetadata(jsonCache.AppMetadata):{}}}}class Serializer{static serializeJSONBlob(data){return JSON.stringify(data)}static serializeAccounts(accCache){const accounts={};return Object.keys(accCache).map((function(key){const accountEntity=accCache[key];accounts[key]={home_account_id:accountEntity.homeAccountId,environment:accountEntity.environment,realm:accountEntity.realm,local_account_id:accountEntity.localAccountId,username:accountEntity.username,authority_type:accountEntity.authorityType,name:accountEntity.name,client_info:accountEntity.clientInfo,last_modification_time:accountEntity.lastModificationTime,last_modification_app:accountEntity.lastModificationApp}})),accounts}static serializeIdTokens(idTCache){const idTokens={};return Object.keys(idTCache).map((function(key){const idTEntity=idTCache[key];idTokens[key]={home_account_id:idTEntity.homeAccountId,environment:idTEntity.environment,credential_type:idTEntity.credentialType,client_id:idTEntity.clientId,secret:idTEntity.secret,realm:idTEntity.realm}})),idTokens}static serializeAccessTokens(atCache){const accessTokens={};return Object.keys(atCache).map((function(key){const atEntity=atCache[key];accessTokens[key]={home_account_id:atEntity.homeAccountId,environment:atEntity.environment,credential_type:atEntity.credentialType,client_id:atEntity.clientId,secret:atEntity.secret,realm:atEntity.realm,target:atEntity.target,cached_at:atEntity.cachedAt,expires_on:atEntity.expiresOn,extended_expires_on:atEntity.extendedExpiresOn,refresh_on:atEntity.refreshOn,key_id:atEntity.keyId,token_type:atEntity.tokenType,requestedClaims:atEntity.requestedClaims,requestedClaimsHash:atEntity.requestedClaimsHash,userAssertionHash:atEntity.userAssertionHash}})),accessTokens}static serializeRefreshTokens(rtCache){const refreshTokens={};return Object.keys(rtCache).map((function(key){const rtEntity=rtCache[key];refreshTokens[key]={home_account_id:rtEntity.homeAccountId,environment:rtEntity.environment,credential_type:rtEntity.credentialType,client_id:rtEntity.clientId,secret:rtEntity.secret,family_id:rtEntity.familyId,target:rtEntity.target,realm:rtEntity.realm}})),refreshTokens}static serializeAppMetadata(amdtCache){const appMetadata={};return Object.keys(amdtCache).map((function(key){const amdtEntity=amdtCache[key];appMetadata[key]={client_id:amdtEntity.clientId,environment:amdtEntity.environment,family_id:amdtEntity.familyId}})),appMetadata}static serializeAllCache(inMemCache){return{Account:this.serializeAccounts(inMemCache.accounts),IdToken:this.serializeIdTokens(inMemCache.idTokens),AccessToken:this.serializeAccessTokens(inMemCache.accessTokens),RefreshToken:this.serializeRefreshTokens(inMemCache.refreshTokens),AppMetadata:this.serializeAppMetadata(inMemCache.appMetadata)}}}class NodeStorage extends msalCommon.CacheManager{constructor(logger,clientId,cryptoImpl){super(clientId,cryptoImpl,logger),this.cache={},this.changeEmitters=[],this.logger=logger}registerChangeEmitter(func){this.changeEmitters.push(func)}emitChange(){this.changeEmitters.forEach((func=>func.call(null)))}cacheToInMemoryCache(cache){const inMemoryCache={accounts:{},idTokens:{},accessTokens:{},refreshTokens:{},appMetadata:{}};for(const key in cache)if(cache[key]instanceof msalCommon.AccountEntity)inMemoryCache.accounts[key]=cache[key];else if(cache[key]instanceof msalCommon.IdTokenEntity)inMemoryCache.idTokens[key]=cache[key];else if(cache[key]instanceof msalCommon.AccessTokenEntity)inMemoryCache.accessTokens[key]=cache[key];else if(cache[key]instanceof msalCommon.RefreshTokenEntity)inMemoryCache.refreshTokens[key]=cache[key];else{if(!(cache[key]instanceof msalCommon.AppMetadataEntity))continue;inMemoryCache.appMetadata[key]=cache[key]}return inMemoryCache}inMemoryCacheToCache(inMemoryCache){let cache=this.getCache();return cache={...cache,...inMemoryCache.accounts,...inMemoryCache.idTokens,...inMemoryCache.accessTokens,...inMemoryCache.refreshTokens,...inMemoryCache.appMetadata},cache}getInMemoryCache(){this.logger.trace("Getting in-memory cache");return this.cacheToInMemoryCache(this.getCache())}setInMemoryCache(inMemoryCache){this.logger.trace("Setting in-memory cache");const cache=this.inMemoryCacheToCache(inMemoryCache);this.setCache(cache),this.emitChange()}getCache(){return this.logger.trace("Getting cache key-value store"),this.cache}setCache(cache){this.logger.trace("Setting cache key value store"),this.cache=cache,this.emitChange()}getItem(key){this.logger.tracePii(`Item key: ${key}`);return this.getCache()[key]}setItem(key,value){this.logger.tracePii(`Item key: ${key}`);const cache=this.getCache();cache[key]=value,this.setCache(cache)}getAccountKeys(){const inMemoryCache=this.getInMemoryCache();return Object.keys(inMemoryCache.accounts)}getTokenKeys(){const inMemoryCache=this.getInMemoryCache();return{idToken:Object.keys(inMemoryCache.idTokens),accessToken:Object.keys(inMemoryCache.accessTokens),refreshToken:Object.keys(inMemoryCache.refreshTokens)}}getAccount(accountKey){const account=this.getItem(accountKey);return msalCommon.AccountEntity.isAccountEntity(account)?account:null}setAccount(account){const accountKey=account.generateAccountKey();this.setItem(accountKey,account)}getIdTokenCredential(idTokenKey){const idToken=this.getItem(idTokenKey);return msalCommon.IdTokenEntity.isIdTokenEntity(idToken)?idToken:null}setIdTokenCredential(idToken){const idTokenKey=idToken.generateCredentialKey();this.setItem(idTokenKey,idToken)}getAccessTokenCredential(accessTokenKey){const accessToken=this.getItem(accessTokenKey);return msalCommon.AccessTokenEntity.isAccessTokenEntity(accessToken)?accessToken:null}setAccessTokenCredential(accessToken){const accessTokenKey=accessToken.generateCredentialKey();this.setItem(accessTokenKey,accessToken)}getRefreshTokenCredential(refreshTokenKey){const refreshToken=this.getItem(refreshTokenKey);return msalCommon.RefreshTokenEntity.isRefreshTokenEntity(refreshToken)?refreshToken:null}setRefreshTokenCredential(refreshToken){const refreshTokenKey=refreshToken.generateCredentialKey();this.setItem(refreshTokenKey,refreshToken)}getAppMetadata(appMetadataKey){const appMetadata=this.getItem(appMetadataKey);return msalCommon.AppMetadataEntity.isAppMetadataEntity(appMetadataKey,appMetadata)?appMetadata:null}setAppMetadata(appMetadata){const appMetadataKey=appMetadata.generateAppMetadataKey();this.setItem(appMetadataKey,appMetadata)}getServerTelemetry(serverTelemetrykey){const serverTelemetryEntity=this.getItem(serverTelemetrykey);return serverTelemetryEntity&&msalCommon.ServerTelemetryEntity.isServerTelemetryEntity(serverTelemetrykey,serverTelemetryEntity)?serverTelemetryEntity:null}setServerTelemetry(serverTelemetryKey,serverTelemetry){this.setItem(serverTelemetryKey,serverTelemetry)}getAuthorityMetadata(key){const authorityMetadataEntity=this.getItem(key);return authorityMetadataEntity&&msalCommon.AuthorityMetadataEntity.isAuthorityMetadataEntity(key,authorityMetadataEntity)?authorityMetadataEntity:null}getAuthorityMetadataKeys(){return this.getKeys().filter((key=>this.isAuthorityMetadata(key)))}setAuthorityMetadata(key,metadata){this.setItem(key,metadata)}getThrottlingCache(throttlingCacheKey){const throttlingCache=this.getItem(throttlingCacheKey);return throttlingCache&&msalCommon.ThrottlingEntity.isThrottlingEntity(throttlingCacheKey,throttlingCache)?throttlingCache:null}setThrottlingCache(throttlingCacheKey,throttlingCache){this.setItem(throttlingCacheKey,throttlingCache)}removeItem(key){this.logger.tracePii(`Item key: ${key}`);let result=!1;const cache=this.getCache();return cache[key]&&(delete cache[key],result=!0),result&&(this.setCache(cache),this.emitChange()),result}containsKey(key){return this.getKeys().includes(key)}getKeys(){this.logger.trace("Retrieving all cache keys");const cache=this.getCache();return[...Object.keys(cache)]}async clear(){this.logger.trace("Clearing cache entries created by MSAL");this.getKeys().forEach((key=>{this.removeItem(key)})),this.emitChange()}static generateInMemoryCache(cache){return Deserializer.deserializeAllCache(Deserializer.deserializeJSONBlob(cache))}static generateJsonCache(inMemoryCache){return Serializer.serializeAllCache(inMemoryCache)}updateCredentialCacheKey(currentCacheKey,credential){const updatedCacheKey=credential.generateCredentialKey();if(currentCacheKey!==updatedCacheKey){const cacheItem=this.getItem(currentCacheKey);if(cacheItem)return this.removeItem(currentCacheKey),this.setItem(updatedCacheKey,cacheItem),this.logger.verbose(`Updated an outdated ${credential.credentialType} cache key`),updatedCacheKey;this.logger.error(`Attempted to update an outdated ${credential.credentialType} cache key but no item matching the outdated key was found in storage`)}return currentCacheKey}}const defaultSerializedCache={Account:{},IdToken:{},AccessToken:{},RefreshToken:{},AppMetadata:{}};class TokenCache{constructor(storage,logger,cachePlugin){this.cacheHasChanged=!1,this.storage=storage,this.storage.registerChangeEmitter(this.handleChangeEvent.bind(this)),cachePlugin&&(this.persistence=cachePlugin),this.logger=logger}hasChanged(){return this.cacheHasChanged}serialize(){this.logger.trace("Serializing in-memory cache");let finalState=Serializer.serializeAllCache(this.storage.getInMemoryCache());return msalCommon.StringUtils.isEmpty(this.cacheSnapshot)?this.logger.trace("No cache snapshot to merge"):(this.logger.trace("Reading cache snapshot from disk"),finalState=this.mergeState(JSON.parse(this.cacheSnapshot),finalState)),this.cacheHasChanged=!1,JSON.stringify(finalState)}deserialize(cache){if(this.logger.trace("Deserializing JSON to in-memory cache"),this.cacheSnapshot=cache,msalCommon.StringUtils.isEmpty(this.cacheSnapshot))this.logger.trace("No cache snapshot to deserialize");else{this.logger.trace("Reading cache snapshot from disk");const deserializedCache=Deserializer.deserializeAllCache(this.overlayDefaults(JSON.parse(this.cacheSnapshot)));this.storage.setInMemoryCache(deserializedCache)}}getKVStore(){return this.storage.getCache()}async getAllAccounts(){let cacheContext;this.logger.trace("getAllAccounts called");try{return this.persistence&&(cacheContext=new msalCommon.TokenCacheContext(this,!1),await this.persistence.beforeCacheAccess(cacheContext)),this.storage.getAllAccounts()}finally{this.persistence&&cacheContext&&await this.persistence.afterCacheAccess(cacheContext)}}async getAccountByHomeId(homeAccountId){const allAccounts=await this.getAllAccounts();return!msalCommon.StringUtils.isEmpty(homeAccountId)&&allAccounts&&allAccounts.length&&allAccounts.filter((accountObj=>accountObj.homeAccountId===homeAccountId))[0]||null}async getAccountByLocalId(localAccountId){const allAccounts=await this.getAllAccounts();return!msalCommon.StringUtils.isEmpty(localAccountId)&&allAccounts&&allAccounts.length&&allAccounts.filter((accountObj=>accountObj.localAccountId===localAccountId))[0]||null}async removeAccount(account){let cacheContext;this.logger.trace("removeAccount called");try{this.persistence&&(cacheContext=new msalCommon.TokenCacheContext(this,!0),await this.persistence.beforeCacheAccess(cacheContext)),await this.storage.removeAccount(msalCommon.AccountEntity.generateAccountCacheKey(account))}finally{this.persistence&&cacheContext&&await this.persistence.afterCacheAccess(cacheContext)}}handleChangeEvent(){this.cacheHasChanged=!0}mergeState(oldState,currentState){this.logger.trace("Merging in-memory cache with cache snapshot");const stateAfterRemoval=this.mergeRemovals(oldState,currentState);return this.mergeUpdates(stateAfterRemoval,currentState)}mergeUpdates(oldState,newState){return Object.keys(newState).forEach((newKey=>{const newValue=newState[newKey];if(oldState.hasOwnProperty(newKey)){const newValueNotNull=null!==newValue,newValueIsObject="object"==typeof newValue,newValueIsNotArray=!Array.isArray(newValue),oldStateNotUndefinedOrNull=void 0!==oldState[newKey]&&null!==oldState[newKey];newValueNotNull&&newValueIsObject&&newValueIsNotArray&&oldStateNotUndefinedOrNull?this.mergeUpdates(oldState[newKey],newValue):oldState[newKey]=newValue}else null!==newValue&&(oldState[newKey]=newValue)})),oldState}mergeRemovals(oldState,newState){this.logger.trace("Remove updated entries in cache");const accounts=oldState.Account?this.mergeRemovalsDict(oldState.Account,newState.Account):oldState.Account,accessTokens=oldState.AccessToken?this.mergeRemovalsDict(oldState.AccessToken,newState.AccessToken):oldState.AccessToken,refreshTokens=oldState.RefreshToken?this.mergeRemovalsDict(oldState.RefreshToken,newState.RefreshToken):oldState.RefreshToken,idTokens=oldState.IdToken?this.mergeRemovalsDict(oldState.IdToken,newState.IdToken):oldState.IdToken,appMetadata=oldState.AppMetadata?this.mergeRemovalsDict(oldState.AppMetadata,newState.AppMetadata):oldState.AppMetadata;return{...oldState,Account:accounts,AccessToken:accessTokens,RefreshToken:refreshTokens,IdToken:idTokens,AppMetadata:appMetadata}}mergeRemovalsDict(oldState,newState){const finalState={...oldState};return Object.keys(oldState).forEach((oldKey=>{newState&&newState.hasOwnProperty(oldKey)||delete finalState[oldKey]})),finalState}overlayDefaults(passedInCache){return this.logger.trace("Overlaying input cache with the default cache"),{Account:{...defaultSerializedCache.Account,...passedInCache.Account},IdToken:{...defaultSerializedCache.IdToken,...passedInCache.IdToken},AccessToken:{...defaultSerializedCache.AccessToken,...passedInCache.AccessToken},RefreshToken:{...defaultSerializedCache.RefreshToken,...passedInCache.RefreshToken},AppMetadata:{...defaultSerializedCache.AppMetadata,...passedInCache.AppMetadata}}}}const name="@azure/msal-node",version="1.17.3",NodeAuthErrorMessage={invalidLoopbackAddressType:{code:"invalid_loopback_server_address_type",desc:"Loopback server address is not type string. This is unexpected."},unableToLoadRedirectUri:{code:"unable_to_load_redirectUrl",desc:"Loopback server callback was invoked without a url. This is unexpected."},noAuthCodeInResponse:{code:"no_auth_code_in_response",desc:"No auth code found in the server response. Please check your network trace to determine what happened."},noLoopbackServerExists:{code:"no_loopback_server_exists",desc:"No loopback server exists yet."},loopbackServerAlreadyExists:{code:"loopback_server_already_exists",desc:"Loopback server already exists. Cannot create another."},loopbackServerTimeout:{code:"loopback_server_timeout",desc:"Timed out waiting for auth code listener to be registered."},stateNotFoundError:{code:"state_not_found",desc:"State not found. Please verify that the request originated from msal."}};class NodeAuthError extends msalCommon.AuthError{constructor(errorCode,errorMessage){super(errorCode,errorMessage),this.name="NodeAuthError"}static createInvalidLoopbackAddressTypeError(){return new NodeAuthError(NodeAuthErrorMessage.invalidLoopbackAddressType.code,`${NodeAuthErrorMessage.invalidLoopbackAddressType.desc}`)}static createUnableToLoadRedirectUrlError(){return new NodeAuthError(NodeAuthErrorMessage.unableToLoadRedirectUri.code,`${NodeAuthErrorMessage.unableToLoadRedirectUri.desc}`)}static createNoAuthCodeInResponseError(){return new NodeAuthError(NodeAuthErrorMessage.noAuthCodeInResponse.code,`${NodeAuthErrorMessage.noAuthCodeInResponse.desc}`)}static createNoLoopbackServerExistsError(){return new NodeAuthError(NodeAuthErrorMessage.noLoopbackServerExists.code,`${NodeAuthErrorMessage.noLoopbackServerExists.desc}`)}static createLoopbackServerAlreadyExistsError(){return new NodeAuthError(NodeAuthErrorMessage.loopbackServerAlreadyExists.code,`${NodeAuthErrorMessage.loopbackServerAlreadyExists.desc}`)}static createLoopbackServerTimeoutError(){return new NodeAuthError(NodeAuthErrorMessage.loopbackServerTimeout.code,`${NodeAuthErrorMessage.loopbackServerTimeout.desc}`)}static createStateNotFoundError(){return new NodeAuthError(NodeAuthErrorMessage.stateNotFoundError.code,NodeAuthErrorMessage.stateNotFoundError.desc)}}class ClientApplication{constructor(configuration){this.config=buildAppConfiguration(configuration),this.cryptoProvider=new CryptoProvider,this.logger=new msalCommon.Logger(this.config.system.loggerOptions,name,version),this.storage=new NodeStorage(this.logger,this.config.auth.clientId,this.cryptoProvider),this.tokenCache=new TokenCache(this.storage,this.logger,this.config.cache.cachePlugin)}async getAuthCodeUrl(request){this.logger.info("getAuthCodeUrl called",request.correlationId);const validRequest={...request,...await this.initializeBaseRequest(request),responseMode:request.responseMode||msalCommon.ResponseMode.QUERY,authenticationScheme:msalCommon.AuthenticationScheme.BEARER},authClientConfig=await this.buildOauthClientConfiguration(validRequest.authority,validRequest.correlationId,void 0,void 0,request.azureCloudOptions),authorizationCodeClient=new msalCommon.AuthorizationCodeClient(authClientConfig);return this.logger.verbose("Auth code client created",validRequest.correlationId),authorizationCodeClient.getAuthCodeUrl(validRequest)}async acquireTokenByCode(request,authCodePayLoad){this.logger.info("acquireTokenByCode called"),request.state&&authCodePayLoad&&(this.logger.info("acquireTokenByCode - validating state"),this.validateState(request.state,authCodePayLoad.state||""),authCodePayLoad={...authCodePayLoad,state:""});const validRequest={...request,...await this.initializeBaseRequest(request),authenticationScheme:msalCommon.AuthenticationScheme.BEARER},serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenByCode,validRequest.correlationId);try{const authClientConfig=await this.buildOauthClientConfiguration(validRequest.authority,validRequest.correlationId,serverTelemetryManager,void 0,request.azureCloudOptions),authorizationCodeClient=new msalCommon.AuthorizationCodeClient(authClientConfig);return this.logger.verbose("Auth code client created",validRequest.correlationId),authorizationCodeClient.acquireToken(validRequest,authCodePayLoad)}catch(e){throw e instanceof msalCommon.AuthError&&e.setCorrelationId(validRequest.correlationId),serverTelemetryManager.cacheFailedRequest(e),e}}async acquireTokenByRefreshToken(request){this.logger.info("acquireTokenByRefreshToken called",request.correlationId);const validRequest={...request,...await this.initializeBaseRequest(request),authenticationScheme:msalCommon.AuthenticationScheme.BEARER},serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenByRefreshToken,validRequest.correlationId);try{const refreshTokenClientConfig=await this.buildOauthClientConfiguration(validRequest.authority,validRequest.correlationId,serverTelemetryManager,void 0,request.azureCloudOptions),refreshTokenClient=new msalCommon.RefreshTokenClient(refreshTokenClientConfig);return this.logger.verbose("Refresh token client created",validRequest.correlationId),refreshTokenClient.acquireToken(validRequest)}catch(e){throw e instanceof msalCommon.AuthError&&e.setCorrelationId(validRequest.correlationId),serverTelemetryManager.cacheFailedRequest(e),e}}async acquireTokenSilent(request){const validRequest={...request,...await this.initializeBaseRequest(request),forceRefresh:request.forceRefresh||!1},serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenSilent,validRequest.correlationId,validRequest.forceRefresh);try{const silentFlowClientConfig=await this.buildOauthClientConfiguration(validRequest.authority,validRequest.correlationId,serverTelemetryManager,void 0,request.azureCloudOptions),silentFlowClient=new msalCommon.SilentFlowClient(silentFlowClientConfig);return this.logger.verbose("Silent flow client created",validRequest.correlationId),silentFlowClient.acquireToken(validRequest)}catch(e){throw e instanceof msalCommon.AuthError&&e.setCorrelationId(validRequest.correlationId),serverTelemetryManager.cacheFailedRequest(e),e}}async acquireTokenByUsernamePassword(request){this.logger.info("acquireTokenByUsernamePassword called",request.correlationId);const validRequest={...request,...await this.initializeBaseRequest(request)},serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenByUsernamePassword,validRequest.correlationId);try{const usernamePasswordClientConfig=await this.buildOauthClientConfiguration(validRequest.authority,validRequest.correlationId,serverTelemetryManager,void 0,request.azureCloudOptions),usernamePasswordClient=new msalCommon.UsernamePasswordClient(usernamePasswordClientConfig);return this.logger.verbose("Username password client created",validRequest.correlationId),usernamePasswordClient.acquireToken(validRequest)}catch(e){throw e instanceof msalCommon.AuthError&&e.setCorrelationId(validRequest.correlationId),serverTelemetryManager.cacheFailedRequest(e),e}}getTokenCache(){return this.logger.info("getTokenCache called"),this.tokenCache}validateState(state,cachedState){if(!state)throw NodeAuthError.createStateNotFoundError();if(state!==cachedState)throw msalCommon.ClientAuthError.createStateMismatchError()}getLogger(){return this.logger}setLogger(logger){this.logger=logger}async buildOauthClientConfiguration(authority,requestCorrelationId,serverTelemetryManager,azureRegionConfiguration,azureCloudOptions){this.logger.verbose("buildOauthClientConfiguration called",requestCorrelationId);const userAzureCloudOptions=azureCloudOptions||this.config.auth.azureCloudOptions;this.logger.verbose(`building oauth client configuration with the authority: ${authority}`,requestCorrelationId);const discoveredAuthority=await this.createAuthority(authority,azureRegionConfiguration,requestCorrelationId,userAzureCloudOptions);null==serverTelemetryManager||serverTelemetryManager.updateRegionDiscoveryMetadata(discoveredAuthority.regionDiscoveryMetadata);return{authOptions:{clientId:this.config.auth.clientId,authority:discoveredAuthority,clientCapabilities:this.config.auth.clientCapabilities},loggerOptions:{logLevel:this.config.system.loggerOptions.logLevel,loggerCallback:this.config.system.loggerOptions.loggerCallback,piiLoggingEnabled:this.config.system.loggerOptions.piiLoggingEnabled,correlationId:requestCorrelationId},cryptoInterface:this.cryptoProvider,networkInterface:this.config.system.networkClient,storageInterface:this.storage,serverTelemetryManager:serverTelemetryManager,clientCredentials:{clientSecret:this.clientSecret,clientAssertion:this.clientAssertion?this.getClientAssertion(discoveredAuthority):void 0},libraryInfo:{sku:Constants.MSAL_SKU,version:version,cpu:process.arch||msalCommon.Constants.EMPTY_STRING,os:process.platform||msalCommon.Constants.EMPTY_STRING},telemetry:this.config.telemetry,persistencePlugin:this.config.cache.cachePlugin,serializableCache:this.tokenCache}}getClientAssertion(authority){return{assertion:this.clientAssertion.getJwt(this.cryptoProvider,this.config.auth.clientId,authority.tokenEndpoint),assertionType:Constants.JWT_BEARER_ASSERTION_TYPE}}async initializeBaseRequest(authRequest){return this.logger.verbose("initializeRequestScopes called",authRequest.correlationId),authRequest.authenticationScheme&&authRequest.authenticationScheme===msalCommon.AuthenticationScheme.POP&&this.logger.verbose("Authentication Scheme 'pop' is not supported yet, setting Authentication Scheme to 'Bearer' for request",authRequest.correlationId),authRequest.authenticationScheme=msalCommon.AuthenticationScheme.BEARER,authRequest.claims&&!msalCommon.StringUtils.isEmpty(authRequest.claims)&&(authRequest.requestedClaimsHash=await this.cryptoProvider.hashString(authRequest.claims)),{...authRequest,scopes:[...authRequest&&authRequest.scopes||[],...msalCommon.OIDC_DEFAULT_SCOPES],correlationId:authRequest&&authRequest.correlationId||this.cryptoProvider.createNewGuid(),authority:authRequest.authority||this.config.auth.authority}}initializeServerTelemetryManager(apiId,correlationId,forceRefresh){const telemetryPayload={clientId:this.config.auth.clientId,correlationId:correlationId,apiId:apiId,forceRefresh:forceRefresh||!1};return new msalCommon.ServerTelemetryManager(telemetryPayload,this.storage)}async createAuthority(authorityString,azureRegionConfiguration,requestCorrelationId,azureCloudOptions){this.logger.verbose("createAuthority called",requestCorrelationId);const authorityUrl=msalCommon.Authority.generateAuthority(authorityString,azureCloudOptions),authorityOptions={protocolMode:this.config.auth.protocolMode,knownAuthorities:this.config.auth.knownAuthorities,cloudDiscoveryMetadata:this.config.auth.cloudDiscoveryMetadata,authorityMetadata:this.config.auth.authorityMetadata,azureRegionConfiguration:azureRegionConfiguration,skipAuthorityMetadataCache:this.config.auth.skipAuthorityMetadataCache};return await msalCommon.AuthorityFactory.createDiscoveredInstance(authorityUrl,this.config.system.networkClient,this.storage,authorityOptions,this.logger)}clearCache(){this.storage.clear()}}class LoopbackClient{async listenForAuthCode(successTemplate,errorTemplate){if(this.server)throw NodeAuthError.createLoopbackServerAlreadyExistsError();const authCodeListener=new Promise(((resolve,reject)=>{this.server=http.createServer((async(req,res)=>{const url=req.url;if(!url)return res.end(errorTemplate||"Error occurred loading redirectUrl"),void reject(NodeAuthError.createUnableToLoadRedirectUrlError());if(url===msalCommon.Constants.FORWARD_SLASH)return void res.end(successTemplate||"Auth code was successfully acquired. You can close this window now.");const authCodeResponse=msalCommon.UrlString.getDeserializedQueryString(url);if(authCodeResponse.code){const redirectUri=await this.getRedirectUri();res.writeHead(HttpStatus.REDIRECT,{location:redirectUri}),res.end()}resolve(authCodeResponse)})),this.server.listen(0)}));return await new Promise((resolve=>{let ticks=0;const id=setInterval((()=>{if(LOOPBACK_SERVER_CONSTANTS.TIMEOUT_MS/LOOPBACK_SERVER_CONSTANTS.INTERVAL_MS<ticks)throw NodeAuthError.createLoopbackServerTimeoutError();this.server.listening&&(clearInterval(id),resolve()),ticks++}),LOOPBACK_SERVER_CONSTANTS.INTERVAL_MS)})),authCodeListener}getRedirectUri(){if(!this.server)throw NodeAuthError.createNoLoopbackServerExistsError();const address=this.server.address();if(!address||"string"==typeof address||!address.port)throw this.closeServer(),NodeAuthError.createInvalidLoopbackAddressTypeError();const port=address&&address.port;return`${Constants.HTTP_PROTOCOL}${Constants.LOCALHOST}:${port}`}closeServer(){this.server&&this.server.close()}}class PublicClientApplication extends ClientApplication{constructor(configuration){super(configuration),this.config.broker.nativeBrokerPlugin&&(this.config.broker.nativeBrokerPlugin.isBrokerAvailable?(this.nativeBrokerPlugin=this.config.broker.nativeBrokerPlugin,this.nativeBrokerPlugin.setLogger(this.config.system.loggerOptions)):this.logger.warning("NativeBroker implementation was provided but the broker is unavailable."))}async acquireTokenByDeviceCode(request){this.logger.info("acquireTokenByDeviceCode called",request.correlationId);const validRequest=Object.assign(request,await this.initializeBaseRequest(request)),serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenByDeviceCode,validRequest.correlationId);try{const deviceCodeConfig=await this.buildOauthClientConfiguration(validRequest.authority,validRequest.correlationId,serverTelemetryManager,void 0,request.azureCloudOptions),deviceCodeClient=new msalCommon.DeviceCodeClient(deviceCodeConfig);return this.logger.verbose("Device code client created",validRequest.correlationId),deviceCodeClient.acquireToken(validRequest)}catch(e){throw e instanceof msalCommon.AuthError&&e.setCorrelationId(validRequest.correlationId),serverTelemetryManager.cacheFailedRequest(e),e}}async acquireTokenInteractive(request){const correlationId=request.correlationId||this.cryptoProvider.createNewGuid();this.logger.trace("acquireTokenInteractive called",correlationId);const{openBrowser:openBrowser,successTemplate:successTemplate,errorTemplate:errorTemplate,windowHandle:windowHandle,loopbackClient:customLoopbackClient,...remainingProperties}=request;if(this.nativeBrokerPlugin){var _remainingProperties$;const brokerRequest={...remainingProperties,clientId:this.config.auth.clientId,scopes:request.scopes||msalCommon.OIDC_DEFAULT_SCOPES,redirectUri:`${Constants.HTTP_PROTOCOL}${Constants.LOCALHOST}`,authority:request.authority||this.config.auth.authority,correlationId:correlationId,extraParameters:{...remainingProperties.extraQueryParameters,...remainingProperties.tokenQueryParameters},accountId:null==(_remainingProperties$=remainingProperties.account)?void 0:_remainingProperties$.nativeAccountId};return this.nativeBrokerPlugin.acquireTokenInteractive(brokerRequest,windowHandle)}const{verifier:verifier,challenge:challenge}=await this.cryptoProvider.generatePkceCodes(),loopbackClient=customLoopbackClient||new LoopbackClient,authCodeListener=loopbackClient.listenForAuthCode(successTemplate,errorTemplate),redirectUri=loopbackClient.getRedirectUri(),validRequest={...remainingProperties,correlationId:correlationId,scopes:request.scopes||msalCommon.OIDC_DEFAULT_SCOPES,redirectUri:redirectUri,responseMode:msalCommon.ResponseMode.QUERY,codeChallenge:challenge,codeChallengeMethod:msalCommon.CodeChallengeMethodValues.S256},authCodeUrl=await this.getAuthCodeUrl(validRequest);await openBrowser(authCodeUrl);const authCodeResponse=await authCodeListener.finally((()=>{loopbackClient.closeServer()}));if(authCodeResponse.error)throw new msalCommon.ServerError(authCodeResponse.error,authCodeResponse.error_description,authCodeResponse.suberror);if(!authCodeResponse.code)throw NodeAuthError.createNoAuthCodeInResponseError();const clientInfo=authCodeResponse.client_info,tokenRequest={code:authCodeResponse.code,codeVerifier:verifier,clientInfo:clientInfo||msalCommon.Constants.EMPTY_STRING,...validRequest};return this.acquireTokenByCode(tokenRequest)}async acquireTokenSilent(request){const correlationId=request.correlationId||this.cryptoProvider.createNewGuid();if(this.logger.trace("acquireTokenSilent called",correlationId),this.nativeBrokerPlugin){const brokerRequest={...request,clientId:this.config.auth.clientId,scopes:request.scopes||msalCommon.OIDC_DEFAULT_SCOPES,redirectUri:`${Constants.HTTP_PROTOCOL}${Constants.LOCALHOST}`,authority:request.authority||this.config.auth.authority,correlationId:correlationId,extraParameters:request.tokenQueryParameters,accountId:request.account.nativeAccountId,forceRefresh:request.forceRefresh||!1};return this.nativeBrokerPlugin.acquireTokenSilent(brokerRequest)}return super.acquireTokenSilent(request)}async signOut(request){if(this.nativeBrokerPlugin&&request.account.nativeAccountId){const signoutRequest={clientId:this.config.auth.clientId,accountId:request.account.nativeAccountId,correlationId:request.correlationId||this.cryptoProvider.createNewGuid()};await this.nativeBrokerPlugin.signOut(signoutRequest)}await this.getTokenCache().removeAccount(request.account)}async getAllAccounts(){if(this.nativeBrokerPlugin){const correlationId=this.cryptoProvider.createNewGuid();return this.nativeBrokerPlugin.getAllAccounts(this.config.auth.clientId,correlationId)}return this.getTokenCache().getAllAccounts()}}class ClientAssertion{static fromAssertion(assertion){const clientAssertion=new ClientAssertion;return clientAssertion.jwt=assertion,clientAssertion}static fromCertificate(thumbprint,privateKey,publicCertificate){const clientAssertion=new ClientAssertion;return clientAssertion.privateKey=privateKey,clientAssertion.thumbprint=thumbprint,publicCertificate&&(clientAssertion.publicCertificate=this.parseCertificate(publicCertificate)),clientAssertion}getJwt(cryptoProvider,issuer,jwtAudience){if(this.privateKey&&this.thumbprint)return this.jwt&&!this.isExpired()&&issuer===this.issuer&&jwtAudience===this.jwtAudience?this.jwt:this.createJwt(cryptoProvider,issuer,jwtAudience);if(this.jwt)return this.jwt;throw msalCommon.ClientAuthError.createInvalidAssertionError()}createJwt(cryptoProvider,issuer,jwtAudience){this.issuer=issuer,this.jwtAudience=jwtAudience;const issuedAt=msalCommon.TimeUtils.nowSeconds();this.expirationTime=issuedAt+600;const header={alg:JwtConstants.RSA_256,x5t:EncodingUtils.base64EncodeUrl(this.thumbprint,"hex")};this.publicCertificate&&Object.assign(header,{x5c:this.publicCertificate});const payload={[JwtConstants.AUDIENCE]:this.jwtAudience,[JwtConstants.EXPIRATION_TIME]:this.expirationTime,[JwtConstants.ISSUER]:this.issuer,[JwtConstants.SUBJECT]:this.issuer,[JwtConstants.NOT_BEFORE]:issuedAt,[JwtConstants.JWT_ID]:cryptoProvider.createNewGuid()};return this.jwt=jsonwebtoken.sign(payload,this.privateKey,{header:header}),this.jwt}isExpired(){return this.expirationTime<msalCommon.TimeUtils.nowSeconds()}static parseCertificate(publicCertificate){const regexToFindCerts=/-----BEGIN CERTIFICATE-----\r*\n(.+?)\r*\n-----END CERTIFICATE-----/gs,certs=[];let matches;for(;null!==(matches=regexToFindCerts.exec(publicCertificate));)certs.push(matches[1].replace(/\r*\n/g,msalCommon.Constants.EMPTY_STRING));return certs}}class ConfidentialClientApplication extends ClientApplication{constructor(configuration){super(configuration),this.setClientCredential(this.config),this.appTokenProvider=void 0}SetAppTokenProvider(provider){this.appTokenProvider=provider}async acquireTokenByClientCredential(request){let clientAssertion;this.logger.info("acquireTokenByClientCredential called",request.correlationId),request.clientAssertion&&(clientAssertion={assertion:request.clientAssertion,assertionType:Constants.JWT_BEARER_ASSERTION_TYPE});const baseRequest=await this.initializeBaseRequest(request),validBaseRequest={...baseRequest,scopes:baseRequest.scopes.filter((scope=>!msalCommon.OIDC_DEFAULT_SCOPES.includes(scope)))},validRequest={...request,...validBaseRequest,clientAssertion:clientAssertion},azureRegionConfiguration={azureRegion:validRequest.azureRegion,environmentRegion:process.env[REGION_ENVIRONMENT_VARIABLE]},serverTelemetryManager=this.initializeServerTelemetryManager(ApiId.acquireTokenByClientCredential,validRequest.correlationId,validRequest.skipCache);try{const clientCredentialConfig=await this.buildOauthClientConfiguration(validRequest.authority,validRequest.correlationId,serverTelemetryManager,azureRegionConfiguration,request.azureCloudOptions),clientCredentialClient=new msalCommon.ClientCredentialClient(clientCredentialConfig,this.appTokenProvider);return this.logger.verbose("Client credential client created",validRequest.correlationId),clientCredentialClient.acquireToken(validRequest)}catch(e){throw e instanceof msalCommon.AuthError&&e.setCorrelationId(validRequest.correlationId),serverTelemetryManager.cacheFailedRequest(e),e}}async acquireTokenOnBehalfOf(request){this.logger.info("acquireTokenOnBehalfOf called",request.correlationId);const validRequest={...request,...await this.initializeBaseRequest(request)};try{const onBehalfOfConfig=await this.buildOauthClientConfiguration(validRequest.authority,validRequest.correlationId,void 0,void 0,request.azureCloudOptions),oboClient=new msalCommon.OnBehalfOfClient(onBehalfOfConfig);return this.logger.verbose("On behalf of client created",validRequest.correlationId),oboClient.acquireToken(validRequest)}catch(e){throw e instanceof msalCommon.AuthError&&e.setCorrelationId(validRequest.correlationId),e}}setClientCredential(configuration){const clientSecretNotEmpty=!msalCommon.StringUtils.isEmpty(configuration.auth.clientSecret),clientAssertionNotEmpty=!msalCommon.StringUtils.isEmpty(configuration.auth.clientAssertion),certificate=configuration.auth.clientCertificate||{thumbprint:msalCommon.Constants.EMPTY_STRING,privateKey:msalCommon.Constants.EMPTY_STRING},certificateNotEmpty=!msalCommon.StringUtils.isEmpty(certificate.thumbprint)||!msalCommon.StringUtils.isEmpty(certificate.privateKey);if(!this.appTokenProvider){if(clientSecretNotEmpty&&clientAssertionNotEmpty||clientAssertionNotEmpty&&certificateNotEmpty||clientSecretNotEmpty&&certificateNotEmpty)throw msalCommon.ClientAuthError.createInvalidCredentialError();if(configuration.auth.clientSecret)this.clientSecret=configuration.auth.clientSecret;else if(configuration.auth.clientAssertion)this.clientAssertion=ClientAssertion.fromAssertion(configuration.auth.clientAssertion);else{if(!certificateNotEmpty)throw msalCommon.ClientAuthError.createInvalidCredentialError();var _configuration$auth$c;this.clientAssertion=ClientAssertion.fromCertificate(certificate.thumbprint,certificate.privateKey,null==(_configuration$auth$c=configuration.auth.clientCertificate)?void 0:_configuration$auth$c.x5c)}}}}class DistributedCachePlugin{constructor(client,partitionManager){this.client=client,this.partitionManager=partitionManager}async beforeCacheAccess(cacheContext){const partitionKey=await this.partitionManager.getKey(),cacheData=await this.client.get(partitionKey);cacheContext.tokenCache.deserialize(cacheData)}async afterCacheAccess(cacheContext){if(cacheContext.cacheHasChanged){const kvStore=cacheContext.tokenCache.getKVStore(),accountEntities=Object.values(kvStore).filter((value=>msalCommon.AccountEntity.isAccountEntity(value)));if(accountEntities.length>0){const accountEntity=accountEntities[0],partitionKey=await this.partitionManager.extractKey(accountEntity);await this.client.set(partitionKey,cacheContext.tokenCache.serialize())}}}}Object.defineProperty(exports,"AuthError",{enumerable:!0,get:function(){return msalCommon.AuthError}}),Object.defineProperty(exports,"AuthErrorMessage",{enumerable:!0,get:function(){return msalCommon.AuthErrorMessage}}),Object.defineProperty(exports,"AzureCloudInstance",{enumerable:!0,get:function(){return msalCommon.AzureCloudInstance}}),Object.defineProperty(exports,"ClientAuthError",{enumerable:!0,get:function(){return msalCommon.ClientAuthError}}),Object.defineProperty(exports,"ClientAuthErrorMessage",{enumerable:!0,get:function(){return msalCommon.ClientAuthErrorMessage}}),Object.defineProperty(exports,"ClientConfigurationError",{enumerable:!0,get:function(){return msalCommon.ClientConfigurationError}}),Object.defineProperty(exports,"ClientConfigurationErrorMessage",{enumerable:!0,get:function(){return msalCommon.ClientConfigurationErrorMessage}}),Object.defineProperty(exports,"InteractionRequiredAuthError",{enumerable:!0,get:function(){return msalCommon.InteractionRequiredAuthError}}),Object.defineProperty(exports,"InteractionRequiredAuthErrorMessage",{enumerable:!0,get:function(){return msalCommon.InteractionRequiredAuthErrorMessage}}),Object.defineProperty(exports,"LogLevel",{enumerable:!0,get:function(){return msalCommon.LogLevel}}),Object.defineProperty(exports,"Logger",{enumerable:!0,get:function(){return msalCommon.Logger}}),Object.defineProperty(exports,"PromptValue",{enumerable:!0,get:function(){return msalCommon.PromptValue}}),Object.defineProperty(exports,"ProtocolMode",{enumerable:!0,get:function(){return msalCommon.ProtocolMode}}),Object.defineProperty(exports,"ResponseMode",{enumerable:!0,get:function(){return msalCommon.ResponseMode}}),Object.defineProperty(exports,"ServerError",{enumerable:!0,get:function(){return msalCommon.ServerError}}),Object.defineProperty(exports,"TokenCacheContext",{enumerable:!0,get:function(){return msalCommon.TokenCacheContext}}),exports.ClientApplication=ClientApplication,exports.ClientAssertion=ClientAssertion,exports.ConfidentialClientApplication=ConfidentialClientApplication,exports.CryptoProvider=CryptoProvider,exports.DistributedCachePlugin=DistributedCachePlugin,exports.NodeStorage=NodeStorage,exports.PublicClientApplication=PublicClientApplication,exports.TokenCache=TokenCache,exports.buildAppConfiguration=buildAppConfiguration,exports.version=version;