/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{__awaiter,__generator}from"../_virtual/_tslib.js";import{RegionDiscoverySources,ResponseCodes,Constants}from"../utils/Constants.js";import{PerformanceEvents}from"../telemetry/performance/PerformanceEvent.js";var RegionDiscovery=function(){function RegionDiscovery(networkInterface,performanceClient,correlationId){this.networkInterface=networkInterface,this.performanceClient=performanceClient,this.correlationId=correlationId}return RegionDiscovery.prototype.detectRegion=function(environmentRegion,regionDiscoveryMetadata){var _a,_b,_c,_d;return __awaiter(this,void 0,void 0,(function(){var autodetectedRegionName,options,localIMDSVersionResponse,currentIMDSVersion,currentIMDSVersionResponse;return __generator(this,(function(_e){switch(_e.label){case 0:if(null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.RegionDiscoveryDetectRegion,this.correlationId),autodetectedRegionName=environmentRegion)return[3,8];options=RegionDiscovery.IMDS_OPTIONS,_e.label=1;case 1:return _e.trys.push([1,6,,7]),null===(_b=this.performanceClient)||void 0===_b||_b.setPreQueueTime(PerformanceEvents.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[4,this.getRegionFromIMDS(Constants.IMDS_VERSION,options)];case 2:return(localIMDSVersionResponse=_e.sent()).status===ResponseCodes.httpSuccess&&(autodetectedRegionName=localIMDSVersionResponse.body,regionDiscoveryMetadata.region_source=RegionDiscoverySources.IMDS),localIMDSVersionResponse.status!==ResponseCodes.httpBadRequest?[3,5]:(null===(_c=this.performanceClient)||void 0===_c||_c.setPreQueueTime(PerformanceEvents.RegionDiscoveryGetCurrentVersion,this.correlationId),[4,this.getCurrentVersion(options)]);case 3:return(currentIMDSVersion=_e.sent())?(null===(_d=this.performanceClient)||void 0===_d||_d.setPreQueueTime(PerformanceEvents.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[4,this.getRegionFromIMDS(currentIMDSVersion,options)]):(regionDiscoveryMetadata.region_source=RegionDiscoverySources.FAILED_AUTO_DETECTION,[2,null]);case 4:(currentIMDSVersionResponse=_e.sent()).status===ResponseCodes.httpSuccess&&(autodetectedRegionName=currentIMDSVersionResponse.body,regionDiscoveryMetadata.region_source=RegionDiscoverySources.IMDS),_e.label=5;case 5:return[3,7];case 6:return _e.sent(),regionDiscoveryMetadata.region_source=RegionDiscoverySources.FAILED_AUTO_DETECTION,[2,null];case 7:return[3,9];case 8:regionDiscoveryMetadata.region_source=RegionDiscoverySources.ENVIRONMENT_VARIABLE,_e.label=9;case 9:return autodetectedRegionName||(regionDiscoveryMetadata.region_source=RegionDiscoverySources.FAILED_AUTO_DETECTION),[2,autodetectedRegionName||null]}}))}))},RegionDiscovery.prototype.getRegionFromIMDS=function(version,options){var _a;return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(_b){return null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.RegionDiscoveryGetRegionFromIMDS,this.correlationId),[2,this.networkInterface.sendGetRequestAsync(Constants.IMDS_ENDPOINT+"?api-version="+version+"&format=text",options,Constants.IMDS_TIMEOUT)]}))}))},RegionDiscovery.prototype.getCurrentVersion=function(options){var _a;return __awaiter(this,void 0,void 0,(function(){var response;return __generator(this,(function(_b){switch(_b.label){case 0:null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.RegionDiscoveryGetCurrentVersion,this.correlationId),_b.label=1;case 1:return _b.trys.push([1,3,,4]),[4,this.networkInterface.sendGetRequestAsync(Constants.IMDS_ENDPOINT+"?format=json",options)];case 2:return(response=_b.sent()).status===ResponseCodes.httpBadRequest&&response.body&&response.body["newest-versions"]&&response.body["newest-versions"].length>0?[2,response.body["newest-versions"][0]]:[2,null];case 3:return _b.sent(),[2,null];case 4:return[2]}}))}))},RegionDiscovery.IMDS_OPTIONS={headers:{Metadata:"true"}},RegionDiscovery}();export{RegionDiscovery};