/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{__spreadArrays}from"../_virtual/_tslib.js";import{ClientConfigurationError}from"../error/ClientConfigurationError.js";import{StringUtils}from"../utils/StringUtils.js";import{ClientAuthError}from"../error/ClientAuthError.js";import{Constants,OIDC_SCOPES}from"../utils/Constants.js";var ScopeSet=function(){function ScopeSet(inputScopes){var _this=this,scopeArr=inputScopes?StringUtils.trimArrayEntries(__spreadArrays(inputScopes)):[],filteredInput=scopeArr?StringUtils.removeEmptyStringsFromArray(scopeArr):[];this.validateInputScopes(filteredInput),this.scopes=new Set,filteredInput.forEach((function(scope){return _this.scopes.add(scope)}))}return ScopeSet.fromString=function(inputScopeString){return new ScopeSet((inputScopeString||Constants.EMPTY_STRING).split(" "))},ScopeSet.createSearchScopes=function(inputScopeString){var scopeSet=new ScopeSet(inputScopeString);return scopeSet.containsOnlyOIDCScopes()?scopeSet.removeScope(Constants.OFFLINE_ACCESS_SCOPE):scopeSet.removeOIDCScopes(),scopeSet},ScopeSet.prototype.validateInputScopes=function(inputScopes){if(!inputScopes||inputScopes.length<1)throw ClientConfigurationError.createEmptyScopesArrayError()},ScopeSet.prototype.containsScope=function(scope){var lowerCaseScopesSet=new ScopeSet(this.printScopesLowerCase().split(" "));return!StringUtils.isEmpty(scope)&&lowerCaseScopesSet.scopes.has(scope.toLowerCase())},ScopeSet.prototype.containsScopeSet=function(scopeSet){var _this=this;return!(!scopeSet||scopeSet.scopes.size<=0)&&(this.scopes.size>=scopeSet.scopes.size&&scopeSet.asArray().every((function(scope){return _this.containsScope(scope)})))},ScopeSet.prototype.containsOnlyOIDCScopes=function(){var _this=this,defaultScopeCount=0;return OIDC_SCOPES.forEach((function(defaultScope){_this.containsScope(defaultScope)&&(defaultScopeCount+=1)})),this.scopes.size===defaultScopeCount},ScopeSet.prototype.appendScope=function(newScope){StringUtils.isEmpty(newScope)||this.scopes.add(newScope.trim())},ScopeSet.prototype.appendScopes=function(newScopes){var _this=this;try{newScopes.forEach((function(newScope){return _this.appendScope(newScope)}))}catch(e){throw ClientAuthError.createAppendScopeSetError(e)}},ScopeSet.prototype.removeScope=function(scope){if(StringUtils.isEmpty(scope))throw ClientAuthError.createRemoveEmptyScopeFromSetError(scope);this.scopes.delete(scope.trim())},ScopeSet.prototype.removeOIDCScopes=function(){var _this=this;OIDC_SCOPES.forEach((function(defaultScope){_this.scopes.delete(defaultScope)}))},ScopeSet.prototype.unionScopeSets=function(otherScopes){if(!otherScopes)throw ClientAuthError.createEmptyInputScopeSetError();var unionScopes=new Set;return otherScopes.scopes.forEach((function(scope){return unionScopes.add(scope.toLowerCase())})),this.scopes.forEach((function(scope){return unionScopes.add(scope.toLowerCase())})),unionScopes},ScopeSet.prototype.intersectingScopeSets=function(otherScopes){if(!otherScopes)throw ClientAuthError.createEmptyInputScopeSetError();otherScopes.containsOnlyOIDCScopes()||otherScopes.removeOIDCScopes();var unionScopes=this.unionScopeSets(otherScopes),sizeOtherScopes=otherScopes.getScopeCount(),sizeThisScopes=this.getScopeCount();return unionScopes.size<sizeThisScopes+sizeOtherScopes},ScopeSet.prototype.getScopeCount=function(){return this.scopes.size},ScopeSet.prototype.asArray=function(){var array=[];return this.scopes.forEach((function(val){return array.push(val)})),array},ScopeSet.prototype.printScopes=function(){return this.scopes?this.asArray().join(" "):Constants.EMPTY_STRING},ScopeSet.prototype.printScopesLowerCase=function(){return this.printScopes().toLowerCase()},ScopeSet}();export{ScopeSet};