/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{DateTimeException,UnsupportedTemporalTypeException,NullPointerException}from"./errors";import{MathUtil}from"./MathUtil";import{assert,requireNonNull,requireInstance}from"./assert";import{ChronoField}from"./temporal/ChronoField";import{ChronoUnit}from"./temporal/ChronoUnit";import{IllegalArgumentException}from"./errors";import{TemporalAccessor}from"./temporal/TemporalAccessor";import{TemporalQueries}from"./temporal/TemporalQueries";import{createTemporalQuery}from"./temporal/TemporalQuery";export class DayOfWeek extends TemporalAccessor{constructor(ordinal,name){super(),this._ordinal=ordinal,this._name=name}ordinal(){return this._ordinal}name(){return this._name}static values(){return ENUMS.slice()}static valueOf(name){let ordinal=0;for(;ordinal<ENUMS.length&&ENUMS[ordinal].name()!==name;ordinal++);return DayOfWeek.of(ordinal+1)}static of(dayOfWeek){if(dayOfWeek<1||dayOfWeek>7)throw new DateTimeException(`Invalid value for DayOfWeek: ${dayOfWeek}`);return ENUMS[dayOfWeek-1]}static from(temporal){if(assert(null!=temporal,"temporal",NullPointerException),temporal instanceof DayOfWeek)return temporal;try{return DayOfWeek.of(temporal.get(ChronoField.DAY_OF_WEEK))}catch(ex){throw ex instanceof DateTimeException?new DateTimeException(`Unable to obtain DayOfWeek from TemporalAccessor: ${temporal}, type ${null!=temporal.constructor?temporal.constructor.name:""}`,ex):ex}}value(){return this._ordinal+1}displayName(style,locale){throw new IllegalArgumentException("Pattern using (localized) text not implemented yet!")}isSupported(field){return field instanceof ChronoField?field===ChronoField.DAY_OF_WEEK:null!=field&&field.isSupportedBy(this)}range(field){if(field===ChronoField.DAY_OF_WEEK)return field.range();if(field instanceof ChronoField)throw new UnsupportedTemporalTypeException(`Unsupported field: ${field}`);return field.rangeRefinedBy(this)}get(field){return field===ChronoField.DAY_OF_WEEK?this.value():this.range(field).checkValidIntValue(this.getLong(field),field)}getLong(field){if(field===ChronoField.DAY_OF_WEEK)return this.value();if(field instanceof ChronoField)throw new UnsupportedTemporalTypeException(`Unsupported field: ${field}`);return field.getFrom(this)}plus(days){const amount=MathUtil.floorMod(days,7);return ENUMS[MathUtil.floorMod(this._ordinal+(amount+7),7)]}minus(days){return this.plus(-1*MathUtil.floorMod(days,7))}query(query){return query===TemporalQueries.precision()?ChronoUnit.DAYS:query===TemporalQueries.localDate()||query===TemporalQueries.localTime()||query===TemporalQueries.chronology()||query===TemporalQueries.zone()||query===TemporalQueries.zoneId()||query===TemporalQueries.offset()?null:(assert(null!=query,"query",NullPointerException),query.queryFrom(this))}adjustInto(temporal){return requireNonNull(temporal,"temporal"),temporal.with(ChronoField.DAY_OF_WEEK,this.value())}equals(other){return this===other}toString(){return this._name}compareTo(other){return requireNonNull(other,"other"),requireInstance(other,DayOfWeek,"other"),this._ordinal-other._ordinal}toJSON(){return this.toString()}}let ENUMS;export function _init(){DayOfWeek.MONDAY=new DayOfWeek(0,"MONDAY"),DayOfWeek.TUESDAY=new DayOfWeek(1,"TUESDAY"),DayOfWeek.WEDNESDAY=new DayOfWeek(2,"WEDNESDAY"),DayOfWeek.THURSDAY=new DayOfWeek(3,"THURSDAY"),DayOfWeek.FRIDAY=new DayOfWeek(4,"FRIDAY"),DayOfWeek.SATURDAY=new DayOfWeek(5,"SATURDAY"),DayOfWeek.SUNDAY=new DayOfWeek(6,"SUNDAY"),DayOfWeek.FROM=createTemporalQuery("DayOfWeek.FROM",(temporal=>DayOfWeek.from(temporal))),ENUMS=[DayOfWeek.MONDAY,DayOfWeek.TUESDAY,DayOfWeek.WEDNESDAY,DayOfWeek.THURSDAY,DayOfWeek.FRIDAY,DayOfWeek.SATURDAY,DayOfWeek.SUNDAY]}