/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{assert,requireNonNull}from"../assert";import{DateTimeBuilder}from"./DateTimeBuilder";import{EnumMap}from"./EnumMap";import{IsoChronology}from"../chrono/IsoChronology";import{Temporal}from"../temporal/Temporal";import{TemporalQueries}from"../temporal/TemporalQueries";export class DateTimeParseContext{constructor(){if(1===arguments.length){if(arguments[0]instanceof DateTimeParseContext)return void this._constructorSelf.apply(this,arguments);this._constructorFormatter.apply(this,arguments)}else this._constructorParam.apply(this,arguments);this._caseSensitive=!0,this._strict=!0,this._parsed=[new Parsed(this)]}_constructorParam(locale,symbols,chronology){this._locale=locale,this._symbols=symbols,this._overrideChronology=chronology}_constructorFormatter(formatter){this._locale=formatter.locale(),this._symbols=formatter.decimalStyle(),this._overrideChronology=formatter.chronology()}_constructorSelf(other){this._locale=other._locale,this._symbols=other._symbols,this._overrideChronology=other._overrideChronology,this._overrideZone=other._overrideZone,this._caseSensitive=other._caseSensitive,this._strict=other._strict,this._parsed=[new Parsed(this)]}copy(){return new DateTimeParseContext(this)}symbols(){return this._symbols}isStrict(){return this._strict}setStrict(strict){this._strict=strict}locale(){return this._locale}setLocale(locale){this._locale=locale}startOptional(){this._parsed.push(this.currentParsed().copy())}endOptional(successful){successful?this._parsed.splice(this._parsed.length-2,1):this._parsed.splice(this._parsed.length-1,1)}isCaseSensitive(){return this._caseSensitive}setCaseSensitive(caseSensitive){this._caseSensitive=caseSensitive}subSequenceEquals(cs1,offset1,cs2,offset2,length){if(offset1+length>cs1.length||offset2+length>cs2.length)return!1;this.isCaseSensitive()||(cs1=cs1.toLowerCase(),cs2=cs2.toLowerCase());for(let i=0;i<length;i++){if(cs1[offset1+i]!==cs2[offset2+i])return!1}return!0}charEquals(ch1,ch2){return this.isCaseSensitive()?ch1===ch2:this.charEqualsIgnoreCase(ch1,ch2)}charEqualsIgnoreCase(c1,c2){return c1===c2||c1.toLowerCase()===c2.toLowerCase()}setParsedField(field,value,errorPos,successPos){const currentParsedFieldValues=this.currentParsed().fieldValues,old=currentParsedFieldValues.get(field);return currentParsedFieldValues.set(field,value),null!=old&&old!==value?~errorPos:successPos}setParsedZone(zone){requireNonNull(zone,"zone"),this.currentParsed().zone=zone}getParsed(field){return this.currentParsed().fieldValues.get(field)}toParsed(){return this.currentParsed()}currentParsed(){return this._parsed[this._parsed.length-1]}setParsedLeapSecond(){this.currentParsed().leapSecond=!0}getEffectiveChronology(){let chrono=this.currentParsed().chrono;return null==chrono&&(chrono=this._overrideChronology,null==chrono&&(chrono=IsoChronology.INSTANCE)),chrono}}class Parsed extends Temporal{constructor(dateTimeParseContext){super(),this.chrono=null,this.zone=null,this.fieldValues=new EnumMap,this.leapSecond=!1,this.dateTimeParseContext=dateTimeParseContext}copy(){const cloned=new Parsed;return cloned.chrono=this.chrono,cloned.zone=this.zone,cloned.fieldValues.putAll(this.fieldValues),cloned.leapSecond=this.leapSecond,cloned.dateTimeParseContext=this.dateTimeParseContext,cloned}toString(){return`${this.fieldValues}, ${this.chrono}, ${this.zone}`}isSupported(field){return this.fieldValues.containsKey(field)}get(field){const val=this.fieldValues.get(field);return assert(null!=val),val}query(query){return query===TemporalQueries.chronology()?this.chrono:query===TemporalQueries.zoneId()||query===TemporalQueries.zone()?this.zone:super.query(query)}toBuilder(){const builder=new DateTimeBuilder;return builder.fieldValues.putAll(this.fieldValues),builder.chrono=this.dateTimeParseContext.getEffectiveChronology(),null!=this.zone?builder.zone=this.zone:builder.zone=this.overrideZone,builder.leapSecond=this.leapSecond,builder.excessDays=this.excessDays,builder}}