/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../../assert";import{IllegalArgumentException}from"../../errors";import{MathUtil}from"../../MathUtil";import{ChronoField}from"../../temporal/ChronoField";const PATTERNS=["+HH","+HHmm","+HH:mm","+HHMM","+HH:MM","+HHMMss","+HH:MM:ss","+HHMMSS","+HH:MM:SS"];export class OffsetIdPrinterParser{constructor(noOffsetText,pattern){requireNonNull(noOffsetText,"noOffsetText"),requireNonNull(pattern,"pattern"),this.noOffsetText=noOffsetText,this.type=this._checkPattern(pattern)}_checkPattern(pattern){for(let i=0;i<PATTERNS.length;i++)if(PATTERNS[i]===pattern)return i;throw new IllegalArgumentException(`Invalid zone offset pattern: ${pattern}`)}print(context,buf){const offsetSecs=context.getValue(ChronoField.OFFSET_SECONDS);if(null==offsetSecs)return!1;const totalSecs=MathUtil.safeToInt(offsetSecs);if(0===totalSecs)buf.append(this.noOffsetText);else{const absHours=Math.abs(MathUtil.intMod(MathUtil.intDiv(totalSecs,3600),100)),absMinutes=Math.abs(MathUtil.intMod(MathUtil.intDiv(totalSecs,60),60)),absSeconds=Math.abs(MathUtil.intMod(totalSecs,60)),bufPos=buf.length();let output=absHours;buf.append(totalSecs<0?"-":"+").appendChar(`${MathUtil.intDiv(absHours,10)}0`).appendChar(`${MathUtil.intMod(absHours,10)}0`),(this.type>=3||this.type>=1&&absMinutes>0)&&(buf.append(this.type%2==0?":":"").appendChar(`${MathUtil.intDiv(absMinutes,10)}0`).appendChar(absMinutes%10+"0"),output+=absMinutes,(this.type>=7||this.type>=5&&absSeconds>0)&&(buf.append(this.type%2==0?":":"").appendChar(`${MathUtil.intDiv(absSeconds,10)}0`).appendChar(absSeconds%10+"0"),output+=absSeconds)),0===output&&(buf.setLength(bufPos),buf.append(this.noOffsetText))}return!0}parse(context,text,position){const length=text.length,noOffsetLen=this.noOffsetText.length;if(0===noOffsetLen){if(position===length)return context.setParsedField(ChronoField.OFFSET_SECONDS,0,position,position)}else{if(position===length)return~position;if(context.subSequenceEquals(text,position,this.noOffsetText,0,noOffsetLen))return context.setParsedField(ChronoField.OFFSET_SECONDS,0,position,position+noOffsetLen)}const sign=text[position];if("+"===sign||"-"===sign){const negative="-"===sign?-1:1,array=[0,0,0,0];if(array[0]=position+1,!1===(this._parseNumber(array,1,text,!0)||this._parseNumber(array,2,text,this.type>=3)||this._parseNumber(array,3,text,!1))){const offsetSecs=MathUtil.safeZero(negative*(3600*array[1]+60*array[2]+array[3]));return context.setParsedField(ChronoField.OFFSET_SECONDS,offsetSecs,position,array[0])}}return 0===noOffsetLen?context.setParsedField(ChronoField.OFFSET_SECONDS,0,position,position+noOffsetLen):~position}_parseNumber(array,arrayIndex,parseText,required){if((this.type+3)/2<arrayIndex)return!1;let pos=array[0];if(this.type%2==0&&arrayIndex>1){if(pos+1>parseText.length||":"!==parseText[pos])return required;pos++}if(pos+2>parseText.length)return required;const ch1=parseText[pos++],ch2=parseText[pos++];if(ch1<"0"||ch1>"9"||ch2<"0"||ch2>"9")return required;const value=10*(ch1.charCodeAt(0)-48)+(ch2.charCodeAt(0)-48);return value<0||value>59?required:(array[arrayIndex]=value,array[0]=pos,!1)}toString(){const converted=this.noOffsetText.replace("'","''");return`Offset(${PATTERNS[this.type]},'${converted}')`}}OffsetIdPrinterParser.INSTANCE_ID=new OffsetIdPrinterParser("Z","+HH:MM:ss"),OffsetIdPrinterParser.PATTERNS=PATTERNS;