/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull,abstractMethodFail}from"../assert";import{Duration}from"../Duration";import{Instant}from"../Instant";export class ZoneRules{static of(offset){return requireNonNull(offset,"offset"),new Fixed(offset)}isFixedOffset(){abstractMethodFail("ZoneRules.isFixedOffset")}offset(instantOrLocalDateTime){return instantOrLocalDateTime instanceof Instant?this.offsetOfInstant(instantOrLocalDateTime):this.offsetOfLocalDateTime(instantOrLocalDateTime)}offsetOfInstant(instant){abstractMethodFail("ZoneRules.offsetInstant")}offsetOfEpochMilli(epochMilli){abstractMethodFail("ZoneRules.offsetOfEpochMilli")}offsetOfLocalDateTime(localDateTime){abstractMethodFail("ZoneRules.offsetLocalDateTime")}validOffsets(localDateTime){abstractMethodFail("ZoneRules.validOffsets")}transition(localDateTime){abstractMethodFail("ZoneRules.transition")}standardOffset(instant){abstractMethodFail("ZoneRules.standardOffset")}daylightSavings(instant){abstractMethodFail("ZoneRules.daylightSavings")}isDaylightSavings(instant){abstractMethodFail("ZoneRules.isDaylightSavings")}isValidOffset(localDateTime,offset){abstractMethodFail("ZoneRules.isValidOffset")}nextTransition(instant){abstractMethodFail("ZoneRules.nextTransition")}previousTransition(instant){abstractMethodFail("ZoneRules.previousTransition")}transitions(){abstractMethodFail("ZoneRules.transitions")}transitionRules(){abstractMethodFail("ZoneRules.transitionRules")}toString(){abstractMethodFail("ZoneRules.toString")}toJSON(){return this.toString()}}class Fixed extends ZoneRules{constructor(offset){super(),this._offset=offset}isFixedOffset(){return!0}offsetOfInstant(){return this._offset}offsetOfEpochMilli(){return this._offset}offsetOfLocalDateTime(){return this._offset}validOffsets(){return[this._offset]}transition(){return null}standardOffset(){return this._offset}daylightSavings(){return Duration.ZERO}isDaylightSavings(){return!1}isValidOffset(localDateTime,offset){return this._offset.equals(offset)}nextTransition(){return null}previousTransition(){return null}transitions(){return[]}transitionRules(){return[]}equals(other){return this===other||other instanceof Fixed&&this._offset.equals(other._offset)}toString(){return`FixedRules:${this._offset.toString()}`}}