"use strict";const{Buffer:Buffer}=require("buffer"),symbol=Symbol.for("BufferList");function BufferList(buf){if(!(this instanceof BufferList))return new BufferList(buf);BufferList._init.call(this,buf)}BufferList._init=function(buf){Object.defineProperty(this,symbol,{value:!0}),this._bufs=[],this.length=0,buf&&this.append(buf)},BufferList.prototype._new=function(buf){return new BufferList(buf)},BufferList.prototype._offset=function(offset){if(0===offset)return[0,0];let tot=0;for(let i=0;i<this._bufs.length;i++){const _t=tot+this._bufs[i].length;if(offset<_t||i===this._bufs.length-1)return[i,offset-tot];tot=_t}},BufferList.prototype._reverseOffset=function(blOffset){const bufferId=blOffset[0];let offset=blOffset[1];for(let i=0;i<bufferId;i++)offset+=this._bufs[i].length;return offset},BufferList.prototype.get=function(index){if(index>this.length||index<0)return;const offset=this._offset(index);return this._bufs[offset[0]][offset[1]]},BufferList.prototype.slice=function(start,end){return"number"==typeof start&&start<0&&(start+=this.length),"number"==typeof end&&end<0&&(end+=this.length),this.copy(null,0,start,end)},BufferList.prototype.copy=function(dst,dstStart,srcStart,srcEnd){if(("number"!=typeof srcStart||srcStart<0)&&(srcStart=0),("number"!=typeof srcEnd||srcEnd>this.length)&&(srcEnd=this.length),srcStart>=this.length)return dst||Buffer.alloc(0);if(srcEnd<=0)return dst||Buffer.alloc(0);const copy=!!dst,off=this._offset(srcStart),len=srcEnd-srcStart;let bytes=len,bufoff=copy&&dstStart||0,start=off[1];if(0===srcStart&&srcEnd===this.length){if(!copy)return 1===this._bufs.length?this._bufs[0]:Buffer.concat(this._bufs,this.length);for(let i=0;i<this._bufs.length;i++)this._bufs[i].copy(dst,bufoff),bufoff+=this._bufs[i].length;return dst}if(bytes<=this._bufs[off[0]].length-start)return copy?this._bufs[off[0]].copy(dst,dstStart,start,start+bytes):this._bufs[off[0]].slice(start,start+bytes);copy||(dst=Buffer.allocUnsafe(len));for(let i=off[0];i<this._bufs.length;i++){const l=this._bufs[i].length-start;if(!(bytes>l)){this._bufs[i].copy(dst,bufoff,start,start+bytes),bufoff+=l;break}this._bufs[i].copy(dst,bufoff,start),bufoff+=l,bytes-=l,start&&(start=0)}return dst.length>bufoff?dst.slice(0,bufoff):dst},BufferList.prototype.shallowSlice=function(start,end){if(start=start||0,end="number"!=typeof end?this.length:end,start<0&&(start+=this.length),end<0&&(end+=this.length),start===end)return this._new();const startOffset=this._offset(start),endOffset=this._offset(end),buffers=this._bufs.slice(startOffset[0],endOffset[0]+1);return 0===endOffset[1]?buffers.pop():buffers[buffers.length-1]=buffers[buffers.length-1].slice(0,endOffset[1]),0!==startOffset[1]&&(buffers[0]=buffers[0].slice(startOffset[1])),this._new(buffers)},BufferList.prototype.toString=function(encoding,start,end){return this.slice(start,end).toString(encoding)},BufferList.prototype.consume=function(bytes){if(bytes=Math.trunc(bytes),Number.isNaN(bytes)||bytes<=0)return this;for(;this._bufs.length;){if(!(bytes>=this._bufs[0].length)){this._bufs[0]=this._bufs[0].slice(bytes),this.length-=bytes;break}bytes-=this._bufs[0].length,this.length-=this._bufs[0].length,this._bufs.shift()}return this},BufferList.prototype.duplicate=function(){const copy=this._new();for(let i=0;i<this._bufs.length;i++)copy.append(this._bufs[i]);return copy},BufferList.prototype.append=function(buf){if(null==buf)return this;if(buf.buffer)this._appendBuffer(Buffer.from(buf.buffer,buf.byteOffset,buf.byteLength));else if(Array.isArray(buf))for(let i=0;i<buf.length;i++)this.append(buf[i]);else if(this._isBufferList(buf))for(let i=0;i<buf._bufs.length;i++)this.append(buf._bufs[i]);else"number"==typeof buf&&(buf=buf.toString()),this._appendBuffer(Buffer.from(buf));return this},BufferList.prototype._appendBuffer=function(buf){this._bufs.push(buf),this.length+=buf.length},BufferList.prototype.indexOf=function(search,offset,encoding){if(void 0===encoding&&"string"==typeof offset&&(encoding=offset,offset=void 0),"function"==typeof search||Array.isArray(search))throw new TypeError('The "value" argument must be one of type string, Buffer, BufferList, or Uint8Array.');if("number"==typeof search?search=Buffer.from([search]):"string"==typeof search?search=Buffer.from(search,encoding):this._isBufferList(search)?search=search.slice():Array.isArray(search.buffer)?search=Buffer.from(search.buffer,search.byteOffset,search.byteLength):Buffer.isBuffer(search)||(search=Buffer.from(search)),offset=Number(offset||0),isNaN(offset)&&(offset=0),offset<0&&(offset=this.length+offset),offset<0&&(offset=0),0===search.length)return offset>this.length?this.length:offset;const blOffset=this._offset(offset);let blIndex=blOffset[0],buffOffset=blOffset[1];for(;blIndex<this._bufs.length;blIndex++){const buff=this._bufs[blIndex];for(;buffOffset<buff.length;){if(buff.length-buffOffset>=search.length){const nativeSearchResult=buff.indexOf(search,buffOffset);if(-1!==nativeSearchResult)return this._reverseOffset([blIndex,nativeSearchResult]);buffOffset=buff.length-search.length+1}else{const revOffset=this._reverseOffset([blIndex,buffOffset]);if(this._match(revOffset,search))return revOffset;buffOffset++}}buffOffset=0}return-1},BufferList.prototype._match=function(offset,search){if(this.length-offset<search.length)return!1;for(let searchOffset=0;searchOffset<search.length;searchOffset++)if(this.get(offset+searchOffset)!==search[searchOffset])return!1;return!0},function(){const methods={readDoubleBE:8,readDoubleLE:8,readFloatBE:4,readFloatLE:4,readInt32BE:4,readInt32LE:4,readUInt32BE:4,readUInt32LE:4,readInt16BE:2,readInt16LE:2,readUInt16BE:2,readUInt16LE:2,readInt8:1,readUInt8:1,readIntBE:null,readIntLE:null,readUIntBE:null,readUIntLE:null};for(const m in methods)!function(m){null===methods[m]?BufferList.prototype[m]=function(offset,byteLength){return this.slice(offset,offset+byteLength)[m](0,byteLength)}:BufferList.prototype[m]=function(offset=0){return this.slice(offset,offset+methods[m])[m](0)}}(m)}(),BufferList.prototype._isBufferList=function(b){return b instanceof BufferList||BufferList.isBufferList(b)},BufferList.isBufferList=function(b){return null!=b&&b[symbol]},module.exports=BufferList;