"use strict";const tape=require("tape"),BufferList=require("../"),{Buffer:Buffer}=require("buffer");tape("indexOf single byte needle",(t=>{const bl=new BufferList(["abcdefg","abcdefg","12345"]);t.equal(bl.indexOf("e"),4),t.equal(bl.indexOf("e",5),11),t.equal(bl.indexOf("e",12),-1),t.equal(bl.indexOf("5"),18),t.end()})),tape("indexOf multiple byte needle",(t=>{const bl=new BufferList(["abcdefg","abcdefg"]);t.equal(bl.indexOf("ef"),4),t.equal(bl.indexOf("ef",5),11),t.end()})),tape("indexOf multiple byte needles across buffer boundaries",(t=>{const bl=new BufferList(["abcdefg","abcdefg"]);t.equal(bl.indexOf("fgabc"),5),t.end()})),tape("indexOf takes a Uint8Array search",(t=>{const bl=new BufferList(["abcdefg","abcdefg"]),search=new Uint8Array([102,103,97,98,99]);t.equal(bl.indexOf(search),5),t.end()})),tape("indexOf takes a buffer list search",(t=>{const bl=new BufferList(["abcdefg","abcdefg"]),search=new BufferList("fgabc");t.equal(bl.indexOf(search),5),t.end()})),tape("indexOf a zero byte needle",(t=>{const b=new BufferList("abcdef"),bufEmpty=Buffer.from("");t.equal(b.indexOf(""),0),t.equal(b.indexOf("",1),1),t.equal(b.indexOf("",b.length+1),b.length),t.equal(b.indexOf("",1/0),b.length),t.equal(b.indexOf(bufEmpty),0),t.equal(b.indexOf(bufEmpty,1),1),t.equal(b.indexOf(bufEmpty,b.length+1),b.length),t.equal(b.indexOf(bufEmpty,1/0),b.length),t.end()})),tape("indexOf buffers smaller and larger than the needle",(t=>{const bl=new BufferList(["abcdefg","a","bcdefg","a","bcfgab"]);t.equal(bl.indexOf("fgabc"),5),t.equal(bl.indexOf("fgabc",6),12),t.equal(bl.indexOf("fgabc",13),-1),t.end()})),process.version.substr(1).split(".")[0]>=6&&tape("indexOf latin1 and binary encoding",(t=>{const b=new BufferList("abcdef");t.equal(new BufferList(Buffer.from(b.toString("latin1"),"latin1")).indexOf("d",0,"latin1"),3),t.equal(new BufferList(Buffer.from(b.toString("latin1"),"latin1")).indexOf(Buffer.from("d","latin1"),0,"latin1"),3),t.equal(new BufferList(Buffer.from("aaèaa","latin1")).indexOf("è","latin1"),2),t.equal(new BufferList(Buffer.from("è","latin1")).indexOf("è","latin1"),0),t.equal(new BufferList(Buffer.from("è","latin1")).indexOf(Buffer.from("è","latin1"),"latin1"),0),t.equal(new BufferList(Buffer.from(b.toString("binary"),"binary")).indexOf("d",0,"binary"),3),t.equal(new BufferList(Buffer.from(b.toString("binary"),"binary")).indexOf(Buffer.from("d","binary"),0,"binary"),3),t.equal(new BufferList(Buffer.from("aaèaa","binary")).indexOf("è","binary"),2),t.equal(new BufferList(Buffer.from("è","binary")).indexOf("è","binary"),0),t.equal(new BufferList(Buffer.from("è","binary")).indexOf(Buffer.from("è","binary"),"binary"),0),t.end()})),tape("indexOf the entire nodejs10 buffer test suite",(t=>{const b=new BufferList("abcdef"),bufA=Buffer.from("a"),bufBc=Buffer.from("bc"),bufF=Buffer.from("f"),bufZ=Buffer.from("z"),stringComparison="abcdef";t.equal(b.indexOf("a"),0),t.equal(b.indexOf("a",1),-1),t.equal(b.indexOf("a",-1),-1),t.equal(b.indexOf("a",-4),-1),t.equal(b.indexOf("a",-b.length),0),t.equal(b.indexOf("a",NaN),0),t.equal(b.indexOf("a",-1/0),0),t.equal(b.indexOf("a",1/0),-1),t.equal(b.indexOf("bc"),1),t.equal(b.indexOf("bc",2),-1),t.equal(b.indexOf("bc",-1),-1),t.equal(b.indexOf("bc",-3),-1),t.equal(b.indexOf("bc",-5),1),t.equal(b.indexOf("bc",NaN),1),t.equal(b.indexOf("bc",-1/0),1),t.equal(b.indexOf("bc",1/0),-1),t.equal(b.indexOf("f"),b.length-1),t.equal(b.indexOf("z"),-1),t.equal(b.indexOf(bufA),0),t.equal(b.indexOf(bufA,1),-1),t.equal(b.indexOf(bufA,-1),-1),t.equal(b.indexOf(bufA,-4),-1),t.equal(b.indexOf(bufA,-b.length),0),t.equal(b.indexOf(bufA,NaN),0),t.equal(b.indexOf(bufA,-1/0),0),t.equal(b.indexOf(bufA,1/0),-1),t.equal(b.indexOf(bufBc),1),t.equal(b.indexOf(bufBc,2),-1),t.equal(b.indexOf(bufBc,-1),-1),t.equal(b.indexOf(bufBc,-3),-1),t.equal(b.indexOf(bufBc,-5),1),t.equal(b.indexOf(bufBc,NaN),1),t.equal(b.indexOf(bufBc,-1/0),1),t.equal(b.indexOf(bufBc,1/0),-1),t.equal(b.indexOf(bufF),b.length-1),t.equal(b.indexOf(bufZ),-1),t.equal(b.indexOf(97),0),t.equal(b.indexOf(97,1),-1),t.equal(b.indexOf(97,-1),-1),t.equal(b.indexOf(97,-4),-1),t.equal(b.indexOf(97,-b.length),0),t.equal(b.indexOf(97,NaN),0),t.equal(b.indexOf(97,-1/0),0),t.equal(b.indexOf(97,1/0),-1),t.equal(b.indexOf(0),-1),t.equal(b.indexOf("d",2),3),t.equal(b.indexOf("f",5),5),t.equal(b.indexOf("f",-1),5),t.equal(b.indexOf("f",6),-1),t.equal(b.indexOf(Buffer.from("d"),2),3),t.equal(b.indexOf(Buffer.from("f"),5),5),t.equal(b.indexOf(Buffer.from("f"),-1),5),t.equal(b.indexOf(Buffer.from("f"),6),-1),t.equal(Buffer.from("ff").indexOf(Buffer.from("f"),1,"ucs2"),-1),t.equal(b.indexOf("b","utf8"),1),t.equal(b.indexOf("b","UTF8"),1),t.equal(b.indexOf("62","HEX"),1),t.throws((()=>b.indexOf("bad","enc")),TypeError),t.equal(Buffer.from(b.toString("hex"),"hex").indexOf("64",0,"hex"),3),t.equal(Buffer.from(b.toString("hex"),"hex").indexOf(Buffer.from("64","hex"),0,"hex"),3),t.equal(Buffer.from(b.toString("base64"),"base64").indexOf("ZA==",0,"base64"),3),t.equal(Buffer.from(b.toString("base64"),"base64").indexOf(Buffer.from("ZA==","base64"),0,"base64"),3),t.equal(Buffer.from(b.toString("ascii"),"ascii").indexOf("d",0,"ascii"),3),t.equal(Buffer.from(b.toString("ascii"),"ascii").indexOf(Buffer.from("d","ascii"),0,"ascii"),3),t.equal(Buffer.from("aaaa0").indexOf("30","hex"),4),t.equal(Buffer.from("aaaa00a").indexOf("3030","hex"),4);{const twoByteString=Buffer.from("ΚΑΣΣΕ","ucs2");t.equal(8,twoByteString.indexOf("Ε",4,"ucs2")),t.equal(6,twoByteString.indexOf("Σ",-4,"ucs2")),t.equal(4,twoByteString.indexOf("Σ",-6,"ucs2")),t.equal(4,twoByteString.indexOf(Buffer.from("Σ","ucs2"),-6,"ucs2")),t.equal(-1,twoByteString.indexOf("Σ",-2,"ucs2"))}const mixedByteStringUcs2=Buffer.from("ΚΑabcΣΣΕ","ucs2");t.equal(6,mixedByteStringUcs2.indexOf("bc",0,"ucs2")),t.equal(10,mixedByteStringUcs2.indexOf("Σ",0,"ucs2")),t.equal(-1,mixedByteStringUcs2.indexOf("Ζ",0,"ucs2")),t.equal(6,mixedByteStringUcs2.indexOf(Buffer.from("bc","ucs2"),0,"ucs2")),t.equal(10,mixedByteStringUcs2.indexOf(Buffer.from("Σ","ucs2"),0,"ucs2")),t.equal(-1,mixedByteStringUcs2.indexOf(Buffer.from("Ζ","ucs2"),0,"ucs2"));{const twoByteString=Buffer.from("ΚΑΣΣΕ","ucs2");t.equal(0,twoByteString.indexOf("Κ",0,"ucs2"));let index=twoByteString.indexOf("Α",0,"ucs2");t.equal(2,index,`Alpha - at index ${index}`),index=twoByteString.indexOf("Σ",0,"ucs2"),t.equal(4,index,`First Sigma - at index ${index}`),index=twoByteString.indexOf("Σ",6,"ucs2"),t.equal(6,index,`Second Sigma - at index ${index}`),index=twoByteString.indexOf("Ε",0,"ucs2"),t.equal(8,index,`Epsilon - at index ${index}`),index=twoByteString.indexOf("Β",0,"ucs2"),t.equal(-1,index,`Not beta - at index ${index}`),index=twoByteString.indexOf("ΚΑ",0,"ucs2"),t.equal(0,index,`Lambda Alpha - at index ${index}`),index=twoByteString.indexOf("ΑΣ",0,"ucs2"),t.equal(2,index,`Alpha Sigma - at index ${index}`),index=twoByteString.indexOf("ΣΣ",0,"ucs2"),t.equal(4,index,`Sigma Sigma - at index ${index}`),index=twoByteString.indexOf("ΣΕ",0,"ucs2"),t.equal(6,index,`Sigma Epsilon - at index ${index}`)}const mixedByteStringUtf8=Buffer.from("ΚΑabcΣΣΕ");t.equal(5,mixedByteStringUtf8.indexOf("bc")),t.equal(5,mixedByteStringUtf8.indexOf("bc",5)),t.equal(5,mixedByteStringUtf8.indexOf("bc",-8)),t.equal(7,mixedByteStringUtf8.indexOf("Σ")),t.equal(-1,mixedByteStringUtf8.indexOf("Ζ"));let longString="A";for(let i=66;i<76;i++)longString=longString+String.fromCharCode(i)+longString;const longBufferString=Buffer.from(longString);let pattern="ABACABADABACABA";for(let i=0;i<longBufferString.length-pattern.length;i+=7){const index=longBufferString.indexOf(pattern,i);t.equal(i+15&-16,index,`Long ABACABA...-string at index ${i}`)}let index=longBufferString.indexOf("AJABACA");t.equal(510,index,`Long AJABACA, First J - at index ${index}`),index=longBufferString.indexOf("AJABACA",511),t.equal(1534,index,`Long AJABACA, Second J - at index ${index}`),pattern="JABACABADABACABA",index=longBufferString.indexOf(pattern),t.equal(511,index,`Long JABACABA..., First J - at index ${index}`),index=longBufferString.indexOf(pattern,512),t.equal(1535,index,`Long JABACABA..., Second J - at index ${index}`);const asciiString=Buffer.from("somethingnotatallsinisterwhichalsoworks");t.equal(-1,asciiString.indexOf(" 61")),t.equal(3,asciiString.indexOf("eth",0));const allCodePoints=[];for(let i=0;i<65536;i++)allCodePoints[i]=i;const allCharsString=String.fromCharCode.apply(String,allCodePoints),allCharsBufferUtf8=Buffer.from(allCharsString),allCharsBufferUcs2=Buffer.from(allCharsString,"ucs2");t.equal(-1,allCharsBufferUtf8.indexOf("notfound")),t.equal(-1,allCharsBufferUcs2.indexOf("notfound")),t.equal(Buffer.from("aaaa").indexOf("a".repeat(4),"ucs2"),-1),t.equal(Buffer.from("aaaa").indexOf("a".repeat(4),"utf8"),0),t.equal(Buffer.from("aaaa").indexOf("你好","ucs2"),-1),t.equal(Buffer.from("aaaaa").indexOf("b","ucs2"),-1);{const lengths=[1,3,15],indices=[5,96,1024,1664,2030,65282,91664,194427];for(let lengthIndex=0;lengthIndex<lengths.length;lengthIndex++)for(let i=0;i<indices.length;i++){const index=indices[i];let length=lengths[lengthIndex];index+length>127&&(length*=2),index+length>2047&&(length*=3),index+length>65535&&(length*=4);const patternBufferUtf8=allCharsBufferUtf8.slice(index,index+length);t.equal(index,allCharsBufferUtf8.indexOf(patternBufferUtf8));const patternStringUtf8=patternBufferUtf8.toString();t.equal(index,allCharsBufferUtf8.indexOf(patternStringUtf8))}}{const lengths=[2,4,16],indices=[5,101,261,517,645,8197,8325,65520];for(let lengthIndex=0;lengthIndex<lengths.length;lengthIndex++)for(let i=0;i<indices.length;i++){const index=2*indices[i],length=lengths[lengthIndex],patternBufferUcs2=allCharsBufferUcs2.slice(index,index+length);t.equal(index,allCharsBufferUcs2.indexOf(patternBufferUcs2,0,"ucs2"));const patternStringUcs2=patternBufferUcs2.toString("ucs2");t.equal(index,allCharsBufferUcs2.indexOf(patternStringUcs2,0,"ucs2"))}}[()=>{},{},[]].forEach((val=>{t.throws((()=>b.indexOf(val)),TypeError,`"${JSON.stringify(val)}" should throw`)})),t.equal(b.indexOf("b",void 0),1),t.equal(b.indexOf("b",{}),1),t.equal(b.indexOf("b",0),1),t.equal(b.indexOf("b",null),1),t.equal(b.indexOf("b",[]),1),t.equal(b.indexOf("b",[2]),-1),t.equal(b.indexOf("b",void 0),stringComparison.indexOf("b",void 0)),t.equal(b.indexOf("b",{}),stringComparison.indexOf("b",{})),t.equal(b.indexOf("b",0),stringComparison.indexOf("b",0)),t.equal(b.indexOf("b",null),stringComparison.indexOf("b",null)),t.equal(b.indexOf("b",[]),stringComparison.indexOf("b",[])),t.equal(b.indexOf("b",[2]),stringComparison.indexOf("b",[2]));{const buf=Buffer.from("this is a test");t.equal(buf.indexOf(26995),3),t.equal(buf.indexOf(6910752),4),t.equal(buf.indexOf(1769152617),2),t.equal(buf.indexOf(0x697374657374),0),t.equal(buf.indexOf(1769173876),0),t.equal(buf.indexOf(1769174117),11),t.equal(buf.indexOf(1769174117),11),t.equal(buf.indexOf(-140),0),t.equal(buf.indexOf(-152),1),t.equal(buf.indexOf(255),-1),t.equal(buf.indexOf(65535),-1)}{const needle=new Uint8Array([102,111,111]),haystack=new BufferList(Buffer.from("a foo b foo"));t.equal(haystack.indexOf(needle),2)}t.end()}));