"use strict";var __awaiter=this&&this.__awaiter||function(thisArg,_arguments,P,generator){function adopt(value){return value instanceof P?value:new P((function(resolve){resolve(value)}))}return new(P||(P=Promise))((function(resolve,reject){function fulfilled(value){try{step(generator.next(value))}catch(e){reject(e)}}function rejected(value){try{step(generator.throw(value))}catch(e){reject(e)}}function step(result){result.done?resolve(result.value):adopt(result.value).then(fulfilled,rejected)}step((generator=generator.apply(thisArg,_arguments||[])).next())}))},__importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{default:mod}};Object.defineProperty(exports,"__esModule",{value:!0});const net_1=__importDefault(require("net")),tls_1=__importDefault(require("tls")),url_1=__importDefault(require("url")),assert_1=__importDefault(require("assert")),debug_1=__importDefault(require("debug")),agent_base_1=require("agent-base"),parse_proxy_response_1=__importDefault(require("./parse-proxy-response")),debug=debug_1.default("https-proxy-agent:agent");class HttpsProxyAgent extends agent_base_1.Agent{constructor(_opts){let opts;if(opts="string"==typeof _opts?url_1.default.parse(_opts):_opts,!opts)throw new Error("an HTTP(S) proxy server `host` and `port` must be specified!");debug("creating new HttpsProxyAgent instance: %o",opts),super(opts);const proxy=Object.assign({},opts);this.secureProxy=opts.secureProxy||isHTTPS(proxy.protocol),proxy.host=proxy.hostname||proxy.host,"string"==typeof proxy.port&&(proxy.port=parseInt(proxy.port,10)),!proxy.port&&proxy.host&&(proxy.port=this.secureProxy?443:80),this.secureProxy&&!("ALPNProtocols"in proxy)&&(proxy.ALPNProtocols=["http 1.1"]),proxy.host&&proxy.path&&(delete proxy.path,delete proxy.pathname),this.proxy=proxy}callback(req,opts){return __awaiter(this,void 0,void 0,(function*(){const{proxy:proxy,secureProxy:secureProxy}=this;let socket;secureProxy?(debug("Creating `tls.Socket`: %o",proxy),socket=tls_1.default.connect(proxy)):(debug("Creating `net.Socket`: %o",proxy),socket=net_1.default.connect(proxy));const headers=Object.assign({},proxy.headers);let payload=`CONNECT ${`${opts.host}:${opts.port}`} HTTP/1.1\r\n`;proxy.auth&&(headers["Proxy-Authorization"]=`Basic ${Buffer.from(proxy.auth).toString("base64")}`);let{host:host,port:port,secureEndpoint:secureEndpoint}=opts;isDefaultPort(port,secureEndpoint)||(host+=`:${port}`),headers.Host=host,headers.Connection="close";for(const name of Object.keys(headers))payload+=`${name}: ${headers[name]}\r\n`;const proxyResponsePromise=parse_proxy_response_1.default(socket);socket.write(`${payload}\r\n`);const{statusCode:statusCode,buffered:buffered}=yield proxyResponsePromise;if(200===statusCode){if(req.once("socket",resume),opts.secureEndpoint){debug("Upgrading socket connection to TLS");const servername=opts.servername||opts.host;return tls_1.default.connect(Object.assign(Object.assign({},omit(opts,"host","hostname","path","port")),{socket:socket,servername:servername}))}return socket}socket.destroy();const fakeSocket=new net_1.default.Socket({writable:!1});return fakeSocket.readable=!0,req.once("socket",(s=>{debug("replaying proxy buffer for failed request"),assert_1.default(s.listenerCount("data")>0),s.push(buffered),s.push(null)})),fakeSocket}))}}function resume(socket){socket.resume()}function isDefaultPort(port,secure){return Boolean(!secure&&80===port||secure&&443===port)}function isHTTPS(protocol){return"string"==typeof protocol&&/^https:?$/i.test(protocol)}function omit(obj,...keys){const ret={};let key;for(key in obj)keys.includes(key)||(ret[key]=obj[key]);return ret}exports.default=HttpsProxyAgent;