"use strict";var support=require("./support"),base64=require("./base64"),nodejsUtils=require("./nodejsUtils"),external=require("./external");function string2binary(str){return stringToArrayLike(str,support.uint8array?new Uint8Array(str.length):new Array(str.length))}function identity(input){return input}function stringToArrayLike(str,array){for(var i=0;i<str.length;++i)array[i]=255&str.charCodeAt(i);return array}require("setimmediate"),exports.newBlob=function(part,type){exports.checkSupport("blob");try{return new Blob([part],{type:type})}catch(e){try{var builder=new(self.BlobBuilder||self.WebKitBlobBuilder||self.MozBlobBuilder||self.MSBlobBuilder);return builder.append(part),builder.getBlob(type)}catch(e){throw new Error("Bug : can't construct the Blob.")}}};var arrayToStringHelper={stringifyByChunk:function(array,type,chunk){var result=[],k=0,len=array.length;if(len<=chunk)return String.fromCharCode.apply(null,array);for(;k<len;)"array"===type||"nodebuffer"===type?result.push(String.fromCharCode.apply(null,array.slice(k,Math.min(k+chunk,len)))):result.push(String.fromCharCode.apply(null,array.subarray(k,Math.min(k+chunk,len)))),k+=chunk;return result.join("")},stringifyByChar:function(array){for(var resultStr="",i=0;i<array.length;i++)resultStr+=String.fromCharCode(array[i]);return resultStr},applyCanBeUsed:{uint8array:function(){try{return support.uint8array&&1===String.fromCharCode.apply(null,new Uint8Array(1)).length}catch(e){return!1}}(),nodebuffer:function(){try{return support.nodebuffer&&1===String.fromCharCode.apply(null,nodejsUtils.allocBuffer(1)).length}catch(e){return!1}}()}};function arrayLikeToString(array){var chunk=65536,type=exports.getTypeOf(array),canUseApply=!0;if("uint8array"===type?canUseApply=arrayToStringHelper.applyCanBeUsed.uint8array:"nodebuffer"===type&&(canUseApply=arrayToStringHelper.applyCanBeUsed.nodebuffer),canUseApply)for(;chunk>1;)try{return arrayToStringHelper.stringifyByChunk(array,type,chunk)}catch(e){chunk=Math.floor(chunk/2)}return arrayToStringHelper.stringifyByChar(array)}function arrayLikeToArrayLike(arrayFrom,arrayTo){for(var i=0;i<arrayFrom.length;i++)arrayTo[i]=arrayFrom[i];return arrayTo}exports.applyFromCharCode=arrayLikeToString;var transform={};transform.string={string:identity,array:function(input){return stringToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return transform.string.uint8array(input).buffer},uint8array:function(input){return stringToArrayLike(input,new Uint8Array(input.length))},nodebuffer:function(input){return stringToArrayLike(input,nodejsUtils.allocBuffer(input.length))}},transform.array={string:arrayLikeToString,array:identity,arraybuffer:function(input){return new Uint8Array(input).buffer},uint8array:function(input){return new Uint8Array(input)},nodebuffer:function(input){return nodejsUtils.newBufferFrom(input)}},transform.arraybuffer={string:function(input){return arrayLikeToString(new Uint8Array(input))},array:function(input){return arrayLikeToArrayLike(new Uint8Array(input),new Array(input.byteLength))},arraybuffer:identity,uint8array:function(input){return new Uint8Array(input)},nodebuffer:function(input){return nodejsUtils.newBufferFrom(new Uint8Array(input))}},transform.uint8array={string:arrayLikeToString,array:function(input){return arrayLikeToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return input.buffer},uint8array:identity,nodebuffer:function(input){return nodejsUtils.newBufferFrom(input)}},transform.nodebuffer={string:arrayLikeToString,array:function(input){return arrayLikeToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return transform.nodebuffer.uint8array(input).buffer},uint8array:function(input){return arrayLikeToArrayLike(input,new Uint8Array(input.length))},nodebuffer:identity},exports.transformTo=function(outputType,input){if(input||(input=""),!outputType)return input;exports.checkSupport(outputType);var inputType=exports.getTypeOf(input);return transform[inputType][outputType](input)},exports.resolve=function(path){for(var parts=path.split("/"),result=[],index=0;index<parts.length;index++){var part=parts[index];"."===part||""===part&&0!==index&&index!==parts.length-1||(".."===part?result.pop():result.push(part))}return result.join("/")},exports.getTypeOf=function(input){return"string"==typeof input?"string":"[object Array]"===Object.prototype.toString.call(input)?"array":support.nodebuffer&&nodejsUtils.isBuffer(input)?"nodebuffer":support.uint8array&&input instanceof Uint8Array?"uint8array":support.arraybuffer&&input instanceof ArrayBuffer?"arraybuffer":void 0},exports.checkSupport=function(type){if(!support[type.toLowerCase()])throw new Error(type+" is not supported by this platform")},exports.MAX_VALUE_16BITS=65535,exports.MAX_VALUE_32BITS=-1,exports.pretty=function(str){var code,i,res="";for(i=0;i<(str||"").length;i++)res+="\\x"+((code=str.charCodeAt(i))<16?"0":"")+code.toString(16).toUpperCase();return res},exports.delay=function(callback,args,self){setImmediate((function(){callback.apply(self||null,args||[])}))},exports.inherits=function(ctor,superCtor){var Obj=function(){};Obj.prototype=superCtor.prototype,ctor.prototype=new Obj},exports.extend=function(){var i,attr,result={};for(i=0;i<arguments.length;i++)for(attr in arguments[i])Object.prototype.hasOwnProperty.call(arguments[i],attr)&&void 0===result[attr]&&(result[attr]=arguments[i][attr]);return result},exports.prepareContent=function(name,inputData,isBinary,isOptimizedBinaryString,isBase64){return external.Promise.resolve(inputData).then((function(data){return support.blob&&(data instanceof Blob||-1!==["[object File]","[object Blob]"].indexOf(Object.prototype.toString.call(data)))&&"undefined"!=typeof FileReader?new external.Promise((function(resolve,reject){var reader=new FileReader;reader.onload=function(e){resolve(e.target.result)},reader.onerror=function(e){reject(e.target.error)},reader.readAsArrayBuffer(data)})):data})).then((function(data){var dataType=exports.getTypeOf(data);return dataType?("arraybuffer"===dataType?data=exports.transformTo("uint8array",data):"string"===dataType&&(isBase64?data=base64.decode(data):isBinary&&!0!==isOptimizedBinaryString&&(data=string2binary(data))),data):external.Promise.reject(new Error("Can't read the data of '"+name+"'. Is it in a supported JavaScript type (String, Blob, ArrayBuffer, etc) ?"))}))};