var bufferEqual=require("buffer-equal-constant-time"),Buffer=require("safe-buffer").Buffer,crypto=require("crypto"),formatEcdsa=require("ecdsa-sig-formatter"),util=require("util"),MSG_INVALID_ALGORITHM='"%s" is not a valid algorithm.\n  Supported algorithms are:\n  "HS256", "HS384", "HS512", "RS256", "RS384", "RS512", "PS256", "PS384", "PS512", "ES256", "ES384", "ES512" and "none".',MSG_INVALID_SECRET="secret must be a string or buffer",MSG_INVALID_VERIFIER_KEY="key must be a string or a buffer",MSG_INVALID_SIGNER_KEY="key must be a string, a buffer or an object",supportsKeyObjects="function"==typeof crypto.createPublicKey;function checkIsPublicKey(key){if(!Buffer.isBuffer(key)&&"string"!=typeof key){if(!supportsKeyObjects)throw typeError(MSG_INVALID_VERIFIER_KEY);if("object"!=typeof key)throw typeError(MSG_INVALID_VERIFIER_KEY);if("string"!=typeof key.type)throw typeError(MSG_INVALID_VERIFIER_KEY);if("string"!=typeof key.asymmetricKeyType)throw typeError(MSG_INVALID_VERIFIER_KEY);if("function"!=typeof key.export)throw typeError(MSG_INVALID_VERIFIER_KEY)}}function checkIsPrivateKey(key){if(!Buffer.isBuffer(key)&&"string"!=typeof key&&"object"!=typeof key)throw typeError(MSG_INVALID_SIGNER_KEY)}function checkIsSecretKey(key){if(!Buffer.isBuffer(key)){if("string"==typeof key)return key;if(!supportsKeyObjects)throw typeError(MSG_INVALID_SECRET);if("object"!=typeof key)throw typeError(MSG_INVALID_SECRET);if("secret"!==key.type)throw typeError(MSG_INVALID_SECRET);if("function"!=typeof key.export)throw typeError(MSG_INVALID_SECRET)}}function fromBase64(base64){return base64.replace(/=/g,"").replace(/\+/g,"-").replace(/\//g,"_")}function toBase64(base64url){var padding=4-(base64url=base64url.toString()).length%4;if(4!==padding)for(var i=0;i<padding;++i)base64url+="=";return base64url.replace(/\-/g,"+").replace(/_/g,"/")}function typeError(template){var args=[].slice.call(arguments,1),errMsg=util.format.bind(util,template).apply(null,args);return new TypeError(errMsg)}function bufferOrString(obj){return Buffer.isBuffer(obj)||"string"==typeof obj}function normalizeInput(thing){return bufferOrString(thing)||(thing=JSON.stringify(thing)),thing}function createHmacSigner(bits){return function(thing,secret){checkIsSecretKey(secret),thing=normalizeInput(thing);var hmac=crypto.createHmac("sha"+bits,secret);return fromBase64((hmac.update(thing),hmac.digest("base64")))}}function createHmacVerifier(bits){return function(thing,signature,secret){var computedSig=createHmacSigner(bits)(thing,secret);return bufferEqual(Buffer.from(signature),Buffer.from(computedSig))}}function createKeySigner(bits){return function(thing,privateKey){checkIsPrivateKey(privateKey),thing=normalizeInput(thing);var signer=crypto.createSign("RSA-SHA"+bits);return fromBase64((signer.update(thing),signer.sign(privateKey,"base64")))}}function createKeyVerifier(bits){return function(thing,signature,publicKey){checkIsPublicKey(publicKey),thing=normalizeInput(thing),signature=toBase64(signature);var verifier=crypto.createVerify("RSA-SHA"+bits);return verifier.update(thing),verifier.verify(publicKey,signature,"base64")}}function createPSSKeySigner(bits){return function(thing,privateKey){checkIsPrivateKey(privateKey),thing=normalizeInput(thing);var signer=crypto.createSign("RSA-SHA"+bits);return fromBase64((signer.update(thing),signer.sign({key:privateKey,padding:crypto.constants.RSA_PKCS1_PSS_PADDING,saltLength:crypto.constants.RSA_PSS_SALTLEN_DIGEST},"base64")))}}function createPSSKeyVerifier(bits){return function(thing,signature,publicKey){checkIsPublicKey(publicKey),thing=normalizeInput(thing),signature=toBase64(signature);var verifier=crypto.createVerify("RSA-SHA"+bits);return verifier.update(thing),verifier.verify({key:publicKey,padding:crypto.constants.RSA_PKCS1_PSS_PADDING,saltLength:crypto.constants.RSA_PSS_SALTLEN_DIGEST},signature,"base64")}}function createECDSASigner(bits){var inner=createKeySigner(bits);return function(){var signature=inner.apply(null,arguments);return signature=formatEcdsa.derToJose(signature,"ES"+bits)}}function createECDSAVerifer(bits){var inner=createKeyVerifier(bits);return function(thing,signature,publicKey){return signature=formatEcdsa.joseToDer(signature,"ES"+bits).toString("base64"),inner(thing,signature,publicKey)}}function createNoneSigner(){return function(){return""}}function createNoneVerifier(){return function(thing,signature){return""===signature}}supportsKeyObjects&&(MSG_INVALID_VERIFIER_KEY+=" or a KeyObject",MSG_INVALID_SECRET+="or a KeyObject"),module.exports=function(algorithm){var signerFactories={hs:createHmacSigner,rs:createKeySigner,ps:createPSSKeySigner,es:createECDSASigner,none:createNoneSigner},verifierFactories={hs:createHmacVerifier,rs:createKeyVerifier,ps:createPSSKeyVerifier,es:createECDSAVerifer,none:createNoneVerifier},match=algorithm.match(/^(RS|PS|ES|HS)(256|384|512)$|^(none)$/);if(!match)throw typeError(MSG_INVALID_ALGORITHM,algorithm);var algo=(match[1]||match[3]).toLowerCase(),bits=match[2];return{sign:signerFactories[algo](bits),verify:verifierFactories[algo](bits)}};