"use strict";const debug=require("debug")("mssql:base"),{EventEmitter:EventEmitter}=require("events"),{Readable:Readable}=require("stream"),{IDS:IDS,objectHasProperty:objectHasProperty}=require("../utils"),globalConnection=require("../global-connection"),{RequestError:RequestError,ConnectionError:ConnectionError}=require("../error"),{TYPES:TYPES}=require("../datatypes"),shared=require("../shared");class Request extends EventEmitter{constructor(parent){super(),IDS.add(this,"Request"),debug("request(%d): created",IDS.get(this)),this.canceled=!1,this._paused=!1,this.parent=parent||globalConnection.pool,this.parameters={},this.stream=null,this.arrayRowMode=null}get paused(){return this._paused}template(){const values=Array.prototype.slice.call(arguments),strings=values.shift();return this._template(strings,values)}_template(strings,values,method){const command=[strings[0]];for(let index=0;index<values.length;index++){const value=values[index];if(Array.isArray(value)){for(let parameterIndex=0;parameterIndex<value.length;parameterIndex++)this.input(`param${index+1}_${parameterIndex}`,value[parameterIndex]),command.push(`@param${index+1}_${parameterIndex}`),parameterIndex<value.length-1&&command.push(", ");command.push(strings[index+1])}else this.input(`param${index+1}`,value),command.push(`@param${index+1}`,strings[index+1])}return method?this[method](command.join("")):command.join("")}input(name,type,value){if(/(--| |\/\*|\*\/|')/.test(name))throw new RequestError(`SQL injection warning for param '${name}'`,"EINJECT");if(arguments.length<2)throw new RequestError("Invalid number of arguments. At least 2 arguments expected.","EARGS");if(2===arguments.length&&(value=type,type=shared.getTypeByValue(value)),!value||"function"!=typeof value.valueOf||value instanceof Date||(value=value.valueOf()),void 0===value&&(value=null),"number"==typeof value&&isNaN(value)&&(value=null),type instanceof Function&&(type=type()),objectHasProperty(this.parameters,name))throw new RequestError(`The parameter name ${name} has already been declared. Parameter names must be unique`,"EDUPEPARAM");return this.parameters[name]={name:name,type:type.type,io:1,value:value,length:type.length,scale:type.scale,precision:type.precision,tvpType:type.tvpType},this}replaceInput(name,type,value){return delete this.parameters[name],this.input(name,type,value)}output(name,type,value){if(type||(type=TYPES.NVarChar),/(--| |\/\*|\*\/|')/.test(name))throw new RequestError(`SQL injection warning for param '${name}'`,"EINJECT");if(type===TYPES.Text||type===TYPES.NText||type===TYPES.Image)throw new RequestError("Deprecated types (Text, NText, Image) are not supported as OUTPUT parameters.","EDEPRECATED");if(!value||"function"!=typeof value.valueOf||value instanceof Date||(value=value.valueOf()),void 0===value&&(value=null),"number"==typeof value&&isNaN(value)&&(value=null),type instanceof Function&&(type=type()),objectHasProperty(this.parameters,name))throw new RequestError(`The parameter name ${name} has already been declared. Parameter names must be unique`,"EDUPEPARAM");return this.parameters[name]={name:name,type:type.type,io:2,value:value,length:type.length,scale:type.scale,precision:type.precision},this}replaceOutput(name,type,value){return delete this.parameters[name],this.output(name,type,value)}batch(batch,callback){if(null===this.stream&&this.parent&&(this.stream=this.parent.config.stream),null===this.arrayRowMode&&this.parent&&(this.arrayRowMode=this.parent.config.arrayRowMode),this.rowsAffected=0,"function"==typeof callback)return this._batch(batch,((err,recordsets,output,rowsAffected)=>{if(this.stream&&(err&&this.emit("error",err),err=null,this.emit("done",{output:output,rowsAffected:rowsAffected})),err)return callback(err);callback(null,{recordsets:recordsets,recordset:recordsets&&recordsets[0],output:output,rowsAffected:rowsAffected})})),this;if("object"==typeof batch){const values=Array.prototype.slice.call(arguments),strings=values.shift();batch=this._template(strings,values)}return new shared.Promise(((resolve,reject)=>{this._batch(batch,((err,recordsets,output,rowsAffected)=>{if(this.stream&&(err&&this.emit("error",err),err=null,this.emit("done",{output:output,rowsAffected:rowsAffected})),err)return reject(err);resolve({recordsets:recordsets,recordset:recordsets&&recordsets[0],output:output,rowsAffected:rowsAffected})}))}))}_batch(batch,callback){return this.parent?this.parent.connected?(this.canceled=!1,void setImmediate(callback)):setImmediate(callback,new ConnectionError("Connection is closed.","ECONNCLOSED")):setImmediate(callback,new RequestError("No connection is specified for that request.","ENOCONN"))}bulk(table,options,callback){return"function"==typeof options?(callback=options,options={}):void 0===options&&(options={}),null===this.stream&&this.parent&&(this.stream=this.parent.config.stream),null===this.arrayRowMode&&this.parent&&(this.arrayRowMode=this.parent.config.arrayRowMode),this.stream||"function"==typeof callback?(this._bulk(table,options,((err,rowsAffected)=>this.stream?(err&&this.emit("error",err),this.emit("done",{rowsAffected:rowsAffected})):err?callback(err):void callback(null,{rowsAffected:rowsAffected}))),this):new shared.Promise(((resolve,reject)=>{this._bulk(table,options,((err,rowsAffected)=>{if(err)return reject(err);resolve({rowsAffected:rowsAffected})}))}))}_bulk(table,options,callback){return this.parent?this.parent.connected?(this.canceled=!1,void setImmediate(callback)):setImmediate(callback,new ConnectionError("Connection is closed.","ECONNCLOSED")):setImmediate(callback,new RequestError("No connection is specified for that request.","ENOCONN"))}toReadableStream(streamOptions={}){this.stream=!0,this.pause();const readableStream=new Readable({...streamOptions,objectMode:!0,read:()=>{this.resume()}});return this.on("row",(row=>{readableStream.push(row)||this.pause()})),this.on("error",(error=>{readableStream.emit("error",error)})),this.on("done",(()=>{readableStream.push(null)})),readableStream}pipe(writableStream){return this.toReadableStream().pipe(writableStream)}query(command,callback){if(null===this.stream&&this.parent&&(this.stream=this.parent.config.stream),null===this.arrayRowMode&&this.parent&&(this.arrayRowMode=this.parent.config.arrayRowMode),this.rowsAffected=0,"function"==typeof callback)return this._query(command,((err,recordsets,output,rowsAffected,columns)=>{if(this.stream&&(err&&this.emit("error",err),err=null,this.emit("done",{output:output,rowsAffected:rowsAffected})),err)return callback(err);const result={recordsets:recordsets,recordset:recordsets&&recordsets[0],output:output,rowsAffected:rowsAffected};this.arrayRowMode&&(result.columns=columns),callback(null,result)})),this;if("object"==typeof command){const values=Array.prototype.slice.call(arguments),strings=values.shift();command=this._template(strings,values)}return new shared.Promise(((resolve,reject)=>{this._query(command,((err,recordsets,output,rowsAffected,columns)=>{if(this.stream&&(err&&this.emit("error",err),err=null,this.emit("done",{output:output,rowsAffected:rowsAffected})),err)return reject(err);const result={recordsets:recordsets,recordset:recordsets&&recordsets[0],output:output,rowsAffected:rowsAffected};this.arrayRowMode&&(result.columns=columns),resolve(result)}))}))}_query(command,callback){return this.parent?this.parent.connected?(this.canceled=!1,void setImmediate(callback)):setImmediate(callback,new ConnectionError("Connection is closed.","ECONNCLOSED")):setImmediate(callback,new RequestError("No connection is specified for that request.","ENOCONN"))}execute(command,callback){return null===this.stream&&this.parent&&(this.stream=this.parent.config.stream),null===this.arrayRowMode&&this.parent&&(this.arrayRowMode=this.parent.config.arrayRowMode),this.rowsAffected=0,"function"==typeof callback?(this._execute(command,((err,recordsets,output,returnValue,rowsAffected,columns)=>{if(this.stream&&(err&&this.emit("error",err),err=null,this.emit("done",{output:output,rowsAffected:rowsAffected,returnValue:returnValue})),err)return callback(err);const result={recordsets:recordsets,recordset:recordsets&&recordsets[0],output:output,rowsAffected:rowsAffected,returnValue:returnValue};this.arrayRowMode&&(result.columns=columns),callback(null,result)})),this):new shared.Promise(((resolve,reject)=>{this._execute(command,((err,recordsets,output,returnValue,rowsAffected,columns)=>{if(this.stream&&(err&&this.emit("error",err),err=null,this.emit("done",{output:output,rowsAffected:rowsAffected,returnValue:returnValue})),err)return reject(err);const result={recordsets:recordsets,recordset:recordsets&&recordsets[0],output:output,rowsAffected:rowsAffected,returnValue:returnValue};this.arrayRowMode&&(result.columns=columns),resolve(result)}))}))}_execute(procedure,callback){return this.parent?this.parent.connected?(this.canceled=!1,void setImmediate(callback)):setImmediate(callback,new ConnectionError("Connection is closed.","ECONNCLOSED")):setImmediate(callback,new RequestError("No connection is specified for that request.","ENOCONN"))}cancel(){return this._cancel(),!0}_cancel(){this.canceled=!0}pause(){return!!this.stream&&(this._pause(),!0)}_pause(){this._paused=!0}resume(){return!!this.stream&&(this._resume(),!0)}_resume(){this._paused=!1}_setCurrentRequest(request){return this._currentRequest=request,this._paused&&this.pause(),this}}module.exports=Request;