"use strict";const objectHasProperty=require("./utils").objectHasProperty,inspect=Symbol.for("nodejs.util.inspect.custom"),TYPES={VarChar:length=>({type:TYPES.VarChar,length:length}),NVarChar:length=>({type:TYPES.NVarChar,length:length}),Text:()=>({type:TYPES.Text}),Int:()=>({type:TYPES.Int}),BigInt:()=>({type:TYPES.BigInt}),TinyInt:()=>({type:TYPES.TinyInt}),SmallInt:()=>({type:TYPES.SmallInt}),Bit:()=>({type:TYPES.Bit}),Float:()=>({type:TYPES.Float}),Numeric:(precision,scale)=>({type:TYPES.Numeric,precision:precision,scale:scale}),Decimal:(precision,scale)=>({type:TYPES.Decimal,precision:precision,scale:scale}),Real:()=>({type:TYPES.Real}),Date:()=>({type:TYPES.Date}),DateTime:()=>({type:TYPES.DateTime}),DateTime2:scale=>({type:TYPES.DateTime2,scale:scale}),DateTimeOffset:scale=>({type:TYPES.DateTimeOffset,scale:scale}),SmallDateTime:()=>({type:TYPES.SmallDateTime}),Time:scale=>({type:TYPES.Time,scale:scale}),UniqueIdentifier:()=>({type:TYPES.UniqueIdentifier}),SmallMoney:()=>({type:TYPES.SmallMoney}),Money:()=>({type:TYPES.Money}),Binary:length=>({type:TYPES.Binary,length:length}),VarBinary:length=>({type:TYPES.VarBinary,length:length}),Image:()=>({type:TYPES.Image}),Xml:()=>({type:TYPES.Xml}),Char:length=>({type:TYPES.Char,length:length}),NChar:length=>({type:TYPES.NChar,length:length}),NText:()=>({type:TYPES.NText}),TVP:tvpType=>({type:TYPES.TVP,tvpType:tvpType}),UDT:()=>({type:TYPES.UDT}),Geography:()=>({type:TYPES.Geography}),Geometry:()=>({type:TYPES.Geometry}),Variant:()=>({type:TYPES.Variant})};module.exports.TYPES=TYPES,module.exports.DECLARATIONS={};const zero=function(value,length){if(null==length&&(length=2),(value=String(value)).length<length)for(let i=1;i<=length-value.length;i++)value=`0${value}`;return value};for(const key in TYPES)if(objectHasProperty(TYPES,key)){const value=TYPES[key];value.declaration=key.toLowerCase(),module.exports.DECLARATIONS[value.declaration]=value,((key,value)=>{value[inspect]=()=>`[sql.${key}]`})(key,value)}module.exports.declare=(type,options)=>{switch(type){case TYPES.VarChar:case TYPES.VarBinary:return`${type.declaration} (${options.length>8e3||null==options.length?"MAX":options.length})`;case TYPES.NVarChar:return`${type.declaration} (${options.length>4e3||null==options.length?"MAX":options.length})`;case TYPES.Char:case TYPES.NChar:case TYPES.Binary:return`${type.declaration} (${null==options.length?1:options.length})`;case TYPES.Decimal:case TYPES.Numeric:return`${type.declaration} (${null==options.precision?18:options.precision}, ${null==options.scale?0:options.scale})`;case TYPES.Time:case TYPES.DateTime2:case TYPES.DateTimeOffset:return`${type.declaration} (${null==options.scale?7:options.scale})`;case TYPES.TVP:return`${options.tvpType} readonly`;default:return type.declaration}},module.exports.cast=(value,type,options)=>{if(null==value)return null;switch(typeof value){case"string":return`N'${value.replace(/'/g,"''")}'`;case"number":return value;case"boolean":return value?1:0;case"object":if(value instanceof Date){let ns=value.getUTCMilliseconds()/1e3;null!=value.nanosecondDelta&&(ns+=value.nanosecondDelta);const scale=null==options.scale?7:options.scale;return ns=scale>0?String(ns).substr(1,scale+1):"",`N'${value.getUTCFullYear()}-${zero(value.getUTCMonth()+1)}-${zero(value.getUTCDate())} ${zero(value.getUTCHours())}:${zero(value.getUTCMinutes())}:${zero(value.getUTCSeconds())}${ns}'`}return Buffer.isBuffer(value)?`0x${value.toString("hex")}`:null;default:return null}};