"use strict";const msnodesql=require("msnodesqlv8"),debug=require("debug")("mssql:msv8"),BaseRequest=require("../base/request"),RequestError=require("../error/request-error"),{IDS:IDS,objectHasProperty:objectHasProperty}=require("../utils"),{TYPES:TYPES,DECLARATIONS:DECLARATIONS,declare:declare}=require("../datatypes"),{PARSERS:UDT}=require("../udt"),Table=require("../table"),{valueHandler:valueHandler}=require("../shared"),JSON_COLUMN_ID="JSON_F52E2B61-18A1-11d1-B105-00805F49916B",XML_COLUMN_ID="XML_F52E2B61-18A1-11d1-B105-00805F49916B",EMPTY_BUFFER=Buffer.alloc(0),castParameter=function(value,type){if(null==value)return type===TYPES.Binary||type===TYPES.VarBinary||type===TYPES.Image?EMPTY_BUFFER:null;switch(type){case TYPES.VarChar:case TYPES.NVarChar:case TYPES.Char:case TYPES.NChar:case TYPES.Xml:case TYPES.Text:case TYPES.NText:"string"==typeof value||value instanceof String||(value=value.toString());break;case TYPES.Int:case TYPES.TinyInt:case TYPES.BigInt:case TYPES.SmallInt:"number"==typeof value||value instanceof Number||(value=parseInt(value),isNaN(value)&&(value=null));break;case TYPES.Float:case TYPES.Real:case TYPES.Decimal:case TYPES.Numeric:case TYPES.SmallMoney:case TYPES.Money:"number"==typeof value||value instanceof Number||(value=parseFloat(value),isNaN(value)&&(value=null));break;case TYPES.Bit:"boolean"==typeof value||value instanceof Boolean||(value=Boolean(value));break;case TYPES.DateTime:case TYPES.SmallDateTime:case TYPES.DateTimeOffset:case TYPES.Date:value instanceof Date||(value=new Date(value));break;case TYPES.Binary:case TYPES.VarBinary:case TYPES.Image:value instanceof Buffer||(value=Buffer.from(value.toString()));break;case TYPES.TVP:value=msnodesql.TvpFromTable(value)}return value},createColumns=function(metadata,arrayRowMode){let out={};arrayRowMode&&(out=[]);for(let index=0,length=metadata.length;index<length;index++){const column=metadata[index],colName=column.name,outColumn={index:index,name:column.name,length:column.size,type:DECLARATIONS[column.sqlType],nullable:column.nullable};null!=column.udtType&&(outColumn.udt={name:column.udtType},DECLARATIONS[column.udtType]&&(outColumn.type=DECLARATIONS[column.udtType])),arrayRowMode?out.push(outColumn):out[colName]=outColumn}return out},valueCorrection=function(value,metadata){const type=metadata&&objectHasProperty(metadata,"sqlType")&&objectHasProperty(DECLARATIONS,metadata.sqlType)?DECLARATIONS[metadata.sqlType]:null;return type&&valueHandler.has(type)?valueHandler.get(type)(value):"time"===metadata.sqlType&&null!=value?(value.setFullYear(1970),value):"udt"===metadata.sqlType&&null!=value&&UDT[metadata.udtType]?UDT[metadata.udtType](value):value};class Request extends BaseRequest{_batch(batch,callback){this._isBatch=!0,this._query(batch,callback)}_bulk(table,options,callback){super._bulk(table,options,(err=>{if(err)return callback(err);try{table._makeBulk()}catch(e){return callback(new RequestError(e,"EREQUEST"))}table.name||setImmediate(callback,new RequestError("Table name must be specified for bulk insert.","ENAME")),"@"===table.name.charAt(0)&&setImmediate(callback,new RequestError("You can't use table variables for bulk insert.","ENAME")),this.parent.acquire(this,((err,connection)=>{let hasReturned=!1;if(!err){if(debug("connection(%d): borrowed to request #%d",IDS.get(connection),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),this.parent.release(connection),callback(new RequestError("Canceled.","ECANCEL"));const done=(err,rowCount)=>{hasReturned||(hasReturned=!0,err&&("string"==typeof err.sqlstate&&"08s01"===err.sqlstate.toLowerCase()&&(connection.hasError=!0),(err=new RequestError(err)).code="EREQUEST"),this.parent.release(connection),err?callback(err):callback(null,table.rows.length))},go=()=>connection.tableMgr().bind(table.path.replace(/\[|\]/g,""),(mgr=>{if(0===mgr.columns.length)return done(new RequestError("Table was not found on the server.","ENAME"));const rows=[];for(const row of Array.from(table.rows)){const item={};for(let index=0;index<table.columns.length;index++){item[table.columns[index].name]=row[index]}rows.push(item)}mgr.insertRows(rows,done)}));if(table.create){let objectid;return objectid=table.temporary?`tempdb..[${table.name}]`:table.path,connection.queryRaw(`if object_id('${objectid.replace(/'/g,"''")}') is null ${table.declare()}`,(function(err){if(err)return done(err);go()}))}go()}}))}))}_query(command,callback){super._query(command,(err=>{if(err)return callback(err);if(0===command.length)return callback(null,[]);const recordsets=[],recordsetcolumns=[],errors=[],errorHandlers={},output={},rowsAffected=[];let hasReturned=!1,row=null,columns=null,recordset=null,handleOutput=!1,isChunkedRecordset=!1,chunksBuffer=null;const handleError=(req,connection,info,moreErrors)=>{const doReturn=!moreErrors;"string"==typeof info.sqlstate&&"08s01"===info.sqlstate.toLowerCase()&&(connection.hasError=!0);const err=new RequestError(info,"EREQUEST");if(err.code="EREQUEST",this.stream)this.emit("error",err);else if(doReturn&&!hasReturned){if(req)for(const event in errorHandlers)req.removeListener(event,errorHandlers[event]);let previous;connection&&(this.parent.release(connection),delete this._cancel,debug("request(%d): failed",IDS.get(this),err)),errors.length&&(previous=errors.pop(),err.precedingErrors||(err.precedingErrors=[]),err.precedingErrors.push(previous)),hasReturned=!0,callback(err)}errors.push(err)};if(!this._nested){const input=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];input.push(`@${param.name} ${declare(param.type,param)}`)}const sets=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];1===param.io&&sets.push(`set @${param.name}=?`)}const output=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];2===param.io&&output.push(`@${param.name} as '${param.name}'`)}input.length&&(command=`declare ${input.join(",")};${sets.join(";")};${command};`),output.length&&(command+=`select ${output.join(",")};`,handleOutput=!0)}this.parent.acquire(this,((err,connection,config)=>{if(err)return callback(err);if(debug("connection(%d): borrowed to request #%d",IDS.get(connection),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),this.parent.release(connection),callback(new RequestError("Canceled.","ECANCEL"));const params=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];(1===param.io||2===param.io&&param.value)&&params.push(castParameter(param.value,param.type))}debug("request(%d): query",IDS.get(this),command);const req=connection.queryRaw({query_str:command,query_timeout:config.requestTimeout/1e3},params);this._setCurrentRequest(req),this._cancel=()=>{debug("request(%d): cancel",IDS.get(this)),req.cancelQuery((err=>{err&&debug("request(%d): failed to cancel",IDS.get(this),err);try{req.isPaused()&&req.emit("done")}catch(err){}}))},req.on("meta",(metadata=>{if(row&&isChunkedRecordset){const concatenatedChunks=chunksBuffer.join("");if(columns[0].name===JSON_COLUMN_ID&&!0===config.parseJSON)try{row=""===concatenatedChunks?null:JSON.parse(concatenatedChunks),this.stream||(recordsets[recordsets.length-1][0]=row)}catch(ex){row=null;const ex2=new RequestError(`Failed to parse incoming JSON. ${ex.message}`,"EJSON");this.stream?this.emit("error",ex2):console.error(ex2)}else row[columns[0].name]=concatenatedChunks;chunksBuffer=null,row&&null==row.___return___&&this.stream&&!this.paused&&this.emit("row",row)}row=null,columns=metadata,recordset=[],Object.defineProperty(recordset,"columns",{enumerable:!1,configurable:!0,value:createColumns(metadata,this.arrayRowMode)}),Object.defineProperty(recordset,"toTable",{enumerable:!1,configurable:!0,value(name){return Table.fromRecordset(this,name)}}),isChunkedRecordset=!1,1!==metadata.length||metadata[0].name!==JSON_COLUMN_ID&&metadata[0].name!==XML_COLUMN_ID||(isChunkedRecordset=!0,chunksBuffer=[]);let hasReturnColumn=!1;if(null!=recordset.columns.___return___)hasReturnColumn=!0;else if(this.arrayRowMode)for(let i=0;i<columns.length;i++)if("___return___"===columns[i].name){hasReturnColumn=!0;break}this.stream?hasReturnColumn||this.emit("recordset",recordset.columns):recordsets.push(recordset),this.arrayRowMode&&recordsetcolumns.push(recordset.columns)})),req.on("row",(rownumber=>{row&&isChunkedRecordset||(row=this.arrayRowMode?[]:{},this.stream||recordset.push(row))})),req.on("column",((idx,data,more)=>{if(isChunkedRecordset)chunksBuffer.push(data);else{if(data=valueCorrection(data,columns[idx]),this.arrayRowMode)row.push(data);else{const exi=row[columns[idx].name];null!=exi?exi instanceof Array?exi.push(data):row[columns[idx].name]=[exi,data]:row[columns[idx].name]=data}let hasReturnColumn=!1;if(row&&null!=row.___return___)hasReturnColumn=!0;else if(this.arrayRowMode)for(let i=0;i<columns.length;i++)if("___return___"===columns[i].name){hasReturnColumn=!0;break}hasReturnColumn||this.stream&&!this.paused&&idx===columns.length-1&&this.emit("row",row)}})),req.on("rowcount",(rowCount=>{rowsAffected.push(rowCount),this.stream&&this.emit("rowsaffected",rowCount)})),req.on("info",(msg=>{if(/^\[Microsoft\]\[SQL Server Native Client 11\.0\](?:\[SQL Server\])?([\s\S]*)$/.exec(msg.message)&&(msg.message=RegExp.$1),this.emit("info",{message:msg.message,number:msg.code,state:msg.sqlstate,class:msg.class||0,lineNumber:msg.lineNumber||0,serverName:msg.serverName,procName:msg.procName}),3621===msg.code&&!hasReturned){const error=errors.length>0?errors.pop():msg;handleError(req,connection,error.originalError||error,!1)}})),req.on("error",errorHandlers.error=handleError.bind(null,req,connection)),req.once("done",(()=>{if(!hasReturned){if(hasReturned=!0,!this._nested){if(row&&isChunkedRecordset){const concatenatedChunks=chunksBuffer.join("");if(columns[0].name===JSON_COLUMN_ID&&!0===config.parseJSON)try{row=""===concatenatedChunks?null:JSON.parse(concatenatedChunks),this.stream||(recordsets[recordsets.length-1][0]=row)}catch(ex){row=null;const ex2=new RequestError(`Failed to parse incoming JSON. ${ex.message}`,"EJSON");this.stream?this.emit("error",ex2):console.error(ex2)}else row[columns[0].name]=concatenatedChunks;chunksBuffer=null,row&&null==row.___return___&&this.stream&&!this.paused&&this.emit("row",row)}if(handleOutput&&recordsets.length){const last=recordsets.pop()[0];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];2===param.io&&(output[param.name]=last[param.name])}}}delete this._cancel,this.parent.release(connection),debug("request(%d): completed",IDS.get(this)),this.stream?callback(null,this._nested?row:null,output,rowsAffected,recordsetcolumns):callback(null,recordsets,output,rowsAffected,recordsetcolumns)}}))}))}))}_execute(procedure,callback){super._execute(procedure,(err=>{if(err)return callback(err);const params=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];2===param.io&&params.push(`@${param.name} ${declare(param.type,param)}`)}const sets=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];2===param.io&&param.value&&sets.push(`set @${param.name}=?`)}let cmd=`declare ${["@___return___ int"].concat(params).join(", ")};${sets.join(";")};`;cmd+=`exec @___return___ = ${procedure} `;const spp=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];2===param.io?spp.push(`@${param.name}=@${param.name} output`):spp.push(`@${param.name}=?`)}const params2=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];2===param.io&&params2.push(`@${param.name} as '${param.name}'`)}cmd+=`${spp.join(", ")};`,cmd+=`select ${["@___return___ as '___return___'"].concat(params2).join(", ")};`,this._nested=!0,this._query(cmd,((err,recordsets,output,rowsAffected,recordsetcolumns)=>{if(this._nested=!1,err)return callback(err);let last,returnValue;this.stream?last=recordsets:(last=recordsets.pop(),last&&(last=last[0]));const lastColumns=recordsetcolumns.pop();if(last&&this.arrayRowMode&&lastColumns){let returnColumnIdx=null;const parametersNameToLastIdxDict={};for(let i=0;i<lastColumns.length;i++)"___return___"===lastColumns[i].name?returnColumnIdx=i:objectHasProperty(this.parameters,lastColumns[i].name)&&(parametersNameToLastIdxDict[lastColumns[i].name]=i);null!=returnColumnIdx&&(returnValue=last[returnColumnIdx]);for(const name in parametersNameToLastIdxDict){if(!objectHasProperty(parametersNameToLastIdxDict,name))continue;const param=this.parameters[name];2===param.io&&(output[param.name]=last[parametersNameToLastIdxDict[name]])}}else if(last&&null!=last.___return___){returnValue=last.___return___;for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];2===param.io&&(output[param.name]=last[param.name])}}this.stream?callback(null,null,output,returnValue,rowsAffected,recordsetcolumns):callback(null,recordsets,output,returnValue,rowsAffected,recordsetcolumns)}))}))}_pause(){super._pause(),this._currentRequest&&this._currentRequest.pauseQuery()}_resume(){super._resume(),this._currentRequest&&this._currentRequest.resumeQuery()}}module.exports=Request;