"use strict";const tds=require("tedious"),debug=require("debug")("mssql:tedi"),BaseRequest=require("../base/request"),RequestError=require("../error/request-error"),{IDS:IDS,objectHasProperty:objectHasProperty}=require("../utils"),{TYPES:TYPES,DECLARATIONS:DECLARATIONS,declare:declare,cast:cast}=require("../datatypes"),Table=require("../table"),{PARSERS:UDT}=require("../udt"),{valueHandler:valueHandler}=require("../shared"),JSON_COLUMN_ID="JSON_F52E2B61-18A1-11d1-B105-00805F49916B",XML_COLUMN_ID="XML_F52E2B61-18A1-11d1-B105-00805F49916B",N_TYPES={BitN:104,DateTimeN:111,DecimalN:106,FloatN:109,IntN:38,MoneyN:110,NumericN:108},getTediousType=function(type){switch(type){case TYPES.VarChar:return tds.TYPES.VarChar;case TYPES.NVarChar:return tds.TYPES.NVarChar;case TYPES.Text:return tds.TYPES.Text;case TYPES.Int:return tds.TYPES.Int;case TYPES.BigInt:return tds.TYPES.BigInt;case TYPES.TinyInt:return tds.TYPES.TinyInt;case TYPES.SmallInt:return tds.TYPES.SmallInt;case TYPES.Bit:return tds.TYPES.Bit;case TYPES.Float:return tds.TYPES.Float;case TYPES.Decimal:return tds.TYPES.Decimal;case TYPES.Numeric:return tds.TYPES.Numeric;case TYPES.Real:return tds.TYPES.Real;case TYPES.Money:return tds.TYPES.Money;case TYPES.SmallMoney:return tds.TYPES.SmallMoney;case TYPES.Time:return tds.TYPES.Time;case TYPES.Date:return tds.TYPES.Date;case TYPES.DateTime:return tds.TYPES.DateTime;case TYPES.DateTime2:return tds.TYPES.DateTime2;case TYPES.DateTimeOffset:return tds.TYPES.DateTimeOffset;case TYPES.SmallDateTime:return tds.TYPES.SmallDateTime;case TYPES.UniqueIdentifier:return tds.TYPES.UniqueIdentifier;case TYPES.Xml:return tds.TYPES.NVarChar;case TYPES.Char:return tds.TYPES.Char;case TYPES.NChar:return tds.TYPES.NChar;case TYPES.NText:return tds.TYPES.NVarChar;case TYPES.Image:return tds.TYPES.Image;case TYPES.Binary:return tds.TYPES.Binary;case TYPES.VarBinary:return tds.TYPES.VarBinary;case TYPES.UDT:case TYPES.Geography:case TYPES.Geometry:return tds.TYPES.UDT;case TYPES.TVP:return tds.TYPES.TVP;case TYPES.Variant:return tds.TYPES.Variant;default:return type}},getMssqlType=function(type,length){if("object"==typeof type)switch(type){case tds.TYPES.Char:return TYPES.Char;case tds.TYPES.NChar:return TYPES.NChar;case tds.TYPES.VarChar:return TYPES.VarChar;case tds.TYPES.NVarChar:return TYPES.NVarChar;case tds.TYPES.Text:return TYPES.Text;case tds.TYPES.NText:return TYPES.NText;case tds.TYPES.Int:return TYPES.Int;case tds.TYPES.BigInt:return TYPES.BigInt;case tds.TYPES.TinyInt:return TYPES.TinyInt;case tds.TYPES.SmallInt:return TYPES.SmallInt;case tds.TYPES.Bit:return TYPES.Bit;case tds.TYPES.Float:return TYPES.Float;case tds.TYPES.Real:return TYPES.Real;case tds.TYPES.Money:return TYPES.Money;case tds.TYPES.SmallMoney:return TYPES.SmallMoney;case tds.TYPES.Numeric:return TYPES.Numeric;case tds.TYPES.Decimal:return TYPES.Decimal;case tds.TYPES.DateTime:return TYPES.DateTime;case tds.TYPES.Time:return TYPES.Time;case tds.TYPES.Date:return TYPES.Date;case tds.TYPES.DateTime2:return TYPES.DateTime2;case tds.TYPES.DateTimeOffset:return TYPES.DateTimeOffset;case tds.TYPES.SmallDateTime:return TYPES.SmallDateTime;case tds.TYPES.UniqueIdentifier:return TYPES.UniqueIdentifier;case tds.TYPES.Image:return TYPES.Image;case tds.TYPES.Binary:return TYPES.Binary;case tds.TYPES.VarBinary:return TYPES.VarBinary;case tds.TYPES.Xml:return TYPES.Xml;case tds.TYPES.UDT:return TYPES.UDT;case tds.TYPES.TVP:return TYPES.TVP;case tds.TYPES.Variant:return TYPES.Variant;default:switch(type.id){case N_TYPES.BitN:return TYPES.Bit;case N_TYPES.NumericN:return TYPES.Numeric;case N_TYPES.DecimalN:return TYPES.Decimal;case N_TYPES.IntN:return 8===length?TYPES.BigInt:4===length?TYPES.Int:2===length?TYPES.SmallInt:TYPES.TinyInt;case N_TYPES.FloatN:return 8===length?TYPES.Float:TYPES.Real;case N_TYPES.MoneyN:return 8===length?TYPES.Money:TYPES.SmallMoney;case N_TYPES.DateTimeN:return 8===length?TYPES.DateTime:TYPES.SmallDateTime}}},createColumns=function(metadata,arrayRowMode){let out={};arrayRowMode&&(out=[]);for(let index=0,length=metadata.length;index<length;index++){const column=metadata[index],outColumn={index:index,name:column.colName,length:column.dataLength,type:getMssqlType(column.type,column.dataLength),scale:column.scale,precision:column.precision,nullable:!!(1&column.flags),caseSensitive:!!(2&column.flags),identity:!!(16&column.flags),readOnly:!(12&column.flags)};column.udtInfo&&(outColumn.udt={name:column.udtInfo.typeName,database:column.udtInfo.dbname,schema:column.udtInfo.owningSchema,assembly:column.udtInfo.assemblyName},DECLARATIONS[column.udtInfo.typeName]&&(outColumn.type=DECLARATIONS[column.udtInfo.typeName])),arrayRowMode?out.push(outColumn):out[column.colName]=outColumn}return out},valueCorrection=function(value,metadata){const type=getMssqlType(metadata.type);return valueHandler.has(type)?valueHandler.get(type)(value):metadata.type===tds.TYPES.UDT&&null!=value&&UDT[metadata.udtInfo.typeName]?UDT[metadata.udtInfo.typeName](value):value},parameterCorrection=function(value){if(value instanceof Table){const tvp={name:value.name,schema:value.schema,columns:[],rows:value.rows};for(const col of value.columns)tvp.columns.push({name:col.name,type:getTediousType(col.type),length:col.length,scale:col.scale,precision:col.precision});return tvp}return value};class Request extends BaseRequest{_batch(batch,callback){this._isBatch=!0,this._query(batch,callback)}_bulk(table,options,callback){super._bulk(table,options,(err=>{if(err)return callback(err);try{table._makeBulk()}catch(e){return callback(new RequestError(e,"EREQUEST"))}if(!table.name)return callback(new RequestError("Table name must be specified for bulk insert.","ENAME"));if("@"===table.name.charAt(0))return callback(new RequestError("You can't use table variables for bulk insert.","ENAME"));const errors=[],errorHandlers={};let hasReturned=!1;const handleError=(doReturn,connection,info)=>{let err=new Error(info.message);if(err.info=info,err=new RequestError(err,"EREQUEST"),this.stream)this.emit("error",err);else if(doReturn&&!hasReturned){if(connection){for(const event in errorHandlers)connection.removeListener(event,errorHandlers[event]);this.parent.release(connection)}hasReturned=!0,callback(err)}errors.push(err)},handleInfo=msg=>{this.emit("info",{message:msg.message,number:msg.number,state:msg.state,class:msg.class,lineNumber:msg.lineNumber,serverName:msg.serverName,procName:msg.procName})};this.parent.acquire(this,((err,connection)=>{const callbackWithRelease=(err,...args)=>{try{this.parent.release(connection)}catch(e){}callback(err,...args)};if(err)return callbackWithRelease(err);if(debug("connection(%d): borrowed to request #%d",IDS.get(connection),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),callbackWithRelease(new RequestError("Canceled.","ECANCEL"));this._cancel=()=>{debug("request(%d): cancel",IDS.get(this)),connection.cancel()},connection.on("infoMessage",errorHandlers.infoMessage=handleInfo),connection.on("errorMessage",errorHandlers.errorMessage=handleError.bind(null,!1,connection)),connection.on("error",errorHandlers.error=handleError.bind(null,!0,connection));const done=(err,rowCount)=>{let error;if(err&&(!errors.length||errors.length&&err.message!==errors[errors.length-1].message)&&(err=new RequestError(err,"EREQUEST"),this.stream&&this.emit("error",err),errors.push(err)),delete this._cancel,errors.length&&!this.stream&&(error=errors.pop(),error.precedingErrors=errors),!hasReturned){for(const event in errorHandlers)connection.removeListener(event,errorHandlers[event]);hasReturned=!0,this.stream?callbackWithRelease(null,rowCount):callbackWithRelease(error,rowCount)}},bulk=connection.newBulkLoad(table.path,options,done);for(const col of table.columns)bulk.addColumn(col.name,getTediousType(col.type),{nullable:col.nullable,length:col.length,scale:col.scale,precision:col.precision});if(table.create){const objectid=table.temporary?`tempdb..[${table.name}]`:table.path,req=new tds.Request(`if object_id('${objectid.replace(/'/g,"''")}') is null ${table.declare()}`,(err=>{if(err)return done(err);connection.execBulkLoad(bulk,table.rows)}));this._setCurrentRequest(req),connection.execSqlBatch(req)}else connection.execBulkLoad(bulk,table.rows)}))}))}_query(command,callback){super._query(command,(err=>{if(err)return callback(err);const recordsets=[],recordsetcolumns=[],errors=[],errorHandlers={},output={},rowsAffected=[];let columns={},recordset=[],batchLastRow=null,batchHasOutput=!1,isChunkedRecordset=!1,chunksBuffer=null,hasReturned=!1;const handleError=(doReturn,connection,info)=>{let err=new Error(info.message);if(err.info=info,err=new RequestError(err,"EREQUEST"),this.stream)this.emit("error",err);else if(doReturn&&!hasReturned){if(connection){for(const event in errorHandlers)connection.removeListener(event,errorHandlers[event]);this.parent.release(connection)}hasReturned=!0,callback(err)}errors.push(err)},handleInfo=msg=>{this.emit("info",{message:msg.message,number:msg.number,state:msg.state,class:msg.class,lineNumber:msg.lineNumber,serverName:msg.serverName,procName:msg.procName})};this.parent.acquire(this,((err,connection,config)=>{if(err)return callback(err);let row;if(debug("connection(%d): borrowed to request #%d",IDS.get(connection),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),this.parent.release(connection),callback(new RequestError("Canceled.","ECANCEL"));this._cancel=()=>{debug("request(%d): cancel",IDS.get(this)),connection.cancel()},connection.on("infoMessage",errorHandlers.infoMessage=handleInfo),connection.on("errorMessage",errorHandlers.errorMessage=handleError.bind(null,!1,connection)),connection.on("error",errorHandlers.error=handleError.bind(null,!0,connection)),debug("request(%d): query",IDS.get(this),command);const req=new tds.Request(command,(err=>{if((err?.errors?err.errors:[err]).forEach(((e,i,{length:length})=>{e&&(!errors.length||errors.length&&errors.length>=length&&e.message!==errors[errors.length-length+i].message)&&(e=new RequestError(e,"EREQUEST"),this.stream&&this.emit("error",e),errors.push(e))})),batchHasOutput){this.stream||(batchLastRow=recordsets.pop()[0]);for(const name in batchLastRow){const value=batchLastRow[name];"___return___"!==name&&(output[name]=value)}}let error;if(delete this._cancel,errors.length&&!this.stream&&(error=errors.pop(),error.precedingErrors=errors),!hasReturned){for(const event in errorHandlers)connection.removeListener(event,errorHandlers[event]);this.parent.release(connection),hasReturned=!0,error?debug("request(%d): failed",IDS.get(this),error):debug("request(%d): completed",IDS.get(this)),this.stream?callback(null,null,output,rowsAffected,recordsetcolumns):callback(error,recordsets,output,rowsAffected,recordsetcolumns)}}));this._setCurrentRequest(req),req.on("columnMetadata",(metadata=>{columns=createColumns(metadata,this.arrayRowMode),isChunkedRecordset=!1,1!==metadata.length||metadata[0].colName!==JSON_COLUMN_ID&&metadata[0].colName!==XML_COLUMN_ID||(isChunkedRecordset=!0,chunksBuffer=[]),this.stream&&(this._isBatch&&columns.___return___||this.emit("recordset",columns)),this.arrayRowMode&&recordsetcolumns.push(columns)}));const doneHandler=(rowCount,more)=>{if(null!=rowCount&&(rowsAffected.push(rowCount),this.stream&&this.emit("rowsaffected",rowCount)),0!==Object.keys(columns).length){if(isChunkedRecordset){const concatenatedChunks=chunksBuffer.join("");if(columns[JSON_COLUMN_ID]&&!0===config.parseJSON)try{row=""===concatenatedChunks?null:JSON.parse(concatenatedChunks)}catch(ex){row=null;const ex2=new RequestError(new Error(`Failed to parse incoming JSON. ${ex.message}`),"EJSON");this.stream&&this.emit("error",ex2),errors.push(ex2)}else row={},row[Object.keys(columns)[0]]=concatenatedChunks;chunksBuffer=null,this.stream?this.emit("row",row):recordset.push(row)}this.stream||(Object.defineProperty(recordset,"columns",{enumerable:!1,configurable:!0,value:columns}),Object.defineProperty(recordset,"toTable",{enumerable:!1,configurable:!0,value(name){return Table.fromRecordset(this,name)}}),recordsets.push(recordset)),recordset=[],columns={}}};if(req.on("doneInProc",doneHandler),req.on("done",doneHandler),req.on("returnValue",((parameterName,value,metadata)=>{output[parameterName]=value})),req.on("row",(columns=>{if(recordset||(recordset=[]),isChunkedRecordset)return chunksBuffer.push(columns[0].value);row=this.arrayRowMode?[]:{};for(const col of columns)if(col.value=valueCorrection(col.value,col.metadata),this.arrayRowMode)row.push(col.value);else{const exi=row[col.metadata.colName];void 0!==exi?exi instanceof Array?exi.push(col.value):row[col.metadata.colName]=[exi,col.value]:row[col.metadata.colName]=col.value}this.stream?this._isBatch&&row.___return___?batchLastRow=row:this.emit("row",row):recordset.push(row)})),this._isBatch){if(Object.keys(this.parameters).length){for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];try{param.value=getTediousType(param.type).validate(param.value,this.parent.collation)}catch(e){e.message=`Validation failed for parameter '${name}'. ${e.message}`;const err=new RequestError(e,"EPARAM");return this.parent.release(connection),callback(err)}}const declarations=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];declarations.push(`@${name} ${declare(param.type,param)}`)}const assigns=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];assigns.push(`@${name} = ${cast(param.value,param.type,param)}`)}const selects=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;2===this.parameters[name].io&&selects.push(`@${name} as [${name}]`)}batchHasOutput=selects.length>0,req.sqlTextOrProcedure=`declare ${declarations.join(", ")};select ${assigns.join(", ")};${req.sqlTextOrProcedure};${batchHasOutput?`select 1 as [___return___], ${selects.join(", ")}`:""}`}}else for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];1===param.io?req.addParameter(param.name,getTediousType(param.type),parameterCorrection(param.value),{length:param.length,scale:param.scale,precision:param.precision}):req.addOutputParameter(param.name,getTediousType(param.type),parameterCorrection(param.value),{length:param.length,scale:param.scale,precision:param.precision})}try{connection[this._isBatch?"execSqlBatch":"execSql"](req)}catch(error){handleError(!0,connection,error)}}))}))}_execute(procedure,callback){super._execute(procedure,(err=>{if(err)return callback(err);const recordsets=[],recordsetcolumns=[],errors=[],errorHandlers={},output={},rowsAffected=[];let columns={},recordset=[],returnValue=0,isChunkedRecordset=!1,chunksBuffer=null,hasReturned=!1;const handleError=(doReturn,connection,info)=>{let err=new Error(info.message);if(err.info=info,err=new RequestError(err,"EREQUEST"),this.stream)this.emit("error",err);else if(doReturn&&!hasReturned){if(connection){for(const event in errorHandlers)connection.removeListener(event,errorHandlers[event]);this.parent.release(connection)}hasReturned=!0,callback(err)}errors.push(err)},handleInfo=msg=>{this.emit("info",{message:msg.message,number:msg.number,state:msg.state,class:msg.class,lineNumber:msg.lineNumber,serverName:msg.serverName,procName:msg.procName})};this.parent.acquire(this,((err,connection,config)=>{if(err)return callback(err);let row;if(debug("connection(%d): borrowed to request #%d",IDS.get(connection),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),this.parent.release(connection),callback(new RequestError("Canceled.","ECANCEL"));if(this._cancel=()=>{debug("request(%d): cancel",IDS.get(this)),connection.cancel()},connection.on("infoMessage",errorHandlers.infoMessage=handleInfo),connection.on("errorMessage",errorHandlers.errorMessage=handleError.bind(null,!1,connection)),connection.on("error",errorHandlers.error=handleError.bind(null,!0,connection)),debug.enabled){const params=Object.keys(this.parameters).map((k=>this.parameters[k])),logValue=s=>"string"==typeof s&&s.length>50?s.substring(0,47)+"...":s,logName=param=>param.name+" [sql."+param.type.name+"]",logParams={};params.forEach((p=>{logParams[logName(p)]=logValue(p.value)})),debug("request(%d): execute %s %O",IDS.get(this),procedure,logParams)}const req=new tds.Request(procedure,(err=>{let error;if(err&&(!errors.length||errors.length&&err.message!==errors[errors.length-1].message)&&(err=new RequestError(err,"EREQUEST"),this.stream&&this.emit("error",err),errors.push(err)),delete this._cancel,errors.length&&!this.stream&&(error=errors.pop(),error.precedingErrors=errors),!hasReturned){for(const event in errorHandlers)connection.removeListener(event,errorHandlers[event]);this.parent.release(connection),hasReturned=!0,error?debug("request(%d): failed",IDS.get(this),error):debug("request(%d): complete",IDS.get(this)),this.stream?callback(null,null,output,returnValue,rowsAffected,recordsetcolumns):callback(error,recordsets,output,returnValue,rowsAffected,recordsetcolumns)}}));this._setCurrentRequest(req),req.on("columnMetadata",(metadata=>{columns=createColumns(metadata,this.arrayRowMode),isChunkedRecordset=!1,1!==metadata.length||metadata[0].colName!==JSON_COLUMN_ID&&metadata[0].colName!==XML_COLUMN_ID||(isChunkedRecordset=!0,chunksBuffer=[]),this.stream&&this.emit("recordset",columns),this.arrayRowMode&&recordsetcolumns.push(columns)})),req.on("row",(columns=>{if(recordset||(recordset=[]),isChunkedRecordset)return chunksBuffer.push(columns[0].value);row=this.arrayRowMode?[]:{};for(const col of columns)if(col.value=valueCorrection(col.value,col.metadata),this.arrayRowMode)row.push(col.value);else{const exi=row[col.metadata.colName];null!=exi?exi instanceof Array?exi.push(col.value):row[col.metadata.colName]=[exi,col.value]:row[col.metadata.colName]=col.value}this.stream?this.emit("row",row):recordset.push(row)})),req.on("doneInProc",((rowCount,more)=>{if(null!=rowCount&&(rowsAffected.push(rowCount),this.stream&&this.emit("rowsaffected",rowCount)),0!==Object.keys(columns).length){if(isChunkedRecordset){if(columns[JSON_COLUMN_ID]&&!0===config.parseJSON)try{row=0===chunksBuffer.length?null:JSON.parse(chunksBuffer.join(""))}catch(ex){row=null;const ex2=new RequestError(new Error(`Failed to parse incoming JSON. ${ex.message}`),"EJSON");this.stream&&this.emit("error",ex2),errors.push(ex2)}else row={},row[Object.keys(columns)[0]]=chunksBuffer.join("");chunksBuffer=null,this.stream?this.emit("row",row):recordset.push(row)}this.stream||(Object.defineProperty(recordset,"columns",{enumerable:!1,configurable:!0,value:columns}),Object.defineProperty(recordset,"toTable",{enumerable:!1,configurable:!0,value(name){return Table.fromRecordset(this,name)}}),recordsets.push(recordset)),recordset=[],columns={}}})),req.on("doneProc",((rowCount,more,returnStatus)=>{returnValue=returnStatus})),req.on("returnValue",((parameterName,value,metadata)=>{output[parameterName]=value}));for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];1===param.io?req.addParameter(param.name,getTediousType(param.type),parameterCorrection(param.value),{length:param.length,scale:param.scale,precision:param.precision}):req.addOutputParameter(param.name,getTediousType(param.type),parameterCorrection(param.value),{length:param.length,scale:param.scale,precision:param.precision})}connection.callProcedure(req)}))}))}_pause(){super._pause(),this._currentRequest&&this._currentRequest.pause()}_resume(){super._resume(),this._currentRequest&&this._currentRequest.resume()}}module.exports=Request;