var Crypto=require("crypto"),Events=require("events"),Net=require("net"),tls=require("tls"),ConnectionConfig=require("./ConnectionConfig"),Protocol=require("./protocol/Protocol"),SqlString=require("./protocol/SqlString"),Query=require("./protocol/sequences/Query"),Util=require("util");function Connection(options){Events.EventEmitter.call(this),this.config=options.config,this._socket=options.socket,this._protocol=new Protocol({config:this.config,connection:this}),this._connectCalled=!1,this.state="disconnected",this.threadId=null}function createSecureContext(config,cb){var context=null,error=null;try{context=tls.createSecureContext({ca:config.ssl.ca,cert:config.ssl.cert,ciphers:config.ssl.ciphers,key:config.ssl.key,passphrase:config.ssl.passphrase})}catch(err){error=err}cb(error,context)}function unwrapFromDomain(fn){return function(){for(var ret,domains=[];process.domain;)domains.shift(process.domain),process.domain.exit();try{ret=fn.apply(this,arguments)}finally{for(var i=0;i<domains.length;i++)domains[i].enter()}return ret}}function wrapCallbackInDomain(ee,fn){if("function"==typeof fn){if(fn.domain)return fn;var domain=process.domain;return domain?domain.bind(fn):ee?unwrapFromDomain(wrapToDomain(ee,fn)):fn}}function wrapToDomain(ee,fn){return function(){Events.usingDomains&&ee.domain?(ee.domain.enter(),fn.apply(this,arguments),ee.domain.exit()):fn.apply(this,arguments)}}module.exports=Connection,Util.inherits(Connection,Events.EventEmitter),Connection.createQuery=function(sql,values,callback){if(sql instanceof Query)return sql;var cb=callback,options={};if("function"==typeof sql?cb=sql:"object"==typeof sql?(options=Object.create(sql),"function"==typeof values?cb=values:void 0!==values&&Object.defineProperty(options,"values",{value:values})):(options.sql=sql,"function"==typeof values?cb=values:void 0!==values&&(options.values=values)),void 0!==cb&&void 0===(cb=wrapCallbackInDomain(null,cb)))throw new TypeError("argument callback must be a function when provided");return new Query(options,cb)},Connection.prototype.connect=function(options,callback){if(callback||"function"!=typeof options||(callback=options,options={}),!this._connectCalled){this._connectCalled=!0,this._socket=this.config.socketPath?Net.createConnection(this.config.socketPath):Net.createConnection(this.config.port,this.config.host),Events.usingDomains&&(this._socket.domain=this.domain);var connection=this;if(this._protocol.on("data",(function(data){connection._socket.write(data)})),this._socket.on("data",wrapToDomain(connection,(function(data){connection._protocol.write(data)}))),this._protocol.on("end",(function(){connection._socket.end()})),this._socket.on("end",wrapToDomain(connection,(function(){connection._protocol.end()}))),this._socket.on("error",this._handleNetworkError.bind(this)),this._socket.on("connect",this._handleProtocolConnect.bind(this)),this._protocol.on("handshake",this._handleProtocolHandshake.bind(this)),this._protocol.on("initialize",this._handleProtocolInitialize.bind(this)),this._protocol.on("unhandledError",this._handleProtocolError.bind(this)),this._protocol.on("drain",this._handleProtocolDrain.bind(this)),this._protocol.on("end",this._handleProtocolEnd.bind(this)),this._protocol.on("enqueue",this._handleProtocolEnqueue.bind(this)),this.config.connectTimeout){var handleConnectTimeout=this._handleConnectTimeout.bind(this);this._socket.setTimeout(this.config.connectTimeout,handleConnectTimeout),this._socket.once("connect",(function(){this.setTimeout(0,handleConnectTimeout)}))}}this._protocol.handshake(options,wrapCallbackInDomain(this,callback))},Connection.prototype.changeUser=function(options,callback){callback||"function"!=typeof options||(callback=options,options={}),this._implyConnect();var charsetNumber=options.charset?ConnectionConfig.getCharsetNumber(options.charset):this.config.charsetNumber;return this._protocol.changeUser({user:options.user||this.config.user,password:options.password||this.config.password,database:options.database||this.config.database,timeout:options.timeout,charsetNumber:charsetNumber,currentConfig:this.config},wrapCallbackInDomain(this,callback))},Connection.prototype.beginTransaction=function(options,callback){return callback||"function"!=typeof options||(callback=options,options={}),(options=options||{}).sql="START TRANSACTION",options.values=null,this.query(options,callback)},Connection.prototype.commit=function(options,callback){return callback||"function"!=typeof options||(callback=options,options={}),(options=options||{}).sql="COMMIT",options.values=null,this.query(options,callback)},Connection.prototype.rollback=function(options,callback){return callback||"function"!=typeof options||(callback=options,options={}),(options=options||{}).sql="ROLLBACK",options.values=null,this.query(options,callback)},Connection.prototype.query=function(sql,values,cb){var query=Connection.createQuery(sql,values,cb);return query._connection=this,"object"==typeof sql&&"typeCast"in sql||(query.typeCast=this.config.typeCast),query.sql&&(query.sql=this.format(query.sql,query.values)),query._callback&&(query._callback=wrapCallbackInDomain(this,query._callback)),this._implyConnect(),this._protocol._enqueue(query)},Connection.prototype.ping=function(options,callback){callback||"function"!=typeof options||(callback=options,options={}),this._implyConnect(),this._protocol.ping(options,wrapCallbackInDomain(this,callback))},Connection.prototype.statistics=function(options,callback){callback||"function"!=typeof options||(callback=options,options={}),this._implyConnect(),this._protocol.stats(options,wrapCallbackInDomain(this,callback))},Connection.prototype.end=function(options,callback){var cb=callback,opts=options;callback||"function"!=typeof options||(cb=options,opts=null),void 0===(opts=Object.create(opts||null)).timeout&&(opts.timeout=3e4),this._implyConnect(),this._protocol.quit(opts,wrapCallbackInDomain(this,cb))},Connection.prototype.destroy=function(){this.state="disconnected",this._implyConnect(),this._socket.destroy(),this._protocol.destroy()},Connection.prototype.pause=function(){this._socket.pause(),this._protocol.pause()},Connection.prototype.resume=function(){this._socket.resume(),this._protocol.resume()},Connection.prototype.escape=function(value){return SqlString.escape(value,!1,this.config.timezone)},Connection.prototype.escapeId=function(value){return SqlString.escapeId(value,!1)},Connection.prototype.format=function(sql,values){return"function"==typeof this.config.queryFormat?this.config.queryFormat.call(this,sql,values,this.config.timezone):SqlString.format(sql,values,this.config.stringifyObjects,this.config.timezone)},tls.TLSSocket?Connection.prototype._startTLS=function(onSecure){var connection=this;createSecureContext(this.config,(function(err,secureContext){if(err)onSecure(err);else{connection._socket.removeAllListeners("data"),connection._protocol.removeAllListeners("data");var rejectUnauthorized=connection.config.ssl.rejectUnauthorized,secureEstablished=!1,secureSocket=new tls.TLSSocket(connection._socket,{rejectUnauthorized:rejectUnauthorized,requestCert:!0,secureContext:secureContext,isServer:!1});secureSocket.on("_tlsError",(function(err){secureEstablished?connection._handleNetworkError(err):onSecure(err)})),secureSocket.pipe(connection._protocol),connection._protocol.on("data",(function(data){secureSocket.write(data)})),secureSocket.on("secure",(function(){secureEstablished=!0,onSecure(rejectUnauthorized?this.ssl.verifyError():null)})),secureSocket._start()}}))}:Connection.prototype._startTLS=function(onSecure){var connection=this,credentials=Crypto.createCredentials({ca:this.config.ssl.ca,cert:this.config.ssl.cert,ciphers:this.config.ssl.ciphers,key:this.config.ssl.key,passphrase:this.config.ssl.passphrase}),rejectUnauthorized=this.config.ssl.rejectUnauthorized,secureEstablished=!1,securePair=tls.createSecurePair(credentials,!1,!0,rejectUnauthorized);securePair.on("error",(function(err){secureEstablished?connection._handleNetworkError(err):onSecure(err)})),this._socket.removeAllListeners("data"),this._protocol.removeAllListeners("data"),securePair.encrypted.pipe(this._socket),this._socket.on("data",(function(data){securePair.encrypted.write(data)})),securePair.cleartext.pipe(this._protocol),this._protocol.on("data",(function(data){securePair.cleartext.write(data)})),securePair.on("secure",(function(){if(secureEstablished=!0,rejectUnauthorized){var verifyError=this.ssl.verifyError(),err=verifyError;"string"==typeof err&&((err=new Error(verifyError)).code=verifyError),onSecure(err)}else onSecure()})),securePair._cycle=securePair.cycle,securePair.cycle=function(){return this.ssl&&this.ssl.error&&this.error(),this._cycle.apply(this,arguments)}},Connection.prototype._handleConnectTimeout=function(){this._socket&&(this._socket.setTimeout(0),this._socket.destroy());var err=new Error("connect ETIMEDOUT");err.errorno="ETIMEDOUT",err.code="ETIMEDOUT",err.syscall="connect",this._handleNetworkError(err)},Connection.prototype._handleNetworkError=function(err){this._protocol.handleNetworkError(err)},Connection.prototype._handleProtocolError=function(err){this.state="protocol_error",this.emit("error",err)},Connection.prototype._handleProtocolDrain=function(){this.emit("drain")},Connection.prototype._handleProtocolConnect=function(){this.state="connected",this.emit("connect")},Connection.prototype._handleProtocolHandshake=function(){this.state="authenticated"},Connection.prototype._handleProtocolInitialize=function(packet){this.threadId=packet.threadId},Connection.prototype._handleProtocolEnd=function(err){this.state="disconnected",this.emit("end",err)},Connection.prototype._handleProtocolEnqueue=function(sequence){this.emit("enqueue",sequence)},Connection.prototype._implyConnect=function(){this._connectCalled||this.connect()};