"use strict";const net=require("net"),co=require("co"),expect=require("expect.js"),describe=require("mocha").describe,it=require("mocha").it,before=require("mocha").before,after=require("mocha").after,Pool=require("../");describe("connection timeout",(()=>{const connectionFailure=new Error("Temporary connection failure");before((done=>{this.server=net.createServer((socket=>{socket.on("data",(()=>{}))})),this.server.listen((()=>{this.port=this.server.address().port,done()}))})),after((done=>{this.server.close(done)})),it("should callback with an error if timeout is passed",(done=>{const pool=new Pool({connectionTimeoutMillis:10,port:this.port,host:"localhost"});pool.connect(((err,client,release)=>{expect(err).to.be.an(Error),expect(err.message).to.contain("timeout"),expect(client).to.equal(void 0),expect(pool.idleCount).to.equal(0),done()}))})),it("should reject promise with an error if timeout is passed",(done=>{const pool=new Pool({connectionTimeoutMillis:10,port:this.port,host:"localhost"});pool.connect().catch((err=>{expect(err).to.be.an(Error),expect(err.message).to.contain("timeout"),expect(pool.idleCount).to.equal(0),done()}))})),it("should handle multiple timeouts",co.wrap(function*(){const errors=[],pool=new Pool({connectionTimeoutMillis:1,port:this.port,host:"localhost"});for(var i=0;i<15;i++)try{yield pool.connect()}catch(e){errors.push(e)}expect(errors).to.have.length(15)}.bind(this))),it("should timeout on checkout of used connection",(done=>{const pool=new Pool({connectionTimeoutMillis:100,max:1});pool.connect(((err,client,release)=>{expect(err).to.be(void 0),expect(client).to.not.be(void 0),pool.connect(((err,client)=>{expect(err).to.be.an(Error),expect(client).to.be(void 0),release(),pool.end(done)}))}))})),it("should not break further pending checkouts on a timeout",(done=>{const pool=new Pool({connectionTimeoutMillis:200,max:1});pool.connect(((err,client,releaseOuter)=>{expect(err).to.be(void 0),pool.connect(((err,client)=>{expect(err).to.be.an(Error),expect(client).to.be(void 0),releaseOuter()})),setTimeout((()=>{pool.connect(((err,client,releaseInner)=>{expect(err).to.be(void 0),expect(client).to.not.be(void 0),releaseInner(),pool.end(done)}))}),100)}))})),it("should timeout on query if all clients are busy",(done=>{const pool=new Pool({connectionTimeoutMillis:100,max:1});pool.connect(((err,client,release)=>{expect(err).to.be(void 0),expect(client).to.not.be(void 0),pool.query("select now()",((err,result)=>{expect(err).to.be.an(Error),expect(result).to.be(void 0),release(),pool.end(done)}))}))})),it("should recover from timeout errors",(done=>{const pool=new Pool({connectionTimeoutMillis:100,max:1});pool.connect(((err,client,release)=>{expect(err).to.be(void 0),expect(client).to.not.be(void 0),pool.query("select now()",((err,result)=>{expect(err).to.be.an(Error),expect(result).to.be(void 0),release(),pool.query("select $1::text as name",["brianc"],((err,res)=>{expect(err).to.be(void 0),expect(res.rows).to.have.length(1),pool.end(done)}))}))}))})),it("continues processing after a connection failure",(done=>{const Client=require("pg").Client,orgConnect=Client.prototype.connect;let called=!1;Client.prototype.connect=function(cb){if(!called)return called=!0,setTimeout((()=>{cb(connectionFailure)}),100);orgConnect.call(this,cb)};const pool=new Pool({Client:Client,connectionTimeoutMillis:1e3,max:1});pool.connect(((err,client,release)=>{expect(err).to.be(connectionFailure),pool.query("select $1::text as name",["brianc"],((err,res)=>{expect(err).to.be(void 0),expect(res.rows).to.have.length(1),pool.end(done)}))}))})),it("releases newly connected clients if the queued already timed out",(done=>{const Client=require("pg").Client,orgConnect=Client.prototype.connect;let connection=0;Client.prototype.connect=function(cb){return 0===connection?(connection++,setTimeout((()=>{cb(connectionFailure)}),300)):1===connection?(connection++,setTimeout((()=>{orgConnect.call(this,cb)}),1e3)):void orgConnect.call(this,cb)};const pool=new Pool({Client:Client,connectionTimeoutMillis:1e3,max:1});pool.connect(((err,client,release)=>{expect(err).to.be(connectionFailure)}));let called=0;pool.connect(((err,client,release)=>{expect(called++).to.be(0),expect(err).to.be.an(Error),pool.query("select $1::text as name",["brianc"],((err,res)=>{expect(err).to.be(void 0),expect(res.rows).to.have.length(1),pool.end(done)}))}))}))}));