"use strict";var net=require("net"),EventEmitter=require("events").EventEmitter;const{parse:parse,serialize:serialize}=require("pg-protocol"),{getStream:getStream,getSecureStream:getSecureStream}=require("./stream"),flushBuffer=serialize.flush(),syncBuffer=serialize.sync(),endBuffer=serialize.end();class Connection extends EventEmitter{constructor(config){super(),config=config||{},this.stream=config.stream||getStream(config.ssl),"function"==typeof this.stream&&(this.stream=this.stream(config)),this._keepAlive=config.keepAlive,this._keepAliveInitialDelayMillis=config.keepAliveInitialDelayMillis,this.lastBuffer=!1,this.parsedStatements={},this.ssl=config.ssl||!1,this._ending=!1,this._emitMessage=!1;var self=this;this.on("newListener",(function(eventName){"message"===eventName&&(self._emitMessage=!0)}))}connect(port,host){var self=this;this._connecting=!0,this.stream.setNoDelay(!0),this.stream.connect(port,host),this.stream.once("connect",(function(){self._keepAlive&&self.stream.setKeepAlive(!0,self._keepAliveInitialDelayMillis),self.emit("connect")}));const reportStreamError=function(error){(!self._ending||"ECONNRESET"!==error.code&&"EPIPE"!==error.code)&&self.emit("error",error)};if(this.stream.on("error",reportStreamError),this.stream.on("close",(function(){self.emit("end")})),!this.ssl)return this.attachListeners(this.stream);this.stream.once("data",(function(buffer){switch(buffer.toString("utf8")){case"S":break;case"N":return self.stream.end(),self.emit("error",new Error("The server does not support SSL connections"));default:return self.stream.end(),self.emit("error",new Error("There was an error establishing an SSL connection"))}const options={socket:self.stream};!0!==self.ssl&&(Object.assign(options,self.ssl),"key"in self.ssl&&(options.key=self.ssl.key));var net=require("net");net.isIP&&0===net.isIP(host)&&(options.servername=host);try{self.stream=getSecureStream(options)}catch(err){return self.emit("error",err)}self.attachListeners(self.stream),self.stream.on("error",reportStreamError),self.emit("sslconnect")}))}attachListeners(stream){parse(stream,(msg=>{var eventName="error"===msg.name?"errorMessage":msg.name;this._emitMessage&&this.emit("message",msg),this.emit(eventName,msg)}))}requestSsl(){this.stream.write(serialize.requestSsl())}startup(config){this.stream.write(serialize.startup(config))}cancel(processID,secretKey){this._send(serialize.cancel(processID,secretKey))}password(password){this._send(serialize.password(password))}sendSASLInitialResponseMessage(mechanism,initialResponse){this._send(serialize.sendSASLInitialResponseMessage(mechanism,initialResponse))}sendSCRAMClientFinalMessage(additionalData){this._send(serialize.sendSCRAMClientFinalMessage(additionalData))}_send(buffer){return!!this.stream.writable&&this.stream.write(buffer)}query(text){this._send(serialize.query(text))}parse(query){this._send(serialize.parse(query))}bind(config){this._send(serialize.bind(config))}execute(config){this._send(serialize.execute(config))}flush(){this.stream.writable&&this.stream.write(flushBuffer)}sync(){this._ending=!0,this._send(syncBuffer)}ref(){this.stream.ref()}unref(){this.stream.unref()}end(){if(this._ending=!0,this._connecting&&this.stream.writable)return this.stream.write(endBuffer,(()=>{this.stream.end()}));this.stream.end()}close(msg){this._send(serialize.close(msg))}describe(msg){this._send(serialize.describe(msg))}sendCopyFromChunk(chunk){this._send(serialize.copyData(chunk))}endCopyFrom(){this._send(serialize.copyDone())}sendCopyFail(msg){this._send(serialize.copyFail(msg))}}module.exports=Connection;