"use strict";const crypto=require("./utils");function startSession(mechanisms){if(-1===mechanisms.indexOf("SCRAM-SHA-256"))throw new Error("SASL: Only mechanism SCRAM-SHA-256 is currently supported");const clientNonce=crypto.randomBytes(18).toString("base64");return{mechanism:"SCRAM-SHA-256",clientNonce:clientNonce,response:"n,,n=*,r="+clientNonce,message:"SASLInitialResponse"}}async function continueSession(session,password,serverData){if("SASLInitialResponse"!==session.message)throw new Error("SASL: Last message was not SASLInitialResponse");if("string"!=typeof password)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: client password must be a string");if(""===password)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: client password must be a non-empty string");if("string"!=typeof serverData)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: serverData must be a string");const sv=parseServerFirstMessage(serverData);if(!sv.nonce.startsWith(session.clientNonce))throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: server nonce does not start with client nonce");if(sv.nonce.length===session.clientNonce.length)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: server nonce is too short");var clientFirstMessageBare="n=*,r="+session.clientNonce,serverFirstMessage="r="+sv.nonce+",s="+sv.salt+",i="+sv.iteration,clientFinalMessageWithoutProof="c=biws,r="+sv.nonce,authMessage=clientFirstMessageBare+","+serverFirstMessage+","+clientFinalMessageWithoutProof,saltBytes=Buffer.from(sv.salt,"base64"),saltedPassword=await crypto.deriveKey(password,saltBytes,sv.iteration),clientKey=await crypto.hmacSha256(saltedPassword,"Client Key"),storedKey=await crypto.sha256(clientKey),clientSignature=await crypto.hmacSha256(storedKey,authMessage),clientProof=xorBuffers(Buffer.from(clientKey),Buffer.from(clientSignature)).toString("base64"),serverKey=await crypto.hmacSha256(saltedPassword,"Server Key"),serverSignatureBytes=await crypto.hmacSha256(serverKey,authMessage);session.message="SASLResponse",session.serverSignature=Buffer.from(serverSignatureBytes).toString("base64"),session.response=clientFinalMessageWithoutProof+",p="+clientProof}function finalizeSession(session,serverData){if("SASLResponse"!==session.message)throw new Error("SASL: Last message was not SASLResponse");if("string"!=typeof serverData)throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: serverData must be a string");const{serverSignature:serverSignature}=parseServerFinalMessage(serverData);if(serverSignature!==session.serverSignature)throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature does not match")}function isPrintableChars(text){if("string"!=typeof text)throw new TypeError("SASL: text must be a string");return text.split("").map(((_,i)=>text.charCodeAt(i))).every((c=>c>=33&&c<=43||c>=45&&c<=126))}function isBase64(text){return/^(?:[a-zA-Z0-9+/]{4})*(?:[a-zA-Z0-9+/]{2}==|[a-zA-Z0-9+/]{3}=)?$/.test(text)}function parseAttributePairs(text){if("string"!=typeof text)throw new TypeError("SASL: attribute pairs text must be a string");return new Map(text.split(",").map((attrValue=>{if(!/^.=/.test(attrValue))throw new Error("SASL: Invalid attribute pair entry");return[attrValue[0],attrValue.substring(2)]})))}function parseServerFirstMessage(data){const attrPairs=parseAttributePairs(data),nonce=attrPairs.get("r");if(!nonce)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: nonce missing");if(!isPrintableChars(nonce))throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: nonce must only contain printable characters");const salt=attrPairs.get("s");if(!salt)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: salt missing");if(!isBase64(salt))throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: salt must be base64");const iterationText=attrPairs.get("i");if(!iterationText)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: iteration missing");if(!/^[1-9][0-9]*$/.test(iterationText))throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: invalid iteration count");return{nonce:nonce,salt:salt,iteration:parseInt(iterationText,10)}}function parseServerFinalMessage(serverData){const serverSignature=parseAttributePairs(serverData).get("v");if(!serverSignature)throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature is missing");if(!isBase64(serverSignature))throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature must be base64");return{serverSignature:serverSignature}}function xorBuffers(a,b){if(!Buffer.isBuffer(a))throw new TypeError("first argument must be a Buffer");if(!Buffer.isBuffer(b))throw new TypeError("second argument must be a Buffer");if(a.length!==b.length)throw new Error("Buffer lengths must match");if(0===a.length)throw new Error("Buffers cannot be empty");return Buffer.from(a.map(((_,i)=>a[i]^b[i])))}module.exports={startSession:startSession,continueSession:continueSession,finalizeSession:finalizeSession};