"use strict";const{EventEmitter:EventEmitter}=require("events"),Result=require("./result"),utils=require("./utils");class Query extends EventEmitter{constructor(config,values,callback){super(),config=utils.normalizeQueryConfig(config,values,callback),this.text=config.text,this.values=config.values,this.rows=config.rows,this.types=config.types,this.name=config.name,this.binary=config.binary,this.portal=config.portal||"",this.callback=config.callback,this._rowMode=config.rowMode,process.domain&&config.callback&&(this.callback=process.domain.bind(config.callback)),this._result=new Result(this._rowMode,this.types),this._results=this._result,this.isPreparedStatement=!1,this._canceledDueToError=!1,this._promise=null}requiresPreparation(){return!!this.name||(!!this.rows||!!this.text&&(!!this.values&&this.values.length>0))}_checkForMultirow(){this._result.command&&(Array.isArray(this._results)||(this._results=[this._result]),this._result=new Result(this._rowMode,this.types),this._results.push(this._result))}handleRowDescription(msg){this._checkForMultirow(),this._result.addFields(msg.fields),this._accumulateRows=this.callback||!this.listeners("row").length}handleDataRow(msg){let row;if(!this._canceledDueToError){try{row=this._result.parseRow(msg.fields)}catch(err){return void(this._canceledDueToError=err)}this.emit("row",row,this._result),this._accumulateRows&&this._result.addRow(row)}}handleCommandComplete(msg,connection){this._checkForMultirow(),this._result.addCommandComplete(msg),this.rows&&connection.sync()}handleEmptyQuery(connection){this.rows&&connection.sync()}handleError(err,connection){if(this._canceledDueToError&&(err=this._canceledDueToError,this._canceledDueToError=!1),this.callback)return this.callback(err);this.emit("error",err)}handleReadyForQuery(con){if(this._canceledDueToError)return this.handleError(this._canceledDueToError,con);if(this.callback)try{this.callback(null,this._results)}catch(err){process.nextTick((()=>{throw err}))}this.emit("end",this._results)}submit(connection){if("string"!=typeof this.text&&"string"!=typeof this.name)return new Error("A query must have either text or a name. Supplying neither is unsupported.");const previous=connection.parsedStatements[this.name];return this.text&&previous&&this.text!==previous?new Error(`Prepared statements must be unique - '${this.name}' was used for a different statement`):this.values&&!Array.isArray(this.values)?new Error("Query values must be an array"):(this.requiresPreparation()?this.prepare(connection):connection.query(this.text),null)}hasBeenParsed(connection){return this.name&&connection.parsedStatements[this.name]}handlePortalSuspended(connection){this._getRows(connection,this.rows)}_getRows(connection,rows){connection.execute({portal:this.portal,rows:rows}),rows?connection.flush():connection.sync()}prepare(connection){this.isPreparedStatement=!0,this.hasBeenParsed(connection)||connection.parse({text:this.text,name:this.name,types:this.types});try{connection.bind({portal:this.portal,statement:this.name,values:this.values,binary:this.binary,valueMapper:utils.prepareValue})}catch(err){return void this.handleError(err,connection)}connection.describe({type:"P",name:this.portal||""}),this._getRows(connection,this.rows)}handleCopyInResponse(connection){connection.sendCopyFail("No source stream defined")}handleCopyData(msg,connection){}}module.exports=Query;