/*!
 * serve-static
 * Copyright(c) 2010 Sencha Inc.
 * Copyright(c) 2011 TJ Holowaychuk
 * Copyright(c) 2014-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
"use strict";var encodeUrl=require("encodeurl"),escapeHtml=require("escape-html"),parseUrl=require("parseurl"),resolve=require("path").resolve,send=require("send"),url=require("url");function serveStatic(root,options){if(!root)throw new TypeError("root path required");if("string"!=typeof root)throw new TypeError("root path must be a string");var opts=Object.create(options||null),fallthrough=!1!==opts.fallthrough,redirect=!1!==opts.redirect,setHeaders=opts.setHeaders;if(setHeaders&&"function"!=typeof setHeaders)throw new TypeError("option setHeaders must be function");opts.maxage=opts.maxage||opts.maxAge||0,opts.root=resolve(root);var onDirectory=redirect?createRedirectDirectoryListener():createNotFoundDirectoryListener();return function(req,res,next){if("GET"!==req.method&&"HEAD"!==req.method)return fallthrough?next():(res.statusCode=405,res.setHeader("Allow","GET, HEAD"),res.setHeader("Content-Length","0"),void res.end());var forwardError=!fallthrough,originalUrl=parseUrl.original(req),path=parseUrl(req).pathname;"/"===path&&"/"!==originalUrl.pathname.substr(-1)&&(path="");var stream=send(req,path,opts);stream.on("directory",onDirectory),setHeaders&&stream.on("headers",setHeaders),fallthrough&&stream.on("file",(function(){forwardError=!0})),stream.on("error",(function(err){!forwardError&&err.statusCode<500?next():next(err)})),stream.pipe(res)}}function collapseLeadingSlashes(str){for(var i=0;i<str.length&&47===str.charCodeAt(i);i++);return i>1?"/"+str.substr(i):str}function createHtmlDocument(title,body){return'<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>'+title+"</title>\n</head>\n<body>\n<pre>"+body+"</pre>\n</body>\n</html>\n"}function createNotFoundDirectoryListener(){return function(){this.error(404)}}function createRedirectDirectoryListener(){return function(res){if(this.hasTrailingSlash())this.error(404);else{var originalUrl=parseUrl.original(this.req);originalUrl.path=null,originalUrl.pathname=collapseLeadingSlashes(originalUrl.pathname+"/");var loc=encodeUrl(url.format(originalUrl)),doc=createHtmlDocument("Redirecting",'Redirecting to <a href="'+escapeHtml(loc)+'">'+escapeHtml(loc)+"</a>");res.statusCode=301,res.setHeader("Content-Type","text/html; charset=UTF-8"),res.setHeader("Content-Length",Buffer.byteLength(doc)),res.setHeader("Content-Security-Policy","default-src 'none'"),res.setHeader("X-Content-Type-Options","nosniff"),res.setHeader("Location",loc),res.end(doc)}}}module.exports=serveStatic,module.exports.mime=send.mime;