"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const PendingOperation_1=require("./PendingOperation"),Resource_1=require("./Resource"),utils_1=require("./utils"),events_1=require("events"),timers_1=require("timers");class Pool{constructor(opt){if(this.destroyed=!1,this.emitter=new events_1.EventEmitter,!(opt=opt||{}).create)throw new Error("Tarn: opt.create function most be provided");if(!opt.destroy)throw new Error("Tarn: opt.destroy function most be provided");if("number"!=typeof opt.min||opt.min<0||opt.min!==Math.round(opt.min))throw new Error("Tarn: opt.min must be an integer >= 0");if("number"!=typeof opt.max||opt.max<=0||opt.max!==Math.round(opt.max))throw new Error("Tarn: opt.max must be an integer > 0");if(opt.min>opt.max)throw new Error("Tarn: opt.max is smaller than opt.min");if(!utils_1.checkOptionalTime(opt.acquireTimeoutMillis))throw new Error("Tarn: invalid opt.acquireTimeoutMillis "+JSON.stringify(opt.acquireTimeoutMillis));if(!utils_1.checkOptionalTime(opt.createTimeoutMillis))throw new Error("Tarn: invalid opt.createTimeoutMillis "+JSON.stringify(opt.createTimeoutMillis));if(!utils_1.checkOptionalTime(opt.destroyTimeoutMillis))throw new Error("Tarn: invalid opt.destroyTimeoutMillis "+JSON.stringify(opt.destroyTimeoutMillis));if(!utils_1.checkOptionalTime(opt.idleTimeoutMillis))throw new Error("Tarn: invalid opt.idleTimeoutMillis "+JSON.stringify(opt.idleTimeoutMillis));if(!utils_1.checkOptionalTime(opt.reapIntervalMillis))throw new Error("Tarn: invalid opt.reapIntervalMillis "+JSON.stringify(opt.reapIntervalMillis));if(!utils_1.checkOptionalTime(opt.createRetryIntervalMillis))throw new Error("Tarn: invalid opt.createRetryIntervalMillis "+JSON.stringify(opt.createRetryIntervalMillis));const allowedKeys={create:!0,validate:!0,destroy:!0,log:!0,min:!0,max:!0,acquireTimeoutMillis:!0,createTimeoutMillis:!0,destroyTimeoutMillis:!0,idleTimeoutMillis:!0,reapIntervalMillis:!0,createRetryIntervalMillis:!0,propagateCreateError:!0};for(const key of Object.keys(opt))if(!allowedKeys[key])throw new Error(`Tarn: unsupported option opt.${key}`);this.creator=opt.create,this.destroyer=opt.destroy,this.validate="function"==typeof opt.validate?opt.validate:()=>!0,this.log=opt.log||(()=>{}),this.acquireTimeoutMillis=opt.acquireTimeoutMillis||3e4,this.createTimeoutMillis=opt.createTimeoutMillis||3e4,this.destroyTimeoutMillis=opt.destroyTimeoutMillis||5e3,this.idleTimeoutMillis=opt.idleTimeoutMillis||3e4,this.reapIntervalMillis=opt.reapIntervalMillis||1e3,this.createRetryIntervalMillis=opt.createRetryIntervalMillis||200,this.propagateCreateError=!!opt.propagateCreateError,this.min=opt.min,this.max=opt.max,this.used=[],this.free=[],this.pendingCreates=[],this.pendingAcquires=[],this.pendingDestroys=[],this.pendingValidations=[],this.destroyed=!1,this.interval=null,this.eventId=1}numUsed(){return this.used.length}numFree(){return this.free.length}numPendingAcquires(){return this.pendingAcquires.length}numPendingValidations(){return this.pendingValidations.length}numPendingCreates(){return this.pendingCreates.length}acquire(){const eventId=this.eventId++;this._executeEventHandlers("acquireRequest",eventId);const pendingAcquire=new PendingOperation_1.PendingOperation(this.acquireTimeoutMillis);return this.pendingAcquires.push(pendingAcquire),pendingAcquire.promise=pendingAcquire.promise.then((resource=>(this._executeEventHandlers("acquireSuccess",eventId,resource),resource))).catch((err=>(this._executeEventHandlers("acquireFail",eventId,err),remove(this.pendingAcquires,pendingAcquire),Promise.reject(err)))),this._tryAcquireOrCreate(),pendingAcquire}release(resource){this._executeEventHandlers("release",resource);for(let i=0,l=this.used.length;i<l;++i){const used=this.used[i];if(used.resource===resource)return this.used.splice(i,1),this.free.push(used.resolve()),this._tryAcquireOrCreate(),!0}return!1}isEmpty(){return 0===[this.numFree(),this.numUsed(),this.numPendingAcquires(),this.numPendingValidations(),this.numPendingCreates()].reduce(((total,value)=>total+value))}check(){const timestamp=utils_1.now(),newFree=[],minKeep=this.min-this.used.length,maxDestroy=this.free.length-minKeep;let numDestroyed=0;this.free.forEach((free=>{utils_1.duration(timestamp,free.timestamp)>=this.idleTimeoutMillis&&numDestroyed<maxDestroy?(numDestroyed++,this._destroy(free.resource)):newFree.push(free)})),this.free=newFree,this.isEmpty()&&this._stopReaping()}destroy(){const eventId=this.eventId++;return this._executeEventHandlers("poolDestroyRequest",eventId),this._stopReaping(),this.destroyed=!0,utils_1.reflect(Promise.all(this.pendingCreates.map((create=>utils_1.reflect(create.promise)))).then((()=>new Promise(((resolve,reject)=>{if(0===this.numPendingValidations())return void resolve();const interval=setInterval((()=>{0===this.numPendingValidations()&&(timers_1.clearInterval(interval),resolve())}),100)})))).then((()=>Promise.all(this.used.map((used=>utils_1.reflect(used.promise)))))).then((()=>Promise.all(this.pendingAcquires.map((acquire=>(acquire.abort(),utils_1.reflect(acquire.promise))))))).then((()=>Promise.all(this.free.map((free=>utils_1.reflect(this._destroy(free.resource))))))).then((()=>Promise.all(this.pendingDestroys.map((pd=>pd.promise))))).then((()=>{this.free=[],this.pendingAcquires=[]}))).then((res=>(this._executeEventHandlers("poolDestroySuccess",eventId),this.emitter.removeAllListeners(),res)))}on(event,listener){this.emitter.on(event,listener)}removeListener(event,listener){this.emitter.removeListener(event,listener)}removeAllListeners(event){this.emitter.removeAllListeners(event)}_tryAcquireOrCreate(){this.destroyed||(this._hasFreeResources()?this._doAcquire():this._shouldCreateMoreResources()&&this._doCreate())}_hasFreeResources(){return this.free.length>0}_doAcquire(){for(;this._canAcquire();){const pendingAcquire=this.pendingAcquires.shift(),free=this.free.pop();if(void 0===free||void 0===pendingAcquire){const errMessage="this.free was empty while trying to acquire resource";throw this.log(`Tarn: ${errMessage}`,"warn"),new Error(`Internal error, should never happen. ${errMessage}`)}this.pendingValidations.push(pendingAcquire),this.used.push(free);const abortAbleValidation=new PendingOperation_1.PendingOperation(this.acquireTimeoutMillis);pendingAcquire.promise.catch((err=>{abortAbleValidation.abort()})),abortAbleValidation.promise.catch((err=>(this.log("Tarn: resource validator threw an exception "+err.stack,"warn"),!1))).then((validationSuccess=>{try{validationSuccess&&!pendingAcquire.isRejected?(this._startReaping(),pendingAcquire.resolve(free.resource)):(remove(this.used,free),validationSuccess?this.free.push(free):(this._destroy(free.resource),setTimeout((()=>{this._tryAcquireOrCreate()}),0)),pendingAcquire.isRejected||this.pendingAcquires.unshift(pendingAcquire))}finally{remove(this.pendingValidations,pendingAcquire)}})),this._validateResource(free.resource).then((validationSuccess=>{abortAbleValidation.resolve(validationSuccess)})).catch((err=>{abortAbleValidation.reject(err)}))}}_canAcquire(){return this.free.length>0&&this.pendingAcquires.length>0}_validateResource(resource){try{return Promise.resolve(this.validate(resource))}catch(err){return Promise.reject(err)}}_shouldCreateMoreResources(){return this.used.length+this.pendingCreates.length<this.max&&this.pendingCreates.length<this.pendingAcquires.length}_doCreate(){const pendingAcquiresBeforeCreate=this.pendingAcquires.slice();this._create().promise.then((()=>(this._tryAcquireOrCreate(),null))).catch((err=>{this.propagateCreateError&&0!==this.pendingAcquires.length&&this.pendingAcquires[0].reject(err),pendingAcquiresBeforeCreate.forEach((pendingAcquire=>{pendingAcquire.possibleTimeoutCause=err})),utils_1.delay(this.createRetryIntervalMillis).then((()=>this._tryAcquireOrCreate()))}))}_create(){const eventId=this.eventId++;this._executeEventHandlers("createRequest",eventId);const pendingCreate=new PendingOperation_1.PendingOperation(this.createTimeoutMillis);return pendingCreate.promise=pendingCreate.promise.catch((err=>{throw remove(this.pendingCreates,pendingCreate)&&this._executeEventHandlers("createFail",eventId,err),err})),this.pendingCreates.push(pendingCreate),callbackOrPromise(this.creator).then((resource=>pendingCreate.isRejected?(this.destroyer(resource),null):(remove(this.pendingCreates,pendingCreate),this.free.push(new Resource_1.Resource(resource)),pendingCreate.resolve(resource),this._executeEventHandlers("createSuccess",eventId,resource),null))).catch((err=>(pendingCreate.isRejected||(remove(this.pendingCreates,pendingCreate)&&this._executeEventHandlers("createFail",eventId,err),pendingCreate.reject(err)),null))),pendingCreate}_destroy(resource){const eventId=this.eventId++;this._executeEventHandlers("destroyRequest",eventId,resource);const pendingDestroy=new PendingOperation_1.PendingOperation(this.destroyTimeoutMillis);return Promise.resolve().then((()=>this.destroyer(resource))).then((()=>{pendingDestroy.resolve(resource)})).catch((err=>{pendingDestroy.reject(err)})),this.pendingDestroys.push(pendingDestroy),pendingDestroy.promise.then((res=>(this._executeEventHandlers("destroySuccess",eventId,resource),res))).catch((err=>this._logDestroyerError(eventId,resource,err))).then((res=>{const index=this.pendingDestroys.findIndex((pd=>pd===pendingDestroy));return this.pendingDestroys.splice(index,1),res}))}_logDestroyerError(eventId,resource,err){this._executeEventHandlers("destroyFail",eventId,resource,err),this.log("Tarn: resource destroyer threw an exception "+err.stack,"warn")}_startReaping(){this.interval||(this._executeEventHandlers("startReaping"),this.interval=setInterval((()=>this.check()),this.reapIntervalMillis))}_stopReaping(){null!==this.interval&&(this._executeEventHandlers("stopReaping"),timers_1.clearInterval(this.interval)),this.interval=null}_executeEventHandlers(eventName,...args){this.emitter.listeners(eventName).forEach((listener=>{try{listener(...args)}catch(err){this.log(`Tarn: event handler "${eventName}" threw an exception ${err.stack}`,"warn")}}))}}function remove(arr,item){const idx=arr.indexOf(item);return-1!==idx&&(arr.splice(idx,1),!0)}function callbackOrPromise(func){return new Promise(((resolve,reject)=>{const callback=(err,resource)=>{err?reject(err):resolve(resource)};utils_1.tryPromise((()=>func(callback))).then((res=>{res&&resolve(res)})).catch((err=>{reject(err)}))}))}exports.Pool=Pool;