"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _crypto=_interopRequireDefault(require("crypto")),_os=_interopRequireDefault(require("os")),_dns=_interopRequireDefault(require("dns")),_constants=_interopRequireDefault(require("constants")),_stream=require("stream"),_identity=require("@azure/identity"),_bulkLoad=_interopRequireDefault(require("./bulk-load")),_debug=_interopRequireDefault(require("./debug")),_events=require("events"),_instanceLookup=require("./instance-lookup"),_transientErrorLookup=require("./transient-error-lookup"),_packet=require("./packet"),_preloginPayload=_interopRequireDefault(require("./prelogin-payload")),_login7Payload=_interopRequireDefault(require("./login7-payload")),_ntlmPayload=_interopRequireDefault(require("./ntlm-payload")),_request=_interopRequireDefault(require("./request")),_rpcrequestPayload=_interopRequireDefault(require("./rpcrequest-payload")),_sqlbatchPayload=_interopRequireDefault(require("./sqlbatch-payload")),_messageIo=_interopRequireDefault(require("./message-io")),_tokenStreamParser=require("./token/token-stream-parser"),_transaction=require("./transaction"),_errors=require("./errors"),_connector=require("./connector"),_library=require("./library"),_tdsVersions=require("./tds-versions"),_message=_interopRequireDefault(require("./message")),_ntlm=require("./ntlm"),_nodeAbortController=require("node-abort-controller"),_dataType=require("./data-type"),_bulkLoadPayload=require("./bulk-load-payload"),_esAggregateError=_interopRequireDefault(require("es-aggregate-error")),_package=require("../package.json"),_url=require("url"),_handler=require("./token/handler");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}const KEEP_ALIVE_INITIAL_DELAY=3e4,DEFAULT_CONNECT_TIMEOUT=15e3,DEFAULT_CLIENT_REQUEST_TIMEOUT=15e3,DEFAULT_CANCEL_TIMEOUT=5e3,DEFAULT_CONNECT_RETRY_INTERVAL=500,DEFAULT_PACKET_SIZE=4096,DEFAULT_TEXTSIZE=2147483647,DEFAULT_DATEFIRST=7,DEFAULT_PORT=1433,DEFAULT_TDS_VERSION="7_4",DEFAULT_LANGUAGE="us_english",DEFAULT_DATEFORMAT="mdy",CLEANUP_TYPE={NORMAL:0,REDIRECT:1,RETRY:2};class Connection extends _events.EventEmitter{constructor(config){if(super(),this.fedAuthRequired=void 0,this.config=void 0,this.secureContextOptions=void 0,this.inTransaction=void 0,this.transactionDescriptors=void 0,this.transactionDepth=void 0,this.isSqlBatch=void 0,this.curTransientRetryCount=void 0,this.transientErrorLookup=void 0,this.closed=void 0,this.loginError=void 0,this.debug=void 0,this.ntlmpacket=void 0,this.ntlmpacketBuffer=void 0,this.routingData=void 0,this.messageIo=void 0,this.state=void 0,this.resetConnectionOnNextRequest=void 0,this.request=void 0,this.procReturnStatusValue=void 0,this.socket=void 0,this.messageBuffer=void 0,this.connectTimer=void 0,this.cancelTimer=void 0,this.requestTimer=void 0,this.retryTimer=void 0,this._cancelAfterRequestSent=void 0,this.databaseCollation=void 0,"object"!=typeof config||null===config)throw new TypeError('The "config" argument is required and must be of type Object.');if("string"!=typeof config.server)throw new TypeError('The "config.server" property is required and must be of type string.');let authentication;if(this.fedAuthRequired=!1,void 0!==config.authentication){if("object"!=typeof config.authentication||null===config.authentication)throw new TypeError('The "config.authentication" property must be of type Object.');const type=config.authentication.type,options=void 0===config.authentication.options?{}:config.authentication.options;if("string"!=typeof type)throw new TypeError('The "config.authentication.type" property must be of type string.');if("default"!==type&&"ntlm"!==type&&"azure-active-directory-password"!==type&&"azure-active-directory-access-token"!==type&&"azure-active-directory-msi-vm"!==type&&"azure-active-directory-msi-app-service"!==type&&"azure-active-directory-service-principal-secret"!==type&&"azure-active-directory-default"!==type)throw new TypeError('The "type" property must one of "default", "ntlm", "azure-active-directory-password", "azure-active-directory-access-token", "azure-active-directory-default", "azure-active-directory-msi-vm" or "azure-active-directory-msi-app-service" or "azure-active-directory-service-principal-secret".');if("object"!=typeof options||null===options)throw new TypeError('The "config.authentication.options" property must be of type object.');if("ntlm"===type){if("string"!=typeof options.domain)throw new TypeError('The "config.authentication.options.domain" property must be of type string.');if(void 0!==options.userName&&"string"!=typeof options.userName)throw new TypeError('The "config.authentication.options.userName" property must be of type string.');if(void 0!==options.password&&"string"!=typeof options.password)throw new TypeError('The "config.authentication.options.password" property must be of type string.');authentication={type:"ntlm",options:{userName:options.userName,password:options.password,domain:options.domain&&options.domain.toUpperCase()}}}else if("azure-active-directory-password"===type){if("string"!=typeof options.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');if(void 0!==options.userName&&"string"!=typeof options.userName)throw new TypeError('The "config.authentication.options.userName" property must be of type string.');if(void 0!==options.password&&"string"!=typeof options.password)throw new TypeError('The "config.authentication.options.password" property must be of type string.');if(void 0!==options.tenantId&&"string"!=typeof options.tenantId)throw new TypeError('The "config.authentication.options.tenantId" property must be of type string.');authentication={type:"azure-active-directory-password",options:{userName:options.userName,password:options.password,tenantId:options.tenantId,clientId:options.clientId}}}else if("azure-active-directory-access-token"===type){if("string"!=typeof options.token)throw new TypeError('The "config.authentication.options.token" property must be of type string.');authentication={type:"azure-active-directory-access-token",options:{token:options.token}}}else if("azure-active-directory-msi-vm"===type){if(void 0!==options.clientId&&"string"!=typeof options.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');authentication={type:"azure-active-directory-msi-vm",options:{clientId:options.clientId}}}else if("azure-active-directory-default"===type){if(void 0!==options.clientId&&"string"!=typeof options.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');authentication={type:"azure-active-directory-default",options:{clientId:options.clientId}}}else if("azure-active-directory-msi-app-service"===type){if(void 0!==options.clientId&&"string"!=typeof options.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');authentication={type:"azure-active-directory-msi-app-service",options:{clientId:options.clientId}}}else if("azure-active-directory-service-principal-secret"===type){if("string"!=typeof options.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');if("string"!=typeof options.clientSecret)throw new TypeError('The "config.authentication.options.clientSecret" property must be of type string.');if("string"!=typeof options.tenantId)throw new TypeError('The "config.authentication.options.tenantId" property must be of type string.');authentication={type:"azure-active-directory-service-principal-secret",options:{clientId:options.clientId,clientSecret:options.clientSecret,tenantId:options.tenantId}}}else{if(void 0!==options.userName&&"string"!=typeof options.userName)throw new TypeError('The "config.authentication.options.userName" property must be of type string.');if(void 0!==options.password&&"string"!=typeof options.password)throw new TypeError('The "config.authentication.options.password" property must be of type string.');authentication={type:"default",options:{userName:options.userName,password:options.password}}}}else authentication={type:"default",options:{userName:void 0,password:void 0}};if(this.config={server:config.server,authentication:authentication,options:{abortTransactionOnError:!1,appName:void 0,camelCaseColumns:!1,cancelTimeout:DEFAULT_CANCEL_TIMEOUT,columnEncryptionKeyCacheTTL:72e5,columnEncryptionSetting:!1,columnNameReplacer:void 0,connectionRetryInterval:DEFAULT_CONNECT_RETRY_INTERVAL,connectTimeout:DEFAULT_CONNECT_TIMEOUT,connectionIsolationLevel:_transaction.ISOLATION_LEVEL.READ_COMMITTED,cryptoCredentialsDetails:{},database:void 0,datefirst:DEFAULT_DATEFIRST,dateFormat:DEFAULT_DATEFORMAT,debug:{data:!1,packet:!1,payload:!1,token:!1},enableAnsiNull:!0,enableAnsiNullDefault:!0,enableAnsiPadding:!0,enableAnsiWarnings:!0,enableArithAbort:!0,enableConcatNullYieldsNull:!0,enableCursorCloseOnCommit:null,enableImplicitTransactions:!1,enableNumericRoundabort:!1,enableQuotedIdentifier:!0,encrypt:!0,fallbackToDefaultDb:!1,encryptionKeyStoreProviders:void 0,instanceName:void 0,isolationLevel:_transaction.ISOLATION_LEVEL.READ_COMMITTED,language:DEFAULT_LANGUAGE,localAddress:void 0,maxRetriesOnTransientErrors:3,multiSubnetFailover:!1,packetSize:DEFAULT_PACKET_SIZE,port:DEFAULT_PORT,readOnlyIntent:!1,requestTimeout:DEFAULT_CLIENT_REQUEST_TIMEOUT,rowCollectionOnDone:!1,rowCollectionOnRequestCompletion:!1,serverName:void 0,serverSupportsColumnEncryption:!1,tdsVersion:DEFAULT_TDS_VERSION,textsize:DEFAULT_TEXTSIZE,trustedServerNameAE:void 0,trustServerCertificate:!1,useColumnNames:!1,useUTC:!0,workstationId:void 0,lowerCaseGuids:!1}},config.options){if(config.options.port&&config.options.instanceName)throw new Error("Port and instanceName are mutually exclusive, but "+config.options.port+" and "+config.options.instanceName+" provided");if(void 0!==config.options.abortTransactionOnError){if("boolean"!=typeof config.options.abortTransactionOnError&&null!==config.options.abortTransactionOnError)throw new TypeError('The "config.options.abortTransactionOnError" property must be of type string or null.');this.config.options.abortTransactionOnError=config.options.abortTransactionOnError}if(void 0!==config.options.appName){if("string"!=typeof config.options.appName)throw new TypeError('The "config.options.appName" property must be of type string.');this.config.options.appName=config.options.appName}if(void 0!==config.options.camelCaseColumns){if("boolean"!=typeof config.options.camelCaseColumns)throw new TypeError('The "config.options.camelCaseColumns" property must be of type boolean.');this.config.options.camelCaseColumns=config.options.camelCaseColumns}if(void 0!==config.options.cancelTimeout){if("number"!=typeof config.options.cancelTimeout)throw new TypeError('The "config.options.cancelTimeout" property must be of type number.');this.config.options.cancelTimeout=config.options.cancelTimeout}if(config.options.columnNameReplacer){if("function"!=typeof config.options.columnNameReplacer)throw new TypeError('The "config.options.cancelTimeout" property must be of type function.');this.config.options.columnNameReplacer=config.options.columnNameReplacer}if(void 0!==config.options.connectionIsolationLevel&&((0,_transaction.assertValidIsolationLevel)(config.options.connectionIsolationLevel,"config.options.connectionIsolationLevel"),this.config.options.connectionIsolationLevel=config.options.connectionIsolationLevel),void 0!==config.options.connectTimeout){if("number"!=typeof config.options.connectTimeout)throw new TypeError('The "config.options.connectTimeout" property must be of type number.');this.config.options.connectTimeout=config.options.connectTimeout}if(void 0!==config.options.cryptoCredentialsDetails){if("object"!=typeof config.options.cryptoCredentialsDetails||null===config.options.cryptoCredentialsDetails)throw new TypeError('The "config.options.cryptoCredentialsDetails" property must be of type Object.');this.config.options.cryptoCredentialsDetails=config.options.cryptoCredentialsDetails}if(void 0!==config.options.database){if("string"!=typeof config.options.database)throw new TypeError('The "config.options.database" property must be of type string.');this.config.options.database=config.options.database}if(void 0!==config.options.datefirst){if("number"!=typeof config.options.datefirst&&null!==config.options.datefirst)throw new TypeError('The "config.options.datefirst" property must be of type number.');if(null!==config.options.datefirst&&(config.options.datefirst<1||config.options.datefirst>7))throw new RangeError('The "config.options.datefirst" property must be >= 1 and <= 7');this.config.options.datefirst=config.options.datefirst}if(void 0!==config.options.dateFormat){if("string"!=typeof config.options.dateFormat&&null!==config.options.dateFormat)throw new TypeError('The "config.options.dateFormat" property must be of type string or null.');this.config.options.dateFormat=config.options.dateFormat}if(config.options.debug){if(void 0!==config.options.debug.data){if("boolean"!=typeof config.options.debug.data)throw new TypeError('The "config.options.debug.data" property must be of type boolean.');this.config.options.debug.data=config.options.debug.data}if(void 0!==config.options.debug.packet){if("boolean"!=typeof config.options.debug.packet)throw new TypeError('The "config.options.debug.packet" property must be of type boolean.');this.config.options.debug.packet=config.options.debug.packet}if(void 0!==config.options.debug.payload){if("boolean"!=typeof config.options.debug.payload)throw new TypeError('The "config.options.debug.payload" property must be of type boolean.');this.config.options.debug.payload=config.options.debug.payload}if(void 0!==config.options.debug.token){if("boolean"!=typeof config.options.debug.token)throw new TypeError('The "config.options.debug.token" property must be of type boolean.');this.config.options.debug.token=config.options.debug.token}}if(void 0!==config.options.enableAnsiNull){if("boolean"!=typeof config.options.enableAnsiNull&&null!==config.options.enableAnsiNull)throw new TypeError('The "config.options.enableAnsiNull" property must be of type boolean or null.');this.config.options.enableAnsiNull=config.options.enableAnsiNull}if(void 0!==config.options.enableAnsiNullDefault){if("boolean"!=typeof config.options.enableAnsiNullDefault&&null!==config.options.enableAnsiNullDefault)throw new TypeError('The "config.options.enableAnsiNullDefault" property must be of type boolean or null.');this.config.options.enableAnsiNullDefault=config.options.enableAnsiNullDefault}if(void 0!==config.options.enableAnsiPadding){if("boolean"!=typeof config.options.enableAnsiPadding&&null!==config.options.enableAnsiPadding)throw new TypeError('The "config.options.enableAnsiPadding" property must be of type boolean or null.');this.config.options.enableAnsiPadding=config.options.enableAnsiPadding}if(void 0!==config.options.enableAnsiWarnings){if("boolean"!=typeof config.options.enableAnsiWarnings&&null!==config.options.enableAnsiWarnings)throw new TypeError('The "config.options.enableAnsiWarnings" property must be of type boolean or null.');this.config.options.enableAnsiWarnings=config.options.enableAnsiWarnings}if(void 0!==config.options.enableArithAbort){if("boolean"!=typeof config.options.enableArithAbort&&null!==config.options.enableArithAbort)throw new TypeError('The "config.options.enableArithAbort" property must be of type boolean or null.');this.config.options.enableArithAbort=config.options.enableArithAbort}if(void 0!==config.options.enableConcatNullYieldsNull){if("boolean"!=typeof config.options.enableConcatNullYieldsNull&&null!==config.options.enableConcatNullYieldsNull)throw new TypeError('The "config.options.enableConcatNullYieldsNull" property must be of type boolean or null.');this.config.options.enableConcatNullYieldsNull=config.options.enableConcatNullYieldsNull}if(void 0!==config.options.enableCursorCloseOnCommit){if("boolean"!=typeof config.options.enableCursorCloseOnCommit&&null!==config.options.enableCursorCloseOnCommit)throw new TypeError('The "config.options.enableCursorCloseOnCommit" property must be of type boolean or null.');this.config.options.enableCursorCloseOnCommit=config.options.enableCursorCloseOnCommit}if(void 0!==config.options.enableImplicitTransactions){if("boolean"!=typeof config.options.enableImplicitTransactions&&null!==config.options.enableImplicitTransactions)throw new TypeError('The "config.options.enableImplicitTransactions" property must be of type boolean or null.');this.config.options.enableImplicitTransactions=config.options.enableImplicitTransactions}if(void 0!==config.options.enableNumericRoundabort){if("boolean"!=typeof config.options.enableNumericRoundabort&&null!==config.options.enableNumericRoundabort)throw new TypeError('The "config.options.enableNumericRoundabort" property must be of type boolean or null.');this.config.options.enableNumericRoundabort=config.options.enableNumericRoundabort}if(void 0!==config.options.enableQuotedIdentifier){if("boolean"!=typeof config.options.enableQuotedIdentifier&&null!==config.options.enableQuotedIdentifier)throw new TypeError('The "config.options.enableQuotedIdentifier" property must be of type boolean or null.');this.config.options.enableQuotedIdentifier=config.options.enableQuotedIdentifier}if(void 0!==config.options.encrypt){if("boolean"!=typeof config.options.encrypt)throw new TypeError('The "config.options.encrypt" property must be of type boolean.');this.config.options.encrypt=config.options.encrypt}if(void 0!==config.options.fallbackToDefaultDb){if("boolean"!=typeof config.options.fallbackToDefaultDb)throw new TypeError('The "config.options.fallbackToDefaultDb" property must be of type boolean.');this.config.options.fallbackToDefaultDb=config.options.fallbackToDefaultDb}if(void 0!==config.options.instanceName){if("string"!=typeof config.options.instanceName)throw new TypeError('The "config.options.instanceName" property must be of type string.');this.config.options.instanceName=config.options.instanceName,this.config.options.port=void 0}if(void 0!==config.options.isolationLevel&&((0,_transaction.assertValidIsolationLevel)(config.options.isolationLevel,"config.options.isolationLevel"),this.config.options.isolationLevel=config.options.isolationLevel),void 0!==config.options.language){if("string"!=typeof config.options.language&&null!==config.options.language)throw new TypeError('The "config.options.language" property must be of type string or null.');this.config.options.language=config.options.language}if(void 0!==config.options.localAddress){if("string"!=typeof config.options.localAddress)throw new TypeError('The "config.options.localAddress" property must be of type string.');this.config.options.localAddress=config.options.localAddress}if(void 0!==config.options.multiSubnetFailover){if("boolean"!=typeof config.options.multiSubnetFailover)throw new TypeError('The "config.options.multiSubnetFailover" property must be of type boolean.');this.config.options.multiSubnetFailover=config.options.multiSubnetFailover}if(void 0!==config.options.packetSize){if("number"!=typeof config.options.packetSize)throw new TypeError('The "config.options.packetSize" property must be of type number.');this.config.options.packetSize=config.options.packetSize}if(void 0!==config.options.port){if("number"!=typeof config.options.port)throw new TypeError('The "config.options.port" property must be of type number.');if(config.options.port<=0||config.options.port>=65536)throw new RangeError('The "config.options.port" property must be > 0 and < 65536');this.config.options.port=config.options.port,this.config.options.instanceName=void 0}if(void 0!==config.options.readOnlyIntent){if("boolean"!=typeof config.options.readOnlyIntent)throw new TypeError('The "config.options.readOnlyIntent" property must be of type boolean.');this.config.options.readOnlyIntent=config.options.readOnlyIntent}if(void 0!==config.options.requestTimeout){if("number"!=typeof config.options.requestTimeout)throw new TypeError('The "config.options.requestTimeout" property must be of type number.');this.config.options.requestTimeout=config.options.requestTimeout}if(void 0!==config.options.maxRetriesOnTransientErrors){if("number"!=typeof config.options.maxRetriesOnTransientErrors)throw new TypeError('The "config.options.maxRetriesOnTransientErrors" property must be of type number.');if(config.options.maxRetriesOnTransientErrors<0)throw new TypeError('The "config.options.maxRetriesOnTransientErrors" property must be equal or greater than 0.');this.config.options.maxRetriesOnTransientErrors=config.options.maxRetriesOnTransientErrors}if(void 0!==config.options.connectionRetryInterval){if("number"!=typeof config.options.connectionRetryInterval)throw new TypeError('The "config.options.connectionRetryInterval" property must be of type number.');if(config.options.connectionRetryInterval<=0)throw new TypeError('The "config.options.connectionRetryInterval" property must be greater than 0.');this.config.options.connectionRetryInterval=config.options.connectionRetryInterval}if(void 0!==config.options.rowCollectionOnDone){if("boolean"!=typeof config.options.rowCollectionOnDone)throw new TypeError('The "config.options.rowCollectionOnDone" property must be of type boolean.');this.config.options.rowCollectionOnDone=config.options.rowCollectionOnDone}if(void 0!==config.options.rowCollectionOnRequestCompletion){if("boolean"!=typeof config.options.rowCollectionOnRequestCompletion)throw new TypeError('The "config.options.rowCollectionOnRequestCompletion" property must be of type boolean.');this.config.options.rowCollectionOnRequestCompletion=config.options.rowCollectionOnRequestCompletion}if(void 0!==config.options.tdsVersion){if("string"!=typeof config.options.tdsVersion)throw new TypeError('The "config.options.tdsVersion" property must be of type string.');this.config.options.tdsVersion=config.options.tdsVersion}if(void 0!==config.options.textsize){if("number"!=typeof config.options.textsize&&null!==config.options.textsize)throw new TypeError('The "config.options.textsize" property must be of type number or null.');if(config.options.textsize>2147483647)throw new TypeError('The "config.options.textsize" can\'t be greater than 2147483647.');if(config.options.textsize<-1)throw new TypeError('The "config.options.textsize" can\'t be smaller than -1.');this.config.options.textsize=0|config.options.textsize}if(void 0!==config.options.trustServerCertificate){if("boolean"!=typeof config.options.trustServerCertificate)throw new TypeError('The "config.options.trustServerCertificate" property must be of type boolean.');this.config.options.trustServerCertificate=config.options.trustServerCertificate}if(void 0!==config.options.useColumnNames){if("boolean"!=typeof config.options.useColumnNames)throw new TypeError('The "config.options.useColumnNames" property must be of type boolean.');this.config.options.useColumnNames=config.options.useColumnNames}if(void 0!==config.options.useUTC){if("boolean"!=typeof config.options.useUTC)throw new TypeError('The "config.options.useUTC" property must be of type boolean.');this.config.options.useUTC=config.options.useUTC}if(void 0!==config.options.workstationId){if("string"!=typeof config.options.workstationId)throw new TypeError('The "config.options.workstationId" property must be of type string.');this.config.options.workstationId=config.options.workstationId}if(void 0!==config.options.lowerCaseGuids){if("boolean"!=typeof config.options.lowerCaseGuids)throw new TypeError('The "config.options.lowerCaseGuids" property must be of type boolean.');this.config.options.lowerCaseGuids=config.options.lowerCaseGuids}}this.secureContextOptions=this.config.options.cryptoCredentialsDetails,void 0===this.secureContextOptions.secureOptions&&(this.secureContextOptions=Object.create(this.secureContextOptions,{secureOptions:{value:_constants.default.SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS}})),this.debug=this.createDebug(),this.inTransaction=!1,this.transactionDescriptors=[Buffer.from([0,0,0,0,0,0,0,0])],this.transactionDepth=0,this.isSqlBatch=!1,this.closed=!1,this.messageBuffer=Buffer.alloc(0),this.curTransientRetryCount=0,this.transientErrorLookup=new _transientErrorLookup.TransientErrorLookup,this.state=this.STATE.INITIALIZED,this._cancelAfterRequestSent=()=>{this.messageIo.sendMessage(_packet.TYPE.ATTENTION),this.createCancelTimer()}}connect(connectListener){if(this.state!==this.STATE.INITIALIZED)throw new _errors.ConnectionError("`.connect` can not be called on a Connection in `"+this.state.name+"` state.");if(connectListener){const onConnect=err=>{this.removeListener("error",onError),connectListener(err)},onError=err=>{this.removeListener("connect",onConnect),connectListener(err)};this.once("connect",onConnect),this.once("error",onError)}this.transitionTo(this.STATE.CONNECTING)}on(event,listener){return super.on(event,listener)}emit(event,...args){return super.emit(event,...args)}close(){this.transitionTo(this.STATE.FINAL)}initialiseConnection(){const signal=this.createConnectTimer();return this.config.options.port?this.connectOnPort(this.config.options.port,this.config.options.multiSubnetFailover,signal):(0,_instanceLookup.instanceLookup)({server:this.config.server,instanceName:this.config.options.instanceName,timeout:this.config.options.connectTimeout,signal:signal}).then((port=>{process.nextTick((()=>{this.connectOnPort(port,this.config.options.multiSubnetFailover,signal)}))}),(err=>{this.clearConnectTimer(),"AbortError"!==err.name&&process.nextTick((()=>{this.emit("connect",new _errors.ConnectionError(err.message,"EINSTLOOKUP"))}))}))}cleanupConnection(cleanupType){if(!this.closed){this.clearConnectTimer(),this.clearRequestTimer(),this.clearRetryTimer(),this.closeConnection(),cleanupType===CLEANUP_TYPE.REDIRECT?this.emit("rerouting"):cleanupType!==CLEANUP_TYPE.RETRY&&process.nextTick((()=>{this.emit("end")}));const request=this.request;if(request){const err=new _errors.RequestError("Connection closed before request completed.","ECLOSE");request.callback(err),this.request=void 0}this.closed=!0,this.loginError=void 0}}createDebug(){const debug=new _debug.default(this.config.options.debug);return debug.on("debug",(message=>{this.emit("debug",message)})),debug}createTokenStreamParser(message,handler){return new _tokenStreamParser.Parser(message,this.debug,handler,this.config.options)}connectOnPort(port,multiSubnetFailover,signal){const connectOpts={host:this.routingData?this.routingData.server:this.config.server,port:this.routingData?this.routingData.port:port,localAddress:this.config.options.localAddress};(multiSubnetFailover?_connector.connectInParallel:_connector.connectInSequence)(connectOpts,_dns.default.lookup,signal).then((socket=>{process.nextTick((()=>{socket.on("error",(error=>{this.socketError(error)})),socket.on("close",(()=>{this.socketClose()})),socket.on("end",(()=>{this.socketEnd()})),socket.setKeepAlive(!0,KEEP_ALIVE_INITIAL_DELAY),this.messageIo=new _messageIo.default(socket,this.config.options.packetSize,this.debug),this.messageIo.on("secure",(cleartext=>{this.emit("secure",cleartext)})),this.socket=socket,this.closed=!1,this.debug.log("connected to "+this.config.server+":"+this.config.options.port),this.sendPreLogin(),this.transitionTo(this.STATE.SENT_PRELOGIN)}))}),(err=>{this.clearConnectTimer(),"AbortError"!==err.name&&process.nextTick((()=>{this.socketError(err)}))}))}closeConnection(){this.socket&&this.socket.destroy()}createConnectTimer(){const controller=new _nodeAbortController.AbortController;return this.connectTimer=setTimeout((()=>{controller.abort(),this.connectTimeout()}),this.config.options.connectTimeout),controller.signal}createCancelTimer(){this.clearCancelTimer();const timeout=this.config.options.cancelTimeout;timeout>0&&(this.cancelTimer=setTimeout((()=>{this.cancelTimeout()}),timeout))}createRequestTimer(){this.clearRequestTimer();const request=this.request,timeout=void 0!==request.timeout?request.timeout:this.config.options.requestTimeout;timeout&&(this.requestTimer=setTimeout((()=>{this.requestTimeout()}),timeout))}createRetryTimer(){this.clearRetryTimer(),this.retryTimer=setTimeout((()=>{this.retryTimeout()}),this.config.options.connectionRetryInterval)}connectTimeout(){const message=`Failed to connect to ${this.config.server}${this.config.options.port?`:${this.config.options.port}`:`\\${this.config.options.instanceName}`} in ${this.config.options.connectTimeout}ms`;this.debug.log(message),this.emit("connect",new _errors.ConnectionError(message,"ETIMEOUT")),this.connectTimer=void 0,this.dispatchEvent("connectTimeout")}cancelTimeout(){const message=`Failed to cancel request in ${this.config.options.cancelTimeout}ms`;this.debug.log(message),this.dispatchEvent("socketError",new _errors.ConnectionError(message,"ETIMEOUT"))}requestTimeout(){this.requestTimer=void 0;const request=this.request;request.cancel();const message="Timeout: Request failed to complete in "+(void 0!==request.timeout?request.timeout:this.config.options.requestTimeout)+"ms";request.error=new _errors.RequestError(message,"ETIMEOUT")}retryTimeout(){this.retryTimer=void 0,this.emit("retry"),this.transitionTo(this.STATE.CONNECTING)}clearConnectTimer(){this.connectTimer&&(clearTimeout(this.connectTimer),this.connectTimer=void 0)}clearCancelTimer(){this.cancelTimer&&(clearTimeout(this.cancelTimer),this.cancelTimer=void 0)}clearRequestTimer(){this.requestTimer&&(clearTimeout(this.requestTimer),this.requestTimer=void 0)}clearRetryTimer(){this.retryTimer&&(clearTimeout(this.retryTimer),this.retryTimer=void 0)}transitionTo(newState){this.state!==newState?(this.state&&this.state.exit&&this.state.exit.call(this,newState),this.debug.log("State change: "+(this.state?this.state.name:"undefined")+" -> "+newState.name),this.state=newState,this.state.enter&&this.state.enter.apply(this)):this.debug.log("State is already "+newState.name)}getEventHandler(eventName){const handler=this.state.events[eventName];if(!handler)throw new Error(`No event '${eventName}' in state '${this.state.name}'`);return handler}dispatchEvent(eventName,...args){const handler=this.state.events[eventName];handler?handler.apply(this,args):(this.emit("error",new Error(`No event '${eventName}' in state '${this.state.name}'`)),this.close())}socketError(error){if(this.state===this.STATE.CONNECTING||this.state===this.STATE.SENT_TLSSSLNEGOTIATION){const message=`Failed to connect to ${this.config.server}:${this.config.options.port} - ${error.message}`;this.debug.log(message),this.emit("connect",new _errors.ConnectionError(message,"ESOCKET"))}else{const message=`Connection lost - ${error.message}`;this.debug.log(message),this.emit("error",new _errors.ConnectionError(message,"ESOCKET"))}this.dispatchEvent("socketError",error)}socketEnd(){if(this.debug.log("socket ended"),this.state!==this.STATE.FINAL){const error=new Error("socket hang up");error.code="ECONNRESET",this.socketError(error)}}socketClose(){if(this.debug.log("connection to "+this.config.server+":"+this.config.options.port+" closed"),this.state===this.STATE.REROUTING)this.debug.log("Rerouting to "+this.routingData.server+":"+this.routingData.port),this.dispatchEvent("reconnect");else if(this.state===this.STATE.TRANSIENT_FAILURE_RETRY){const server=this.routingData?this.routingData.server:this.config.server,port=this.routingData?this.routingData.port:this.config.options.port;this.debug.log("Retry after transient failure connecting to "+server+":"+port),this.dispatchEvent("retry")}else this.transitionTo(this.STATE.FINAL)}sendPreLogin(){const[,major,minor,build]=/^(\d+)\.(\d+)\.(\d+)/.exec(_package.version)??["0.0.0","0","0","0"],payload=new _preloginPayload.default({encrypt:this.config.options.encrypt,version:{major:Number(major),minor:Number(minor),build:Number(build),subbuild:0}});this.messageIo.sendMessage(_packet.TYPE.PRELOGIN,payload.data),this.debug.payload((function(){return payload.toString("  ")}))}sendLogin7Packet(){const payload=new _login7Payload.default({tdsVersion:_tdsVersions.versions[this.config.options.tdsVersion],packetSize:this.config.options.packetSize,clientProgVer:0,clientPid:process.pid,connectionId:0,clientTimeZone:(new Date).getTimezoneOffset(),clientLcid:1033}),{authentication:authentication}=this.config;switch(authentication.type){case"azure-active-directory-password":payload.fedAuth={type:"ADAL",echo:this.fedAuthRequired,workflow:"default"};break;case"azure-active-directory-access-token":payload.fedAuth={type:"SECURITYTOKEN",echo:this.fedAuthRequired,fedAuthToken:authentication.options.token};break;case"azure-active-directory-msi-vm":case"azure-active-directory-default":case"azure-active-directory-msi-app-service":case"azure-active-directory-service-principal-secret":payload.fedAuth={type:"ADAL",echo:this.fedAuthRequired,workflow:"integrated"};break;case"ntlm":payload.sspi=(0,_ntlm.createNTLMRequest)({domain:authentication.options.domain});break;default:payload.userName=authentication.options.userName,payload.password=authentication.options.password}payload.hostname=this.config.options.workstationId||_os.default.hostname(),payload.serverName=this.routingData?this.routingData.server:this.config.server,payload.appName=this.config.options.appName||"Tedious",payload.libraryName=_library.name,payload.language=this.config.options.language,payload.database=this.config.options.database,payload.clientId=Buffer.from([1,2,3,4,5,6]),payload.readOnlyIntent=this.config.options.readOnlyIntent,payload.initDbFatal=!this.config.options.fallbackToDefaultDb,this.routingData=void 0,this.messageIo.sendMessage(_packet.TYPE.LOGIN7,payload.toBuffer()),this.debug.payload((function(){return payload.toString("  ")}))}sendFedAuthTokenMessage(token){const accessTokenLen=Buffer.byteLength(token,"ucs2"),data=Buffer.alloc(8+accessTokenLen);let offset=0;offset=data.writeUInt32LE(accessTokenLen+4,offset),offset=data.writeUInt32LE(accessTokenLen,offset),data.write(token,offset,"ucs2"),this.messageIo.sendMessage(_packet.TYPE.FEDAUTH_TOKEN,data),this.transitionTo(this.STATE.SENT_LOGIN7_WITH_STANDARD_LOGIN)}sendInitialSql(){const payload=new _sqlbatchPayload.default(this.getInitialSql(),this.currentTransactionDescriptor(),this.config.options),message=new _message.default({type:_packet.TYPE.SQL_BATCH});this.messageIo.outgoingMessageStream.write(message),_stream.Readable.from(payload).pipe(message)}getInitialSql(){const options=[];return!0===this.config.options.enableAnsiNull?options.push("set ansi_nulls on"):!1===this.config.options.enableAnsiNull&&options.push("set ansi_nulls off"),!0===this.config.options.enableAnsiNullDefault?options.push("set ansi_null_dflt_on on"):!1===this.config.options.enableAnsiNullDefault&&options.push("set ansi_null_dflt_on off"),!0===this.config.options.enableAnsiPadding?options.push("set ansi_padding on"):!1===this.config.options.enableAnsiPadding&&options.push("set ansi_padding off"),!0===this.config.options.enableAnsiWarnings?options.push("set ansi_warnings on"):!1===this.config.options.enableAnsiWarnings&&options.push("set ansi_warnings off"),!0===this.config.options.enableArithAbort?options.push("set arithabort on"):!1===this.config.options.enableArithAbort&&options.push("set arithabort off"),!0===this.config.options.enableConcatNullYieldsNull?options.push("set concat_null_yields_null on"):!1===this.config.options.enableConcatNullYieldsNull&&options.push("set concat_null_yields_null off"),!0===this.config.options.enableCursorCloseOnCommit?options.push("set cursor_close_on_commit on"):!1===this.config.options.enableCursorCloseOnCommit&&options.push("set cursor_close_on_commit off"),null!==this.config.options.datefirst&&options.push(`set datefirst ${this.config.options.datefirst}`),null!==this.config.options.dateFormat&&options.push(`set dateformat ${this.config.options.dateFormat}`),!0===this.config.options.enableImplicitTransactions?options.push("set implicit_transactions on"):!1===this.config.options.enableImplicitTransactions&&options.push("set implicit_transactions off"),null!==this.config.options.language&&options.push(`set language ${this.config.options.language}`),!0===this.config.options.enableNumericRoundabort?options.push("set numeric_roundabort on"):!1===this.config.options.enableNumericRoundabort&&options.push("set numeric_roundabort off"),!0===this.config.options.enableQuotedIdentifier?options.push("set quoted_identifier on"):!1===this.config.options.enableQuotedIdentifier&&options.push("set quoted_identifier off"),null!==this.config.options.textsize&&options.push(`set textsize ${this.config.options.textsize}`),null!==this.config.options.connectionIsolationLevel&&options.push(`set transaction isolation level ${this.getIsolationLevelText(this.config.options.connectionIsolationLevel)}`),!0===this.config.options.abortTransactionOnError?options.push("set xact_abort on"):!1===this.config.options.abortTransactionOnError&&options.push("set xact_abort off"),options.join("\n")}processedInitialSql(){this.clearConnectTimer(),this.emit("connect")}execSqlBatch(request){this.makeRequest(request,_packet.TYPE.SQL_BATCH,new _sqlbatchPayload.default(request.sqlTextOrProcedure,this.currentTransactionDescriptor(),this.config.options))}execSql(request){try{request.validateParameters(this.databaseCollation)}catch(error){return request.error=error,void process.nextTick((()=>{this.debug.log(error.message),request.callback(error)}))}const parameters=[];parameters.push({type:_dataType.TYPES.NVarChar,name:"statement",value:request.sqlTextOrProcedure,output:!1,length:void 0,precision:void 0,scale:void 0}),request.parameters.length&&(parameters.push({type:_dataType.TYPES.NVarChar,name:"params",value:request.makeParamsParameter(request.parameters),output:!1,length:void 0,precision:void 0,scale:void 0}),parameters.push(...request.parameters)),this.makeRequest(request,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default("sp_executesql",parameters,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}newBulkLoad(table,callbackOrOptions,callback){let options;if(void 0===callback?(callback=callbackOrOptions,options={}):options=callbackOrOptions,"object"!=typeof options)throw new TypeError('"options" argument must be an object');return new _bulkLoad.default(table,this.databaseCollation,this.config.options,options,callback)}execBulkLoad(bulkLoad,rows){if(bulkLoad.executionStarted=!0,rows){if(bulkLoad.streamingMode)throw new Error("Connection.execBulkLoad can't be called with a BulkLoad that was put in streaming mode.");if(bulkLoad.firstRowWritten)throw new Error("Connection.execBulkLoad can't be called with a BulkLoad that already has rows written to it.");const rowStream=_stream.Readable.from(rows);rowStream.on("error",(err=>{bulkLoad.rowToPacketTransform.destroy(err)})),bulkLoad.rowToPacketTransform.on("error",(err=>{rowStream.destroy(err)})),rowStream.pipe(bulkLoad.rowToPacketTransform)}else bulkLoad.streamingMode||bulkLoad.rowToPacketTransform.end();const onCancel=()=>{request.cancel()},payload=new _bulkLoadPayload.BulkLoadPayload(bulkLoad),request=new _request.default(bulkLoad.getBulkInsertSql(),(error=>{if(bulkLoad.removeListener("cancel",onCancel),error)return"UNKNOWN"===error.code&&(error.message+=" This is likely because the schema of the BulkLoad does not match the schema of the table you are attempting to insert into."),bulkLoad.error=error,void bulkLoad.callback(error);this.makeRequest(bulkLoad,_packet.TYPE.BULK_LOAD,payload)}));bulkLoad.once("cancel",onCancel),this.execSqlBatch(request)}prepare(request){const parameters=[];parameters.push({type:_dataType.TYPES.Int,name:"handle",value:void 0,output:!0,length:void 0,precision:void 0,scale:void 0}),parameters.push({type:_dataType.TYPES.NVarChar,name:"params",value:request.parameters.length?request.makeParamsParameter(request.parameters):null,output:!1,length:void 0,precision:void 0,scale:void 0}),parameters.push({type:_dataType.TYPES.NVarChar,name:"stmt",value:request.sqlTextOrProcedure,output:!1,length:void 0,precision:void 0,scale:void 0}),request.preparing=!0,request.on("returnValue",((name,value)=>{"handle"===name?request.handle=value:request.error=new _errors.RequestError(`Tedious > Unexpected output parameter ${name} from sp_prepare`)})),this.makeRequest(request,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default("sp_prepare",parameters,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}unprepare(request){const parameters=[];parameters.push({type:_dataType.TYPES.Int,name:"handle",value:request.handle,output:!1,length:void 0,precision:void 0,scale:void 0}),this.makeRequest(request,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default("sp_unprepare",parameters,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}execute(request,parameters){const executeParameters=[];executeParameters.push({type:_dataType.TYPES.Int,name:"handle",value:request.handle,output:!1,length:void 0,precision:void 0,scale:void 0});try{for(let i=0,len=request.parameters.length;i<len;i++){const parameter=request.parameters[i];executeParameters.push({...parameter,value:parameter.type.validate(parameters?parameters[parameter.name]:null,this.databaseCollation)})}}catch(error){return request.error=error,void process.nextTick((()=>{this.debug.log(error.message),request.callback(error)}))}this.makeRequest(request,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default("sp_execute",executeParameters,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}callProcedure(request){try{request.validateParameters(this.databaseCollation)}catch(error){return request.error=error,void process.nextTick((()=>{this.debug.log(error.message),request.callback(error)}))}this.makeRequest(request,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default(request.sqlTextOrProcedure,request.parameters,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}beginTransaction(callback,name="",isolationLevel=this.config.options.isolationLevel){(0,_transaction.assertValidIsolationLevel)(isolationLevel,"isolationLevel");const transaction=new _transaction.Transaction(name,isolationLevel);if(this.config.options.tdsVersion<"7_2")return this.execSqlBatch(new _request.default("SET TRANSACTION ISOLATION LEVEL "+transaction.isolationLevelToTSQL()+";BEGIN TRAN "+transaction.name,(err=>{this.transactionDepth++,1===this.transactionDepth&&(this.inTransaction=!0),callback(err)})));const request=new _request.default(void 0,(err=>callback(err,this.currentTransactionDescriptor())));return this.makeRequest(request,_packet.TYPE.TRANSACTION_MANAGER,transaction.beginPayload(this.currentTransactionDescriptor()))}commitTransaction(callback,name=""){const transaction=new _transaction.Transaction(name);if(this.config.options.tdsVersion<"7_2")return this.execSqlBatch(new _request.default("COMMIT TRAN "+transaction.name,(err=>{this.transactionDepth--,0===this.transactionDepth&&(this.inTransaction=!1),callback(err)})));const request=new _request.default(void 0,callback);return this.makeRequest(request,_packet.TYPE.TRANSACTION_MANAGER,transaction.commitPayload(this.currentTransactionDescriptor()))}rollbackTransaction(callback,name=""){const transaction=new _transaction.Transaction(name);if(this.config.options.tdsVersion<"7_2")return this.execSqlBatch(new _request.default("ROLLBACK TRAN "+transaction.name,(err=>{this.transactionDepth--,0===this.transactionDepth&&(this.inTransaction=!1),callback(err)})));const request=new _request.default(void 0,callback);return this.makeRequest(request,_packet.TYPE.TRANSACTION_MANAGER,transaction.rollbackPayload(this.currentTransactionDescriptor()))}saveTransaction(callback,name){const transaction=new _transaction.Transaction(name);if(this.config.options.tdsVersion<"7_2")return this.execSqlBatch(new _request.default("SAVE TRAN "+transaction.name,(err=>{this.transactionDepth++,callback(err)})));const request=new _request.default(void 0,callback);return this.makeRequest(request,_packet.TYPE.TRANSACTION_MANAGER,transaction.savePayload(this.currentTransactionDescriptor()))}transaction(cb,isolationLevel){if("function"!=typeof cb)throw new TypeError("`cb` must be a function");const useSavepoint=this.inTransaction,name="_tedious_"+_crypto.default.randomBytes(10).toString("hex"),txDone=(err,done,...args)=>{err?this.inTransaction&&this.state===this.STATE.LOGGED_IN?this.rollbackTransaction((txErr=>{done(txErr||err,...args)}),name):done(err,...args):useSavepoint?(this.config.options.tdsVersion<"7_2"&&this.transactionDepth--,done(null,...args)):this.commitTransaction((txErr=>{done(txErr,...args)}),name)};return useSavepoint?this.saveTransaction((err=>err?cb(err):isolationLevel?this.execSqlBatch(new _request.default("SET transaction isolation level "+this.getIsolationLevelText(isolationLevel),(err=>cb(err,txDone)))):cb(null,txDone)),name):this.beginTransaction((err=>err?cb(err):cb(null,txDone)),name,isolationLevel)}makeRequest(request,packetType,payload){if(this.state!==this.STATE.LOGGED_IN){const message="Requests can only be made in the "+this.STATE.LOGGED_IN.name+" state, not the "+this.state.name+" state";this.debug.log(message),request.callback(new _errors.RequestError(message,"EINVALIDSTATE"))}else if(request.canceled)process.nextTick((()=>{request.callback(new _errors.RequestError("Canceled.","ECANCEL"))}));else{packetType===_packet.TYPE.SQL_BATCH?this.isSqlBatch=!0:this.isSqlBatch=!1,this.request=request,request.connection=this,request.rowCount=0,request.rows=[],request.rst=[];const onCancel=()=>{payloadStream.unpipe(message),payloadStream.destroy(new _errors.RequestError("Canceled.","ECANCEL")),message.ignore=!0,message.end(),request instanceof _request.default&&request.paused&&request.resume()};request.once("cancel",onCancel),this.createRequestTimer();const message=new _message.default({type:packetType,resetConnection:this.resetConnectionOnNextRequest});this.messageIo.outgoingMessageStream.write(message),this.transitionTo(this.STATE.SENT_CLIENT_REQUEST),message.once("finish",(()=>{request.removeListener("cancel",onCancel),request.once("cancel",this._cancelAfterRequestSent),this.resetConnectionOnNextRequest=!1,this.debug.payload((function(){return payload.toString("  ")}))}));const payloadStream=_stream.Readable.from(payload);payloadStream.once("error",(error=>{payloadStream.unpipe(message),request.error??(request.error=error),message.ignore=!0,message.end()})),payloadStream.pipe(message)}}cancel(){return!!this.request&&(!this.request.canceled&&(this.request.cancel(),!0))}reset(callback){const request=new _request.default(this.getInitialSql(),(err=>{this.config.options.tdsVersion<"7_2"&&(this.inTransaction=!1),callback(err)}));this.resetConnectionOnNextRequest=!0,this.execSqlBatch(request)}currentTransactionDescriptor(){return this.transactionDescriptors[this.transactionDescriptors.length-1]}getIsolationLevelText(isolationLevel){switch(isolationLevel){case _transaction.ISOLATION_LEVEL.READ_UNCOMMITTED:return"read uncommitted";case _transaction.ISOLATION_LEVEL.REPEATABLE_READ:return"repeatable read";case _transaction.ISOLATION_LEVEL.SERIALIZABLE:return"serializable";case _transaction.ISOLATION_LEVEL.SNAPSHOT:return"snapshot";default:return"read committed"}}}function isTransientError(error){return error instanceof _esAggregateError.default&&(error=error.errors[0]),error instanceof _errors.ConnectionError&&!!error.isTransient}var _default=Connection;exports.default=_default,module.exports=Connection,Connection.prototype.STATE={INITIALIZED:{name:"Initialized",events:{}},CONNECTING:{name:"Connecting",enter:function(){this.initialiseConnection()},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_PRELOGIN:{name:"SentPrelogin",enter:function(){(async()=>{let message,messageBuffer=Buffer.alloc(0);try{message=await this.messageIo.readMessage()}catch(err){return this.socketError(err)}for await(const data of message)messageBuffer=Buffer.concat([messageBuffer,data]);const preloginPayload=new _preloginPayload.default(messageBuffer);if(this.debug.payload((function(){return preloginPayload.toString("  ")})),1===preloginPayload.fedAuthRequired&&(this.fedAuthRequired=!0),"ON"===preloginPayload.encryptionString||"REQ"===preloginPayload.encryptionString){if(!this.config.options.encrypt)return this.emit("connect",new _errors.ConnectionError("Server requires encryption, set 'encrypt' config option to true.","EENCRYPT")),this.close();try{var _this$routingData;this.transitionTo(this.STATE.SENT_TLSSSLNEGOTIATION),await this.messageIo.startTls(this.secureContextOptions,(null===(_this$routingData=this.routingData)||void 0===_this$routingData?void 0:_this$routingData.server)??this.config.server,this.config.options.trustServerCertificate)}catch(err){return this.socketError(err)}}this.sendLogin7Packet();const{authentication:authentication}=this.config;switch(authentication.type){case"azure-active-directory-password":case"azure-active-directory-msi-vm":case"azure-active-directory-msi-app-service":case"azure-active-directory-service-principal-secret":case"azure-active-directory-default":this.transitionTo(this.STATE.SENT_LOGIN7_WITH_FEDAUTH);break;case"ntlm":this.transitionTo(this.STATE.SENT_LOGIN7_WITH_NTLM);break;default:this.transitionTo(this.STATE.SENT_LOGIN7_WITH_STANDARD_LOGIN)}})().catch((err=>{process.nextTick((()=>{throw err}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},REROUTING:{name:"ReRouting",enter:function(){this.cleanupConnection(CLEANUP_TYPE.REDIRECT)},events:{message:function(){},socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)},reconnect:function(){this.transitionTo(this.STATE.CONNECTING)}}},TRANSIENT_FAILURE_RETRY:{name:"TRANSIENT_FAILURE_RETRY",enter:function(){this.curTransientRetryCount++,this.cleanupConnection(CLEANUP_TYPE.RETRY)},events:{message:function(){},socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)},retry:function(){this.createRetryTimer()}}},SENT_TLSSSLNEGOTIATION:{name:"SentTLSSSLNegotiation",events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_LOGIN7_WITH_STANDARD_LOGIN:{name:"SentLogin7WithStandardLogin",enter:function(){(async()=>{let message;try{message=await this.messageIo.readMessage()}catch(err){return this.socketError(err)}const handler=new _handler.Login7TokenHandler(this),tokenStreamParser=this.createTokenStreamParser(message,handler);await(0,_events.once)(tokenStreamParser,"end"),handler.loginAckReceived?handler.routingData?(this.routingData=handler.routingData,this.transitionTo(this.STATE.REROUTING)):this.transitionTo(this.STATE.LOGGED_IN_SENDING_INITIAL_SQL):this.loginError?isTransientError(this.loginError)?(this.debug.log("Initiating retry on transient error"),this.transitionTo(this.STATE.TRANSIENT_FAILURE_RETRY)):(this.emit("connect",this.loginError),this.transitionTo(this.STATE.FINAL)):(this.emit("connect",new _errors.ConnectionError("Login failed.","ELOGIN")),this.transitionTo(this.STATE.FINAL))})().catch((err=>{process.nextTick((()=>{throw err}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_LOGIN7_WITH_NTLM:{name:"SentLogin7WithNTLMLogin",enter:function(){(async()=>{for(;;){let message;try{message=await this.messageIo.readMessage()}catch(err){return this.socketError(err)}const handler=new _handler.Login7TokenHandler(this),tokenStreamParser=this.createTokenStreamParser(message,handler);if(await(0,_events.once)(tokenStreamParser,"end"),handler.loginAckReceived)return handler.routingData?(this.routingData=handler.routingData,this.transitionTo(this.STATE.REROUTING)):this.transitionTo(this.STATE.LOGGED_IN_SENDING_INITIAL_SQL);if(!this.ntlmpacket)return this.loginError?isTransientError(this.loginError)?(this.debug.log("Initiating retry on transient error"),this.transitionTo(this.STATE.TRANSIENT_FAILURE_RETRY)):(this.emit("connect",this.loginError),this.transitionTo(this.STATE.FINAL)):(this.emit("connect",new _errors.ConnectionError("Login failed.","ELOGIN")),this.transitionTo(this.STATE.FINAL));{const authentication=this.config.authentication,payload=new _ntlmPayload.default({domain:authentication.options.domain,userName:authentication.options.userName,password:authentication.options.password,ntlmpacket:this.ntlmpacket});this.messageIo.sendMessage(_packet.TYPE.NTLMAUTH_PKT,payload.data),this.debug.payload((function(){return payload.toString("  ")})),this.ntlmpacket=void 0}}})().catch((err=>{process.nextTick((()=>{throw err}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_LOGIN7_WITH_FEDAUTH:{name:"SentLogin7Withfedauth",enter:function(){(async()=>{let message;try{message=await this.messageIo.readMessage()}catch(err){return this.socketError(err)}const handler=new _handler.Login7TokenHandler(this),tokenStreamParser=this.createTokenStreamParser(message,handler);if(await(0,_events.once)(tokenStreamParser,"end"),handler.loginAckReceived)return void(handler.routingData?(this.routingData=handler.routingData,this.transitionTo(this.STATE.REROUTING)):this.transitionTo(this.STATE.LOGGED_IN_SENDING_INITIAL_SQL));const fedAuthInfoToken=handler.fedAuthInfoToken;if(fedAuthInfoToken&&fedAuthInfoToken.stsurl&&fedAuthInfoToken.spn){const authentication=this.config.authentication,tokenScope=new _url.URL("/.default",fedAuthInfoToken.spn).toString();let credentials,tokenResponse;switch(authentication.type){case"azure-active-directory-password":credentials=new _identity.UsernamePasswordCredential(authentication.options.tenantId??"common",authentication.options.clientId,authentication.options.userName,authentication.options.password);break;case"azure-active-directory-msi-vm":case"azure-active-directory-msi-app-service":const msiArgs=authentication.options.clientId?[authentication.options.clientId,{}]:[{}];credentials=new _identity.ManagedIdentityCredential(...msiArgs);break;case"azure-active-directory-default":const args=authentication.options.clientId?{managedIdentityClientId:authentication.options.clientId}:{};credentials=new _identity.DefaultAzureCredential(args);break;case"azure-active-directory-service-principal-secret":credentials=new _identity.ClientSecretCredential(authentication.options.tenantId,authentication.options.clientId,authentication.options.clientSecret)}try{tokenResponse=await credentials.getToken(tokenScope)}catch(err){return this.loginError=new _esAggregateError.default([new _errors.ConnectionError("Security token could not be authenticated or authorized.","EFEDAUTH"),err]),this.emit("connect",this.loginError),void this.transitionTo(this.STATE.FINAL)}const token=tokenResponse.token;this.sendFedAuthTokenMessage(token)}else this.loginError?isTransientError(this.loginError)?(this.debug.log("Initiating retry on transient error"),this.transitionTo(this.STATE.TRANSIENT_FAILURE_RETRY)):(this.emit("connect",this.loginError),this.transitionTo(this.STATE.FINAL)):(this.emit("connect",new _errors.ConnectionError("Login failed.","ELOGIN")),this.transitionTo(this.STATE.FINAL))})().catch((err=>{process.nextTick((()=>{throw err}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},LOGGED_IN_SENDING_INITIAL_SQL:{name:"LoggedInSendingInitialSql",enter:function(){(async()=>{let message;this.sendInitialSql();try{message=await this.messageIo.readMessage()}catch(err){return this.socketError(err)}const tokenStreamParser=this.createTokenStreamParser(message,new _handler.InitialSqlTokenHandler(this));await(0,_events.once)(tokenStreamParser,"end"),this.transitionTo(this.STATE.LOGGED_IN),this.processedInitialSql()})().catch((err=>{process.nextTick((()=>{throw err}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},LOGGED_IN:{name:"LoggedIn",events:{socketError:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_CLIENT_REQUEST:{name:"SentClientRequest",enter:function(){(async()=>{var _this$request,_this$request3,_this$request10;let message;try{message=await this.messageIo.readMessage()}catch(err){return this.socketError(err)}this.clearRequestTimer();const tokenStreamParser=this.createTokenStreamParser(message,new _handler.RequestTokenHandler(this,this.request));if(null!==(_this$request=this.request)&&void 0!==_this$request&&_this$request.canceled&&this.cancelTimer)return this.transitionTo(this.STATE.SENT_ATTENTION);const onResume=()=>{tokenStreamParser.resume()},onPause=()=>{var _this$request2;tokenStreamParser.pause(),null===(_this$request2=this.request)||void 0===_this$request2||_this$request2.once("resume",onResume)};null===(_this$request3=this.request)||void 0===_this$request3||_this$request3.on("pause",onPause),this.request instanceof _request.default&&this.request.paused&&onPause();const onCancel=()=>{var _this$request4,_this$request5;tokenStreamParser.removeListener("end",onEndOfMessage),this.request instanceof _request.default&&this.request.paused&&this.request.resume(),null===(_this$request4=this.request)||void 0===_this$request4||_this$request4.removeListener("pause",onPause),null===(_this$request5=this.request)||void 0===_this$request5||_this$request5.removeListener("resume",onResume),this.transitionTo(this.STATE.SENT_ATTENTION)},onEndOfMessage=()=>{var _this$request6,_this$request7,_this$request8,_this$request9;null===(_this$request6=this.request)||void 0===_this$request6||_this$request6.removeListener("cancel",this._cancelAfterRequestSent),null===(_this$request7=this.request)||void 0===_this$request7||_this$request7.removeListener("cancel",onCancel),null===(_this$request8=this.request)||void 0===_this$request8||_this$request8.removeListener("pause",onPause),null===(_this$request9=this.request)||void 0===_this$request9||_this$request9.removeListener("resume",onResume),this.transitionTo(this.STATE.LOGGED_IN);const sqlRequest=this.request;this.request=void 0,this.config.options.tdsVersion<"7_2"&&sqlRequest.error&&this.isSqlBatch&&(this.inTransaction=!1),sqlRequest.callback(sqlRequest.error,sqlRequest.rowCount,sqlRequest.rows)};tokenStreamParser.once("end",onEndOfMessage),null===(_this$request10=this.request)||void 0===_this$request10||_this$request10.once("cancel",onCancel)})()},exit:function(nextState){this.clearRequestTimer()},events:{socketError:function(err){const sqlRequest=this.request;this.request=void 0,this.transitionTo(this.STATE.FINAL),sqlRequest.callback(err)}}},SENT_ATTENTION:{name:"SentAttention",enter:function(){(async()=>{let message;try{message=await this.messageIo.readMessage()}catch(err){return this.socketError(err)}const handler=new _handler.AttentionTokenHandler(this,this.request),tokenStreamParser=this.createTokenStreamParser(message,handler);if(await(0,_events.once)(tokenStreamParser,"end"),handler.attentionReceived){this.clearCancelTimer();const sqlRequest=this.request;this.request=void 0,this.transitionTo(this.STATE.LOGGED_IN),sqlRequest.error&&sqlRequest.error instanceof _errors.RequestError&&"ETIMEOUT"===sqlRequest.error.code?sqlRequest.callback(sqlRequest.error):sqlRequest.callback(new _errors.RequestError("Canceled.","ECANCEL"))}})().catch((err=>{process.nextTick((()=>{throw err}))}))},events:{socketError:function(err){const sqlRequest=this.request;this.request=void 0,this.transitionTo(this.STATE.FINAL),sqlRequest.callback(err)}}},FINAL:{name:"Final",enter:function(){this.cleanupConnection(CLEANUP_TYPE.NORMAL)},events:{connectTimeout:function(){},message:function(){},socketError:function(){}}}};