"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.UnexpectedTokenError=exports.TokenHandler=exports.RequestTokenHandler=exports.Login7TokenHandler=exports.InitialSqlTokenHandler=exports.AttentionTokenHandler=void 0;var _request=_interopRequireDefault(require("../request")),_errors=require("../errors"),_esAggregateError=_interopRequireDefault(require("es-aggregate-error"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}class UnexpectedTokenError extends Error{constructor(handler,token){super("Unexpected token `"+token.name+"` in `"+handler.constructor.name+"`")}}exports.UnexpectedTokenError=UnexpectedTokenError;class TokenHandler{onInfoMessage(token){throw new UnexpectedTokenError(this,token)}onErrorMessage(token){throw new UnexpectedTokenError(this,token)}onSSPI(token){throw new UnexpectedTokenError(this,token)}onDatabaseChange(token){throw new UnexpectedTokenError(this,token)}onLanguageChange(token){throw new UnexpectedTokenError(this,token)}onCharsetChange(token){throw new UnexpectedTokenError(this,token)}onSqlCollationChange(token){throw new UnexpectedTokenError(this,token)}onRoutingChange(token){throw new UnexpectedTokenError(this,token)}onPacketSizeChange(token){throw new UnexpectedTokenError(this,token)}onResetConnection(token){throw new UnexpectedTokenError(this,token)}onBeginTransaction(token){throw new UnexpectedTokenError(this,token)}onCommitTransaction(token){throw new UnexpectedTokenError(this,token)}onRollbackTransaction(token){throw new UnexpectedTokenError(this,token)}onFedAuthInfo(token){throw new UnexpectedTokenError(this,token)}onFeatureExtAck(token){throw new UnexpectedTokenError(this,token)}onLoginAck(token){throw new UnexpectedTokenError(this,token)}onColMetadata(token){throw new UnexpectedTokenError(this,token)}onOrder(token){throw new UnexpectedTokenError(this,token)}onRow(token){throw new UnexpectedTokenError(this,token)}onReturnStatus(token){throw new UnexpectedTokenError(this,token)}onReturnValue(token){throw new UnexpectedTokenError(this,token)}onDoneProc(token){throw new UnexpectedTokenError(this,token)}onDoneInProc(token){throw new UnexpectedTokenError(this,token)}onDone(token){throw new UnexpectedTokenError(this,token)}onDatabaseMirroringPartner(token){throw new UnexpectedTokenError(this,token)}}exports.TokenHandler=TokenHandler;class InitialSqlTokenHandler extends TokenHandler{constructor(connection){super(),this.connection=void 0,this.connection=connection}onInfoMessage(token){this.connection.emit("infoMessage",token)}onErrorMessage(token){this.connection.emit("errorMessage",token)}onDatabaseChange(token){this.connection.emit("databaseChange",token.newValue)}onLanguageChange(token){this.connection.emit("languageChange",token.newValue)}onCharsetChange(token){this.connection.emit("charsetChange",token.newValue)}onSqlCollationChange(token){this.connection.databaseCollation=token.newValue}onPacketSizeChange(token){this.connection.messageIo.packetSize(token.newValue)}onBeginTransaction(token){this.connection.transactionDescriptors.push(token.newValue),this.connection.inTransaction=!0}onCommitTransaction(token){this.connection.transactionDescriptors.length=1,this.connection.inTransaction=!1}onRollbackTransaction(token){this.connection.transactionDescriptors.length=1,this.connection.inTransaction=!1,this.connection.emit("rollbackTransaction")}onColMetadata(token){this.connection.emit("error",new Error("Received 'columnMetadata' when no sqlRequest is in progress")),this.connection.close()}onOrder(token){this.connection.emit("error",new Error("Received 'order' when no sqlRequest is in progress")),this.connection.close()}onRow(token){this.connection.emit("error",new Error("Received 'row' when no sqlRequest is in progress")),this.connection.close()}onReturnStatus(token){}onReturnValue(token){}onDoneProc(token){}onDoneInProc(token){}onDone(token){}onResetConnection(token){this.connection.emit("resetConnection")}}exports.InitialSqlTokenHandler=InitialSqlTokenHandler;class Login7TokenHandler extends TokenHandler{constructor(connection){super(),this.connection=void 0,this.fedAuthInfoToken=void 0,this.routingData=void 0,this.loginAckReceived=!1,this.connection=connection}onInfoMessage(token){this.connection.emit("infoMessage",token)}onErrorMessage(token){this.connection.emit("errorMessage",token);const error=new _errors.ConnectionError(token.message,"ELOGIN");this.connection.transientErrorLookup.isTransientError(token.number)&&this.connection.curTransientRetryCount!==this.connection.config.options.maxRetriesOnTransientErrors&&(error.isTransient=!0),this.connection.loginError=error}onSSPI(token){token.ntlmpacket&&(this.connection.ntlmpacket=token.ntlmpacket,this.connection.ntlmpacketBuffer=token.ntlmpacketBuffer)}onDatabaseChange(token){this.connection.emit("databaseChange",token.newValue)}onLanguageChange(token){this.connection.emit("languageChange",token.newValue)}onCharsetChange(token){this.connection.emit("charsetChange",token.newValue)}onSqlCollationChange(token){this.connection.databaseCollation=token.newValue}onFedAuthInfo(token){this.fedAuthInfoToken=token}onFeatureExtAck(token){const{authentication:authentication}=this.connection.config;"azure-active-directory-password"===authentication.type||"azure-active-directory-access-token"===authentication.type||"azure-active-directory-msi-vm"===authentication.type||"azure-active-directory-msi-app-service"===authentication.type||"azure-active-directory-service-principal-secret"===authentication.type||"azure-active-directory-default"===authentication.type?void 0===token.fedAuth?this.connection.loginError=new _errors.ConnectionError("Did not receive Active Directory authentication acknowledgement"):0!==token.fedAuth.length&&(this.connection.loginError=new _errors.ConnectionError(`Active Directory authentication acknowledgment for ${authentication.type} authentication method includes extra data`)):void 0===token.fedAuth&&void 0===token.utf8Support?this.connection.loginError=new _errors.ConnectionError("Received acknowledgement for unknown feature"):token.fedAuth&&(this.connection.loginError=new _errors.ConnectionError("Did not request Active Directory authentication, but received the acknowledgment"))}onLoginAck(token){token.tdsVersion?token.interface?(this.connection.config.options.tdsVersion=token.tdsVersion,this.loginAckReceived=!0):this.connection.loginError=new _errors.ConnectionError("Server responded with unsupported interface.","EINTERFACENOTSUPP"):this.connection.loginError=new _errors.ConnectionError("Server responded with unknown TDS version.","ETDS")}onRoutingChange(token){const[server]=token.newValue.server.split("\\");this.routingData={server:server,port:token.newValue.port}}onDoneInProc(token){}onDone(token){}onPacketSizeChange(token){this.connection.messageIo.packetSize(token.newValue)}onDatabaseMirroringPartner(token){}}exports.Login7TokenHandler=Login7TokenHandler;class RequestTokenHandler extends TokenHandler{constructor(connection,request){super(),this.connection=void 0,this.request=void 0,this.errors=void 0,this.connection=connection,this.request=request,this.errors=[]}onInfoMessage(token){this.connection.emit("infoMessage",token)}onErrorMessage(token){if(this.connection.emit("errorMessage",token),!this.request.canceled){const error=new _errors.RequestError(token.message,"EREQUEST");error.number=token.number,error.state=token.state,error.class=token.class,error.serverName=token.serverName,error.procName=token.procName,error.lineNumber=token.lineNumber,this.errors.push(error),this.request.error=error,this.request instanceof _request.default&&this.errors.length>1&&(this.request.error=new _esAggregateError.default(this.errors))}}onDatabaseChange(token){this.connection.emit("databaseChange",token.newValue)}onLanguageChange(token){this.connection.emit("languageChange",token.newValue)}onCharsetChange(token){this.connection.emit("charsetChange",token.newValue)}onSqlCollationChange(token){this.connection.databaseCollation=token.newValue}onPacketSizeChange(token){this.connection.messageIo.packetSize(token.newValue)}onBeginTransaction(token){this.connection.transactionDescriptors.push(token.newValue),this.connection.inTransaction=!0}onCommitTransaction(token){this.connection.transactionDescriptors.length=1,this.connection.inTransaction=!1}onRollbackTransaction(token){this.connection.transactionDescriptors.length=1,this.connection.inTransaction=!1,this.connection.emit("rollbackTransaction")}onColMetadata(token){if(!this.request.canceled)if(this.connection.config.options.useColumnNames){const columns=Object.create(null);for(let j=0,len=token.columns.length;j<len;j++){const col=token.columns[j];null==columns[col.colName]&&(columns[col.colName]=col)}this.request.emit("columnMetadata",columns)}else this.request.emit("columnMetadata",token.columns)}onOrder(token){this.request.canceled||this.request.emit("order",token.orderColumns)}onRow(token){this.request.canceled||(this.connection.config.options.rowCollectionOnRequestCompletion&&this.request.rows.push(token.columns),this.connection.config.options.rowCollectionOnDone&&this.request.rst.push(token.columns),this.request.emit("row",token.columns))}onReturnStatus(token){this.request.canceled||(this.connection.procReturnStatusValue=token.value)}onReturnValue(token){this.request.canceled||this.request.emit("returnValue",token.paramName,token.value,token.metadata)}onDoneProc(token){this.request.canceled||(token.sqlError&&!this.request.error&&(this.request.error=new _errors.RequestError("An unknown error has occurred.","UNKNOWN")),this.request.emit("doneProc",token.rowCount,token.more,this.connection.procReturnStatusValue,this.request.rst),this.connection.procReturnStatusValue=void 0,void 0!==token.rowCount&&(this.request.rowCount+=token.rowCount),this.connection.config.options.rowCollectionOnDone&&(this.request.rst=[]))}onDoneInProc(token){this.request.canceled||(this.request.emit("doneInProc",token.rowCount,token.more,this.request.rst),void 0!==token.rowCount&&(this.request.rowCount+=token.rowCount),this.connection.config.options.rowCollectionOnDone&&(this.request.rst=[]))}onDone(token){this.request.canceled||(token.sqlError&&!this.request.error&&(this.request.error=new _errors.RequestError("An unknown error has occurred.","UNKNOWN")),this.request.emit("done",token.rowCount,token.more,this.request.rst),void 0!==token.rowCount&&(this.request.rowCount+=token.rowCount),this.connection.config.options.rowCollectionOnDone&&(this.request.rst=[]))}onResetConnection(token){this.connection.emit("resetConnection")}}exports.RequestTokenHandler=RequestTokenHandler;class AttentionTokenHandler extends TokenHandler{constructor(connection,request){super(),this.connection=void 0,this.request=void 0,this.attentionReceived=void 0,this.connection=connection,this.request=request,this.attentionReceived=!1}onDone(token){token.attention&&(this.attentionReceived=!0)}}exports.AttentionTokenHandler=AttentionTokenHandler;