"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _token=require("./token"),_colmetadataTokenParser=_interopRequireDefault(require("./colmetadata-token-parser")),_doneTokenParser=require("./done-token-parser"),_envChangeTokenParser=_interopRequireDefault(require("./env-change-token-parser")),_infoerrorTokenParser=require("./infoerror-token-parser"),_fedauthInfoParser=_interopRequireDefault(require("./fedauth-info-parser")),_featureExtAckParser=_interopRequireDefault(require("./feature-ext-ack-parser")),_loginackTokenParser=_interopRequireDefault(require("./loginack-token-parser")),_orderTokenParser=_interopRequireDefault(require("./order-token-parser")),_returnstatusTokenParser=_interopRequireDefault(require("./returnstatus-token-parser")),_returnvalueTokenParser=_interopRequireDefault(require("./returnvalue-token-parser")),_rowTokenParser=_interopRequireDefault(require("./row-token-parser")),_nbcrowTokenParser=_interopRequireDefault(require("./nbcrow-token-parser")),_sspiTokenParser=_interopRequireDefault(require("./sspi-token-parser"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}const tokenParsers={[_token.TYPE.DONE]:_doneTokenParser.doneParser,[_token.TYPE.DONEINPROC]:_doneTokenParser.doneInProcParser,[_token.TYPE.DONEPROC]:_doneTokenParser.doneProcParser,[_token.TYPE.ENVCHANGE]:_envChangeTokenParser.default,[_token.TYPE.ERROR]:_infoerrorTokenParser.errorParser,[_token.TYPE.FEDAUTHINFO]:_fedauthInfoParser.default,[_token.TYPE.FEATUREEXTACK]:_featureExtAckParser.default,[_token.TYPE.INFO]:_infoerrorTokenParser.infoParser,[_token.TYPE.LOGINACK]:_loginackTokenParser.default,[_token.TYPE.ORDER]:_orderTokenParser.default,[_token.TYPE.RETURNSTATUS]:_returnstatusTokenParser.default,[_token.TYPE.RETURNVALUE]:_returnvalueTokenParser.default,[_token.TYPE.SSPI]:_sspiTokenParser.default};class StreamBuffer{constructor(iterable){this.iterator=void 0,this.buffer=void 0,this.position=void 0,this.iterator=(iterable[Symbol.asyncIterator]||iterable[Symbol.iterator]).call(iterable),this.buffer=Buffer.alloc(0),this.position=0}async waitForChunk(){const result=await this.iterator.next();if(result.done)throw new Error("unexpected end of data");this.position===this.buffer.length?this.buffer=result.value:this.buffer=Buffer.concat([this.buffer.slice(this.position),result.value]),this.position=0}}class Parser{static async*parseTokens(iterable,debug,options,colMetadata=[]){let token;const onDoneParsing=t=>{token=t},streamBuffer=new StreamBuffer(iterable),parser=new Parser(streamBuffer,debug,options);for(parser.colMetadata=colMetadata;;){try{await streamBuffer.waitForChunk()}catch(err){if(streamBuffer.position===streamBuffer.buffer.length)return;throw err}if(parser.suspended){parser.suspended=!1;(0,parser.next)(),!parser.suspended&&token&&(token instanceof _token.ColMetadataToken&&(parser.colMetadata=token.columns),yield token)}for(;!parser.suspended&&parser.position+1<=parser.buffer.length;){const type=parser.buffer.readUInt8(parser.position);if(parser.position+=1,type===_token.TYPE.COLMETADATA){const token=await(0,_colmetadataTokenParser.default)(parser);parser.colMetadata=token.columns,yield token}else if(type===_token.TYPE.ROW)yield(0,_rowTokenParser.default)(parser);else if(type===_token.TYPE.NBCROW)yield(0,_nbcrowTokenParser.default)(parser);else{if(!tokenParsers[type])throw new Error("Unknown type: "+type);tokenParsers[type](parser,parser.options,onDoneParsing),!parser.suspended&&token&&(token instanceof _token.ColMetadataToken&&(parser.colMetadata=token.columns),yield token)}}}}constructor(streamBuffer,debug,options){this.debug=void 0,this.colMetadata=void 0,this.options=void 0,this.suspended=void 0,this.next=void 0,this.streamBuffer=void 0,this.debug=debug,this.colMetadata=[],this.options=options,this.streamBuffer=streamBuffer,this.suspended=!1,this.next=void 0}get buffer(){return this.streamBuffer.buffer}get position(){return this.streamBuffer.position}set position(value){this.streamBuffer.position=value}suspend(next){this.suspended=!0,this.next=next}awaitData(length,callback){this.position+length<=this.buffer.length?callback():this.suspend((()=>{this.awaitData(length,callback)}))}readInt8(callback){this.awaitData(1,(()=>{const data=this.buffer.readInt8(this.position);this.position+=1,callback(data)}))}readUInt8(callback){this.awaitData(1,(()=>{const data=this.buffer.readUInt8(this.position);this.position+=1,callback(data)}))}readInt16LE(callback){this.awaitData(2,(()=>{const data=this.buffer.readInt16LE(this.position);this.position+=2,callback(data)}))}readInt16BE(callback){this.awaitData(2,(()=>{const data=this.buffer.readInt16BE(this.position);this.position+=2,callback(data)}))}readUInt16LE(callback){this.awaitData(2,(()=>{const data=this.buffer.readUInt16LE(this.position);this.position+=2,callback(data)}))}readUInt16BE(callback){this.awaitData(2,(()=>{const data=this.buffer.readUInt16BE(this.position);this.position+=2,callback(data)}))}readInt32LE(callback){this.awaitData(4,(()=>{const data=this.buffer.readInt32LE(this.position);this.position+=4,callback(data)}))}readInt32BE(callback){this.awaitData(4,(()=>{const data=this.buffer.readInt32BE(this.position);this.position+=4,callback(data)}))}readUInt32LE(callback){this.awaitData(4,(()=>{const data=this.buffer.readUInt32LE(this.position);this.position+=4,callback(data)}))}readUInt32BE(callback){this.awaitData(4,(()=>{const data=this.buffer.readUInt32BE(this.position);this.position+=4,callback(data)}))}readBigInt64LE(callback){this.awaitData(8,(()=>{const data=this.buffer.readBigInt64LE(this.position);this.position+=8,callback(data)}))}readInt64LE(callback){this.awaitData(8,(()=>{const data=Math.pow(2,32)*this.buffer.readInt32LE(this.position+4)+(128==(128&this.buffer[this.position+4])?1:-1)*this.buffer.readUInt32LE(this.position);this.position+=8,callback(data)}))}readInt64BE(callback){this.awaitData(8,(()=>{const data=Math.pow(2,32)*this.buffer.readInt32BE(this.position)+(128==(128&this.buffer[this.position])?1:-1)*this.buffer.readUInt32BE(this.position+4);this.position+=8,callback(data)}))}readBigUInt64LE(callback){this.awaitData(8,(()=>{const data=this.buffer.readBigUInt64LE(this.position);this.position+=8,callback(data)}))}readUInt64LE(callback){this.awaitData(8,(()=>{const data=Math.pow(2,32)*this.buffer.readUInt32LE(this.position+4)+this.buffer.readUInt32LE(this.position);this.position+=8,callback(data)}))}readUInt64BE(callback){this.awaitData(8,(()=>{const data=Math.pow(2,32)*this.buffer.readUInt32BE(this.position)+this.buffer.readUInt32BE(this.position+4);this.position+=8,callback(data)}))}readFloatLE(callback){this.awaitData(4,(()=>{const data=this.buffer.readFloatLE(this.position);this.position+=4,callback(data)}))}readFloatBE(callback){this.awaitData(4,(()=>{const data=this.buffer.readFloatBE(this.position);this.position+=4,callback(data)}))}readDoubleLE(callback){this.awaitData(8,(()=>{const data=this.buffer.readDoubleLE(this.position);this.position+=8,callback(data)}))}readDoubleBE(callback){this.awaitData(8,(()=>{const data=this.buffer.readDoubleBE(this.position);this.position+=8,callback(data)}))}readUInt24LE(callback){this.awaitData(3,(()=>{const low=this.buffer.readUInt16LE(this.position),high=this.buffer.readUInt8(this.position+2);this.position+=3,callback(low|high<<16)}))}readUInt40LE(callback){this.awaitData(5,(()=>{const low=this.buffer.readUInt32LE(this.position),high=this.buffer.readUInt8(this.position+4);this.position+=5,callback(4294967296*high+low)}))}readUNumeric64LE(callback){this.awaitData(8,(()=>{const low=this.buffer.readUInt32LE(this.position),high=this.buffer.readUInt32LE(this.position+4);this.position+=8,callback(4294967296*high+low)}))}readUNumeric96LE(callback){this.awaitData(12,(()=>{const dword1=this.buffer.readUInt32LE(this.position),dword2=this.buffer.readUInt32LE(this.position+4),dword3=this.buffer.readUInt32LE(this.position+8);this.position+=12,callback(dword1+4294967296*dword2+0x10000000000000000*dword3)}))}readUNumeric128LE(callback){this.awaitData(16,(()=>{const dword1=this.buffer.readUInt32LE(this.position),dword2=this.buffer.readUInt32LE(this.position+4),dword3=this.buffer.readUInt32LE(this.position+8),dword4=this.buffer.readUInt32LE(this.position+12);this.position+=16,callback(dword1+4294967296*dword2+0x10000000000000000*dword3+7922816251426434e13*dword4)}))}readBuffer(length,callback){this.awaitData(length,(()=>{const data=this.buffer.slice(this.position,this.position+length);this.position+=length,callback(data)}))}readBVarChar(callback){this.readUInt8((length=>{this.readBuffer(2*length,(data=>{callback(data.toString("ucs2"))}))}))}readUsVarChar(callback){this.readUInt16LE((length=>{this.readBuffer(2*length,(data=>{callback(data.toString("ucs2"))}))}))}readBVarByte(callback){this.readUInt8((length=>{this.readBuffer(length,callback)}))}readUsVarByte(callback){this.readUInt16LE((length=>{this.readBuffer(length,callback)}))}}var _default=Parser;exports.default=_default,module.exports=Parser;