"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Transaction=exports.OPERATION_TYPE=exports.ISOLATION_LEVEL=void 0,exports.assertValidIsolationLevel=assertValidIsolationLevel,exports.isolationLevelByValue=void 0;var _writableTrackingBuffer=_interopRequireDefault(require("./tracking-buffer/writable-tracking-buffer")),_allHeaders=require("./all-headers");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}const OPERATION_TYPE={TM_GET_DTC_ADDRESS:0,TM_PROPAGATE_XACT:1,TM_BEGIN_XACT:5,TM_PROMOTE_XACT:6,TM_COMMIT_XACT:7,TM_ROLLBACK_XACT:8,TM_SAVE_XACT:9};exports.OPERATION_TYPE=OPERATION_TYPE;const ISOLATION_LEVEL={NO_CHANGE:0,READ_UNCOMMITTED:1,READ_COMMITTED:2,REPEATABLE_READ:3,SERIALIZABLE:4,SNAPSHOT:5};exports.ISOLATION_LEVEL=ISOLATION_LEVEL;const isolationLevelByValue={};exports.isolationLevelByValue=isolationLevelByValue;for(const name in ISOLATION_LEVEL){const value=ISOLATION_LEVEL[name];isolationLevelByValue[value]=name}function assertValidIsolationLevel(isolationLevel,name){if("number"!=typeof isolationLevel)throw new TypeError(`The "${name}" ${name.includes(".")?"property":"argument"} must be of type number. Received type ${typeof isolationLevel} (${isolationLevel})`);if(!Number.isInteger(isolationLevel))throw new RangeError(`The value of "${name}" is out of range. It must be an integer. Received: ${isolationLevel}`);if(!(isolationLevel>=0&&isolationLevel<=5))throw new RangeError(`The value of "${name}" is out of range. It must be >= 0 && <= 5. Received: ${isolationLevel}`)}class Transaction{constructor(name,isolationLevel=ISOLATION_LEVEL.NO_CHANGE){this.name=void 0,this.isolationLevel=void 0,this.outstandingRequestCount=void 0,this.name=name,this.isolationLevel=isolationLevel,this.outstandingRequestCount=1}beginPayload(txnDescriptor){const buffer=new _writableTrackingBuffer.default(100,"ucs2");return(0,_allHeaders.writeToTrackingBuffer)(buffer,txnDescriptor,this.outstandingRequestCount),buffer.writeUShort(OPERATION_TYPE.TM_BEGIN_XACT),buffer.writeUInt8(this.isolationLevel),buffer.writeUInt8(2*this.name.length),buffer.writeString(this.name,"ucs2"),{*[Symbol.iterator](){yield buffer.data},toString:()=>"Begin Transaction: name="+this.name+", isolationLevel="+isolationLevelByValue[this.isolationLevel]}}commitPayload(txnDescriptor){const buffer=new _writableTrackingBuffer.default(100,"ascii");return(0,_allHeaders.writeToTrackingBuffer)(buffer,txnDescriptor,this.outstandingRequestCount),buffer.writeUShort(OPERATION_TYPE.TM_COMMIT_XACT),buffer.writeUInt8(2*this.name.length),buffer.writeString(this.name,"ucs2"),buffer.writeUInt8(0),{*[Symbol.iterator](){yield buffer.data},toString:()=>"Commit Transaction: name="+this.name}}rollbackPayload(txnDescriptor){const buffer=new _writableTrackingBuffer.default(100,"ascii");return(0,_allHeaders.writeToTrackingBuffer)(buffer,txnDescriptor,this.outstandingRequestCount),buffer.writeUShort(OPERATION_TYPE.TM_ROLLBACK_XACT),buffer.writeUInt8(2*this.name.length),buffer.writeString(this.name,"ucs2"),buffer.writeUInt8(0),{*[Symbol.iterator](){yield buffer.data},toString:()=>"Rollback Transaction: name="+this.name}}savePayload(txnDescriptor){const buffer=new _writableTrackingBuffer.default(100,"ascii");return(0,_allHeaders.writeToTrackingBuffer)(buffer,txnDescriptor,this.outstandingRequestCount),buffer.writeUShort(OPERATION_TYPE.TM_SAVE_XACT),buffer.writeUInt8(2*this.name.length),buffer.writeString(this.name,"ucs2"),{*[Symbol.iterator](){yield buffer.data},toString:()=>"Save Transaction: name="+this.name}}isolationLevelToTSQL(){switch(this.isolationLevel){case ISOLATION_LEVEL.READ_UNCOMMITTED:return"READ UNCOMMITTED";case ISOLATION_LEVEL.READ_COMMITTED:return"READ COMMITTED";case ISOLATION_LEVEL.REPEATABLE_READ:return"REPEATABLE READ";case ISOLATION_LEVEL.SERIALIZABLE:return"SERIALIZABLE";case ISOLATION_LEVEL.SNAPSHOT:return"SNAPSHOT"}return""}}exports.Transaction=Transaction;