"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _metadataParser=require("./metadata-parser"),_dataType=require("./data-type"),_iconvLite=_interopRequireDefault(require("iconv-lite")),_sprintfJs=require("sprintf-js"),_guidParser=require("./guid-parser");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}const NULL=65535,MAX=65535,THREE_AND_A_THIRD=3+1/3,MONEY_DIVISOR=1e4,PLP_NULL=Buffer.from([255,255,255,255,255,255,255,255]),UNKNOWN_PLP_LEN=Buffer.from([254,255,255,255,255,255,255,255]),DEFAULT_ENCODING="utf8";function readTinyInt(parser,callback){parser.readUInt8(callback)}function readSmallInt(parser,callback){parser.readInt16LE(callback)}function readInt(parser,callback){parser.readInt32LE(callback)}function readBigInt(parser,callback){parser.readBigInt64LE((value=>{callback(value.toString())}))}function readReal(parser,callback){parser.readFloatLE(callback)}function readFloat(parser,callback){parser.readDoubleLE(callback)}function readSmallMoney(parser,callback){parser.readInt32LE((value=>{callback(value/MONEY_DIVISOR)}))}function readMoney(parser,callback){parser.readInt32LE((high=>{parser.readUInt32LE((low=>{callback((low+4294967296*high)/MONEY_DIVISOR)}))}))}function readBit(parser,callback){parser.readUInt8((value=>{callback(!!value)}))}function valueParse(parser,metadata,options,callback){const type=metadata.type;switch(type.name){case"Null":return callback(null);case"TinyInt":return readTinyInt(parser,callback);case"SmallInt":return readSmallInt(parser,callback);case"Int":return readInt(parser,callback);case"BigInt":return readBigInt(parser,callback);case"IntN":return parser.readUInt8((dataLength=>{switch(dataLength){case 0:return callback(null);case 1:return readTinyInt(parser,callback);case 2:return readSmallInt(parser,callback);case 4:return readInt(parser,callback);case 8:return readBigInt(parser,callback);default:throw new Error("Unsupported dataLength "+dataLength+" for IntN")}}));case"Real":return readReal(parser,callback);case"Float":return readFloat(parser,callback);case"FloatN":return parser.readUInt8((dataLength=>{switch(dataLength){case 0:return callback(null);case 4:return readReal(parser,callback);case 8:return readFloat(parser,callback);default:throw new Error("Unsupported dataLength "+dataLength+" for FloatN")}}));case"SmallMoney":return readSmallMoney(parser,callback);case"Money":return readMoney(parser,callback);case"MoneyN":return parser.readUInt8((dataLength=>{switch(dataLength){case 0:return callback(null);case 4:return readSmallMoney(parser,callback);case 8:return readMoney(parser,callback);default:throw new Error("Unsupported dataLength "+dataLength+" for MoneyN")}}));case"Bit":return readBit(parser,callback);case"BitN":return parser.readUInt8((dataLength=>{switch(dataLength){case 0:return callback(null);case 1:return readBit(parser,callback);default:throw new Error("Unsupported dataLength "+dataLength+" for BitN")}}));case"VarChar":case"Char":const codepage=metadata.collation.codepage;return metadata.dataLength===MAX?readMaxChars(parser,codepage,callback):parser.readUInt16LE((dataLength=>{if(dataLength===NULL)return callback(null);readChars(parser,dataLength,codepage,callback)}));case"NVarChar":case"NChar":return metadata.dataLength===MAX?readMaxNChars(parser,callback):parser.readUInt16LE((dataLength=>{if(dataLength===NULL)return callback(null);readNChars(parser,dataLength,callback)}));case"VarBinary":case"Binary":return metadata.dataLength===MAX?readMaxBinary(parser,callback):parser.readUInt16LE((dataLength=>{if(dataLength===NULL)return callback(null);readBinary(parser,dataLength,callback)}));case"Text":return parser.readUInt8((textPointerLength=>{if(0===textPointerLength)return callback(null);parser.readBuffer(textPointerLength,(_textPointer=>{parser.readBuffer(8,(_timestamp=>{parser.readUInt32LE((dataLength=>{readChars(parser,dataLength,metadata.collation.codepage,callback)}))}))}))}));case"NText":return parser.readUInt8((textPointerLength=>{if(0===textPointerLength)return callback(null);parser.readBuffer(textPointerLength,(_textPointer=>{parser.readBuffer(8,(_timestamp=>{parser.readUInt32LE((dataLength=>{readNChars(parser,dataLength,callback)}))}))}))}));case"Image":return parser.readUInt8((textPointerLength=>{if(0===textPointerLength)return callback(null);parser.readBuffer(textPointerLength,(_textPointer=>{parser.readBuffer(8,(_timestamp=>{parser.readUInt32LE((dataLength=>{readBinary(parser,dataLength,callback)}))}))}))}));case"Xml":return readMaxNChars(parser,callback);case"SmallDateTime":return readSmallDateTime(parser,options.useUTC,callback);case"DateTime":return readDateTime(parser,options.useUTC,callback);case"DateTimeN":return parser.readUInt8((dataLength=>{switch(dataLength){case 0:return callback(null);case 4:return readSmallDateTime(parser,options.useUTC,callback);case 8:return readDateTime(parser,options.useUTC,callback);default:throw new Error("Unsupported dataLength "+dataLength+" for DateTimeN")}}));case"Time":return parser.readUInt8((dataLength=>0===dataLength?callback(null):readTime(parser,dataLength,metadata.scale,options.useUTC,callback)));case"Date":return parser.readUInt8((dataLength=>0===dataLength?callback(null):readDate(parser,options.useUTC,callback)));case"DateTime2":return parser.readUInt8((dataLength=>0===dataLength?callback(null):readDateTime2(parser,dataLength,metadata.scale,options.useUTC,callback)));case"DateTimeOffset":return parser.readUInt8((dataLength=>0===dataLength?callback(null):readDateTimeOffset(parser,dataLength,metadata.scale,callback)));case"NumericN":case"DecimalN":return parser.readUInt8((dataLength=>0===dataLength?callback(null):readNumeric(parser,dataLength,metadata.precision,metadata.scale,callback)));case"UniqueIdentifier":return parser.readUInt8((dataLength=>{switch(dataLength){case 0:return callback(null);case 16:return readUniqueIdentifier(parser,options,callback);default:throw new Error((0,_sprintfJs.sprintf)("Unsupported guid size %d",dataLength-1))}}));case"UDT":return readMaxBinary(parser,callback);case"Variant":return parser.readUInt32LE((dataLength=>{if(0===dataLength)return callback(null);readVariant(parser,options,dataLength,callback)}));default:throw new Error((0,_sprintfJs.sprintf)("Unrecognised type %s",type.name))}}function readUniqueIdentifier(parser,options,callback){parser.readBuffer(16,(data=>{callback(options.lowerCaseGuids?(0,_guidParser.bufferToLowerCaseGuid)(data):(0,_guidParser.bufferToUpperCaseGuid)(data))}))}function readNumeric(parser,dataLength,_precision,scale,callback){parser.readUInt8((sign=>{let readValue;if(sign=1===sign?1:-1,5===dataLength)readValue=parser.readUInt32LE;else if(9===dataLength)readValue=parser.readUNumeric64LE;else if(13===dataLength)readValue=parser.readUNumeric96LE;else{if(17!==dataLength)throw new Error((0,_sprintfJs.sprintf)("Unsupported numeric dataLength %d",dataLength));readValue=parser.readUNumeric128LE}readValue.call(parser,(value=>{callback(value*sign/Math.pow(10,scale))}))}))}function readVariant(parser,options,dataLength,callback){return parser.readUInt8((baseType=>{const type=_dataType.TYPE[baseType];return parser.readUInt8((propBytes=>{switch(dataLength=dataLength-propBytes-2,type.name){case"UniqueIdentifier":return readUniqueIdentifier(parser,options,callback);case"Bit":return readBit(parser,callback);case"TinyInt":return readTinyInt(parser,callback);case"SmallInt":return readSmallInt(parser,callback);case"Int":return readInt(parser,callback);case"BigInt":return readBigInt(parser,callback);case"SmallDateTime":return readSmallDateTime(parser,options.useUTC,callback);case"DateTime":return readDateTime(parser,options.useUTC,callback);case"Real":return readReal(parser,callback);case"Float":return readFloat(parser,callback);case"SmallMoney":return readSmallMoney(parser,callback);case"Money":return readMoney(parser,callback);case"Date":return readDate(parser,options.useUTC,callback);case"Time":return parser.readUInt8((scale=>readTime(parser,dataLength,scale,options.useUTC,callback)));case"DateTime2":return parser.readUInt8((scale=>readDateTime2(parser,dataLength,scale,options.useUTC,callback)));case"DateTimeOffset":return parser.readUInt8((scale=>readDateTimeOffset(parser,dataLength,scale,callback)));case"VarBinary":case"Binary":return parser.readUInt16LE((_maxLength=>{readBinary(parser,dataLength,callback)}));case"NumericN":case"DecimalN":return parser.readUInt8((precision=>{parser.readUInt8((scale=>{readNumeric(parser,dataLength,precision,scale,callback)}))}));case"VarChar":case"Char":return parser.readUInt16LE((_maxLength=>{(0,_metadataParser.readCollation)(parser,(collation=>{readChars(parser,dataLength,collation.codepage,callback)}))}));case"NVarChar":case"NChar":return parser.readUInt16LE((_maxLength=>{(0,_metadataParser.readCollation)(parser,(_collation=>{readNChars(parser,dataLength,callback)}))}));default:throw new Error("Invalid type!")}}))}))}function readBinary(parser,dataLength,callback){return parser.readBuffer(dataLength,callback)}function readChars(parser,dataLength,codepage,callback){return null==codepage&&(codepage=DEFAULT_ENCODING),parser.readBuffer(dataLength,(data=>{callback(_iconvLite.default.decode(data,codepage))}))}function readNChars(parser,dataLength,callback){parser.readBuffer(dataLength,(data=>{callback(data.toString("ucs2"))}))}function readMaxBinary(parser,callback){return readMax(parser,callback)}function readMaxChars(parser,codepage,callback){null==codepage&&(codepage=DEFAULT_ENCODING),readMax(parser,(data=>{callback(data?_iconvLite.default.decode(data,codepage):null)}))}function readMaxNChars(parser,callback){readMax(parser,(data=>{callback(data?data.toString("ucs2"):null)}))}function readMax(parser,callback){parser.readBuffer(8,(type=>{if(type.equals(PLP_NULL))return callback(null);if(type.equals(UNKNOWN_PLP_LEN))return readMaxUnknownLength(parser,callback);{const low=type.readUInt32LE(0),high=type.readUInt32LE(4);high>=2<<21&&console.warn("Read UInt64LE > 53 bits : high="+high+", low="+low);return readMaxKnownLength(parser,low+4294967296*high,callback)}}))}function readMaxKnownLength(parser,totalLength,callback){const data=Buffer.alloc(totalLength,0);let offset=0;function next(done){parser.readUInt32LE((chunkLength=>{if(!chunkLength)return done();parser.readBuffer(chunkLength,(chunk=>{chunk.copy(data,offset),offset+=chunkLength,next(done)}))}))}next((()=>{if(offset!==totalLength)throw new Error("Partially Length-prefixed Bytes unmatched lengths : expected "+totalLength+", but got "+offset+" bytes");callback(data)}))}function readMaxUnknownLength(parser,callback){const chunks=[];let length=0;function next(done){parser.readUInt32LE((chunkLength=>{if(!chunkLength)return done();parser.readBuffer(chunkLength,(chunk=>{chunks.push(chunk),length+=chunkLength,next(done)}))}))}next((()=>{callback(Buffer.concat(chunks,length))}))}function readSmallDateTime(parser,useUTC,callback){parser.readUInt16LE((days=>{parser.readUInt16LE((minutes=>{let value;value=useUTC?new Date(Date.UTC(1900,0,1+days,0,minutes)):new Date(1900,0,1+days,0,minutes),callback(value)}))}))}function readDateTime(parser,useUTC,callback){parser.readInt32LE((days=>{parser.readUInt32LE((threeHundredthsOfSecond=>{const milliseconds=Math.round(threeHundredthsOfSecond*THREE_AND_A_THIRD);let value;value=useUTC?new Date(Date.UTC(1900,0,1+days,0,0,0,milliseconds)):new Date(1900,0,1+days,0,0,0,milliseconds),callback(value)}))}))}function readTime(parser,dataLength,scale,useUTC,callback){let readValue;switch(dataLength){case 3:readValue=parser.readUInt24LE;break;case 4:readValue=parser.readUInt32LE;break;case 5:readValue=parser.readUInt40LE}readValue.call(parser,(value=>{if(scale<7)for(let i=scale;i<7;i++)value*=10;let date;date=useUTC?new Date(Date.UTC(1970,0,1,0,0,0,value/1e4)):new Date(1970,0,1,0,0,0,value/1e4),Object.defineProperty(date,"nanosecondsDelta",{enumerable:!1,value:value%1e4/Math.pow(10,7)}),callback(date)}))}function readDate(parser,useUTC,callback){parser.readUInt24LE((days=>{callback(useUTC?new Date(Date.UTC(2e3,0,days-730118)):new Date(2e3,0,days-730118))}))}function readDateTime2(parser,dataLength,scale,useUTC,callback){readTime(parser,dataLength-3,scale,useUTC,(time=>{parser.readUInt24LE((days=>{let date;date=useUTC?new Date(Date.UTC(2e3,0,days-730118,0,0,0,+time)):new Date(2e3,0,days-730118,time.getHours(),time.getMinutes(),time.getSeconds(),time.getMilliseconds()),Object.defineProperty(date,"nanosecondsDelta",{enumerable:!1,value:time.nanosecondsDelta}),callback(date)}))}))}function readDateTimeOffset(parser,dataLength,scale,callback){readTime(parser,dataLength-5,scale,!0,(time=>{parser.readUInt24LE((days=>{parser.readInt16LE((()=>{const date=new Date(Date.UTC(2e3,0,days-730118,0,0,0,+time));Object.defineProperty(date,"nanosecondsDelta",{enumerable:!1,value:time.nanosecondsDelta}),callback(date)}))}))}))}var _default=valueParse;exports.default=_default,module.exports=valueParse;