"use strict";var Buffer=require("safer-buffer").Buffer;exports._dbcs=DBCSCodec;for(var UNASSIGNED=-1,GB18030_CODE=-2,SEQ_START=-10,NODE_START=-1e3,UNASSIGNED_NODE=new Array(256),DEF_CHAR=-1,i=0;i<256;i++)UNASSIGNED_NODE[i]=UNASSIGNED;function DBCSCodec(codecOptions,iconv){if(this.encodingName=codecOptions.encodingName,!codecOptions)throw new Error("DBCS codec is called without the data.");if(!codecOptions.table)throw new Error("Encoding '"+this.encodingName+"' has no data.");var mappingTable=codecOptions.table();this.decodeTables=[],this.decodeTables[0]=UNASSIGNED_NODE.slice(0),this.decodeTableSeq=[];for(var i=0;i<mappingTable.length;i++)this._addDecodeChunk(mappingTable[i]);if("function"==typeof codecOptions.gb18030){this.gb18030=codecOptions.gb18030();var commonThirdByteNodeIdx=this.decodeTables.length;this.decodeTables.push(UNASSIGNED_NODE.slice(0));var commonFourthByteNodeIdx=this.decodeTables.length;this.decodeTables.push(UNASSIGNED_NODE.slice(0));var firstByteNode=this.decodeTables[0];for(i=129;i<=254;i++)for(var secondByteNode=this.decodeTables[NODE_START-firstByteNode[i]],j=48;j<=57;j++){if(secondByteNode[j]===UNASSIGNED)secondByteNode[j]=NODE_START-commonThirdByteNodeIdx;else if(secondByteNode[j]>NODE_START)throw new Error("gb18030 decode tables conflict at byte 2");for(var thirdByteNode=this.decodeTables[NODE_START-secondByteNode[j]],k=129;k<=254;k++){if(thirdByteNode[k]===UNASSIGNED)thirdByteNode[k]=NODE_START-commonFourthByteNodeIdx;else{if(thirdByteNode[k]===NODE_START-commonFourthByteNodeIdx)continue;if(thirdByteNode[k]>NODE_START)throw new Error("gb18030 decode tables conflict at byte 3")}for(var fourthByteNode=this.decodeTables[NODE_START-thirdByteNode[k]],l=48;l<=57;l++)fourthByteNode[l]===UNASSIGNED&&(fourthByteNode[l]=GB18030_CODE)}}}this.defaultCharUnicode=iconv.defaultCharUnicode,this.encodeTable=[],this.encodeTableSeq=[];var skipEncodeChars={};if(codecOptions.encodeSkipVals)for(i=0;i<codecOptions.encodeSkipVals.length;i++){var val=codecOptions.encodeSkipVals[i];if("number"==typeof val)skipEncodeChars[val]=!0;else for(j=val.from;j<=val.to;j++)skipEncodeChars[j]=!0}if(this._fillEncodeTable(0,0,skipEncodeChars),codecOptions.encodeAdd)for(var uChar in codecOptions.encodeAdd)Object.prototype.hasOwnProperty.call(codecOptions.encodeAdd,uChar)&&this._setEncodeChar(uChar.charCodeAt(0),codecOptions.encodeAdd[uChar]);this.defCharSB=this.encodeTable[0][iconv.defaultCharSingleByte.charCodeAt(0)],this.defCharSB===UNASSIGNED&&(this.defCharSB=this.encodeTable[0]["?"]),this.defCharSB===UNASSIGNED&&(this.defCharSB="?".charCodeAt(0))}function DBCSEncoder(options,codec){this.leadSurrogate=-1,this.seqObj=void 0,this.encodeTable=codec.encodeTable,this.encodeTableSeq=codec.encodeTableSeq,this.defaultCharSingleByte=codec.defCharSB,this.gb18030=codec.gb18030}function DBCSDecoder(options,codec){this.nodeIdx=0,this.prevBytes=[],this.decodeTables=codec.decodeTables,this.decodeTableSeq=codec.decodeTableSeq,this.defaultCharUnicode=codec.defaultCharUnicode,this.gb18030=codec.gb18030}function findIdx(table,val){if(table[0]>val)return-1;for(var l=0,r=table.length;l<r-1;){var mid=l+(r-l+1>>1);table[mid]<=val?l=mid:r=mid}return l}DBCSCodec.prototype.encoder=DBCSEncoder,DBCSCodec.prototype.decoder=DBCSDecoder,DBCSCodec.prototype._getDecodeTrieNode=function(addr){for(var bytes=[];addr>0;addr>>>=8)bytes.push(255&addr);0==bytes.length&&bytes.push(0);for(var node=this.decodeTables[0],i=bytes.length-1;i>0;i--){var val=node[bytes[i]];if(val==UNASSIGNED)node[bytes[i]]=NODE_START-this.decodeTables.length,this.decodeTables.push(node=UNASSIGNED_NODE.slice(0));else{if(!(val<=NODE_START))throw new Error("Overwrite byte in "+this.encodingName+", addr: "+addr.toString(16));node=this.decodeTables[NODE_START-val]}}return node},DBCSCodec.prototype._addDecodeChunk=function(chunk){var curAddr=parseInt(chunk[0],16),writeTable=this._getDecodeTrieNode(curAddr);curAddr&=255;for(var k=1;k<chunk.length;k++){var part=chunk[k];if("string"==typeof part)for(var l=0;l<part.length;){var code=part.charCodeAt(l++);if(55296<=code&&code<56320){var codeTrail=part.charCodeAt(l++);if(!(56320<=codeTrail&&codeTrail<57344))throw new Error("Incorrect surrogate pair in "+this.encodingName+" at chunk "+chunk[0]);writeTable[curAddr++]=65536+1024*(code-55296)+(codeTrail-56320)}else if(4080<code&&code<=4095){for(var len=4095-code+2,seq=[],m=0;m<len;m++)seq.push(part.charCodeAt(l++));writeTable[curAddr++]=SEQ_START-this.decodeTableSeq.length,this.decodeTableSeq.push(seq)}else writeTable[curAddr++]=code}else{if("number"!=typeof part)throw new Error("Incorrect type '"+typeof part+"' given in "+this.encodingName+" at chunk "+chunk[0]);var charCode=writeTable[curAddr-1]+1;for(l=0;l<part;l++)writeTable[curAddr++]=charCode++}}if(curAddr>255)throw new Error("Incorrect chunk in "+this.encodingName+" at addr "+chunk[0]+": too long"+curAddr)},DBCSCodec.prototype._getEncodeBucket=function(uCode){var high=uCode>>8;return void 0===this.encodeTable[high]&&(this.encodeTable[high]=UNASSIGNED_NODE.slice(0)),this.encodeTable[high]},DBCSCodec.prototype._setEncodeChar=function(uCode,dbcsCode){var bucket=this._getEncodeBucket(uCode),low=255&uCode;bucket[low]<=SEQ_START?this.encodeTableSeq[SEQ_START-bucket[low]][DEF_CHAR]=dbcsCode:bucket[low]==UNASSIGNED&&(bucket[low]=dbcsCode)},DBCSCodec.prototype._setEncodeSequence=function(seq,dbcsCode){var node,uCode=seq[0],bucket=this._getEncodeBucket(uCode),low=255&uCode;bucket[low]<=SEQ_START?node=this.encodeTableSeq[SEQ_START-bucket[low]]:(node={},bucket[low]!==UNASSIGNED&&(node[DEF_CHAR]=bucket[low]),bucket[low]=SEQ_START-this.encodeTableSeq.length,this.encodeTableSeq.push(node));for(var j=1;j<seq.length-1;j++){var oldVal=node[uCode];"object"==typeof oldVal?node=oldVal:(node=node[uCode]={},void 0!==oldVal&&(node[DEF_CHAR]=oldVal))}node[uCode=seq[seq.length-1]]=dbcsCode},DBCSCodec.prototype._fillEncodeTable=function(nodeIdx,prefix,skipEncodeChars){for(var node=this.decodeTables[nodeIdx],hasValues=!1,subNodeEmpty={},i=0;i<256;i++){var uCode=node[i],mbCode=prefix+i;if(!skipEncodeChars[mbCode])if(uCode>=0)this._setEncodeChar(uCode,mbCode),hasValues=!0;else if(uCode<=NODE_START){var subNodeIdx=NODE_START-uCode;if(!subNodeEmpty[subNodeIdx]){var newPrefix=mbCode<<8>>>0;this._fillEncodeTable(subNodeIdx,newPrefix,skipEncodeChars)?hasValues=!0:subNodeEmpty[subNodeIdx]=!0}}else uCode<=SEQ_START&&(this._setEncodeSequence(this.decodeTableSeq[SEQ_START-uCode],mbCode),hasValues=!0)}return hasValues},DBCSEncoder.prototype.write=function(str){for(var newBuf=Buffer.alloc(str.length*(this.gb18030?4:3)),leadSurrogate=this.leadSurrogate,seqObj=this.seqObj,nextChar=-1,i=0,j=0;;){if(-1===nextChar){if(i==str.length)break;var uCode=str.charCodeAt(i++)}else{uCode=nextChar;nextChar=-1}if(55296<=uCode&&uCode<57344)if(uCode<56320){if(-1===leadSurrogate){leadSurrogate=uCode;continue}leadSurrogate=uCode,uCode=UNASSIGNED}else-1!==leadSurrogate?(uCode=65536+1024*(leadSurrogate-55296)+(uCode-56320),leadSurrogate=-1):uCode=UNASSIGNED;else-1!==leadSurrogate&&(nextChar=uCode,uCode=UNASSIGNED,leadSurrogate=-1);var dbcsCode=UNASSIGNED;if(void 0!==seqObj&&uCode!=UNASSIGNED){var resCode=seqObj[uCode];if("object"==typeof resCode){seqObj=resCode;continue}"number"==typeof resCode?dbcsCode=resCode:null==resCode&&void 0!==(resCode=seqObj[DEF_CHAR])&&(dbcsCode=resCode,nextChar=uCode),seqObj=void 0}else if(uCode>=0){var subtable=this.encodeTable[uCode>>8];if(void 0!==subtable&&(dbcsCode=subtable[255&uCode]),dbcsCode<=SEQ_START){seqObj=this.encodeTableSeq[SEQ_START-dbcsCode];continue}if(dbcsCode==UNASSIGNED&&this.gb18030){var idx=findIdx(this.gb18030.uChars,uCode);if(-1!=idx){dbcsCode=this.gb18030.gbChars[idx]+(uCode-this.gb18030.uChars[idx]);newBuf[j++]=129+Math.floor(dbcsCode/12600),dbcsCode%=12600,newBuf[j++]=48+Math.floor(dbcsCode/1260),dbcsCode%=1260,newBuf[j++]=129+Math.floor(dbcsCode/10),dbcsCode%=10,newBuf[j++]=48+dbcsCode;continue}}}dbcsCode===UNASSIGNED&&(dbcsCode=this.defaultCharSingleByte),dbcsCode<256?newBuf[j++]=dbcsCode:dbcsCode<65536?(newBuf[j++]=dbcsCode>>8,newBuf[j++]=255&dbcsCode):dbcsCode<16777216?(newBuf[j++]=dbcsCode>>16,newBuf[j++]=dbcsCode>>8&255,newBuf[j++]=255&dbcsCode):(newBuf[j++]=dbcsCode>>>24,newBuf[j++]=dbcsCode>>>16&255,newBuf[j++]=dbcsCode>>>8&255,newBuf[j++]=255&dbcsCode)}return this.seqObj=seqObj,this.leadSurrogate=leadSurrogate,newBuf.slice(0,j)},DBCSEncoder.prototype.end=function(){if(-1!==this.leadSurrogate||void 0!==this.seqObj){var newBuf=Buffer.alloc(10),j=0;if(this.seqObj){var dbcsCode=this.seqObj[DEF_CHAR];void 0!==dbcsCode&&(dbcsCode<256?newBuf[j++]=dbcsCode:(newBuf[j++]=dbcsCode>>8,newBuf[j++]=255&dbcsCode)),this.seqObj=void 0}return-1!==this.leadSurrogate&&(newBuf[j++]=this.defaultCharSingleByte,this.leadSurrogate=-1),newBuf.slice(0,j)}},DBCSEncoder.prototype.findIdx=findIdx,DBCSDecoder.prototype.write=function(buf){for(var newBuf=Buffer.alloc(2*buf.length),nodeIdx=this.nodeIdx,prevBytes=this.prevBytes,prevOffset=this.prevBytes.length,seqStart=-this.prevBytes.length,i=0,j=0;i<buf.length;i++){var uCode,curByte=i>=0?buf[i]:prevBytes[i+prevOffset];if((uCode=this.decodeTables[nodeIdx][curByte])>=0);else if(uCode===UNASSIGNED)uCode=this.defaultCharUnicode.charCodeAt(0),i=seqStart;else if(uCode===GB18030_CODE){if(i>=3)var ptr=12600*(buf[i-3]-129)+1260*(buf[i-2]-48)+10*(buf[i-1]-129)+(curByte-48);else ptr=12600*(prevBytes[i-3+prevOffset]-129)+1260*((i-2>=0?buf[i-2]:prevBytes[i-2+prevOffset])-48)+10*((i-1>=0?buf[i-1]:prevBytes[i-1+prevOffset])-129)+(curByte-48);var idx=findIdx(this.gb18030.gbChars,ptr);uCode=this.gb18030.uChars[idx]+ptr-this.gb18030.gbChars[idx]}else{if(uCode<=NODE_START){nodeIdx=NODE_START-uCode;continue}if(!(uCode<=SEQ_START))throw new Error("iconv-lite internal error: invalid decoding table value "+uCode+" at "+nodeIdx+"/"+curByte);for(var seq=this.decodeTableSeq[SEQ_START-uCode],k=0;k<seq.length-1;k++)uCode=seq[k],newBuf[j++]=255&uCode,newBuf[j++]=uCode>>8;uCode=seq[seq.length-1]}if(uCode>=65536){var uCodeLead=55296|(uCode-=65536)>>10;newBuf[j++]=255&uCodeLead,newBuf[j++]=uCodeLead>>8,uCode=56320|1023&uCode}newBuf[j++]=255&uCode,newBuf[j++]=uCode>>8,nodeIdx=0,seqStart=i+1}return this.nodeIdx=nodeIdx,this.prevBytes=seqStart>=0?Array.prototype.slice.call(buf,seqStart):prevBytes.slice(seqStart+prevOffset).concat(Array.prototype.slice.call(buf)),newBuf.slice(0,j).toString("ucs2")},DBCSDecoder.prototype.end=function(){for(var ret="";this.prevBytes.length>0;){ret+=this.defaultCharUnicode;var bytesArr=this.prevBytes.slice(1);this.prevBytes=[],this.nodeIdx=0,bytesArr.length>0&&(ret+=this.write(bytesArr))}return this.prevBytes=[],this.nodeIdx=0,ret};