"use strict";var Buffer=require("safer-buffer").Buffer;function Utf32Codec(codecOptions,iconv){this.iconv=iconv,this.bomAware=!0,this.isLE=codecOptions.isLE}function Utf32Encoder(options,codec){this.isLE=codec.isLE,this.highSurrogate=0}function Utf32Decoder(options,codec){this.isLE=codec.isLE,this.badChar=codec.iconv.defaultCharUnicode.charCodeAt(0),this.overflow=[]}function _writeCodepoint(dst,offset,codepoint,badChar){if((codepoint<0||codepoint>1114111)&&(codepoint=badChar),codepoint>=65536){var high=55296|(codepoint-=65536)>>10;dst[offset++]=255&high,dst[offset++]=high>>8;codepoint=56320|1023&codepoint}return dst[offset++]=255&codepoint,dst[offset++]=codepoint>>8,offset}function Utf32AutoCodec(options,iconv){this.iconv=iconv}function Utf32AutoEncoder(options,codec){void 0===(options=options||{}).addBOM&&(options.addBOM=!0),this.encoder=codec.iconv.getEncoder(options.defaultEncoding||"utf-32le",options)}function Utf32AutoDecoder(options,codec){this.decoder=null,this.initialBufs=[],this.initialBufsLen=0,this.options=options||{},this.iconv=codec.iconv}function detectEncoding(bufs,defaultEncoding){var b=[],charsProcessed=0,invalidLE=0,invalidBE=0,bmpCharsLE=0,bmpCharsBE=0;outer_loop:for(var i=0;i<bufs.length;i++)for(var buf=bufs[i],j=0;j<buf.length;j++)if(b.push(buf[j]),4===b.length){if(0===charsProcessed){if(255===b[0]&&254===b[1]&&0===b[2]&&0===b[3])return"utf-32le";if(0===b[0]&&0===b[1]&&254===b[2]&&255===b[3])return"utf-32be"}if((0!==b[0]||b[1]>16)&&invalidBE++,(0!==b[3]||b[2]>16)&&invalidLE++,0!==b[0]||0!==b[1]||0===b[2]&&0===b[3]||bmpCharsBE++,0===b[0]&&0===b[1]||0!==b[2]||0!==b[3]||bmpCharsLE++,b.length=0,++charsProcessed>=100)break outer_loop}return bmpCharsBE-invalidBE>bmpCharsLE-invalidLE?"utf-32be":bmpCharsBE-invalidBE<bmpCharsLE-invalidLE?"utf-32le":defaultEncoding||"utf-32le"}exports._utf32=Utf32Codec,exports.utf32le={type:"_utf32",isLE:!0},exports.utf32be={type:"_utf32",isLE:!1},exports.ucs4le="utf32le",exports.ucs4be="utf32be",Utf32Codec.prototype.encoder=Utf32Encoder,Utf32Codec.prototype.decoder=Utf32Decoder,Utf32Encoder.prototype.write=function(str){for(var src=Buffer.from(str,"ucs2"),dst=Buffer.alloc(2*src.length),write32=this.isLE?dst.writeUInt32LE:dst.writeUInt32BE,offset=0,i=0;i<src.length;i+=2){var code=src.readUInt16LE(i),isHighSurrogate=55296<=code&&code<56320,isLowSurrogate=56320<=code&&code<57344;if(this.highSurrogate){if(!isHighSurrogate&&isLowSurrogate){var codepoint=65536+(this.highSurrogate-55296<<10|code-56320);write32.call(dst,codepoint,offset),offset+=4,this.highSurrogate=0;continue}write32.call(dst,this.highSurrogate,offset),offset+=4}isHighSurrogate?this.highSurrogate=code:(write32.call(dst,code,offset),offset+=4,this.highSurrogate=0)}return offset<dst.length&&(dst=dst.slice(0,offset)),dst},Utf32Encoder.prototype.end=function(){if(this.highSurrogate){var buf=Buffer.alloc(4);return this.isLE?buf.writeUInt32LE(this.highSurrogate,0):buf.writeUInt32BE(this.highSurrogate,0),this.highSurrogate=0,buf}},Utf32Decoder.prototype.write=function(src){if(0===src.length)return"";var i=0,codepoint=0,dst=Buffer.alloc(src.length+4),offset=0,isLE=this.isLE,overflow=this.overflow,badChar=this.badChar;if(overflow.length>0){for(;i<src.length&&overflow.length<4;i++)overflow.push(src[i]);4===overflow.length&&(codepoint=isLE?overflow[i]|overflow[i+1]<<8|overflow[i+2]<<16|overflow[i+3]<<24:overflow[i+3]|overflow[i+2]<<8|overflow[i+1]<<16|overflow[i]<<24,overflow.length=0,offset=_writeCodepoint(dst,offset,codepoint,badChar))}for(;i<src.length-3;i+=4)offset=_writeCodepoint(dst,offset,codepoint=isLE?src[i]|src[i+1]<<8|src[i+2]<<16|src[i+3]<<24:src[i+3]|src[i+2]<<8|src[i+1]<<16|src[i]<<24,badChar);for(;i<src.length;i++)overflow.push(src[i]);return dst.slice(0,offset).toString("ucs2")},Utf32Decoder.prototype.end=function(){this.overflow.length=0},exports.utf32=Utf32AutoCodec,exports.ucs4="utf32",Utf32AutoCodec.prototype.encoder=Utf32AutoEncoder,Utf32AutoCodec.prototype.decoder=Utf32AutoDecoder,Utf32AutoEncoder.prototype.write=function(str){return this.encoder.write(str)},Utf32AutoEncoder.prototype.end=function(){return this.encoder.end()},Utf32AutoDecoder.prototype.write=function(buf){if(!this.decoder){if(this.initialBufs.push(buf),this.initialBufsLen+=buf.length,this.initialBufsLen<32)return"";var encoding=detectEncoding(this.initialBufs,this.options.defaultEncoding);this.decoder=this.iconv.getDecoder(encoding,this.options);for(var resStr="",i=0;i<this.initialBufs.length;i++)resStr+=this.decoder.write(this.initialBufs[i]);return this.initialBufs.length=this.initialBufsLen=0,resStr}return this.decoder.write(buf)},Utf32AutoDecoder.prototype.end=function(){if(!this.decoder){var encoding=detectEncoding(this.initialBufs,this.options.defaultEncoding);this.decoder=this.iconv.getDecoder(encoding,this.options);for(var resStr="",i=0;i<this.initialBufs.length;i++)resStr+=this.decoder.write(this.initialBufs[i]);var trail=this.decoder.end();return trail&&(resStr+=trail),this.initialBufs.length=this.initialBufsLen=0,resStr}return this.decoder.end()};