"use strict";var test=require("tape"),typedArrayLength=require("../"),isCallable=require("is-callable"),generators=require("make-generator-function")(),arrowFn=require("make-arrow-function")(),forEach=require("for-each"),inspect=require("object-inspect"),typedArrayNames=["Int8Array","Uint8Array","Uint8ClampedArray","Int16Array","Uint16Array","Int32Array","Uint32Array","Float32Array","Float64Array","BigInt64Array","BigUint64Array"];test("not arrays",(function(t){t.test("non-number/string primitives",(function(st){st.equal(!1,typedArrayLength(),"undefined is not typed array"),st.equal(!1,typedArrayLength(null),"null is not typed array"),st.equal(!1,typedArrayLength(!1),"false is not typed array"),st.equal(!1,typedArrayLength(!0),"true is not typed array"),st.end()})),t.equal(!1,typedArrayLength({}),"object is not typed array"),t.equal(!1,typedArrayLength(/a/g),"regex literal is not typed array"),t.equal(!1,typedArrayLength(new RegExp("a","g")),"regex object is not typed array"),t.equal(!1,typedArrayLength(new Date),"new Date() is not typed array"),t.test("numbers",(function(st){st.equal(!1,typedArrayLength(42),"number is not typed array"),st.equal(!1,typedArrayLength(Object(42)),"number object is not typed array"),st.equal(!1,typedArrayLength(NaN),"NaN is not typed array"),st.equal(!1,typedArrayLength(1/0),"Infinity is not typed array"),st.end()})),t.test("strings",(function(st){st.equal(!1,typedArrayLength("foo"),"string primitive is not typed array"),st.equal(!1,typedArrayLength(Object("foo")),"string object is not typed array"),st.end()})),t.end()})),test("Functions",(function(t){t.equal(!1,typedArrayLength((function(){})),"function is not typed array"),t.end()})),test("Generators",{skip:0===generators.length},(function(t){forEach(generators,(function(genFn){t.equal(!1,typedArrayLength(genFn),"generator function "+inspect(genFn)+" is not typed array")})),t.end()})),test("Arrow functions",{skip:!arrowFn},(function(t){t.equal(!1,typedArrayLength(arrowFn),"arrow function is not typed array"),t.end()})),test("Typed Arrays",(function(t){forEach(typedArrayNames,(function(typedArray){var TypedArray=global[typedArray];if(isCallable(TypedArray)){var length=10,arr=new TypedArray(length);t.equal(typedArrayLength(arr),length,"new "+typedArray+"(10) is typed array of length "+length)}else t.comment("# SKIP "+typedArray+" is not supported")})),t.end()}));