"use strict";var test=require("tape"),whichTypedArray=require("../"),isCallable=require("is-callable"),hasToStringTag=require("has-tostringtag/shams")(),generators=require("make-generator-function")(),arrows=require("make-arrow-function").list(),forEach=require("for-each"),typedArrayNames=["Int8Array","Uint8Array","Uint8ClampedArray","Int16Array","Uint16Array","Int32Array","Uint32Array","Float32Array","Float64Array","BigInt64Array","BigUint64Array"];test("not arrays",(function(t){t.test("non-number/string primitives",(function(st){st.equal(!1,whichTypedArray(),"undefined is not typed array"),st.equal(!1,whichTypedArray(null),"null is not typed array"),st.equal(!1,whichTypedArray(!1),"false is not typed array"),st.equal(!1,whichTypedArray(!0),"true is not typed array"),st.end()})),t.equal(!1,whichTypedArray({}),"object is not typed array"),t.equal(!1,whichTypedArray(/a/g),"regex literal is not typed array"),t.equal(!1,whichTypedArray(new RegExp("a","g")),"regex object is not typed array"),t.equal(!1,whichTypedArray(new Date),"new Date() is not typed array"),t.test("numbers",(function(st){st.equal(!1,whichTypedArray(42),"number is not typed array"),st.equal(!1,whichTypedArray(Object(42)),"number object is not typed array"),st.equal(!1,whichTypedArray(NaN),"NaN is not typed array"),st.equal(!1,whichTypedArray(1/0),"Infinity is not typed array"),st.end()})),t.test("strings",(function(st){st.equal(!1,whichTypedArray("foo"),"string primitive is not typed array"),st.equal(!1,whichTypedArray(Object("foo")),"string object is not typed array"),st.end()})),t.end()})),test("Functions",(function(t){t.equal(!1,whichTypedArray((function(){})),"function is not typed array"),t.end()})),test("Generators",{skip:0===generators.length},(function(t){forEach(generators,(function(genFn){t.equal(!1,whichTypedArray(genFn),"generator function "+genFn+" is not typed array")})),t.end()})),test("Arrow functions",{skip:0===arrows.length},(function(t){forEach(arrows,(function(arrowFn){t.equal(!1,whichTypedArray(arrowFn),"arrow function "+arrowFn+" is not typed array")})),t.end()})),test("@@toStringTag",{skip:!hasToStringTag},(function(t){forEach(typedArrayNames,(function(typedArray){if("function"==typeof global[typedArray]){var fakeTypedArray=[];fakeTypedArray[Symbol.toStringTag]=typedArray,t.equal(!1,whichTypedArray(fakeTypedArray),"faked "+typedArray+" is not typed array")}else t.comment("# SKIP "+typedArray+" is not supported")})),t.end()})),test("Typed Arrays",(function(t){forEach(typedArrayNames,(function(typedArray){var TypedArray=global[typedArray];if(isCallable(TypedArray)){var arr=new TypedArray(10);t.equal(typedArray,whichTypedArray(arr),"new "+typedArray+"(10) is typed array of type "+typedArray)}else t.comment("# SKIP "+typedArray+" is not supported")})),t.end()}));