import{XML_CHARKEY}from"./interfaces";import{RestError}from"@azure/core-rest-pipeline";import{MapperTypeNames}from"./serializer";import{getOperationRequestInfo}from"./operationHelpers";const defaultJsonContentTypes=["application/json","text/json"],defaultXmlContentTypes=["application/xml","application/atom+xml"];export const deserializationPolicyName="deserializationPolicy";export function deserializationPolicy(options={}){var _a,_b,_c,_d,_e,_f,_g;const jsonContentTypes=null!==(_b=null===(_a=options.expectedContentTypes)||void 0===_a?void 0:_a.json)&&void 0!==_b?_b:defaultJsonContentTypes,xmlContentTypes=null!==(_d=null===(_c=options.expectedContentTypes)||void 0===_c?void 0:_c.xml)&&void 0!==_d?_d:defaultXmlContentTypes,parseXML=options.parseXML,serializerOptions=options.serializerOptions,updatedOptions={xml:{rootName:null!==(_e=null==serializerOptions?void 0:serializerOptions.xml.rootName)&&void 0!==_e?_e:"",includeRoot:null!==(_f=null==serializerOptions?void 0:serializerOptions.xml.includeRoot)&&void 0!==_f&&_f,xmlCharKey:null!==(_g=null==serializerOptions?void 0:serializerOptions.xml.xmlCharKey)&&void 0!==_g?_g:XML_CHARKEY}};return{name:deserializationPolicyName,async sendRequest(request,next){const response=await next(request);return deserializeResponseBody(jsonContentTypes,xmlContentTypes,response,updatedOptions,parseXML)}}}function getOperationResponseMap(parsedResponse){let result;const request=parsedResponse.request,operationInfo=getOperationRequestInfo(request),operationSpec=null==operationInfo?void 0:operationInfo.operationSpec;return operationSpec&&(result=(null==operationInfo?void 0:operationInfo.operationResponseGetter)?null==operationInfo?void 0:operationInfo.operationResponseGetter(operationSpec,parsedResponse):operationSpec.responses[parsedResponse.status]),result}function shouldDeserializeResponse(parsedResponse){const request=parsedResponse.request,operationInfo=getOperationRequestInfo(request),shouldDeserialize=null==operationInfo?void 0:operationInfo.shouldDeserialize;let result;return result=void 0===shouldDeserialize||("boolean"==typeof shouldDeserialize?shouldDeserialize:shouldDeserialize(parsedResponse)),result}async function deserializeResponseBody(jsonContentTypes,xmlContentTypes,response,options,parseXML){const parsedResponse=await parse(jsonContentTypes,xmlContentTypes,response,options,parseXML);if(!shouldDeserializeResponse(parsedResponse))return parsedResponse;const operationInfo=getOperationRequestInfo(parsedResponse.request),operationSpec=null==operationInfo?void 0:operationInfo.operationSpec;if(!operationSpec||!operationSpec.responses)return parsedResponse;const responseSpec=getOperationResponseMap(parsedResponse),{error:error,shouldReturnResponse:shouldReturnResponse}=handleErrorResponse(parsedResponse,operationSpec,responseSpec,options);if(error)throw error;if(shouldReturnResponse)return parsedResponse;if(responseSpec){if(responseSpec.bodyMapper){let valueToDeserialize=parsedResponse.parsedBody;operationSpec.isXML&&responseSpec.bodyMapper.type.name===MapperTypeNames.Sequence&&(valueToDeserialize="object"==typeof valueToDeserialize?valueToDeserialize[responseSpec.bodyMapper.xmlElementName]:[]);try{parsedResponse.parsedBody=operationSpec.serializer.deserialize(responseSpec.bodyMapper,valueToDeserialize,"operationRes.parsedBody",options)}catch(deserializeError){throw new RestError(`Error ${deserializeError} occurred in deserializing the responseBody - ${parsedResponse.bodyAsText}`,{statusCode:parsedResponse.status,request:parsedResponse.request,response:parsedResponse})}}else"HEAD"===operationSpec.httpMethod&&(parsedResponse.parsedBody=response.status>=200&&response.status<300);responseSpec.headersMapper&&(parsedResponse.parsedHeaders=operationSpec.serializer.deserialize(responseSpec.headersMapper,parsedResponse.headers.toJSON(),"operationRes.parsedHeaders",{xml:{},ignoreUnknownProperties:!0}))}return parsedResponse}function isOperationSpecEmpty(operationSpec){const expectedStatusCodes=Object.keys(operationSpec.responses);return 0===expectedStatusCodes.length||1===expectedStatusCodes.length&&"default"===expectedStatusCodes[0]}function handleErrorResponse(parsedResponse,operationSpec,responseSpec,options){var _a;const isSuccessByStatus=200<=parsedResponse.status&&parsedResponse.status<300;if(isOperationSpecEmpty(operationSpec)?isSuccessByStatus:!!responseSpec){if(!responseSpec)return{error:null,shouldReturnResponse:!1};if(!responseSpec.isError)return{error:null,shouldReturnResponse:!1}}const errorResponseSpec=null!=responseSpec?responseSpec:operationSpec.responses.default,initialErrorMessage=(null===(_a=parsedResponse.request.streamResponseStatusCodes)||void 0===_a?void 0:_a.has(parsedResponse.status))?`Unexpected status code: ${parsedResponse.status}`:parsedResponse.bodyAsText,error=new RestError(initialErrorMessage,{statusCode:parsedResponse.status,request:parsedResponse.request,response:parsedResponse});if(!errorResponseSpec)throw error;const defaultBodyMapper=errorResponseSpec.bodyMapper,defaultHeadersMapper=errorResponseSpec.headersMapper;try{if(parsedResponse.parsedBody){const parsedBody=parsedResponse.parsedBody;let deserializedError;if(defaultBodyMapper){let valueToDeserialize=parsedBody;if(operationSpec.isXML&&defaultBodyMapper.type.name===MapperTypeNames.Sequence){valueToDeserialize=[];const elementName=defaultBodyMapper.xmlElementName;"object"==typeof parsedBody&&elementName&&(valueToDeserialize=parsedBody[elementName])}deserializedError=operationSpec.serializer.deserialize(defaultBodyMapper,valueToDeserialize,"error.response.parsedBody",options)}const internalError=parsedBody.error||deserializedError||parsedBody;error.code=internalError.code,internalError.message&&(error.message=internalError.message),defaultBodyMapper&&(error.response.parsedBody=deserializedError)}parsedResponse.headers&&defaultHeadersMapper&&(error.response.parsedHeaders=operationSpec.serializer.deserialize(defaultHeadersMapper,parsedResponse.headers.toJSON(),"operationRes.parsedHeaders"))}catch(defaultError){error.message=`Error "${defaultError.message}" occurred in deserializing the responseBody - "${parsedResponse.bodyAsText}" for the default response.`}return{error:error,shouldReturnResponse:!1}}async function parse(jsonContentTypes,xmlContentTypes,operationResponse,opts,parseXML){var _a;if(!(null===(_a=operationResponse.request.streamResponseStatusCodes)||void 0===_a?void 0:_a.has(operationResponse.status))&&operationResponse.bodyAsText){const text=operationResponse.bodyAsText,contentType=operationResponse.headers.get("Content-Type")||"",contentComponents=contentType?contentType.split(";").map((component=>component.toLowerCase())):[];try{if(0===contentComponents.length||contentComponents.some((component=>-1!==jsonContentTypes.indexOf(component))))return operationResponse.parsedBody=JSON.parse(text),operationResponse;if(contentComponents.some((component=>-1!==xmlContentTypes.indexOf(component)))){if(!parseXML)throw new Error("Parsing XML not supported.");const body=await parseXML(text,opts.xml);return operationResponse.parsedBody=body,operationResponse}}catch(err){const msg=`Error "${err}" occurred while parsing the response body - ${operationResponse.bodyAsText}.`,errCode=err.code||RestError.PARSE_ERROR;throw new RestError(msg,{code:errCode,statusCode:operationResponse.status,request:operationResponse.request,response:operationResponse})}}return operationResponse}