import{XML_ATTRKEY,XML_CHARKEY}from"./interfaces";import{getOperationArgumentValueFromParameter,getOperationRequestInfo}from"./operationHelpers";import{MapperTypeNames}from"./serializer";import{getPathStringFromParameter}from"./interfaceHelpers";export const serializationPolicyName="serializationPolicy";export function serializationPolicy(options={}){const stringifyXML=options.stringifyXML;return{name:serializationPolicyName,async sendRequest(request,next){const operationInfo=getOperationRequestInfo(request),operationSpec=null==operationInfo?void 0:operationInfo.operationSpec,operationArguments=null==operationInfo?void 0:operationInfo.operationArguments;return operationSpec&&operationArguments&&(serializeHeaders(request,operationArguments,operationSpec),serializeRequestBody(request,operationArguments,operationSpec,stringifyXML)),next(request)}}}export function serializeHeaders(request,operationArguments,operationSpec){var _a,_b;if(operationSpec.headerParameters)for(const headerParameter of operationSpec.headerParameters){let headerValue=getOperationArgumentValueFromParameter(operationArguments,headerParameter);if(null!=headerValue||headerParameter.mapper.required){headerValue=operationSpec.serializer.serialize(headerParameter.mapper,headerValue,getPathStringFromParameter(headerParameter));const headerCollectionPrefix=headerParameter.mapper.headerCollectionPrefix;if(headerCollectionPrefix)for(const key of Object.keys(headerValue))request.headers.set(headerCollectionPrefix+key,headerValue[key]);else request.headers.set(headerParameter.mapper.serializedName||getPathStringFromParameter(headerParameter),headerValue)}}const customHeaders=null===(_b=null===(_a=operationArguments.options)||void 0===_a?void 0:_a.requestOptions)||void 0===_b?void 0:_b.customHeaders;if(customHeaders)for(const customHeaderName of Object.keys(customHeaders))request.headers.set(customHeaderName,customHeaders[customHeaderName])}export function serializeRequestBody(request,operationArguments,operationSpec,stringifyXML=function(){throw new Error("XML serialization unsupported!")}){var _a,_b,_c,_d,_e;const serializerOptions=null===(_a=operationArguments.options)||void 0===_a?void 0:_a.serializerOptions,updatedOptions={xml:{rootName:null!==(_b=null==serializerOptions?void 0:serializerOptions.xml.rootName)&&void 0!==_b?_b:"",includeRoot:null!==(_c=null==serializerOptions?void 0:serializerOptions.xml.includeRoot)&&void 0!==_c&&_c,xmlCharKey:null!==(_d=null==serializerOptions?void 0:serializerOptions.xml.xmlCharKey)&&void 0!==_d?_d:XML_CHARKEY}},xmlCharKey=updatedOptions.xml.xmlCharKey;if(operationSpec.requestBody&&operationSpec.requestBody.mapper){request.body=getOperationArgumentValueFromParameter(operationArguments,operationSpec.requestBody);const bodyMapper=operationSpec.requestBody.mapper,{required:required,serializedName:serializedName,xmlName:xmlName,xmlElementName:xmlElementName,xmlNamespace:xmlNamespace,xmlNamespacePrefix:xmlNamespacePrefix,nullable:nullable}=bodyMapper,typeName=bodyMapper.type.name;try{if(void 0!==request.body&&null!==request.body||nullable&&null===request.body||required){const requestBodyParameterPathString=getPathStringFromParameter(operationSpec.requestBody);request.body=operationSpec.serializer.serialize(bodyMapper,request.body,requestBodyParameterPathString,updatedOptions);const isStream=typeName===MapperTypeNames.Stream;if(operationSpec.isXML){const xmlnsKey=xmlNamespacePrefix?`xmlns:${xmlNamespacePrefix}`:"xmlns",value=getXmlValueWithNamespace(xmlNamespace,xmlnsKey,typeName,request.body,updatedOptions);typeName===MapperTypeNames.Sequence?request.body=stringifyXML(prepareXMLRootList(value,xmlElementName||xmlName||serializedName,xmlnsKey,xmlNamespace),{rootName:xmlName||serializedName,xmlCharKey:xmlCharKey}):isStream||(request.body=stringifyXML(value,{rootName:xmlName||serializedName,xmlCharKey:xmlCharKey}))}else{if(typeName===MapperTypeNames.String&&((null===(_e=operationSpec.contentType)||void 0===_e?void 0:_e.match("text/plain"))||"text"===operationSpec.mediaType))return;isStream||(request.body=JSON.stringify(request.body))}}}catch(error){throw new Error(`Error "${error.message}" occurred in serializing the payload - ${JSON.stringify(serializedName,void 0,"  ")}.`)}}else if(operationSpec.formDataParameters&&operationSpec.formDataParameters.length>0){request.formData={};for(const formDataParameter of operationSpec.formDataParameters){const formDataParameterValue=getOperationArgumentValueFromParameter(operationArguments,formDataParameter);if(null!=formDataParameterValue){const formDataParameterPropertyName=formDataParameter.mapper.serializedName||getPathStringFromParameter(formDataParameter);request.formData[formDataParameterPropertyName]=operationSpec.serializer.serialize(formDataParameter.mapper,formDataParameterValue,getPathStringFromParameter(formDataParameter),updatedOptions)}}}}function getXmlValueWithNamespace(xmlNamespace,xmlnsKey,typeName,serializedValue,options){if(xmlNamespace&&!["Composite","Sequence","Dictionary"].includes(typeName)){const result={};return result[options.xml.xmlCharKey]=serializedValue,result[XML_ATTRKEY]={[xmlnsKey]:xmlNamespace},result}return serializedValue}function prepareXMLRootList(obj,elementName,xmlNamespaceKey,xmlNamespace){if(Array.isArray(obj)||(obj=[obj]),!xmlNamespaceKey||!xmlNamespace)return{[elementName]:obj};const result={[elementName]:obj};return result[XML_ATTRKEY]={[xmlNamespaceKey]:xmlNamespace},result}