import*as base64 from"./base64";import{XML_ATTRKEY,XML_CHARKEY}from"./interfaces";import{isDuration,isValidUuid}from"./utils";class SerializerImpl{constructor(modelMappers={},isXML=!1){this.modelMappers=modelMappers,this.isXML=isXML}validateConstraints(mapper,value,objectName){const failValidation=(constraintName,constraintValue)=>{throw new Error(`"${objectName}" with value "${value}" should satisfy the constraint "${constraintName}": ${constraintValue}.`)};if(mapper.constraints&&null!=value){const{ExclusiveMaximum:ExclusiveMaximum,ExclusiveMinimum:ExclusiveMinimum,InclusiveMaximum:InclusiveMaximum,InclusiveMinimum:InclusiveMinimum,MaxItems:MaxItems,MaxLength:MaxLength,MinItems:MinItems,MinLength:MinLength,MultipleOf:MultipleOf,Pattern:Pattern,UniqueItems:UniqueItems}=mapper.constraints;if(void 0!==ExclusiveMaximum&&value>=ExclusiveMaximum&&failValidation("ExclusiveMaximum",ExclusiveMaximum),void 0!==ExclusiveMinimum&&value<=ExclusiveMinimum&&failValidation("ExclusiveMinimum",ExclusiveMinimum),void 0!==InclusiveMaximum&&value>InclusiveMaximum&&failValidation("InclusiveMaximum",InclusiveMaximum),void 0!==InclusiveMinimum&&value<InclusiveMinimum&&failValidation("InclusiveMinimum",InclusiveMinimum),void 0!==MaxItems&&value.length>MaxItems&&failValidation("MaxItems",MaxItems),void 0!==MaxLength&&value.length>MaxLength&&failValidation("MaxLength",MaxLength),void 0!==MinItems&&value.length<MinItems&&failValidation("MinItems",MinItems),void 0!==MinLength&&value.length<MinLength&&failValidation("MinLength",MinLength),void 0!==MultipleOf&&value%MultipleOf!=0&&failValidation("MultipleOf",MultipleOf),Pattern){const pattern="string"==typeof Pattern?new RegExp(Pattern):Pattern;"string"==typeof value&&null!==value.match(pattern)||failValidation("Pattern",Pattern)}UniqueItems&&value.some(((item,i,ar)=>ar.indexOf(item)!==i))&&failValidation("UniqueItems",UniqueItems)}}serialize(mapper,object,objectName,options={xml:{}}){var _a,_b,_c;const updatedOptions={xml:{rootName:null!==(_a=options.xml.rootName)&&void 0!==_a?_a:"",includeRoot:null!==(_b=options.xml.includeRoot)&&void 0!==_b&&_b,xmlCharKey:null!==(_c=options.xml.xmlCharKey)&&void 0!==_c?_c:XML_CHARKEY}};let payload={};const mapperType=mapper.type.name;objectName||(objectName=mapper.serializedName),null!==mapperType.match(/^Sequence$/i)&&(payload=[]),mapper.isConstant&&(object=mapper.defaultValue);const{required:required,nullable:nullable}=mapper;if(required&&nullable&&void 0===object)throw new Error(`${objectName} cannot be undefined.`);if(required&&!nullable&&null==object)throw new Error(`${objectName} cannot be null or undefined.`);if(!required&&!1===nullable&&null===object)throw new Error(`${objectName} cannot be null.`);if(null==object)payload=object;else if(null!==mapperType.match(/^any$/i))payload=object;else if(null!==mapperType.match(/^(Number|String|Boolean|Object|Stream|Uuid)$/i))payload=serializeBasicTypes(mapperType,objectName,object);else if(null!==mapperType.match(/^Enum$/i)){payload=serializeEnumType(objectName,mapper.type.allowedValues,object)}else null!==mapperType.match(/^(Date|DateTime|TimeSpan|DateTimeRfc1123|UnixTime)$/i)?payload=serializeDateTypes(mapperType,object,objectName):null!==mapperType.match(/^ByteArray$/i)?payload=serializeByteArrayType(objectName,object):null!==mapperType.match(/^Base64Url$/i)?payload=serializeBase64UrlType(objectName,object):null!==mapperType.match(/^Sequence$/i)?payload=serializeSequenceType(this,mapper,object,objectName,Boolean(this.isXML),updatedOptions):null!==mapperType.match(/^Dictionary$/i)?payload=serializeDictionaryType(this,mapper,object,objectName,Boolean(this.isXML),updatedOptions):null!==mapperType.match(/^Composite$/i)&&(payload=serializeCompositeType(this,mapper,object,objectName,Boolean(this.isXML),updatedOptions));return payload}deserialize(mapper,responseBody,objectName,options={xml:{}}){var _a,_b,_c,_d;const updatedOptions={xml:{rootName:null!==(_a=options.xml.rootName)&&void 0!==_a?_a:"",includeRoot:null!==(_b=options.xml.includeRoot)&&void 0!==_b&&_b,xmlCharKey:null!==(_c=options.xml.xmlCharKey)&&void 0!==_c?_c:XML_CHARKEY},ignoreUnknownProperties:null!==(_d=options.ignoreUnknownProperties)&&void 0!==_d&&_d};if(null==responseBody)return this.isXML&&"Sequence"===mapper.type.name&&!mapper.xmlIsWrapped&&(responseBody=[]),void 0!==mapper.defaultValue&&(responseBody=mapper.defaultValue),responseBody;let payload;const mapperType=mapper.type.name;if(objectName||(objectName=mapper.serializedName),null!==mapperType.match(/^Composite$/i))payload=deserializeCompositeType(this,mapper,responseBody,objectName,updatedOptions);else{if(this.isXML){const xmlCharKey=updatedOptions.xml.xmlCharKey;void 0!==responseBody[XML_ATTRKEY]&&void 0!==responseBody[xmlCharKey]&&(responseBody=responseBody[xmlCharKey])}null!==mapperType.match(/^Number$/i)?(payload=parseFloat(responseBody),isNaN(payload)&&(payload=responseBody)):null!==mapperType.match(/^Boolean$/i)?payload="true"===responseBody||"false"!==responseBody&&responseBody:null!==mapperType.match(/^(String|Enum|Object|Stream|Uuid|TimeSpan|any)$/i)?payload=responseBody:null!==mapperType.match(/^(Date|DateTime|DateTimeRfc1123)$/i)?payload=new Date(responseBody):null!==mapperType.match(/^UnixTime$/i)?payload=unixTimeToDate(responseBody):null!==mapperType.match(/^ByteArray$/i)?payload=base64.decodeString(responseBody):null!==mapperType.match(/^Base64Url$/i)?payload=base64UrlToByteArray(responseBody):null!==mapperType.match(/^Sequence$/i)?payload=deserializeSequenceType(this,mapper,responseBody,objectName,updatedOptions):null!==mapperType.match(/^Dictionary$/i)&&(payload=deserializeDictionaryType(this,mapper,responseBody,objectName,updatedOptions))}return mapper.isConstant&&(payload=mapper.defaultValue),payload}}export function createSerializer(modelMappers={},isXML=!1){return new SerializerImpl(modelMappers,isXML)}function trimEnd(str,ch){let len=str.length;for(;len-1>=0&&str[len-1]===ch;)--len;return str.substr(0,len)}function bufferToBase64Url(buffer){if(!buffer)return;if(!(buffer instanceof Uint8Array))throw new Error("Please provide an input of type Uint8Array for converting to Base64Url.");return trimEnd(base64.encodeByteArray(buffer),"=").replace(/\+/g,"-").replace(/\//g,"_")}function base64UrlToByteArray(str){if(str){if(str&&"string"!=typeof str.valueOf())throw new Error("Please provide an input of type string for converting to Uint8Array");return str=str.replace(/-/g,"+").replace(/_/g,"/"),base64.decodeString(str)}}function splitSerializeName(prop){const classes=[];let partialclass="";if(prop){const subwords=prop.split(".");for(const item of subwords)"\\"===item.charAt(item.length-1)?partialclass+=item.substr(0,item.length-1)+".":(partialclass+=item,classes.push(partialclass),partialclass="")}return classes}function dateToUnixTime(d){if(d)return"string"==typeof d.valueOf()&&(d=new Date(d)),Math.floor(d.getTime()/1e3)}function unixTimeToDate(n){if(n)return new Date(1e3*n)}function serializeBasicTypes(typeName,objectName,value){if(null!=value)if(null!==typeName.match(/^Number$/i)){if("number"!=typeof value)throw new Error(`${objectName} with value ${value} must be of type number.`)}else if(null!==typeName.match(/^String$/i)){if("string"!=typeof value.valueOf())throw new Error(`${objectName} with value "${value}" must be of type string.`)}else if(null!==typeName.match(/^Uuid$/i)){if("string"!=typeof value.valueOf()||!isValidUuid(value))throw new Error(`${objectName} with value "${value}" must be of type string and a valid uuid.`)}else if(null!==typeName.match(/^Boolean$/i)){if("boolean"!=typeof value)throw new Error(`${objectName} with value ${value} must be of type boolean.`)}else if(null!==typeName.match(/^Stream$/i)){const objectType=typeof value;if(!("string"===objectType||"function"==typeof value.pipe||value instanceof ArrayBuffer||ArrayBuffer.isView(value)||("function"==typeof Blob||"object"==typeof Blob)&&value instanceof Blob||"function"===objectType))throw new Error(`${objectName} must be a string, Blob, ArrayBuffer, ArrayBufferView, NodeJS.ReadableStream, or () => NodeJS.ReadableStream.`)}return value}function serializeEnumType(objectName,allowedValues,value){if(!allowedValues)throw new Error(`Please provide a set of allowedValues to validate ${objectName} as an Enum Type.`);if(!allowedValues.some((item=>"string"==typeof item.valueOf()?item.toLowerCase()===value.toLowerCase():item===value)))throw new Error(`${value} is not a valid value for ${objectName}. The valid values are: ${JSON.stringify(allowedValues)}.`);return value}function serializeByteArrayType(objectName,value){if(null!=value){if(!(value instanceof Uint8Array))throw new Error(`${objectName} must be of type Uint8Array.`);value=base64.encodeByteArray(value)}return value}function serializeBase64UrlType(objectName,value){if(null!=value){if(!(value instanceof Uint8Array))throw new Error(`${objectName} must be of type Uint8Array.`);value=bufferToBase64Url(value)}return value}function serializeDateTypes(typeName,value,objectName){if(null!=value)if(null!==typeName.match(/^Date$/i)){if(!(value instanceof Date||"string"==typeof value.valueOf()&&!isNaN(Date.parse(value))))throw new Error(`${objectName} must be an instanceof Date or a string in ISO8601 format.`);value=value instanceof Date?value.toISOString().substring(0,10):new Date(value).toISOString().substring(0,10)}else if(null!==typeName.match(/^DateTime$/i)){if(!(value instanceof Date||"string"==typeof value.valueOf()&&!isNaN(Date.parse(value))))throw new Error(`${objectName} must be an instanceof Date or a string in ISO8601 format.`);value=value instanceof Date?value.toISOString():new Date(value).toISOString()}else if(null!==typeName.match(/^DateTimeRfc1123$/i)){if(!(value instanceof Date||"string"==typeof value.valueOf()&&!isNaN(Date.parse(value))))throw new Error(`${objectName} must be an instanceof Date or a string in RFC-1123 format.`);value=value instanceof Date?value.toUTCString():new Date(value).toUTCString()}else if(null!==typeName.match(/^UnixTime$/i)){if(!(value instanceof Date||"string"==typeof value.valueOf()&&!isNaN(Date.parse(value))))throw new Error(`${objectName} must be an instanceof Date or a string in RFC-1123/ISO8601 format for it to be serialized in UnixTime/Epoch format.`);value=dateToUnixTime(value)}else if(null!==typeName.match(/^TimeSpan$/i)&&!isDuration(value))throw new Error(`${objectName} must be a string in ISO 8601 format. Instead was "${value}".`);return value}function serializeSequenceType(serializer,mapper,object,objectName,isXml,options){var _a;if(!Array.isArray(object))throw new Error(`${objectName} must be of type Array.`);let elementType=mapper.type.element;if(!elementType||"object"!=typeof elementType)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${objectName}.`);"Composite"===elementType.type.name&&elementType.type.className&&(elementType=null!==(_a=serializer.modelMappers[elementType.type.className])&&void 0!==_a?_a:elementType);const tempArray=[];for(let i=0;i<object.length;i++){const serializedValue=serializer.serialize(elementType,object[i],objectName,options);if(isXml&&elementType.xmlNamespace){const xmlnsKey=elementType.xmlNamespacePrefix?`xmlns:${elementType.xmlNamespacePrefix}`:"xmlns";"Composite"===elementType.type.name?(tempArray[i]=Object.assign({},serializedValue),tempArray[i][XML_ATTRKEY]={[xmlnsKey]:elementType.xmlNamespace}):(tempArray[i]={},tempArray[i][options.xml.xmlCharKey]=serializedValue,tempArray[i][XML_ATTRKEY]={[xmlnsKey]:elementType.xmlNamespace})}else tempArray[i]=serializedValue}return tempArray}function serializeDictionaryType(serializer,mapper,object,objectName,isXml,options){if("object"!=typeof object)throw new Error(`${objectName} must be of type object.`);const valueType=mapper.type.value;if(!valueType||"object"!=typeof valueType)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${objectName}.`);const tempDictionary={};for(const key of Object.keys(object)){const serializedValue=serializer.serialize(valueType,object[key],objectName,options);tempDictionary[key]=getXmlObjectValue(valueType,serializedValue,isXml,options)}if(isXml&&mapper.xmlNamespace){const xmlnsKey=mapper.xmlNamespacePrefix?`xmlns:${mapper.xmlNamespacePrefix}`:"xmlns",result=tempDictionary;return result[XML_ATTRKEY]={[xmlnsKey]:mapper.xmlNamespace},result}return tempDictionary}function resolveAdditionalProperties(serializer,mapper,objectName){const additionalProperties=mapper.type.additionalProperties;if(!additionalProperties&&mapper.type.className){const modelMapper=resolveReferencedMapper(serializer,mapper,objectName);return null==modelMapper?void 0:modelMapper.type.additionalProperties}return additionalProperties}function resolveReferencedMapper(serializer,mapper,objectName){const className=mapper.type.className;if(!className)throw new Error(`Class name for model "${objectName}" is not provided in the mapper "${JSON.stringify(mapper,void 0,2)}".`);return serializer.modelMappers[className]}function resolveModelProperties(serializer,mapper,objectName){let modelProps=mapper.type.modelProperties;if(!modelProps){const modelMapper=resolveReferencedMapper(serializer,mapper,objectName);if(!modelMapper)throw new Error(`mapper() cannot be null or undefined for model "${mapper.type.className}".`);if(modelProps=null==modelMapper?void 0:modelMapper.type.modelProperties,!modelProps)throw new Error(`modelProperties cannot be null or undefined in the mapper "${JSON.stringify(modelMapper)}" of type "${mapper.type.className}" for object "${objectName}".`)}return modelProps}function serializeCompositeType(serializer,mapper,object,objectName,isXml,options){if(getPolymorphicDiscriminatorRecursively(serializer,mapper)&&(mapper=getPolymorphicMapper(serializer,mapper,object,"clientName")),null!=object){const payload={},modelProps=resolveModelProperties(serializer,mapper,objectName);for(const key of Object.keys(modelProps)){const propertyMapper=modelProps[key];if(propertyMapper.readOnly)continue;let propName,parentObject=payload;if(serializer.isXML)propName=propertyMapper.xmlIsWrapped?propertyMapper.xmlName:propertyMapper.xmlElementName||propertyMapper.xmlName;else{const paths=splitSerializeName(propertyMapper.serializedName);propName=paths.pop();for(const pathName of paths){const childObject=parentObject[pathName];null==childObject&&(void 0!==object[key]&&null!==object[key]||void 0!==propertyMapper.defaultValue)&&(parentObject[pathName]={}),parentObject=parentObject[pathName]}}if(null!=parentObject){if(isXml&&mapper.xmlNamespace){const xmlnsKey=mapper.xmlNamespacePrefix?`xmlns:${mapper.xmlNamespacePrefix}`:"xmlns";parentObject[XML_ATTRKEY]=Object.assign(Object.assign({},parentObject[XML_ATTRKEY]),{[xmlnsKey]:mapper.xmlNamespace})}const propertyObjectName=""!==propertyMapper.serializedName?objectName+"."+propertyMapper.serializedName:objectName;let toSerialize=object[key];const polymorphicDiscriminator=getPolymorphicDiscriminatorRecursively(serializer,mapper);polymorphicDiscriminator&&polymorphicDiscriminator.clientName===key&&null==toSerialize&&(toSerialize=mapper.serializedName);const serializedValue=serializer.serialize(propertyMapper,toSerialize,propertyObjectName,options);if(void 0!==serializedValue&&null!=propName){const value=getXmlObjectValue(propertyMapper,serializedValue,isXml,options);isXml&&propertyMapper.xmlIsAttribute?(parentObject[XML_ATTRKEY]=parentObject[XML_ATTRKEY]||{},parentObject[XML_ATTRKEY][propName]=serializedValue):isXml&&propertyMapper.xmlIsWrapped?parentObject[propName]={[propertyMapper.xmlElementName]:value}:parentObject[propName]=value}}}const additionalPropertiesMapper=resolveAdditionalProperties(serializer,mapper,objectName);if(additionalPropertiesMapper){const propNames=Object.keys(modelProps);for(const clientPropName in object){propNames.every((pn=>pn!==clientPropName))&&(payload[clientPropName]=serializer.serialize(additionalPropertiesMapper,object[clientPropName],objectName+'["'+clientPropName+'"]',options))}}return payload}return object}function getXmlObjectValue(propertyMapper,serializedValue,isXml,options){if(!isXml||!propertyMapper.xmlNamespace)return serializedValue;const xmlNamespace={[propertyMapper.xmlNamespacePrefix?`xmlns:${propertyMapper.xmlNamespacePrefix}`:"xmlns"]:propertyMapper.xmlNamespace};if(["Composite"].includes(propertyMapper.type.name)){if(serializedValue[XML_ATTRKEY])return serializedValue;{const result=Object.assign({},serializedValue);return result[XML_ATTRKEY]=xmlNamespace,result}}const result={};return result[options.xml.xmlCharKey]=serializedValue,result[XML_ATTRKEY]=xmlNamespace,result}function isSpecialXmlProperty(propertyName,options){return[XML_ATTRKEY,options.xml.xmlCharKey].includes(propertyName)}function deserializeCompositeType(serializer,mapper,responseBody,objectName,options){var _a,_b;const xmlCharKey=null!==(_a=options.xml.xmlCharKey)&&void 0!==_a?_a:XML_CHARKEY;getPolymorphicDiscriminatorRecursively(serializer,mapper)&&(mapper=getPolymorphicMapper(serializer,mapper,responseBody,"serializedName"));const modelProps=resolveModelProperties(serializer,mapper,objectName);let instance={};const handledPropertyNames=[];for(const key of Object.keys(modelProps)){const propertyMapper=modelProps[key],paths=splitSerializeName(modelProps[key].serializedName);handledPropertyNames.push(paths[0]);const{serializedName:serializedName,xmlName:xmlName,xmlElementName:xmlElementName}=propertyMapper;let propertyObjectName=objectName;""!==serializedName&&void 0!==serializedName&&(propertyObjectName=objectName+"."+serializedName);const headerCollectionPrefix=propertyMapper.headerCollectionPrefix;if(headerCollectionPrefix){const dictionary={};for(const headerKey of Object.keys(responseBody))headerKey.startsWith(headerCollectionPrefix)&&(dictionary[headerKey.substring(headerCollectionPrefix.length)]=serializer.deserialize(propertyMapper.type.value,responseBody[headerKey],propertyObjectName,options)),handledPropertyNames.push(headerKey);instance[key]=dictionary}else if(serializer.isXML)if(propertyMapper.xmlIsAttribute&&responseBody[XML_ATTRKEY])instance[key]=serializer.deserialize(propertyMapper,responseBody[XML_ATTRKEY][xmlName],propertyObjectName,options);else if(propertyMapper.xmlIsMsText)void 0!==responseBody[xmlCharKey]?instance[key]=responseBody[xmlCharKey]:"string"==typeof responseBody&&(instance[key]=responseBody);else{const propertyName=xmlElementName||xmlName||serializedName;if(propertyMapper.xmlIsWrapped){const wrapped=responseBody[xmlName],elementList=null!==(_b=null==wrapped?void 0:wrapped[xmlElementName])&&void 0!==_b?_b:[];instance[key]=serializer.deserialize(propertyMapper,elementList,propertyObjectName,options),handledPropertyNames.push(xmlName)}else{const property=responseBody[propertyName];instance[key]=serializer.deserialize(propertyMapper,property,propertyObjectName,options),handledPropertyNames.push(propertyName)}}else{let propertyInstance,res=responseBody,steps=0;for(const item of paths){if(!res)break;steps++,res=res[item]}null===res&&steps<paths.length&&(res=void 0),propertyInstance=res;const polymorphicDiscriminator=mapper.type.polymorphicDiscriminator;let serializedValue;if(polymorphicDiscriminator&&key===polymorphicDiscriminator.clientName&&null==propertyInstance&&(propertyInstance=mapper.serializedName),Array.isArray(responseBody[key])&&""===modelProps[key].serializedName){propertyInstance=responseBody[key];const arrayInstance=serializer.deserialize(propertyMapper,propertyInstance,propertyObjectName,options);for(const[k,v]of Object.entries(instance))Object.prototype.hasOwnProperty.call(arrayInstance,k)||(arrayInstance[k]=v);instance=arrayInstance}else void 0===propertyInstance&&void 0===propertyMapper.defaultValue||(serializedValue=serializer.deserialize(propertyMapper,propertyInstance,propertyObjectName,options),instance[key]=serializedValue)}}const additionalPropertiesMapper=mapper.type.additionalProperties;if(additionalPropertiesMapper){const isAdditionalProperty=responsePropName=>{for(const clientPropName in modelProps){if(splitSerializeName(modelProps[clientPropName].serializedName)[0]===responsePropName)return!1}return!0};for(const responsePropName in responseBody)isAdditionalProperty(responsePropName)&&(instance[responsePropName]=serializer.deserialize(additionalPropertiesMapper,responseBody[responsePropName],objectName+'["'+responsePropName+'"]',options))}else if(responseBody&&!options.ignoreUnknownProperties)for(const key of Object.keys(responseBody))void 0!==instance[key]||handledPropertyNames.includes(key)||isSpecialXmlProperty(key,options)||(instance[key]=responseBody[key]);return instance}function deserializeDictionaryType(serializer,mapper,responseBody,objectName,options){const value=mapper.type.value;if(!value||"object"!=typeof value)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${objectName}`);if(responseBody){const tempDictionary={};for(const key of Object.keys(responseBody))tempDictionary[key]=serializer.deserialize(value,responseBody[key],objectName,options);return tempDictionary}return responseBody}function deserializeSequenceType(serializer,mapper,responseBody,objectName,options){var _a;let element=mapper.type.element;if(!element||"object"!=typeof element)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${objectName}`);if(responseBody){Array.isArray(responseBody)||(responseBody=[responseBody]),"Composite"===element.type.name&&element.type.className&&(element=null!==(_a=serializer.modelMappers[element.type.className])&&void 0!==_a?_a:element);const tempArray=[];for(let i=0;i<responseBody.length;i++)tempArray[i]=serializer.deserialize(element,responseBody[i],`${objectName}[${i}]`,options);return tempArray}return responseBody}function getIndexDiscriminator(discriminators,discriminatorValue,typeName){const typeNamesToCheck=[typeName];for(;typeNamesToCheck.length;){const currentName=typeNamesToCheck.shift(),indexDiscriminator=discriminatorValue===currentName?discriminatorValue:currentName+"."+discriminatorValue;if(Object.prototype.hasOwnProperty.call(discriminators,indexDiscriminator))return discriminators[indexDiscriminator];for(const[name,mapper]of Object.entries(discriminators))name.startsWith(currentName+".")&&mapper.type.uberParent===currentName&&mapper.type.className&&typeNamesToCheck.push(mapper.type.className)}}function getPolymorphicMapper(serializer,mapper,object,polymorphicPropertyName){var _a;const polymorphicDiscriminator=getPolymorphicDiscriminatorRecursively(serializer,mapper);if(polymorphicDiscriminator){let discriminatorName=polymorphicDiscriminator[polymorphicPropertyName];if(discriminatorName){"serializedName"===polymorphicPropertyName&&(discriminatorName=discriminatorName.replace(/\\/gi,""));const discriminatorValue=object[discriminatorName],typeName=null!==(_a=mapper.type.uberParent)&&void 0!==_a?_a:mapper.type.className;if("string"==typeof discriminatorValue&&typeName){const polymorphicMapper=getIndexDiscriminator(serializer.modelMappers.discriminators,discriminatorValue,typeName);polymorphicMapper&&(mapper=polymorphicMapper)}}}return mapper}function getPolymorphicDiscriminatorRecursively(serializer,mapper){return mapper.type.polymorphicDiscriminator||getPolymorphicDiscriminatorSafely(serializer,mapper.type.uberParent)||getPolymorphicDiscriminatorSafely(serializer,mapper.type.className)}function getPolymorphicDiscriminatorSafely(serializer,typeName){return typeName&&serializer.modelMappers[typeName]&&serializer.modelMappers[typeName].type.polymorphicDiscriminator}export const MapperTypeNames={Base64Url:"Base64Url",Boolean:"Boolean",ByteArray:"ByteArray",Composite:"Composite",Date:"Date",DateTime:"DateTime",DateTimeRfc1123:"DateTimeRfc1123",Dictionary:"Dictionary",Enum:"Enum",Number:"Number",Object:"Object",Sequence:"Sequence",String:"String",Stream:"Stream",TimeSpan:"TimeSpan",UnixTime:"UnixTime"};