import{createPipelineRequest}from"@azure/core-rest-pipeline";import{createClientPipeline}from"./pipeline";import{flattenResponse}from"./utils";import{getCachedDefaultHttpClient}from"./httpClientCache";import{getOperationRequestInfo}from"./operationHelpers";import{getRequestUrl}from"./urlHelpers";import{getStreamingResponseStatusCodes}from"./interfaceHelpers";import{logger}from"./log";export class ServiceClient{constructor(options={}){var _a,_b;if(this._requestContentType=options.requestContentType,this._endpoint=null!==(_a=options.endpoint)&&void 0!==_a?_a:options.baseUri,options.baseUri&&logger.warning("The baseUri option for SDK Clients has been deprecated, please use endpoint instead."),this._allowInsecureConnection=options.allowInsecureConnection,this._httpClient=options.httpClient||getCachedDefaultHttpClient(),this.pipeline=options.pipeline||createDefaultPipeline(options),null===(_b=options.additionalPolicies)||void 0===_b?void 0:_b.length)for(const{policy:policy,position:position}of options.additionalPolicies){const afterPhase="perRetry"===position?"Sign":void 0;this.pipeline.addPolicy(policy,{afterPhase:afterPhase})}}async sendRequest(request){return this.pipeline.sendRequest(this._httpClient,request)}async sendOperationRequest(operationArguments,operationSpec){const endpoint=operationSpec.baseUrl||this._endpoint;if(!endpoint)throw new Error("If operationSpec.baseUrl is not specified, then the ServiceClient must have a endpoint string property that contains the base URL to use.");const url=getRequestUrl(endpoint,operationSpec,operationArguments,this),request=createPipelineRequest({url:url});request.method=operationSpec.httpMethod;const operationInfo=getOperationRequestInfo(request);operationInfo.operationSpec=operationSpec,operationInfo.operationArguments=operationArguments;const contentType=operationSpec.contentType||this._requestContentType;contentType&&operationSpec.requestBody&&request.headers.set("Content-Type",contentType);const options=operationArguments.options;if(options){const requestOptions=options.requestOptions;requestOptions&&(requestOptions.timeout&&(request.timeout=requestOptions.timeout),requestOptions.onUploadProgress&&(request.onUploadProgress=requestOptions.onUploadProgress),requestOptions.onDownloadProgress&&(request.onDownloadProgress=requestOptions.onDownloadProgress),void 0!==requestOptions.shouldDeserialize&&(operationInfo.shouldDeserialize=requestOptions.shouldDeserialize),requestOptions.allowInsecureConnection&&(request.allowInsecureConnection=!0)),options.abortSignal&&(request.abortSignal=options.abortSignal),options.tracingOptions&&(request.tracingOptions=options.tracingOptions)}this._allowInsecureConnection&&(request.allowInsecureConnection=!0),void 0===request.streamResponseStatusCodes&&(request.streamResponseStatusCodes=getStreamingResponseStatusCodes(operationSpec));try{const rawResponse=await this.sendRequest(request),flatResponse=flattenResponse(rawResponse,operationSpec.responses[rawResponse.status]);return(null==options?void 0:options.onResponse)&&options.onResponse(rawResponse,flatResponse),flatResponse}catch(error){if("object"==typeof error&&(null==error?void 0:error.response)){const rawResponse=error.response,flatResponse=flattenResponse(rawResponse,operationSpec.responses[error.statusCode]||operationSpec.responses.default);error.details=flatResponse,(null==options?void 0:options.onResponse)&&options.onResponse(rawResponse,flatResponse,error)}throw error}}}function createDefaultPipeline(options){const credentialScopes=getCredentialScopes(options),credentialOptions=options.credential&&credentialScopes?{credentialScopes:credentialScopes,credential:options.credential}:void 0;return createClientPipeline(Object.assign(Object.assign({},options),{credentialOptions:credentialOptions}))}function getCredentialScopes(options){if(options.credentialScopes)return options.credentialScopes;if(options.endpoint)return`${options.endpoint}/.default`;if(options.baseUri)return`${options.baseUri}/.default`;if(options.credential&&!options.credentialScopes)throw new Error("When using credentials, the ServiceClientOptions must contain either a endpoint or a credentialScopes. Unable to create a bearerTokenAuthenticationPolicy")}