import{getOperationArgumentValueFromParameter}from"./operationHelpers";import{getPathStringFromParameter}from"./interfaceHelpers";const CollectionFormatToDelimiterMap={CSV:",",SSV:" ",Multi:"Multi",TSV:"\t",Pipes:"|"};export function getRequestUrl(baseUri,operationSpec,operationArguments,fallbackObject){const urlReplacements=calculateUrlReplacements(operationSpec,operationArguments,fallbackObject);let isAbsolutePath=!1,requestUrl=replaceAll(baseUri,urlReplacements);if(operationSpec.path){let path=replaceAll(operationSpec.path,urlReplacements);"/{nextLink}"===operationSpec.path&&path.startsWith("/")&&(path=path.substring(1)),isAbsoluteUrl(path)?(requestUrl=path,isAbsolutePath=!0):requestUrl=appendPath(requestUrl,path)}const{queryParams:queryParams,sequenceParams:sequenceParams}=calculateQueryParameters(operationSpec,operationArguments,fallbackObject);return requestUrl=appendQueryParams(requestUrl,queryParams,sequenceParams,isAbsolutePath),requestUrl}function replaceAll(input,replacements){let result=input;for(const[searchValue,replaceValue]of replacements)result=result.split(searchValue).join(replaceValue);return result}function calculateUrlReplacements(operationSpec,operationArguments,fallbackObject){var _a;const result=new Map;if(null===(_a=operationSpec.urlParameters)||void 0===_a?void 0:_a.length)for(const urlParameter of operationSpec.urlParameters){let urlParameterValue=getOperationArgumentValueFromParameter(operationArguments,urlParameter,fallbackObject);const parameterPathString=getPathStringFromParameter(urlParameter);urlParameterValue=operationSpec.serializer.serialize(urlParameter.mapper,urlParameterValue,parameterPathString),urlParameter.skipEncoding||(urlParameterValue=encodeURIComponent(urlParameterValue)),result.set(`{${urlParameter.mapper.serializedName||parameterPathString}}`,urlParameterValue)}return result}function isAbsoluteUrl(url){return url.includes("://")}function appendPath(url,pathToAppend){if(!pathToAppend)return url;const parsedUrl=new URL(url);let newPath=parsedUrl.pathname;newPath.endsWith("/")||(newPath=`${newPath}/`),pathToAppend.startsWith("/")&&(pathToAppend=pathToAppend.substring(1));const searchStart=pathToAppend.indexOf("?");if(-1!==searchStart){const path=pathToAppend.substring(0,searchStart),search=pathToAppend.substring(searchStart+1);newPath+=path,search&&(parsedUrl.search=parsedUrl.search?`${parsedUrl.search}&${search}`:search)}else newPath+=pathToAppend;return parsedUrl.pathname=newPath,parsedUrl.toString()}function calculateQueryParameters(operationSpec,operationArguments,fallbackObject){var _a;const result=new Map,sequenceParams=new Set;if(null===(_a=operationSpec.queryParameters)||void 0===_a?void 0:_a.length)for(const queryParameter of operationSpec.queryParameters){"Sequence"===queryParameter.mapper.type.name&&queryParameter.mapper.serializedName&&sequenceParams.add(queryParameter.mapper.serializedName);let queryParameterValue=getOperationArgumentValueFromParameter(operationArguments,queryParameter,fallbackObject);if(null!=queryParameterValue||queryParameter.mapper.required){queryParameterValue=operationSpec.serializer.serialize(queryParameter.mapper,queryParameterValue,getPathStringFromParameter(queryParameter));const delimiter=queryParameter.collectionFormat?CollectionFormatToDelimiterMap[queryParameter.collectionFormat]:"";if(Array.isArray(queryParameterValue)&&(queryParameterValue=queryParameterValue.map((item=>null==item?"":item))),"Multi"===queryParameter.collectionFormat&&0===queryParameterValue.length)continue;!Array.isArray(queryParameterValue)||"SSV"!==queryParameter.collectionFormat&&"TSV"!==queryParameter.collectionFormat||(queryParameterValue=queryParameterValue.join(delimiter)),queryParameter.skipEncoding||(queryParameterValue=Array.isArray(queryParameterValue)?queryParameterValue.map((item=>encodeURIComponent(item))):encodeURIComponent(queryParameterValue)),!Array.isArray(queryParameterValue)||"CSV"!==queryParameter.collectionFormat&&"Pipes"!==queryParameter.collectionFormat||(queryParameterValue=queryParameterValue.join(delimiter)),result.set(queryParameter.mapper.serializedName||getPathStringFromParameter(queryParameter),queryParameterValue)}}return{queryParams:result,sequenceParams:sequenceParams}}function simpleParseQueryParams(queryString){const result=new Map;if(!queryString||"?"!==queryString[0])return result;const pairs=(queryString=queryString.slice(1)).split("&");for(const pair of pairs){const[name,value]=pair.split("=",2),existingValue=result.get(name);existingValue?Array.isArray(existingValue)?existingValue.push(value):result.set(name,[existingValue,value]):result.set(name,value)}return result}export function appendQueryParams(url,queryParams,sequenceParams,noOverwrite=!1){if(0===queryParams.size)return url;const parsedUrl=new URL(url),combinedParams=simpleParseQueryParams(parsedUrl.search);for(const[name,value]of queryParams){const existingValue=combinedParams.get(name);if(Array.isArray(existingValue))if(Array.isArray(value)){existingValue.push(...value);const valueSet=new Set(existingValue);combinedParams.set(name,Array.from(valueSet))}else existingValue.push(value);else existingValue?(Array.isArray(value)?value.unshift(existingValue):sequenceParams.has(name)&&combinedParams.set(name,[existingValue,value]),noOverwrite||combinedParams.set(name,value)):combinedParams.set(name,value)}const searchPieces=[];for(const[name,value]of combinedParams)if("string"==typeof value)searchPieces.push(`${name}=${value}`);else if(Array.isArray(value))for(const subValue of value)searchPieces.push(`${name}=${subValue}`);else searchPieces.push(`${name}=${value}`);return parsedUrl.search=searchPieces.length?`?${searchPieces.join("&")}`:"",parsedUrl.toString()}