import{initOperation,pollOperation}from"../poller/operation";import{logger}from"../logger";function getOperationLocationPollingUrl(inputs){const{azureAsyncOperation:azureAsyncOperation,operationLocation:operationLocation}=inputs;return null!=operationLocation?operationLocation:azureAsyncOperation}function getLocationHeader(rawResponse){return rawResponse.headers.location}function getOperationLocationHeader(rawResponse){return rawResponse.headers["operation-location"]}function getAzureAsyncOperationHeader(rawResponse){return rawResponse.headers["azure-asyncoperation"]}function findResourceLocation(inputs){const{location:location,requestMethod:requestMethod,requestPath:requestPath,resourceLocationConfig:resourceLocationConfig}=inputs;switch(requestMethod){case"PUT":return requestPath;case"DELETE":return;default:switch(resourceLocationConfig){case"azure-async-operation":return;case"original-uri":return requestPath;default:return location}}}export function inferLroMode(inputs){const{rawResponse:rawResponse,requestMethod:requestMethod,requestPath:requestPath,resourceLocationConfig:resourceLocationConfig}=inputs,pollingUrl=getOperationLocationPollingUrl({operationLocation:getOperationLocationHeader(rawResponse),azureAsyncOperation:getAzureAsyncOperationHeader(rawResponse)}),location=getLocationHeader(rawResponse),normalizedRequestMethod=null==requestMethod?void 0:requestMethod.toLocaleUpperCase();return void 0!==pollingUrl?{mode:"OperationLocation",operationLocation:pollingUrl,resourceLocation:findResourceLocation({requestMethod:normalizedRequestMethod,location:location,requestPath:requestPath,resourceLocationConfig:resourceLocationConfig})}:void 0!==location?{mode:"ResourceLocation",operationLocation:location}:"PUT"===normalizedRequestMethod&&requestPath?{mode:"Body",operationLocation:requestPath}:void 0}function transformStatus(inputs){const{status:status,statusCode:statusCode}=inputs;if("string"!=typeof status&&void 0!==status)throw new Error(`Polling was unsuccessful. Expected status to have a string value or no value but it has instead: ${status}. This doesn't necessarily indicate the operation has failed. Check your Azure subscription or resource status for more information.`);switch(null==status?void 0:status.toLocaleLowerCase()){case void 0:return toOperationStatus(statusCode);case"succeeded":return"succeeded";case"failed":return"failed";case"running":case"accepted":case"started":case"canceling":case"cancelling":return"running";case"canceled":case"cancelled":return"canceled";default:return logger.verbose(`LRO: unrecognized operation status: ${status}`),status}}function getStatus(rawResponse){var _a;const{status:status}=null!==(_a=rawResponse.body)&&void 0!==_a?_a:{};return transformStatus({status:status,statusCode:rawResponse.statusCode})}function getProvisioningState(rawResponse){var _a,_b;const{properties:properties,provisioningState:provisioningState}=null!==(_a=rawResponse.body)&&void 0!==_a?_a:{};return transformStatus({status:null!==(_b=null==properties?void 0:properties.provisioningState)&&void 0!==_b?_b:provisioningState,statusCode:rawResponse.statusCode})}function toOperationStatus(statusCode){return 202===statusCode?"running":statusCode<300?"succeeded":"failed"}export function parseRetryAfter({rawResponse:rawResponse}){const retryAfter=rawResponse.headers["retry-after"];if(void 0!==retryAfter){const retryAfterInSeconds=parseInt(retryAfter);return isNaN(retryAfterInSeconds)?calculatePollingIntervalFromDate(new Date(retryAfter)):1e3*retryAfterInSeconds}}export function getErrorFromResponse(response){const error=response.flatResponse.error;if(error){if(error.code&&error.message)return error;logger.warning("The long-running operation failed but the error property in the response's body doesn't contain code or message")}else logger.warning("The long-running operation failed but there is no error property in the response's body")}function calculatePollingIntervalFromDate(retryAfterDate){const timeNow=Math.floor((new Date).getTime()),retryAfterTime=retryAfterDate.getTime();if(timeNow<retryAfterTime)return retryAfterTime-timeNow}export function getStatusFromInitialResponse(inputs){const{response:response,state:state,operationLocation:operationLocation}=inputs;function helper(){var _a;switch(null===(_a=state.config.metadata)||void 0===_a?void 0:_a.mode){case void 0:return toOperationStatus(response.rawResponse.statusCode);case"Body":return getOperationStatus(response,state);default:return"running"}}const status=helper();return"running"===status&&void 0===operationLocation?"succeeded":status}export async function initHttpOperation(inputs){const{stateProxy:stateProxy,resourceLocationConfig:resourceLocationConfig,processResult:processResult,lro:lro,setErrorAsResult:setErrorAsResult}=inputs;return initOperation({init:async()=>{const response=await lro.sendInitialRequest(),config=inferLroMode({rawResponse:response.rawResponse,requestPath:lro.requestPath,requestMethod:lro.requestMethod,resourceLocationConfig:resourceLocationConfig});return Object.assign({response:response,operationLocation:null==config?void 0:config.operationLocation,resourceLocation:null==config?void 0:config.resourceLocation},(null==config?void 0:config.mode)?{metadata:{mode:config.mode}}:{})},stateProxy:stateProxy,processResult:processResult?({flatResponse:flatResponse},state)=>processResult(flatResponse,state):({flatResponse:flatResponse})=>flatResponse,getOperationStatus:getStatusFromInitialResponse,setErrorAsResult:setErrorAsResult})}export function getOperationLocation({rawResponse:rawResponse},state){var _a;switch(null===(_a=state.config.metadata)||void 0===_a?void 0:_a.mode){case"OperationLocation":return getOperationLocationPollingUrl({operationLocation:getOperationLocationHeader(rawResponse),azureAsyncOperation:getAzureAsyncOperationHeader(rawResponse)});case"ResourceLocation":return getLocationHeader(rawResponse);default:return}}export function getOperationStatus({rawResponse:rawResponse},state){var _a;const mode=null===(_a=state.config.metadata)||void 0===_a?void 0:_a.mode;switch(mode){case"OperationLocation":return getStatus(rawResponse);case"ResourceLocation":return toOperationStatus(rawResponse.statusCode);case"Body":return getProvisioningState(rawResponse);default:throw new Error(`Internal error: Unexpected operation mode: ${mode}`)}}export function getResourceLocation({flatResponse:flatResponse},state){if("object"==typeof flatResponse){const resourceLocation=flatResponse.resourceLocation;void 0!==resourceLocation&&(state.config.resourceLocation=resourceLocation)}return state.config.resourceLocation}export function isOperationError(e){return"RestError"===e.name}export async function pollHttpOperation(inputs){const{lro:lro,stateProxy:stateProxy,options:options,processResult:processResult,updateState:updateState,setDelay:setDelay,state:state,setErrorAsResult:setErrorAsResult}=inputs;return pollOperation({state:state,stateProxy:stateProxy,setDelay:setDelay,processResult:processResult?({flatResponse:flatResponse},inputState)=>processResult(flatResponse,inputState):({flatResponse:flatResponse})=>flatResponse,getError:getErrorFromResponse,updateState:updateState,getPollingInterval:parseRetryAfter,getOperationLocation:getOperationLocation,getOperationStatus:getOperationStatus,isOperationError:isOperationError,getResourceLocation:getResourceLocation,options:options,poll:async(location,inputOptions)=>lro.sendPollRequest(location,inputOptions),setErrorAsResult:setErrorAsResult})}