export class PollerStoppedError extends Error{constructor(message){super(message),this.name="PollerStoppedError",Object.setPrototypeOf(this,PollerStoppedError.prototype)}}export class PollerCancelledError extends Error{constructor(message){super(message),this.name="PollerCancelledError",Object.setPrototypeOf(this,PollerCancelledError.prototype)}}export class Poller{constructor(operation){this.resolveOnUnsuccessful=!1,this.stopped=!0,this.pollProgressCallbacks=[],this.operation=operation,this.promise=new Promise(((resolve,reject)=>{this.resolve=resolve,this.reject=reject})),this.promise.catch((()=>{}))}async startPolling(pollOptions={}){for(this.stopped&&(this.stopped=!1);!this.isStopped()&&!this.isDone();)await this.poll(pollOptions),await this.delay()}async pollOnce(options={}){this.isDone()||(this.operation=await this.operation.update({abortSignal:options.abortSignal,fireProgress:this.fireProgress.bind(this)})),this.processUpdatedState()}fireProgress(state){for(const callback of this.pollProgressCallbacks)callback(state)}async cancelOnce(options={}){this.operation=await this.operation.cancel(options)}poll(options={}){if(!this.pollOncePromise){this.pollOncePromise=this.pollOnce(options);const clearPollOncePromise=()=>{this.pollOncePromise=void 0};this.pollOncePromise.then(clearPollOncePromise,clearPollOncePromise).catch(this.reject)}return this.pollOncePromise}processUpdatedState(){if(this.operation.state.error&&(this.stopped=!0,!this.resolveOnUnsuccessful))throw this.reject(this.operation.state.error),this.operation.state.error;if(this.operation.state.isCancelled&&(this.stopped=!0,!this.resolveOnUnsuccessful)){const error=new PollerCancelledError("Operation was canceled");throw this.reject(error),error}this.isDone()&&this.resolve&&this.resolve(this.getResult())}async pollUntilDone(pollOptions={}){return this.stopped&&this.startPolling(pollOptions).catch(this.reject),this.processUpdatedState(),this.promise}onProgress(callback){return this.pollProgressCallbacks.push(callback),()=>{this.pollProgressCallbacks=this.pollProgressCallbacks.filter((c=>c!==callback))}}isDone(){const state=this.operation.state;return Boolean(state.isCompleted||state.isCancelled||state.error)}stopPolling(){this.stopped||(this.stopped=!0,this.reject&&this.reject(new PollerStoppedError("This poller is already stopped")))}isStopped(){return this.stopped}cancelOperation(options={}){if(this.cancelPromise){if(options.abortSignal)throw new Error("A cancel request is currently pending")}else this.cancelPromise=this.cancelOnce(options);return this.cancelPromise}getOperationState(){return this.operation.state}getResult(){return this.operation.state.result}toString(){return this.operation.toString()}}