import{AbortError}from"@azure/abort-controller";import{RestError}from"./restError";import{createHttpHeaders}from"./httpHeaders";function isNodeReadableStream(body){return body&&"function"==typeof body.pipe}function isReadableStream(body){return Boolean(body&&"function"==typeof body.getReader&&"function"==typeof body.tee)}function isBlob(body){return("function"==typeof Blob||"object"==typeof Blob)&&body instanceof Blob}class FetchHttpClient{async sendRequest(request){if("https:"!==new URL(request.url).protocol&&!request.allowInsecureConnection)throw new Error(`Cannot connect to ${request.url} while allowInsecureConnection is false.`);if(request.proxySettings)throw new Error("HTTP proxy is not supported in browser environment");try{return await makeRequest(request)}catch(e){throw getError(e,request)}}}async function makeRequest(request){const{abortController:abortController,abortControllerCleanup:abortControllerCleanup}=setupAbortSignal(request);try{const headers=buildFetchHeaders(request.headers),requestBody=buildRequestBody(request),response=await fetch(request.url,{body:requestBody,method:request.method,headers:headers,signal:abortController.signal,credentials:request.withCredentials?"include":"same-origin",cache:"no-store"});return isBlob(request.body)&&request.onUploadProgress&&request.onUploadProgress({loadedBytes:request.body.size}),buildPipelineResponse(response,request)}finally{abortControllerCleanup&&abortControllerCleanup()}}async function buildPipelineResponse(httpResponse,request){var _a,_b;const response={request:request,headers:buildPipelineHeaders(httpResponse),status:httpResponse.status},bodyStream=isReadableStream(httpResponse.body)?buildBodyStream(httpResponse.body,request.onDownloadProgress):httpResponse.body;if((null===(_a=request.streamResponseStatusCodes)||void 0===_a?void 0:_a.has(Number.POSITIVE_INFINITY))||(null===(_b=request.streamResponseStatusCodes)||void 0===_b?void 0:_b.has(response.status)))if(request.enableBrowserStreams)response.browserStreamBody=null!=bodyStream?bodyStream:void 0;else{const responseStream=new Response(bodyStream);response.blobBody=responseStream.blob()}else{const responseStream=new Response(bodyStream);response.bodyAsText=await responseStream.text()}return response}function setupAbortSignal(request){const abortController=new AbortController;let abortControllerCleanup,abortListener;if(request.abortSignal){if(request.abortSignal.aborted)throw new AbortError("The operation was aborted.");abortListener=event=>{"abort"===event.type&&abortController.abort()},request.abortSignal.addEventListener("abort",abortListener),abortControllerCleanup=()=>{var _a;abortListener&&(null===(_a=request.abortSignal)||void 0===_a||_a.removeEventListener("abort",abortListener))}}return request.timeout>0&&setTimeout((()=>{abortController.abort()}),request.timeout),{abortController:abortController,abortControllerCleanup:abortControllerCleanup}}function getError(e,request){var _a;return e&&"AbortError"===(null==e?void 0:e.name)?e:new RestError(`Error sending request: ${e.message}`,{code:null!==(_a=null==e?void 0:e.code)&&void 0!==_a?_a:RestError.REQUEST_SEND_ERROR,request:request})}function buildFetchHeaders(pipelineHeaders){const headers=new Headers;for(const[name,value]of pipelineHeaders)headers.append(name,value);return headers}function buildPipelineHeaders(httpResponse){const responseHeaders=createHttpHeaders();for(const[name,value]of httpResponse.headers)responseHeaders.set(name,value);return responseHeaders}function buildRequestBody(request){const body="function"==typeof request.body?request.body():request.body;if(isNodeReadableStream(body))throw new Error("Node streams are not supported in browser environment.");return isReadableStream(body)?buildBodyStream(body,request.onUploadProgress):body}function buildBodyStream(readableStream,onProgress){let loadedBytes=0;if(isTransformStreamSupported(readableStream))return readableStream.pipeThrough(new TransformStream({transform(chunk,controller){null!==chunk?(controller.enqueue(chunk),loadedBytes+=chunk.length,onProgress&&onProgress({loadedBytes:loadedBytes})):controller.terminate()}}));{const reader=readableStream.getReader();return new ReadableStream({async pull(controller){var _a;const{done:done,value:value}=await reader.read();if(done||!value)return controller.close(),void reader.releaseLock();loadedBytes+=null!==(_a=null==value?void 0:value.length)&&void 0!==_a?_a:0,controller.enqueue(value),onProgress&&onProgress({loadedBytes:loadedBytes})}})}}export function createFetchHttpClient(){return new FetchHttpClient}function isTransformStreamSupported(readableStream){return void 0!==readableStream.pipeThrough&&void 0!==self.TransformStream}