import*as http from"http";import*as https from"https";import*as zlib from"zlib";import{Transform}from"stream";import{AbortController,AbortError}from"@azure/abort-controller";import{createHttpHeaders}from"./httpHeaders";import{RestError}from"./restError";import{logger}from"./log";const DEFAULT_TLS_SETTINGS={};function isReadableStream(body){return body&&"function"==typeof body.pipe}function isStreamComplete(stream){return new Promise((resolve=>{stream.on("close",resolve),stream.on("end",resolve),stream.on("error",resolve)}))}function isArrayBuffer(body){return body&&"number"==typeof body.byteLength}class ReportTransform extends Transform{_transform(chunk,_encoding,callback){this.push(chunk),this.loadedBytes+=chunk.length;try{this.progressCallback({loadedBytes:this.loadedBytes}),callback()}catch(e){callback(e)}}constructor(progressCallback){super(),this.loadedBytes=0,this.progressCallback=progressCallback}}class NodeHttpClient{constructor(){this.cachedHttpsAgents=new WeakMap}async sendRequest(request){var _a,_b,_c;const abortController=new AbortController;let abortListener;if(request.abortSignal){if(request.abortSignal.aborted)throw new AbortError("The operation was aborted.");abortListener=event=>{"abort"===event.type&&abortController.abort()},request.abortSignal.addEventListener("abort",abortListener)}request.timeout>0&&setTimeout((()=>{abortController.abort()}),request.timeout);const acceptEncoding=request.headers.get("Accept-Encoding"),shouldDecompress=(null==acceptEncoding?void 0:acceptEncoding.includes("gzip"))||(null==acceptEncoding?void 0:acceptEncoding.includes("deflate"));let responseStream,body="function"==typeof request.body?request.body():request.body;if(body&&!request.headers.has("Content-Length")){const bodyLength=getBodyLength(body);null!==bodyLength&&request.headers.set("Content-Length",bodyLength)}try{if(body&&request.onUploadProgress){const onUploadProgress=request.onUploadProgress,uploadReportStream=new ReportTransform(onUploadProgress);uploadReportStream.on("error",(e=>{logger.error("Error in upload progress",e)})),isReadableStream(body)?body.pipe(uploadReportStream):uploadReportStream.end(body),body=uploadReportStream}const res=await this.makeRequest(request,abortController,body),headers=getResponseHeaders(res),response={status:null!==(_a=res.statusCode)&&void 0!==_a?_a:0,headers:headers,request:request};if("HEAD"===request.method)return res.resume(),response;responseStream=shouldDecompress?getDecodedResponseStream(res,headers):res;const onDownloadProgress=request.onDownloadProgress;if(onDownloadProgress){const downloadReportStream=new ReportTransform(onDownloadProgress);downloadReportStream.on("error",(e=>{logger.error("Error in download progress",e)})),responseStream.pipe(downloadReportStream),responseStream=downloadReportStream}return(null===(_b=request.streamResponseStatusCodes)||void 0===_b?void 0:_b.has(Number.POSITIVE_INFINITY))||(null===(_c=request.streamResponseStatusCodes)||void 0===_c?void 0:_c.has(response.status))?response.readableStreamBody=responseStream:response.bodyAsText=await streamToText(responseStream),response}finally{if(request.abortSignal&&abortListener){let uploadStreamDone=Promise.resolve();isReadableStream(body)&&(uploadStreamDone=isStreamComplete(body));let downloadStreamDone=Promise.resolve();isReadableStream(responseStream)&&(downloadStreamDone=isStreamComplete(responseStream)),Promise.all([uploadStreamDone,downloadStreamDone]).then((()=>{var _a;abortListener&&(null===(_a=request.abortSignal)||void 0===_a||_a.removeEventListener("abort",abortListener))})).catch((e=>{logger.warning("Error when cleaning up abortListener on httpRequest",e)}))}}}makeRequest(request,abortController,body){var _a;const url=new URL(request.url),isInsecure="https:"!==url.protocol;if(isInsecure&&!request.allowInsecureConnection)throw new Error(`Cannot connect to ${request.url} while allowInsecureConnection is false.`);const options={agent:null!==(_a=request.agent)&&void 0!==_a?_a:this.getOrCreateAgent(request,isInsecure),hostname:url.hostname,path:`${url.pathname}${url.search}`,port:url.port,method:request.method,headers:request.headers.toJSON({preserveCase:!0})};return new Promise(((resolve,reject)=>{const req=isInsecure?http.request(options,resolve):https.request(options,resolve);req.once("error",(err=>{var _a;reject(new RestError(err.message,{code:null!==(_a=err.code)&&void 0!==_a?_a:RestError.REQUEST_SEND_ERROR,request:request}))})),abortController.signal.addEventListener("abort",(()=>{const abortError=new AbortError("The operation was aborted.");req.destroy(abortError),reject(abortError)})),body&&isReadableStream(body)?body.pipe(req):body?"string"==typeof body||Buffer.isBuffer(body)?req.end(body):isArrayBuffer(body)?req.end(ArrayBuffer.isView(body)?Buffer.from(body.buffer):Buffer.from(body)):(logger.error("Unrecognized body type",body),reject(new RestError("Unrecognized body type"))):req.end()}))}getOrCreateAgent(request,isInsecure){var _a;const disableKeepAlive=request.disableKeepAlive;if(isInsecure)return disableKeepAlive?http.globalAgent:(this.cachedHttpAgent||(this.cachedHttpAgent=new http.Agent({keepAlive:!0})),this.cachedHttpAgent);{if(disableKeepAlive&&!request.tlsSettings)return https.globalAgent;const tlsSettings=null!==(_a=request.tlsSettings)&&void 0!==_a?_a:DEFAULT_TLS_SETTINGS;let agent=this.cachedHttpsAgents.get(tlsSettings);return agent&&agent.options.keepAlive===!disableKeepAlive||(logger.info("No cached TLS Agent exist, creating a new Agent"),agent=new https.Agent(Object.assign({keepAlive:!disableKeepAlive},tlsSettings)),this.cachedHttpsAgents.set(tlsSettings,agent)),agent}}}function getResponseHeaders(res){const headers=createHttpHeaders();for(const header of Object.keys(res.headers)){const value=res.headers[header];Array.isArray(value)?value.length>0&&headers.set(header,value[0]):value&&headers.set(header,value)}return headers}function getDecodedResponseStream(stream,headers){const contentEncoding=headers.get("Content-Encoding");if("gzip"===contentEncoding){const unzip=zlib.createGunzip();return stream.pipe(unzip),unzip}if("deflate"===contentEncoding){const inflate=zlib.createInflate();return stream.pipe(inflate),inflate}return stream}function streamToText(stream){return new Promise(((resolve,reject)=>{const buffer=[];stream.on("data",(chunk=>{Buffer.isBuffer(chunk)?buffer.push(chunk):buffer.push(Buffer.from(chunk))})),stream.on("end",(()=>{resolve(Buffer.concat(buffer).toString("utf8"))})),stream.on("error",(e=>{e&&"AbortError"===(null==e?void 0:e.name)?reject(e):reject(new RestError(`Error reading response as text: ${e.message}`,{code:RestError.PARSE_ERROR}))}))}))}export function getBodyLength(body){return body?Buffer.isBuffer(body)?body.length:isReadableStream(body)?null:isArrayBuffer(body)?body.byteLength:"string"==typeof body?Buffer.from(body).length:null:0}export function createNodeHttpClient(){return new NodeHttpClient}