import{HttpsProxyAgent}from"https-proxy-agent";import{HttpProxyAgent}from"http-proxy-agent";import{logger}from"../log";const HTTPS_PROXY="HTTPS_PROXY",HTTP_PROXY="HTTP_PROXY",ALL_PROXY="ALL_PROXY",NO_PROXY="NO_PROXY";export const proxyPolicyName="proxyPolicy";export const globalNoProxyList=[];let noProxyListLoaded=!1;const globalBypassedMap=new Map;function getEnvironmentValue(name){return process.env[name]?process.env[name]:process.env[name.toLowerCase()]?process.env[name.toLowerCase()]:void 0}function loadEnvironmentProxyValue(){if(!process)return;const httpsProxy=getEnvironmentValue(HTTPS_PROXY),allProxy=getEnvironmentValue(ALL_PROXY),httpProxy=getEnvironmentValue(HTTP_PROXY);return httpsProxy||allProxy||httpProxy}function isBypassed(uri,noProxyList,bypassedMap){if(0===noProxyList.length)return!1;const host=new URL(uri).hostname;if(null==bypassedMap?void 0:bypassedMap.has(host))return bypassedMap.get(host);let isBypassedFlag=!1;for(const pattern of noProxyList)"."===pattern[0]?(host.endsWith(pattern)||host.length===pattern.length-1&&host===pattern.slice(1))&&(isBypassedFlag=!0):host===pattern&&(isBypassedFlag=!0);return null==bypassedMap||bypassedMap.set(host,isBypassedFlag),isBypassedFlag}export function loadNoProxy(){const noProxy=getEnvironmentValue(NO_PROXY);return noProxyListLoaded=!0,noProxy?noProxy.split(",").map((item=>item.trim())).filter((item=>item.length)):[]}export function getDefaultProxySettings(proxyUrl){if(!proxyUrl&&!(proxyUrl=loadEnvironmentProxyValue()))return;const parsedUrl=new URL(proxyUrl);return{host:(parsedUrl.protocol?parsedUrl.protocol+"//":"")+parsedUrl.hostname,port:Number.parseInt(parsedUrl.port||"80"),username:parsedUrl.username,password:parsedUrl.password}}export function getProxyAgentOptions(proxySettings,{headers:headers,tlsSettings:tlsSettings}){let parsedProxyUrl;try{parsedProxyUrl=new URL(proxySettings.host)}catch(_error){throw new Error(`Expecting a valid host string in proxy settings, but found "${proxySettings.host}".`)}tlsSettings&&logger.warning("TLS settings are not supported in combination with custom Proxy, certificates provided to the client will be ignored.");const proxyAgentOptions={hostname:parsedProxyUrl.hostname,port:proxySettings.port,protocol:parsedProxyUrl.protocol,headers:headers.toJSON()};return proxySettings.username&&proxySettings.password?proxyAgentOptions.auth=`${proxySettings.username}:${proxySettings.password}`:proxySettings.username&&(proxyAgentOptions.auth=`${proxySettings.username}`),proxyAgentOptions}function setProxyAgentOnRequest(request,cachedAgents){if(request.agent)return;const isInsecure="https:"!==new URL(request.url).protocol,proxySettings=request.proxySettings;if(proxySettings)if(isInsecure){if(!cachedAgents.httpProxyAgent){const proxyAgentOptions=getProxyAgentOptions(proxySettings,request);cachedAgents.httpProxyAgent=new HttpProxyAgent(proxyAgentOptions)}request.agent=cachedAgents.httpProxyAgent}else{if(!cachedAgents.httpsProxyAgent){const proxyAgentOptions=getProxyAgentOptions(proxySettings,request);cachedAgents.httpsProxyAgent=new HttpsProxyAgent(proxyAgentOptions)}request.agent=cachedAgents.httpsProxyAgent}}export function proxyPolicy(proxySettings=getDefaultProxySettings(),options){noProxyListLoaded||globalNoProxyList.push(...loadNoProxy());const cachedAgents={};return{name:proxyPolicyName,async sendRequest(request,next){var _a;return request.proxySettings||isBypassed(request.url,null!==(_a=null==options?void 0:options.customNoProxyList)&&void 0!==_a?_a:globalNoProxyList,(null==options?void 0:options.customNoProxyList)?void 0:globalBypassedMap)||(request.proxySettings=proxySettings),request.proxySettings&&setProxyAgentOnRequest(request,cachedAgents),next(request)}}}