import{delay}from"../util/helpers";import{createClientLogger}from"@azure/logger";import{AbortError}from"@azure/abort-controller";import{DEFAULT_RETRY_POLICY_COUNT}from"../constants";const retryPolicyLogger=createClientLogger("core-rest-pipeline retryPolicy"),retryPolicyName="retryPolicy";export function retryPolicy(strategies,options={maxRetries:DEFAULT_RETRY_POLICY_COUNT}){const logger=options.logger||retryPolicyLogger;return{name:retryPolicyName,async sendRequest(request,next){var _a,_b;let response,responseError,retryCount=-1;retryRequest:for(;;){retryCount+=1,response=void 0,responseError=void 0;try{logger.info(`Retry ${retryCount}: Attempting to send request`,request.requestId),response=await next(request),logger.info(`Retry ${retryCount}: Received a response from request`,request.requestId)}catch(e){if(logger.error(`Retry ${retryCount}: Received an error from request`,request.requestId),responseError=e,!e||"RestError"!==responseError.name)throw e;response=responseError.response}if(null===(_a=request.abortSignal)||void 0===_a?void 0:_a.aborted){logger.error(`Retry ${retryCount}: Request aborted.`);throw new AbortError}if(retryCount>=(null!==(_b=options.maxRetries)&&void 0!==_b?_b:DEFAULT_RETRY_POLICY_COUNT)){if(logger.info(`Retry ${retryCount}: Maximum retries reached. Returning the last received response, or throwing the last received error.`),responseError)throw responseError;if(response)return response;throw new Error("Maximum retries reached with no response or error to throw")}logger.info(`Retry ${retryCount}: Processing ${strategies.length} retry strategies.`);strategiesLoop:for(const strategy of strategies){const strategyLogger=strategy.logger||retryPolicyLogger;strategyLogger.info(`Retry ${retryCount}: Processing retry strategy ${strategy.name}.`);const modifiers=strategy.retry({retryCount:retryCount,response:response,responseError:responseError});if(modifiers.skipStrategy){strategyLogger.info(`Retry ${retryCount}: Skipped.`);continue strategiesLoop}const{errorToThrow:errorToThrow,retryAfterInMs:retryAfterInMs,redirectTo:redirectTo}=modifiers;if(errorToThrow)throw strategyLogger.error(`Retry ${retryCount}: Retry strategy ${strategy.name} throws error:`,errorToThrow),errorToThrow;if(retryAfterInMs||0===retryAfterInMs){strategyLogger.info(`Retry ${retryCount}: Retry strategy ${strategy.name} retries after ${retryAfterInMs}`),await delay(retryAfterInMs,void 0,{abortSignal:request.abortSignal});continue retryRequest}if(redirectTo){strategyLogger.info(`Retry ${retryCount}: Retry strategy ${strategy.name} redirects to ${redirectTo}`),request.url=redirectTo;continue retryRequest}}if(responseError)throw logger.info("None of the retry strategies could work with the received error. Throwing it."),responseError;if(response)return logger.info("None of the retry strategies could work with the received response. Returning it."),response}}}}