import{createTracingClient}from"@azure/core-tracing";import{SDK_VERSION}from"../constants";import{getUserAgentValue}from"../util/userAgent";import{logger}from"../log";import{getErrorMessage,isError}from"@azure/core-util";import{isRestError}from"../restError";export const tracingPolicyName="tracingPolicy";export function tracingPolicy(options={}){const userAgent=getUserAgentValue(options.userAgentPrefix),tracingClient=tryCreateTracingClient();return{name:tracingPolicyName,async sendRequest(request,next){var _a,_b;if(!tracingClient||!(null===(_a=request.tracingOptions)||void 0===_a?void 0:_a.tracingContext))return next(request);const{span:span,tracingContext:tracingContext}=null!==(_b=tryCreateSpan(tracingClient,request,userAgent))&&void 0!==_b?_b:{};if(!span||!tracingContext)return next(request);try{const response=await tracingClient.withContext(tracingContext,next,request);return tryProcessResponse(span,response),response}catch(err){throw tryProcessError(span,err),err}}}}function tryCreateTracingClient(){try{return createTracingClient({namespace:"",packageName:"@azure/core-rest-pipeline",packageVersion:SDK_VERSION})}catch(e){return void logger.warning(`Error when creating the TracingClient: ${getErrorMessage(e)}`)}}function tryCreateSpan(tracingClient,request,userAgent){try{const{span:span,updatedOptions:updatedOptions}=tracingClient.startSpan(`HTTP ${request.method}`,{tracingOptions:request.tracingOptions},{spanKind:"client",spanAttributes:{"http.method":request.method,"http.url":request.url,requestId:request.requestId}});if(!span.isRecording())return void span.end();userAgent&&span.setAttribute("http.user_agent",userAgent);const headers=tracingClient.createRequestHeaders(updatedOptions.tracingOptions.tracingContext);for(const[key,value]of Object.entries(headers))request.headers.set(key,value);return{span:span,tracingContext:updatedOptions.tracingOptions.tracingContext}}catch(e){return void logger.warning(`Skipping creating a tracing span due to an error: ${getErrorMessage(e)}`)}}function tryProcessError(span,error){try{span.setStatus({status:"error",error:isError(error)?error:void 0}),isRestError(error)&&error.statusCode&&span.setAttribute("http.status_code",error.statusCode),span.end()}catch(e){logger.warning(`Skipping tracing span processing due to an error: ${getErrorMessage(e)}`)}}function tryProcessResponse(span,response){try{span.setAttribute("http.status_code",response.status);const serviceRequestId=response.headers.get("x-ms-request-id");serviceRequestId&&span.setAttribute("serviceRequestId",serviceRequestId),span.setStatus({status:"success"}),span.end()}catch(e){logger.warning(`Skipping tracing span processing due to an error: ${getErrorMessage(e)}`)}}