import{AggregateAuthenticationError,CredentialUnavailableError}from"../errors";import{tracingClient}from"../util/tracing";import{credentialLogger,formatError,formatSuccess}from"../util/logging";export const logger=credentialLogger("ChainedTokenCredential");export class ChainedTokenCredential{constructor(...sources){this.UnavailableMessage="ChainedTokenCredential => failed to retrieve a token from the included credentials",this._sources=[],this._sources=sources}async getToken(scopes,options={}){let token=null,successfulCredentialName="";const errors=[];return tracingClient.withSpan("ChainedTokenCredential.getToken",options,(async updatedOptions=>{for(let i=0;i<this._sources.length&&null===token;i++)try{token=await this._sources[i].getToken(scopes,updatedOptions),successfulCredentialName=this._sources[i].constructor.name}catch(err){if("CredentialUnavailableError"!==err.name&&"AuthenticationRequiredError"!==err.name)throw logger.getToken.info(formatError(scopes,err)),err;errors.push(err)}if(!token&&errors.length>0){const err=new AggregateAuthenticationError(errors,"ChainedTokenCredential authentication failed.");throw logger.getToken.info(formatError(scopes,err)),err}if(logger.getToken.info(`Result for ${successfulCredentialName}: ${formatSuccess(scopes)}`),null===token)throw new CredentialUnavailableError("Failed to retrieve a valid token");return token}))}}