import{credentialLogger,formatError,formatSuccess,processEnvVars}from"../util/logging";import{ClientSecretCredential}from"./clientSecretCredential";import{AuthenticationError,CredentialUnavailableError}from"../errors";import{checkTenantId}from"../util/checkTenantId";import{tracingClient}from"../util/tracing";import{ClientCertificateCredential}from"./clientCertificateCredential";import{UsernamePasswordCredential}from"./usernamePasswordCredential";export const AllSupportedEnvironmentVariables=["AZURE_TENANT_ID","AZURE_CLIENT_ID","AZURE_CLIENT_SECRET","AZURE_CLIENT_CERTIFICATE_PATH","AZURE_USERNAME","AZURE_PASSWORD"];const credentialName="EnvironmentCredential",logger=credentialLogger(credentialName);export class EnvironmentCredential{constructor(options){this._credential=void 0;const assigned=processEnvVars(AllSupportedEnvironmentVariables).assigned.join(", ");logger.info(`Found the following environment variables: ${assigned}`);const tenantId=process.env.AZURE_TENANT_ID,clientId=process.env.AZURE_CLIENT_ID,clientSecret=process.env.AZURE_CLIENT_SECRET;if(tenantId&&checkTenantId(logger,tenantId),tenantId&&clientId&&clientSecret)return logger.info(`Invoking ClientSecretCredential with tenant ID: ${tenantId}, clientId: ${clientId} and clientSecret: [REDACTED]`),void(this._credential=new ClientSecretCredential(tenantId,clientId,clientSecret,options));const certificatePath=process.env.AZURE_CLIENT_CERTIFICATE_PATH;if(tenantId&&clientId&&certificatePath)return logger.info(`Invoking ClientCertificateCredential with tenant ID: ${tenantId}, clientId: ${clientId} and certificatePath: ${certificatePath}`),void(this._credential=new ClientCertificateCredential(tenantId,clientId,{certificatePath:certificatePath},options));const username=process.env.AZURE_USERNAME,password=process.env.AZURE_PASSWORD;tenantId&&clientId&&username&&password&&(logger.info(`Invoking UsernamePasswordCredential with tenant ID: ${tenantId}, clientId: ${clientId} and username: ${username}`),this._credential=new UsernamePasswordCredential(tenantId,clientId,username,password,options))}async getToken(scopes,options={}){return tracingClient.withSpan(`${credentialName}.getToken`,options,(async newOptions=>{if(this._credential)try{const result=await this._credential.getToken(scopes,newOptions);return logger.getToken.info(formatSuccess(scopes)),result}catch(err){const authenticationError=new AuthenticationError(400,{error:`${credentialName} authentication failed. To troubleshoot, visit https://aka.ms/azsdk/js/identity/environmentcredential/troubleshoot.`,error_description:err.message.toString().split("More details:").join("")});throw logger.getToken.info(formatError(scopes,authenticationError)),authenticationError}throw new CredentialUnavailableError(`${credentialName} is unavailable. No underlying credential could be used. To troubleshoot, visit https://aka.ms/azsdk/js/identity/environmentcredential/troubleshoot.`)}))}}