import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{credentialLogger}from"../../util/logging";import{mapScopesToResource}from"./utils";const msiName="ManagedIdentityCredential - AppServiceMSI 2017",logger=credentialLogger(msiName);function expiresOnParser(requestBody){return Date.parse(requestBody.expires_on)}function prepareRequestOptions(scopes,clientId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName}: Multiple scopes are not supported.`);const queryParameters={resource:resource,"api-version":"2017-09-01"};clientId&&(queryParameters.clientid=clientId);const query=new URLSearchParams(queryParameters);if(!process.env.MSI_ENDPOINT)throw new Error(`${msiName}: Missing environment variable: MSI_ENDPOINT`);if(!process.env.MSI_SECRET)throw new Error(`${msiName}: Missing environment variable: MSI_SECRET`);return{url:`${process.env.MSI_ENDPOINT}?${query.toString()}`,method:"GET",headers:createHttpHeaders({Accept:"application/json",secret:process.env.MSI_SECRET})}}export const appServiceMsi2017={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;const env=process.env,result=Boolean(env.MSI_ENDPOINT&&env.MSI_SECRET);return result||logger.info(`${msiName}: Unavailable. The environment variables needed are: MSI_ENDPOINT and MSI_SECRET.`),result},async getToken(configuration,getTokenOptions={}){const{identityClient:identityClient,scopes:scopes,clientId:clientId,resourceId:resourceId}=configuration;resourceId&&logger.warning(`${msiName}: managed Identity by resource Id is not supported. Argument resourceId might be ignored by the service.`),logger.info(`${msiName}: Using the endpoint and the secret coming form the environment variables: MSI_ENDPOINT=${process.env.MSI_ENDPOINT} and MSI_SECRET=[REDACTED].`);const request=createPipelineRequest(Object.assign(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions(scopes,clientId)),{allowInsecureConnection:!0})),tokenResponse=await identityClient.sendTokenRequest(request,expiresOnParser);return tokenResponse&&tokenResponse.accessToken||null}};