import https from"https";import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{credentialLogger}from"../../util/logging";import{mapScopesToResource}from"./utils";import{azureFabricVersion}from"./constants";const msiName="ManagedIdentityCredential - Fabric MSI",logger=credentialLogger(msiName);function expiresOnParser(requestBody){return Number(requestBody.expires_on)}function prepareRequestOptions(scopes,clientId,resourceId){const resource=mapScopesToResource(scopes);if(!resource)throw new Error(`${msiName}: Multiple scopes are not supported.`);const queryParameters={resource:resource,"api-version":azureFabricVersion};clientId&&(queryParameters.client_id=clientId),resourceId&&(queryParameters.msi_res_id=resourceId);const query=new URLSearchParams(queryParameters);if(!process.env.IDENTITY_ENDPOINT)throw new Error("Missing environment variable: IDENTITY_ENDPOINT");if(!process.env.IDENTITY_HEADER)throw new Error("Missing environment variable: IDENTITY_HEADER");return{url:`${process.env.IDENTITY_ENDPOINT}?${query.toString()}`,method:"GET",headers:createHttpHeaders({Accept:"application/json",secret:process.env.IDENTITY_HEADER})}}export const fabricMsi={async isAvailable({scopes:scopes}){if(!mapScopesToResource(scopes))return logger.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;const env=process.env,result=Boolean(env.IDENTITY_ENDPOINT&&env.IDENTITY_HEADER&&env.IDENTITY_SERVER_THUMBPRINT);return result||logger.info(`${msiName}: Unavailable. The environment variables needed are: IDENTITY_ENDPOINT, IDENTITY_HEADER and IDENTITY_SERVER_THUMBPRINT`),result},async getToken(configuration,getTokenOptions={}){const{scopes:scopes,identityClient:identityClient,clientId:clientId,resourceId:resourceId}=configuration;resourceId&&logger.warning(`${msiName}: user defined managed Identity by resource Id is not supported. Argument resourceId might be ignored by the service.`),logger.info([`${msiName}:`,"Using the endpoint and the secret coming from the environment variables:",`IDENTITY_ENDPOINT=${process.env.IDENTITY_ENDPOINT},`,"IDENTITY_HEADER=[REDACTED] and","IDENTITY_SERVER_THUMBPRINT=[REDACTED]."].join(" "));const request=createPipelineRequest(Object.assign({abortSignal:getTokenOptions.abortSignal},prepareRequestOptions(scopes,clientId,resourceId)));request.agent=new https.Agent({rejectUnauthorized:!1});const tokenResponse=await identityClient.sendTokenRequest(request,expiresOnParser);return tokenResponse&&tokenResponse.accessToken||null}};