import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{IdentityClient}from"../client/identityClient";import{credentialLogger,formatError,formatSuccess}from"../util/logging";import{getIdentityTokenEndpointSuffix}from"../util/identityTokenEndpoint";import{tracingClient}from"../util/tracing";import{checkTenantId}from"../util/checkTenantId";const logger=credentialLogger("UsernamePasswordCredential");export class UsernamePasswordCredential{constructor(tenantIdOrName,clientId,username,password,options){checkTenantId(logger,tenantIdOrName),this.identityClient=new IdentityClient(options),this.tenantId=tenantIdOrName,this.clientId=clientId,this.username=username,this.password=password}async getToken(scopes,options){const{span:span,updatedOptions:newOptions}=tracingClient.startSpan("UsernamePasswordCredential.getToken",options);try{const urlSuffix=getIdentityTokenEndpointSuffix(this.tenantId),params=new URLSearchParams({response_type:"token",grant_type:"password",client_id:this.clientId,username:this.username,password:this.password,scope:"string"==typeof scopes?scopes:scopes.join(" ")}),webResource=createPipelineRequest({url:`${this.identityClient.authorityHost}/${this.tenantId}/${urlSuffix}`,method:"POST",body:params.toString(),headers:createHttpHeaders({Accept:"application/json","Content-Type":"application/x-www-form-urlencoded"}),abortSignal:options&&options.abortSignal,tracingOptions:newOptions.tracingOptions}),tokenResponse=await this.identityClient.sendTokenRequest(webResource);return logger.getToken.info(formatSuccess(scopes)),tokenResponse&&tokenResponse.accessToken||null}catch(err){throw span.setStatus({status:"error",error:err}),logger.getToken.info(formatError(scopes,err)),err}finally{span.end()}}}