import{DefaultTenantId}from"../../constants";import{resolveTenantId}from"../../util/resolveTenantId";import{processMultiTenantRequest}from"../../util/validateMultiTenant";import{AuthenticationRequiredError,CredentialUnavailableError}from"../../errors";import{MsalBaseUtilities,getAuthority,getKnownAuthorities}from"../utils";export function defaultBrowserMsalConfig(options){const tenantId=options.tenantId||DefaultTenantId,authority=getAuthority(tenantId,options.authorityHost);return{auth:{clientId:options.clientId,authority:authority,knownAuthorities:getKnownAuthorities(tenantId,authority),redirectUri:options.redirectUri||self.location.origin}}}export class MsalBrowser extends MsalBaseUtilities{constructor(options){if(super(options),this.logger=options.logger,this.loginStyle=options.loginStyle,!options.clientId)throw new CredentialUnavailableError("A client ID is required in browsers");this.clientId=options.clientId,this.tenantId=resolveTenantId(this.logger,options.tenantId,options.clientId),this.authorityHost=options.authorityHost,this.msalConfig=defaultBrowserMsalConfig(options),this.disableAutomaticAuthentication=options.disableAutomaticAuthentication,options.authenticationRecord&&(this.account=Object.assign(Object.assign({},options.authenticationRecord),{tenantId:this.tenantId}))}async init(){}async logout(){var _a;null===(_a=this.app)||void 0===_a||_a.logout()}async getToken(scopes,options={}){const tenantId=processMultiTenantRequest(this.tenantId,options)||this.tenantId;return options.authority||(options.authority=getAuthority(tenantId,this.authorityHost)),await this.handleRedirect(),await this.getActiveAccount()||this.disableAutomaticAuthentication||await this.login(scopes),this.getTokenSilent(scopes).catch((err=>{if("AuthenticationRequiredError"!==err.name)throw err;if(null==options?void 0:options.disableAutomaticAuthentication)throw new AuthenticationRequiredError({scopes:scopes,getTokenOptions:options,message:"Automatic authentication has been disabled. You may call the authentication() method."});return this.logger.info(`Silent authentication failed, falling back to interactive method ${this.loginStyle}`),this.doGetToken(scopes)}))}}