import*as msalNode from"@azure/msal-node";import{IdentityClient}from"../../client/identityClient";import{DeveloperSignOnClientId}from"../../constants";import{resolveTenantId}from"../../util/resolveTenantId";import{AuthenticationRequiredError}from"../../errors";import{MsalBaseUtilities,defaultLoggerCallback,getAuthority,getKnownAuthorities,msalToPublic,publicToMsal}from"../utils";import{processMultiTenantRequest}from"../../util/validateMultiTenant";import{RegionalAuthority}from"../../regionalAuthority";let persistenceProvider;export const msalNodeFlowCacheControl={setPersistence(pluginProvider){persistenceProvider=pluginProvider}};export class MsalNode extends MsalBaseUtilities{constructor(options){var _a,_b,_c;if(super(options),this.requiresConfidential=!1,this.msalConfig=this.defaultNodeMsalConfig(options),this.tenantId=resolveTenantId(options.logger,options.tenantId,options.clientId),this.clientId=this.msalConfig.auth.clientId,(null==options?void 0:options.getAssertion)&&(this.getAssertion=options.getAssertion),void 0!==persistenceProvider&&(null===(_a=options.tokenCachePersistenceOptions)||void 0===_a?void 0:_a.enabled))this.createCachePlugin=()=>persistenceProvider(options.tokenCachePersistenceOptions);else if(null===(_b=options.tokenCachePersistenceOptions)||void 0===_b?void 0:_b.enabled)throw new Error(["Persistent token caching was requested, but no persistence provider was configured.","You must install the identity-cache-persistence plugin package (`npm install --save @azure/identity-cache-persistence`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(cachePersistencePlugin)` before using `tokenCachePersistenceOptions`."].join(" "));this.azureRegion=null!==(_c=options.regionalAuthority)&&void 0!==_c?_c:process.env.AZURE_REGIONAL_AUTHORITY_NAME,this.azureRegion===RegionalAuthority.AutoDiscoverRegion&&(this.azureRegion="AUTO_DISCOVER")}defaultNodeMsalConfig(options){const clientId=options.clientId||DeveloperSignOnClientId,tenantId=resolveTenantId(options.logger,options.tenantId,options.clientId);this.authorityHost=options.authorityHost||process.env.AZURE_AUTHORITY_HOST;const authority=getAuthority(tenantId,this.authorityHost);this.identityClient=new IdentityClient(Object.assign(Object.assign({},options.tokenCredentialOptions),{authorityHost:authority,loggingOptions:options.loggingOptions}));let clientCapabilities=["cp1"];return process.env.AZURE_IDENTITY_DISABLE_CP1&&(clientCapabilities=[]),{auth:{clientId:clientId,authority:authority,knownAuthorities:getKnownAuthorities(tenantId,authority),clientCapabilities:clientCapabilities},system:{networkClient:this.identityClient,loggerOptions:{loggerCallback:defaultLoggerCallback(options.logger)}}}}async init(options){if((null==options?void 0:options.abortSignal)&&options.abortSignal.addEventListener("abort",(()=>{this.identityClient.abortRequests(options.correlationId)})),!this.publicApp&&!this.confidentialApp)if(void 0!==this.createCachePlugin&&(this.msalConfig.cache={cachePlugin:await this.createCachePlugin()}),this.publicApp=new msalNode.PublicClientApplication(this.msalConfig),this.getAssertion&&(this.msalConfig.auth.clientAssertion=await this.getAssertion()),this.msalConfig.auth.clientSecret||this.msalConfig.auth.clientAssertion||this.msalConfig.auth.clientCertificate)this.confidentialApp=new msalNode.ConfidentialClientApplication(this.msalConfig);else if(this.requiresConfidential)throw new Error("Unable to generate the MSAL confidential client. Missing either the client's secret, certificate or assertion.")}withCancellation(promise,abortSignal,onCancel){return new Promise(((resolve,reject)=>{promise.then((msalToken=>resolve(msalToken))).catch(reject),abortSignal&&abortSignal.addEventListener("abort",(()=>{null==onCancel||onCancel()}))}))}async getActiveAccount(){var _a,_b,_c;if(this.account)return this.account;const cache=null!==(_b=null===(_a=this.confidentialApp)||void 0===_a?void 0:_a.getTokenCache())&&void 0!==_b?_b:null===(_c=this.publicApp)||void 0===_c?void 0:_c.getTokenCache(),accountsByTenant=await(null==cache?void 0:cache.getAllAccounts());if(accountsByTenant){if(1===accountsByTenant.length)return this.account=msalToPublic(this.clientId,accountsByTenant[0]),this.account;this.logger.info('More than one account was found authenticated for this Client ID and Tenant ID.\nHowever, no "authenticationRecord" has been provided for this credential,\ntherefore we\'re unable to pick between these accounts.\nA new login attempt will be requested, to ensure the correct account is picked.\nTo work with multiple accounts for the same Client ID and Tenant ID, please provide an "authenticationRecord" when initializing a credential to prevent this from happening.')}}async getTokenSilent(scopes,options){var _a,_b;if(await this.getActiveAccount(),!this.account)throw new AuthenticationRequiredError({scopes:scopes,getTokenOptions:options,message:"Silent authentication failed. We couldn't retrieve an active account from the cache."});const silentRequest={account:publicToMsal(this.account),correlationId:null==options?void 0:options.correlationId,scopes:scopes,authority:null==options?void 0:options.authority,claims:null==options?void 0:options.claims};try{this.logger.info("Attempting to acquire token silently");const response=null!==(_b=await(null===(_a=this.confidentialApp)||void 0===_a?void 0:_a.acquireTokenSilent(silentRequest)))&&void 0!==_b?_b:await this.publicApp.acquireTokenSilent(silentRequest);return this.handleResult(scopes,this.clientId,response||void 0)}catch(err){throw this.handleError(scopes,err,options)}}async getToken(scopes,options={}){const tenantId=processMultiTenantRequest(this.tenantId,options)||this.tenantId;options.authority=getAuthority(tenantId,this.authorityHost),options.correlationId=(null==options?void 0:options.correlationId)||this.generateUuid(),await this.init(options);try{const optionsClaims=options.claims;return optionsClaims&&(this.cachedClaims=optionsClaims),this.cachedClaims&&!optionsClaims&&(options.claims=this.cachedClaims),await this.getTokenSilent(scopes,options)}catch(err){if("AuthenticationRequiredError"!==err.name)throw err;if(null==options?void 0:options.disableAutomaticAuthentication)throw new AuthenticationRequiredError({scopes:scopes,getTokenOptions:options,message:"Automatic authentication has been disabled. You may call the authentication() method."});return this.logger.info("Silent authentication failed, falling back to interactive method."),this.doGetToken(scopes,options)}}}