import*as msalNode from"@azure/msal-node";import http from"http";import open from"open";import stoppable from"stoppable";import{credentialLogger,formatError,formatSuccess}from"../../util/logging";import{CredentialUnavailableError}from"../../errors";import{MsalNode}from"./msalNodeCommon";import{msalToPublic}from"../utils";export const interactiveBrowserMockable={open:open};export class MsalOpenBrowser extends MsalNode{constructor(options){super(options),this.logger=credentialLogger("Node.js MSAL Open Browser"),this.redirectUri=options.redirectUri,this.loginHint=options.loginHint;const url=new URL(this.redirectUri);this.port=parseInt(url.port),isNaN(this.port)&&(this.port=80),this.hostname=url.hostname}async acquireTokenByCode(request){return this.publicApp.acquireTokenByCode(request)}doGetToken(scopes,options){return new Promise(((resolve,reject)=>{const socketToDestroy=[],requestListener=(req,res)=>{var _a;if(!req.url)return void reject(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'));let url;try{url=new URL(req.url,this.redirectUri)}catch(e){return void reject(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'))}const tokenRequest={code:url.searchParams.get("code"),redirectUri:this.redirectUri,scopes:scopes,authority:null==options?void 0:options.authority,codeVerifier:null===(_a=this.pkceCodes)||void 0===_a?void 0:_a.verifier};this.acquireTokenByCode(tokenRequest).then((authResponse=>{(null==authResponse?void 0:authResponse.account)&&(this.account=msalToPublic(this.clientId,authResponse.account));const successMessage="Authentication Complete. You can close the browser and return to the application.";if(authResponse&&authResponse.expiresOn){const expiresOnTimestamp=null==authResponse?void 0:authResponse.expiresOn.valueOf();res.writeHead(200),res.end(successMessage),this.logger.getToken.info(formatSuccess(scopes)),resolve({expiresOnTimestamp:expiresOnTimestamp,token:authResponse.accessToken})}else{const errorMessage=formatError(scopes,`${url.searchParams.get("error")}. ${url.searchParams.get("error_description")}`);res.writeHead(500),res.end(errorMessage),this.logger.getToken.info(errorMessage),reject(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'))}cleanup()})).catch((()=>{const errorMessage=formatError(scopes,`${url.searchParams.get("error")}. ${url.searchParams.get("error_description")}`);res.writeHead(500),res.end(errorMessage),this.logger.getToken.info(errorMessage),reject(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"')),cleanup()}))},app=http.createServer(requestListener),server=stoppable(app),listen=app.listen(this.port,this.hostname,(()=>this.logger.info(`InteractiveBrowserCredential listening on port ${this.port}!`)));function cleanup(){listen&&listen.close();for(const socket of socketToDestroy)socket.destroy();server&&(server.close(),server.stop())}app.on("connection",(socket=>socketToDestroy.push(socket))),app.on("error",(err=>{cleanup();const code=err.code;reject(new CredentialUnavailableError("EACCES"===code||"EADDRINUSE"===code?[`InteractiveBrowserCredential: Access denied to port ${this.port}.`,"Try sending a redirect URI with a different port, as follows:",'`new InteractiveBrowserCredential({ redirectUri: "http://localhost:1337" })`'].join(" "):`InteractiveBrowserCredential: Failed to start the necessary web server. Error: ${err.message}`))})),app.on("listening",(()=>{const openPromise=this.openAuthCodeUrl(scopes,options),abortSignal=null==options?void 0:options.abortSignal;abortSignal&&abortSignal.addEventListener("abort",(()=>{cleanup(),reject(new Error("Aborted"))})),openPromise.then().catch((e=>{cleanup(),reject(e)}))}))}))}async openAuthCodeUrl(scopeArray,options){const cryptoProvider=new msalNode.CryptoProvider;this.pkceCodes=await cryptoProvider.generatePkceCodes();const authCodeUrlParameters={scopes:scopeArray,correlationId:null==options?void 0:options.correlationId,redirectUri:this.redirectUri,authority:null==options?void 0:options.authority,claims:null==options?void 0:options.claims,loginHint:this.loginHint,codeChallenge:this.pkceCodes.challenge,codeChallengeMethod:"S256"},response=await this.publicApp.getAuthCodeUrl(authCodeUrlParameters);try{await interactiveBrowserMockable.open(response,{wait:!0,newInstance:!0})}catch(e){throw new CredentialUnavailableError(`InteractiveBrowserCredential: Could not open a browser window. Error: ${e.message}`)}}}