import*as msalCommon from"@azure/msal-common";import{isNode}from"@azure/core-util";import{AbortError}from"@azure/abort-controller";import{v4 as uuidv4}from"uuid";import{formatError,formatSuccess}from"../util/logging";import{AuthenticationRequiredError,CredentialUnavailableError}from"../errors";import{DefaultAuthorityHost,DefaultTenantId}from"../constants";const LatestAuthenticationRecordVersion="1.0";export function ensureValidMsalToken(scopes,logger,msalToken,getTokenOptions){const error=message=>(logger.getToken.info(message),new AuthenticationRequiredError({scopes:Array.isArray(scopes)?scopes:[scopes],getTokenOptions:getTokenOptions,message:message}));if(!msalToken)throw error("No response");if(!msalToken.expiresOn)throw error('Response had no "expiresOn" property.');if(!msalToken.accessToken)throw error('Response had no "accessToken" property.')}export function getAuthority(tenantId,host){return host||(host=DefaultAuthorityHost),new RegExp(`${tenantId}/?$`).test(host)?host:host.endsWith("/")?host+tenantId:`${host}/${tenantId}`}export function getKnownAuthorities(tenantId,authorityHost){return"adfs"===tenantId&&authorityHost?[authorityHost]:[]}export const defaultLoggerCallback=(logger,platform=(isNode?"Node":"Browser"))=>(level,message,containsPii)=>{if(!containsPii)switch(level){case msalCommon.LogLevel.Error:return void logger.info(`MSAL ${platform} V2 error: ${message}`);case msalCommon.LogLevel.Info:return void logger.info(`MSAL ${platform} V2 info message: ${message}`);case msalCommon.LogLevel.Verbose:return void logger.info(`MSAL ${platform} V2 verbose message: ${message}`);case msalCommon.LogLevel.Warning:return void logger.info(`MSAL ${platform} V2 warning: ${message}`)}};export class MsalBaseUtilities{constructor(options){this.logger=options.logger,this.account=options.authenticationRecord}generateUuid(){return uuidv4()}handleResult(scopes,clientId,result,getTokenOptions){return(null==result?void 0:result.account)&&(this.account=msalToPublic(clientId,result.account)),ensureValidMsalToken(scopes,this.logger,result,getTokenOptions),this.logger.getToken.info(formatSuccess(scopes)),{token:result.accessToken,expiresOnTimestamp:result.expiresOn.getTime()}}handleError(scopes,error,getTokenOptions){if("AuthError"===error.name||"ClientAuthError"===error.name||"BrowserAuthError"===error.name){const msalError=error;switch(msalError.errorCode){case"endpoints_resolution_error":return this.logger.info(formatError(scopes,error.message)),new CredentialUnavailableError(error.message);case"device_code_polling_cancelled":return new AbortError("The authentication has been aborted by the caller.");case"consent_required":case"interaction_required":case"login_required":this.logger.info(formatError(scopes,`Authentication returned errorCode ${msalError.errorCode}`));break;default:this.logger.info(formatError(scopes,`Failed to acquire token: ${error.message}`))}}return"ClientConfigurationError"===error.name||"BrowserConfigurationAuthError"===error.name||"AbortError"===error.name?error:new AuthenticationRequiredError({scopes:scopes,getTokenOptions:getTokenOptions,message:error.message})}}export function publicToMsal(account){const[environment]=account.authority.match(/([a-z]*\.[a-z]*\.[a-z]*)/)||[];return Object.assign(Object.assign({},account),{localAccountId:account.homeAccountId,environment:environment})}export function msalToPublic(clientId,account){return{authority:getAuthority(account.tenantId,account.environment),homeAccountId:account.homeAccountId,tenantId:account.tenantId||DefaultTenantId,username:account.username,clientId:clientId,version:LatestAuthenticationRecordVersion}}export function serializeAuthenticationRecord(record){return JSON.stringify(record)}export function deserializeAuthenticationRecord(serializedRecord){const parsed=JSON.parse(serializedRecord);if(parsed.version&&parsed.version!==LatestAuthenticationRecordVersion)throw Error("Unsupported AuthenticationRecord version");return parsed}