import{__rest}from"tslib";import{bearerTokenAuthenticationPolicy}from"@azure/core-rest-pipeline";import{SDK_VERSION}from"../constants";import{KeyVaultClient}from"../generated";import{parseKeyVaultKeyIdentifier}from"../identifier";import{LATEST_API_VERSION}from"../keysModels";import{getKeyFromKeyBundle}from"../transformations";import{createHash}from"./crypto";import{logger}from"../log";import{createKeyVaultChallengeCallbacks}from"../../../keyvault-common/src";import{tracingClient}from"../tracing";export class RemoteCryptographyProvider{constructor(key,credential,pipelineOptions={}){var _a;let keyId;this.client=getOrInitializeClient(credential,pipelineOptions),this.key=key,keyId="string"==typeof key?key:key.id;try{const parsed=parseKeyVaultKeyIdentifier(keyId);if(""===parsed.name)throw new Error("Could not find 'name' of key in key URL");if(!parsed.vaultUrl||""===parsed.vaultUrl)throw new Error("Could not find 'vaultUrl' of key in key URL");this.vaultUrl=parsed.vaultUrl,this.name=parsed.name,this.version=null!==(_a=parsed.version)&&void 0!==_a?_a:""}catch(err){throw logger.error(err),new Error(`${keyId} is not a valid Key Vault key ID`)}}isSupported(_algorithm,_operation){return!0}encrypt(encryptParameters,options={}){const{algorithm:algorithm,plaintext:plaintext}=encryptParameters,params=__rest(encryptParameters,["algorithm","plaintext"]),requestOptions=Object.assign(Object.assign({},options),params);return tracingClient.withSpan("RemoteCryptographyProvider.encrypt",requestOptions,(async updatedOptions=>{const result=await this.client.encrypt(this.vaultUrl,this.name,this.version,algorithm,plaintext,updatedOptions);return{algorithm:encryptParameters.algorithm,result:result.result,keyID:this.getKeyID(),additionalAuthenticatedData:result.additionalAuthenticatedData,authenticationTag:result.authenticationTag,iv:result.iv}}))}decrypt(decryptParameters,options={}){const{algorithm:algorithm,ciphertext:ciphertext}=decryptParameters,params=__rest(decryptParameters,["algorithm","ciphertext"]),requestOptions=Object.assign(Object.assign({},options),params);return tracingClient.withSpan("RemoteCryptographyProvider.decrypt",requestOptions,(async updatedOptions=>({result:(await this.client.decrypt(this.vaultUrl,this.name,this.version,algorithm,ciphertext,updatedOptions)).result,keyID:this.getKeyID(),algorithm:algorithm})))}wrapKey(algorithm,keyToWrap,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.wrapKey",options,(async updatedOptions=>({result:(await this.client.wrapKey(this.vaultUrl,this.name,this.version,algorithm,keyToWrap,updatedOptions)).result,algorithm:algorithm,keyID:this.getKeyID()})))}unwrapKey(algorithm,encryptedKey,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.unwrapKey",options,(async updatedOptions=>({result:(await this.client.unwrapKey(this.vaultUrl,this.name,this.version,algorithm,encryptedKey,updatedOptions)).result,algorithm:algorithm,keyID:this.getKeyID()})))}sign(algorithm,digest,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.sign",options,(async updatedOptions=>({result:(await this.client.sign(this.vaultUrl,this.name,this.version,algorithm,digest,updatedOptions)).result,algorithm:algorithm,keyID:this.getKeyID()})))}verifyData(algorithm,data,signature,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.verifyData",options,(async updatedOptions=>{const hash=await createHash(algorithm,data);return this.verify(algorithm,hash,signature,updatedOptions)}))}verify(algorithm,digest,signature,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.verify",options,(async updatedOptions=>{const response=await this.client.verify(this.vaultUrl,this.name,this.version,algorithm,digest,signature,updatedOptions);return{result:!!response.value&&response.value,keyID:this.getKeyID()}}))}signData(algorithm,data,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.signData",options,(async updatedOptions=>{const digest=await createHash(algorithm,data);return{result:(await this.client.sign(this.vaultUrl,this.name,this.version,algorithm,digest,updatedOptions)).result,algorithm:algorithm,keyID:this.getKeyID()}}))}get keyId(){return this.getKeyID()}getKey(options={}){return tracingClient.withSpan("RemoteCryptographyProvider.getKey",options,(async updatedOptions=>{if("string"==typeof this.key){if(!this.name||""===this.name)throw new Error("getKey requires a key with a name");const response=await this.client.getKey(this.vaultUrl,this.name,options&&options.version?options.version:this.version?this.version:"",updatedOptions);this.key=getKeyFromKeyBundle(response)}return this.key}))}getKeyID(){let kid;return kid="string"!=typeof this.key?this.key.id:this.key,kid}}function getOrInitializeClient(credential,options){if(options.generatedClient)return options.generatedClient;const libInfo=`azsdk-js-keyvault-keys/${SDK_VERSION}`,userAgentOptions=options.userAgentOptions;options.userAgentOptions={userAgentPrefix:userAgentOptions&&userAgentOptions.userAgentPrefix?`${userAgentOptions.userAgentPrefix} ${libInfo}`:libInfo};const authPolicy=bearerTokenAuthenticationPolicy({credential:credential,scopes:[],challengeCallbacks:createKeyVaultChallengeCallbacks(options)}),internalPipelineOptions=Object.assign(Object.assign({},options),{loggingOptions:{logger:logger.info,allowedHeaderNames:["x-ms-keyvault-region","x-ms-keyvault-network-info","x-ms-keyvault-service-version"]}}),client=new KeyVaultClient(options.serviceVersion||LATEST_API_VERSION,internalPipelineOptions);return client.pipeline.addPolicy(authPolicy),client}