import{__asyncGenerator,__asyncValues,__await,__rest}from"tslib";import{bearerTokenAuthenticationPolicy}from"@azure/core-rest-pipeline";import{logger}from"./log";import"@azure/core-paging";import{KnownDeletionRecoveryLevel,KnownJsonWebKeyType}from"./generated/models";import{KeyVaultClient}from"./generated/keyVaultClient";import{SDK_VERSION}from"./constants";import{createKeyVaultChallengeCallbacks}from"../../keyvault-common/src";import{DeleteKeyPoller}from"./lro/delete/poller";import{RecoverDeletedKeyPoller}from"./lro/recover/poller";import{KnownKeyExportEncryptionAlgorithm,KnownKeyOperations,KnownKeyTypes,LATEST_API_VERSION}from"./keysModels";import{CryptographyClient}from"./cryptographyClient";import{KnownEncryptionAlgorithms,KnownKeyCurveNames,KnownSignatureAlgorithms}from"./cryptographyClientModels";import{parseKeyVaultKeyIdentifier}from"./identifier";import{getDeletedKeyFromDeletedKeyItem,getKeyFromKeyBundle,getKeyPropertiesFromKeyItem,keyRotationTransformations}from"./transformations";import{tracingClient}from"./tracing";export{CryptographyClient,KnownDeletionRecoveryLevel,KnownKeyCurveNames,KnownKeyExportEncryptionAlgorithm,KnownEncryptionAlgorithms,KnownKeyOperations,KnownKeyTypes,KnownSignatureAlgorithms,parseKeyVaultKeyIdentifier,logger};export class KeyClient{constructor(vaultUrl,credential,pipelineOptions={}){this.vaultUrl=vaultUrl;const libInfo=`azsdk-js-keyvault-keys/${SDK_VERSION}`,userAgentOptions=pipelineOptions.userAgentOptions;pipelineOptions.userAgentOptions={userAgentPrefix:userAgentOptions&&userAgentOptions.userAgentPrefix?`${userAgentOptions.userAgentPrefix} ${libInfo}`:libInfo};const authPolicy=bearerTokenAuthenticationPolicy({credential:credential,scopes:[],challengeCallbacks:createKeyVaultChallengeCallbacks(pipelineOptions)}),internalPipelineOptions=Object.assign(Object.assign({},pipelineOptions),{loggingOptions:{logger:logger.info,allowedHeaderNames:["x-ms-keyvault-region","x-ms-keyvault-network-info","x-ms-keyvault-service-version"]}});this.credential=credential,this.client=new KeyVaultClient(pipelineOptions.serviceVersion||LATEST_API_VERSION,internalPipelineOptions),this.client.pipeline.addPolicy(authPolicy)}createKey(name,keyType,options){let unflattenedOptions={};if(options){const{enabled:enabled,notBefore:notBefore,expiresOn:expires,exportable:exportable}=options,remainingOptions=__rest(options,["enabled","notBefore","expiresOn","exportable"]);unflattenedOptions=Object.assign(Object.assign({},remainingOptions),{keyAttributes:{enabled:enabled,notBefore:notBefore,expires:expires,exportable:exportable}})}return tracingClient.withSpan("KeyClient.createKey",unflattenedOptions,(async updatedOptions=>{const response=await this.client.createKey(this.vaultUrl,name,keyType,updatedOptions);return getKeyFromKeyBundle(response)}))}async createEcKey(name,options){const keyType=(null==options?void 0:options.hsm)?KnownJsonWebKeyType.ECHSM:KnownJsonWebKeyType.EC;return this.createKey(name,keyType,options)}async createRsaKey(name,options){const keyType=(null==options?void 0:options.hsm)?KnownJsonWebKeyType.RSAHSM:KnownJsonWebKeyType.RSA;return this.createKey(name,keyType,options)}async createOctKey(name,options){const keyType=(null==options?void 0:options.hsm)?KnownJsonWebKeyType.OctHSM:KnownJsonWebKeyType.Oct;return this.createKey(name,keyType,options)}importKey(name,key,options){let unflattenedOptions={};if(options){const{enabled:enabled,notBefore:notBefore,exportable:exportable,expiresOn:expires,hardwareProtected:hsm}=options,remainingOptions=__rest(options,["enabled","notBefore","exportable","expiresOn","hardwareProtected"]);unflattenedOptions=Object.assign(Object.assign({},remainingOptions),{keyAttributes:{enabled:enabled,notBefore:notBefore,expires:expires,hsm:hsm,exportable:exportable}})}return tracingClient.withSpan("KeyClient.importKey",unflattenedOptions,(async updatedOptions=>{const response=await this.client.importKey(this.vaultUrl,name,key,updatedOptions);return getKeyFromKeyBundle(response)}))}getCryptographyClient(keyName,options){const keyUrl=new URL(["keys",keyName,null==options?void 0:options.keyVersion].filter(Boolean).join("/"),this.vaultUrl),constructorOptions={generatedClient:this.client};return new CryptographyClient(keyUrl.toString(),this.credential,constructorOptions)}async beginDeleteKey(name,options={}){const poller=new DeleteKeyPoller({name:name,vaultUrl:this.vaultUrl,client:this.client,intervalInMs:options.intervalInMs,resumeFrom:options.resumeFrom,operationOptions:options});return await poller.poll(),poller}updateKeyProperties(...args){const[name,keyVersion,options]=this.disambiguateUpdateKeyPropertiesArgs(args);return tracingClient.withSpan("KeyClient.updateKeyProperties",options,(async updatedOptions=>{const{enabled:enabled,notBefore:notBefore,expiresOn:expires}=updatedOptions,remainingOptions=__rest(updatedOptions,["enabled","notBefore","expiresOn"]),unflattenedOptions=Object.assign(Object.assign({},remainingOptions),{keyAttributes:{enabled:enabled,notBefore:notBefore,expires:expires}}),response=await this.client.updateKey(this.vaultUrl,name,keyVersion,unflattenedOptions);return getKeyFromKeyBundle(response)}))}disambiguateUpdateKeyPropertiesArgs(args){return"string"==typeof args[1]?[args[0],args[1],args[2]||{}]:[args[0],"",args[1]||{}]}getKey(name,options={}){return tracingClient.withSpan("KeyClient.getKey",options,(async updatedOptions=>{const response=await this.client.getKey(this.vaultUrl,name,options&&options.version?options.version:"",updatedOptions);return getKeyFromKeyBundle(response)}))}getDeletedKey(name,options={}){return tracingClient.withSpan("KeyClient.getDeletedKey",options,(async updatedOptions=>{const response=await this.client.getDeletedKey(this.vaultUrl,name,updatedOptions);return getKeyFromKeyBundle(response)}))}purgeDeletedKey(name,options={}){return tracingClient.withSpan("KeyClient.purgeDeletedKey",options,(async updatedOptions=>{await this.client.purgeDeletedKey(this.vaultUrl,name,updatedOptions)}))}async beginRecoverDeletedKey(name,options={}){const poller=new RecoverDeletedKeyPoller({name:name,vaultUrl:this.vaultUrl,client:this.client,intervalInMs:options.intervalInMs,resumeFrom:options.resumeFrom,operationOptions:options});return await poller.poll(),poller}backupKey(name,options={}){return tracingClient.withSpan("KeyClient.backupKey",options,(async updatedOptions=>(await this.client.backupKey(this.vaultUrl,name,updatedOptions)).value))}async restoreKeyBackup(backup,options={}){return tracingClient.withSpan("KeyClient.restoreKeyBackup",options,(async updatedOptions=>{const response=await this.client.restoreKey(this.vaultUrl,backup,updatedOptions);return getKeyFromKeyBundle(response)}))}getRandomBytes(count,options={}){return tracingClient.withSpan("KeyClient.getRandomBytes",options,(async updatedOptions=>(await this.client.getRandomBytes(this.vaultUrl,count,updatedOptions)).value))}rotateKey(name,options={}){return tracingClient.withSpan("KeyClient.rotateKey",options,(async updatedOptions=>{const key=await this.client.rotateKey(this.vaultUrl,name,updatedOptions);return getKeyFromKeyBundle(key)}))}releaseKey(name,targetAttestationToken,options={}){return tracingClient.withSpan("KeyClient.releaseKey",options,(async updatedOptions=>{const{nonce:nonce,algorithm:algorithm}=updatedOptions,rest=__rest(updatedOptions,["nonce","algorithm"]);return{value:(await this.client.release(this.vaultUrl,name,(null==options?void 0:options.version)||"",targetAttestationToken,Object.assign({enc:algorithm,nonce:nonce},rest))).value}}))}getKeyRotationPolicy(keyName,options={}){return tracingClient.withSpan("KeyClient.getKeyRotationPolicy",options,(async()=>{const policy=await this.client.getKeyRotationPolicy(this.vaultUrl,keyName);return keyRotationTransformations.generatedToPublic(policy)}))}updateKeyRotationPolicy(keyName,policy,options={}){return tracingClient.withSpan("KeyClient.updateKeyRotationPolicy",options,(async updatedOptions=>{const result=await this.client.updateKeyRotationPolicy(this.vaultUrl,keyName,keyRotationTransformations.propertiesToGenerated(policy),updatedOptions);return keyRotationTransformations.generatedToPublic(result)}))}listPropertiesOfKeyVersionsPage(name,continuationState,options){return __asyncGenerator(this,arguments,(function*(){if(null==continuationState.continuationToken){const optionsComplete=Object.assign({maxresults:continuationState.maxPageSize},options),currentSetResponse=yield __await(tracingClient.withSpan("KeyClient.listPropertiesOfKeyVersionsPage",optionsComplete,(async updatedOptions=>this.client.getKeyVersions(this.vaultUrl,name,updatedOptions))));continuationState.continuationToken=currentSetResponse.nextLink,currentSetResponse.value&&(yield yield __await(currentSetResponse.value.map(getKeyPropertiesFromKeyItem,this)))}for(;continuationState.continuationToken;){const currentSetResponse=yield __await(tracingClient.withSpan("KeyClient.listPropertiesOfKeyVersionsPage",options||{},(async updatedOptions=>this.client.getKeyVersionsNext(this.vaultUrl,continuationState.continuationToken,name,updatedOptions))));if(continuationState.continuationToken=currentSetResponse.nextLink,!currentSetResponse.value)break;yield yield __await(currentSetResponse.value.map(getKeyPropertiesFromKeyItem,this))}}))}listPropertiesOfKeyVersionsAll(name,options){return __asyncGenerator(this,arguments,(function*(){var _a,e_1,_b,_c;const f={};try{for(var _f,_d=!0,_e=__asyncValues(this.listPropertiesOfKeyVersionsPage(name,f,options));!(_a=(_f=yield __await(_e.next())).done);){_c=_f.value,_d=!1;try{const page=_c;for(const item of page)yield yield __await(item)}finally{_d=!0}}}catch(e_1_1){e_1={error:e_1_1}}finally{try{_d||_a||!(_b=_e.return)||(yield __await(_b.call(_e)))}finally{if(e_1)throw e_1.error}}}))}listPropertiesOfKeyVersions(name,options={}){const iter=this.listPropertiesOfKeyVersionsAll(name,options);return{next:()=>iter.next(),[Symbol.asyncIterator](){return this},byPage:(settings={})=>this.listPropertiesOfKeyVersionsPage(name,settings,options)}}listPropertiesOfKeysPage(continuationState,options){return __asyncGenerator(this,arguments,(function*(){if(null==continuationState.continuationToken){const optionsComplete=Object.assign({maxresults:continuationState.maxPageSize},options),currentSetResponse=yield __await(tracingClient.withSpan("KeyClient.listPropertiesOfKeysPage",optionsComplete,(async updatedOptions=>this.client.getKeys(this.vaultUrl,updatedOptions))));continuationState.continuationToken=currentSetResponse.nextLink,currentSetResponse.value&&(yield yield __await(currentSetResponse.value.map(getKeyPropertiesFromKeyItem,this)))}for(;continuationState.continuationToken;){const currentSetResponse=yield __await(tracingClient.withSpan("KeyClient.listPropertiesOfKeysPage",options||{},(async updatedOptions=>this.client.getKeysNext(this.vaultUrl,continuationState.continuationToken,updatedOptions))));if(continuationState.continuationToken=currentSetResponse.nextLink,!currentSetResponse.value)break;yield yield __await(currentSetResponse.value.map(getKeyPropertiesFromKeyItem,this))}}))}listPropertiesOfKeysAll(options){return __asyncGenerator(this,arguments,(function*(){var _a,e_2,_b,_c;const f={};try{for(var _f,_d=!0,_e=__asyncValues(this.listPropertiesOfKeysPage(f,options));!(_a=(_f=yield __await(_e.next())).done);){_c=_f.value,_d=!1;try{const page=_c;for(const item of page)yield yield __await(item)}finally{_d=!0}}}catch(e_2_1){e_2={error:e_2_1}}finally{try{_d||_a||!(_b=_e.return)||(yield __await(_b.call(_e)))}finally{if(e_2)throw e_2.error}}}))}listPropertiesOfKeys(options={}){const iter=this.listPropertiesOfKeysAll(options);return{next:()=>iter.next(),[Symbol.asyncIterator](){return this},byPage:(settings={})=>this.listPropertiesOfKeysPage(settings,options)}}listDeletedKeysPage(continuationState,options){return __asyncGenerator(this,arguments,(function*(){if(null==continuationState.continuationToken){const optionsComplete=Object.assign({maxresults:continuationState.maxPageSize},options),currentSetResponse=yield __await(tracingClient.withSpan("KeyClient.listDeletedKeysPage",optionsComplete,(async updatedOptions=>this.client.getDeletedKeys(this.vaultUrl,updatedOptions))));continuationState.continuationToken=currentSetResponse.nextLink,currentSetResponse.value&&(yield yield __await(currentSetResponse.value.map(getDeletedKeyFromDeletedKeyItem,this)))}for(;continuationState.continuationToken;){const currentSetResponse=yield __await(tracingClient.withSpan("KeyClient.listDeletedKeysPage",options||{},(async updatedOptions=>this.client.getDeletedKeysNext(this.vaultUrl,continuationState.continuationToken,updatedOptions))));if(continuationState.continuationToken=currentSetResponse.nextLink,!currentSetResponse.value)break;yield yield __await(currentSetResponse.value.map(getDeletedKeyFromDeletedKeyItem,this))}}))}listDeletedKeysAll(options){return __asyncGenerator(this,arguments,(function*(){var _a,e_3,_b,_c;const f={};try{for(var _f,_d=!0,_e=__asyncValues(this.listDeletedKeysPage(f,options));!(_a=(_f=yield __await(_e.next())).done);){_c=_f.value,_d=!1;try{const page=_c;for(const item of page)yield yield __await(item)}finally{_d=!0}}}catch(e_3_1){e_3={error:e_3_1}}finally{try{_d||_a||!(_b=_e.return)||(yield __await(_b.call(_e)))}finally{if(e_3)throw e_3.error}}}))}listDeletedKeys(options={}){const iter=this.listDeletedKeysAll(options);return{next:()=>iter.next(),[Symbol.asyncIterator](){return this},byPage:(settings={})=>this.listDeletedKeysPage(settings,options)}}}