"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var tslib=require("tslib"),coreRestPipeline=require("@azure/core-rest-pipeline"),logger$1=require("@azure/logger");require("@azure/core-paging");var coreClient=require("@azure/core-client"),coreHttpCompat=require("@azure/core-http-compat"),coreTracing=require("@azure/core-tracing"),coreUtil=require("@azure/core-util"),coreLro=require("@azure/core-lro"),crypto=require("crypto"),constants=require("constants");function _interopNamespace(e){if(e&&e.__esModule)return e;var n=Object.create(null);return e&&Object.keys(e).forEach((function(k){if("default"!==k){var d=Object.getOwnPropertyDescriptor(e,k);Object.defineProperty(n,k,d.get?d:{enumerable:!0,get:function(){return e[k]}})}})),n.default=e,Object.freeze(n)}var coreRestPipeline__namespace=_interopNamespace(coreRestPipeline),coreClient__namespace=_interopNamespace(coreClient),coreHttpCompat__namespace=_interopNamespace(coreHttpCompat),crypto__namespace=_interopNamespace(crypto);const logger=logger$1.createClientLogger("keyvault-keys");var KnownApiVersion74,KnownJsonWebKeyOperation,KnownJsonWebKeyEncryptionAlgorithm,KnownKeyEncryptionAlgorithm;!function(KnownApiVersion74){KnownApiVersion74.Seven4="7.4"}(KnownApiVersion74||(KnownApiVersion74={})),exports.KnownKeyTypes=void 0,function(KnownJsonWebKeyType){KnownJsonWebKeyType.EC="EC",KnownJsonWebKeyType.ECHSM="EC-HSM",KnownJsonWebKeyType.RSA="RSA",KnownJsonWebKeyType.RSAHSM="RSA-HSM",KnownJsonWebKeyType.Oct="oct",KnownJsonWebKeyType.OctHSM="oct-HSM"}(exports.KnownKeyTypes||(exports.KnownKeyTypes={})),function(KnownJsonWebKeyOperation){KnownJsonWebKeyOperation.Encrypt="encrypt",KnownJsonWebKeyOperation.Decrypt="decrypt",KnownJsonWebKeyOperation.Sign="sign",KnownJsonWebKeyOperation.Verify="verify",KnownJsonWebKeyOperation.WrapKey="wrapKey",KnownJsonWebKeyOperation.UnwrapKey="unwrapKey",KnownJsonWebKeyOperation.Import="import",KnownJsonWebKeyOperation.Export="export"}(KnownJsonWebKeyOperation||(KnownJsonWebKeyOperation={})),exports.KnownDeletionRecoveryLevel=void 0,function(KnownDeletionRecoveryLevel){KnownDeletionRecoveryLevel.Purgeable="Purgeable",KnownDeletionRecoveryLevel.RecoverablePurgeable="Recoverable+Purgeable",KnownDeletionRecoveryLevel.Recoverable="Recoverable",KnownDeletionRecoveryLevel.RecoverableProtectedSubscription="Recoverable+ProtectedSubscription",KnownDeletionRecoveryLevel.CustomizedRecoverablePurgeable="CustomizedRecoverable+Purgeable",KnownDeletionRecoveryLevel.CustomizedRecoverable="CustomizedRecoverable",KnownDeletionRecoveryLevel.CustomizedRecoverableProtectedSubscription="CustomizedRecoverable+ProtectedSubscription"}(exports.KnownDeletionRecoveryLevel||(exports.KnownDeletionRecoveryLevel={})),exports.KnownKeyCurveNames=void 0,function(KnownJsonWebKeyCurveName){KnownJsonWebKeyCurveName.P256="P-256",KnownJsonWebKeyCurveName.P384="P-384",KnownJsonWebKeyCurveName.P521="P-521",KnownJsonWebKeyCurveName.P256K="P-256K"}(exports.KnownKeyCurveNames||(exports.KnownKeyCurveNames={})),function(KnownJsonWebKeyEncryptionAlgorithm){KnownJsonWebKeyEncryptionAlgorithm.RSAOaep="RSA-OAEP",KnownJsonWebKeyEncryptionAlgorithm.RSAOaep256="RSA-OAEP-256",KnownJsonWebKeyEncryptionAlgorithm.RSA15="RSA1_5",KnownJsonWebKeyEncryptionAlgorithm.A128GCM="A128GCM",KnownJsonWebKeyEncryptionAlgorithm.A192GCM="A192GCM",KnownJsonWebKeyEncryptionAlgorithm.A256GCM="A256GCM",KnownJsonWebKeyEncryptionAlgorithm.A128KW="A128KW",KnownJsonWebKeyEncryptionAlgorithm.A192KW="A192KW",KnownJsonWebKeyEncryptionAlgorithm.A256KW="A256KW",KnownJsonWebKeyEncryptionAlgorithm.A128CBC="A128CBC",KnownJsonWebKeyEncryptionAlgorithm.A192CBC="A192CBC",KnownJsonWebKeyEncryptionAlgorithm.A256CBC="A256CBC",KnownJsonWebKeyEncryptionAlgorithm.A128Cbcpad="A128CBCPAD",KnownJsonWebKeyEncryptionAlgorithm.A192Cbcpad="A192CBCPAD",KnownJsonWebKeyEncryptionAlgorithm.A256Cbcpad="A256CBCPAD"}(KnownJsonWebKeyEncryptionAlgorithm||(KnownJsonWebKeyEncryptionAlgorithm={})),exports.KnownSignatureAlgorithms=void 0,function(KnownJsonWebKeySignatureAlgorithm){KnownJsonWebKeySignatureAlgorithm.PS256="PS256",KnownJsonWebKeySignatureAlgorithm.PS384="PS384",KnownJsonWebKeySignatureAlgorithm.PS512="PS512",KnownJsonWebKeySignatureAlgorithm.RS256="RS256",KnownJsonWebKeySignatureAlgorithm.RS384="RS384",KnownJsonWebKeySignatureAlgorithm.RS512="RS512",KnownJsonWebKeySignatureAlgorithm.Rsnull="RSNULL",KnownJsonWebKeySignatureAlgorithm.ES256="ES256",KnownJsonWebKeySignatureAlgorithm.ES384="ES384",KnownJsonWebKeySignatureAlgorithm.ES512="ES512",KnownJsonWebKeySignatureAlgorithm.ES256K="ES256K"}(exports.KnownSignatureAlgorithms||(exports.KnownSignatureAlgorithms={})),function(KnownKeyEncryptionAlgorithm){KnownKeyEncryptionAlgorithm.CKMRSAAESKEYWrap="CKM_RSA_AES_KEY_WRAP",KnownKeyEncryptionAlgorithm.RSAAESKEYWrap256="RSA_AES_KEY_WRAP_256",KnownKeyEncryptionAlgorithm.RSAAESKEYWrap384="RSA_AES_KEY_WRAP_384"}(KnownKeyEncryptionAlgorithm||(KnownKeyEncryptionAlgorithm={}));const KeyCreateParameters={type:{name:"Composite",className:"KeyCreateParameters",modelProperties:{kty:{serializedName:"kty",required:!0,type:{name:"String"}},keySize:{serializedName:"key_size",type:{name:"Number"}},publicExponent:{serializedName:"public_exponent",type:{name:"Number"}},keyOps:{serializedName:"key_ops",type:{name:"Sequence",element:{type:{name:"String"}}}},keyAttributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},curve:{serializedName:"crv",type:{name:"String"}},releasePolicy:{serializedName:"release_policy",type:{name:"Composite",className:"KeyReleasePolicy"}}}}},Attributes={type:{name:"Composite",className:"Attributes",modelProperties:{enabled:{serializedName:"enabled",type:{name:"Boolean"}},notBefore:{serializedName:"nbf",type:{name:"UnixTime"}},expires:{serializedName:"exp",type:{name:"UnixTime"}},created:{serializedName:"created",readOnly:!0,type:{name:"UnixTime"}},updated:{serializedName:"updated",readOnly:!0,type:{name:"UnixTime"}}}}},KeyReleasePolicy={type:{name:"Composite",className:"KeyReleasePolicy",modelProperties:{contentType:{defaultValue:"application/json; charset=utf-8",serializedName:"contentType",type:{name:"String"}},immutable:{serializedName:"immutable",type:{name:"Boolean"}},encodedPolicy:{serializedName:"data",type:{name:"Base64Url"}}}}},KeyBundle={type:{name:"Composite",className:"KeyBundle",modelProperties:{key:{serializedName:"key",type:{name:"Composite",className:"JsonWebKey"}},attributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},managed:{serializedName:"managed",readOnly:!0,type:{name:"Boolean"}},releasePolicy:{serializedName:"release_policy",type:{name:"Composite",className:"KeyReleasePolicy"}}}}},JsonWebKey={type:{name:"Composite",className:"JsonWebKey",modelProperties:{kid:{serializedName:"kid",type:{name:"String"}},kty:{serializedName:"kty",type:{name:"String"}},keyOps:{serializedName:"key_ops",type:{name:"Sequence",element:{type:{name:"String"}}}},n:{serializedName:"n",type:{name:"Base64Url"}},e:{serializedName:"e",type:{name:"Base64Url"}},d:{serializedName:"d",type:{name:"Base64Url"}},dp:{serializedName:"dp",type:{name:"Base64Url"}},dq:{serializedName:"dq",type:{name:"Base64Url"}},qi:{serializedName:"qi",type:{name:"Base64Url"}},p:{serializedName:"p",type:{name:"Base64Url"}},q:{serializedName:"q",type:{name:"Base64Url"}},k:{serializedName:"k",type:{name:"Base64Url"}},t:{serializedName:"key_hsm",type:{name:"Base64Url"}},crv:{serializedName:"crv",type:{name:"String"}},x:{serializedName:"x",type:{name:"Base64Url"}},y:{serializedName:"y",type:{name:"Base64Url"}}}}},KeyVaultError={type:{name:"Composite",className:"KeyVaultError",modelProperties:{error:{serializedName:"error",type:{name:"Composite",className:"ErrorModel"}}}}},ErrorModel={type:{name:"Composite",className:"ErrorModel",modelProperties:{code:{serializedName:"code",readOnly:!0,type:{name:"String"}},message:{serializedName:"message",readOnly:!0,type:{name:"String"}},innerError:{serializedName:"innererror",type:{name:"Composite",className:"ErrorModel"}}}}},KeyImportParameters={type:{name:"Composite",className:"KeyImportParameters",modelProperties:{hsm:{serializedName:"Hsm",type:{name:"Boolean"}},key:{serializedName:"key",type:{name:"Composite",className:"JsonWebKey"}},keyAttributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},releasePolicy:{serializedName:"release_policy",type:{name:"Composite",className:"KeyReleasePolicy"}}}}},KeyUpdateParameters={type:{name:"Composite",className:"KeyUpdateParameters",modelProperties:{keyOps:{serializedName:"key_ops",type:{name:"Sequence",element:{type:{name:"String"}}}},keyAttributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},releasePolicy:{serializedName:"release_policy",type:{name:"Composite",className:"KeyReleasePolicy"}}}}},KeyListResult={type:{name:"Composite",className:"KeyListResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"Sequence",element:{type:{name:"Composite",className:"KeyItem"}}}},nextLink:{serializedName:"nextLink",readOnly:!0,type:{name:"String"}}}}},KeyItem={type:{name:"Composite",className:"KeyItem",modelProperties:{kid:{serializedName:"kid",type:{name:"String"}},attributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},managed:{serializedName:"managed",readOnly:!0,type:{name:"Boolean"}}}}},BackupKeyResult={type:{name:"Composite",className:"BackupKeyResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"Base64Url"}}}}},KeyRestoreParameters={type:{name:"Composite",className:"KeyRestoreParameters",modelProperties:{keyBundleBackup:{serializedName:"value",required:!0,type:{name:"Base64Url"}}}}},KeyOperationsParameters={type:{name:"Composite",className:"KeyOperationsParameters",modelProperties:{algorithm:{serializedName:"alg",required:!0,type:{name:"String"}},value:{serializedName:"value",required:!0,type:{name:"Base64Url"}},iv:{serializedName:"iv",type:{name:"Base64Url"}},additionalAuthenticatedData:{serializedName:"aad",type:{name:"Base64Url"}},authenticationTag:{serializedName:"tag",type:{name:"Base64Url"}}}}},KeyOperationResult={type:{name:"Composite",className:"KeyOperationResult",modelProperties:{kid:{serializedName:"kid",readOnly:!0,type:{name:"String"}},result:{serializedName:"value",readOnly:!0,type:{name:"Base64Url"}},iv:{serializedName:"iv",readOnly:!0,type:{name:"Base64Url"}},authenticationTag:{serializedName:"tag",readOnly:!0,type:{name:"Base64Url"}},additionalAuthenticatedData:{serializedName:"aad",readOnly:!0,type:{name:"Base64Url"}}}}},KeySignParameters={type:{name:"Composite",className:"KeySignParameters",modelProperties:{algorithm:{serializedName:"alg",required:!0,type:{name:"String"}},value:{serializedName:"value",required:!0,type:{name:"Base64Url"}}}}},KeyVerifyParameters={type:{name:"Composite",className:"KeyVerifyParameters",modelProperties:{algorithm:{serializedName:"alg",required:!0,type:{name:"String"}},digest:{serializedName:"digest",required:!0,type:{name:"Base64Url"}},signature:{serializedName:"value",required:!0,type:{name:"Base64Url"}}}}},KeyVerifyResult={type:{name:"Composite",className:"KeyVerifyResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"Boolean"}}}}},KeyReleaseParameters={type:{name:"Composite",className:"KeyReleaseParameters",modelProperties:{targetAttestationToken:{constraints:{MinLength:1},serializedName:"target",required:!0,type:{name:"String"}},nonce:{serializedName:"nonce",type:{name:"String"}},enc:{serializedName:"enc",type:{name:"String"}}}}},KeyReleaseResult={type:{name:"Composite",className:"KeyReleaseResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"String"}}}}},DeletedKeyListResult={type:{name:"Composite",className:"DeletedKeyListResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"Sequence",element:{type:{name:"Composite",className:"DeletedKeyItem"}}}},nextLink:{serializedName:"nextLink",readOnly:!0,type:{name:"String"}}}}},KeyRotationPolicy={type:{name:"Composite",className:"KeyRotationPolicy",modelProperties:{id:{serializedName:"id",readOnly:!0,type:{name:"String"}},lifetimeActions:{serializedName:"lifetimeActions",type:{name:"Sequence",element:{type:{name:"Composite",className:"LifetimeActions"}}}},attributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyRotationPolicyAttributes"}}}}},LifetimeActions={type:{name:"Composite",className:"LifetimeActions",modelProperties:{trigger:{serializedName:"trigger",type:{name:"Composite",className:"LifetimeActionsTrigger"}},action:{serializedName:"action",type:{name:"Composite",className:"LifetimeActionsType"}}}}},LifetimeActionsTrigger={type:{name:"Composite",className:"LifetimeActionsTrigger",modelProperties:{timeAfterCreate:{serializedName:"timeAfterCreate",type:{name:"String"}},timeBeforeExpiry:{serializedName:"timeBeforeExpiry",type:{name:"String"}}}}},LifetimeActionsType={type:{name:"Composite",className:"LifetimeActionsType",modelProperties:{type:{serializedName:"type",type:{name:"Enum",allowedValues:["Rotate","Notify"]}}}}},KeyRotationPolicyAttributes={type:{name:"Composite",className:"KeyRotationPolicyAttributes",modelProperties:{expiryTime:{serializedName:"expiryTime",type:{name:"String"}},created:{serializedName:"created",readOnly:!0,type:{name:"UnixTime"}},updated:{serializedName:"updated",readOnly:!0,type:{name:"UnixTime"}}}}},GetRandomBytesRequest={type:{name:"Composite",className:"GetRandomBytesRequest",modelProperties:{count:{constraints:{InclusiveMaximum:128,InclusiveMinimum:1},serializedName:"count",required:!0,type:{name:"Number"}}}}},RandomBytes={type:{name:"Composite",className:"RandomBytes",modelProperties:{value:{serializedName:"value",required:!0,type:{name:"Base64Url"}}}}},KeyProperties={type:{name:"Composite",className:"KeyProperties",modelProperties:{exportable:{serializedName:"exportable",type:{name:"Boolean"}},keyType:{serializedName:"kty",type:{name:"String"}},keySize:{serializedName:"key_size",type:{name:"Number"}},reuseKey:{serializedName:"reuse_key",type:{name:"Boolean"}},curve:{serializedName:"crv",type:{name:"String"}}}}},KeyExportParameters={type:{name:"Composite",className:"KeyExportParameters",modelProperties:{wrappingKey:{serializedName:"wrappingKey",type:{name:"Composite",className:"JsonWebKey"}},wrappingKid:{serializedName:"wrappingKid",type:{name:"String"}},enc:{serializedName:"enc",type:{name:"String"}}}}},KeyAttributes={type:{name:"Composite",className:"KeyAttributes",modelProperties:Object.assign(Object.assign({},Attributes.type.modelProperties),{recoverableDays:{serializedName:"recoverableDays",readOnly:!0,type:{name:"Number"}},recoveryLevel:{serializedName:"recoveryLevel",readOnly:!0,type:{name:"String"}},exportable:{serializedName:"exportable",type:{name:"Boolean"}}})}},DeletedKeyBundle={type:{name:"Composite",className:"DeletedKeyBundle",modelProperties:Object.assign(Object.assign({},KeyBundle.type.modelProperties),{recoveryId:{serializedName:"recoveryId",type:{name:"String"}},scheduledPurgeDate:{serializedName:"scheduledPurgeDate",readOnly:!0,type:{name:"UnixTime"}},deletedDate:{serializedName:"deletedDate",readOnly:!0,type:{name:"UnixTime"}}})}},DeletedKeyItem={type:{name:"Composite",className:"DeletedKeyItem",modelProperties:Object.assign(Object.assign({},KeyItem.type.modelProperties),{recoveryId:{serializedName:"recoveryId",type:{name:"String"}},scheduledPurgeDate:{serializedName:"scheduledPurgeDate",readOnly:!0,type:{name:"UnixTime"}},deletedDate:{serializedName:"deletedDate",readOnly:!0,type:{name:"UnixTime"}}})}};var Mappers=Object.freeze({__proto__:null,KeyCreateParameters:KeyCreateParameters,Attributes:Attributes,KeyReleasePolicy:KeyReleasePolicy,KeyBundle:KeyBundle,JsonWebKey:JsonWebKey,KeyVaultError:KeyVaultError,ErrorModel:ErrorModel,KeyImportParameters:KeyImportParameters,KeyUpdateParameters:KeyUpdateParameters,KeyListResult:KeyListResult,KeyItem:KeyItem,BackupKeyResult:BackupKeyResult,KeyRestoreParameters:KeyRestoreParameters,KeyOperationsParameters:KeyOperationsParameters,KeyOperationResult:KeyOperationResult,KeySignParameters:KeySignParameters,KeyVerifyParameters:KeyVerifyParameters,KeyVerifyResult:KeyVerifyResult,KeyReleaseParameters:KeyReleaseParameters,KeyReleaseResult:KeyReleaseResult,DeletedKeyListResult:DeletedKeyListResult,KeyRotationPolicy:KeyRotationPolicy,LifetimeActions:LifetimeActions,LifetimeActionsTrigger:LifetimeActionsTrigger,LifetimeActionsType:LifetimeActionsType,KeyRotationPolicyAttributes:KeyRotationPolicyAttributes,GetRandomBytesRequest:GetRandomBytesRequest,RandomBytes:RandomBytes,KeyProperties:KeyProperties,KeyExportParameters:KeyExportParameters,KeyAttributes:KeyAttributes,DeletedKeyBundle:DeletedKeyBundle,DeletedKeyItem:DeletedKeyItem});const contentType={parameterPath:["options","contentType"],mapper:{defaultValue:"application/json",isConstant:!0,serializedName:"Content-Type",type:{name:"String"}}},accept={parameterPath:"accept",mapper:{defaultValue:"application/json",isConstant:!0,serializedName:"Accept",type:{name:"String"}}},vaultBaseUrl={parameterPath:"vaultBaseUrl",mapper:{serializedName:"vaultBaseUrl",required:!0,type:{name:"String"}},skipEncoding:!0},keyName={parameterPath:"keyName",mapper:{constraints:{Pattern:new RegExp("^[0-9a-zA-Z-]+$")},serializedName:"key-name",required:!0,type:{name:"String"}}},apiVersion={parameterPath:"apiVersion",mapper:{serializedName:"api-version",required:!0,type:{name:"String"}}},keyName1={parameterPath:"keyName",mapper:{serializedName:"key-name",required:!0,type:{name:"String"}}},keyVersion={parameterPath:"keyVersion",mapper:{serializedName:"key-version",required:!0,type:{name:"String"}}},maxresults={parameterPath:["options","maxresults"],mapper:{constraints:{InclusiveMaximum:25,InclusiveMinimum:1},serializedName:"maxresults",type:{name:"Number"}}},keyRotationPolicy={parameterPath:"keyRotationPolicy",mapper:KeyRotationPolicy},nextLink={parameterPath:"nextLink",mapper:{serializedName:"nextLink",required:!0,type:{name:"String"}},skipEncoding:!0};class KeyVaultClient extends coreHttpCompat__namespace.ExtendedServiceClient{constructor(apiVersion,options){var _a,_b;if(void 0===apiVersion)throw new Error("'apiVersion' cannot be null");options||(options={});const defaults={requestContentType:"application/json; charset=utf-8"},packageDetails="azsdk-js-keyvault-keys/4.7.1",userAgentPrefix=options.userAgentOptions&&options.userAgentOptions.userAgentPrefix?`${options.userAgentOptions.userAgentPrefix} ${packageDetails}`:`${packageDetails}`,optionsWithDefaults=Object.assign(Object.assign(Object.assign({},defaults),options),{userAgentOptions:{userAgentPrefix:userAgentPrefix},baseUri:null!==(_b=null!==(_a=options.endpoint)&&void 0!==_a?_a:options.baseUri)&&void 0!==_b?_b:"{vaultBaseUrl}"});if(super(optionsWithDefaults),(null==options?void 0:options.pipeline)&&options.pipeline.getOrderedPolicies().length>0){options.pipeline.getOrderedPolicies().some((pipelinePolicy=>pipelinePolicy.name===coreRestPipeline__namespace.bearerTokenAuthenticationPolicyName))||(this.pipeline.removePolicy({name:coreRestPipeline__namespace.bearerTokenAuthenticationPolicyName}),this.pipeline.addPolicy(coreRestPipeline__namespace.bearerTokenAuthenticationPolicy({scopes:`${optionsWithDefaults.baseUri}/.default`,challengeCallbacks:{authorizeRequestOnChallenge:coreClient__namespace.authorizeRequestOnClaimChallenge}})))}this.apiVersion=apiVersion}createKey(vaultBaseUrl,keyName,kty,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,kty:kty,options:options},createKeyOperationSpec)}rotateKey(vaultBaseUrl,keyName,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,options:options},rotateKeyOperationSpec)}importKey(vaultBaseUrl,keyName,key,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,key:key,options:options},importKeyOperationSpec)}deleteKey(vaultBaseUrl,keyName,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,options:options},deleteKeyOperationSpec)}updateKey(vaultBaseUrl,keyName,keyVersion,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,options:options},updateKeyOperationSpec)}getKey(vaultBaseUrl,keyName,keyVersion,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,options:options},getKeyOperationSpec)}getKeyVersions(vaultBaseUrl,keyName,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,options:options},getKeyVersionsOperationSpec)}getKeys(vaultBaseUrl,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,options:options},getKeysOperationSpec)}backupKey(vaultBaseUrl,keyName,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,options:options},backupKeyOperationSpec)}restoreKey(vaultBaseUrl,keyBundleBackup,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyBundleBackup:keyBundleBackup,options:options},restoreKeyOperationSpec)}encrypt(vaultBaseUrl,keyName,keyVersion,algorithm,value,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,algorithm:algorithm,value:value,options:options},encryptOperationSpec)}decrypt(vaultBaseUrl,keyName,keyVersion,algorithm,value,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,algorithm:algorithm,value:value,options:options},decryptOperationSpec)}sign(vaultBaseUrl,keyName,keyVersion,algorithm,value,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,algorithm:algorithm,value:value,options:options},signOperationSpec)}verify(vaultBaseUrl,keyName,keyVersion,algorithm,digest,signature,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,algorithm:algorithm,digest:digest,signature:signature,options:options},verifyOperationSpec)}wrapKey(vaultBaseUrl,keyName,keyVersion,algorithm,value,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,algorithm:algorithm,value:value,options:options},wrapKeyOperationSpec)}unwrapKey(vaultBaseUrl,keyName,keyVersion,algorithm,value,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,algorithm:algorithm,value:value,options:options},unwrapKeyOperationSpec)}release(vaultBaseUrl,keyName,keyVersion,targetAttestationToken,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyVersion:keyVersion,targetAttestationToken:targetAttestationToken,options:options},releaseOperationSpec)}getDeletedKeys(vaultBaseUrl,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,options:options},getDeletedKeysOperationSpec)}getDeletedKey(vaultBaseUrl,keyName,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,options:options},getDeletedKeyOperationSpec)}purgeDeletedKey(vaultBaseUrl,keyName,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,options:options},purgeDeletedKeyOperationSpec)}recoverDeletedKey(vaultBaseUrl,keyName,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,options:options},recoverDeletedKeyOperationSpec)}getKeyRotationPolicy(vaultBaseUrl,keyName,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,options:options},getKeyRotationPolicyOperationSpec)}updateKeyRotationPolicy(vaultBaseUrl,keyName,keyRotationPolicy,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,keyRotationPolicy:keyRotationPolicy,options:options},updateKeyRotationPolicyOperationSpec)}getRandomBytes(vaultBaseUrl,count,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,count:count,options:options},getRandomBytesOperationSpec)}getKeyVersionsNext(vaultBaseUrl,keyName,nextLink,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,keyName:keyName,nextLink:nextLink,options:options},getKeyVersionsNextOperationSpec)}getKeysNext(vaultBaseUrl,nextLink,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,nextLink:nextLink,options:options},getKeysNextOperationSpec)}getDeletedKeysNext(vaultBaseUrl,nextLink,options){return this.sendOperationRequest({vaultBaseUrl:vaultBaseUrl,nextLink:nextLink,options:options},getDeletedKeysNextOperationSpec)}}const serializer=coreClient__namespace.createSerializer(Mappers,!1),createKeyOperationSpec={path:"/keys/{key-name}/create",httpMethod:"POST",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{kty:["kty"],keySize:["options","keySize"],publicExponent:["options","publicExponent"],keyOps:["options","keyOps"],keyAttributes:["options","keyAttributes"],tags:["options","tags"],curve:["options","curve"],releasePolicy:["options","releasePolicy"]},mapper:Object.assign(Object.assign({},KeyCreateParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},rotateKeyOperationSpec={path:"/keys/{key-name}/rotate",httpMethod:"POST",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName],headerParameters:[accept],serializer:serializer},importKeyOperationSpec={path:"/keys/{key-name}",httpMethod:"PUT",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{hsm:["options","hsm"],key:["key"],keyAttributes:["options","keyAttributes"],tags:["options","tags"],releasePolicy:["options","releasePolicy"]},mapper:Object.assign(Object.assign({},KeyImportParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},deleteKeyOperationSpec={path:"/keys/{key-name}",httpMethod:"DELETE",responses:{200:{bodyMapper:DeletedKeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},updateKeyOperationSpec={path:"/keys/{key-name}/{key-version}",httpMethod:"PATCH",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{keyOps:["options","keyOps"],keyAttributes:["options","keyAttributes"],tags:["options","tags"],releasePolicy:["options","releasePolicy"]},mapper:Object.assign(Object.assign({},KeyUpdateParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},getKeyOperationSpec={path:"/keys/{key-name}/{key-version}",httpMethod:"GET",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[accept],serializer:serializer},getKeyVersionsOperationSpec={path:"/keys/{key-name}/versions",httpMethod:"GET",responses:{200:{bodyMapper:KeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},getKeysOperationSpec={path:"/keys",httpMethod:"GET",responses:{200:{bodyMapper:KeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl],headerParameters:[accept],serializer:serializer},backupKeyOperationSpec={path:"/keys/{key-name}/backup",httpMethod:"POST",responses:{200:{bodyMapper:BackupKeyResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},restoreKeyOperationSpec={path:"/keys/restore",httpMethod:"POST",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{keyBundleBackup:["keyBundleBackup"]},mapper:Object.assign(Object.assign({},KeyRestoreParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},encryptOperationSpec={path:"/keys/{key-name}/{key-version}/encrypt",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"],iv:["options","iv"],additionalAuthenticatedData:["options","additionalAuthenticatedData"],authenticationTag:["options","authenticationTag"]},mapper:Object.assign(Object.assign({},KeyOperationsParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},decryptOperationSpec={path:"/keys/{key-name}/{key-version}/decrypt",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"],iv:["options","iv"],additionalAuthenticatedData:["options","additionalAuthenticatedData"],authenticationTag:["options","authenticationTag"]},mapper:Object.assign(Object.assign({},KeyOperationsParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},signOperationSpec={path:"/keys/{key-name}/{key-version}/sign",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"]},mapper:Object.assign(Object.assign({},KeySignParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},verifyOperationSpec={path:"/keys/{key-name}/{key-version}/verify",httpMethod:"POST",responses:{200:{bodyMapper:KeyVerifyResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],digest:["digest"],signature:["signature"]},mapper:Object.assign(Object.assign({},KeyVerifyParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},wrapKeyOperationSpec={path:"/keys/{key-name}/{key-version}/wrapkey",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"],iv:["options","iv"],additionalAuthenticatedData:["options","additionalAuthenticatedData"],authenticationTag:["options","authenticationTag"]},mapper:Object.assign(Object.assign({},KeyOperationsParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},unwrapKeyOperationSpec={path:"/keys/{key-name}/{key-version}/unwrapkey",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"],iv:["options","iv"],additionalAuthenticatedData:["options","additionalAuthenticatedData"],authenticationTag:["options","authenticationTag"]},mapper:Object.assign(Object.assign({},KeyOperationsParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},releaseOperationSpec={path:"/keys/{key-name}/{key-version}/release",httpMethod:"POST",responses:{200:{bodyMapper:KeyReleaseResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{targetAttestationToken:["targetAttestationToken"],nonce:["options","nonce"],enc:["options","enc"]},mapper:Object.assign(Object.assign({},KeyReleaseParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},getDeletedKeysOperationSpec={path:"/deletedkeys",httpMethod:"GET",responses:{200:{bodyMapper:DeletedKeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl],headerParameters:[accept],serializer:serializer},getDeletedKeyOperationSpec={path:"/deletedkeys/{key-name}",httpMethod:"GET",responses:{200:{bodyMapper:DeletedKeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},purgeDeletedKeyOperationSpec={path:"/deletedkeys/{key-name}",httpMethod:"DELETE",responses:{204:{},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},recoverDeletedKeyOperationSpec={path:"/deletedkeys/{key-name}/recover",httpMethod:"POST",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},getKeyRotationPolicyOperationSpec={path:"/keys/{key-name}/rotationpolicy",httpMethod:"GET",responses:{200:{bodyMapper:KeyRotationPolicy},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},updateKeyRotationPolicyOperationSpec={path:"/keys/{key-name}/rotationpolicy",httpMethod:"PUT",responses:{200:{bodyMapper:KeyRotationPolicy},default:{bodyMapper:KeyVaultError}},requestBody:keyRotationPolicy,queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},getRandomBytesOperationSpec={path:"/rng",httpMethod:"POST",responses:{200:{bodyMapper:RandomBytes},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{count:["count"]},mapper:Object.assign(Object.assign({},GetRandomBytesRequest),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},getKeyVersionsNextOperationSpec={path:"{nextLink}",httpMethod:"GET",responses:{200:{bodyMapper:KeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl,keyName1,nextLink],headerParameters:[accept],serializer:serializer},getKeysNextOperationSpec={path:"{nextLink}",httpMethod:"GET",responses:{200:{bodyMapper:KeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl,nextLink],headerParameters:[accept],serializer:serializer},getDeletedKeysNextOperationSpec={path:"{nextLink}",httpMethod:"GET",responses:{200:{bodyMapper:DeletedKeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl,nextLink],headerParameters:[accept],serializer:serializer},SDK_VERSION="4.7.1",validWWWAuthenticateProperties=["authorization","authorization_url","resource","scope","tenantId"];function parseWWWAuthenticateHeader(headerValue){const pairDelimiter=/,? +/,parsed=headerValue.split(pairDelimiter).reduce(((kvPairs,p)=>{if(p.match(/\w="/)){const[key,value]=p.split("=");if(validWWWAuthenticateProperties.includes(key))return Object.assign(Object.assign({},kvPairs),{[key]:value.slice(1,-1)})}return kvPairs}),{});if(parsed.authorization)try{const tenantId=new URL(parsed.authorization).pathname.substring(1);tenantId&&(parsed.tenantId=tenantId)}catch(_){throw new Error(`The challenge authorization URI '${parsed.authorization}' is invalid.`)}return parsed}function verifyChallengeResource(scope,request){let scopeAsUrl;try{scopeAsUrl=new URL(scope)}catch(e){throw new Error(`The challenge contains invalid scope '${scope}'`)}if(!new URL(request.url).hostname.endsWith(`.${scopeAsUrl.hostname}`))throw new Error(`The challenge resource '${scopeAsUrl.hostname}' does not match the requested domain. Set disableChallengeResourceVerification to true in your client options to disable. See https://aka.ms/azsdk/blog/vault-uri for more information.`)}function createKeyVaultChallengeCallbacks(options={}){const{disableChallengeResourceVerification:disableChallengeResourceVerification}=options;let challengeState={status:"none"};function requestToOptions(request){return{abortSignal:request.abortSignal,requestOptions:{timeout:request.timeout>0?request.timeout:void 0},tracingOptions:request.tracingOptions}}async function authorizeRequest({request:request,getAccessToken:getAccessToken}){const requestOptions=requestToOptions(request);switch(challengeState.status){case"none":challengeState={status:"started",originalBody:request.body},request.body=null;break;case"started":break;case"complete":{const token=await getAccessToken(challengeState.scopes,requestOptions);token&&request.headers.set("authorization",`Bearer ${token.token}`);break}}return Promise.resolve()}async function authorizeRequestOnChallenge({request:request,response:response,getAccessToken:getAccessToken}){null===request.body&&"started"===challengeState.status&&(request.body=challengeState.originalBody);const getTokenOptions=requestToOptions(request),challenge=response.headers.get("WWW-Authenticate");if(!challenge)throw new Error("Missing challenge.");const parsedChallenge=parseWWWAuthenticateHeader(challenge)||{},scope=parsedChallenge.resource?parsedChallenge.resource+"/.default":parsedChallenge.scope;if(!scope)throw new Error("Missing scope.");disableChallengeResourceVerification||verifyChallengeResource(scope,request);const accessToken=await getAccessToken([scope],Object.assign(Object.assign({},getTokenOptions),{tenantId:parsedChallenge.tenantId}));return!!accessToken&&(request.headers.set("Authorization",`Bearer ${accessToken.token}`),challengeState={status:"complete",scopes:[scope]},!0)}return{authorizeRequest:authorizeRequest,authorizeRequestOnChallenge:authorizeRequestOnChallenge}}function parseKeyVaultIdentifier(collection,identifier){if("string"!=typeof collection||!(collection=collection.trim()))throw new Error("Invalid collection argument");if("string"!=typeof identifier||!(identifier=identifier.trim()))throw new Error("Invalid identifier argument");let baseUri;try{baseUri=new URL(identifier)}catch(e){throw new Error(`Invalid ${collection} identifier: ${identifier}. Not a valid URI`)}const segments=(baseUri.pathname||"").split("/");if(3!==segments.length&&4!==segments.length)throw new Error(`Invalid ${collection} identifier: ${identifier}. Bad number of segments: ${segments.length}`);if(collection!==segments[1])throw new Error(`Invalid ${collection} identifier: ${identifier}. segment [1] should be "${collection}", found "${segments[1]}"`);return{vaultUrl:`${baseUri.protocol}//${baseUri.host}`,name:segments[2],version:4===segments.length?segments[3]:void 0}}const tracingClient=coreTracing.createTracingClient({namespace:"Microsoft.KeyVault",packageName:"@azure/keyvault-keys",packageVersion:SDK_VERSION});function parseKeyVaultKeyIdentifier(id){const collection=id.split("/")[3];return Object.assign({sourceId:id},parseKeyVaultIdentifier(collection,id))}function getKeyFromKeyBundle(bundle){const keyBundle=bundle,deletedKeyBundle=bundle,parsedId=parseKeyVaultKeyIdentifier(keyBundle.key.kid),attributes=keyBundle.attributes||{};delete keyBundle.attributes;const resultObject={key:keyBundle.key,id:keyBundle.key?keyBundle.key.kid:void 0,name:parsedId.name,keyOperations:keyBundle.key?keyBundle.key.keyOps:void 0,keyType:keyBundle.key?keyBundle.key.kty:void 0,properties:{tags:keyBundle.tags,enabled:attributes.enabled,notBefore:attributes.notBefore,expiresOn:attributes.expires,createdOn:attributes.created,updatedOn:attributes.updated,recoverableDays:attributes.recoverableDays,recoveryLevel:attributes.recoveryLevel,exportable:attributes.exportable,releasePolicy:keyBundle.releasePolicy,vaultUrl:parsedId.vaultUrl,version:parsedId.version,name:parsedId.name,managed:keyBundle.managed,id:keyBundle.key?keyBundle.key.kid:void 0}};return deletedKeyBundle.recoveryId&&(resultObject.properties.recoveryId=deletedKeyBundle.recoveryId,resultObject.properties.scheduledPurgeDate=deletedKeyBundle.scheduledPurgeDate,resultObject.properties.deletedOn=deletedKeyBundle.deletedDate),resultObject}function getDeletedKeyFromDeletedKeyItem(keyItem){const commonProperties=getKeyPropertiesFromKeyItem(keyItem);return{key:{kid:keyItem.kid},id:keyItem.kid,name:commonProperties.name,properties:Object.assign(Object.assign({},commonProperties),{recoveryId:keyItem.recoveryId,scheduledPurgeDate:keyItem.scheduledPurgeDate,deletedOn:keyItem.deletedDate})}}function getKeyPropertiesFromKeyItem(keyItem){const parsedId=parseKeyVaultKeyIdentifier(keyItem.kid),attributes=keyItem.attributes||{};return{createdOn:attributes.created,enabled:null==attributes?void 0:attributes.enabled,expiresOn:null==attributes?void 0:attributes.expires,id:keyItem.kid,managed:keyItem.managed,name:parsedId.name,notBefore:null==attributes?void 0:attributes.notBefore,recoverableDays:null==attributes?void 0:attributes.recoverableDays,recoveryLevel:null==attributes?void 0:attributes.recoveryLevel,tags:keyItem.tags,updatedOn:attributes.updated,vaultUrl:parsedId.vaultUrl,version:parsedId.version}}const keyRotationTransformations={propertiesToGenerated:function(parameters){var _a;return{attributes:{expiryTime:parameters.expiresIn},lifetimeActions:null===(_a=parameters.lifetimeActions)||void 0===_a?void 0:_a.map((action=>{const generatedAction={action:{type:action.action},trigger:{}};return action.timeAfterCreate&&(generatedAction.trigger.timeAfterCreate=action.timeAfterCreate),action.timeBeforeExpiry&&(generatedAction.trigger.timeBeforeExpiry=action.timeBeforeExpiry),generatedAction}))}},generatedToPublic(generated){var _a,_b,_c,_d;return{id:generated.id,createdOn:null===(_a=generated.attributes)||void 0===_a?void 0:_a.created,updatedOn:null===(_b=generated.attributes)||void 0===_b?void 0:_b.updated,expiresIn:null===(_c=generated.attributes)||void 0===_c?void 0:_c.expiryTime,lifetimeActions:null===(_d=generated.lifetimeActions)||void 0===_d?void 0:_d.map((action=>{var _a,_b;return{action:action.action.type,timeAfterCreate:null===(_a=action.trigger)||void 0===_a?void 0:_a.timeAfterCreate,timeBeforeExpiry:null===(_b=action.trigger)||void 0===_b?void 0:_b.timeBeforeExpiry}}))}}};class KeyVaultKeyPoller extends coreLro.Poller{constructor(){super(...arguments),this.intervalInMs=2e3}async delay(){return coreUtil.delay(this.intervalInMs)}}class KeyVaultKeyPollOperation{constructor(state,options={}){this.state=state,this.cancelMessage="",options.cancelMessage&&(this.cancelMessage=options.cancelMessage)}async update(){throw new Error("Operation not supported.")}async cancel(){throw new Error(this.cancelMessage)}toString(){return JSON.stringify({state:this.state})}}class DeleteKeyPollOperation extends KeyVaultKeyPollOperation{constructor(state,vaultUrl,client,operationOptions={}){super(state,{cancelMessage:"Canceling the deletion of a key is not supported."}),this.state=state,this.vaultUrl=vaultUrl,this.client=client,this.operationOptions=operationOptions}deleteKey(name,options={}){return tracingClient.withSpan("DeleteKeyPoller.deleteKey",options,(async updatedOptions=>getKeyFromKeyBundle(await this.client.deleteKey(this.vaultUrl,name,updatedOptions))))}getDeletedKey(name,options={}){return tracingClient.withSpan("DeleteKeyPoller.getDeletedKey",options,(async updatedOptions=>getKeyFromKeyBundle(await this.client.getDeletedKey(this.vaultUrl,name,updatedOptions))))}async update(options={}){const state=this.state,{name:name}=state;if(options.abortSignal&&(this.operationOptions.abortSignal=options.abortSignal),!state.isStarted){const deletedKey=await this.deleteKey(name,this.operationOptions);state.isStarted=!0,state.result=deletedKey,deletedKey.properties.recoveryId||(state.isCompleted=!0)}if(!state.isCompleted)try{state.result=await this.getDeletedKey(name,this.operationOptions),state.isCompleted=!0}catch(error){if(403===error.statusCode)state.isCompleted=!0;else if(404!==error.statusCode)throw state.error=error,state.isCompleted=!0,error}return this}}class DeleteKeyPoller extends KeyVaultKeyPoller{constructor(options){const{vaultUrl:vaultUrl,client:client,name:name,operationOptions:operationOptions,intervalInMs:intervalInMs=2e3,resumeFrom:resumeFrom}=options;let state;resumeFrom&&(state=JSON.parse(resumeFrom).state);super(new DeleteKeyPollOperation(Object.assign(Object.assign({},state),{name:name}),vaultUrl,client,operationOptions)),this.intervalInMs=intervalInMs}}class RecoverDeletedKeyPollOperation extends KeyVaultKeyPollOperation{constructor(state,vaultUrl,client,operationOptions={}){super(state,{cancelMessage:"Canceling the recovery of a deleted key is not supported."}),this.state=state,this.vaultUrl=vaultUrl,this.client=client,this.operationOptions=operationOptions}getKey(name,options={}){return tracingClient.withSpan("RecoverDeleteKeyPoller.getKey",options,(async updatedOptions=>getKeyFromKeyBundle(await this.client.getKey(this.vaultUrl,name,(null==updatedOptions?void 0:updatedOptions.version)||"",updatedOptions))))}async recoverDeletedKey(name,options={}){return tracingClient.withSpan("RecoverDeletedKeyPoller.recoverDeleteKey",options,(async updatedOptions=>getKeyFromKeyBundle(await this.client.recoverDeletedKey(this.vaultUrl,name,updatedOptions))))}async update(options={}){const state=this.state,{name:name}=state,operationOptions=this.operationOptions;if(options.abortSignal&&(operationOptions.abortSignal=options.abortSignal),!state.isStarted){try{state.result=await this.getKey(name,operationOptions),state.isCompleted=!0}catch(_a){}state.isCompleted||(state.result=await this.recoverDeletedKey(name,operationOptions),state.isStarted=!0)}if(!state.isCompleted)try{state.result=await this.getKey(name,operationOptions),state.isCompleted=!0}catch(error){if(403===error.statusCode)state.isCompleted=!0;else if(404!==error.statusCode)throw state.error=error,state.isCompleted=!0,error}return this}}class RecoverDeletedKeyPoller extends KeyVaultKeyPoller{constructor(options){const{vaultUrl:vaultUrl,client:client,name:name,operationOptions:operationOptions,intervalInMs:intervalInMs=2e3,resumeFrom:resumeFrom}=options;let state;resumeFrom&&(state=JSON.parse(resumeFrom).state);super(new RecoverDeletedKeyPollOperation(Object.assign(Object.assign({},state),{name:name}),vaultUrl,client,operationOptions)),this.intervalInMs=intervalInMs}}const LATEST_API_VERSION="7.4";exports.KnownKeyOperations=void 0,function(KnownKeyOperations){KnownKeyOperations.Encrypt="encrypt",KnownKeyOperations.Decrypt="decrypt",KnownKeyOperations.Sign="sign",KnownKeyOperations.Verify="verify",KnownKeyOperations.WrapKey="wrapKey",KnownKeyOperations.UnwrapKey="unwrapKey",KnownKeyOperations.Import="import"}(exports.KnownKeyOperations||(exports.KnownKeyOperations={})),exports.KnownKeyExportEncryptionAlgorithm=void 0,function(KnownKeyExportEncryptionAlgorithm){KnownKeyExportEncryptionAlgorithm.CkmRsaAesKeyWrap="CKM_RSA_AES_KEY_WRAP",KnownKeyExportEncryptionAlgorithm.RsaAesKeyWrap256="RSA_AES_KEY_WRAP_256",KnownKeyExportEncryptionAlgorithm.RsaAesKeyWrap384="RSA_AES_KEY_WRAP_384"}(exports.KnownKeyExportEncryptionAlgorithm||(exports.KnownKeyExportEncryptionAlgorithm={}));const algorithmToHashAlgorithm={ES256:"SHA256",ES256K:"SHA256",PS256:"SHA256",RS256:"SHA256",ES384:"SHA384",PS384:"SHA384",RS384:"SHA384",ES512:"SHA512",PS512:"SHA512",RS512:"SHA512"};async function createHash(algorithm,data){const hashAlgorithm=algorithmToHashAlgorithm[algorithm];if(!hashAlgorithm)throw new Error(`Invalid algorithm ${algorithm} passed to createHash. Supported algorithms: ${Object.keys(algorithmToHashAlgorithm).join(", ")}`);const hash=crypto.createHash(hashAlgorithm);hash.update(Buffer.from(data));return hash.digest()}function createVerify(algorithm,data){const verifyAlgorithm=algorithmToHashAlgorithm[algorithm];if(!verifyAlgorithm)throw new Error(`Invalid algorithm ${algorithm} passed to createHash. Supported algorithms: ${Object.keys(algorithmToHashAlgorithm).join(", ")}`);const verifier=crypto.createVerify(verifyAlgorithm);return verifier.update(Buffer.from(data)),verifier.end(),verifier}function randomBytes(length){return crypto.randomBytes(length)}class RemoteCryptographyProvider{constructor(key,credential,pipelineOptions={}){var _a;let keyId;this.client=getOrInitializeClient(credential,pipelineOptions),this.key=key,keyId="string"==typeof key?key:key.id;try{const parsed=parseKeyVaultKeyIdentifier(keyId);if(""===parsed.name)throw new Error("Could not find 'name' of key in key URL");if(!parsed.vaultUrl||""===parsed.vaultUrl)throw new Error("Could not find 'vaultUrl' of key in key URL");this.vaultUrl=parsed.vaultUrl,this.name=parsed.name,this.version=null!==(_a=parsed.version)&&void 0!==_a?_a:""}catch(err){throw logger.error(err),new Error(`${keyId} is not a valid Key Vault key ID`)}}isSupported(_algorithm,_operation){return!0}encrypt(encryptParameters,options={}){const{algorithm:algorithm,plaintext:plaintext}=encryptParameters,params=tslib.__rest(encryptParameters,["algorithm","plaintext"]),requestOptions=Object.assign(Object.assign({},options),params);return tracingClient.withSpan("RemoteCryptographyProvider.encrypt",requestOptions,(async updatedOptions=>{const result=await this.client.encrypt(this.vaultUrl,this.name,this.version,algorithm,plaintext,updatedOptions);return{algorithm:encryptParameters.algorithm,result:result.result,keyID:this.getKeyID(),additionalAuthenticatedData:result.additionalAuthenticatedData,authenticationTag:result.authenticationTag,iv:result.iv}}))}decrypt(decryptParameters,options={}){const{algorithm:algorithm,ciphertext:ciphertext}=decryptParameters,params=tslib.__rest(decryptParameters,["algorithm","ciphertext"]),requestOptions=Object.assign(Object.assign({},options),params);return tracingClient.withSpan("RemoteCryptographyProvider.decrypt",requestOptions,(async updatedOptions=>({result:(await this.client.decrypt(this.vaultUrl,this.name,this.version,algorithm,ciphertext,updatedOptions)).result,keyID:this.getKeyID(),algorithm:algorithm})))}wrapKey(algorithm,keyToWrap,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.wrapKey",options,(async updatedOptions=>({result:(await this.client.wrapKey(this.vaultUrl,this.name,this.version,algorithm,keyToWrap,updatedOptions)).result,algorithm:algorithm,keyID:this.getKeyID()})))}unwrapKey(algorithm,encryptedKey,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.unwrapKey",options,(async updatedOptions=>({result:(await this.client.unwrapKey(this.vaultUrl,this.name,this.version,algorithm,encryptedKey,updatedOptions)).result,algorithm:algorithm,keyID:this.getKeyID()})))}sign(algorithm,digest,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.sign",options,(async updatedOptions=>({result:(await this.client.sign(this.vaultUrl,this.name,this.version,algorithm,digest,updatedOptions)).result,algorithm:algorithm,keyID:this.getKeyID()})))}verifyData(algorithm,data,signature,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.verifyData",options,(async updatedOptions=>{const hash=await createHash(algorithm,data);return this.verify(algorithm,hash,signature,updatedOptions)}))}verify(algorithm,digest,signature,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.verify",options,(async updatedOptions=>{const response=await this.client.verify(this.vaultUrl,this.name,this.version,algorithm,digest,signature,updatedOptions);return{result:!!response.value&&response.value,keyID:this.getKeyID()}}))}signData(algorithm,data,options={}){return tracingClient.withSpan("RemoteCryptographyProvider.signData",options,(async updatedOptions=>{const digest=await createHash(algorithm,data);return{result:(await this.client.sign(this.vaultUrl,this.name,this.version,algorithm,digest,updatedOptions)).result,algorithm:algorithm,keyID:this.getKeyID()}}))}get keyId(){return this.getKeyID()}getKey(options={}){return tracingClient.withSpan("RemoteCryptographyProvider.getKey",options,(async updatedOptions=>{if("string"==typeof this.key){if(!this.name||""===this.name)throw new Error("getKey requires a key with a name");const response=await this.client.getKey(this.vaultUrl,this.name,options&&options.version?options.version:this.version?this.version:"",updatedOptions);this.key=getKeyFromKeyBundle(response)}return this.key}))}getKeyID(){let kid;return kid="string"!=typeof this.key?this.key.id:this.key,kid}}function getOrInitializeClient(credential,options){if(options.generatedClient)return options.generatedClient;const libInfo=`azsdk-js-keyvault-keys/${SDK_VERSION}`,userAgentOptions=options.userAgentOptions;options.userAgentOptions={userAgentPrefix:userAgentOptions&&userAgentOptions.userAgentPrefix?`${userAgentOptions.userAgentPrefix} ${libInfo}`:libInfo};const authPolicy=coreRestPipeline.bearerTokenAuthenticationPolicy({credential:credential,scopes:[],challengeCallbacks:createKeyVaultChallengeCallbacks(options)}),internalPipelineOptions=Object.assign(Object.assign({},options),{loggingOptions:{logger:logger.info,allowedHeaderNames:["x-ms-keyvault-region","x-ms-keyvault-network-info","x-ms-keyvault-service-version"]}}),client=new KeyVaultClient(options.serviceVersion||LATEST_API_VERSION,internalPipelineOptions);return client.pipeline.addPolicy(authPolicy),client}function encodeLength(length){if(length<=127)return Uint8Array.of(length);if(length<256)return Uint8Array.of(129,length);if(length<65536)return Uint8Array.of(130,length>>8,255&length);throw new Error("Unsupported length to encode")}function encodeBuffer(buffer,bufferId){if(0===buffer.length)return buffer;let result=new Uint8Array(buffer);if(128&result[0]){const array=new Uint8Array(result.length+1);array[0]=0,array.set(result,1),result=array}const encodedLength=encodeLength(result.length),totalLength=1+encodedLength.length+result.length,outputBuffer=new Uint8Array(totalLength);return outputBuffer[0]=bufferId,outputBuffer.set(encodedLength,1),outputBuffer.set(result,1+encodedLength.length),outputBuffer}function makeSequence(encodedParts){const totalLength=encodedParts.reduce(((sum,part)=>sum+part.length),0),sequence=new Uint8Array(totalLength);for(let i=0;i<encodedParts.length;i++){const previousLength=i>0?encodedParts[i-1].length:0;sequence.set(encodedParts[i],previousLength)}const full_encoded=encodeBuffer(sequence,48);return Buffer.from(full_encoded).toString("base64")}function formatBase64Sequence(base64Sequence){const lines=base64Sequence.match(/.{1,64}/g);let result="";if(!lines)throw new Error("Could not create correct PEM");for(const line of lines)result+=line,result+="\n";return result}function convertJWKtoPEM(key){let result="";if(key.n&&key.e){result+="-----BEGIN RSA PUBLIC KEY-----\n",result+=formatBase64Sequence(makeSequence([key.n,key.e].map((part=>encodeBuffer(part,2))))),result+="-----END RSA PUBLIC KEY-----\n"}if(!result.length)throw new Error("Unsupported key format for local operations");return result.slice(0,-1)}class LocalCryptographyUnsupportedError extends Error{}class RsaCryptographyProvider{constructor(key){this.applicableAlgorithms=["RSA1_5","RSA-OAEP","PS256","RS256","PS384","RS384","PS512","RS512"],this.applicableOperations=["encrypt","wrapKey","verifyData"],this.signatureAlgorithmToHashAlgorithm={PS256:"SHA256",RS256:"SHA256",PS384:"SHA384",RS384:"SHA384",PS512:"SHA512",RS512:"SHA512"},this.key=key}isSupported(algorithm,operation){return this.applicableAlgorithms.includes(algorithm)&&this.applicableOperations.includes(operation)}encrypt(encryptParameters,_options){this.ensureValid();const keyPEM=convertJWKtoPEM(this.key),padding="RSA1_5"===encryptParameters.algorithm?constants.RSA_PKCS1_PADDING:constants.RSA_PKCS1_OAEP_PADDING;return Promise.resolve({algorithm:encryptParameters.algorithm,keyID:this.key.kid,result:crypto.publicEncrypt({key:keyPEM,padding:padding},Buffer.from(encryptParameters.plaintext))})}decrypt(_decryptParameters,_options){throw new LocalCryptographyUnsupportedError("Decrypting using a local JsonWebKey is not supported.")}wrapKey(algorithm,keyToWrap,_options){this.ensureValid();const keyPEM=convertJWKtoPEM(this.key),padding="RSA1_5"===algorithm?constants.RSA_PKCS1_PADDING:constants.RSA_PKCS1_OAEP_PADDING;return Promise.resolve({algorithm:algorithm,result:crypto.publicEncrypt({key:keyPEM,padding:padding},Buffer.from(keyToWrap)),keyID:this.key.kid})}unwrapKey(_algorithm,_encryptedKey,_options){throw new LocalCryptographyUnsupportedError("Unwrapping a key using a local JsonWebKey is not supported.")}sign(_algorithm,_digest,_options){throw new LocalCryptographyUnsupportedError("Signing a digest using a local JsonWebKey is not supported.")}signData(_algorithm,_data,_options){throw new LocalCryptographyUnsupportedError("Signing a block of data using a local JsonWebKey is not supported.")}async verify(_algorithm,_digest,_signature,_options){throw new LocalCryptographyUnsupportedError("Verifying a digest using a local JsonWebKey is not supported.")}verifyData(algorithm,data,signature,_options){this.ensureValid();const keyPEM=convertJWKtoPEM(this.key),verifier=createVerify(algorithm,data);return Promise.resolve({result:verifier.verify(keyPEM,Buffer.from(signature)),keyID:this.key.kid})}ensureValid(){var _a,_b;if(this.key&&"RSA"!==(null===(_a=this.key.kty)||void 0===_a?void 0:_a.toUpperCase())&&"RSA-HSM"!==(null===(_b=this.key.kty)||void 0===_b?void 0:_b.toUpperCase()))throw new Error("Key type does not match the algorithm RSA")}}class AesCryptographyProvider{constructor(key){this.supportedAlgorithms={A128CBCPAD:{algorithm:"aes-128-cbc",keySizeInBytes:16},A192CBCPAD:{algorithm:"aes-192-cbc",keySizeInBytes:24},A256CBCPAD:{algorithm:"aes-256-cbc",keySizeInBytes:32}},this.supportedOperations=["encrypt","decrypt"],this.key=key}encrypt(encryptParameters,_options){const{algorithm:algorithm,keySizeInBytes:keySizeInBytes}=this.supportedAlgorithms[encryptParameters.algorithm],iv=encryptParameters.iv||crypto__namespace.randomBytes(16);this.ensureValid(keySizeInBytes);const cipher=crypto__namespace.createCipheriv(algorithm,this.key.k.subarray(0,keySizeInBytes),iv);let encrypted=cipher.update(Buffer.from(encryptParameters.plaintext));return encrypted=Buffer.concat([encrypted,cipher.final()]),Promise.resolve({algorithm:encryptParameters.algorithm,result:encrypted,iv:iv})}decrypt(decryptParameters,_options){const{algorithm:algorithm,keySizeInBytes:keySizeInBytes}=this.supportedAlgorithms[decryptParameters.algorithm];this.ensureValid(keySizeInBytes);const decipher=crypto__namespace.createDecipheriv(algorithm,this.key.k.subarray(0,keySizeInBytes),decryptParameters.iv);let dec=decipher.update(Buffer.from(decryptParameters.ciphertext));return dec=Buffer.concat([dec,decipher.final()]),Promise.resolve({algorithm:decryptParameters.algorithm,result:dec})}isSupported(algorithm,operation){return!!this.key.k&&(!!Object.keys(this.supportedAlgorithms).includes(algorithm)&&!!this.supportedOperations.includes(operation))}wrapKey(_algorithm,_keyToWrap,_options){throw new LocalCryptographyUnsupportedError("Wrapping a key using a local JsonWebKey is not supported for AES.")}unwrapKey(_algorithm,_encryptedKey,_options){throw new LocalCryptographyUnsupportedError("Unwrapping a key using a local JsonWebKey is not supported for AES.")}sign(_algorithm,_digest,_options){throw new LocalCryptographyUnsupportedError("Signing using a local JsonWebKey is not supported for AES.")}signData(_algorithm,_data,_options){throw new LocalCryptographyUnsupportedError("Signing using a local JsonWebKey is not supported for AES.")}verify(_algorithm,_digest,_signature,_options){throw new LocalCryptographyUnsupportedError("Verifying using a local JsonWebKey is not supported for AES.")}verifyData(_algorithm,_data,_signature,_updatedOptions){throw new LocalCryptographyUnsupportedError("Verifying using a local JsonWebKey is not supported for AES.")}ensureValid(keySizeInBytes){var _a,_b;if(this.key&&"OCT"!==(null===(_a=this.key.kty)||void 0===_a?void 0:_a.toUpperCase())&&"OCT-HSM"!==(null===(_b=this.key.kty)||void 0===_b?void 0:_b.toUpperCase()))throw new Error("Key type does not match the key type oct or oct-hsm");if(!this.key.k)throw new Error("Symmetric key is required");if(this.key.k.length<keySizeInBytes)throw new Error(`Key must be at least ${keySizeInBytes<<3} bits`)}}class CryptographyClient{constructor(key,credential,pipelineOptions={}){"string"==typeof key?(this.key={kind:"identifier",value:key},this.remoteProvider=new RemoteCryptographyProvider(key,credential,pipelineOptions)):"name"in key?(this.key={kind:"KeyVaultKey",value:key},this.remoteProvider=new RemoteCryptographyProvider(key,credential,pipelineOptions)):this.key={kind:"JsonWebKey",value:key}}get vaultUrl(){var _a;return(null===(_a=this.remoteProvider)||void 0===_a?void 0:_a.vaultUrl)||""}get keyID(){return"identifier"===this.key.kind||"remoteOnlyIdentifier"===this.key.kind?this.key.value:"KeyVaultKey"===this.key.kind?this.key.value.id:this.key.value.kid}encrypt(...args){const[parameters,options]=this.disambiguateEncryptArguments(args);return tracingClient.withSpan("CryptographyClient.encrypt",options,(async updatedOptions=>{this.ensureValid(await this.fetchKey(updatedOptions),exports.KnownKeyOperations.Encrypt),this.initializeIV(parameters);const provider=await this.getProvider("encrypt",parameters.algorithm,updatedOptions);try{return provider.encrypt(parameters,updatedOptions)}catch(error){if(this.remoteProvider)return this.remoteProvider.encrypt(parameters,updatedOptions);throw error}}))}initializeIV(parameters){const algorithmsRequiringIV=["A128CBC","A128CBCPAD","A192CBC","A192CBCPAD","A256CBC","A256CBCPAD"];if(parameters.algorithm in algorithmsRequiringIV)try{const cbcParams=parameters;cbcParams.iv||(cbcParams.iv=randomBytes(16))}catch(e){throw new Error(`Unable to initialize IV for algorithm ${parameters.algorithm}. You may pass a valid IV to avoid this error. Error: ${e.message}`)}}disambiguateEncryptArguments(args){return"string"==typeof args[0]?[{algorithm:args[0],plaintext:args[1]},args[2]||{}]:[args[0],args[1]||{}]}decrypt(...args){const[parameters,options]=this.disambiguateDecryptArguments(args);return tracingClient.withSpan("CryptographyClient.decrypt",options,(async updatedOptions=>{this.ensureValid(await this.fetchKey(updatedOptions),exports.KnownKeyOperations.Decrypt);const provider=await this.getProvider("decrypt",parameters.algorithm,updatedOptions);try{return provider.decrypt(parameters,updatedOptions)}catch(error){if(this.remoteProvider)return this.remoteProvider.decrypt(parameters,updatedOptions);throw error}}))}disambiguateDecryptArguments(args){return"string"==typeof args[0]?[{algorithm:args[0],ciphertext:args[1]},args[2]||{}]:[args[0],args[1]||{}]}wrapKey(algorithm,key,options={}){return tracingClient.withSpan("CryptographyClient.wrapKey",options,(async updatedOptions=>{this.ensureValid(await this.fetchKey(updatedOptions),exports.KnownKeyOperations.WrapKey);const provider=await this.getProvider("wrapKey",algorithm,updatedOptions);try{return provider.wrapKey(algorithm,key,updatedOptions)}catch(err){if(this.remoteProvider)return this.remoteProvider.wrapKey(algorithm,key,options);throw err}}))}unwrapKey(algorithm,encryptedKey,options={}){return tracingClient.withSpan("CryptographyClient.unwrapKey",options,(async updatedOptions=>{this.ensureValid(await this.fetchKey(updatedOptions),exports.KnownKeyOperations.UnwrapKey);const provider=await this.getProvider("unwrapKey",algorithm,updatedOptions);try{return provider.unwrapKey(algorithm,encryptedKey,updatedOptions)}catch(err){if(this.remoteProvider)return this.remoteProvider.unwrapKey(algorithm,encryptedKey,options);throw err}}))}sign(algorithm,digest,options={}){return tracingClient.withSpan("CryptographyClient.sign",options,(async updatedOptions=>{this.ensureValid(await this.fetchKey(updatedOptions),exports.KnownKeyOperations.Sign);const provider=await this.getProvider("sign",algorithm,updatedOptions);try{return provider.sign(algorithm,digest,updatedOptions)}catch(err){if(this.remoteProvider)return this.remoteProvider.sign(algorithm,digest,updatedOptions);throw err}}))}verify(algorithm,digest,signature,options={}){return tracingClient.withSpan("CryptographyClient.verify",options,(async updatedOptions=>{this.ensureValid(await this.fetchKey(updatedOptions),exports.KnownKeyOperations.Verify);const provider=await this.getProvider("verify",algorithm,updatedOptions);try{return provider.verify(algorithm,digest,signature,updatedOptions)}catch(err){if(this.remoteProvider)return this.remoteProvider.verify(algorithm,digest,signature,updatedOptions);throw err}}))}signData(algorithm,data,options={}){return tracingClient.withSpan("CryptographyClient.signData",options,(async updatedOptions=>{this.ensureValid(await this.fetchKey(updatedOptions),exports.KnownKeyOperations.Sign);const provider=await this.getProvider("signData",algorithm,updatedOptions);try{return provider.signData(algorithm,data,updatedOptions)}catch(err){if(this.remoteProvider)return this.remoteProvider.signData(algorithm,data,options);throw err}}))}verifyData(algorithm,data,signature,options={}){return tracingClient.withSpan("CryptographyClient.verifyData",options,(async updatedOptions=>{this.ensureValid(await this.fetchKey(updatedOptions),exports.KnownKeyOperations.Verify);const provider=await this.getProvider("verifyData",algorithm,updatedOptions);try{return provider.verifyData(algorithm,data,signature,updatedOptions)}catch(err){if(this.remoteProvider)return this.remoteProvider.verifyData(algorithm,data,signature,updatedOptions);throw err}}))}async getKeyMaterial(options){const key=await this.fetchKey(options);switch(key.kind){case"JsonWebKey":return key.value;case"KeyVaultKey":return key.value.key;default:return}}async fetchKey(options){if("identifier"===this.key.kind){let key;try{key=await this.remoteProvider.getKey(options)}catch(e){if(!coreRestPipeline.isRestError(e)||403!==e.statusCode)throw e;logger.verbose(`Permission denied to get key ${this.key.value}. Falling back to remote operation.`),this.key={kind:"remoteOnlyIdentifier",value:this.key.value}}key&&(this.key={kind:"KeyVaultKey",value:key})}return this.key}async getProvider(operation,algorithm,options){if(!this.providers){const keyMaterial=await this.getKeyMaterial(options);this.providers=[],keyMaterial&&this.providers.push(new RsaCryptographyProvider(keyMaterial),new AesCryptographyProvider(keyMaterial)),this.remoteProvider&&this.providers.push(this.remoteProvider)}const providers=this.providers.filter((p=>p.isSupported(algorithm,operation)));if(0===providers.length)throw new Error(`Unable to support operation: "${operation}" with algorithm: "${algorithm}" ${"JsonWebKey"===this.key.kind?"using a local JsonWebKey":""}`);return providers[0]}ensureValid(key,operation){var _a;if("KeyVaultKey"===key.kind){const keyOps=key.value.keyOperations,{notBefore:notBefore,expiresOn:expiresOn}=key.value.properties,now=new Date;if(notBefore&&now<notBefore)throw new Error(`Key ${key.value.id} can't be used before ${notBefore.toISOString()}`);if(expiresOn&&now>expiresOn)throw new Error(`Key ${key.value.id} expired at ${expiresOn.toISOString()}`);if(operation&&keyOps&&!(null==keyOps?void 0:keyOps.includes(operation)))throw new Error(`Operation ${operation} is not supported on key ${key.value.id}`)}else if("JsonWebKey"===key.kind&&operation&&key.value.keyOps&&!(null===(_a=key.value.keyOps)||void 0===_a?void 0:_a.includes(operation)))throw new Error(`Operation ${operation} is not supported on key ${key.value.kid}`)}}exports.KnownEncryptionAlgorithms=void 0,function(KnownEncryptionAlgorithms){KnownEncryptionAlgorithms.RSAOaep="RSA-OAEP",KnownEncryptionAlgorithms.RSAOaep256="RSA-OAEP-256",KnownEncryptionAlgorithms.RSA15="RSA1_5",KnownEncryptionAlgorithms.A128GCM="A128GCM",KnownEncryptionAlgorithms.A192GCM="A192GCM",KnownEncryptionAlgorithms.A256GCM="A256GCM",KnownEncryptionAlgorithms.A128KW="A128KW",KnownEncryptionAlgorithms.A192KW="A192KW",KnownEncryptionAlgorithms.A256KW="A256KW",KnownEncryptionAlgorithms.A128CBC="A128CBC",KnownEncryptionAlgorithms.A192CBC="A192CBC",KnownEncryptionAlgorithms.A256CBC="A256CBC",KnownEncryptionAlgorithms.A128Cbcpad="A128CBCPAD",KnownEncryptionAlgorithms.A192Cbcpad="A192CBCPAD",KnownEncryptionAlgorithms.A256Cbcpad="A256CBCPAD"}(exports.KnownEncryptionAlgorithms||(exports.KnownEncryptionAlgorithms={}));class KeyClient{constructor(vaultUrl,credential,pipelineOptions={}){this.vaultUrl=vaultUrl;const libInfo=`azsdk-js-keyvault-keys/${SDK_VERSION}`,userAgentOptions=pipelineOptions.userAgentOptions;pipelineOptions.userAgentOptions={userAgentPrefix:userAgentOptions&&userAgentOptions.userAgentPrefix?`${userAgentOptions.userAgentPrefix} ${libInfo}`:libInfo};const authPolicy=coreRestPipeline.bearerTokenAuthenticationPolicy({credential:credential,scopes:[],challengeCallbacks:createKeyVaultChallengeCallbacks(pipelineOptions)}),internalPipelineOptions=Object.assign(Object.assign({},pipelineOptions),{loggingOptions:{logger:logger.info,allowedHeaderNames:["x-ms-keyvault-region","x-ms-keyvault-network-info","x-ms-keyvault-service-version"]}});this.credential=credential,this.client=new KeyVaultClient(pipelineOptions.serviceVersion||LATEST_API_VERSION,internalPipelineOptions),this.client.pipeline.addPolicy(authPolicy)}createKey(name,keyType,options){let unflattenedOptions={};if(options){const{enabled:enabled,notBefore:notBefore,expiresOn:expires,exportable:exportable}=options,remainingOptions=tslib.__rest(options,["enabled","notBefore","expiresOn","exportable"]);unflattenedOptions=Object.assign(Object.assign({},remainingOptions),{keyAttributes:{enabled:enabled,notBefore:notBefore,expires:expires,exportable:exportable}})}return tracingClient.withSpan("KeyClient.createKey",unflattenedOptions,(async updatedOptions=>getKeyFromKeyBundle(await this.client.createKey(this.vaultUrl,name,keyType,updatedOptions))))}async createEcKey(name,options){const keyType=(null==options?void 0:options.hsm)?exports.KnownKeyTypes.ECHSM:exports.KnownKeyTypes.EC;return this.createKey(name,keyType,options)}async createRsaKey(name,options){const keyType=(null==options?void 0:options.hsm)?exports.KnownKeyTypes.RSAHSM:exports.KnownKeyTypes.RSA;return this.createKey(name,keyType,options)}async createOctKey(name,options){const keyType=(null==options?void 0:options.hsm)?exports.KnownKeyTypes.OctHSM:exports.KnownKeyTypes.Oct;return this.createKey(name,keyType,options)}importKey(name,key,options){let unflattenedOptions={};if(options){const{enabled:enabled,notBefore:notBefore,exportable:exportable,expiresOn:expires,hardwareProtected:hsm}=options,remainingOptions=tslib.__rest(options,["enabled","notBefore","exportable","expiresOn","hardwareProtected"]);unflattenedOptions=Object.assign(Object.assign({},remainingOptions),{keyAttributes:{enabled:enabled,notBefore:notBefore,expires:expires,hsm:hsm,exportable:exportable}})}return tracingClient.withSpan("KeyClient.importKey",unflattenedOptions,(async updatedOptions=>getKeyFromKeyBundle(await this.client.importKey(this.vaultUrl,name,key,updatedOptions))))}getCryptographyClient(keyName,options){const keyUrl=new URL(["keys",keyName,null==options?void 0:options.keyVersion].filter(Boolean).join("/"),this.vaultUrl),constructorOptions={generatedClient:this.client};return new CryptographyClient(keyUrl.toString(),this.credential,constructorOptions)}async beginDeleteKey(name,options={}){const poller=new DeleteKeyPoller({name:name,vaultUrl:this.vaultUrl,client:this.client,intervalInMs:options.intervalInMs,resumeFrom:options.resumeFrom,operationOptions:options});return await poller.poll(),poller}updateKeyProperties(...args){const[name,keyVersion,options]=this.disambiguateUpdateKeyPropertiesArgs(args);return tracingClient.withSpan("KeyClient.updateKeyProperties",options,(async updatedOptions=>{const{enabled:enabled,notBefore:notBefore,expiresOn:expires}=updatedOptions,remainingOptions=tslib.__rest(updatedOptions,["enabled","notBefore","expiresOn"]),unflattenedOptions=Object.assign(Object.assign({},remainingOptions),{keyAttributes:{enabled:enabled,notBefore:notBefore,expires:expires}});return getKeyFromKeyBundle(await this.client.updateKey(this.vaultUrl,name,keyVersion,unflattenedOptions))}))}disambiguateUpdateKeyPropertiesArgs(args){return"string"==typeof args[1]?[args[0],args[1],args[2]||{}]:[args[0],"",args[1]||{}]}getKey(name,options={}){return tracingClient.withSpan("KeyClient.getKey",options,(async updatedOptions=>getKeyFromKeyBundle(await this.client.getKey(this.vaultUrl,name,options&&options.version?options.version:"",updatedOptions))))}getDeletedKey(name,options={}){return tracingClient.withSpan("KeyClient.getDeletedKey",options,(async updatedOptions=>getKeyFromKeyBundle(await this.client.getDeletedKey(this.vaultUrl,name,updatedOptions))))}purgeDeletedKey(name,options={}){return tracingClient.withSpan("KeyClient.purgeDeletedKey",options,(async updatedOptions=>{await this.client.purgeDeletedKey(this.vaultUrl,name,updatedOptions)}))}async beginRecoverDeletedKey(name,options={}){const poller=new RecoverDeletedKeyPoller({name:name,vaultUrl:this.vaultUrl,client:this.client,intervalInMs:options.intervalInMs,resumeFrom:options.resumeFrom,operationOptions:options});return await poller.poll(),poller}backupKey(name,options={}){return tracingClient.withSpan("KeyClient.backupKey",options,(async updatedOptions=>(await this.client.backupKey(this.vaultUrl,name,updatedOptions)).value))}async restoreKeyBackup(backup,options={}){return tracingClient.withSpan("KeyClient.restoreKeyBackup",options,(async updatedOptions=>getKeyFromKeyBundle(await this.client.restoreKey(this.vaultUrl,backup,updatedOptions))))}getRandomBytes(count,options={}){return tracingClient.withSpan("KeyClient.getRandomBytes",options,(async updatedOptions=>(await this.client.getRandomBytes(this.vaultUrl,count,updatedOptions)).value))}rotateKey(name,options={}){return tracingClient.withSpan("KeyClient.rotateKey",options,(async updatedOptions=>getKeyFromKeyBundle(await this.client.rotateKey(this.vaultUrl,name,updatedOptions))))}releaseKey(name,targetAttestationToken,options={}){return tracingClient.withSpan("KeyClient.releaseKey",options,(async updatedOptions=>{const{nonce:nonce,algorithm:algorithm}=updatedOptions,rest=tslib.__rest(updatedOptions,["nonce","algorithm"]);return{value:(await this.client.release(this.vaultUrl,name,(null==options?void 0:options.version)||"",targetAttestationToken,Object.assign({enc:algorithm,nonce:nonce},rest))).value}}))}getKeyRotationPolicy(keyName,options={}){return tracingClient.withSpan("KeyClient.getKeyRotationPolicy",options,(async()=>{const policy=await this.client.getKeyRotationPolicy(this.vaultUrl,keyName);return keyRotationTransformations.generatedToPublic(policy)}))}updateKeyRotationPolicy(keyName,policy,options={}){return tracingClient.withSpan("KeyClient.updateKeyRotationPolicy",options,(async updatedOptions=>{const result=await this.client.updateKeyRotationPolicy(this.vaultUrl,keyName,keyRotationTransformations.propertiesToGenerated(policy),updatedOptions);return keyRotationTransformations.generatedToPublic(result)}))}listPropertiesOfKeyVersionsPage(name,continuationState,options){return tslib.__asyncGenerator(this,arguments,(function*(){if(null==continuationState.continuationToken){const optionsComplete=Object.assign({maxresults:continuationState.maxPageSize},options),currentSetResponse=yield tslib.__await(tracingClient.withSpan("KeyClient.listPropertiesOfKeyVersionsPage",optionsComplete,(async updatedOptions=>this.client.getKeyVersions(this.vaultUrl,name,updatedOptions))));continuationState.continuationToken=currentSetResponse.nextLink,currentSetResponse.value&&(yield yield tslib.__await(currentSetResponse.value.map(getKeyPropertiesFromKeyItem,this)))}for(;continuationState.continuationToken;){const currentSetResponse=yield tslib.__await(tracingClient.withSpan("KeyClient.listPropertiesOfKeyVersionsPage",options||{},(async updatedOptions=>this.client.getKeyVersionsNext(this.vaultUrl,continuationState.continuationToken,name,updatedOptions))));if(continuationState.continuationToken=currentSetResponse.nextLink,!currentSetResponse.value)break;yield yield tslib.__await(currentSetResponse.value.map(getKeyPropertiesFromKeyItem,this))}}))}listPropertiesOfKeyVersionsAll(name,options){return tslib.__asyncGenerator(this,arguments,(function*(){var _a,e_1,_b,_c;const f={};try{for(var _f,_d=!0,_e=tslib.__asyncValues(this.listPropertiesOfKeyVersionsPage(name,f,options));!(_a=(_f=yield tslib.__await(_e.next())).done);){_c=_f.value,_d=!1;try{const page=_c;for(const item of page)yield yield tslib.__await(item)}finally{_d=!0}}}catch(e_1_1){e_1={error:e_1_1}}finally{try{_d||_a||!(_b=_e.return)||(yield tslib.__await(_b.call(_e)))}finally{if(e_1)throw e_1.error}}}))}listPropertiesOfKeyVersions(name,options={}){const iter=this.listPropertiesOfKeyVersionsAll(name,options);return{next:()=>iter.next(),[Symbol.asyncIterator](){return this},byPage:(settings={})=>this.listPropertiesOfKeyVersionsPage(name,settings,options)}}listPropertiesOfKeysPage(continuationState,options){return tslib.__asyncGenerator(this,arguments,(function*(){if(null==continuationState.continuationToken){const optionsComplete=Object.assign({maxresults:continuationState.maxPageSize},options),currentSetResponse=yield tslib.__await(tracingClient.withSpan("KeyClient.listPropertiesOfKeysPage",optionsComplete,(async updatedOptions=>this.client.getKeys(this.vaultUrl,updatedOptions))));continuationState.continuationToken=currentSetResponse.nextLink,currentSetResponse.value&&(yield yield tslib.__await(currentSetResponse.value.map(getKeyPropertiesFromKeyItem,this)))}for(;continuationState.continuationToken;){const currentSetResponse=yield tslib.__await(tracingClient.withSpan("KeyClient.listPropertiesOfKeysPage",options||{},(async updatedOptions=>this.client.getKeysNext(this.vaultUrl,continuationState.continuationToken,updatedOptions))));if(continuationState.continuationToken=currentSetResponse.nextLink,!currentSetResponse.value)break;yield yield tslib.__await(currentSetResponse.value.map(getKeyPropertiesFromKeyItem,this))}}))}listPropertiesOfKeysAll(options){return tslib.__asyncGenerator(this,arguments,(function*(){var _a,e_2,_b,_c;const f={};try{for(var _f,_d=!0,_e=tslib.__asyncValues(this.listPropertiesOfKeysPage(f,options));!(_a=(_f=yield tslib.__await(_e.next())).done);){_c=_f.value,_d=!1;try{const page=_c;for(const item of page)yield yield tslib.__await(item)}finally{_d=!0}}}catch(e_2_1){e_2={error:e_2_1}}finally{try{_d||_a||!(_b=_e.return)||(yield tslib.__await(_b.call(_e)))}finally{if(e_2)throw e_2.error}}}))}listPropertiesOfKeys(options={}){const iter=this.listPropertiesOfKeysAll(options);return{next:()=>iter.next(),[Symbol.asyncIterator](){return this},byPage:(settings={})=>this.listPropertiesOfKeysPage(settings,options)}}listDeletedKeysPage(continuationState,options){return tslib.__asyncGenerator(this,arguments,(function*(){if(null==continuationState.continuationToken){const optionsComplete=Object.assign({maxresults:continuationState.maxPageSize},options),currentSetResponse=yield tslib.__await(tracingClient.withSpan("KeyClient.listDeletedKeysPage",optionsComplete,(async updatedOptions=>this.client.getDeletedKeys(this.vaultUrl,updatedOptions))));continuationState.continuationToken=currentSetResponse.nextLink,currentSetResponse.value&&(yield yield tslib.__await(currentSetResponse.value.map(getDeletedKeyFromDeletedKeyItem,this)))}for(;continuationState.continuationToken;){const currentSetResponse=yield tslib.__await(tracingClient.withSpan("KeyClient.listDeletedKeysPage",options||{},(async updatedOptions=>this.client.getDeletedKeysNext(this.vaultUrl,continuationState.continuationToken,updatedOptions))));if(continuationState.continuationToken=currentSetResponse.nextLink,!currentSetResponse.value)break;yield yield tslib.__await(currentSetResponse.value.map(getDeletedKeyFromDeletedKeyItem,this))}}))}listDeletedKeysAll(options){return tslib.__asyncGenerator(this,arguments,(function*(){var _a,e_3,_b,_c;const f={};try{for(var _f,_d=!0,_e=tslib.__asyncValues(this.listDeletedKeysPage(f,options));!(_a=(_f=yield tslib.__await(_e.next())).done);){_c=_f.value,_d=!1;try{const page=_c;for(const item of page)yield yield tslib.__await(item)}finally{_d=!0}}}catch(e_3_1){e_3={error:e_3_1}}finally{try{_d||_a||!(_b=_e.return)||(yield tslib.__await(_b.call(_e)))}finally{if(e_3)throw e_3.error}}}))}listDeletedKeys(options={}){const iter=this.listDeletedKeysAll(options);return{next:()=>iter.next(),[Symbol.asyncIterator](){return this},byPage:(settings={})=>this.listDeletedKeysPage(settings,options)}}}exports.CryptographyClient=CryptographyClient,exports.KeyClient=KeyClient,exports.logger=logger,exports.parseKeyVaultKeyIdentifier=parseKeyVaultKeyIdentifier;