/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{PerformanceEvents,Constants,ServerError,InteractionRequiredAuthError}from"@azure/msal-common";import{DEFAULT_REQUEST,InteractionType,CacheLookupPolicy,ApiId,BrowserConstants}from"../utils/BrowserConstants.js";import{ClientApplication}from"./ClientApplication.js";import{EventType}from"../event/EventType.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";import{NativeAuthError}from"../error/NativeAuthError.js";import{NativeMessageHandler}from"../broker/nativeBroker/NativeMessageHandler.js";import{BrowserUtils}from"../utils/BrowserUtils.js";var PublicClientApplication=function(_super){function PublicClientApplication(configuration){var _this=_super.call(this,configuration)||this;return _this.astsAsyncMeasurement=void 0,_this.activeSilentTokenRequests=new Map,_this.trackPageVisibility=_this.trackPageVisibility.bind(_this),_this}return __extends(PublicClientApplication,_super),PublicClientApplication.prototype.loginRedirect=function(request){return __awaiter(this,void 0,void 0,(function(){var correlationId;return __generator(this,(function(_a){return correlationId=this.getRequestCorrelationId(request),this.logger.verbose("loginRedirect called",correlationId),[2,this.acquireTokenRedirect(__assign({correlationId:correlationId},request||DEFAULT_REQUEST))]}))}))},PublicClientApplication.prototype.loginPopup=function(request){var correlationId=this.getRequestCorrelationId(request);return this.logger.verbose("loginPopup called",correlationId),this.acquireTokenPopup(__assign({correlationId:correlationId},request||DEFAULT_REQUEST))},PublicClientApplication.prototype.acquireTokenSilent=function(request){return __awaiter(this,void 0,void 0,(function(){var correlationId,atsMeasurement,account,thumbprint,silentRequestKey,cachedResponse,response,_this=this;return __generator(this,(function(_a){if(correlationId=this.getRequestCorrelationId(request),(atsMeasurement=this.performanceClient.startMeasurement(PerformanceEvents.AcquireTokenSilent,correlationId)).addStaticFields({cacheLookupPolicy:request.cacheLookupPolicy}),this.preflightBrowserEnvironmentCheck(InteractionType.Silent),this.logger.verbose("acquireTokenSilent called",correlationId),!(account=request.account||this.getActiveAccount()))throw BrowserAuthError.createNoAccountError();return thumbprint={clientId:this.config.auth.clientId,authority:request.authority||Constants.EMPTY_STRING,scopes:request.scopes,homeAccountIdentifier:account.homeAccountId,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},silentRequestKey=JSON.stringify(thumbprint),void 0===(cachedResponse=this.activeSilentTokenRequests.get(silentRequestKey))?(this.logger.verbose("acquireTokenSilent called for the first time, storing active request",correlationId),this.performanceClient.setPreQueueTime(PerformanceEvents.AcquireTokenSilentAsync,correlationId),response=this.acquireTokenSilentAsync(__assign(__assign({},request),{correlationId:correlationId}),account).then((function(result){return _this.activeSilentTokenRequests.delete(silentRequestKey),atsMeasurement.addStaticFields({accessTokenSize:result.accessToken.length,idTokenSize:result.idToken.length}),atsMeasurement.endMeasurement({success:!0,fromCache:result.fromCache,isNativeBroker:result.fromNativeBroker,cacheLookupPolicy:request.cacheLookupPolicy,requestId:result.requestId}),result})).catch((function(error){throw _this.activeSilentTokenRequests.delete(silentRequestKey),atsMeasurement.endMeasurement({errorCode:error.errorCode,subErrorCode:error.subError,success:!1}),error})),this.activeSilentTokenRequests.set(silentRequestKey,response),[2,response]):(this.logger.verbose("acquireTokenSilent has been called previously, returning the result from the first call",correlationId),atsMeasurement.discardMeasurement(),[2,cachedResponse])}))}))},PublicClientApplication.prototype.trackPageVisibility=function(){this.astsAsyncMeasurement&&(this.logger.info("Perf: Visibility change detected"),this.astsAsyncMeasurement.increment({visibilityChangeCount:1}))},PublicClientApplication.prototype.acquireTokenSilentAsync=function(request,account){var _a;return __awaiter(this,void 0,void 0,(function(){var result,silentRequest,silentCacheClient,silentRequest_1,requestWithCLP_1,_this=this;return __generator(this,(function(_b){switch(_b.label){case 0:return this.performanceClient.addQueueMeasurement(PerformanceEvents.AcquireTokenSilentAsync,request.correlationId),this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_START,InteractionType.Silent,request),this.astsAsyncMeasurement=this.performanceClient.startMeasurement(PerformanceEvents.AcquireTokenSilentAsync,request.correlationId),null===(_a=this.astsAsyncMeasurement)||void 0===_a||_a.increment({visibilityChangeCount:0}),document.addEventListener("visibilitychange",this.trackPageVisibility),NativeMessageHandler.isNativeAvailable(this.config,this.logger,this.nativeExtensionProvider,request.authenticationScheme)&&account.nativeAccountId?(this.logger.verbose("acquireTokenSilent - attempting to acquire token from native platform"),silentRequest=__assign(__assign({},request),{account:account}),result=this.acquireTokenNative(silentRequest,ApiId.acquireTokenSilent_silentFlow).catch((function(e){return __awaiter(_this,void 0,void 0,(function(){return __generator(this,(function(_a){if(e instanceof NativeAuthError&&e.isFatal())return this.logger.verbose("acquireTokenSilent - native platform unavailable, falling back to web flow"),this.nativeExtensionProvider=void 0,[2,this.createSilentIframeClient(request.correlationId).acquireToken(request)];throw e}))}))})),[3,3]):[3,1];case 1:return this.logger.verbose("acquireTokenSilent - attempting to acquire token from web flow"),silentCacheClient=this.createSilentCacheClient(request.correlationId),this.performanceClient.setPreQueueTime(PerformanceEvents.InitializeSilentRequest,request.correlationId),[4,silentCacheClient.initializeSilentRequest(request,account)];case 2:silentRequest_1=_b.sent(),requestWithCLP_1=__assign(__assign({},request),{cacheLookupPolicy:request.cacheLookupPolicy||CacheLookupPolicy.Default}),this.performanceClient.setPreQueueTime(PerformanceEvents.AcquireTokenFromCache,silentRequest_1.correlationId),result=this.acquireTokenFromCache(silentCacheClient,silentRequest_1,requestWithCLP_1).catch((function(cacheError){if(requestWithCLP_1.cacheLookupPolicy===CacheLookupPolicy.AccessToken)throw cacheError;return BrowserUtils.blockReloadInHiddenIframes(),_this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_NETWORK_START,InteractionType.Silent,silentRequest_1),_this.performanceClient.setPreQueueTime(PerformanceEvents.AcquireTokenByRefreshToken,silentRequest_1.correlationId),_this.acquireTokenByRefreshToken(silentRequest_1,requestWithCLP_1).catch((function(refreshTokenError){var isServerError=refreshTokenError instanceof ServerError,isInteractionRequiredError=refreshTokenError instanceof InteractionRequiredAuthError,isInvalidGrantError=refreshTokenError.errorCode===BrowserConstants.INVALID_GRANT_ERROR;if((!isServerError||!isInvalidGrantError||isInteractionRequiredError||requestWithCLP_1.cacheLookupPolicy===CacheLookupPolicy.AccessTokenAndRefreshToken||requestWithCLP_1.cacheLookupPolicy===CacheLookupPolicy.RefreshToken)&&requestWithCLP_1.cacheLookupPolicy!==CacheLookupPolicy.Skip)throw refreshTokenError;return _this.logger.verbose("Refresh token expired/invalid or CacheLookupPolicy is set to Skip, attempting acquire token by iframe.",request.correlationId),_this.performanceClient.setPreQueueTime(PerformanceEvents.AcquireTokenBySilentIframe,silentRequest_1.correlationId),_this.acquireTokenBySilentIframe(silentRequest_1)}))})),_b.label=3;case 3:return[2,result.then((function(response){var _a;return _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_SUCCESS,InteractionType.Silent,response),null===(_a=_this.astsAsyncMeasurement)||void 0===_a||_a.endMeasurement({success:!0,fromCache:response.fromCache,isNativeBroker:response.fromNativeBroker,requestId:response.requestId}),response})).catch((function(tokenRenewalError){var _a;throw _this.eventHandler.emitEvent(EventType.ACQUIRE_TOKEN_FAILURE,InteractionType.Silent,null,tokenRenewalError),null===(_a=_this.astsAsyncMeasurement)||void 0===_a||_a.endMeasurement({errorCode:tokenRenewalError.errorCode,subErrorCode:tokenRenewalError.subError,success:!1}),tokenRenewalError})).finally((function(){document.removeEventListener("visibilitychange",_this.trackPageVisibility)}))]}}))}))},PublicClientApplication}(ClientApplication);export{PublicClientApplication};