/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__awaiter,__generator}from"../_virtual/_tslib.js";import{BrowserAuthError,BrowserAuthErrorMessage}from"../error/BrowserAuthError.js";import{DatabaseStorage}from"./DatabaseStorage.js";import{MemoryStorage}from"./MemoryStorage.js";var AsyncMemoryStorage=function(){function AsyncMemoryStorage(logger,storeName){this.inMemoryCache=new MemoryStorage,this.indexedDBCache=new DatabaseStorage,this.logger=logger,this.storeName=storeName}return AsyncMemoryStorage.prototype.handleDatabaseAccessError=function(error){if(!(error instanceof BrowserAuthError&&error.errorCode===BrowserAuthErrorMessage.databaseUnavailable.code))throw error;this.logger.error("Could not access persistent storage. This may be caused by browser privacy features which block persistent storage in third-party contexts.")},AsyncMemoryStorage.prototype.getItem=function(key){return __awaiter(this,void 0,void 0,(function(){var item,e_1;return __generator(this,(function(_a){switch(_a.label){case 0:if(item=this.inMemoryCache.getItem(key))return[3,4];_a.label=1;case 1:return _a.trys.push([1,3,,4]),this.logger.verbose("Queried item not found in in-memory cache, now querying persistent storage."),[4,this.indexedDBCache.getItem(key)];case 2:return[2,_a.sent()];case 3:return e_1=_a.sent(),this.handleDatabaseAccessError(e_1),[3,4];case 4:return[2,item]}}))}))},AsyncMemoryStorage.prototype.setItem=function(key,value){return __awaiter(this,void 0,void 0,(function(){var e_2;return __generator(this,(function(_a){switch(_a.label){case 0:this.inMemoryCache.setItem(key,value),_a.label=1;case 1:return _a.trys.push([1,3,,4]),[4,this.indexedDBCache.setItem(key,value)];case 2:return _a.sent(),[3,4];case 3:return e_2=_a.sent(),this.handleDatabaseAccessError(e_2),[3,4];case 4:return[2]}}))}))},AsyncMemoryStorage.prototype.removeItem=function(key){return __awaiter(this,void 0,void 0,(function(){var e_3;return __generator(this,(function(_a){switch(_a.label){case 0:this.inMemoryCache.removeItem(key),_a.label=1;case 1:return _a.trys.push([1,3,,4]),[4,this.indexedDBCache.removeItem(key)];case 2:return _a.sent(),[3,4];case 3:return e_3=_a.sent(),this.handleDatabaseAccessError(e_3),[3,4];case 4:return[2]}}))}))},AsyncMemoryStorage.prototype.getKeys=function(){return __awaiter(this,void 0,void 0,(function(){var cacheKeys,e_4;return __generator(this,(function(_a){switch(_a.label){case 0:if(0!==(cacheKeys=this.inMemoryCache.getKeys()).length)return[3,4];_a.label=1;case 1:return _a.trys.push([1,3,,4]),this.logger.verbose("In-memory cache is empty, now querying persistent storage."),[4,this.indexedDBCache.getKeys()];case 2:return[2,_a.sent()];case 3:return e_4=_a.sent(),this.handleDatabaseAccessError(e_4),[3,4];case 4:return[2,cacheKeys]}}))}))},AsyncMemoryStorage.prototype.containsKey=function(key){return __awaiter(this,void 0,void 0,(function(){var containsKey,e_5;return __generator(this,(function(_a){switch(_a.label){case 0:if(containsKey=this.inMemoryCache.containsKey(key))return[3,4];_a.label=1;case 1:return _a.trys.push([1,3,,4]),this.logger.verbose("Key not found in in-memory cache, now querying persistent storage."),[4,this.indexedDBCache.containsKey(key)];case 2:return[2,_a.sent()];case 3:return e_5=_a.sent(),this.handleDatabaseAccessError(e_5),[3,4];case 4:return[2,containsKey]}}))}))},AsyncMemoryStorage.prototype.clearInMemory=function(){this.logger.verbose("Deleting in-memory keystore "+this.storeName),this.inMemoryCache.clear(),this.logger.verbose("In-memory keystore "+this.storeName+" deleted")},AsyncMemoryStorage.prototype.clearPersistent=function(){return __awaiter(this,void 0,void 0,(function(){var dbDeleted,e_6;return __generator(this,(function(_a){switch(_a.label){case 0:return _a.trys.push([0,2,,3]),this.logger.verbose("Deleting persistent keystore"),[4,this.indexedDBCache.deleteDatabase()];case 1:return(dbDeleted=_a.sent())&&this.logger.verbose("Persistent keystore deleted"),[2,dbDeleted];case 2:return e_6=_a.sent(),this.handleDatabaseAccessError(e_6),[2,!1];case 3:return[2]}}))}))},AsyncMemoryStorage}();export{AsyncMemoryStorage};