/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__awaiter,__generator}from"../_virtual/_tslib.js";import{BrowserStringUtils}from"../utils/BrowserStringUtils.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";import{ModernBrowserCrypto}from"./ModernBrowserCrypto.js";import{MsrBrowserCrypto}from"./MsrBrowserCrypto.js";import{MsBrowserCrypto}from"./MsBrowserCrypto.js";import{BrowserConfigurationAuthError}from"../error/BrowserConfigurationAuthError.js";var PKCS1_V15_KEYGEN_ALG="RSASSA-PKCS1-v1_5",S256_HASH_ALG="SHA-256",MODULUS_LENGTH=2048,PUBLIC_EXPONENT=new Uint8Array([1,0,1]),BrowserCrypto=function(){function BrowserCrypto(logger,cryptoOptions){var _a,_b;if(this.logger=logger,this.cryptoOptions=cryptoOptions,this.hasBrowserCrypto())this.logger.verbose("BrowserCrypto: modern crypto interface available"),this.subtleCrypto=new ModernBrowserCrypto;else if(this.hasIECrypto())this.logger.verbose("BrowserCrypto: MS crypto interface available"),this.subtleCrypto=new MsBrowserCrypto;else{if(!this.hasMsrCrypto()||!(null===(_a=this.cryptoOptions)||void 0===_a?void 0:_a.useMsrCrypto))throw this.hasMsrCrypto()&&this.logger.info("BrowserCrypto: MSR Crypto interface available but system.cryptoOptions.useMsrCrypto not enabled"),this.logger.error("BrowserCrypto: No crypto interfaces available."),BrowserAuthError.createCryptoNotAvailableError("Browser crypto, msCrypto, or msrCrypto interfaces not available.");this.logger.verbose("BrowserCrypto: MSR crypto interface available"),this.subtleCrypto=new MsrBrowserCrypto}if(this.subtleCrypto.initPrng){if(this.logger.verbose("BrowserCrypto: Interface requires entropy"),!(null===(_b=this.cryptoOptions)||void 0===_b?void 0:_b.entropy))throw this.logger.error("BrowserCrypto: Interface requires entropy but none provided."),BrowserConfigurationAuthError.createEntropyNotProvided();this.logger.verbose("BrowserCrypto: Entropy provided"),this.subtleCrypto.initPrng(this.cryptoOptions.entropy)}this.keygenAlgorithmOptions={name:PKCS1_V15_KEYGEN_ALG,hash:S256_HASH_ALG,modulusLength:MODULUS_LENGTH,publicExponent:PUBLIC_EXPONENT}}return BrowserCrypto.prototype.hasIECrypto=function(){return"msCrypto"in window},BrowserCrypto.prototype.hasBrowserCrypto=function(){return"crypto"in window},BrowserCrypto.prototype.hasMsrCrypto=function(){return"msrCrypto"in window},BrowserCrypto.prototype.sha256Digest=function(dataString){return __awaiter(this,void 0,void 0,(function(){var data;return __generator(this,(function(_a){return data=BrowserStringUtils.stringToUtf8Arr(dataString),[2,this.subtleCrypto.digest({name:S256_HASH_ALG},data)]}))}))},BrowserCrypto.prototype.getRandomValues=function(dataBuffer){return this.subtleCrypto.getRandomValues(dataBuffer)},BrowserCrypto.prototype.generateKeyPair=function(extractable,usages){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(_a){return[2,this.subtleCrypto.generateKey(this.keygenAlgorithmOptions,extractable,usages)]}))}))},BrowserCrypto.prototype.exportJwk=function(key){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(_a){return[2,this.subtleCrypto.exportKey(key)]}))}))},BrowserCrypto.prototype.importJwk=function(key,extractable,usages){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(_a){return[2,this.subtleCrypto.importKey(key,this.keygenAlgorithmOptions,extractable,usages)]}))}))},BrowserCrypto.prototype.sign=function(key,data){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(_a){return[2,this.subtleCrypto.sign(this.keygenAlgorithmOptions,key,data)]}))}))},BrowserCrypto}();export{BrowserCrypto};