/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign}from"../_virtual/_tslib.js";import{AuthError,PerformanceEvents,Constants}from"@azure/msal-common";import{StandardInteractionClient}from"./StandardInteractionClient.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";import{InteractionType}from"../utils/BrowserConstants.js";import{SilentHandler}from"../interaction_handler/SilentHandler.js";import{HybridSpaAuthorizationCodeClient}from"./HybridSpaAuthorizationCodeClient.js";var SilentAuthCodeClient=function(_super){function SilentAuthCodeClient(config,storageImpl,browserCrypto,logger,eventHandler,navigationClient,apiId,performanceClient,nativeMessageHandler,correlationId){var _this=_super.call(this,config,storageImpl,browserCrypto,logger,eventHandler,navigationClient,performanceClient,nativeMessageHandler,correlationId)||this;return _this.apiId=apiId,_this}return __extends(SilentAuthCodeClient,_super),SilentAuthCodeClient.prototype.acquireToken=function(request){return __awaiter(this,void 0,void 0,(function(){var silentRequest,serverTelemetryManager,authCodeRequest,clientConfig,authClient,e_1;return __generator(this,(function(_a){switch(_a.label){case 0:if(this.logger.trace("SilentAuthCodeClient.acquireToken called"),!request.code)throw BrowserAuthError.createAuthCodeRequiredError();return this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientInitializeAuthorizationRequest,request.correlationId),[4,this.initializeAuthorizationRequest(request,InteractionType.Silent)];case 1:silentRequest=_a.sent(),this.browserStorage.updateCacheEntries(silentRequest.state,silentRequest.nonce,silentRequest.authority,silentRequest.loginHint||Constants.EMPTY_STRING,silentRequest.account||null),serverTelemetryManager=this.initializeServerTelemetryManager(this.apiId),_a.label=2;case 2:return _a.trys.push([2,4,,5]),authCodeRequest=__assign(__assign({},silentRequest),{code:request.code}),this.performanceClient.setPreQueueTime(PerformanceEvents.StandardInteractionClientGetClientConfiguration,request.correlationId),[4,this.getClientConfiguration(serverTelemetryManager,silentRequest.authority)];case 3:return clientConfig=_a.sent(),authClient=new HybridSpaAuthorizationCodeClient(clientConfig),this.logger.verbose("Auth code client created"),[2,new SilentHandler(authClient,this.browserStorage,authCodeRequest,this.logger,this.config.system,this.performanceClient).handleCodeResponseFromServer({code:request.code,msgraph_host:request.msGraphHost,cloud_graph_host_name:request.cloudGraphHostName,cloud_instance_host_name:request.cloudInstanceHostName},silentRequest.state,authClient.authority,this.networkClient,!1)];case 4:throw(e_1=_a.sent())instanceof AuthError&&e_1.setCorrelationId(this.correlationId),serverTelemetryManager.cacheFailedRequest(e_1),this.browserStorage.cleanRequestByState(silentRequest.state),e_1;case 5:return[2]}}))}))},SilentAuthCodeClient.prototype.logout=function(){return Promise.reject(BrowserAuthError.createSilentLogoutUnsupportedError())},SilentAuthCodeClient}(StandardInteractionClient);export{SilentAuthCodeClient};