/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__awaiter,__generator}from"../_virtual/_tslib.js";import{PerformanceEvents,StringUtils,ClientAuthError,ServerError,AuthorityFactory}from"@azure/msal-common";import{BrowserAuthError,BrowserAuthErrorMessage}from"../error/BrowserAuthError.js";import{TemporaryCacheKeys}from"../utils/BrowserConstants.js";var InteractionHandler=function(){function InteractionHandler(authCodeModule,storageImpl,authCodeRequest,logger,performanceClient){this.authModule=authCodeModule,this.browserStorage=storageImpl,this.authCodeRequest=authCodeRequest,this.logger=logger,this.performanceClient=performanceClient}return InteractionHandler.prototype.handleCodeResponseFromHash=function(locationHash,state,authority,networkModule){return __awaiter(this,void 0,void 0,(function(){var stateKey,requestState,authCodeResponse;return __generator(this,(function(_a){if(this.performanceClient.addQueueMeasurement(PerformanceEvents.HandleCodeResponseFromHash,this.authCodeRequest.correlationId),this.logger.verbose("InteractionHandler.handleCodeResponse called"),StringUtils.isEmpty(locationHash))throw BrowserAuthError.createEmptyHashError(locationHash);if(stateKey=this.browserStorage.generateStateKey(state),!(requestState=this.browserStorage.getTemporaryCache(stateKey)))throw ClientAuthError.createStateNotFoundError("Cached State");try{authCodeResponse=this.authModule.handleFragmentResponse(locationHash,requestState)}catch(e){throw e instanceof ServerError&&e.subError===BrowserAuthErrorMessage.userCancelledError.code?BrowserAuthError.createUserCancelledError():e}return this.performanceClient.setPreQueueTime(PerformanceEvents.HandleCodeResponseFromServer,this.authCodeRequest.correlationId),[2,this.handleCodeResponseFromServer(authCodeResponse,state,authority,networkModule)]}))}))},InteractionHandler.prototype.handleCodeResponseFromServer=function(authCodeResponse,state,authority,networkModule,validateNonce){return void 0===validateNonce&&(validateNonce=!0),__awaiter(this,void 0,void 0,(function(){var stateKey,requestState,nonceKey,cachedNonce,cachedCcsCred,tokenResponse;return __generator(this,(function(_a){switch(_a.label){case 0:if(this.performanceClient.addQueueMeasurement(PerformanceEvents.HandleCodeResponseFromServer,this.authCodeRequest.correlationId),this.logger.trace("InteractionHandler.handleCodeResponseFromServer called"),stateKey=this.browserStorage.generateStateKey(state),!(requestState=this.browserStorage.getTemporaryCache(stateKey)))throw ClientAuthError.createStateNotFoundError("Cached State");return nonceKey=this.browserStorage.generateNonceKey(requestState),cachedNonce=this.browserStorage.getTemporaryCache(nonceKey),this.authCodeRequest.code=authCodeResponse.code,authCodeResponse.cloud_instance_host_name?(this.performanceClient.setPreQueueTime(PerformanceEvents.UpdateTokenEndpointAuthority,this.authCodeRequest.correlationId),[4,this.updateTokenEndpointAuthority(authCodeResponse.cloud_instance_host_name,authority,networkModule)]):[3,2];case 1:_a.sent(),_a.label=2;case 2:return validateNonce&&(authCodeResponse.nonce=cachedNonce||void 0),authCodeResponse.state=requestState,authCodeResponse.client_info?this.authCodeRequest.clientInfo=authCodeResponse.client_info:(cachedCcsCred=this.checkCcsCredentials())&&(this.authCodeRequest.ccsCredential=cachedCcsCred),this.performanceClient.setPreQueueTime(PerformanceEvents.AuthClientAcquireToken,this.authCodeRequest.correlationId),[4,this.authModule.acquireToken(this.authCodeRequest,authCodeResponse)];case 3:return tokenResponse=_a.sent(),this.browserStorage.cleanRequestByState(state),[2,tokenResponse]}}))}))},InteractionHandler.prototype.updateTokenEndpointAuthority=function(cloudInstanceHostname,authority,networkModule){return __awaiter(this,void 0,void 0,(function(){var cloudInstanceAuthorityUri,cloudInstanceAuthority;return __generator(this,(function(_a){switch(_a.label){case 0:return this.performanceClient.addQueueMeasurement(PerformanceEvents.UpdateTokenEndpointAuthority,this.authCodeRequest.correlationId),cloudInstanceAuthorityUri="https://"+cloudInstanceHostname+"/"+authority.tenant+"/",[4,AuthorityFactory.createDiscoveredInstance(cloudInstanceAuthorityUri,networkModule,this.browserStorage,authority.options,this.logger,this.performanceClient,this.authCodeRequest.correlationId)];case 1:return cloudInstanceAuthority=_a.sent(),this.authModule.updateAuthority(cloudInstanceAuthority),[2]}}))}))},InteractionHandler.prototype.checkCcsCredentials=function(){var cachedCcsCred=this.browserStorage.getTemporaryCache(TemporaryCacheKeys.CCS_CREDENTIAL,!0);if(cachedCcsCred)try{return JSON.parse(cachedCcsCred)}catch(e){this.authModule.logger.error("Cache credential could not be parsed"),this.authModule.logger.errorPii("Cache credential could not be parsed: "+cachedCcsCred)}return null},InteractionHandler}();export{InteractionHandler};