/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator}from"../_virtual/_tslib.js";import{StringUtils,ClientAuthError,ServerError}from"@azure/msal-common";import{BrowserAuthError,BrowserAuthErrorMessage}from"../error/BrowserAuthError.js";import{TemporaryCacheKeys,ApiId}from"../utils/BrowserConstants.js";import{InteractionHandler}from"./InteractionHandler.js";var RedirectHandler=function(_super){function RedirectHandler(authCodeModule,storageImpl,authCodeRequest,logger,browserCrypto,performanceClient){var _this=_super.call(this,authCodeModule,storageImpl,authCodeRequest,logger,performanceClient)||this;return _this.browserCrypto=browserCrypto,_this}return __extends(RedirectHandler,_super),RedirectHandler.prototype.initiateAuthRequest=function(requestUrl,params){return __awaiter(this,void 0,void 0,(function(){var navigationOptions;return __generator(this,(function(_a){switch(_a.label){case 0:return this.logger.verbose("RedirectHandler.initiateAuthRequest called"),StringUtils.isEmpty(requestUrl)?[3,7]:(params.redirectStartPage&&(this.logger.verbose("RedirectHandler.initiateAuthRequest: redirectStartPage set, caching start page"),this.browserStorage.setTemporaryCache(TemporaryCacheKeys.ORIGIN_URI,params.redirectStartPage,!0)),this.browserStorage.setTemporaryCache(TemporaryCacheKeys.CORRELATION_ID,this.authCodeRequest.correlationId,!0),this.browserStorage.cacheCodeRequest(this.authCodeRequest,this.browserCrypto),this.logger.infoPii("RedirectHandler.initiateAuthRequest: Navigate to: "+requestUrl),navigationOptions={apiId:ApiId.acquireTokenRedirect,timeout:params.redirectTimeout,noHistory:!1},"function"!=typeof params.onRedirectNavigate?[3,4]:(this.logger.verbose("RedirectHandler.initiateAuthRequest: Invoking onRedirectNavigate callback"),!1===params.onRedirectNavigate(requestUrl)?[3,2]:(this.logger.verbose("RedirectHandler.initiateAuthRequest: onRedirectNavigate did not return false, navigating"),[4,params.navigationClient.navigateExternal(requestUrl,navigationOptions)])));case 1:case 5:return _a.sent(),[2];case 2:return this.logger.verbose("RedirectHandler.initiateAuthRequest: onRedirectNavigate returned false, stopping navigation"),[2];case 3:return[3,6];case 4:return this.logger.verbose("RedirectHandler.initiateAuthRequest: Navigating window to navigate url"),[4,params.navigationClient.navigateExternal(requestUrl,navigationOptions)];case 6:return[3,8];case 7:throw this.logger.info("RedirectHandler.initiateAuthRequest: Navigate url is empty"),BrowserAuthError.createEmptyNavigationUriError();case 8:return[2]}}))}))},RedirectHandler.prototype.handleCodeResponseFromHash=function(locationHash,state,authority,networkModule){return __awaiter(this,void 0,void 0,(function(){var stateKey,requestState,authCodeResponse,nonceKey,cachedNonce,cachedCcsCred,tokenResponse;return __generator(this,(function(_a){switch(_a.label){case 0:if(this.logger.verbose("RedirectHandler.handleCodeResponse called"),StringUtils.isEmpty(locationHash))throw BrowserAuthError.createEmptyHashError(locationHash);if(this.browserStorage.setInteractionInProgress(!1),stateKey=this.browserStorage.generateStateKey(state),!(requestState=this.browserStorage.getTemporaryCache(stateKey)))throw ClientAuthError.createStateNotFoundError("Cached State");try{authCodeResponse=this.authModule.handleFragmentResponse(locationHash,requestState)}catch(e){throw e instanceof ServerError&&e.subError===BrowserAuthErrorMessage.userCancelledError.code?BrowserAuthError.createUserCancelledError():e}return nonceKey=this.browserStorage.generateNonceKey(requestState),cachedNonce=this.browserStorage.getTemporaryCache(nonceKey),this.authCodeRequest.code=authCodeResponse.code,authCodeResponse.cloud_instance_host_name?[4,this.updateTokenEndpointAuthority(authCodeResponse.cloud_instance_host_name,authority,networkModule)]:[3,2];case 1:_a.sent(),_a.label=2;case 2:return authCodeResponse.nonce=cachedNonce||void 0,authCodeResponse.state=requestState,authCodeResponse.client_info?this.authCodeRequest.clientInfo=authCodeResponse.client_info:(cachedCcsCred=this.checkCcsCredentials())&&(this.authCodeRequest.ccsCredential=cachedCcsCred),[4,this.authModule.acquireToken(this.authCodeRequest,authCodeResponse)];case 3:return tokenResponse=_a.sent(),this.browserStorage.cleanRequestByState(state),[2,tokenResponse]}}))}))},RedirectHandler}(InteractionHandler);export{RedirectHandler};