/*! @azure/msal-browser v2.37.1 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator}from"../_virtual/_tslib.js";import{PerformanceEvents,StringUtils,Constants,UrlString}from"@azure/msal-common";import{InteractionHandler}from"./InteractionHandler.js";import{BrowserAuthError}from"../error/BrowserAuthError.js";import{DEFAULT_IFRAME_TIMEOUT_MS}from"../config/Configuration.js";var SilentHandler=function(_super){function SilentHandler(authCodeModule,storageImpl,authCodeRequest,logger,systemOptions,performanceClient){var _this=_super.call(this,authCodeModule,storageImpl,authCodeRequest,logger,performanceClient)||this;return _this.navigateFrameWait=systemOptions.navigateFrameWait,_this.pollIntervalMilliseconds=systemOptions.pollIntervalMilliseconds,_this}return __extends(SilentHandler,_super),SilentHandler.prototype.initiateAuthRequest=function(requestUrl){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(_a){switch(_a.label){case 0:if(this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentHandlerInitiateAuthRequest,this.authCodeRequest.correlationId),StringUtils.isEmpty(requestUrl))throw this.logger.info("Navigate url is empty"),BrowserAuthError.createEmptyNavigationUriError();return this.navigateFrameWait?(this.performanceClient.setPreQueueTime(PerformanceEvents.SilentHandlerLoadFrame,this.authCodeRequest.correlationId),[4,this.loadFrame(requestUrl)]):[3,2];case 1:return[2,_a.sent()];case 2:return[2,this.loadFrameSync(requestUrl)]}}))}))},SilentHandler.prototype.monitorIframeForHash=function(iframe,timeout){var _this=this;return this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentHandlerMonitorIframeForHash,this.authCodeRequest.correlationId),new Promise((function(resolve,reject){timeout<DEFAULT_IFRAME_TIMEOUT_MS&&_this.logger.warning("system.loadFrameTimeout or system.iframeHashTimeout set to lower ("+timeout+"ms) than the default ("+DEFAULT_IFRAME_TIMEOUT_MS+"ms). This may result in timeouts.");var timeoutMark=window.performance.now()+timeout,intervalId=setInterval((function(){if(window.performance.now()>timeoutMark)return _this.removeHiddenIframe(iframe),clearInterval(intervalId),void reject(BrowserAuthError.createMonitorIframeTimeoutError());var href=Constants.EMPTY_STRING,contentWindow=iframe.contentWindow;try{href=contentWindow?contentWindow.location.href:Constants.EMPTY_STRING}catch(e){}if(!StringUtils.isEmpty(href)){var contentHash=contentWindow?contentWindow.location.hash:Constants.EMPTY_STRING;return UrlString.hashContainsKnownProperties(contentHash)?(_this.removeHiddenIframe(iframe),clearInterval(intervalId),void resolve(contentHash)):void 0}}),_this.pollIntervalMilliseconds)}))},SilentHandler.prototype.loadFrame=function(urlNavigate){var _this=this;return this.performanceClient.addQueueMeasurement(PerformanceEvents.SilentHandlerLoadFrame,this.authCodeRequest.correlationId),new Promise((function(resolve,reject){var frameHandle=_this.createHiddenIframe();setTimeout((function(){frameHandle?(frameHandle.src=urlNavigate,resolve(frameHandle)):reject("Unable to load iframe")}),_this.navigateFrameWait)}))},SilentHandler.prototype.loadFrameSync=function(urlNavigate){var frameHandle=this.createHiddenIframe();return frameHandle.src=urlNavigate,frameHandle},SilentHandler.prototype.createHiddenIframe=function(){var authFrame=document.createElement("iframe");return authFrame.style.visibility="hidden",authFrame.style.position="absolute",authFrame.style.width=authFrame.style.height="0",authFrame.style.border="0",authFrame.setAttribute("sandbox","allow-scripts allow-same-origin allow-forms"),document.getElementsByTagName("body")[0].appendChild(authFrame),authFrame},SilentHandler.prototype.removeHiddenIframe=function(iframe){document.body===iframe.parentNode&&document.body.removeChild(iframe)},SilentHandler}(InteractionHandler);export{SilentHandler};