/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator,__assign,__spreadArrays}from"../_virtual/_tslib.js";import{BaseClient}from"./BaseClient.js";import{RequestParameterBuilder}from"../request/RequestParameterBuilder.js";import{Separators,AADServerParamKeys,AuthenticationScheme,GrantType,PromptValue,HeaderNames}from"../utils/Constants.js";import{ResponseHandler}from"../response/ResponseHandler.js";import{StringUtils}from"../utils/StringUtils.js";import{ClientAuthError}from"../error/ClientAuthError.js";import{UrlString}from"../url/UrlString.js";import{PopTokenGenerator}from"../crypto/PopTokenGenerator.js";import{TimeUtils}from"../utils/TimeUtils.js";import{buildClientInfo,buildClientInfoFromHomeAccountId}from"../account/ClientInfo.js";import{CcsCredentialType}from"../account/CcsCredential.js";import{ClientConfigurationError}from"../error/ClientConfigurationError.js";import{RequestValidator}from"../request/RequestValidator.js";import{PerformanceEvents}from"../telemetry/performance/PerformanceEvent.js";var AuthorizationCodeClient=function(_super){function AuthorizationCodeClient(configuration,performanceClient){var _this=_super.call(this,configuration,performanceClient)||this;return _this.includeRedirectUri=!0,_this}return __extends(AuthorizationCodeClient,_super),AuthorizationCodeClient.prototype.getAuthCodeUrl=function(request){var _a,_b;return __awaiter(this,void 0,void 0,(function(){var queryString;return __generator(this,(function(_c){switch(_c.label){case 0:return null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.GetAuthCodeUrl,request.correlationId),null===(_b=this.performanceClient)||void 0===_b||_b.setPreQueueTime(PerformanceEvents.AuthClientCreateQueryString,request.correlationId),[4,this.createAuthCodeUrlQueryString(request)];case 1:return queryString=_c.sent(),[2,UrlString.appendQueryString(this.authority.authorizationEndpoint,queryString)]}}))}))},AuthorizationCodeClient.prototype.acquireToken=function(request,authCodePayload){var _a,_b,_c,_d,_e,_f;return __awaiter(this,void 0,void 0,(function(){var atsMeasurement,reqTimestamp,response,requestId,httpVerAuthority,responseHandler,_this=this;return __generator(this,(function(_g){switch(_g.label){case 0:if(!request||!request.code)throw ClientAuthError.createTokenRequestCannotBeMadeError();return null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.AuthClientAcquireToken,request.correlationId),atsMeasurement=null===(_b=this.performanceClient)||void 0===_b?void 0:_b.startMeasurement("AuthCodeClientAcquireToken",request.correlationId),this.logger.info("in acquireToken call in auth-code client"),reqTimestamp=TimeUtils.nowSeconds(),null===(_c=this.performanceClient)||void 0===_c||_c.setPreQueueTime(PerformanceEvents.AuthClientExecuteTokenRequest,request.correlationId),[4,this.executeTokenRequest(this.authority,request)];case 1:return response=_g.sent(),requestId=null===(_d=response.headers)||void 0===_d?void 0:_d[HeaderNames.X_MS_REQUEST_ID],(httpVerAuthority=null===(_e=response.headers)||void 0===_e?void 0:_e[HeaderNames.X_MS_HTTP_VERSION])&&(null==atsMeasurement||atsMeasurement.addStaticFields({httpVerAuthority:httpVerAuthority})),(responseHandler=new ResponseHandler(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin,this.performanceClient)).validateTokenResponse(response.body),null===(_f=this.performanceClient)||void 0===_f||_f.setPreQueueTime(PerformanceEvents.HandleServerTokenResponse,request.correlationId),[2,responseHandler.handleServerTokenResponse(response.body,this.authority,reqTimestamp,request,authCodePayload,void 0,void 0,void 0,requestId).then((function(result){return null==atsMeasurement||atsMeasurement.endMeasurement({success:!0}),result})).catch((function(error){throw _this.logger.verbose("Error in fetching token in ACC",request.correlationId),null==atsMeasurement||atsMeasurement.endMeasurement({errorCode:error.errorCode,subErrorCode:error.subError,success:!1}),error}))]}}))}))},AuthorizationCodeClient.prototype.handleFragmentResponse=function(hashFragment,cachedState){var responseHandler=new ResponseHandler(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,null,null),hashUrlString=new UrlString(hashFragment),serverParams=UrlString.getDeserializedHash(hashUrlString.getHash());if(responseHandler.validateServerAuthorizationCodeResponse(serverParams,cachedState,this.cryptoUtils),!serverParams.code)throw ClientAuthError.createNoAuthCodeInServerResponseError();return __assign(__assign({},serverParams),{code:serverParams.code})},AuthorizationCodeClient.prototype.getLogoutUri=function(logoutRequest){if(!logoutRequest)throw ClientConfigurationError.createEmptyLogoutRequestError();var queryString=this.createLogoutUrlQueryString(logoutRequest);return UrlString.appendQueryString(this.authority.endSessionEndpoint,queryString)},AuthorizationCodeClient.prototype.executeTokenRequest=function(authority,request){var _a,_b;return __awaiter(this,void 0,void 0,(function(){var queryParametersString,endpoint,requestBody,ccsCredential,clientInfo,headers,thumbprint;return __generator(this,(function(_c){switch(_c.label){case 0:return null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.AuthClientExecuteTokenRequest,request.correlationId),null===(_b=this.performanceClient)||void 0===_b||_b.setPreQueueTime(PerformanceEvents.AuthClientCreateTokenRequestBody,request.correlationId),queryParametersString=this.createTokenQueryParameters(request),endpoint=UrlString.appendQueryString(authority.tokenEndpoint,queryParametersString),[4,this.createTokenRequestBody(request)];case 1:if(requestBody=_c.sent(),ccsCredential=void 0,request.clientInfo)try{clientInfo=buildClientInfo(request.clientInfo,this.cryptoUtils),ccsCredential={credential:""+clientInfo.uid+Separators.CLIENT_INFO_SEPARATOR+clientInfo.utid,type:CcsCredentialType.HOME_ACCOUNT_ID}}catch(e){this.logger.verbose("Could not parse client info for CCS Header: "+e)}return headers=this.createTokenRequestHeaders(ccsCredential||request.ccsCredential),thumbprint={clientId:this.config.authOptions.clientId,authority:authority.canonicalAuthority,scopes:request.scopes,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},[2,this.executePostToTokenEndpoint(endpoint,requestBody,headers,thumbprint)]}}))}))},AuthorizationCodeClient.prototype.createTokenRequestBody=function(request){var _a,_b;return __awaiter(this,void 0,void 0,(function(){var parameterBuilder,clientAssertion,popTokenGenerator,reqCnfData,correlationId,ccsCred,clientInfo,_c;return __generator(this,(function(_d){switch(_d.label){case 0:return null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.AuthClientCreateTokenRequestBody,request.correlationId),(parameterBuilder=new RequestParameterBuilder).addClientId(this.config.authOptions.clientId),this.includeRedirectUri?parameterBuilder.addRedirectUri(request.redirectUri):RequestValidator.validateRedirectUri(request.redirectUri),parameterBuilder.addScopes(request.scopes),parameterBuilder.addAuthorizationCode(request.code),parameterBuilder.addLibraryInfo(this.config.libraryInfo),parameterBuilder.addApplicationTelemetry(this.config.telemetry.application),parameterBuilder.addThrottling(),this.serverTelemetryManager&&parameterBuilder.addServerTelemetry(this.serverTelemetryManager),request.codeVerifier&&parameterBuilder.addCodeVerifier(request.codeVerifier),this.config.clientCredentials.clientSecret&&parameterBuilder.addClientSecret(this.config.clientCredentials.clientSecret),this.config.clientCredentials.clientAssertion&&(clientAssertion=this.config.clientCredentials.clientAssertion,parameterBuilder.addClientAssertion(clientAssertion.assertion),parameterBuilder.addClientAssertionType(clientAssertion.assertionType)),parameterBuilder.addGrantType(GrantType.AUTHORIZATION_CODE_GRANT),parameterBuilder.addClientInfo(),request.authenticationScheme!==AuthenticationScheme.POP?[3,2]:(popTokenGenerator=new PopTokenGenerator(this.cryptoUtils,this.performanceClient),null===(_b=this.performanceClient)||void 0===_b||_b.setPreQueueTime(PerformanceEvents.PopTokenGenerateCnf,request.correlationId),[4,popTokenGenerator.generateCnf(request)]);case 1:return reqCnfData=_d.sent(),parameterBuilder.addPopToken(reqCnfData.reqCnfString),[3,3];case 2:if(request.authenticationScheme===AuthenticationScheme.SSH){if(!request.sshJwk)throw ClientConfigurationError.createMissingSshJwkError();parameterBuilder.addSshJwk(request.sshJwk)}_d.label=3;case 3:if(correlationId=request.correlationId||this.config.cryptoInterface.createNewGuid(),parameterBuilder.addCorrelationId(correlationId),(!StringUtils.isEmptyObj(request.claims)||this.config.authOptions.clientCapabilities&&this.config.authOptions.clientCapabilities.length>0)&&parameterBuilder.addClaims(request.claims,this.config.authOptions.clientCapabilities),ccsCred=void 0,request.clientInfo)try{clientInfo=buildClientInfo(request.clientInfo,this.cryptoUtils),ccsCred={credential:""+clientInfo.uid+Separators.CLIENT_INFO_SEPARATOR+clientInfo.utid,type:CcsCredentialType.HOME_ACCOUNT_ID}}catch(e){this.logger.verbose("Could not parse client info for CCS Header: "+e)}else ccsCred=request.ccsCredential;if(this.config.systemOptions.preventCorsPreflight&&ccsCred)switch(ccsCred.type){case CcsCredentialType.HOME_ACCOUNT_ID:try{clientInfo=buildClientInfoFromHomeAccountId(ccsCred.credential),parameterBuilder.addCcsOid(clientInfo)}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case CcsCredentialType.UPN:parameterBuilder.addCcsUpn(ccsCred.credential)}return request.tokenBodyParameters&&parameterBuilder.addExtraQueryParameters(request.tokenBodyParameters),!request.enableSpaAuthorizationCode||request.tokenBodyParameters&&request.tokenBodyParameters[AADServerParamKeys.RETURN_SPA_CODE]||parameterBuilder.addExtraQueryParameters(((_c={})[AADServerParamKeys.RETURN_SPA_CODE]="1",_c)),[2,parameterBuilder.createQueryString()]}}))}))},AuthorizationCodeClient.prototype.createAuthCodeUrlQueryString=function(request){var _a;return __awaiter(this,void 0,void 0,(function(){var parameterBuilder,requestScopes,correlationId,accountSid,accountLoginHintClaim,clientInfo,reqCnfData;return __generator(this,(function(_b){switch(_b.label){case 0:if(null===(_a=this.performanceClient)||void 0===_a||_a.addQueueMeasurement(PerformanceEvents.AuthClientCreateQueryString,request.correlationId),(parameterBuilder=new RequestParameterBuilder).addClientId(this.config.authOptions.clientId),requestScopes=__spreadArrays(request.scopes||[],request.extraScopesToConsent||[]),parameterBuilder.addScopes(requestScopes),parameterBuilder.addRedirectUri(request.redirectUri),correlationId=request.correlationId||this.config.cryptoInterface.createNewGuid(),parameterBuilder.addCorrelationId(correlationId),parameterBuilder.addResponseMode(request.responseMode),parameterBuilder.addResponseTypeCode(),parameterBuilder.addLibraryInfo(this.config.libraryInfo),parameterBuilder.addApplicationTelemetry(this.config.telemetry.application),parameterBuilder.addClientInfo(),request.codeChallenge&&request.codeChallengeMethod&&parameterBuilder.addCodeChallengeParams(request.codeChallenge,request.codeChallengeMethod),request.prompt&&parameterBuilder.addPrompt(request.prompt),request.domainHint&&parameterBuilder.addDomainHint(request.domainHint),request.prompt!==PromptValue.SELECT_ACCOUNT)if(request.sid&&request.prompt===PromptValue.NONE)this.logger.verbose("createAuthCodeUrlQueryString: Prompt is none, adding sid from request"),parameterBuilder.addSid(request.sid);else if(request.account){if(accountSid=this.extractAccountSid(request.account),accountLoginHintClaim=this.extractLoginHint(request.account)){this.logger.verbose("createAuthCodeUrlQueryString: login_hint claim present on account"),parameterBuilder.addLoginHint(accountLoginHintClaim);try{clientInfo=buildClientInfoFromHomeAccountId(request.account.homeAccountId),parameterBuilder.addCcsOid(clientInfo)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}else if(accountSid&&request.prompt===PromptValue.NONE){this.logger.verbose("createAuthCodeUrlQueryString: Prompt is none, adding sid from account"),parameterBuilder.addSid(accountSid);try{clientInfo=buildClientInfoFromHomeAccountId(request.account.homeAccountId),parameterBuilder.addCcsOid(clientInfo)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}else if(request.loginHint)this.logger.verbose("createAuthCodeUrlQueryString: Adding login_hint from request"),parameterBuilder.addLoginHint(request.loginHint),parameterBuilder.addCcsUpn(request.loginHint);else if(request.account.username){this.logger.verbose("createAuthCodeUrlQueryString: Adding login_hint from account"),parameterBuilder.addLoginHint(request.account.username);try{clientInfo=buildClientInfoFromHomeAccountId(request.account.homeAccountId),parameterBuilder.addCcsOid(clientInfo)}catch(e){this.logger.verbose("createAuthCodeUrlQueryString: Could not parse home account ID for CCS Header")}}}else request.loginHint&&(this.logger.verbose("createAuthCodeUrlQueryString: No account, adding login_hint from request"),parameterBuilder.addLoginHint(request.loginHint),parameterBuilder.addCcsUpn(request.loginHint));else this.logger.verbose("createAuthCodeUrlQueryString: Prompt is select_account, ignoring account hints");return request.nonce&&parameterBuilder.addNonce(request.nonce),request.state&&parameterBuilder.addState(request.state),(!StringUtils.isEmpty(request.claims)||this.config.authOptions.clientCapabilities&&this.config.authOptions.clientCapabilities.length>0)&&parameterBuilder.addClaims(request.claims,this.config.authOptions.clientCapabilities),request.extraQueryParameters&&parameterBuilder.addExtraQueryParameters(request.extraQueryParameters),request.nativeBroker?(parameterBuilder.addNativeBroker(),request.authenticationScheme!==AuthenticationScheme.POP?[3,2]:[4,new PopTokenGenerator(this.cryptoUtils).generateCnf(request)]):[3,2];case 1:reqCnfData=_b.sent(),parameterBuilder.addPopToken(reqCnfData.reqCnfString),_b.label=2;case 2:return[2,parameterBuilder.createQueryString()]}}))}))},AuthorizationCodeClient.prototype.createLogoutUrlQueryString=function(request){var parameterBuilder=new RequestParameterBuilder;return request.postLogoutRedirectUri&&parameterBuilder.addPostLogoutRedirectUri(request.postLogoutRedirectUri),request.correlationId&&parameterBuilder.addCorrelationId(request.correlationId),request.idTokenHint&&parameterBuilder.addIdTokenHint(request.idTokenHint),request.state&&parameterBuilder.addState(request.state),request.logoutHint&&parameterBuilder.addLogoutHint(request.logoutHint),request.extraQueryParameters&&parameterBuilder.addExtraQueryParameters(request.extraQueryParameters),parameterBuilder.createQueryString()},AuthorizationCodeClient.prototype.extractAccountSid=function(account){var _a;return(null===(_a=account.idTokenClaims)||void 0===_a?void 0:_a.sid)||null},AuthorizationCodeClient.prototype.extractLoginHint=function(account){var _a;return(null===(_a=account.idTokenClaims)||void 0===_a?void 0:_a.login_hint)||null},AuthorizationCodeClient}(BaseClient);export{AuthorizationCodeClient};