/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator}from"../_virtual/_tslib.js";import{BaseClient}from"./BaseClient.js";import{AuthToken}from"../account/AuthToken.js";import{TimeUtils}from"../utils/TimeUtils.js";import{RefreshTokenClient}from"./RefreshTokenClient.js";import{ClientAuthError,ClientAuthErrorMessage}from"../error/ClientAuthError.js";import{ClientConfigurationError}from"../error/ClientConfigurationError.js";import{ResponseHandler}from"../response/ResponseHandler.js";import{CacheOutcome}from"../utils/Constants.js";var SilentFlowClient=function(_super){function SilentFlowClient(configuration,performanceClient){return _super.call(this,configuration,performanceClient)||this}return __extends(SilentFlowClient,_super),SilentFlowClient.prototype.acquireToken=function(request){return __awaiter(this,void 0,void 0,(function(){var e_1;return __generator(this,(function(_a){switch(_a.label){case 0:return _a.trys.push([0,2,,3]),[4,this.acquireCachedToken(request)];case 1:return[2,_a.sent()];case 2:if((e_1=_a.sent())instanceof ClientAuthError&&e_1.errorCode===ClientAuthErrorMessage.tokenRefreshRequired.code)return[2,new RefreshTokenClient(this.config,this.performanceClient).acquireTokenByRefreshToken(request)];throw e_1;case 3:return[2]}}))}))},SilentFlowClient.prototype.acquireCachedToken=function(request){var _a,_b,_c,_d;return __awaiter(this,void 0,void 0,(function(){var environment,cacheRecord;return __generator(this,(function(_e){switch(_e.label){case 0:if(!request)throw ClientConfigurationError.createEmptyTokenRequestError();if(request.forceRefresh)throw null===(_a=this.serverTelemetryManager)||void 0===_a||_a.setCacheOutcome(CacheOutcome.FORCE_REFRESH),this.logger.info("SilentFlowClient:acquireCachedToken - Skipping cache because forceRefresh is true."),ClientAuthError.createRefreshRequiredError();if(!request.account)throw ClientAuthError.createNoAccountInSilentRequestError();if(environment=request.authority||this.authority.getPreferredCache(),!(cacheRecord=this.cacheManager.readCacheRecord(request.account,request,environment)).accessToken)throw null===(_b=this.serverTelemetryManager)||void 0===_b||_b.setCacheOutcome(CacheOutcome.NO_CACHED_ACCESS_TOKEN),this.logger.info("SilentFlowClient:acquireCachedToken - No access token found in cache for the given properties."),ClientAuthError.createRefreshRequiredError();if(TimeUtils.wasClockTurnedBack(cacheRecord.accessToken.cachedAt)||TimeUtils.isTokenExpired(cacheRecord.accessToken.expiresOn,this.config.systemOptions.tokenRenewalOffsetSeconds))throw null===(_c=this.serverTelemetryManager)||void 0===_c||_c.setCacheOutcome(CacheOutcome.CACHED_ACCESS_TOKEN_EXPIRED),this.logger.info("SilentFlowClient:acquireCachedToken - Cached access token is expired or will expire within "+this.config.systemOptions.tokenRenewalOffsetSeconds+" seconds."),ClientAuthError.createRefreshRequiredError();if(cacheRecord.accessToken.refreshOn&&TimeUtils.isTokenExpired(cacheRecord.accessToken.refreshOn,0))throw null===(_d=this.serverTelemetryManager)||void 0===_d||_d.setCacheOutcome(CacheOutcome.REFRESH_CACHED_ACCESS_TOKEN),this.logger.info("SilentFlowClient:acquireCachedToken - Cached access token's refreshOn property has been exceeded'."),ClientAuthError.createRefreshRequiredError();return this.config.serverTelemetryManager&&this.config.serverTelemetryManager.incrementCacheHits(),[4,this.generateResultFromCacheRecord(cacheRecord,request)];case 1:return[2,_e.sent()]}}))}))},SilentFlowClient.prototype.generateResultFromCacheRecord=function(cacheRecord,request){return __awaiter(this,void 0,void 0,(function(){var idTokenObj,authTime;return __generator(this,(function(_a){switch(_a.label){case 0:if(cacheRecord.idToken&&(idTokenObj=new AuthToken(cacheRecord.idToken.secret,this.config.cryptoInterface)),request.maxAge||0===request.maxAge){if(!(authTime=null==idTokenObj?void 0:idTokenObj.claims.auth_time))throw ClientAuthError.createAuthTimeNotFoundError();AuthToken.checkMaxAge(authTime,request.maxAge)}return[4,ResponseHandler.generateAuthenticationResult(this.cryptoUtils,this.authority,cacheRecord,!0,request,idTokenObj)];case 1:return[2,_a.sent()]}}))}))},SilentFlowClient}(BaseClient);export{SilentFlowClient};