/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{Separators,CacheAccountType,CacheType,Constants}from"../../utils/Constants.js";import{buildClientInfo}from"../../account/ClientInfo.js";import{StringUtils}from"../../utils/StringUtils.js";import{ClientAuthError}from"../../error/ClientAuthError.js";import{AuthorityType}from"../../authority/AuthorityType.js";var AccountEntity=function(){function AccountEntity(){}return AccountEntity.prototype.generateAccountId=function(){return[this.homeAccountId,this.environment].join(Separators.CACHE_KEY_SEPARATOR).toLowerCase()},AccountEntity.prototype.generateAccountKey=function(){return AccountEntity.generateAccountCacheKey({homeAccountId:this.homeAccountId,environment:this.environment,tenantId:this.realm,username:this.username,localAccountId:this.localAccountId})},AccountEntity.prototype.generateType=function(){switch(this.authorityType){case CacheAccountType.ADFS_ACCOUNT_TYPE:return CacheType.ADFS;case CacheAccountType.MSAV1_ACCOUNT_TYPE:return CacheType.MSA;case CacheAccountType.MSSTS_ACCOUNT_TYPE:return CacheType.MSSTS;case CacheAccountType.GENERIC_ACCOUNT_TYPE:return CacheType.GENERIC;default:throw ClientAuthError.createUnexpectedAccountTypeError()}},AccountEntity.prototype.getAccountInfo=function(){return{homeAccountId:this.homeAccountId,environment:this.environment,tenantId:this.realm,username:this.username,localAccountId:this.localAccountId,name:this.name,idTokenClaims:this.idTokenClaims,nativeAccountId:this.nativeAccountId}},AccountEntity.generateAccountCacheKey=function(accountInterface){return[accountInterface.homeAccountId,accountInterface.environment||Constants.EMPTY_STRING,accountInterface.tenantId||Constants.EMPTY_STRING].join(Separators.CACHE_KEY_SEPARATOR).toLowerCase()},AccountEntity.createAccount=function(clientInfo,homeAccountId,idToken,authority,cloudGraphHostName,msGraphHost,environment,nativeAccountId){var _a,_b,_c,_d,_e,_f,account=new AccountEntity;account.authorityType=CacheAccountType.MSSTS_ACCOUNT_TYPE,account.clientInfo=clientInfo,account.homeAccountId=homeAccountId,account.nativeAccountId=nativeAccountId;var env=environment||authority&&authority.getPreferredCache();if(!env)throw ClientAuthError.createInvalidCacheEnvironmentError();if(account.environment=env,account.realm=(null===(_a=null==idToken?void 0:idToken.claims)||void 0===_a?void 0:_a.tid)||Constants.EMPTY_STRING,idToken){account.idTokenClaims=idToken.claims,account.localAccountId=(null===(_b=null==idToken?void 0:idToken.claims)||void 0===_b?void 0:_b.oid)||(null===(_c=null==idToken?void 0:idToken.claims)||void 0===_c?void 0:_c.sub)||Constants.EMPTY_STRING;var preferredUsername=null===(_d=null==idToken?void 0:idToken.claims)||void 0===_d?void 0:_d.preferred_username,email=(null===(_e=null==idToken?void 0:idToken.claims)||void 0===_e?void 0:_e.emails)?idToken.claims.emails[0]:null;account.username=preferredUsername||email||Constants.EMPTY_STRING,account.name=null===(_f=null==idToken?void 0:idToken.claims)||void 0===_f?void 0:_f.name}return account.cloudGraphHostName=cloudGraphHostName,account.msGraphHost=msGraphHost,account},AccountEntity.createGenericAccount=function(homeAccountId,idToken,authority,cloudGraphHostName,msGraphHost,environment){var _a,_b,_c,_d,account=new AccountEntity;account.authorityType=authority&&authority.authorityType===AuthorityType.Adfs?CacheAccountType.ADFS_ACCOUNT_TYPE:CacheAccountType.GENERIC_ACCOUNT_TYPE,account.homeAccountId=homeAccountId,account.realm=Constants.EMPTY_STRING;var env=environment||authority&&authority.getPreferredCache();if(!env)throw ClientAuthError.createInvalidCacheEnvironmentError();return idToken&&(account.localAccountId=(null===(_a=null==idToken?void 0:idToken.claims)||void 0===_a?void 0:_a.oid)||(null===(_b=null==idToken?void 0:idToken.claims)||void 0===_b?void 0:_b.sub)||Constants.EMPTY_STRING,account.username=(null===(_c=null==idToken?void 0:idToken.claims)||void 0===_c?void 0:_c.upn)||Constants.EMPTY_STRING,account.name=(null===(_d=null==idToken?void 0:idToken.claims)||void 0===_d?void 0:_d.name)||Constants.EMPTY_STRING,account.idTokenClaims=null==idToken?void 0:idToken.claims),account.environment=env,account.cloudGraphHostName=cloudGraphHostName,account.msGraphHost=msGraphHost,account},AccountEntity.generateHomeAccountId=function(serverClientInfo,authType,logger,cryptoObj,idToken){var _a,accountId=(null===(_a=null==idToken?void 0:idToken.claims)||void 0===_a?void 0:_a.sub)?idToken.claims.sub:Constants.EMPTY_STRING;if(authType===AuthorityType.Adfs||authType===AuthorityType.Dsts)return accountId;if(serverClientInfo)try{var clientInfo=buildClientInfo(serverClientInfo,cryptoObj);if(!StringUtils.isEmpty(clientInfo.uid)&&!StringUtils.isEmpty(clientInfo.utid))return""+clientInfo.uid+Separators.CLIENT_INFO_SEPARATOR+clientInfo.utid}catch(e){}return logger.verbose("No client info in response"),accountId},AccountEntity.isAccountEntity=function(entity){return!!entity&&(entity.hasOwnProperty("homeAccountId")&&entity.hasOwnProperty("environment")&&entity.hasOwnProperty("realm")&&entity.hasOwnProperty("localAccountId")&&entity.hasOwnProperty("username")&&entity.hasOwnProperty("authorityType"))},AccountEntity.accountInfoIsEqual=function(accountA,accountB,compareClaims){if(!accountA||!accountB)return!1;var claimsMatch=!0;if(compareClaims){var accountAClaims=accountA.idTokenClaims||{},accountBClaims=accountB.idTokenClaims||{};claimsMatch=accountAClaims.iat===accountBClaims.iat&&accountAClaims.nonce===accountBClaims.nonce}return accountA.homeAccountId===accountB.homeAccountId&&accountA.localAccountId===accountB.localAccountId&&accountA.username===accountB.username&&accountA.tenantId===accountB.tenantId&&accountA.environment===accountB.environment&&accountA.nativeAccountId===accountB.nativeAccountId&&claimsMatch},AccountEntity}();export{AccountEntity};