/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{__awaiter,__generator}from"../_virtual/_tslib.js";import{buildClientConfiguration}from"../config/ClientConfiguration.js";import{NetworkManager}from"../network/NetworkManager.js";import{Logger}from"../logger/Logger.js";import{HeaderNames,Constants}from"../utils/Constants.js";import{name,version}from"../packageMetadata.js";import{ClientAuthError}from"../error/ClientAuthError.js";import{CcsCredentialType}from"../account/CcsCredential.js";import{buildClientInfoFromHomeAccountId}from"../account/ClientInfo.js";var BaseClient=function(){function BaseClient(configuration,performanceClient){this.config=buildClientConfiguration(configuration),this.logger=new Logger(this.config.loggerOptions,name,version),this.cryptoUtils=this.config.cryptoInterface,this.cacheManager=this.config.storageInterface,this.networkClient=this.config.networkInterface,this.networkManager=new NetworkManager(this.networkClient,this.cacheManager),this.serverTelemetryManager=this.config.serverTelemetryManager,this.authority=this.config.authOptions.authority,this.performanceClient=performanceClient}return BaseClient.prototype.createTokenRequestHeaders=function(ccsCred){var headers={};if(headers[HeaderNames.CONTENT_TYPE]=Constants.URL_FORM_CONTENT_TYPE,!this.config.systemOptions.preventCorsPreflight&&ccsCred)switch(ccsCred.type){case CcsCredentialType.HOME_ACCOUNT_ID:try{var clientInfo=buildClientInfoFromHomeAccountId(ccsCred.credential);headers[HeaderNames.CCS_HEADER]="Oid:"+clientInfo.uid+"@"+clientInfo.utid}catch(e){this.logger.verbose("Could not parse home account ID for CCS Header: "+e)}break;case CcsCredentialType.UPN:headers[HeaderNames.CCS_HEADER]="UPN: "+ccsCred.credential}return headers},BaseClient.prototype.executePostToTokenEndpoint=function(tokenEndpoint,queryString,headers,thumbprint){return __awaiter(this,void 0,void 0,(function(){var response;return __generator(this,(function(_a){switch(_a.label){case 0:return[4,this.networkManager.sendPostRequest(thumbprint,tokenEndpoint,{body:queryString,headers:headers,proxyUrl:this.config.systemOptions.proxyUrl})];case 1:return response=_a.sent(),this.config.serverTelemetryManager&&response.status<500&&429!==response.status&&this.config.serverTelemetryManager.clearTelemetryCache(),[2,response]}}))}))},BaseClient.prototype.updateAuthority=function(updatedAuthority){if(!updatedAuthority.discoveryComplete())throw ClientAuthError.createEndpointDiscoveryIncompleteError("Updated authority has not completed endpoint discovery.");this.authority=updatedAuthority},BaseClient}();export{BaseClient};