/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{__extends,__awaiter,__generator}from"../_virtual/_tslib.js";import{BaseClient}from"./BaseClient.js";import{RequestParameterBuilder}from"../request/RequestParameterBuilder.js";import{ScopeSet}from"../request/ScopeSet.js";import{AuthenticationScheme,CredentialType,GrantType,AADServerParamKeys,CacheOutcome,Constants}from"../utils/Constants.js";import{ResponseHandler}from"../response/ResponseHandler.js";import{TimeUtils}from"../utils/TimeUtils.js";import{AuthToken}from"../account/AuthToken.js";import{ClientAuthError}from"../error/ClientAuthError.js";var OnBehalfOfClient=function(_super){function OnBehalfOfClient(configuration){return _super.call(this,configuration)||this}return __extends(OnBehalfOfClient,_super),OnBehalfOfClient.prototype.acquireToken=function(request){return __awaiter(this,void 0,void 0,(function(){var _a;return __generator(this,(function(_b){switch(_b.label){case 0:return this.scopeSet=new ScopeSet(request.scopes||[]),_a=this,[4,this.cryptoUtils.hashString(request.oboAssertion)];case 1:return _a.userAssertionHash=_b.sent(),request.skipCache?[4,this.executeTokenRequest(request,this.authority,this.userAssertionHash)]:[3,3];case 2:case 4:case 6:return[2,_b.sent()];case 3:return _b.trys.push([3,5,,7]),[4,this.getCachedAuthenticationResult(request)];case 5:return _b.sent(),[4,this.executeTokenRequest(request,this.authority,this.userAssertionHash)];case 7:return[2]}}))}))},OnBehalfOfClient.prototype.getCachedAuthenticationResult=function(request){var _a,_b;return __awaiter(this,void 0,void 0,(function(){var cachedAccessToken,cachedIdToken,idTokenObject,cachedAccount,localAccountId,accountInfo;return __generator(this,(function(_c){switch(_c.label){case 0:if(!(cachedAccessToken=this.readAccessTokenFromCacheForOBO(this.config.authOptions.clientId,request)))throw null===(_a=this.serverTelemetryManager)||void 0===_a||_a.setCacheOutcome(CacheOutcome.NO_CACHED_ACCESS_TOKEN),this.logger.info("SilentFlowClient:acquireCachedToken - No access token found in cache for the given properties."),ClientAuthError.createRefreshRequiredError();if(TimeUtils.isTokenExpired(cachedAccessToken.expiresOn,this.config.systemOptions.tokenRenewalOffsetSeconds))throw null===(_b=this.serverTelemetryManager)||void 0===_b||_b.setCacheOutcome(CacheOutcome.CACHED_ACCESS_TOKEN_EXPIRED),this.logger.info("OnbehalfofFlow:getCachedAuthenticationResult - Cached access token is expired or will expire within "+this.config.systemOptions.tokenRenewalOffsetSeconds+" seconds."),ClientAuthError.createRefreshRequiredError();return cachedIdToken=this.readIdTokenFromCacheForOBO(request,cachedAccessToken.homeAccountId),cachedAccount=null,cachedIdToken&&(idTokenObject=new AuthToken(cachedIdToken.secret,this.config.cryptoInterface),localAccountId=idTokenObject.claims.oid?idTokenObject.claims.oid:idTokenObject.claims.sub,accountInfo={homeAccountId:cachedIdToken.homeAccountId,environment:cachedIdToken.environment,tenantId:cachedIdToken.realm,username:Constants.EMPTY_STRING,localAccountId:localAccountId||Constants.EMPTY_STRING},cachedAccount=this.cacheManager.readAccountFromCache(accountInfo)),this.config.serverTelemetryManager&&this.config.serverTelemetryManager.incrementCacheHits(),[4,ResponseHandler.generateAuthenticationResult(this.cryptoUtils,this.authority,{account:cachedAccount,accessToken:cachedAccessToken,idToken:cachedIdToken,refreshToken:null,appMetadata:null},!0,request,idTokenObject)];case 1:return[2,_c.sent()]}}))}))},OnBehalfOfClient.prototype.readIdTokenFromCacheForOBO=function(request,atHomeAccountId){var idTokenFilter={homeAccountId:atHomeAccountId,environment:this.authority.canonicalAuthorityUrlComponents.HostNameAndPort,credentialType:CredentialType.ID_TOKEN,clientId:this.config.authOptions.clientId,realm:this.authority.tenant},credentialCache=this.cacheManager.getCredentialsFilteredBy(idTokenFilter),idTokens=Object.keys(credentialCache.idTokens).map((function(key){return credentialCache.idTokens[key]}));return idTokens.length<1?null:idTokens[0]},OnBehalfOfClient.prototype.readAccessTokenFromCacheForOBO=function(clientId,request){var authScheme=request.authenticationScheme||AuthenticationScheme.BEARER,accessTokenFilter={credentialType:authScheme&&authScheme.toLowerCase()!==AuthenticationScheme.BEARER.toLowerCase()?CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME:CredentialType.ACCESS_TOKEN,clientId:clientId,target:this.scopeSet.printScopesLowerCase(),tokenType:authScheme,keyId:request.sshKid,requestedClaimsHash:request.requestedClaimsHash,userAssertionHash:this.userAssertionHash},credentialCache=this.cacheManager.getCredentialsFilteredBy(accessTokenFilter),accessTokens=Object.keys(credentialCache.accessTokens).map((function(key){return credentialCache.accessTokens[key]})),numAccessTokens=accessTokens.length;if(numAccessTokens<1)return null;if(numAccessTokens>1)throw ClientAuthError.createMultipleMatchingTokensInCacheError();return accessTokens[0]},OnBehalfOfClient.prototype.executeTokenRequest=function(request,authority,userAssertionHash){return __awaiter(this,void 0,void 0,(function(){var requestBody,headers,thumbprint,reqTimestamp,response,responseHandler;return __generator(this,(function(_a){switch(_a.label){case 0:return requestBody=this.createTokenRequestBody(request),headers=this.createTokenRequestHeaders(),thumbprint={clientId:this.config.authOptions.clientId,authority:request.authority,scopes:request.scopes,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},reqTimestamp=TimeUtils.nowSeconds(),[4,this.executePostToTokenEndpoint(authority.tokenEndpoint,requestBody,headers,thumbprint)];case 1:return response=_a.sent(),(responseHandler=new ResponseHandler(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin)).validateTokenResponse(response.body),[4,responseHandler.handleServerTokenResponse(response.body,this.authority,reqTimestamp,request,void 0,userAssertionHash)];case 2:return[2,_a.sent()]}}))}))},OnBehalfOfClient.prototype.createTokenRequestBody=function(request){var parameterBuilder=new RequestParameterBuilder;parameterBuilder.addClientId(this.config.authOptions.clientId),parameterBuilder.addScopes(request.scopes),parameterBuilder.addGrantType(GrantType.JWT_BEARER),parameterBuilder.addClientInfo(),parameterBuilder.addLibraryInfo(this.config.libraryInfo),parameterBuilder.addApplicationTelemetry(this.config.telemetry.application),parameterBuilder.addThrottling(),this.serverTelemetryManager&&parameterBuilder.addServerTelemetry(this.serverTelemetryManager);var correlationId=request.correlationId||this.config.cryptoInterface.createNewGuid();if(parameterBuilder.addCorrelationId(correlationId),parameterBuilder.addRequestTokenUse(AADServerParamKeys.ON_BEHALF_OF),parameterBuilder.addOboAssertion(request.oboAssertion),this.config.clientCredentials.clientSecret&&parameterBuilder.addClientSecret(this.config.clientCredentials.clientSecret),this.config.clientCredentials.clientAssertion){var clientAssertion=this.config.clientCredentials.clientAssertion;parameterBuilder.addClientAssertion(clientAssertion.assertion),parameterBuilder.addClientAssertionType(clientAssertion.assertionType)}return parameterBuilder.createQueryString()},OnBehalfOfClient}(BaseClient);export{OnBehalfOfClient};