/*! @azure/msal-common v7.6.0 2022-10-10 */
"use strict";import{__extends}from"../_virtual/_tslib.js";import{ClientAuthError}from"./ClientAuthError.js";var ClientConfigurationErrorMessage={redirectUriNotSet:{code:"redirect_uri_empty",desc:"A redirect URI is required for all calls, and none has been set."},postLogoutUriNotSet:{code:"post_logout_uri_empty",desc:"A post logout redirect has not been set."},claimsRequestParsingError:{code:"claims_request_parsing_error",desc:"Could not parse the given claims request object."},authorityUriInsecure:{code:"authority_uri_insecure",desc:"Authority URIs must use https.  Please see here for valid authority configuration options: https://docs.microsoft.com/en-us/azure/active-directory/develop/msal-js-initializing-client-applications#configuration-options"},urlParseError:{code:"url_parse_error",desc:"URL could not be parsed into appropriate segments."},urlEmptyError:{code:"empty_url_error",desc:"URL was empty or null."},emptyScopesError:{code:"empty_input_scopes_error",desc:"Scopes cannot be passed as null, undefined or empty array because they are required to obtain an access token."},nonArrayScopesError:{code:"nonarray_input_scopes_error",desc:"Scopes cannot be passed as non-array."},clientIdSingleScopeError:{code:"clientid_input_scopes_error",desc:"Client ID can only be provided as a single scope."},invalidPrompt:{code:"invalid_prompt_value",desc:"Supported prompt values are 'login', 'select_account', 'consent', 'create', 'none' and 'no_session'.  Please see here for valid configuration options: https://azuread.github.io/microsoft-authentication-library-for-js/ref/modules/_azure_msal_common.html#commonauthorizationurlrequest"},invalidClaimsRequest:{code:"invalid_claims",desc:"Given claims parameter must be a stringified JSON object."},tokenRequestEmptyError:{code:"token_request_empty",desc:"Token request was empty and not found in cache."},logoutRequestEmptyError:{code:"logout_request_empty",desc:"The logout request was null or undefined."},invalidCodeChallengeMethod:{code:"invalid_code_challenge_method",desc:'code_challenge_method passed is invalid. Valid values are "plain" and "S256".'},invalidCodeChallengeParams:{code:"pkce_params_missing",desc:"Both params: code_challenge and code_challenge_method are to be passed if to be sent in the request"},invalidCloudDiscoveryMetadata:{code:"invalid_cloud_discovery_metadata",desc:"Invalid cloudDiscoveryMetadata provided. Must be a stringified JSON object containing tenant_discovery_endpoint and metadata fields"},invalidAuthorityMetadata:{code:"invalid_authority_metadata",desc:"Invalid authorityMetadata provided. Must by a stringified JSON object containing authorization_endpoint, token_endpoint, issuer fields."},untrustedAuthority:{code:"untrusted_authority",desc:"The provided authority is not a trusted authority. Please include this authority in the knownAuthorities config parameter."},invalidAzureCloudInstance:{code:"invalid_azure_cloud_instance",desc:"Invalid AzureCloudInstance provided. Please refer MSAL JS docs: aks.ms/msaljs/azure_cloud_instance for valid values"},missingSshJwk:{code:"missing_ssh_jwk",desc:"Missing sshJwk in SSH certificate request. A stringified JSON Web Key is required when using the SSH authentication scheme."},missingSshKid:{code:"missing_ssh_kid",desc:"Missing sshKid in SSH certificate request. A string that uniquely identifies the public SSH key is required when using the SSH authentication scheme."},missingNonceAuthenticationHeader:{code:"missing_nonce_authentication_header",desc:"Unable to find an authentication header containing server nonce. Either the Authentication-Info or WWW-Authenticate headers must be present in order to obtain a server nonce."},invalidAuthenticationHeader:{code:"invalid_authentication_header",desc:"Invalid authentication header provided"}},ClientConfigurationError=function(_super){function ClientConfigurationError(errorCode,errorMessage){var _this=_super.call(this,errorCode,errorMessage)||this;return _this.name="ClientConfigurationError",Object.setPrototypeOf(_this,ClientConfigurationError.prototype),_this}return __extends(ClientConfigurationError,_super),ClientConfigurationError.createRedirectUriEmptyError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.redirectUriNotSet.code,ClientConfigurationErrorMessage.redirectUriNotSet.desc)},ClientConfigurationError.createPostLogoutRedirectUriEmptyError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.postLogoutUriNotSet.code,ClientConfigurationErrorMessage.postLogoutUriNotSet.desc)},ClientConfigurationError.createClaimsRequestParsingError=function(claimsRequestParseError){return new ClientConfigurationError(ClientConfigurationErrorMessage.claimsRequestParsingError.code,ClientConfigurationErrorMessage.claimsRequestParsingError.desc+" Given value: "+claimsRequestParseError)},ClientConfigurationError.createInsecureAuthorityUriError=function(urlString){return new ClientConfigurationError(ClientConfigurationErrorMessage.authorityUriInsecure.code,ClientConfigurationErrorMessage.authorityUriInsecure.desc+" Given URI: "+urlString)},ClientConfigurationError.createUrlParseError=function(urlParseError){return new ClientConfigurationError(ClientConfigurationErrorMessage.urlParseError.code,ClientConfigurationErrorMessage.urlParseError.desc+" Given Error: "+urlParseError)},ClientConfigurationError.createUrlEmptyError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.urlEmptyError.code,ClientConfigurationErrorMessage.urlEmptyError.desc)},ClientConfigurationError.createEmptyScopesArrayError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.emptyScopesError.code,""+ClientConfigurationErrorMessage.emptyScopesError.desc)},ClientConfigurationError.createClientIdSingleScopeError=function(inputScopes){return new ClientConfigurationError(ClientConfigurationErrorMessage.clientIdSingleScopeError.code,ClientConfigurationErrorMessage.clientIdSingleScopeError.desc+" Given Scopes: "+inputScopes)},ClientConfigurationError.createInvalidPromptError=function(promptValue){return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidPrompt.code,ClientConfigurationErrorMessage.invalidPrompt.desc+" Given value: "+promptValue)},ClientConfigurationError.createInvalidClaimsRequestError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidClaimsRequest.code,ClientConfigurationErrorMessage.invalidClaimsRequest.desc)},ClientConfigurationError.createEmptyLogoutRequestError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.logoutRequestEmptyError.code,ClientConfigurationErrorMessage.logoutRequestEmptyError.desc)},ClientConfigurationError.createEmptyTokenRequestError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.tokenRequestEmptyError.code,ClientConfigurationErrorMessage.tokenRequestEmptyError.desc)},ClientConfigurationError.createInvalidCodeChallengeMethodError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidCodeChallengeMethod.code,ClientConfigurationErrorMessage.invalidCodeChallengeMethod.desc)},ClientConfigurationError.createInvalidCodeChallengeParamsError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidCodeChallengeParams.code,ClientConfigurationErrorMessage.invalidCodeChallengeParams.desc)},ClientConfigurationError.createInvalidCloudDiscoveryMetadataError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidCloudDiscoveryMetadata.code,ClientConfigurationErrorMessage.invalidCloudDiscoveryMetadata.desc)},ClientConfigurationError.createInvalidAuthorityMetadataError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidAuthorityMetadata.code,ClientConfigurationErrorMessage.invalidAuthorityMetadata.desc)},ClientConfigurationError.createUntrustedAuthorityError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.untrustedAuthority.code,ClientConfigurationErrorMessage.untrustedAuthority.desc)},ClientConfigurationError.createInvalidAzureCloudInstanceError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidAzureCloudInstance.code,ClientConfigurationErrorMessage.invalidAzureCloudInstance.desc)},ClientConfigurationError.createMissingSshJwkError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.missingSshJwk.code,ClientConfigurationErrorMessage.missingSshJwk.desc)},ClientConfigurationError.createMissingSshKidError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.missingSshKid.code,ClientConfigurationErrorMessage.missingSshKid.desc)},ClientConfigurationError.createMissingNonceAuthenticationHeadersError=function(){return new ClientConfigurationError(ClientConfigurationErrorMessage.missingNonceAuthenticationHeader.code,ClientConfigurationErrorMessage.missingNonceAuthenticationHeader.desc)},ClientConfigurationError.createInvalidAuthenticationHeaderError=function(invalidHeaderName,details){return new ClientConfigurationError(ClientConfigurationErrorMessage.invalidAuthenticationHeader.code,ClientConfigurationErrorMessage.invalidAuthenticationHeader.desc+". Invalid header: "+invalidHeaderName+". Details: "+details)},ClientConfigurationError}(ClientAuthError);export{ClientConfigurationError,ClientConfigurationErrorMessage};