/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{__extends}from"../../_virtual/_tslib.js";import{CredentialEntity}from"./CredentialEntity.js";import{CredentialType,AuthenticationScheme}from"../../utils/Constants.js";import{TimeUtils}from"../../utils/TimeUtils.js";import{StringUtils}from"../../utils/StringUtils.js";import{AuthToken}from"../../account/AuthToken.js";import{ClientAuthError}from"../../error/ClientAuthError.js";var AccessTokenEntity=function(_super){function AccessTokenEntity(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(AccessTokenEntity,_super),AccessTokenEntity.createAccessTokenEntity=function(homeAccountId,environment,accessToken,clientId,tenantId,scopes,expiresOn,extExpiresOn,cryptoUtils,refreshOn,tokenType,userAssertionHash,keyId,requestedClaims,requestedClaimsHash){var _a,_b,atEntity=new AccessTokenEntity;atEntity.homeAccountId=homeAccountId,atEntity.credentialType=CredentialType.ACCESS_TOKEN,atEntity.secret=accessToken;var currentTime=TimeUtils.nowSeconds();if(atEntity.cachedAt=currentTime.toString(),atEntity.expiresOn=expiresOn.toString(),atEntity.extendedExpiresOn=extExpiresOn.toString(),refreshOn&&(atEntity.refreshOn=refreshOn.toString()),atEntity.environment=environment,atEntity.clientId=clientId,atEntity.realm=tenantId,atEntity.target=scopes,atEntity.userAssertionHash=userAssertionHash,atEntity.tokenType=StringUtils.isEmpty(tokenType)?AuthenticationScheme.BEARER:tokenType,requestedClaims&&(atEntity.requestedClaims=requestedClaims,atEntity.requestedClaimsHash=requestedClaimsHash),(null===(_a=atEntity.tokenType)||void 0===_a?void 0:_a.toLowerCase())!==AuthenticationScheme.BEARER.toLowerCase())switch(atEntity.credentialType=CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME,atEntity.tokenType){case AuthenticationScheme.POP:var tokenClaims=AuthToken.extractTokenClaims(accessToken,cryptoUtils);if(!(null===(_b=null==tokenClaims?void 0:tokenClaims.cnf)||void 0===_b?void 0:_b.kid))throw ClientAuthError.createTokenClaimsRequiredError();atEntity.keyId=tokenClaims.cnf.kid;break;case AuthenticationScheme.SSH:atEntity.keyId=keyId}return atEntity},AccessTokenEntity.isAccessTokenEntity=function(entity){return!!entity&&(entity.hasOwnProperty("homeAccountId")&&entity.hasOwnProperty("environment")&&entity.hasOwnProperty("credentialType")&&entity.hasOwnProperty("realm")&&entity.hasOwnProperty("clientId")&&entity.hasOwnProperty("secret")&&entity.hasOwnProperty("target")&&(entity.credentialType===CredentialType.ACCESS_TOKEN||entity.credentialType===CredentialType.ACCESS_TOKEN_WITH_AUTH_SCHEME))},AccessTokenEntity}(CredentialEntity);export{AccessTokenEntity};