/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{__extends,__awaiter,__generator}from"../_virtual/_tslib.js";import{BaseClient}from"./BaseClient.js";import{ResponseHandler}from"../response/ResponseHandler.js";import{RequestParameterBuilder}from"../request/RequestParameterBuilder.js";import{GrantType,HeaderNames}from"../utils/Constants.js";import{StringUtils}from"../utils/StringUtils.js";import{TimeUtils}from"../utils/TimeUtils.js";import{CcsCredentialType}from"../account/CcsCredential.js";import{UrlString}from"../url/UrlString.js";var UsernamePasswordClient=function(_super){function UsernamePasswordClient(configuration){return _super.call(this,configuration)||this}return __extends(UsernamePasswordClient,_super),UsernamePasswordClient.prototype.acquireToken=function(request){var _a,_b;return __awaiter(this,void 0,void 0,(function(){var atsMeasurement,reqTimestamp,response,httpVerToken,responseHandler;return __generator(this,(function(_c){switch(_c.label){case 0:return atsMeasurement=null===(_a=this.performanceClient)||void 0===_a?void 0:_a.startMeasurement("UsernamePasswordClientAcquireToken",request.correlationId),this.logger.info("in acquireToken call in username-password client"),reqTimestamp=TimeUtils.nowSeconds(),[4,this.executeTokenRequest(this.authority,request)];case 1:return response=_c.sent(),httpVerToken=null===(_b=response.headers)||void 0===_b?void 0:_b[HeaderNames.X_MS_HTTP_VERSION],null==atsMeasurement||atsMeasurement.addStaticFields({httpVerToken:httpVerToken}),(responseHandler=new ResponseHandler(this.config.authOptions.clientId,this.cacheManager,this.cryptoUtils,this.logger,this.config.serializableCache,this.config.persistencePlugin)).validateTokenResponse(response.body),[2,responseHandler.handleServerTokenResponse(response.body,this.authority,reqTimestamp,request)]}}))}))},UsernamePasswordClient.prototype.executeTokenRequest=function(authority,request){return __awaiter(this,void 0,void 0,(function(){var queryParametersString,endpoint,requestBody,headers,thumbprint;return __generator(this,(function(_a){return queryParametersString=this.createTokenQueryParameters(request),endpoint=UrlString.appendQueryString(authority.tokenEndpoint,queryParametersString),requestBody=this.createTokenRequestBody(request),headers=this.createTokenRequestHeaders({credential:request.username,type:CcsCredentialType.UPN}),thumbprint={clientId:this.config.authOptions.clientId,authority:authority.canonicalAuthority,scopes:request.scopes,claims:request.claims,authenticationScheme:request.authenticationScheme,resourceRequestMethod:request.resourceRequestMethod,resourceRequestUri:request.resourceRequestUri,shrClaims:request.shrClaims,sshKid:request.sshKid},[2,this.executePostToTokenEndpoint(endpoint,requestBody,headers,thumbprint)]}))}))},UsernamePasswordClient.prototype.createTokenRequestBody=function(request){var parameterBuilder=new RequestParameterBuilder;parameterBuilder.addClientId(this.config.authOptions.clientId),parameterBuilder.addUsername(request.username),parameterBuilder.addPassword(request.password),parameterBuilder.addScopes(request.scopes),parameterBuilder.addResponseTypeForTokenAndIdToken(),parameterBuilder.addGrantType(GrantType.RESOURCE_OWNER_PASSWORD_GRANT),parameterBuilder.addClientInfo(),parameterBuilder.addLibraryInfo(this.config.libraryInfo),parameterBuilder.addApplicationTelemetry(this.config.telemetry.application),parameterBuilder.addThrottling(),this.serverTelemetryManager&&parameterBuilder.addServerTelemetry(this.serverTelemetryManager);var correlationId=request.correlationId||this.config.cryptoInterface.createNewGuid();if(parameterBuilder.addCorrelationId(correlationId),this.config.clientCredentials.clientSecret&&parameterBuilder.addClientSecret(this.config.clientCredentials.clientSecret),this.config.clientCredentials.clientAssertion){var clientAssertion=this.config.clientCredentials.clientAssertion;parameterBuilder.addClientAssertion(clientAssertion.assertion),parameterBuilder.addClientAssertionType(clientAssertion.assertionType)}return(!StringUtils.isEmptyObj(request.claims)||this.config.authOptions.clientCapabilities&&this.config.authOptions.clientCapabilities.length>0)&&parameterBuilder.addClaims(request.claims,this.config.authOptions.clientCapabilities),this.config.systemOptions.preventCorsPreflight&&request.username&&parameterBuilder.addCcsUpn(request.username),parameterBuilder.createQueryString()},UsernamePasswordClient}(BaseClient);export{UsernamePasswordClient};