/*! @azure/msal-common v13.1.0 2023-06-07 */
"use strict";import{ClientConfigurationError}from"../error/ClientConfigurationError.js";import{ClientAuthError}from"../error/ClientAuthError.js";import{StringUtils}from"../utils/StringUtils.js";import{AADAuthorityConstants,Constants}from"../utils/Constants.js";var UrlString=function(){function UrlString(url){if(this._urlString=url,StringUtils.isEmpty(this._urlString))throw ClientConfigurationError.createUrlEmptyError();StringUtils.isEmpty(this.getHash())&&(this._urlString=UrlString.canonicalizeUri(url))}return Object.defineProperty(UrlString.prototype,"urlString",{get:function(){return this._urlString},enumerable:!1,configurable:!0}),UrlString.canonicalizeUri=function(url){if(url){var lowerCaseUrl=url.toLowerCase();return StringUtils.endsWith(lowerCaseUrl,"?")?lowerCaseUrl=lowerCaseUrl.slice(0,-1):StringUtils.endsWith(lowerCaseUrl,"?/")&&(lowerCaseUrl=lowerCaseUrl.slice(0,-2)),StringUtils.endsWith(lowerCaseUrl,"/")||(lowerCaseUrl+="/"),lowerCaseUrl}return url},UrlString.prototype.validateAsUri=function(){var components;try{components=this.getUrlComponents()}catch(e){throw ClientConfigurationError.createUrlParseError(e)}if(!components.HostNameAndPort||!components.PathSegments)throw ClientConfigurationError.createUrlParseError("Given url string: "+this.urlString);if(!components.Protocol||"https:"!==components.Protocol.toLowerCase())throw ClientConfigurationError.createInsecureAuthorityUriError(this.urlString)},UrlString.appendQueryString=function(url,queryString){return StringUtils.isEmpty(queryString)?url:url.indexOf("?")<0?url+"?"+queryString:url+"&"+queryString},UrlString.removeHashFromUrl=function(url){return UrlString.canonicalizeUri(url.split("#")[0])},UrlString.prototype.replaceTenantPath=function(tenantId){var urlObject=this.getUrlComponents(),pathArray=urlObject.PathSegments;return!tenantId||0===pathArray.length||pathArray[0]!==AADAuthorityConstants.COMMON&&pathArray[0]!==AADAuthorityConstants.ORGANIZATIONS||(pathArray[0]=tenantId),UrlString.constructAuthorityUriFromObject(urlObject)},UrlString.prototype.getHash=function(){return UrlString.parseHash(this.urlString)},UrlString.prototype.getUrlComponents=function(){var regEx=RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?"),match=this.urlString.match(regEx);if(!match)throw ClientConfigurationError.createUrlParseError("Given url string: "+this.urlString);var urlComponents={Protocol:match[1],HostNameAndPort:match[4],AbsolutePath:match[5],QueryString:match[7]},pathSegments=urlComponents.AbsolutePath.split("/");return pathSegments=pathSegments.filter((function(val){return val&&val.length>0})),urlComponents.PathSegments=pathSegments,!StringUtils.isEmpty(urlComponents.QueryString)&&urlComponents.QueryString.endsWith("/")&&(urlComponents.QueryString=urlComponents.QueryString.substring(0,urlComponents.QueryString.length-1)),urlComponents},UrlString.getDomainFromUrl=function(url){var regEx=RegExp("^([^:/?#]+://)?([^/?#]*)"),match=url.match(regEx);if(!match)throw ClientConfigurationError.createUrlParseError("Given url string: "+url);return match[2]},UrlString.getAbsoluteUrl=function(relativeUrl,baseUrl){if(relativeUrl[0]===Constants.FORWARD_SLASH){var baseComponents=new UrlString(baseUrl).getUrlComponents();return baseComponents.Protocol+"//"+baseComponents.HostNameAndPort+relativeUrl}return relativeUrl},UrlString.parseHash=function(hashString){var hashIndex1=hashString.indexOf("#"),hashIndex2=hashString.indexOf("#/");return hashIndex2>-1?hashString.substring(hashIndex2+2):hashIndex1>-1?hashString.substring(hashIndex1+1):Constants.EMPTY_STRING},UrlString.parseQueryString=function(queryString){var queryIndex1=queryString.indexOf("?"),queryIndex2=queryString.indexOf("/?");return queryIndex2>-1?queryString.substring(queryIndex2+2):queryIndex1>-1?queryString.substring(queryIndex1+1):Constants.EMPTY_STRING},UrlString.constructAuthorityUriFromObject=function(urlObject){return new UrlString(urlObject.Protocol+"//"+urlObject.HostNameAndPort+"/"+urlObject.PathSegments.join("/"))},UrlString.getDeserializedHash=function(hash){if(StringUtils.isEmpty(hash))return{};var parsedHash=UrlString.parseHash(hash),deserializedHash=StringUtils.queryStringToObject(StringUtils.isEmpty(parsedHash)?hash:parsedHash);if(!deserializedHash)throw ClientAuthError.createHashNotDeserializedError(JSON.stringify(deserializedHash));return deserializedHash},UrlString.getDeserializedQueryString=function(query){if(StringUtils.isEmpty(query))return{};var parsedQueryString=UrlString.parseQueryString(query),deserializedQueryString=StringUtils.queryStringToObject(StringUtils.isEmpty(parsedQueryString)?query:parsedQueryString);if(!deserializedQueryString)throw ClientAuthError.createHashNotDeserializedError(JSON.stringify(deserializedQueryString));return deserializedQueryString},UrlString.hashContainsKnownProperties=function(hash){if(StringUtils.isEmpty(hash)||hash.indexOf("=")<0)return!1;var parameters=UrlString.getDeserializedHash(hash);return!!(parameters.code||parameters.error_description||parameters.error||parameters.state)},UrlString}();export{UrlString};