//! @version @js-joda/core - 5.5.3
//! @copyright (c) 2015-present, Philipp Thürwächter, Pattrick Hüper & js-joda contributors
//! @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
//! @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
"use strict";
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function createErrorType(name,init,superErrorClass){function JsJodaException(message){Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):this.stack=(new Error).stack,this.message=message,init&&init.apply(this,arguments),this.toString=function(){return this.name+": "+this.message}}return void 0===superErrorClass&&(superErrorClass=Error),JsJodaException.prototype=Object.create(superErrorClass.prototype),JsJodaException.prototype.name=name,JsJodaException.prototype.constructor=JsJodaException,JsJodaException}var DateTimeException=createErrorType("DateTimeException",messageWithCause),DateTimeParseException=createErrorType("DateTimeParseException",messageForDateTimeParseException),UnsupportedTemporalTypeException=createErrorType("UnsupportedTemporalTypeException",null,DateTimeException),ArithmeticException=createErrorType("ArithmeticException"),IllegalArgumentException=createErrorType("IllegalArgumentException"),IllegalStateException=createErrorType("IllegalStateException"),NullPointerException=createErrorType("NullPointerException");function messageWithCause(message,cause){void 0===cause&&(cause=null);var msg=message||this.name;null!==cause&&cause instanceof Error&&(msg+="\n-------\nCaused by: "+cause.stack+"\n-------\n"),this.message=msg}function messageForDateTimeParseException(message,text,index,cause){void 0===text&&(text=""),void 0===index&&(index=0),void 0===cause&&(cause=null);var msg=message||this.name;msg+=": "+text+", at index: "+index,null!==cause&&cause instanceof Error&&(msg+="\n-------\nCaused by: "+cause.stack+"\n-------\n"),this.message=msg,this.parsedString=function(){return text},this.errorIndex=function(){return index}}function _inheritsLoose(subClass,superClass){subClass.prototype=Object.create(superClass.prototype),subClass.prototype.constructor=subClass,_setPrototypeOf(subClass,superClass)}function _setPrototypeOf(o,p){return _setPrototypeOf=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(o,p){return o.__proto__=p,o},_setPrototypeOf(o,p)}function _assertThisInitialized(self){if(void 0===self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return self}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function assert(assertion,msg,error){if(!assertion)throw error?new error(msg):new Error(msg)}function requireNonNull(value,parameterName){if(null==value)throw new NullPointerException(parameterName+" must not be null");return value}function requireInstance(value,_class,parameterName){if(!(value instanceof _class))throw new IllegalArgumentException(parameterName+" must be an instance of "+(_class.name?_class.name:_class)+(value&&value.constructor&&value.constructor.name?", but is "+value.constructor.name:""));return value}function abstractMethodFail(methodName){throw new TypeError('abstract method "'+methodName+'" is not implemented')}var assert$1=Object.freeze({__proto__:null,assert:assert,requireNonNull:requireNonNull,requireInstance:requireInstance,abstractMethodFail:abstractMethodFail}),MAX_SAFE_INTEGER=9007199254740991,MIN_SAFE_INTEGER=-9007199254740991,MathUtil=function(){function MathUtil(){}return MathUtil.intDiv=function(x,y){var r=x/y;return r=MathUtil.roundDown(r),MathUtil.safeZero(r)},MathUtil.intMod=function(x,y){var r=x-MathUtil.intDiv(x,y)*y;return r=MathUtil.roundDown(r),MathUtil.safeZero(r)},MathUtil.roundDown=function(r){return r<0?Math.ceil(r):Math.floor(r)},MathUtil.floorDiv=function(x,y){var r=Math.floor(x/y);return MathUtil.safeZero(r)},MathUtil.floorMod=function(x,y){var r=x-MathUtil.floorDiv(x,y)*y;return MathUtil.safeZero(r)},MathUtil.safeAdd=function(x,y){if(MathUtil.verifyInt(x),MathUtil.verifyInt(y),0===x)return MathUtil.safeZero(y);if(0===y)return MathUtil.safeZero(x);var r=MathUtil.safeToInt(x+y);if(r===x||r===y)throw new ArithmeticException("Invalid addition beyond MAX_SAFE_INTEGER!");return r},MathUtil.safeSubtract=function(x,y){return MathUtil.verifyInt(x),MathUtil.verifyInt(y),0===x&&0===y?0:0===x?MathUtil.safeZero(-1*y):0===y?MathUtil.safeZero(x):MathUtil.safeToInt(x-y)},MathUtil.safeMultiply=function(x,y){if(MathUtil.verifyInt(x),MathUtil.verifyInt(y),1===x)return MathUtil.safeZero(y);if(1===y)return MathUtil.safeZero(x);if(0===x||0===y)return 0;var r=MathUtil.safeToInt(x*y);if(r/y!==x||x===MIN_SAFE_INTEGER&&-1===y||y===MIN_SAFE_INTEGER&&-1===x)throw new ArithmeticException("Multiplication overflows: "+x+" * "+y);return r},MathUtil.parseInt=function(_parseInt){function parseInt(_x){return _parseInt.apply(this,arguments)}return parseInt.toString=function(){return _parseInt.toString()},parseInt}((function(value){var r=parseInt(value);return MathUtil.safeToInt(r)})),MathUtil.safeToInt=function(value){return MathUtil.verifyInt(value),MathUtil.safeZero(value)},MathUtil.verifyInt=function(value){if(null==value)throw new ArithmeticException("Invalid value: '"+value+"', using null or undefined as argument");if(isNaN(value))throw new ArithmeticException("Invalid int value, using NaN as argument");if(value%1!=0)throw new ArithmeticException("Invalid value: '"+value+"' is a float");if(value>MAX_SAFE_INTEGER||value<MIN_SAFE_INTEGER)throw new ArithmeticException("Calculation overflows an int: "+value)},MathUtil.safeZero=function(value){return 0===value?0:+value},MathUtil.compareNumbers=function(a,b){return a<b?-1:a>b?1:0},MathUtil.smi=function(int){return int>>>1&1073741824|3221225471&int},MathUtil.hash=function(number){if(number!=number||number===1/0)return 0;for(var result=number;number>4294967295;)result^=number/=4294967295;return MathUtil.smi(result)},MathUtil.hashCode=function(){for(var result=17,_len=arguments.length,numbers=new Array(_len),_key=0;_key<_len;_key++)numbers[_key]=arguments[_key];for(var _i=0,_numbers=numbers;_i<_numbers.length;_i++){var n=_numbers[_i];result=(result<<5)-result+MathUtil.hash(n)}return MathUtil.hash(result)},MathUtil}();
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */MathUtil.MAX_SAFE_INTEGER=MAX_SAFE_INTEGER,MathUtil.MIN_SAFE_INTEGER=MIN_SAFE_INTEGER;
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var Enum=function(){function Enum(name){this._name=name}var _proto=Enum.prototype;return _proto.equals=function(other){return this===other},_proto.toString=function(){return this._name},_proto.toJSON=function(){return this.toString()},Enum}(),TemporalAmount=function(){function TemporalAmount(){}var _proto=TemporalAmount.prototype;return _proto.get=function(unit){abstractMethodFail("get")},_proto.units=function(){abstractMethodFail("units")},_proto.addTo=function(temporal){abstractMethodFail("addTo")},_proto.subtractFrom=function(temporal){abstractMethodFail("subtractFrom")},TemporalAmount}();
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */"undefined"!=typeof Symbol&&Symbol.toPrimitive&&(TemporalAmount.prototype[Symbol.toPrimitive]=function(hint){if("number"!==hint)return this.toString();throw new TypeError("A conversion from TemporalAmount to a number is not allowed. To compare use the methods .equals(), .compareTo(), .isBefore() or one that is more suitable to your use case.")})
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */;var TemporalUnit=function(){function TemporalUnit(){}var _proto=TemporalUnit.prototype;return _proto.duration=function(){abstractMethodFail("duration")},_proto.isDurationEstimated=function(){abstractMethodFail("isDurationEstimated")},_proto.isDateBased=function(){abstractMethodFail("isDateBased")},_proto.isTimeBased=function(){abstractMethodFail("isTimeBased")},_proto.isSupportedBy=function(temporal){abstractMethodFail("isSupportedBy")},_proto.addTo=function(dateTime,periodToAdd){abstractMethodFail("addTo")},_proto.between=function(temporal1,temporal2){abstractMethodFail("between")},TemporalUnit}(),Duration=function(_TemporalAmount){function Duration(seconds,nanos){var _this;return(_this=_TemporalAmount.call(this)||this)._seconds=MathUtil.safeToInt(seconds),_this._nanos=MathUtil.safeToInt(nanos),_this}_inheritsLoose(Duration,_TemporalAmount),Duration.ofDays=function(days){return Duration._create(MathUtil.safeMultiply(days,LocalTime.SECONDS_PER_DAY),0)},Duration.ofHours=function(hours){return Duration._create(MathUtil.safeMultiply(hours,LocalTime.SECONDS_PER_HOUR),0)},Duration.ofMinutes=function(minutes){return Duration._create(MathUtil.safeMultiply(minutes,LocalTime.SECONDS_PER_MINUTE),0)},Duration.ofSeconds=function(seconds,nanoAdjustment){void 0===nanoAdjustment&&(nanoAdjustment=0);var secs=MathUtil.safeAdd(seconds,MathUtil.floorDiv(nanoAdjustment,LocalTime.NANOS_PER_SECOND)),nos=MathUtil.floorMod(nanoAdjustment,LocalTime.NANOS_PER_SECOND);return Duration._create(secs,nos)},Duration.ofMillis=function(millis){var secs=MathUtil.intDiv(millis,1e3),mos=MathUtil.intMod(millis,1e3);return mos<0&&(mos+=1e3,secs--),Duration._create(secs,1e6*mos)},Duration.ofNanos=function(nanos){var secs=MathUtil.intDiv(nanos,LocalTime.NANOS_PER_SECOND),nos=MathUtil.intMod(nanos,LocalTime.NANOS_PER_SECOND);return nos<0&&(nos+=LocalTime.NANOS_PER_SECOND,secs--),this._create(secs,nos)},Duration.of=function(amount,unit){return Duration.ZERO.plus(amount,unit)},Duration.from=function(amount){requireNonNull(amount,"amount"),requireInstance(amount,TemporalAmount);var duration=Duration.ZERO;return amount.units().forEach((function(unit){duration=duration.plus(amount.get(unit),unit)})),duration},Duration.between=function(startInclusive,endExclusive){requireNonNull(startInclusive,"startInclusive"),requireNonNull(endExclusive,"endExclusive");var secs=startInclusive.until(endExclusive,ChronoUnit.SECONDS),nanos=0;if(startInclusive.isSupported(ChronoField.NANO_OF_SECOND)&&endExclusive.isSupported(ChronoField.NANO_OF_SECOND))try{var startNos=startInclusive.getLong(ChronoField.NANO_OF_SECOND);if(nanos=endExclusive.getLong(ChronoField.NANO_OF_SECOND)-startNos,secs>0&&nanos<0)nanos+=LocalTime.NANOS_PER_SECOND;else if(secs<0&&nanos>0)nanos-=LocalTime.NANOS_PER_SECOND;else if(0===secs&&0!==nanos){var adjustedEnd=endExclusive.with(ChronoField.NANO_OF_SECOND,startNos);secs=startInclusive.until(adjustedEnd,ChronoUnit.SECONDS)}}catch(e){}return this.ofSeconds(secs,nanos)},Duration.parse=function(text){requireNonNull(text,"text");var matches=new RegExp("([-+]?)P(?:([-+]?[0-9]+)D)?(T(?:([-+]?[0-9]+)H)?(?:([-+]?[0-9]+)M)?(?:([-+]?[0-9]+)(?:[.,]([0-9]{0,9}))?S)?)?","i").exec(text);if(null!==matches&&"T"===matches[3]==!1){var negate="-"===matches[1],dayMatch=matches[2],hourMatch=matches[4],minuteMatch=matches[5],secondMatch=matches[6],fractionMatch=matches[7];if(null!=dayMatch||null!=hourMatch||null!=minuteMatch||null!=secondMatch){var daysAsSecs=Duration._parseNumber(text,dayMatch,LocalTime.SECONDS_PER_DAY,"days"),hoursAsSecs=Duration._parseNumber(text,hourMatch,LocalTime.SECONDS_PER_HOUR,"hours"),minsAsSecs=Duration._parseNumber(text,minuteMatch,LocalTime.SECONDS_PER_MINUTE,"minutes"),seconds=Duration._parseNumber(text,secondMatch,1,"seconds"),negativeSecs=null!=secondMatch&&"-"===secondMatch.charAt(0),nanos=Duration._parseFraction(text,fractionMatch,negativeSecs?-1:1);try{return Duration._create(negate,daysAsSecs,hoursAsSecs,minsAsSecs,seconds,nanos)}catch(ex){throw new DateTimeParseException("Text cannot be parsed to a Duration: overflow",text,0,ex)}}}throw new DateTimeParseException("Text cannot be parsed to a Duration",text,0)},Duration._parseNumber=function(text,parsed,multiplier,errorText){if(null==parsed)return 0;try{return"+"===parsed[0]&&(parsed=parsed.substring(1)),MathUtil.safeMultiply(parseFloat(parsed),multiplier)}catch(ex){throw new DateTimeParseException("Text cannot be parsed to a Duration: "+errorText,text,0,ex)}},Duration._parseFraction=function(text,parsed,negate){return null==parsed||0===parsed.length?0:(parsed=(parsed+"000000000").substring(0,9),parseFloat(parsed)*negate)},Duration._create=function(){return arguments.length<=2?Duration._createSecondsNanos(arguments[0],arguments[1]):Duration._createNegateDaysHoursMinutesSecondsNanos(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5])},Duration._createNegateDaysHoursMinutesSecondsNanos=function(negate,daysAsSecs,hoursAsSecs,minsAsSecs,secs,nanos){var seconds=MathUtil.safeAdd(daysAsSecs,MathUtil.safeAdd(hoursAsSecs,MathUtil.safeAdd(minsAsSecs,secs)));return negate?Duration.ofSeconds(seconds,nanos).negated():Duration.ofSeconds(seconds,nanos)},Duration._createSecondsNanos=function(seconds,nanoAdjustment){return void 0===seconds&&(seconds=0),void 0===nanoAdjustment&&(nanoAdjustment=0),0===seconds&&0===nanoAdjustment?Duration.ZERO:new Duration(seconds,nanoAdjustment)};var _proto=Duration.prototype;return _proto.get=function(unit){if(unit===ChronoUnit.SECONDS)return this._seconds;if(unit===ChronoUnit.NANOS)return this._nanos;throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)},_proto.units=function(){return[ChronoUnit.SECONDS,ChronoUnit.NANOS]},_proto.isZero=function(){return 0===this._seconds&&0===this._nanos},_proto.isNegative=function(){return this._seconds<0},_proto.seconds=function(){return this._seconds},_proto.nano=function(){return this._nanos},_proto.withSeconds=function(seconds){return Duration._create(seconds,this._nanos)},_proto.withNanos=function(nanoOfSecond){return ChronoField.NANO_OF_SECOND.checkValidIntValue(nanoOfSecond),Duration._create(this._seconds,nanoOfSecond)},_proto.plusDuration=function(duration){return requireNonNull(duration,"duration"),this.plus(duration.seconds(),duration.nano())},_proto.plus=function(durationOrNumber,unitOrNumber){return 1===arguments.length?this.plusDuration(durationOrNumber):2===arguments.length&&unitOrNumber instanceof TemporalUnit?this.plusAmountUnit(durationOrNumber,unitOrNumber):this.plusSecondsNanos(durationOrNumber,unitOrNumber)},_proto.plusAmountUnit=function(amountToAdd,unit){if(requireNonNull(amountToAdd,"amountToAdd"),requireNonNull(unit,"unit"),unit===ChronoUnit.DAYS)return this.plusSecondsNanos(MathUtil.safeMultiply(amountToAdd,LocalTime.SECONDS_PER_DAY),0);if(unit.isDurationEstimated())throw new UnsupportedTemporalTypeException("Unit must not have an estimated duration");if(0===amountToAdd)return this;if(unit instanceof ChronoUnit){switch(unit){case ChronoUnit.NANOS:return this.plusNanos(amountToAdd);case ChronoUnit.MICROS:return this.plusSecondsNanos(1e3*MathUtil.intDiv(amountToAdd,1e9),1e3*MathUtil.intMod(amountToAdd,1e9));case ChronoUnit.MILLIS:return this.plusMillis(amountToAdd);case ChronoUnit.SECONDS:return this.plusSeconds(amountToAdd)}return this.plusSecondsNanos(MathUtil.safeMultiply(unit.duration().seconds(),amountToAdd),0)}var duration=unit.duration().multipliedBy(amountToAdd);return this.plusSecondsNanos(duration.seconds(),duration.nano())},_proto.plusDays=function(daysToAdd){return this.plusSecondsNanos(MathUtil.safeMultiply(daysToAdd,LocalTime.SECONDS_PER_DAY),0)},_proto.plusHours=function(hoursToAdd){return this.plusSecondsNanos(MathUtil.safeMultiply(hoursToAdd,LocalTime.SECONDS_PER_HOUR),0)},_proto.plusMinutes=function(minutesToAdd){return this.plusSecondsNanos(MathUtil.safeMultiply(minutesToAdd,LocalTime.SECONDS_PER_MINUTE),0)},_proto.plusSeconds=function(secondsToAdd){return this.plusSecondsNanos(secondsToAdd,0)},_proto.plusMillis=function(millisToAdd){return this.plusSecondsNanos(MathUtil.intDiv(millisToAdd,1e3),1e6*MathUtil.intMod(millisToAdd,1e3))},_proto.plusNanos=function(nanosToAdd){return this.plusSecondsNanos(0,nanosToAdd)},_proto.plusSecondsNanos=function(secondsToAdd,nanosToAdd){if(requireNonNull(secondsToAdd,"secondsToAdd"),requireNonNull(nanosToAdd,"nanosToAdd"),0===secondsToAdd&&0===nanosToAdd)return this;var epochSec=MathUtil.safeAdd(this._seconds,secondsToAdd);epochSec=MathUtil.safeAdd(epochSec,MathUtil.intDiv(nanosToAdd,LocalTime.NANOS_PER_SECOND)),nanosToAdd=MathUtil.intMod(nanosToAdd,LocalTime.NANOS_PER_SECOND);var nanoAdjustment=MathUtil.safeAdd(this._nanos,nanosToAdd);return Duration.ofSeconds(epochSec,nanoAdjustment)},_proto.minus=function(durationOrNumber,unit){return 1===arguments.length?this.minusDuration(durationOrNumber):this.minusAmountUnit(durationOrNumber,unit)},_proto.minusDuration=function(duration){requireNonNull(duration,"duration");var secsToSubtract=duration.seconds(),nanosToSubtract=duration.nano();return secsToSubtract===MIN_SAFE_INTEGER?this.plus(MAX_SAFE_INTEGER,-nanosToSubtract):this.plus(-secsToSubtract,-nanosToSubtract)},_proto.minusAmountUnit=function(amountToSubtract,unit){return requireNonNull(amountToSubtract,"amountToSubtract"),requireNonNull(unit,"unit"),amountToSubtract===MIN_SAFE_INTEGER?this.plusAmountUnit(MAX_SAFE_INTEGER,unit):this.plusAmountUnit(-amountToSubtract,unit)},_proto.minusDays=function(daysToSubtract){return daysToSubtract===MIN_SAFE_INTEGER?this.plusDays(MAX_SAFE_INTEGER):this.plusDays(-daysToSubtract)},_proto.minusHours=function(hoursToSubtract){return hoursToSubtract===MIN_SAFE_INTEGER?this.plusHours(MAX_SAFE_INTEGER):this.plusHours(-hoursToSubtract)},_proto.minusMinutes=function(minutesToSubtract){return minutesToSubtract===MIN_SAFE_INTEGER?this.plusMinutes(MAX_SAFE_INTEGER):this.plusMinutes(-minutesToSubtract)},_proto.minusSeconds=function(secondsToSubtract){return secondsToSubtract===MIN_SAFE_INTEGER?this.plusSeconds(MAX_SAFE_INTEGER):this.plusSeconds(-secondsToSubtract)},_proto.minusMillis=function(millisToSubtract){return millisToSubtract===MIN_SAFE_INTEGER?this.plusMillis(MAX_SAFE_INTEGER):this.plusMillis(-millisToSubtract)},_proto.minusNanos=function(nanosToSubtract){return nanosToSubtract===MIN_SAFE_INTEGER?this.plusNanos(MAX_SAFE_INTEGER):this.plusNanos(-nanosToSubtract)},_proto.multipliedBy=function(multiplicand){if(0===multiplicand)return Duration.ZERO;if(1===multiplicand)return this;var secs=MathUtil.safeMultiply(this._seconds,multiplicand),nos=MathUtil.safeMultiply(this._nanos,multiplicand);return secs+=MathUtil.intDiv(nos,LocalTime.NANOS_PER_SECOND),nos=MathUtil.intMod(nos,LocalTime.NANOS_PER_SECOND),Duration.ofSeconds(secs,nos)},_proto.dividedBy=function(divisor){if(0===divisor)throw new ArithmeticException("Cannot divide by zero");if(1===divisor)return this;var secs=MathUtil.intDiv(this._seconds,divisor),secsMod=MathUtil.roundDown((this._seconds/divisor-secs)*LocalTime.NANOS_PER_SECOND),nos=MathUtil.intDiv(this._nanos,divisor);return nos=secsMod+nos,Duration.ofSeconds(secs,nos)},_proto.negated=function(){return this.multipliedBy(-1)},_proto.abs=function(){return this.isNegative()?this.negated():this},_proto.addTo=function(temporal){return requireNonNull(temporal,"temporal"),0!==this._seconds&&(temporal=temporal.plus(this._seconds,ChronoUnit.SECONDS)),0!==this._nanos&&(temporal=temporal.plus(this._nanos,ChronoUnit.NANOS)),temporal},_proto.subtractFrom=function(temporal){return requireNonNull(temporal,"temporal"),0!==this._seconds&&(temporal=temporal.minus(this._seconds,ChronoUnit.SECONDS)),0!==this._nanos&&(temporal=temporal.minus(this._nanos,ChronoUnit.NANOS)),temporal},_proto.toDays=function(){return MathUtil.intDiv(this._seconds,LocalTime.SECONDS_PER_DAY)},_proto.toHours=function(){return MathUtil.intDiv(this._seconds,LocalTime.SECONDS_PER_HOUR)},_proto.toMinutes=function(){return MathUtil.intDiv(this._seconds,LocalTime.SECONDS_PER_MINUTE)},_proto.toMillis=function(){var millis=Math.round(MathUtil.safeMultiply(this._seconds,1e3));return millis=MathUtil.safeAdd(millis,MathUtil.intDiv(this._nanos,1e6))},_proto.toNanos=function(){var totalNanos=MathUtil.safeMultiply(this._seconds,LocalTime.NANOS_PER_SECOND);return totalNanos=MathUtil.safeAdd(totalNanos,this._nanos)},_proto.compareTo=function(otherDuration){requireNonNull(otherDuration,"otherDuration"),requireInstance(otherDuration,Duration,"otherDuration");var cmp=MathUtil.compareNumbers(this._seconds,otherDuration.seconds());return 0!==cmp?cmp:this._nanos-otherDuration.nano()},_proto.equals=function(otherDuration){return this===otherDuration||otherDuration instanceof Duration&&(this.seconds()===otherDuration.seconds()&&this.nano()===otherDuration.nano())},_proto.toString=function(){if(this===Duration.ZERO)return"PT0S";var nanoString,hours=MathUtil.intDiv(this._seconds,LocalTime.SECONDS_PER_HOUR),minutes=MathUtil.intDiv(MathUtil.intMod(this._seconds,LocalTime.SECONDS_PER_HOUR),LocalTime.SECONDS_PER_MINUTE),secs=MathUtil.intMod(this._seconds,LocalTime.SECONDS_PER_MINUTE),rval="PT";if(0!==hours&&(rval+=hours+"H"),0!==minutes&&(rval+=minutes+"M"),0===secs&&0===this._nanos&&rval.length>2)return rval;if(secs<0&&this._nanos>0?rval+=-1===secs?"-0":secs+1:rval+=secs,this._nanos>0)for(rval+=".",rval+=nanoString=(nanoString=secs<0?""+(2*LocalTime.NANOS_PER_SECOND-this._nanos):""+(LocalTime.NANOS_PER_SECOND+this._nanos)).slice(1,nanoString.length);"0"===rval.charAt(rval.length-1);)rval=rval.slice(0,rval.length-1);return rval+="S"},_proto.toJSON=function(){return this.toString()},Duration}(TemporalAmount);function _init$n(){Duration.ZERO=new Duration(0,0)}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE.md in the root directory of this source tree)
 */var YearConstants=function(){};function _init$m(){YearConstants.MIN_VALUE=-999999,YearConstants.MAX_VALUE=999999}var ChronoUnit=function(_TemporalUnit){function ChronoUnit(name,estimatedDuration){var _this;return(_this=_TemporalUnit.call(this)||this)._name=name,_this._duration=estimatedDuration,_this}_inheritsLoose(ChronoUnit,_TemporalUnit);var _proto=ChronoUnit.prototype;return _proto.duration=function(){return this._duration},_proto.isDurationEstimated=function(){return this.isDateBased()||this===ChronoUnit.FOREVER},_proto.isDateBased=function(){return this.compareTo(ChronoUnit.DAYS)>=0&&this!==ChronoUnit.FOREVER},_proto.isTimeBased=function(){return this.compareTo(ChronoUnit.DAYS)<0},_proto.isSupportedBy=function(temporal){if(this===ChronoUnit.FOREVER)return!1;try{return temporal.plus(1,this),!0}catch(e){try{return temporal.plus(-1,this),!0}catch(e2){return!1}}},_proto.addTo=function(temporal,amount){return temporal.plus(amount,this)},_proto.between=function(temporal1,temporal2){return temporal1.until(temporal2,this)},_proto.toString=function(){return this._name},_proto.compareTo=function(other){return this.duration().compareTo(other.duration())},ChronoUnit}(TemporalUnit);function _init$l(){ChronoUnit.NANOS=new ChronoUnit("Nanos",Duration.ofNanos(1)),ChronoUnit.MICROS=new ChronoUnit("Micros",Duration.ofNanos(1e3)),ChronoUnit.MILLIS=new ChronoUnit("Millis",Duration.ofNanos(1e6)),ChronoUnit.SECONDS=new ChronoUnit("Seconds",Duration.ofSeconds(1)),ChronoUnit.MINUTES=new ChronoUnit("Minutes",Duration.ofSeconds(60)),ChronoUnit.HOURS=new ChronoUnit("Hours",Duration.ofSeconds(3600)),ChronoUnit.HALF_DAYS=new ChronoUnit("HalfDays",Duration.ofSeconds(43200)),ChronoUnit.DAYS=new ChronoUnit("Days",Duration.ofSeconds(86400)),ChronoUnit.WEEKS=new ChronoUnit("Weeks",Duration.ofSeconds(604800)),ChronoUnit.MONTHS=new ChronoUnit("Months",Duration.ofSeconds(2629746)),ChronoUnit.YEARS=new ChronoUnit("Years",Duration.ofSeconds(31556952)),ChronoUnit.DECADES=new ChronoUnit("Decades",Duration.ofSeconds(315569520)),ChronoUnit.CENTURIES=new ChronoUnit("Centuries",Duration.ofSeconds(3155695200)),ChronoUnit.MILLENNIA=new ChronoUnit("Millennia",Duration.ofSeconds(31556952e3)),ChronoUnit.ERAS=new ChronoUnit("Eras",Duration.ofSeconds(31556952*(YearConstants.MAX_VALUE+1))),ChronoUnit.FOREVER=new ChronoUnit("Forever",Duration.ofSeconds(MathUtil.MAX_SAFE_INTEGER,999999999))}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var TemporalField=function(){function TemporalField(){}var _proto=TemporalField.prototype;return _proto.isDateBased=function(){abstractMethodFail("isDateBased")},_proto.isTimeBased=function(){abstractMethodFail("isTimeBased")},_proto.baseUnit=function(){abstractMethodFail("baseUnit")},_proto.rangeUnit=function(){abstractMethodFail("rangeUnit")},_proto.range=function(){abstractMethodFail("range")},_proto.rangeRefinedBy=function(temporal){abstractMethodFail("rangeRefinedBy")},_proto.getFrom=function(temporal){abstractMethodFail("getFrom")},_proto.adjustInto=function(temporal,newValue){abstractMethodFail("adjustInto")},_proto.isSupportedBy=function(temporal){abstractMethodFail("isSupportedBy")},_proto.displayName=function(){abstractMethodFail("displayName")},_proto.equals=function(other){abstractMethodFail("equals")},_proto.name=function(){abstractMethodFail("name")},TemporalField}(),ValueRange=function(){function ValueRange(minSmallest,minLargest,maxSmallest,maxLargest){assert(!(minSmallest>minLargest),"Smallest minimum value '"+minSmallest+"' must be less than largest minimum value '"+minLargest+"'",IllegalArgumentException),assert(!(maxSmallest>maxLargest),"Smallest maximum value '"+maxSmallest+"' must be less than largest maximum value '"+maxLargest+"'",IllegalArgumentException),assert(!(minLargest>maxLargest),"Minimum value '"+minLargest+"' must be less than maximum value '"+maxLargest+"'",IllegalArgumentException),this._minSmallest=minSmallest,this._minLargest=minLargest,this._maxLargest=maxLargest,this._maxSmallest=maxSmallest}var _proto=ValueRange.prototype;return _proto.isFixed=function(){return this._minSmallest===this._minLargest&&this._maxSmallest===this._maxLargest},_proto.minimum=function(){return this._minSmallest},_proto.largestMinimum=function(){return this._minLargest},_proto.maximum=function(){return this._maxLargest},_proto.smallestMaximum=function(){return this._maxSmallest},_proto.isValidValue=function(value){return this.minimum()<=value&&value<=this.maximum()},_proto.checkValidValue=function(value,field){return this.isValidValue(value)?value:assert(!1,null!=field?"Invalid value for "+field+" (valid values "+this.toString()+"): "+value:"Invalid value (valid values "+this.toString()+"): "+value,DateTimeException)},_proto.checkValidIntValue=function(value,field){if(!1===this.isValidIntValue(value))throw new DateTimeException("Invalid int value for "+field+": "+value);return value},_proto.isValidIntValue=function(value){return this.isIntValue()&&this.isValidValue(value)},_proto.isIntValue=function(){return this.minimum()>=MathUtil.MIN_SAFE_INTEGER&&this.maximum()<=MathUtil.MAX_SAFE_INTEGER},_proto.equals=function(other){return other===this||other instanceof ValueRange&&(this._minSmallest===other._minSmallest&&this._minLargest===other._minLargest&&this._maxSmallest===other._maxSmallest&&this._maxLargest===other._maxLargest)},_proto.hashCode=function(){return MathUtil.hashCode(this._minSmallest,this._minLargest,this._maxSmallest,this._maxLargest)},_proto.toString=function(){var str=this.minimum()+(this.minimum()!==this.largestMinimum()?"/"+this.largestMinimum():"");return str+=" - ",str+=this.smallestMaximum()+(this.smallestMaximum()!==this.maximum()?"/"+this.maximum():"")},ValueRange.of=function(){return 2===arguments.length?new ValueRange(arguments[0],arguments[0],arguments[1],arguments[1]):3===arguments.length?new ValueRange(arguments[0],arguments[0],arguments[1],arguments[2]):4===arguments.length?new ValueRange(arguments[0],arguments[1],arguments[2],arguments[3]):assert(!1,"Invalid number of arguments "+arguments.length,IllegalArgumentException)},ValueRange}(),ChronoField=function(_TemporalField){function ChronoField(name,baseUnit,rangeUnit,range){var _this;return(_this=_TemporalField.call(this)||this)._name=name,_this._baseUnit=baseUnit,_this._rangeUnit=rangeUnit,_this._range=range,_this}_inheritsLoose(ChronoField,_TemporalField),ChronoField.byName=function(fieldName){for(var prop in ChronoField)if(ChronoField[prop]&&ChronoField[prop]instanceof ChronoField&&ChronoField[prop].name()===fieldName)return ChronoField[prop]};var _proto=ChronoField.prototype;return _proto.name=function(){return this._name},_proto.baseUnit=function(){return this._baseUnit},_proto.rangeUnit=function(){return this._rangeUnit},_proto.range=function(){return this._range},_proto.displayName=function(){return this.toString()},_proto.checkValidValue=function(value){return this.range().checkValidValue(value,this)},_proto.checkValidIntValue=function(value){return this.range().checkValidIntValue(value,this)},_proto.isDateBased=function(){return this===ChronoField.DAY_OF_WEEK||this===ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH||this===ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR||this===ChronoField.DAY_OF_MONTH||this===ChronoField.DAY_OF_YEAR||this===ChronoField.EPOCH_DAY||this===ChronoField.ALIGNED_WEEK_OF_MONTH||this===ChronoField.ALIGNED_WEEK_OF_YEAR||this===ChronoField.MONTH_OF_YEAR||this===ChronoField.PROLEPTIC_MONTH||this===ChronoField.YEAR_OF_ERA||this===ChronoField.YEAR||this===ChronoField.ERA},_proto.isTimeBased=function(){return this===ChronoField.NANO_OF_SECOND||this===ChronoField.NANO_OF_DAY||this===ChronoField.MICRO_OF_SECOND||this===ChronoField.MICRO_OF_DAY||this===ChronoField.MILLI_OF_SECOND||this===ChronoField.MILLI_OF_DAY||this===ChronoField.SECOND_OF_MINUTE||this===ChronoField.SECOND_OF_DAY||this===ChronoField.MINUTE_OF_HOUR||this===ChronoField.MINUTE_OF_DAY||this===ChronoField.HOUR_OF_AMPM||this===ChronoField.CLOCK_HOUR_OF_AMPM||this===ChronoField.HOUR_OF_DAY||this===ChronoField.CLOCK_HOUR_OF_DAY||this===ChronoField.AMPM_OF_DAY},_proto.rangeRefinedBy=function(temporal){return temporal.range(this)},_proto.getFrom=function(temporal){return temporal.getLong(this)},_proto.toString=function(){return this.name()},_proto.equals=function(other){return this===other},_proto.adjustInto=function(temporal,newValue){return temporal.with(this,newValue)},_proto.isSupportedBy=function(temporal){return temporal.isSupported(this)},ChronoField}(TemporalField);
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function _init$k(){ChronoField.NANO_OF_SECOND=new ChronoField("NanoOfSecond",ChronoUnit.NANOS,ChronoUnit.SECONDS,ValueRange.of(0,999999999)),ChronoField.NANO_OF_DAY=new ChronoField("NanoOfDay",ChronoUnit.NANOS,ChronoUnit.DAYS,ValueRange.of(0,86399999999999)),ChronoField.MICRO_OF_SECOND=new ChronoField("MicroOfSecond",ChronoUnit.MICROS,ChronoUnit.SECONDS,ValueRange.of(0,999999)),ChronoField.MICRO_OF_DAY=new ChronoField("MicroOfDay",ChronoUnit.MICROS,ChronoUnit.DAYS,ValueRange.of(0,86399999999)),ChronoField.MILLI_OF_SECOND=new ChronoField("MilliOfSecond",ChronoUnit.MILLIS,ChronoUnit.SECONDS,ValueRange.of(0,999)),ChronoField.MILLI_OF_DAY=new ChronoField("MilliOfDay",ChronoUnit.MILLIS,ChronoUnit.DAYS,ValueRange.of(0,86399999)),ChronoField.SECOND_OF_MINUTE=new ChronoField("SecondOfMinute",ChronoUnit.SECONDS,ChronoUnit.MINUTES,ValueRange.of(0,59)),ChronoField.SECOND_OF_DAY=new ChronoField("SecondOfDay",ChronoUnit.SECONDS,ChronoUnit.DAYS,ValueRange.of(0,86399)),ChronoField.MINUTE_OF_HOUR=new ChronoField("MinuteOfHour",ChronoUnit.MINUTES,ChronoUnit.HOURS,ValueRange.of(0,59)),ChronoField.MINUTE_OF_DAY=new ChronoField("MinuteOfDay",ChronoUnit.MINUTES,ChronoUnit.DAYS,ValueRange.of(0,1439)),ChronoField.HOUR_OF_AMPM=new ChronoField("HourOfAmPm",ChronoUnit.HOURS,ChronoUnit.HALF_DAYS,ValueRange.of(0,11)),ChronoField.CLOCK_HOUR_OF_AMPM=new ChronoField("ClockHourOfAmPm",ChronoUnit.HOURS,ChronoUnit.HALF_DAYS,ValueRange.of(1,12)),ChronoField.HOUR_OF_DAY=new ChronoField("HourOfDay",ChronoUnit.HOURS,ChronoUnit.DAYS,ValueRange.of(0,23)),ChronoField.CLOCK_HOUR_OF_DAY=new ChronoField("ClockHourOfDay",ChronoUnit.HOURS,ChronoUnit.DAYS,ValueRange.of(1,24)),ChronoField.AMPM_OF_DAY=new ChronoField("AmPmOfDay",ChronoUnit.HALF_DAYS,ChronoUnit.DAYS,ValueRange.of(0,1)),ChronoField.DAY_OF_WEEK=new ChronoField("DayOfWeek",ChronoUnit.DAYS,ChronoUnit.WEEKS,ValueRange.of(1,7)),ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH=new ChronoField("AlignedDayOfWeekInMonth",ChronoUnit.DAYS,ChronoUnit.WEEKS,ValueRange.of(1,7)),ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR=new ChronoField("AlignedDayOfWeekInYear",ChronoUnit.DAYS,ChronoUnit.WEEKS,ValueRange.of(1,7)),ChronoField.DAY_OF_MONTH=new ChronoField("DayOfMonth",ChronoUnit.DAYS,ChronoUnit.MONTHS,ValueRange.of(1,28,31),"day"),ChronoField.DAY_OF_YEAR=new ChronoField("DayOfYear",ChronoUnit.DAYS,ChronoUnit.YEARS,ValueRange.of(1,365,366)),ChronoField.EPOCH_DAY=new ChronoField("EpochDay",ChronoUnit.DAYS,ChronoUnit.FOREVER,ValueRange.of(-365961662,364522971)),ChronoField.ALIGNED_WEEK_OF_MONTH=new ChronoField("AlignedWeekOfMonth",ChronoUnit.WEEKS,ChronoUnit.MONTHS,ValueRange.of(1,4,5)),ChronoField.ALIGNED_WEEK_OF_YEAR=new ChronoField("AlignedWeekOfYear",ChronoUnit.WEEKS,ChronoUnit.YEARS,ValueRange.of(1,53)),ChronoField.MONTH_OF_YEAR=new ChronoField("MonthOfYear",ChronoUnit.MONTHS,ChronoUnit.YEARS,ValueRange.of(1,12),"month"),ChronoField.PROLEPTIC_MONTH=new ChronoField("ProlepticMonth",ChronoUnit.MONTHS,ChronoUnit.FOREVER,ValueRange.of(12*YearConstants.MIN_VALUE,12*YearConstants.MAX_VALUE+11)),ChronoField.YEAR_OF_ERA=new ChronoField("YearOfEra",ChronoUnit.YEARS,ChronoUnit.FOREVER,ValueRange.of(1,YearConstants.MAX_VALUE,YearConstants.MAX_VALUE+1)),ChronoField.YEAR=new ChronoField("Year",ChronoUnit.YEARS,ChronoUnit.FOREVER,ValueRange.of(YearConstants.MIN_VALUE,YearConstants.MAX_VALUE),"year"),ChronoField.ERA=new ChronoField("Era",ChronoUnit.ERAS,ChronoUnit.FOREVER,ValueRange.of(0,1)),ChronoField.INSTANT_SECONDS=new ChronoField("InstantSeconds",ChronoUnit.SECONDS,ChronoUnit.FOREVER,ValueRange.of(MIN_SAFE_INTEGER,MAX_SAFE_INTEGER)),ChronoField.OFFSET_SECONDS=new ChronoField("OffsetSeconds",ChronoUnit.SECONDS,ChronoUnit.FOREVER,ValueRange.of(-64800,64800))}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var TemporalQueries=function(){function TemporalQueries(){}return TemporalQueries.zoneId=function(){return TemporalQueries.ZONE_ID},TemporalQueries.chronology=function(){return TemporalQueries.CHRONO},TemporalQueries.precision=function(){return TemporalQueries.PRECISION},TemporalQueries.zone=function(){return TemporalQueries.ZONE},TemporalQueries.offset=function(){return TemporalQueries.OFFSET},TemporalQueries.localDate=function(){return TemporalQueries.LOCAL_DATE},TemporalQueries.localTime=function(){return TemporalQueries.LOCAL_TIME},TemporalQueries}(),TemporalAccessor=function(){function TemporalAccessor(){}var _proto=TemporalAccessor.prototype;return _proto.query=function(_query){return _query===TemporalQueries.zoneId()||_query===TemporalQueries.chronology()||_query===TemporalQueries.precision()?null:_query.queryFrom(this)},_proto.get=function(field){return this.range(field).checkValidIntValue(this.getLong(field),field)},_proto.getLong=function(field){abstractMethodFail("getLong")},_proto.range=function(field){if(field instanceof ChronoField){if(this.isSupported(field))return field.range();throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.rangeRefinedBy(this)},_proto.isSupported=function(field){abstractMethodFail("isSupported")},TemporalAccessor}(),TemporalQuery=function(_Enum){function TemporalQuery(){return _Enum.apply(this,arguments)||this}return _inheritsLoose(TemporalQuery,_Enum),TemporalQuery.prototype.queryFrom=function(temporal){abstractMethodFail("queryFrom")},TemporalQuery}(Enum);
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function createTemporalQuery(name,queryFromFunction){var ExtendedTemporalQuery=function(_TemporalQuery){function ExtendedTemporalQuery(){return _TemporalQuery.apply(this,arguments)||this}return _inheritsLoose(ExtendedTemporalQuery,_TemporalQuery),ExtendedTemporalQuery}(TemporalQuery);return ExtendedTemporalQuery.prototype.queryFrom=queryFromFunction,new ExtendedTemporalQuery(name)}var ENUMS,DayOfWeek=function(_TemporalAccessor){function DayOfWeek(ordinal,name){var _this;return(_this=_TemporalAccessor.call(this)||this)._ordinal=ordinal,_this._name=name,_this}_inheritsLoose(DayOfWeek,_TemporalAccessor);var _proto=DayOfWeek.prototype;return _proto.ordinal=function(){return this._ordinal},_proto.name=function(){return this._name},DayOfWeek.values=function(){return ENUMS.slice()},DayOfWeek.valueOf=function(name){for(var ordinal=0;ordinal<ENUMS.length&&ENUMS[ordinal].name()!==name;ordinal++);return DayOfWeek.of(ordinal+1)},DayOfWeek.of=function(dayOfWeek){if(dayOfWeek<1||dayOfWeek>7)throw new DateTimeException("Invalid value for DayOfWeek: "+dayOfWeek);return ENUMS[dayOfWeek-1]},DayOfWeek.from=function(temporal){if(assert(null!=temporal,"temporal",NullPointerException),temporal instanceof DayOfWeek)return temporal;try{return DayOfWeek.of(temporal.get(ChronoField.DAY_OF_WEEK))}catch(ex){throw ex instanceof DateTimeException?new DateTimeException("Unable to obtain DayOfWeek from TemporalAccessor: "+temporal+", type "+(null!=temporal.constructor?temporal.constructor.name:""),ex):ex}},_proto.value=function(){return this._ordinal+1},_proto.displayName=function(style,locale){throw new IllegalArgumentException("Pattern using (localized) text not implemented yet!")},_proto.isSupported=function(field){return field instanceof ChronoField?field===ChronoField.DAY_OF_WEEK:null!=field&&field.isSupportedBy(this)},_proto.range=function(field){if(field===ChronoField.DAY_OF_WEEK)return field.range();if(field instanceof ChronoField)throw new UnsupportedTemporalTypeException("Unsupported field: "+field);return field.rangeRefinedBy(this)},_proto.get=function(field){return field===ChronoField.DAY_OF_WEEK?this.value():this.range(field).checkValidIntValue(this.getLong(field),field)},_proto.getLong=function(field){if(field===ChronoField.DAY_OF_WEEK)return this.value();if(field instanceof ChronoField)throw new UnsupportedTemporalTypeException("Unsupported field: "+field);return field.getFrom(this)},_proto.plus=function(days){var amount=MathUtil.floorMod(days,7);return ENUMS[MathUtil.floorMod(this._ordinal+(amount+7),7)]},_proto.minus=function(days){return this.plus(-1*MathUtil.floorMod(days,7))},_proto.query=function(_query){return _query===TemporalQueries.precision()?ChronoUnit.DAYS:_query===TemporalQueries.localDate()||_query===TemporalQueries.localTime()||_query===TemporalQueries.chronology()||_query===TemporalQueries.zone()||_query===TemporalQueries.zoneId()||_query===TemporalQueries.offset()?null:(assert(null!=_query,"query",NullPointerException),_query.queryFrom(this))},_proto.adjustInto=function(temporal){return requireNonNull(temporal,"temporal"),temporal.with(ChronoField.DAY_OF_WEEK,this.value())},_proto.equals=function(other){return this===other},_proto.toString=function(){return this._name},_proto.compareTo=function(other){return requireNonNull(other,"other"),requireInstance(other,DayOfWeek,"other"),this._ordinal-other._ordinal},_proto.toJSON=function(){return this.toString()},DayOfWeek}(TemporalAccessor);function _init$j(){DayOfWeek.MONDAY=new DayOfWeek(0,"MONDAY"),DayOfWeek.TUESDAY=new DayOfWeek(1,"TUESDAY"),DayOfWeek.WEDNESDAY=new DayOfWeek(2,"WEDNESDAY"),DayOfWeek.THURSDAY=new DayOfWeek(3,"THURSDAY"),DayOfWeek.FRIDAY=new DayOfWeek(4,"FRIDAY"),DayOfWeek.SATURDAY=new DayOfWeek(5,"SATURDAY"),DayOfWeek.SUNDAY=new DayOfWeek(6,"SUNDAY"),DayOfWeek.FROM=createTemporalQuery("DayOfWeek.FROM",(function(temporal){return DayOfWeek.from(temporal)})),ENUMS=[DayOfWeek.MONDAY,DayOfWeek.TUESDAY,DayOfWeek.WEDNESDAY,DayOfWeek.THURSDAY,DayOfWeek.FRIDAY,DayOfWeek.SATURDAY,DayOfWeek.SUNDAY]}var MONTHS,Month=function(_TemporalAccessor){function Month(value,name){var _this;return(_this=_TemporalAccessor.call(this)||this)._value=MathUtil.safeToInt(value),_this._name=name,_this}_inheritsLoose(Month,_TemporalAccessor);var _proto=Month.prototype;return _proto.value=function(){return this._value},_proto.ordinal=function(){return this._value-1},_proto.name=function(){return this._name},_proto.displayName=function(style,locale){throw new IllegalArgumentException("Pattern using (localized) text not implemented yet!")},_proto.isSupported=function(field){return null!==field&&(field instanceof ChronoField?field===ChronoField.MONTH_OF_YEAR:null!=field&&field.isSupportedBy(this))},_proto.get=function(field){return field===ChronoField.MONTH_OF_YEAR?this.value():this.range(field).checkValidIntValue(this.getLong(field),field)},_proto.getLong=function(field){if(field===ChronoField.MONTH_OF_YEAR)return this.value();if(field instanceof ChronoField)throw new UnsupportedTemporalTypeException("Unsupported field: "+field);return field.getFrom(this)},_proto.plus=function(months){var amount=MathUtil.intMod(months,12)+12,newMonthVal=MathUtil.intMod(this.value()+amount,12);return newMonthVal=0===newMonthVal?12:newMonthVal,Month.of(newMonthVal)},_proto.minus=function(months){return this.plus(-1*MathUtil.intMod(months,12))},_proto.length=function(leapYear){switch(this){case Month.FEBRUARY:return leapYear?29:28;case Month.APRIL:case Month.JUNE:case Month.SEPTEMBER:case Month.NOVEMBER:return 30;default:return 31}},_proto.minLength=function(){switch(this){case Month.FEBRUARY:return 28;case Month.APRIL:case Month.JUNE:case Month.SEPTEMBER:case Month.NOVEMBER:return 30;default:return 31}},_proto.maxLength=function(){switch(this){case Month.FEBRUARY:return 29;case Month.APRIL:case Month.JUNE:case Month.SEPTEMBER:case Month.NOVEMBER:return 30;default:return 31}},_proto.firstDayOfYear=function(leapYear){var leap=leapYear?1:0;switch(this){case Month.JANUARY:return 1;case Month.FEBRUARY:return 32;case Month.MARCH:return 60+leap;case Month.APRIL:return 91+leap;case Month.MAY:return 121+leap;case Month.JUNE:return 152+leap;case Month.JULY:return 182+leap;case Month.AUGUST:return 213+leap;case Month.SEPTEMBER:return 244+leap;case Month.OCTOBER:return 274+leap;case Month.NOVEMBER:return 305+leap;case Month.DECEMBER:default:return 335+leap}},_proto.firstMonthOfQuarter=function(){switch(this){case Month.JANUARY:case Month.FEBRUARY:case Month.MARCH:return Month.JANUARY;case Month.APRIL:case Month.MAY:case Month.JUNE:return Month.APRIL;case Month.JULY:case Month.AUGUST:case Month.SEPTEMBER:return Month.JULY;case Month.OCTOBER:case Month.NOVEMBER:case Month.DECEMBER:default:return Month.OCTOBER}},_proto.query=function(_query){return assert(null!=_query,"query() parameter must not be null",DateTimeException),_query===TemporalQueries.chronology()?IsoChronology.INSTANCE:_query===TemporalQueries.precision()?ChronoUnit.MONTHS:_TemporalAccessor.prototype.query.call(this,_query)},_proto.toString=function(){switch(this){case Month.JANUARY:return"JANUARY";case Month.FEBRUARY:return"FEBRUARY";case Month.MARCH:return"MARCH";case Month.APRIL:return"APRIL";case Month.MAY:return"MAY";case Month.JUNE:return"JUNE";case Month.JULY:return"JULY";case Month.AUGUST:return"AUGUST";case Month.SEPTEMBER:return"SEPTEMBER";case Month.OCTOBER:return"OCTOBER";case Month.NOVEMBER:return"NOVEMBER";case Month.DECEMBER:return"DECEMBER";default:return"unknown Month, value: "+this.value()}},_proto.toJSON=function(){return this.toString()},_proto.adjustInto=function(temporal){return temporal.with(ChronoField.MONTH_OF_YEAR,this.value())},_proto.compareTo=function(other){return requireNonNull(other,"other"),requireInstance(other,Month,"other"),this._value-other._value},_proto.equals=function(other){return this===other},Month.valueOf=function(name){for(var ordinal=0;ordinal<MONTHS.length&&MONTHS[ordinal].name()!==name;ordinal++);return Month.of(ordinal+1)},Month.values=function(){return MONTHS.slice()},Month.of=function(month){return(month<1||month>12)&&assert(!1,"Invalid value for MonthOfYear: "+month,DateTimeException),MONTHS[month-1]},Month.from=function(temporal){if(temporal instanceof Month)return temporal;try{return Month.of(temporal.get(ChronoField.MONTH_OF_YEAR))}catch(ex){throw new DateTimeException("Unable to obtain Month from TemporalAccessor: "+temporal+" of type "+(temporal&&null!=temporal.constructor?temporal.constructor.name:""),ex)}},Month}(TemporalAccessor);function _init$i(){Month.JANUARY=new Month(1,"JANUARY"),Month.FEBRUARY=new Month(2,"FEBRUARY"),Month.MARCH=new Month(3,"MARCH"),Month.APRIL=new Month(4,"APRIL"),Month.MAY=new Month(5,"MAY"),Month.JUNE=new Month(6,"JUNE"),Month.JULY=new Month(7,"JULY"),Month.AUGUST=new Month(8,"AUGUST"),Month.SEPTEMBER=new Month(9,"SEPTEMBER"),Month.OCTOBER=new Month(10,"OCTOBER"),Month.NOVEMBER=new Month(11,"NOVEMBER"),Month.DECEMBER=new Month(12,"DECEMBER"),MONTHS=[Month.JANUARY,Month.FEBRUARY,Month.MARCH,Month.APRIL,Month.MAY,Month.JUNE,Month.JULY,Month.AUGUST,Month.SEPTEMBER,Month.OCTOBER,Month.NOVEMBER,Month.DECEMBER]}var PATTERN=/([-+]?)P(?:([-+]?[0-9]+)Y)?(?:([-+]?[0-9]+)M)?(?:([-+]?[0-9]+)W)?(?:([-+]?[0-9]+)D)?/,Period=function(_TemporalAmount){function Period(years,months,days){var _this;_this=_TemporalAmount.call(this)||this;var _years=MathUtil.safeToInt(years),_months=MathUtil.safeToInt(months),_days=MathUtil.safeToInt(days);return 0===_years&&0===_months&&0===_days?(Period.ZERO||(_this._years=_years,_this._months=_months,_this._days=_days,Period.ZERO=_assertThisInitialized(_this)),Period.ZERO||_assertThisInitialized(_this)):(_this._years=_years,_this._months=_months,_this._days=_days,_this)}_inheritsLoose(Period,_TemporalAmount),Period.ofYears=function(years){return Period.create(years,0,0)},Period.ofMonths=function(months){return Period.create(0,months,0)},Period.ofWeeks=function(weeks){return Period.create(0,0,MathUtil.safeMultiply(weeks,7))},Period.ofDays=function(days){return Period.create(0,0,days)},Period.of=function(years,months,days){return Period.create(years,months,days)},Period.from=function(amount){if(amount instanceof Period)return amount;requireNonNull(amount,"amount");for(var years=0,months=0,days=0,units=amount.units(),i=0;i<units.length;i++){var unit=units[i],unitAmount=amount.get(unit);if(unit===ChronoUnit.YEARS)years=MathUtil.safeToInt(unitAmount);else if(unit===ChronoUnit.MONTHS)months=MathUtil.safeToInt(unitAmount);else{if(unit!==ChronoUnit.DAYS)throw new DateTimeException("Unit must be Years, Months or Days, but was "+unit);days=MathUtil.safeToInt(unitAmount)}}return Period.create(years,months,days)},Period.between=function(startDate,endDate){return requireNonNull(startDate,"startDate"),requireNonNull(endDate,"endDate"),requireInstance(startDate,LocalDate,"startDate"),requireInstance(endDate,LocalDate,"endDate"),startDate.until(endDate)},Period.parse=function(text){requireNonNull(text,"text");try{return Period._parse(text)}catch(ex){throw ex instanceof ArithmeticException?new DateTimeParseException("Text cannot be parsed to a Period",text,0,ex):ex}},Period._parse=function(text){var matches=PATTERN.exec(text);if(null!=matches){var negate="-"===matches[1]?-1:1,yearMatch=matches[2],monthMatch=matches[3],weekMatch=matches[4],dayMatch=matches[5];if(null!=yearMatch||null!=monthMatch||null!=weekMatch||null!=dayMatch){var years=Period._parseNumber(text,yearMatch,negate),months=Period._parseNumber(text,monthMatch,negate),weeks=Period._parseNumber(text,weekMatch,negate),days=Period._parseNumber(text,dayMatch,negate);return days=MathUtil.safeAdd(days,MathUtil.safeMultiply(weeks,7)),Period.create(years,months,days)}}throw new DateTimeParseException("Text cannot be parsed to a Period",text,0)},Period._parseNumber=function(text,str,negate){if(null==str)return 0;var val=MathUtil.parseInt(str);return MathUtil.safeMultiply(val,negate)},Period.create=function(years,months,days){return new Period(years,months,days)};var _proto=Period.prototype;return _proto.units=function(){return[ChronoUnit.YEARS,ChronoUnit.MONTHS,ChronoUnit.DAYS]},_proto.chronology=function(){return IsoChronology.INSTANCE},_proto.get=function(unit){if(unit===ChronoUnit.YEARS)return this._years;if(unit===ChronoUnit.MONTHS)return this._months;if(unit===ChronoUnit.DAYS)return this._days;throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)},_proto.isZero=function(){return this===Period.ZERO},_proto.isNegative=function(){return this._years<0||this._months<0||this._days<0},_proto.years=function(){return this._years},_proto.months=function(){return this._months},_proto.days=function(){return this._days},_proto.withYears=function(years){return years===this._years?this:Period.create(years,this._months,this._days)},_proto.withMonths=function(months){return months===this._months?this:Period.create(this._years,months,this._days)},_proto.withDays=function(days){return days===this._days?this:Period.create(this._years,this._months,days)},_proto.plus=function(amountToAdd){var amount=Period.from(amountToAdd);return Period.create(MathUtil.safeAdd(this._years,amount._years),MathUtil.safeAdd(this._months,amount._months),MathUtil.safeAdd(this._days,amount._days))},_proto.plusYears=function(yearsToAdd){return 0===yearsToAdd?this:Period.create(MathUtil.safeToInt(MathUtil.safeAdd(this._years,yearsToAdd)),this._months,this._days)},_proto.plusMonths=function(monthsToAdd){return 0===monthsToAdd?this:Period.create(this._years,MathUtil.safeToInt(MathUtil.safeAdd(this._months,monthsToAdd)),this._days)},_proto.plusDays=function(daysToAdd){return 0===daysToAdd?this:Period.create(this._years,this._months,MathUtil.safeToInt(MathUtil.safeAdd(this._days,daysToAdd)))},_proto.minus=function(amountToSubtract){var amount=Period.from(amountToSubtract);return Period.create(MathUtil.safeSubtract(this._years,amount._years),MathUtil.safeSubtract(this._months,amount._months),MathUtil.safeSubtract(this._days,amount._days))},_proto.minusYears=function(yearsToSubtract){return this.plusYears(-1*yearsToSubtract)},_proto.minusMonths=function(monthsToSubtract){return this.plusMonths(-1*monthsToSubtract)},_proto.minusDays=function(daysToSubtract){return this.plusDays(-1*daysToSubtract)},_proto.multipliedBy=function(scalar){return this===Period.ZERO||1===scalar?this:Period.create(MathUtil.safeMultiply(this._years,scalar),MathUtil.safeMultiply(this._months,scalar),MathUtil.safeMultiply(this._days,scalar))},_proto.negated=function(){return this.multipliedBy(-1)},_proto.normalized=function(){var totalMonths=this.toTotalMonths(),splitYears=MathUtil.intDiv(totalMonths,12),splitMonths=MathUtil.intMod(totalMonths,12);return splitYears===this._years&&splitMonths===this._months?this:Period.create(MathUtil.safeToInt(splitYears),splitMonths,this._days)},_proto.toTotalMonths=function(){return 12*this._years+this._months},_proto.addTo=function(temporal){return requireNonNull(temporal,"temporal"),0!==this._years?temporal=0!==this._months?temporal.plus(this.toTotalMonths(),ChronoUnit.MONTHS):temporal.plus(this._years,ChronoUnit.YEARS):0!==this._months&&(temporal=temporal.plus(this._months,ChronoUnit.MONTHS)),0!==this._days&&(temporal=temporal.plus(this._days,ChronoUnit.DAYS)),temporal},_proto.subtractFrom=function(temporal){return requireNonNull(temporal,"temporal"),0!==this._years?temporal=0!==this._months?temporal.minus(this.toTotalMonths(),ChronoUnit.MONTHS):temporal.minus(this._years,ChronoUnit.YEARS):0!==this._months&&(temporal=temporal.minus(this._months,ChronoUnit.MONTHS)),0!==this._days&&(temporal=temporal.minus(this._days,ChronoUnit.DAYS)),temporal},_proto.equals=function(obj){if(this===obj)return!0;if(obj instanceof Period){var other=obj;return this._years===other._years&&this._months===other._months&&this._days===other._days}return!1},_proto.hashCode=function(){return MathUtil.hashCode(this._years,this._months,this._days)},_proto.toString=function(){if(this===Period.ZERO)return"P0D";var buf="P";return 0!==this._years&&(buf+=this._years+"Y"),0!==this._months&&(buf+=this._months+"M"),0!==this._days&&(buf+=this._days+"D"),buf},_proto.toJSON=function(){return this.toString()},Period}(TemporalAmount);function _init$h(){Period.ofDays(0)}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var ParsePosition=function(){function ParsePosition(index){this._index=index,this._errorIndex=-1}var _proto=ParsePosition.prototype;return _proto.getIndex=function(){return this._index},_proto.setIndex=function(index){this._index=index},_proto.getErrorIndex=function(){return this._errorIndex},_proto.setErrorIndex=function(errorIndex){this._errorIndex=errorIndex},ParsePosition}(),EnumMap=function(){function EnumMap(){this._map={}}var _proto=EnumMap.prototype;return _proto.putAll=function(otherMap){for(var key in otherMap._map)this._map[key]=otherMap._map[key];return this},_proto.containsKey=function(key){return this._map.hasOwnProperty(key.name())&&void 0!==this.get(key)},_proto.get=function(key){return this._map[key.name()]},_proto.put=function(key,val){return this.set(key,val)},_proto.set=function(key,val){return this._map[key.name()]=val,this},_proto.retainAll=function(keyList){for(var map={},i=0;i<keyList.length;i++){var key=keyList[i].name();map[key]=this._map[key]}return this._map=map,this},_proto.remove=function(key){var keyName=key.name(),val=this._map[keyName];return this._map[keyName]=void 0,val},_proto.keySet=function(){return this._map},_proto.clear=function(){this._map={}},EnumMap}(),ResolverStyle=function(_Enum){function ResolverStyle(){return _Enum.apply(this,arguments)||this}return _inheritsLoose(ResolverStyle,_Enum),ResolverStyle}(Enum);
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */ResolverStyle.STRICT=new ResolverStyle("STRICT"),ResolverStyle.SMART=new ResolverStyle("SMART"),ResolverStyle.LENIENT=new ResolverStyle("LENIENT");var Temporal=function(_TemporalAccessor){function Temporal(){return _TemporalAccessor.apply(this,arguments)||this}_inheritsLoose(Temporal,_TemporalAccessor);var _proto=Temporal.prototype;return _proto.isSupported=function(fieldOrUnit){abstractMethodFail("isSupported")},_proto.minus=function(amount,unit){return arguments.length<2?this._minusAmount(amount):this._minusUnit(amount,unit)},_proto._minusAmount=function(amount){return requireNonNull(amount,"amount"),requireInstance(amount,TemporalAmount,"amount"),amount.subtractFrom(this)},_proto._minusUnit=function(amountToSubtract,unit){return requireNonNull(amountToSubtract,"amountToSubtract"),requireNonNull(unit,"unit"),requireInstance(unit,TemporalUnit,"unit"),this._plusUnit(-amountToSubtract,unit)},_proto.plus=function(amount,unit){return arguments.length<2?this._plusAmount(amount):this._plusUnit(amount,unit)},_proto._plusAmount=function(amount){return requireNonNull(amount,"amount"),requireInstance(amount,TemporalAmount,"amount"),amount.addTo(this)},_proto._plusUnit=function(amountToAdd,unit){abstractMethodFail("_plusUnit")},_proto.until=function(endTemporal,unit){abstractMethodFail("until")},_proto.with=function(adjusterOrField,newValue){return arguments.length<2?this._withAdjuster(adjusterOrField):this._withField(adjusterOrField,newValue)},_proto._withAdjuster=function(adjuster){return requireNonNull(adjuster,"adjuster"),assert("function"==typeof adjuster.adjustInto,"adjuster must be a TemporalAdjuster",IllegalArgumentException),adjuster.adjustInto(this)},_proto._withField=function(field,newValue){abstractMethodFail("_withField")},Temporal}(TemporalAccessor);"undefined"!=typeof Symbol&&Symbol.toPrimitive&&(Temporal.prototype[Symbol.toPrimitive]=function(hint){if("number"!==hint)return this.toString();throw new TypeError("A conversion from Temporal to a number is not allowed. To compare use the methods .equals(), .compareTo(), .isBefore() or one that is more suitable to your use case.")});var ChronoLocalDate=function(_Temporal){function ChronoLocalDate(){return _Temporal.apply(this,arguments)||this}_inheritsLoose(ChronoLocalDate,_Temporal);var _proto=ChronoLocalDate.prototype;return _proto.isSupported=function(fieldOrUnit){return fieldOrUnit instanceof ChronoField||fieldOrUnit instanceof ChronoUnit?fieldOrUnit.isDateBased():null!=fieldOrUnit&&fieldOrUnit.isSupportedBy(this)},_proto.query=function(_query){return _query===TemporalQueries.chronology()?this.chronology():_query===TemporalQueries.precision()?ChronoUnit.DAYS:_query===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toEpochDay()):_query===TemporalQueries.localTime()||_query===TemporalQueries.zone()||_query===TemporalQueries.zoneId()||_query===TemporalQueries.offset()?null:_Temporal.prototype.query.call(this,_query)},_proto.adjustInto=function(temporal){return temporal.with(ChronoField.EPOCH_DAY,this.toEpochDay())},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),requireInstance(formatter,DateTimeFormatter,"formatter"),formatter.format(this)},ChronoLocalDate}(Temporal),StringUtil=function(){function StringUtil(){}return StringUtil.startsWith=function(text,pattern){return 0===text.indexOf(pattern)},StringUtil.hashCode=function(text){var len=text.length;if(0===len)return 0;for(var hash=0,i=0;i<len;i++){hash=(hash<<5)-hash+text.charCodeAt(i),hash|=0}return MathUtil.smi(hash)},StringUtil}(),ZoneId=function(){function ZoneId(){}ZoneId.systemDefault=function(){throw new DateTimeException("not supported operation")},ZoneId.getAvailableZoneIds=function(){throw new DateTimeException("not supported operation")},ZoneId.of=function(zoneId){throw new DateTimeException("not supported operation"+zoneId)},ZoneId.ofOffset=function(prefix,offset){throw new DateTimeException("not supported operation"+prefix+offset)},ZoneId.from=function(temporal){throw new DateTimeException("not supported operation"+temporal)};var _proto=ZoneId.prototype;return _proto.id=function(){abstractMethodFail("ZoneId.id")},_proto.rules=function(){abstractMethodFail("ZoneId.rules")},_proto.normalized=function(){var rules=this.rules();return rules.isFixedOffset()?rules.offset(Instant.EPOCH):this},_proto.equals=function(other){return this===other||other instanceof ZoneId&&this.id()===other.id()},_proto.hashCode=function(){return StringUtil.hashCode(this.id())},_proto.toString=function(){return this.id()},_proto.toJSON=function(){return this.toString()},ZoneId}(),ZoneRules=function(){function ZoneRules(){}ZoneRules.of=function(offset){return requireNonNull(offset,"offset"),new Fixed(offset)};var _proto=ZoneRules.prototype;return _proto.isFixedOffset=function(){abstractMethodFail("ZoneRules.isFixedOffset")},_proto.offset=function(instantOrLocalDateTime){return instantOrLocalDateTime instanceof Instant?this.offsetOfInstant(instantOrLocalDateTime):this.offsetOfLocalDateTime(instantOrLocalDateTime)},_proto.offsetOfInstant=function(instant){abstractMethodFail("ZoneRules.offsetInstant")},_proto.offsetOfEpochMilli=function(epochMilli){abstractMethodFail("ZoneRules.offsetOfEpochMilli")},_proto.offsetOfLocalDateTime=function(localDateTime){abstractMethodFail("ZoneRules.offsetLocalDateTime")},_proto.validOffsets=function(localDateTime){abstractMethodFail("ZoneRules.validOffsets")},_proto.transition=function(localDateTime){abstractMethodFail("ZoneRules.transition")},_proto.standardOffset=function(instant){abstractMethodFail("ZoneRules.standardOffset")},_proto.daylightSavings=function(instant){abstractMethodFail("ZoneRules.daylightSavings")},_proto.isDaylightSavings=function(instant){abstractMethodFail("ZoneRules.isDaylightSavings")},_proto.isValidOffset=function(localDateTime,offset){abstractMethodFail("ZoneRules.isValidOffset")},_proto.nextTransition=function(instant){abstractMethodFail("ZoneRules.nextTransition")},_proto.previousTransition=function(instant){abstractMethodFail("ZoneRules.previousTransition")},_proto.transitions=function(){abstractMethodFail("ZoneRules.transitions")},_proto.transitionRules=function(){abstractMethodFail("ZoneRules.transitionRules")},_proto.toString=function(){abstractMethodFail("ZoneRules.toString")},_proto.toJSON=function(){return this.toString()},ZoneRules}(),Fixed=function(_ZoneRules){function Fixed(offset){var _this;return(_this=_ZoneRules.call(this)||this)._offset=offset,_this}_inheritsLoose(Fixed,_ZoneRules);var _proto2=Fixed.prototype;return _proto2.isFixedOffset=function(){return!0},_proto2.offsetOfInstant=function(){return this._offset},_proto2.offsetOfEpochMilli=function(){return this._offset},_proto2.offsetOfLocalDateTime=function(){return this._offset},_proto2.validOffsets=function(){return[this._offset]},_proto2.transition=function(){return null},_proto2.standardOffset=function(){return this._offset},_proto2.daylightSavings=function(){return Duration.ZERO},_proto2.isDaylightSavings=function(){return!1},_proto2.isValidOffset=function(localDateTime,offset){return this._offset.equals(offset)},_proto2.nextTransition=function(){return null},_proto2.previousTransition=function(){return null},_proto2.transitions=function(){return[]},_proto2.transitionRules=function(){return[]},_proto2.equals=function(other){return this===other||other instanceof Fixed&&this._offset.equals(other._offset)},_proto2.toString=function(){return"FixedRules:"+this._offset.toString()},Fixed}(ZoneRules),SECONDS_CACHE={},ID_CACHE={},ZoneOffset=function(_ZoneId){function ZoneOffset(totalSeconds){var _this;return _this=_ZoneId.call(this)||this,ZoneOffset._validateTotalSeconds(totalSeconds),_this._totalSeconds=MathUtil.safeToInt(totalSeconds),_this._rules=ZoneRules.of(_assertThisInitialized(_this)),_this._id=ZoneOffset._buildId(totalSeconds),_this}_inheritsLoose(ZoneOffset,_ZoneId);var _proto=ZoneOffset.prototype;return _proto.totalSeconds=function(){return this._totalSeconds},_proto.id=function(){return this._id},ZoneOffset._buildId=function(totalSeconds){if(0===totalSeconds)return"Z";var absTotalSeconds=Math.abs(totalSeconds),absHours=MathUtil.intDiv(absTotalSeconds,LocalTime.SECONDS_PER_HOUR),absMinutes=MathUtil.intMod(MathUtil.intDiv(absTotalSeconds,LocalTime.SECONDS_PER_MINUTE),LocalTime.MINUTES_PER_HOUR),buf=(totalSeconds<0?"-":"+")+(absHours<10?"0":"")+absHours+(absMinutes<10?":0":":")+absMinutes,absSeconds=MathUtil.intMod(absTotalSeconds,LocalTime.SECONDS_PER_MINUTE);return 0!==absSeconds&&(buf+=(absSeconds<10?":0":":")+absSeconds),buf},ZoneOffset._validateTotalSeconds=function(totalSeconds){if(Math.abs(totalSeconds)>ZoneOffset.MAX_SECONDS)throw new DateTimeException("Zone offset not in valid range: -18:00 to +18:00")},ZoneOffset._validate=function(hours,minutes,seconds){if(hours<-18||hours>18)throw new DateTimeException("Zone offset hours not in valid range: value "+hours+" is not in the range -18 to 18");if(hours>0){if(minutes<0||seconds<0)throw new DateTimeException("Zone offset minutes and seconds must be positive because hours is positive")}else if(hours<0){if(minutes>0||seconds>0)throw new DateTimeException("Zone offset minutes and seconds must be negative because hours is negative")}else if(minutes>0&&seconds<0||minutes<0&&seconds>0)throw new DateTimeException("Zone offset minutes and seconds must have the same sign");if(Math.abs(minutes)>59)throw new DateTimeException("Zone offset minutes not in valid range: abs(value) "+Math.abs(minutes)+" is not in the range 0 to 59");if(Math.abs(seconds)>59)throw new DateTimeException("Zone offset seconds not in valid range: abs(value) "+Math.abs(seconds)+" is not in the range 0 to 59");if(18===Math.abs(hours)&&(Math.abs(minutes)>0||Math.abs(seconds)>0))throw new DateTimeException("Zone offset not in valid range: -18:00 to +18:00")},ZoneOffset.of=function(offsetId){requireNonNull(offsetId,"offsetId");var hours,minutes,seconds,offset=ID_CACHE[offsetId];if(null!=offset)return offset;switch(offsetId.length){case 2:offsetId=offsetId[0]+"0"+offsetId[1];case 3:hours=ZoneOffset._parseNumber(offsetId,1,!1),minutes=0,seconds=0;break;case 5:hours=ZoneOffset._parseNumber(offsetId,1,!1),minutes=ZoneOffset._parseNumber(offsetId,3,!1),seconds=0;break;case 6:hours=ZoneOffset._parseNumber(offsetId,1,!1),minutes=ZoneOffset._parseNumber(offsetId,4,!0),seconds=0;break;case 7:hours=ZoneOffset._parseNumber(offsetId,1,!1),minutes=ZoneOffset._parseNumber(offsetId,3,!1),seconds=ZoneOffset._parseNumber(offsetId,5,!1);break;case 9:hours=ZoneOffset._parseNumber(offsetId,1,!1),minutes=ZoneOffset._parseNumber(offsetId,4,!0),seconds=ZoneOffset._parseNumber(offsetId,7,!0);break;default:throw new DateTimeException("Invalid ID for ZoneOffset, invalid format: "+offsetId)}var first=offsetId[0];if("+"!==first&&"-"!==first)throw new DateTimeException("Invalid ID for ZoneOffset, plus/minus not found when expected: "+offsetId);return"-"===first?ZoneOffset.ofHoursMinutesSeconds(-hours,-minutes,-seconds):ZoneOffset.ofHoursMinutesSeconds(hours,minutes,seconds)},ZoneOffset._parseNumber=function(offsetId,pos,precededByColon){if(precededByColon&&":"!==offsetId[pos-1])throw new DateTimeException("Invalid ID for ZoneOffset, colon not found when expected: "+offsetId);var ch1=offsetId[pos],ch2=offsetId[pos+1];if(ch1<"0"||ch1>"9"||ch2<"0"||ch2>"9")throw new DateTimeException("Invalid ID for ZoneOffset, non numeric characters found: "+offsetId);return 10*(ch1.charCodeAt(0)-48)+(ch2.charCodeAt(0)-48)},ZoneOffset.ofHours=function(hours){return ZoneOffset.ofHoursMinutesSeconds(hours,0,0)},ZoneOffset.ofHoursMinutes=function(hours,minutes){return ZoneOffset.ofHoursMinutesSeconds(hours,minutes,0)},ZoneOffset.ofHoursMinutesSeconds=function(hours,minutes,seconds){ZoneOffset._validate(hours,minutes,seconds);var totalSeconds=hours*LocalTime.SECONDS_PER_HOUR+minutes*LocalTime.SECONDS_PER_MINUTE+seconds;return ZoneOffset.ofTotalSeconds(totalSeconds)},ZoneOffset.ofTotalMinutes=function(totalMinutes){var totalSeconds=totalMinutes*LocalTime.SECONDS_PER_MINUTE;return ZoneOffset.ofTotalSeconds(totalSeconds)},ZoneOffset.ofTotalSeconds=function(totalSeconds){if(totalSeconds%(15*LocalTime.SECONDS_PER_MINUTE)==0){var totalSecs=totalSeconds,result=SECONDS_CACHE[totalSecs];return null==result&&(result=new ZoneOffset(totalSeconds),SECONDS_CACHE[totalSecs]=result,ID_CACHE[result.id()]=result),result}return new ZoneOffset(totalSeconds)},_proto.rules=function(){return this._rules},_proto.get=function(field){return this.getLong(field)},_proto.getLong=function(field){if(field===ChronoField.OFFSET_SECONDS)return this._totalSeconds;if(field instanceof ChronoField)throw new DateTimeException("Unsupported field: "+field);return field.getFrom(this)},_proto.query=function(_query){return requireNonNull(_query,"query"),_query===TemporalQueries.offset()||_query===TemporalQueries.zone()?this:_query===TemporalQueries.localDate()||_query===TemporalQueries.localTime()||_query===TemporalQueries.precision()||_query===TemporalQueries.chronology()||_query===TemporalQueries.zoneId()?null:_query.queryFrom(this)},_proto.adjustInto=function(temporal){return temporal.with(ChronoField.OFFSET_SECONDS,this._totalSeconds)},_proto.compareTo=function(other){return requireNonNull(other,"other"),other._totalSeconds-this._totalSeconds},_proto.equals=function(obj){return this===obj||obj instanceof ZoneOffset&&this._totalSeconds===obj._totalSeconds},_proto.hashCode=function(){return this._totalSeconds},_proto.toString=function(){return this._id},ZoneOffset}(ZoneId);
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function _init$g(){ZoneOffset.MAX_SECONDS=18*LocalTime.SECONDS_PER_HOUR,ZoneOffset.UTC=ZoneOffset.ofTotalSeconds(0),ZoneOffset.MIN=ZoneOffset.ofTotalSeconds(-ZoneOffset.MAX_SECONDS),ZoneOffset.MAX=ZoneOffset.ofTotalSeconds(ZoneOffset.MAX_SECONDS)}var DateTimeBuilder=function(_TemporalAccessor){function DateTimeBuilder(){var _this;return(_this=_TemporalAccessor.call(this)||this).fieldValues=new EnumMap,_this.chrono=null,_this.zone=null,_this.date=null,_this.time=null,_this.leapSecond=!1,_this.excessDays=null,_this}_inheritsLoose(DateTimeBuilder,_TemporalAccessor),DateTimeBuilder.create=function(field,value){var dtb=new DateTimeBuilder;return dtb._addFieldValue(field,value),dtb};var _proto=DateTimeBuilder.prototype;return _proto.getFieldValue0=function(field){return this.fieldValues.get(field)},_proto._addFieldValue=function(field,value){requireNonNull(field,"field");var old=this.getFieldValue0(field);if(null!=old&&old!==value)throw new DateTimeException("Conflict found: "+field+" "+old+" differs from "+field+" "+value+": "+this);return this._putFieldValue0(field,value)},_proto._putFieldValue0=function(field,value){return this.fieldValues.put(field,value),this},_proto.resolve=function(resolverStyle,resolverFields){return null!=resolverFields&&this.fieldValues.retainAll(resolverFields),this._mergeDate(resolverStyle),this._mergeTime(resolverStyle),this._resolveTimeInferZeroes(resolverStyle),null!=this.excessDays&&!1===this.excessDays.isZero()&&null!=this.date&&null!=this.time&&(this.date=this.date.plus(this.excessDays),this.excessDays=Period.ZERO),this._resolveInstant(),this},_proto._mergeDate=function(resolverStyle){this._checkDate(IsoChronology.INSTANCE.resolveDate(this.fieldValues,resolverStyle))},_proto._checkDate=function(date){if(null!=date)for(var fieldName in this._addObject(date),this.fieldValues.keySet()){var field=ChronoField.byName(fieldName);if(field&&void 0!==this.fieldValues.get(field)&&field.isDateBased()){var val1=void 0;try{val1=date.getLong(field)}catch(ex){if(ex instanceof DateTimeException)continue;throw ex}var val2=this.fieldValues.get(field);if(val1!==val2)throw new DateTimeException("Conflict found: Field "+field+" "+val1+" differs from "+field+" "+val2+" derived from "+date)}}},_proto._mergeTime=function(resolverStyle){if(this.fieldValues.containsKey(ChronoField.CLOCK_HOUR_OF_DAY)){var ch=this.fieldValues.remove(ChronoField.CLOCK_HOUR_OF_DAY);resolverStyle!==ResolverStyle.LENIENT&&(resolverStyle===ResolverStyle.SMART&&0===ch||ChronoField.CLOCK_HOUR_OF_DAY.checkValidValue(ch)),this._addFieldValue(ChronoField.HOUR_OF_DAY,24===ch?0:ch)}if(this.fieldValues.containsKey(ChronoField.CLOCK_HOUR_OF_AMPM)){var _ch=this.fieldValues.remove(ChronoField.CLOCK_HOUR_OF_AMPM);resolverStyle!==ResolverStyle.LENIENT&&(resolverStyle===ResolverStyle.SMART&&0===_ch||ChronoField.CLOCK_HOUR_OF_AMPM.checkValidValue(_ch)),this._addFieldValue(ChronoField.HOUR_OF_AMPM,12===_ch?0:_ch)}if(resolverStyle!==ResolverStyle.LENIENT&&(this.fieldValues.containsKey(ChronoField.AMPM_OF_DAY)&&ChronoField.AMPM_OF_DAY.checkValidValue(this.fieldValues.get(ChronoField.AMPM_OF_DAY)),this.fieldValues.containsKey(ChronoField.HOUR_OF_AMPM)&&ChronoField.HOUR_OF_AMPM.checkValidValue(this.fieldValues.get(ChronoField.HOUR_OF_AMPM))),this.fieldValues.containsKey(ChronoField.AMPM_OF_DAY)&&this.fieldValues.containsKey(ChronoField.HOUR_OF_AMPM)){var ap=this.fieldValues.remove(ChronoField.AMPM_OF_DAY),hap=this.fieldValues.remove(ChronoField.HOUR_OF_AMPM);this._addFieldValue(ChronoField.HOUR_OF_DAY,12*ap+hap)}if(this.fieldValues.containsKey(ChronoField.NANO_OF_DAY)){var nod=this.fieldValues.remove(ChronoField.NANO_OF_DAY);resolverStyle!==ResolverStyle.LENIENT&&ChronoField.NANO_OF_DAY.checkValidValue(nod),this._addFieldValue(ChronoField.SECOND_OF_DAY,MathUtil.intDiv(nod,1e9)),this._addFieldValue(ChronoField.NANO_OF_SECOND,MathUtil.intMod(nod,1e9))}if(this.fieldValues.containsKey(ChronoField.MICRO_OF_DAY)){var cod=this.fieldValues.remove(ChronoField.MICRO_OF_DAY);resolverStyle!==ResolverStyle.LENIENT&&ChronoField.MICRO_OF_DAY.checkValidValue(cod),this._addFieldValue(ChronoField.SECOND_OF_DAY,MathUtil.intDiv(cod,1e6)),this._addFieldValue(ChronoField.MICRO_OF_SECOND,MathUtil.intMod(cod,1e6))}if(this.fieldValues.containsKey(ChronoField.MILLI_OF_DAY)){var lod=this.fieldValues.remove(ChronoField.MILLI_OF_DAY);resolverStyle!==ResolverStyle.LENIENT&&ChronoField.MILLI_OF_DAY.checkValidValue(lod),this._addFieldValue(ChronoField.SECOND_OF_DAY,MathUtil.intDiv(lod,1e3)),this._addFieldValue(ChronoField.MILLI_OF_SECOND,MathUtil.intMod(lod,1e3))}if(this.fieldValues.containsKey(ChronoField.SECOND_OF_DAY)){var sod=this.fieldValues.remove(ChronoField.SECOND_OF_DAY);resolverStyle!==ResolverStyle.LENIENT&&ChronoField.SECOND_OF_DAY.checkValidValue(sod),this._addFieldValue(ChronoField.HOUR_OF_DAY,MathUtil.intDiv(sod,3600)),this._addFieldValue(ChronoField.MINUTE_OF_HOUR,MathUtil.intMod(MathUtil.intDiv(sod,60),60)),this._addFieldValue(ChronoField.SECOND_OF_MINUTE,MathUtil.intMod(sod,60))}if(this.fieldValues.containsKey(ChronoField.MINUTE_OF_DAY)){var mod=this.fieldValues.remove(ChronoField.MINUTE_OF_DAY);resolverStyle!==ResolverStyle.LENIENT&&ChronoField.MINUTE_OF_DAY.checkValidValue(mod),this._addFieldValue(ChronoField.HOUR_OF_DAY,MathUtil.intDiv(mod,60)),this._addFieldValue(ChronoField.MINUTE_OF_HOUR,MathUtil.intMod(mod,60))}if(resolverStyle!==ResolverStyle.LENIENT&&(this.fieldValues.containsKey(ChronoField.MILLI_OF_SECOND)&&ChronoField.MILLI_OF_SECOND.checkValidValue(this.fieldValues.get(ChronoField.MILLI_OF_SECOND)),this.fieldValues.containsKey(ChronoField.MICRO_OF_SECOND)&&ChronoField.MICRO_OF_SECOND.checkValidValue(this.fieldValues.get(ChronoField.MICRO_OF_SECOND))),this.fieldValues.containsKey(ChronoField.MILLI_OF_SECOND)&&this.fieldValues.containsKey(ChronoField.MICRO_OF_SECOND)){var los=this.fieldValues.remove(ChronoField.MILLI_OF_SECOND),cos=this.fieldValues.get(ChronoField.MICRO_OF_SECOND);this._putFieldValue0(ChronoField.MICRO_OF_SECOND,1e3*los+MathUtil.intMod(cos,1e3))}if(this.fieldValues.containsKey(ChronoField.MICRO_OF_SECOND)&&this.fieldValues.containsKey(ChronoField.NANO_OF_SECOND)){var nos=this.fieldValues.get(ChronoField.NANO_OF_SECOND);this._putFieldValue0(ChronoField.MICRO_OF_SECOND,MathUtil.intDiv(nos,1e3)),this.fieldValues.remove(ChronoField.MICRO_OF_SECOND)}if(this.fieldValues.containsKey(ChronoField.MILLI_OF_SECOND)&&this.fieldValues.containsKey(ChronoField.NANO_OF_SECOND)){var _nos=this.fieldValues.get(ChronoField.NANO_OF_SECOND);this._putFieldValue0(ChronoField.MILLI_OF_SECOND,MathUtil.intDiv(_nos,1e6)),this.fieldValues.remove(ChronoField.MILLI_OF_SECOND)}if(this.fieldValues.containsKey(ChronoField.MICRO_OF_SECOND)){var _cos=this.fieldValues.remove(ChronoField.MICRO_OF_SECOND);this._putFieldValue0(ChronoField.NANO_OF_SECOND,1e3*_cos)}else if(this.fieldValues.containsKey(ChronoField.MILLI_OF_SECOND)){var _los=this.fieldValues.remove(ChronoField.MILLI_OF_SECOND);this._putFieldValue0(ChronoField.NANO_OF_SECOND,1e6*_los)}},_proto._resolveTimeInferZeroes=function(resolverStyle){var hod=this.fieldValues.get(ChronoField.HOUR_OF_DAY),moh=this.fieldValues.get(ChronoField.MINUTE_OF_HOUR),som=this.fieldValues.get(ChronoField.SECOND_OF_MINUTE),nos=this.fieldValues.get(ChronoField.NANO_OF_SECOND);if(null!=hod&&(null!=moh||null==som&&null==nos)&&(null==moh||null!=som||null==nos)){if(resolverStyle!==ResolverStyle.LENIENT){if(null!=hod){resolverStyle!==ResolverStyle.SMART||24!==hod||null!=moh&&0!==moh||null!=som&&0!==som||null!=nos&&0!==nos||(hod=0,this.excessDays=Period.ofDays(1));var hodVal=ChronoField.HOUR_OF_DAY.checkValidIntValue(hod);if(null!=moh){var mohVal=ChronoField.MINUTE_OF_HOUR.checkValidIntValue(moh);if(null!=som){var somVal=ChronoField.SECOND_OF_MINUTE.checkValidIntValue(som);if(null!=nos){var nosVal=ChronoField.NANO_OF_SECOND.checkValidIntValue(nos);this._addObject(LocalTime.of(hodVal,mohVal,somVal,nosVal))}else this._addObject(LocalTime.of(hodVal,mohVal,somVal))}else null==nos&&this._addObject(LocalTime.of(hodVal,mohVal))}else null==som&&null==nos&&this._addObject(LocalTime.of(hodVal,0))}}else if(null!=hod){var _hodVal=hod;if(null!=moh)if(null!=som){null==nos&&(nos=0);var totalNanos=MathUtil.safeMultiply(_hodVal,36e11);totalNanos=MathUtil.safeAdd(totalNanos,MathUtil.safeMultiply(moh,6e10)),totalNanos=MathUtil.safeAdd(totalNanos,MathUtil.safeMultiply(som,1e9)),totalNanos=MathUtil.safeAdd(totalNanos,nos);var excessDays=MathUtil.floorDiv(totalNanos,864e11),nod=MathUtil.floorMod(totalNanos,864e11);this._addObject(LocalTime.ofNanoOfDay(nod)),this.excessDays=Period.ofDays(excessDays)}else{var totalSecs=MathUtil.safeMultiply(_hodVal,3600);totalSecs=MathUtil.safeAdd(totalSecs,MathUtil.safeMultiply(moh,60));var _excessDays=MathUtil.floorDiv(totalSecs,86400),sod=MathUtil.floorMod(totalSecs,86400);this._addObject(LocalTime.ofSecondOfDay(sod)),this.excessDays=Period.ofDays(_excessDays)}else{var _excessDays2=MathUtil.safeToInt(MathUtil.floorDiv(_hodVal,24));_hodVal=MathUtil.floorMod(_hodVal,24),this._addObject(LocalTime.of(_hodVal,0)),this.excessDays=Period.ofDays(_excessDays2)}}this.fieldValues.remove(ChronoField.HOUR_OF_DAY),this.fieldValues.remove(ChronoField.MINUTE_OF_HOUR),this.fieldValues.remove(ChronoField.SECOND_OF_MINUTE),this.fieldValues.remove(ChronoField.NANO_OF_SECOND)}},_proto._addObject=function(dateOrTime){dateOrTime instanceof ChronoLocalDate?this.date=dateOrTime:dateOrTime instanceof LocalTime&&(this.time=dateOrTime)},_proto._resolveInstant=function(){if(null!=this.date&&null!=this.time){var offsetSecs=this.fieldValues.get(ChronoField.OFFSET_SECONDS);if(null!=offsetSecs){var offset=ZoneOffset.ofTotalSeconds(offsetSecs),instant=this.date.atTime(this.time).atZone(offset).getLong(ChronoField.INSTANT_SECONDS);this.fieldValues.put(ChronoField.INSTANT_SECONDS,instant)}else if(null!=this.zone){var _instant=this.date.atTime(this.time).atZone(this.zone).getLong(ChronoField.INSTANT_SECONDS);this.fieldValues.put(ChronoField.INSTANT_SECONDS,_instant)}}},_proto.build=function(type){return type.queryFrom(this)},_proto.isSupported=function(field){return null!=field&&(this.fieldValues.containsKey(field)&&void 0!==this.fieldValues.get(field)||null!=this.date&&this.date.isSupported(field)||null!=this.time&&this.time.isSupported(field))},_proto.getLong=function(field){requireNonNull(field,"field");var value=this.getFieldValue0(field);if(null==value){if(null!=this.date&&this.date.isSupported(field))return this.date.getLong(field);if(null!=this.time&&this.time.isSupported(field))return this.time.getLong(field);throw new DateTimeException("Field not found: "+field)}return value},_proto.query=function(_query){return _query===TemporalQueries.zoneId()?this.zone:_query===TemporalQueries.chronology()?this.chrono:_query===TemporalQueries.localDate()?null!=this.date?LocalDate.from(this.date):null:_query===TemporalQueries.localTime()?this.time:_query===TemporalQueries.zone()||_query===TemporalQueries.offset()?_query.queryFrom(this):_query===TemporalQueries.precision()?null:_query.queryFrom(this)},DateTimeBuilder}(TemporalAccessor),DateTimeParseContext=function(){function DateTimeParseContext(){if(1===arguments.length){if(arguments[0]instanceof DateTimeParseContext)return void this._constructorSelf.apply(this,arguments);this._constructorFormatter.apply(this,arguments)}else this._constructorParam.apply(this,arguments);this._caseSensitive=!0,this._strict=!0,this._parsed=[new Parsed(this)]}var _proto=DateTimeParseContext.prototype;return _proto._constructorParam=function(locale,symbols,chronology){this._locale=locale,this._symbols=symbols,this._overrideChronology=chronology},_proto._constructorFormatter=function(formatter){this._locale=formatter.locale(),this._symbols=formatter.decimalStyle(),this._overrideChronology=formatter.chronology()},_proto._constructorSelf=function(other){this._locale=other._locale,this._symbols=other._symbols,this._overrideChronology=other._overrideChronology,this._overrideZone=other._overrideZone,this._caseSensitive=other._caseSensitive,this._strict=other._strict,this._parsed=[new Parsed(this)]},_proto.copy=function(){return new DateTimeParseContext(this)},_proto.symbols=function(){return this._symbols},_proto.isStrict=function(){return this._strict},_proto.setStrict=function(strict){this._strict=strict},_proto.locale=function(){return this._locale},_proto.setLocale=function(locale){this._locale=locale},_proto.startOptional=function(){this._parsed.push(this.currentParsed().copy())},_proto.endOptional=function(successful){successful?this._parsed.splice(this._parsed.length-2,1):this._parsed.splice(this._parsed.length-1,1)},_proto.isCaseSensitive=function(){return this._caseSensitive},_proto.setCaseSensitive=function(caseSensitive){this._caseSensitive=caseSensitive},_proto.subSequenceEquals=function(cs1,offset1,cs2,offset2,length){if(offset1+length>cs1.length||offset2+length>cs2.length)return!1;this.isCaseSensitive()||(cs1=cs1.toLowerCase(),cs2=cs2.toLowerCase());for(var i=0;i<length;i++){if(cs1[offset1+i]!==cs2[offset2+i])return!1}return!0},_proto.charEquals=function(ch1,ch2){return this.isCaseSensitive()?ch1===ch2:this.charEqualsIgnoreCase(ch1,ch2)},_proto.charEqualsIgnoreCase=function(c1,c2){return c1===c2||c1.toLowerCase()===c2.toLowerCase()},_proto.setParsedField=function(field,value,errorPos,successPos){var currentParsedFieldValues=this.currentParsed().fieldValues,old=currentParsedFieldValues.get(field);return currentParsedFieldValues.set(field,value),null!=old&&old!==value?~errorPos:successPos},_proto.setParsedZone=function(zone){requireNonNull(zone,"zone"),this.currentParsed().zone=zone},_proto.getParsed=function(field){return this.currentParsed().fieldValues.get(field)},_proto.toParsed=function(){return this.currentParsed()},_proto.currentParsed=function(){return this._parsed[this._parsed.length-1]},_proto.setParsedLeapSecond=function(){this.currentParsed().leapSecond=!0},_proto.getEffectiveChronology=function(){var chrono=this.currentParsed().chrono;return null==chrono&&null==(chrono=this._overrideChronology)&&(chrono=IsoChronology.INSTANCE),chrono},DateTimeParseContext}(),Parsed=function(_Temporal){function Parsed(dateTimeParseContext){var _this;return(_this=_Temporal.call(this)||this).chrono=null,_this.zone=null,_this.fieldValues=new EnumMap,_this.leapSecond=!1,_this.dateTimeParseContext=dateTimeParseContext,_this}_inheritsLoose(Parsed,_Temporal);var _proto2=Parsed.prototype;return _proto2.copy=function(){var cloned=new Parsed;return cloned.chrono=this.chrono,cloned.zone=this.zone,cloned.fieldValues.putAll(this.fieldValues),cloned.leapSecond=this.leapSecond,cloned.dateTimeParseContext=this.dateTimeParseContext,cloned},_proto2.toString=function(){return this.fieldValues+", "+this.chrono+", "+this.zone},_proto2.isSupported=function(field){return this.fieldValues.containsKey(field)},_proto2.get=function(field){var val=this.fieldValues.get(field);return assert(null!=val),val},_proto2.query=function(_query){return _query===TemporalQueries.chronology()?this.chrono:_query===TemporalQueries.zoneId()||_query===TemporalQueries.zone()?this.zone:_Temporal.prototype.query.call(this,_query)},_proto2.toBuilder=function(){var builder=new DateTimeBuilder;return builder.fieldValues.putAll(this.fieldValues),builder.chrono=this.dateTimeParseContext.getEffectiveChronology(),null!=this.zone?builder.zone=this.zone:builder.zone=this.overrideZone,builder.leapSecond=this.leapSecond,builder.excessDays=this.excessDays,builder},Parsed}(Temporal),DateTimePrintContext=function(){function DateTimePrintContext(temporal,localeOrFormatter,symbols){2===arguments.length&&arguments[1]instanceof DateTimeFormatter?(this._temporal=DateTimePrintContext.adjust(temporal,localeOrFormatter),this._locale=localeOrFormatter.locale(),this._symbols=localeOrFormatter.decimalStyle()):(this._temporal=temporal,this._locale=localeOrFormatter,this._symbols=symbols),this._optional=0}DateTimePrintContext.adjust=function(temporal,formatter){return temporal};var _proto=DateTimePrintContext.prototype;return _proto.symbols=function(){return this._symbols},_proto.startOptional=function(){this._optional++},_proto.endOptional=function(){this._optional--},_proto.getValueQuery=function(query){var result=this._temporal.query(query);if(null==result&&0===this._optional)throw new DateTimeException("Unable to extract value: "+this._temporal);return result},_proto.getValue=function(field){try{return this._temporal.getLong(field)}catch(ex){if(ex instanceof DateTimeException&&this._optional>0)return null;throw ex}},_proto.temporal=function(){return this._temporal},_proto.locale=function(){return this._locale},_proto.setDateTime=function(temporal){this._temporal=temporal},_proto.setLocale=function(locale){this._locale=locale},DateTimePrintContext}(),IsoFields={},QUARTER_DAYS=[0,90,181,273,0,91,182,274],Field=function(_TemporalField){function Field(){return _TemporalField.apply(this,arguments)||this}_inheritsLoose(Field,_TemporalField);var _proto=Field.prototype;return _proto.isDateBased=function(){return!0},_proto.isTimeBased=function(){return!1},_proto._isIso=function(){return!0},Field._getWeekRangeByLocalDate=function(date){var wby=Field._getWeekBasedYear(date);return ValueRange.of(1,Field._getWeekRangeByYear(wby))},Field._getWeekRangeByYear=function(wby){var date=LocalDate.of(wby,1,1);return date.dayOfWeek()===DayOfWeek.THURSDAY||date.dayOfWeek()===DayOfWeek.WEDNESDAY&&date.isLeapYear()?53:52},Field._getWeek=function(date){var dow0=date.dayOfWeek().ordinal(),doy0=date.dayOfYear()-1,doyThu0=doy0+(3-dow0),firstMonDoy0=doyThu0-7*MathUtil.intDiv(doyThu0,7)-3;if(firstMonDoy0<-3&&(firstMonDoy0+=7),doy0<firstMonDoy0)return Field._getWeekRangeByLocalDate(date.withDayOfYear(180).minusYears(1)).maximum();var week=MathUtil.intDiv(doy0-firstMonDoy0,7)+1;return 53===week&&!1===(-3===firstMonDoy0||-2===firstMonDoy0&&date.isLeapYear())&&(week=1),week},Field._getWeekBasedYear=function(date){var year=date.year(),doy=date.dayOfYear();if(doy<=3)doy-date.dayOfWeek().ordinal()<-2&&year--;else if(doy>=363){var _dow=date.dayOfWeek().ordinal();(doy=doy-363-(date.isLeapYear()?1:0))-_dow>=0&&year++}return year},_proto.displayName=function(){return this.toString()},_proto.resolve=function(){return null},_proto.name=function(){return this.toString()},Field}(TemporalField),DAY_OF_QUARTER_FIELD=function(_Field){function DAY_OF_QUARTER_FIELD(){return _Field.apply(this,arguments)||this}_inheritsLoose(DAY_OF_QUARTER_FIELD,_Field);var _proto2=DAY_OF_QUARTER_FIELD.prototype;return _proto2.toString=function(){return"DayOfQuarter"},_proto2.baseUnit=function(){return ChronoUnit.DAYS},_proto2.rangeUnit=function(){return QUARTER_YEARS},_proto2.range=function(){return ValueRange.of(1,90,92)},_proto2.isSupportedBy=function(temporal){return temporal.isSupported(ChronoField.DAY_OF_YEAR)&&temporal.isSupported(ChronoField.MONTH_OF_YEAR)&&temporal.isSupported(ChronoField.YEAR)&&this._isIso(temporal)},_proto2.rangeRefinedBy=function(temporal){if(!1===temporal.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: DayOfQuarter");var qoy=temporal.getLong(QUARTER_OF_YEAR);if(1===qoy){var year=temporal.getLong(ChronoField.YEAR);return IsoChronology.isLeapYear(year)?ValueRange.of(1,91):ValueRange.of(1,90)}return 2===qoy?ValueRange.of(1,91):3===qoy||4===qoy?ValueRange.of(1,92):this.range()},_proto2.getFrom=function(temporal){if(!1===temporal.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: DayOfQuarter");var doy=temporal.get(ChronoField.DAY_OF_YEAR),moy=temporal.get(ChronoField.MONTH_OF_YEAR),year=temporal.getLong(ChronoField.YEAR);return doy-QUARTER_DAYS[MathUtil.intDiv(moy-1,3)+(IsoChronology.isLeapYear(year)?4:0)]},_proto2.adjustInto=function(temporal,newValue){var curValue=this.getFrom(temporal);return this.range().checkValidValue(newValue,this),temporal.with(ChronoField.DAY_OF_YEAR,temporal.getLong(ChronoField.DAY_OF_YEAR)+(newValue-curValue))},_proto2.resolve=function(fieldValues,partialTemporal,resolverStyle){var yearLong=fieldValues.get(ChronoField.YEAR),qoyLong=fieldValues.get(QUARTER_OF_YEAR);if(null==yearLong||null==qoyLong)return null;var date,y=ChronoField.YEAR.checkValidIntValue(yearLong),doq=fieldValues.get(DAY_OF_QUARTER);if(resolverStyle===ResolverStyle.LENIENT){var qoy=qoyLong;date=(date=(date=LocalDate.of(y,1,1)).plusMonths(MathUtil.safeMultiply(MathUtil.safeSubtract(qoy,1),3))).plusDays(MathUtil.safeSubtract(doq,1))}else{var _qoy=QUARTER_OF_YEAR.range().checkValidIntValue(qoyLong,QUARTER_OF_YEAR);if(resolverStyle===ResolverStyle.STRICT){var max=92;1===_qoy?max=IsoChronology.isLeapYear(y)?91:90:2===_qoy&&(max=91),ValueRange.of(1,max).checkValidValue(doq,this)}else this.range().checkValidValue(doq,this);date=LocalDate.of(y,3*(_qoy-1)+1,1).plusDays(doq-1)}return fieldValues.remove(this),fieldValues.remove(ChronoField.YEAR),fieldValues.remove(QUARTER_OF_YEAR),date},DAY_OF_QUARTER_FIELD}(Field),QUARTER_OF_YEAR_FIELD=function(_Field2){function QUARTER_OF_YEAR_FIELD(){return _Field2.apply(this,arguments)||this}_inheritsLoose(QUARTER_OF_YEAR_FIELD,_Field2);var _proto3=QUARTER_OF_YEAR_FIELD.prototype;return _proto3.toString=function(){return"QuarterOfYear"},_proto3.baseUnit=function(){return QUARTER_YEARS},_proto3.rangeUnit=function(){return ChronoUnit.YEARS},_proto3.range=function(){return ValueRange.of(1,4)},_proto3.isSupportedBy=function(temporal){return temporal.isSupported(ChronoField.MONTH_OF_YEAR)&&this._isIso(temporal)},_proto3.rangeRefinedBy=function(temporal){return this.range()},_proto3.getFrom=function(temporal){if(!1===temporal.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: QuarterOfYear");var moy=temporal.getLong(ChronoField.MONTH_OF_YEAR);return MathUtil.intDiv(moy+2,3)},_proto3.adjustInto=function(temporal,newValue){var curValue=this.getFrom(temporal);return this.range().checkValidValue(newValue,this),temporal.with(ChronoField.MONTH_OF_YEAR,temporal.getLong(ChronoField.MONTH_OF_YEAR)+3*(newValue-curValue))},QUARTER_OF_YEAR_FIELD}(Field),WEEK_OF_WEEK_BASED_YEAR_FIELD=function(_Field3){function WEEK_OF_WEEK_BASED_YEAR_FIELD(){return _Field3.apply(this,arguments)||this}_inheritsLoose(WEEK_OF_WEEK_BASED_YEAR_FIELD,_Field3);var _proto4=WEEK_OF_WEEK_BASED_YEAR_FIELD.prototype;return _proto4.toString=function(){return"WeekOfWeekBasedYear"},_proto4.baseUnit=function(){return ChronoUnit.WEEKS},_proto4.rangeUnit=function(){return WEEK_BASED_YEARS},_proto4.range=function(){return ValueRange.of(1,52,53)},_proto4.isSupportedBy=function(temporal){return temporal.isSupported(ChronoField.EPOCH_DAY)&&this._isIso(temporal)},_proto4.rangeRefinedBy=function(temporal){if(!1===temporal.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: WeekOfWeekBasedYear");return Field._getWeekRangeByLocalDate(LocalDate.from(temporal))},_proto4.getFrom=function(temporal){if(!1===temporal.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: WeekOfWeekBasedYear");return Field._getWeek(LocalDate.from(temporal))},_proto4.adjustInto=function(temporal,newValue){return this.range().checkValidValue(newValue,this),temporal.plus(MathUtil.safeSubtract(newValue,this.getFrom(temporal)),ChronoUnit.WEEKS)},_proto4.resolve=function(fieldValues,partialTemporal,resolverStyle){var wbyLong=fieldValues.get(WEEK_BASED_YEAR),dowLong=fieldValues.get(ChronoField.DAY_OF_WEEK);if(null==wbyLong||null==dowLong)return null;var date,wby=WEEK_BASED_YEAR.range().checkValidIntValue(wbyLong,WEEK_BASED_YEAR),wowby=fieldValues.get(WEEK_OF_WEEK_BASED_YEAR);if(resolverStyle===ResolverStyle.LENIENT){var dow=dowLong,weeks=0;dow>7?(weeks=MathUtil.intDiv(dow-1,7),dow=MathUtil.intMod(dow-1,7)+1):dow<1&&(weeks=MathUtil.intDiv(dow,7)-1,dow=MathUtil.intMod(dow,7)+7),date=LocalDate.of(wby,1,4).plusWeeks(wowby-1).plusWeeks(weeks).with(ChronoField.DAY_OF_WEEK,dow)}else{var _dow2=ChronoField.DAY_OF_WEEK.checkValidIntValue(dowLong);if(resolverStyle===ResolverStyle.STRICT){var temp=LocalDate.of(wby,1,4);Field._getWeekRangeByLocalDate(temp).checkValidValue(wowby,this)}else this.range().checkValidValue(wowby,this);date=LocalDate.of(wby,1,4).plusWeeks(wowby-1).with(ChronoField.DAY_OF_WEEK,_dow2)}return fieldValues.remove(this),fieldValues.remove(WEEK_BASED_YEAR),fieldValues.remove(ChronoField.DAY_OF_WEEK),date},_proto4.displayName=function(){return"Week"},WEEK_OF_WEEK_BASED_YEAR_FIELD}(Field),WEEK_BASED_YEAR_FIELD=function(_Field4){function WEEK_BASED_YEAR_FIELD(){return _Field4.apply(this,arguments)||this}_inheritsLoose(WEEK_BASED_YEAR_FIELD,_Field4);var _proto5=WEEK_BASED_YEAR_FIELD.prototype;return _proto5.toString=function(){return"WeekBasedYear"},_proto5.baseUnit=function(){return WEEK_BASED_YEARS},_proto5.rangeUnit=function(){return ChronoUnit.FOREVER},_proto5.range=function(){return ChronoField.YEAR.range()},_proto5.isSupportedBy=function(temporal){return temporal.isSupported(ChronoField.EPOCH_DAY)&&this._isIso(temporal)},_proto5.rangeRefinedBy=function(temporal){return ChronoField.YEAR.range()},_proto5.getFrom=function(temporal){if(!1===temporal.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: WeekBasedYear");return Field._getWeekBasedYear(LocalDate.from(temporal))},_proto5.adjustInto=function(temporal,newValue){if(!1===this.isSupportedBy(temporal))throw new UnsupportedTemporalTypeException("Unsupported field: WeekBasedYear");var newWby=this.range().checkValidIntValue(newValue,WEEK_BASED_YEAR),date=LocalDate.from(temporal),dow=date.get(ChronoField.DAY_OF_WEEK),week=Field._getWeek(date);53===week&&52===Field._getWeekRangeByYear(newWby)&&(week=52);var resolved=LocalDate.of(newWby,1,4),days=dow-resolved.get(ChronoField.DAY_OF_WEEK)+7*(week-1);return resolved=resolved.plusDays(days),temporal.with(resolved)},WEEK_BASED_YEAR_FIELD}(Field),Unit=function(_TemporalUnit){function Unit(name,estimatedDuration){var _this;return(_this=_TemporalUnit.call(this)||this)._name=name,_this._duration=estimatedDuration,_this}_inheritsLoose(Unit,_TemporalUnit);var _proto6=Unit.prototype;return _proto6.duration=function(){return this._duration},_proto6.isDurationEstimated=function(){return!0},_proto6.isDateBased=function(){return!0},_proto6.isTimeBased=function(){return!1},_proto6.isSupportedBy=function(temporal){return temporal.isSupported(ChronoField.EPOCH_DAY)},_proto6.addTo=function(temporal,periodToAdd){switch(this){case WEEK_BASED_YEARS:var added=MathUtil.safeAdd(temporal.get(WEEK_BASED_YEAR),periodToAdd);return temporal.with(WEEK_BASED_YEAR,added);case QUARTER_YEARS:return temporal.plus(MathUtil.intDiv(periodToAdd,256),ChronoUnit.YEARS).plus(3*MathUtil.intMod(periodToAdd,256),ChronoUnit.MONTHS);default:throw new IllegalStateException("Unreachable")}},_proto6.between=function(temporal1,temporal2){switch(this){case WEEK_BASED_YEARS:return MathUtil.safeSubtract(temporal2.getLong(WEEK_BASED_YEAR),temporal1.getLong(WEEK_BASED_YEAR));case QUARTER_YEARS:return MathUtil.intDiv(temporal1.until(temporal2,ChronoUnit.MONTHS),3);default:throw new IllegalStateException("Unreachable")}},_proto6.toString=function(){return this._name},Unit}(TemporalUnit),DAY_OF_QUARTER=null,QUARTER_OF_YEAR=null,WEEK_OF_WEEK_BASED_YEAR=null,WEEK_BASED_YEAR=null,WEEK_BASED_YEARS=null,QUARTER_YEARS=null;function _init$f(){DAY_OF_QUARTER=new DAY_OF_QUARTER_FIELD,QUARTER_OF_YEAR=new QUARTER_OF_YEAR_FIELD,WEEK_OF_WEEK_BASED_YEAR=new WEEK_OF_WEEK_BASED_YEAR_FIELD,WEEK_BASED_YEAR=new WEEK_BASED_YEAR_FIELD,WEEK_BASED_YEARS=new Unit("WeekBasedYears",Duration.ofSeconds(31556952)),QUARTER_YEARS=new Unit("QuarterYears",Duration.ofSeconds(7889238)),IsoFields.DAY_OF_QUARTER=DAY_OF_QUARTER,IsoFields.QUARTER_OF_YEAR=QUARTER_OF_YEAR,IsoFields.WEEK_OF_WEEK_BASED_YEAR=WEEK_OF_WEEK_BASED_YEAR,IsoFields.WEEK_BASED_YEAR=WEEK_BASED_YEAR,IsoFields.WEEK_BASED_YEARS=WEEK_BASED_YEARS,IsoFields.QUARTER_YEARS=QUARTER_YEARS,LocalDate.prototype.isoWeekOfWeekyear=function(){return this.get(IsoFields.WEEK_OF_WEEK_BASED_YEAR)},LocalDate.prototype.isoWeekyear=function(){return this.get(IsoFields.WEEK_BASED_YEAR)}}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var DecimalStyle=function(){function DecimalStyle(zeroChar,positiveSignChar,negativeSignChar,decimalPointChar){this._zeroDigit=zeroChar,this._zeroDigitCharCode=zeroChar.charCodeAt(0),this._positiveSign=positiveSignChar,this._negativeSign=negativeSignChar,this._decimalSeparator=decimalPointChar}var _proto=DecimalStyle.prototype;return _proto.positiveSign=function(){return this._positiveSign},_proto.withPositiveSign=function(positiveSign){return positiveSign===this._positiveSign?this:new DecimalStyle(this._zeroDigit,positiveSign,this._negativeSign,this._decimalSeparator)},_proto.negativeSign=function(){return this._negativeSign},_proto.withNegativeSign=function(negativeSign){return negativeSign===this._negativeSign?this:new DecimalStyle(this._zeroDigit,this._positiveSign,negativeSign,this._decimalSeparator)},_proto.zeroDigit=function(){return this._zeroDigit},_proto.withZeroDigit=function(zeroDigit){return zeroDigit===this._zeroDigit?this:new DecimalStyle(zeroDigit,this._positiveSign,this._negativeSign,this._decimalSeparator)},_proto.decimalSeparator=function(){return this._decimalSeparator},_proto.withDecimalSeparator=function(decimalSeparator){return decimalSeparator===this._decimalSeparator?this:new DecimalStyle(this._zeroDigit,this._positiveSign,this._negativeSign,decimalSeparator)},_proto.convertToDigit=function(char){var val=char.charCodeAt(0)-this._zeroDigitCharCode;return val>=0&&val<=9?val:-1},_proto.convertNumberToI18N=function(numericText){if("0"===this._zeroDigit)return numericText;for(var diff=this._zeroDigitCharCode-"0".charCodeAt(0),convertedText="",i=0;i<numericText.length;i++)convertedText+=String.fromCharCode(numericText.charCodeAt(i)+diff);return convertedText},_proto.equals=function(other){return this===other||other instanceof DecimalStyle&&(this._zeroDigit===other._zeroDigit&&this._positiveSign===other._positiveSign&&this._negativeSign===other._negativeSign&&this._decimalSeparator===other._decimalSeparator)},_proto.hashCode=function(){return this._zeroDigit+this._positiveSign+this._negativeSign+this._decimalSeparator},_proto.toString=function(){return"DecimalStyle["+this._zeroDigit+this._positiveSign+this._negativeSign+this._decimalSeparator+"]"},DecimalStyle.of=function(){throw new Error("not yet supported")},DecimalStyle.availableLocales=function(){throw new Error("not yet supported")},DecimalStyle}();DecimalStyle.STANDARD=new DecimalStyle("0","+","-",".");var SignStyle=function(_Enum){function SignStyle(){return _Enum.apply(this,arguments)||this}return _inheritsLoose(SignStyle,_Enum),SignStyle.prototype.parse=function(positive,strict,fixedWidth){switch(this){case SignStyle.NORMAL:return!positive||!strict;case SignStyle.ALWAYS:case SignStyle.EXCEEDS_PAD:return!0;default:return!strict&&!fixedWidth}},SignStyle}(Enum);SignStyle.NORMAL=new SignStyle("NORMAL"),SignStyle.NEVER=new SignStyle("NEVER"),SignStyle.ALWAYS=new SignStyle("ALWAYS"),SignStyle.EXCEEDS_PAD=new SignStyle("EXCEEDS_PAD"),SignStyle.NOT_NEGATIVE=new SignStyle("NOT_NEGATIVE");var TextStyle=function(_Enum){function TextStyle(){return _Enum.apply(this,arguments)||this}_inheritsLoose(TextStyle,_Enum);var _proto=TextStyle.prototype;return _proto.isStandalone=function(){switch(this){case TextStyle.FULL_STANDALONE:case TextStyle.SHORT_STANDALONE:case TextStyle.NARROW_STANDALONE:return!0;default:return!1}},_proto.asStandalone=function(){switch(this){case TextStyle.FULL:return TextStyle.FULL_STANDALONE;case TextStyle.SHORT:return TextStyle.SHORT_STANDALONE;case TextStyle.NARROW:return TextStyle.NARROW_STANDALONE;default:return this}},_proto.asNormal=function(){switch(this){case TextStyle.FULL_STANDALONE:return TextStyle.FULL;case TextStyle.SHORT_STANDALONE:return TextStyle.SHORT;case TextStyle.NARROW_STANDALONE:return TextStyle.NARROW;default:return this}},TextStyle}(Enum);TextStyle.FULL=new TextStyle("FULL"),TextStyle.FULL_STANDALONE=new TextStyle("FULL_STANDALONE"),TextStyle.SHORT=new TextStyle("SHORT"),TextStyle.SHORT_STANDALONE=new TextStyle("SHORT_STANDALONE"),TextStyle.NARROW=new TextStyle("NARROW"),TextStyle.NARROW_STANDALONE=new TextStyle("NARROW_STANDALONE");
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var CharLiteralPrinterParser=function(){function CharLiteralPrinterParser(literal){if(literal.length>1)throw new IllegalArgumentException('invalid literal, too long: "'+literal+'"');this._literal=literal}var _proto=CharLiteralPrinterParser.prototype;return _proto.print=function(context,buf){return buf.append(this._literal),!0},_proto.parse=function(context,text,position){if(position===text.length)return~position;var ch=text.charAt(position);return!1===context.charEquals(this._literal,ch)?~position:position+this._literal.length},_proto.toString=function(){return"'"===this._literal?"''":"'"+this._literal+"'"},CharLiteralPrinterParser}(),CompositePrinterParser=function(){function CompositePrinterParser(printerParsers,optional){this._printerParsers=printerParsers,this._optional=optional}var _proto=CompositePrinterParser.prototype;return _proto.withOptional=function(optional){return optional===this._optional?this:new CompositePrinterParser(this._printerParsers,optional)},_proto.print=function(context,buf){var length=buf.length();this._optional&&context.startOptional();try{for(var i=0;i<this._printerParsers.length;i++){if(!1===this._printerParsers[i].print(context,buf))return buf.setLength(length),!0}}finally{this._optional&&context.endOptional()}return!0},_proto.parse=function(context,text,position){if(this._optional){context.startOptional();for(var pos=position,i=0;i<this._printerParsers.length;i++){if((pos=this._printerParsers[i].parse(context,text,pos))<0)return context.endOptional(!1),position}return context.endOptional(!0),pos}for(var _i=0;_i<this._printerParsers.length;_i++){if((position=this._printerParsers[_i].parse(context,text,position))<0)break}return position},_proto.toString=function(){var buf="";if(null!=this._printerParsers){buf+=this._optional?"[":"(";for(var i=0;i<this._printerParsers.length;i++){buf+=this._printerParsers[i].toString()}buf+=this._optional?"]":")"}return buf},CompositePrinterParser}(),FractionPrinterParser=function(){function FractionPrinterParser(field,minWidth,maxWidth,decimalPoint){if(requireNonNull(field,"field"),!1===field.range().isFixed())throw new IllegalArgumentException("Field must have a fixed set of values: "+field);if(minWidth<0||minWidth>9)throw new IllegalArgumentException("Minimum width must be from 0 to 9 inclusive but was "+minWidth);if(maxWidth<1||maxWidth>9)throw new IllegalArgumentException("Maximum width must be from 1 to 9 inclusive but was "+maxWidth);if(maxWidth<minWidth)throw new IllegalArgumentException("Maximum width must exceed or equal the minimum width but "+maxWidth+" < "+minWidth);this.field=field,this.minWidth=minWidth,this.maxWidth=maxWidth,this.decimalPoint=decimalPoint}var _proto=FractionPrinterParser.prototype;return _proto.print=function(context,buf){var value=context.getValue(this.field);if(null===value)return!1;var symbols=context.symbols();if(0===value){if(this.minWidth>0){this.decimalPoint&&buf.append(symbols.decimalSeparator());for(var i=0;i<this.minWidth;i++)buf.append(symbols.zeroDigit())}}else{var fraction=this.convertToFraction(value,symbols.zeroDigit()),outputScale=Math.min(Math.max(fraction.length,this.minWidth),this.maxWidth);if(1*(fraction=fraction.substr(0,outputScale))>0)for(;fraction.length>this.minWidth&&"0"===fraction[fraction.length-1];)fraction=fraction.substr(0,fraction.length-1);var str=fraction;str=symbols.convertNumberToI18N(str),this.decimalPoint&&buf.append(symbols.decimalSeparator()),buf.append(str)}return!0},_proto.parse=function(context,text,position){var effectiveMin=context.isStrict()?this.minWidth:0,effectiveMax=context.isStrict()?this.maxWidth:9,length=text.length;if(position===length)return effectiveMin>0?~position:position;if(this.decimalPoint){if(text[position]!==context.symbols().decimalSeparator())return effectiveMin>0?~position:position;position++}var minEndPos=position+effectiveMin;if(minEndPos>length)return~position;for(var maxEndPos=Math.min(position+effectiveMax,length),total=0,pos=position;pos<maxEndPos;){var ch=text.charAt(pos++),digit=context.symbols().convertToDigit(ch);if(digit<0){if(pos<minEndPos)return~position;pos--;break}total=10*total+digit}var moveLeft=pos-position,scale=Math.pow(10,moveLeft),value=this.convertFromFraction(total,scale);return context.setParsedField(this.field,value,position,pos)},_proto.convertToFraction=function(value,zeroDigit){var range=this.field.range();range.checkValidValue(value,this.field);for(var _min=range.minimum(),_range=range.maximum()-_min+1,_value=value-_min,fraction=""+MathUtil.intDiv(1e9*_value,_range);fraction.length<9;)fraction=zeroDigit+fraction;return fraction},_proto.convertFromFraction=function(total,scale){var range=this.field.range(),_min=range.minimum(),_range=range.maximum()-_min+1;return MathUtil.intDiv(total*_range,scale)},_proto.toString=function(){var decimal=this.decimalPoint?",DecimalPoint":"";return"Fraction("+this.field+","+this.minWidth+","+this.maxWidth+decimal+")"},FractionPrinterParser}(),MAX_WIDTH$1=15,EXCEED_POINTS=[0,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9],NumberPrinterParser=function(){function NumberPrinterParser(field,minWidth,maxWidth,signStyle,subsequentWidth){void 0===subsequentWidth&&(subsequentWidth=0),this._field=field,this._minWidth=minWidth,this._maxWidth=maxWidth,this._signStyle=signStyle,this._subsequentWidth=subsequentWidth}var _proto=NumberPrinterParser.prototype;return _proto.field=function(){return this._field},_proto.minWidth=function(){return this._minWidth},_proto.maxWidth=function(){return this._maxWidth},_proto.signStyle=function(){return this._signStyle},_proto.withFixedWidth=function(){return-1===this._subsequentWidth?this:new NumberPrinterParser(this._field,this._minWidth,this._maxWidth,this._signStyle,-1)},_proto.withSubsequentWidth=function(subsequentWidth){return new NumberPrinterParser(this._field,this._minWidth,this._maxWidth,this._signStyle,this._subsequentWidth+subsequentWidth)},_proto._isFixedWidth=function(){return-1===this._subsequentWidth||this._subsequentWidth>0&&this._minWidth===this._maxWidth&&this._signStyle===SignStyle.NOT_NEGATIVE},_proto.print=function(context,buf){var contextValue=context.getValue(this._field);if(null==contextValue)return!1;var value=this._getValue(context,contextValue),symbols=context.symbols(),str=""+Math.abs(value);if(str.length>this._maxWidth)throw new DateTimeException("Field "+this._field+" cannot be printed as the value "+value+" exceeds the maximum print width of "+this._maxWidth);if(str=symbols.convertNumberToI18N(str),value>=0)switch(this._signStyle){case SignStyle.EXCEEDS_PAD:this._minWidth<MAX_WIDTH$1&&value>=EXCEED_POINTS[this._minWidth]&&buf.append(symbols.positiveSign());break;case SignStyle.ALWAYS:buf.append(symbols.positiveSign())}else switch(this._signStyle){case SignStyle.NORMAL:case SignStyle.EXCEEDS_PAD:case SignStyle.ALWAYS:buf.append(symbols.negativeSign());break;case SignStyle.NOT_NEGATIVE:throw new DateTimeException("Field "+this._field+" cannot be printed as the value "+value+" cannot be negative according to the SignStyle")}for(var i=0;i<this._minWidth-str.length;i++)buf.append(symbols.zeroDigit());return buf.append(str),!0},_proto.parse=function(context,text,position){var length=text.length;if(position===length)return~position;assert(position>=0&&position<length);var sign=text.charAt(position),negative=!1,positive=!1;if(sign===context.symbols().positiveSign()){if(!1===this._signStyle.parse(!0,context.isStrict(),this._minWidth===this._maxWidth))return~position;positive=!0,position++}else if(sign===context.symbols().negativeSign()){if(!1===this._signStyle.parse(!1,context.isStrict(),this._minWidth===this._maxWidth))return~position;negative=!0,position++}else if(this._signStyle===SignStyle.ALWAYS&&context.isStrict())return~position;var effMinWidth=context.isStrict()||this._isFixedWidth()?this._minWidth:1,minEndPos=position+effMinWidth;if(minEndPos>length)return~position;for(var effMaxWidth=(context.isStrict()||this._isFixedWidth()?this._maxWidth:9)+Math.max(this._subsequentWidth,0),total=0,pos=position,pass=0;pass<2;pass++){for(var maxEndPos=Math.min(pos+effMaxWidth,length);pos<maxEndPos;){var ch=text.charAt(pos++),digit=context.symbols().convertToDigit(ch);if(digit<0){if(--pos<minEndPos)return~position;break}if(pos-position>MAX_WIDTH$1)throw new ArithmeticException("number text exceeds length");total=10*total+digit}if(!(this._subsequentWidth>0&&0===pass))break;var parseLen=pos-position;effMaxWidth=Math.max(effMinWidth,parseLen-this._subsequentWidth),pos=position,total=0}if(negative){if(0===total&&context.isStrict())return~(position-1);0!==total&&(total=-total)}else if(this._signStyle===SignStyle.EXCEEDS_PAD&&context.isStrict()){var _parseLen=pos-position;if(positive){if(_parseLen<=this._minWidth)return~(position-1)}else if(_parseLen>this._minWidth)return~position}return this._setValue(context,total,position,pos)},_proto._getValue=function(context,value){return value},_proto._setValue=function(context,value,errorPos,successPos){return context.setParsedField(this._field,value,errorPos,successPos)},_proto.toString=function(){return 1===this._minWidth&&this._maxWidth===MAX_WIDTH$1&&this._signStyle===SignStyle.NORMAL?"Value("+this._field+")":this._minWidth===this._maxWidth&&this._signStyle===SignStyle.NOT_NEGATIVE?"Value("+this._field+","+this._minWidth+")":"Value("+this._field+","+this._minWidth+","+this._maxWidth+","+this._signStyle+")"},NumberPrinterParser}(),ReducedPrinterParser=function(_NumberPrinterParser){function ReducedPrinterParser(field,width,maxWidth,baseValue,baseDate){var _this;if(_this=_NumberPrinterParser.call(this,field,width,maxWidth,SignStyle.NOT_NEGATIVE)||this,width<1||width>10)throw new IllegalArgumentException("The width must be from 1 to 10 inclusive but was "+width);if(maxWidth<1||maxWidth>10)throw new IllegalArgumentException("The maxWidth must be from 1 to 10 inclusive but was "+maxWidth);if(maxWidth<width)throw new IllegalArgumentException("The maxWidth must be greater than the width");if(null===baseDate){if(!1===field.range().isValidValue(baseValue))throw new IllegalArgumentException("The base value must be within the range of the field");if(baseValue+EXCEED_POINTS[width]>MathUtil.MAX_SAFE_INTEGER)throw new DateTimeException("Unable to add printer-parser as the range exceeds the capacity of an int")}return _this._baseValue=baseValue,_this._baseDate=baseDate,_this}_inheritsLoose(ReducedPrinterParser,_NumberPrinterParser);var _proto2=ReducedPrinterParser.prototype;return _proto2._getValue=function(context,value){var absValue=Math.abs(value),baseValue=this._baseValue;null!==this._baseDate&&(context.temporal(),baseValue=IsoChronology.INSTANCE.date(this._baseDate).get(this._field));return value>=baseValue&&value<baseValue+EXCEED_POINTS[this._minWidth]?absValue%EXCEED_POINTS[this._minWidth]:absValue%EXCEED_POINTS[this._maxWidth]},_proto2._setValue=function(context,value,errorPos,successPos){var baseValue=this._baseValue;null!=this._baseDate&&(baseValue=context.getEffectiveChronology().date(this._baseDate).get(this._field));if(successPos-errorPos===this._minWidth&&value>=0){var range=EXCEED_POINTS[this._minWidth],basePart=baseValue-baseValue%range;(value=baseValue>0?basePart+value:basePart-value)<baseValue&&(value+=range)}return context.setParsedField(this._field,value,errorPos,successPos)},_proto2.withFixedWidth=function(){return-1===this._subsequentWidth?this:new ReducedPrinterParser(this._field,this._minWidth,this._maxWidth,this._baseValue,this._baseDate)},_proto2.withSubsequentWidth=function(subsequentWidth){return new ReducedPrinterParser(this._field,this._minWidth,this._maxWidth,this._baseValue,this._baseDate,this._subsequentWidth+subsequentWidth)},_proto2.isFixedWidth=function(context){return!1!==context.isStrict()&&_NumberPrinterParser.prototype.isFixedWidth.call(this,context)},_proto2.toString=function(){return"ReducedValue("+this._field+","+this._minWidth+","+this._maxWidth+","+(null!=this._baseDate?this._baseDate:this._baseValue)+")"},ReducedPrinterParser}(NumberPrinterParser),PATTERNS=["+HH","+HHmm","+HH:mm","+HHMM","+HH:MM","+HHMMss","+HH:MM:ss","+HHMMSS","+HH:MM:SS"],OffsetIdPrinterParser=function(){function OffsetIdPrinterParser(noOffsetText,pattern){requireNonNull(noOffsetText,"noOffsetText"),requireNonNull(pattern,"pattern"),this.noOffsetText=noOffsetText,this.type=this._checkPattern(pattern)}var _proto=OffsetIdPrinterParser.prototype;return _proto._checkPattern=function(pattern){for(var i=0;i<PATTERNS.length;i++)if(PATTERNS[i]===pattern)return i;throw new IllegalArgumentException("Invalid zone offset pattern: "+pattern)},_proto.print=function(context,buf){var offsetSecs=context.getValue(ChronoField.OFFSET_SECONDS);if(null==offsetSecs)return!1;var totalSecs=MathUtil.safeToInt(offsetSecs);if(0===totalSecs)buf.append(this.noOffsetText);else{var absHours=Math.abs(MathUtil.intMod(MathUtil.intDiv(totalSecs,3600),100)),absMinutes=Math.abs(MathUtil.intMod(MathUtil.intDiv(totalSecs,60),60)),absSeconds=Math.abs(MathUtil.intMod(totalSecs,60)),bufPos=buf.length(),output=absHours;buf.append(totalSecs<0?"-":"+").appendChar(MathUtil.intDiv(absHours,10)+"0").appendChar(MathUtil.intMod(absHours,10)+"0"),(this.type>=3||this.type>=1&&absMinutes>0)&&(buf.append(this.type%2==0?":":"").appendChar(MathUtil.intDiv(absMinutes,10)+"0").appendChar(absMinutes%10+"0"),output+=absMinutes,(this.type>=7||this.type>=5&&absSeconds>0)&&(buf.append(this.type%2==0?":":"").appendChar(MathUtil.intDiv(absSeconds,10)+"0").appendChar(absSeconds%10+"0"),output+=absSeconds)),0===output&&(buf.setLength(bufPos),buf.append(this.noOffsetText))}return!0},_proto.parse=function(context,text,position){var length=text.length,noOffsetLen=this.noOffsetText.length;if(0===noOffsetLen){if(position===length)return context.setParsedField(ChronoField.OFFSET_SECONDS,0,position,position)}else{if(position===length)return~position;if(context.subSequenceEquals(text,position,this.noOffsetText,0,noOffsetLen))return context.setParsedField(ChronoField.OFFSET_SECONDS,0,position,position+noOffsetLen)}var sign=text[position];if("+"===sign||"-"===sign){var negative="-"===sign?-1:1,array=[0,0,0,0];if(array[0]=position+1,!1===(this._parseNumber(array,1,text,!0)||this._parseNumber(array,2,text,this.type>=3)||this._parseNumber(array,3,text,!1))){var offsetSecs=MathUtil.safeZero(negative*(3600*array[1]+60*array[2]+array[3]));return context.setParsedField(ChronoField.OFFSET_SECONDS,offsetSecs,position,array[0])}}return 0===noOffsetLen?context.setParsedField(ChronoField.OFFSET_SECONDS,0,position,position+noOffsetLen):~position},_proto._parseNumber=function(array,arrayIndex,parseText,required){if((this.type+3)/2<arrayIndex)return!1;var pos=array[0];if(this.type%2==0&&arrayIndex>1){if(pos+1>parseText.length||":"!==parseText[pos])return required;pos++}if(pos+2>parseText.length)return required;var ch1=parseText[pos++],ch2=parseText[pos++];if(ch1<"0"||ch1>"9"||ch2<"0"||ch2>"9")return required;var value=10*(ch1.charCodeAt(0)-48)+(ch2.charCodeAt(0)-48);return value<0||value>59?required:(array[arrayIndex]=value,array[0]=pos,!1)},_proto.toString=function(){var converted=this.noOffsetText.replace("'","''");return"Offset("+PATTERNS[this.type]+",'"+converted+"')"},OffsetIdPrinterParser}();
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */OffsetIdPrinterParser.INSTANCE_ID=new OffsetIdPrinterParser("Z","+HH:MM:ss"),OffsetIdPrinterParser.PATTERNS=PATTERNS;
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var PadPrinterParserDecorator=function(){function PadPrinterParserDecorator(printerParser,padWidth,padChar){this._printerParser=printerParser,this._padWidth=padWidth,this._padChar=padChar}var _proto=PadPrinterParserDecorator.prototype;return _proto.print=function(context,buf){var preLen=buf.length();if(!1===this._printerParser.print(context,buf))return!1;var len=buf.length()-preLen;if(len>this._padWidth)throw new DateTimeException("Cannot print as output of "+len+" characters exceeds pad width of "+this._padWidth);for(var i=0;i<this._padWidth-len;i++)buf.insert(preLen,this._padChar);return!0},_proto.parse=function(context,text,position){var strict=context.isStrict(),caseSensitive=context.isCaseSensitive();if(assert(!(position>text.length)),assert(position>=0),position===text.length)return~position;var endPos=position+this._padWidth;if(endPos>text.length){if(strict)return~position;endPos=text.length}for(var pos=position;pos<endPos&&(caseSensitive?text[pos]===this._padChar:context.charEquals(text[pos],this._padChar));)pos++;text=text.substring(0,endPos);var resultPos=this._printerParser.parse(context,text,pos);return resultPos!==endPos&&strict?~(position+pos):resultPos},_proto.toString=function(){return"Pad("+this._printerParser+","+this._padWidth+(" "===this._padChar?")":",'"+this._padChar+"')")},PadPrinterParserDecorator}(),SettingsParser=function(_Enum){function SettingsParser(){return _Enum.apply(this,arguments)||this}_inheritsLoose(SettingsParser,_Enum);var _proto=SettingsParser.prototype;return _proto.print=function(){return!0},_proto.parse=function(context,text,position){switch(this){case SettingsParser.SENSITIVE:context.setCaseSensitive(!0);break;case SettingsParser.INSENSITIVE:context.setCaseSensitive(!1);break;case SettingsParser.STRICT:context.setStrict(!0);break;case SettingsParser.LENIENT:context.setStrict(!1)}return position},_proto.toString=function(){switch(this){case SettingsParser.SENSITIVE:return"ParseCaseSensitive(true)";case SettingsParser.INSENSITIVE:return"ParseCaseSensitive(false)";case SettingsParser.STRICT:return"ParseStrict(true)";case SettingsParser.LENIENT:return"ParseStrict(false)"}},SettingsParser}(Enum);SettingsParser.SENSITIVE=new SettingsParser("SENSITIVE"),SettingsParser.INSENSITIVE=new SettingsParser("INSENSITIVE"),SettingsParser.STRICT=new SettingsParser("STRICT"),SettingsParser.LENIENT=new SettingsParser("LENIENT");
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var StringLiteralPrinterParser=function(){function StringLiteralPrinterParser(literal){this._literal=literal}var _proto=StringLiteralPrinterParser.prototype;return _proto.print=function(context,buf){return buf.append(this._literal),!0},_proto.parse=function(context,text,position){return assert(!(position>text.length||position<0)),!1===context.subSequenceEquals(text,position,this._literal,0,this._literal.length)?~position:position+this._literal.length},_proto.toString=function(){return"'"+this._literal.replace("'","''")+"'"},StringLiteralPrinterParser}(),ZoneRulesProvider=function(){function ZoneRulesProvider(){}return ZoneRulesProvider.getRules=function(zoneId){throw new DateTimeException("unsupported ZoneId:"+zoneId)},ZoneRulesProvider.getAvailableZoneIds=function(){return[]},ZoneRulesProvider}(),ZoneRegion=function(_ZoneId){function ZoneRegion(id,rules){var _this;return(_this=_ZoneId.call(this)||this)._id=id,_this._rules=rules,_this}_inheritsLoose(ZoneRegion,_ZoneId),ZoneRegion.ofId=function(zoneId){return new ZoneRegion(zoneId,ZoneRulesProvider.getRules(zoneId))};var _proto=ZoneRegion.prototype;return _proto.id=function(){return this._id},_proto.rules=function(){return this._rules},ZoneRegion}(ZoneId),ZoneIdPrinterParser=function(){function ZoneIdPrinterParser(query,description){this.query=query,this.description=description}var _proto=ZoneIdPrinterParser.prototype;return _proto.print=function(context,buf){var zone=context.getValueQuery(this.query);return null!=zone&&(buf.append(zone.id()),!0)},_proto.parse=function(context,text,position){var length=text.length;if(position>length)return~position;if(position===length)return~position;var nextChar=text.charAt(position);if("+"===nextChar||"-"===nextChar){var newContext=context.copy(),endPos=OffsetIdPrinterParser.INSTANCE_ID.parse(newContext,text,position);if(endPos<0)return endPos;var offset=newContext.getParsed(ChronoField.OFFSET_SECONDS),zone=ZoneOffset.ofTotalSeconds(offset);return context.setParsedZone(zone),endPos}if(length>=position+2){var nextNextChar=text.charAt(position+1);if(context.charEquals(nextChar,"U")&&context.charEquals(nextNextChar,"T"))return length>=position+3&&context.charEquals(text.charAt(position+2),"C")?this._parsePrefixedOffset(context,text,position,position+3):this._parsePrefixedOffset(context,text,position,position+2);if(context.charEquals(nextChar,"G")&&length>=position+3&&context.charEquals(nextNextChar,"M")&&context.charEquals(text.charAt(position+2),"T"))return this._parsePrefixedOffset(context,text,position,position+3)}if("SYSTEM"===text.substr(position,6))return context.setParsedZone(ZoneId.systemDefault()),position+6;if(context.charEquals(nextChar,"Z"))return context.setParsedZone(ZoneOffset.UTC),position+1;var availableZoneIds=ZoneRulesProvider.getAvailableZoneIds();zoneIdTree.size!==availableZoneIds.length&&(zoneIdTree=ZoneIdTree.createTreeMap(availableZoneIds));for(var maxParseLength=length-position,treeMap=zoneIdTree.treeMap,parsedZoneId=null,parseLength=0;null!=treeMap;){var parsedSubZoneId=text.substr(position,Math.min(treeMap.length,maxParseLength));null!=(treeMap=treeMap.get(parsedSubZoneId))&&treeMap.isLeaf&&(parsedZoneId=parsedSubZoneId,parseLength=treeMap.length)}return null!=parsedZoneId?(context.setParsedZone(ZoneRegion.ofId(parsedZoneId)),position+parseLength):~position},_proto._parsePrefixedOffset=function(context,text,prefixPos,position){var prefix=text.substring(prefixPos,position).toUpperCase(),newContext=context.copy();if(position<text.length&&context.charEquals(text.charAt(position),"Z"))return context.setParsedZone(ZoneId.ofOffset(prefix,ZoneOffset.UTC)),position;var endPos=OffsetIdPrinterParser.INSTANCE_ID.parse(newContext,text,position);if(endPos<0)return context.setParsedZone(ZoneId.ofOffset(prefix,ZoneOffset.UTC)),position;var offsetSecs=newContext.getParsed(ChronoField.OFFSET_SECONDS),offset=ZoneOffset.ofTotalSeconds(offsetSecs);return context.setParsedZone(ZoneId.ofOffset(prefix,offset)),endPos},_proto.toString=function(){return this.description},ZoneIdPrinterParser}(),ZoneIdTree=function(){function ZoneIdTree(size,treeMap){this.size=size,this.treeMap=treeMap}return ZoneIdTree.createTreeMap=function(availableZoneIds){for(var sortedZoneIds=availableZoneIds.sort((function(a,b){return a.length-b.length})),treeMap=new ZoneIdTreeMap(sortedZoneIds[0].length,!1),i=0;i<sortedZoneIds.length;i++)treeMap.add(sortedZoneIds[i]);return new ZoneIdTree(sortedZoneIds.length,treeMap)},ZoneIdTree}(),ZoneIdTreeMap=function(){function ZoneIdTreeMap(length,isLeaf){void 0===length&&(length=0),void 0===isLeaf&&(isLeaf=!1),this.length=length,this.isLeaf=isLeaf,this._treeMap={}}var _proto2=ZoneIdTreeMap.prototype;return _proto2.add=function(zoneId){var idLength=zoneId.length;if(idLength===this.length)this._treeMap[zoneId]=new ZoneIdTreeMap(idLength,!0);else if(idLength>this.length){var subZoneId=zoneId.substr(0,this.length),subTreeMap=this._treeMap[subZoneId];null==subTreeMap&&(subTreeMap=new ZoneIdTreeMap(idLength,!1),this._treeMap[subZoneId]=subTreeMap),subTreeMap.add(zoneId)}},_proto2.get=function(zoneId){return this._treeMap[zoneId]},ZoneIdTreeMap}(),zoneIdTree=new ZoneIdTree([]),MAX_WIDTH=15,DateTimeFormatterBuilder=function(){function DateTimeFormatterBuilder(){this._active=this,this._parent=null,this._printerParsers=[],this._optional=!1,this._padNextWidth=0,this._padNextChar=null,this._valueParserIndex=-1}DateTimeFormatterBuilder._of=function(parent,optional){requireNonNull(parent,"parent"),requireNonNull(optional,"optional");var dtFormatterBuilder=new DateTimeFormatterBuilder;return dtFormatterBuilder._parent=parent,dtFormatterBuilder._optional=optional,dtFormatterBuilder};var _proto=DateTimeFormatterBuilder.prototype;return _proto.parseCaseSensitive=function(){return this._appendInternalPrinterParser(SettingsParser.SENSITIVE),this},_proto.parseCaseInsensitive=function(){return this._appendInternalPrinterParser(SettingsParser.INSENSITIVE),this},_proto.parseStrict=function(){return this._appendInternalPrinterParser(SettingsParser.STRICT),this},_proto.parseLenient=function(){return this._appendInternalPrinterParser(SettingsParser.LENIENT),this},_proto.appendValue=function(){return 1===arguments.length?this._appendValue1.apply(this,arguments):2===arguments.length?this._appendValue2.apply(this,arguments):this._appendValue4.apply(this,arguments)},_proto._appendValue1=function(field){return requireNonNull(field),this._appendValuePrinterParser(new NumberPrinterParser(field,1,MAX_WIDTH,SignStyle.NORMAL)),this},_proto._appendValue2=function(field,width){if(requireNonNull(field),width<1||width>MAX_WIDTH)throw new IllegalArgumentException("The width must be from 1 to "+MAX_WIDTH+" inclusive but was "+width);var pp=new NumberPrinterParser(field,width,width,SignStyle.NOT_NEGATIVE);return this._appendValuePrinterParser(pp),this},_proto._appendValue4=function(field,minWidth,maxWidth,signStyle){if(requireNonNull(field),requireNonNull(signStyle),minWidth===maxWidth&&signStyle===SignStyle.NOT_NEGATIVE)return this._appendValue2(field,maxWidth);if(minWidth<1||minWidth>MAX_WIDTH)throw new IllegalArgumentException("The minimum width must be from 1 to "+MAX_WIDTH+" inclusive but was "+minWidth);if(maxWidth<1||maxWidth>MAX_WIDTH)throw new IllegalArgumentException("The minimum width must be from 1 to "+MAX_WIDTH+" inclusive but was "+maxWidth);if(maxWidth<minWidth)throw new IllegalArgumentException("The maximum width must exceed or equal the minimum width but "+maxWidth+" < "+minWidth);var pp=new NumberPrinterParser(field,minWidth,maxWidth,signStyle);return this._appendValuePrinterParser(pp),this},_proto.appendValueReduced=function(){return 4===arguments.length&&arguments[3]instanceof ChronoLocalDate?this._appendValueReducedFieldWidthMaxWidthBaseDate.apply(this,arguments):this._appendValueReducedFieldWidthMaxWidthBaseValue.apply(this,arguments)},_proto._appendValueReducedFieldWidthMaxWidthBaseValue=function(field,width,maxWidth,baseValue){requireNonNull(field,"field");var pp=new ReducedPrinterParser(field,width,maxWidth,baseValue,null);return this._appendValuePrinterParser(pp),this},_proto._appendValueReducedFieldWidthMaxWidthBaseDate=function(field,width,maxWidth,baseDate){requireNonNull(field,"field"),requireNonNull(baseDate,"baseDate"),requireInstance(baseDate,ChronoLocalDate,"baseDate");var pp=new ReducedPrinterParser(field,width,maxWidth,0,baseDate);return this._appendValuePrinterParser(pp),this},_proto._appendValuePrinterParser=function(pp){if(assert(null!=pp),this._active._valueParserIndex>=0&&this._active._printerParsers[this._active._valueParserIndex]instanceof NumberPrinterParser){var activeValueParser=this._active._valueParserIndex,basePP=this._active._printerParsers[activeValueParser];pp.minWidth()===pp.maxWidth()&&pp.signStyle()===SignStyle.NOT_NEGATIVE?(basePP=basePP.withSubsequentWidth(pp.maxWidth()),this._appendInternal(pp.withFixedWidth()),this._active._valueParserIndex=activeValueParser):(basePP=basePP.withFixedWidth(),this._active._valueParserIndex=this._appendInternal(pp)),this._active._printerParsers[activeValueParser]=basePP}else this._active._valueParserIndex=this._appendInternal(pp);return this},_proto.appendFraction=function(field,minWidth,maxWidth,decimalPoint){return this._appendInternal(new FractionPrinterParser(field,minWidth,maxWidth,decimalPoint)),this},_proto.appendInstant=function(fractionalDigits){if(void 0===fractionalDigits&&(fractionalDigits=-2),fractionalDigits<-2||fractionalDigits>9)throw new IllegalArgumentException("Invalid fractional digits: "+fractionalDigits);return this._appendInternal(new InstantPrinterParser(fractionalDigits)),this},_proto.appendOffsetId=function(){return this._appendInternal(OffsetIdPrinterParser.INSTANCE_ID),this},_proto.appendOffset=function(pattern,noOffsetText){return this._appendInternalPrinterParser(new OffsetIdPrinterParser(noOffsetText,pattern)),this},_proto.appendZoneId=function(){return this._appendInternal(new ZoneIdPrinterParser(TemporalQueries.zoneId(),"ZoneId()")),this},_proto.appendPattern=function(pattern){return requireNonNull(pattern,"pattern"),this._parsePattern(pattern),this},_proto.appendZoneText=function(){throw new IllegalArgumentException("Pattern using (localized) text not implemented, use @js-joda/locale plugin!")},_proto.appendText=function(){throw new IllegalArgumentException("Pattern using (localized) text not implemented, use @js-joda/locale plugin!")},_proto.appendLocalizedOffset=function(){throw new IllegalArgumentException("Pattern using (localized) text not implemented, use @js-joda/locale plugin!")},_proto.appendWeekField=function(){throw new IllegalArgumentException("Pattern using (localized) text not implemented, use @js-joda/locale plugin!")},_proto._parsePattern=function(pattern){for(var FIELD_MAP={G:ChronoField.ERA,y:ChronoField.YEAR_OF_ERA,u:ChronoField.YEAR,Q:IsoFields.QUARTER_OF_YEAR,q:IsoFields.QUARTER_OF_YEAR,M:ChronoField.MONTH_OF_YEAR,L:ChronoField.MONTH_OF_YEAR,D:ChronoField.DAY_OF_YEAR,d:ChronoField.DAY_OF_MONTH,F:ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH,E:ChronoField.DAY_OF_WEEK,c:ChronoField.DAY_OF_WEEK,e:ChronoField.DAY_OF_WEEK,a:ChronoField.AMPM_OF_DAY,H:ChronoField.HOUR_OF_DAY,k:ChronoField.CLOCK_HOUR_OF_DAY,K:ChronoField.HOUR_OF_AMPM,h:ChronoField.CLOCK_HOUR_OF_AMPM,m:ChronoField.MINUTE_OF_HOUR,s:ChronoField.SECOND_OF_MINUTE,S:ChronoField.NANO_OF_SECOND,A:ChronoField.MILLI_OF_DAY,n:ChronoField.NANO_OF_SECOND,N:ChronoField.NANO_OF_DAY},pos=0;pos<pattern.length;pos++){var cur=pattern.charAt(pos);if(cur>="A"&&cur<="Z"||cur>="a"&&cur<="z"){for(var start=pos++;pos<pattern.length&&pattern.charAt(pos)===cur;pos++);var count=pos-start;if("p"===cur){var pad=0;if(pos<pattern.length&&((cur=pattern.charAt(pos))>="A"&&cur<="Z"||cur>="a"&&cur<="z")){for(pad=count,start=pos++;pos<pattern.length&&pattern.charAt(pos)===cur;pos++);count=pos-start}if(0===pad)throw new IllegalArgumentException("Pad letter 'p' must be followed by valid pad pattern: "+pattern);this.padNext(pad)}var field=FIELD_MAP[cur];if(null!=field)this._parseField(cur,count,field);else if("z"===cur){if(count>4)throw new IllegalArgumentException("Too many pattern letters: "+cur);4===count?this.appendZoneText(TextStyle.FULL):this.appendZoneText(TextStyle.SHORT)}else if("V"===cur){if(2!==count)throw new IllegalArgumentException("Pattern letter count must be 2: "+cur);this.appendZoneId()}else if("Z"===cur)if(count<4)this.appendOffset("+HHMM","+0000");else if(4===count)this.appendLocalizedOffset(TextStyle.FULL);else{if(5!==count)throw new IllegalArgumentException("Too many pattern letters: "+cur);this.appendOffset("+HH:MM:ss","Z")}else if("O"===cur)if(1===count)this.appendLocalizedOffset(TextStyle.SHORT);else{if(4!==count)throw new IllegalArgumentException("Pattern letter count must be 1 or 4: "+cur);this.appendLocalizedOffset(TextStyle.FULL)}else if("X"===cur){if(count>5)throw new IllegalArgumentException("Too many pattern letters: "+cur);this.appendOffset(OffsetIdPrinterParser.PATTERNS[count+(1===count?0:1)],"Z")}else if("x"===cur){if(count>5)throw new IllegalArgumentException("Too many pattern letters: "+cur);var zero=1===count?"+00":count%2==0?"+0000":"+00:00";this.appendOffset(OffsetIdPrinterParser.PATTERNS[count+(1===count?0:1)],zero)}else if("W"===cur){if(count>1)throw new IllegalArgumentException("Too many pattern letters: "+cur);this.appendWeekField("W",count)}else if("w"===cur){if(count>2)throw new IllegalArgumentException("Too many pattern letters: "+cur);this.appendWeekField("w",count)}else{if("Y"!==cur)throw new IllegalArgumentException("Unknown pattern letter: "+cur);this.appendWeekField("Y",count)}pos--}else if("'"===cur){for(var _start=pos++;pos<pattern.length;pos++)if("'"===pattern.charAt(pos)){if(!(pos+1<pattern.length&&"'"===pattern.charAt(pos+1)))break;pos++}if(pos>=pattern.length)throw new IllegalArgumentException("Pattern ends with an incomplete string literal: "+pattern);var str=pattern.substring(_start+1,pos);0===str.length?this.appendLiteral("'"):this.appendLiteral(str.replace("''","'"))}else if("["===cur)this.optionalStart();else if("]"===cur){if(null===this._active._parent)throw new IllegalArgumentException("Pattern invalid as it contains ] without previous [");this.optionalEnd()}else{if("{"===cur||"}"===cur||"#"===cur)throw new IllegalArgumentException("Pattern includes reserved character: '"+cur+"'");this.appendLiteral(cur)}}},_proto._parseField=function(cur,count,field){switch(cur){case"u":case"y":2===count?this.appendValueReduced(field,2,2,ReducedPrinterParser.BASE_DATE):count<4?this.appendValue(field,count,MAX_WIDTH,SignStyle.NORMAL):this.appendValue(field,count,MAX_WIDTH,SignStyle.EXCEEDS_PAD);break;case"M":case"Q":switch(count){case 1:this.appendValue(field);break;case 2:this.appendValue(field,2);break;case 3:this.appendText(field,TextStyle.SHORT);break;case 4:this.appendText(field,TextStyle.FULL);break;case 5:this.appendText(field,TextStyle.NARROW);break;default:throw new IllegalArgumentException("Too many pattern letters: "+cur)}break;case"L":case"q":switch(count){case 1:this.appendValue(field);break;case 2:this.appendValue(field,2);break;case 3:this.appendText(field,TextStyle.SHORT_STANDALONE);break;case 4:this.appendText(field,TextStyle.FULL_STANDALONE);break;case 5:this.appendText(field,TextStyle.NARROW_STANDALONE);break;default:throw new IllegalArgumentException("Too many pattern letters: "+cur)}break;case"e":switch(count){case 1:case 2:this.appendWeekField("e",count);break;case 3:this.appendText(field,TextStyle.SHORT);break;case 4:this.appendText(field,TextStyle.FULL);break;case 5:this.appendText(field,TextStyle.NARROW);break;default:throw new IllegalArgumentException("Too many pattern letters: "+cur)}break;case"c":switch(count){case 1:this.appendWeekField("c",count);break;case 2:throw new IllegalArgumentException("Invalid number of pattern letters: "+cur);case 3:this.appendText(field,TextStyle.SHORT_STANDALONE);break;case 4:this.appendText(field,TextStyle.FULL_STANDALONE);break;case 5:this.appendText(field,TextStyle.NARROW_STANDALONE);break;default:throw new IllegalArgumentException("Too many pattern letters: "+cur)}break;case"a":if(1!==count)throw new IllegalArgumentException("Too many pattern letters: "+cur);this.appendText(field,TextStyle.SHORT);break;case"E":case"G":switch(count){case 1:case 2:case 3:this.appendText(field,TextStyle.SHORT);break;case 4:this.appendText(field,TextStyle.FULL);break;case 5:this.appendText(field,TextStyle.NARROW);break;default:throw new IllegalArgumentException("Too many pattern letters: "+cur)}break;case"S":this.appendFraction(ChronoField.NANO_OF_SECOND,count,count,!1);break;case"F":if(1!==count)throw new IllegalArgumentException("Too many pattern letters: "+cur);this.appendValue(field);break;case"d":case"h":case"H":case"k":case"K":case"m":case"s":if(1===count)this.appendValue(field);else{if(2!==count)throw new IllegalArgumentException("Too many pattern letters: "+cur);this.appendValue(field,count)}break;case"D":if(1===count)this.appendValue(field);else{if(!(count<=3))throw new IllegalArgumentException("Too many pattern letters: "+cur);this.appendValue(field,count)}break;default:1===count?this.appendValue(field):this.appendValue(field,count)}},_proto.padNext=function(){return 1===arguments.length?this._padNext1.apply(this,arguments):this._padNext2.apply(this,arguments)},_proto._padNext1=function(padWidth){return this._padNext2(padWidth," ")},_proto._padNext2=function(padWidth,padChar){if(padWidth<1)throw new IllegalArgumentException("The pad width must be at least one but was "+padWidth);return this._active._padNextWidth=padWidth,this._active._padNextChar=padChar,this._active._valueParserIndex=-1,this},_proto.optionalStart=function(){return this._active._valueParserIndex=-1,this._active=DateTimeFormatterBuilder._of(this._active,!0),this},_proto.optionalEnd=function(){if(null==this._active._parent)throw new IllegalStateException("Cannot call optionalEnd() as there was no previous call to optionalStart()");if(this._active._printerParsers.length>0){var cpp=new CompositePrinterParser(this._active._printerParsers,this._active._optional);this._active=this._active._parent,this._appendInternal(cpp)}else this._active=this._active._parent;return this},_proto._appendInternal=function(pp){return assert(null!=pp),this._active._padNextWidth>0&&(null!=pp&&(pp=new PadPrinterParserDecorator(pp,this._active._padNextWidth,this._active._padNextChar)),this._active._padNextWidth=0,this._active._padNextChar=0),this._active._printerParsers.push(pp),this._active._valueParserIndex=-1,this._active._printerParsers.length-1},_proto.appendLiteral=function(literal){return assert(null!=literal),literal.length>0&&(1===literal.length?this._appendInternalPrinterParser(new CharLiteralPrinterParser(literal.charAt(0))):this._appendInternalPrinterParser(new StringLiteralPrinterParser(literal))),this},_proto._appendInternalPrinterParser=function(pp){return assert(null!=pp),this._active._padNextWidth>0&&(null!=pp&&(pp=new PadPrinterParserDecorator(pp,this._active._padNextWidth,this._active._padNextChar)),this._active._padNextWidth=0,this._active._padNextChar=0),this._active._printerParsers.push(pp),this._active._valueParserIndex=-1,this._active._printerParsers.length-1},_proto.append=function(formatter){return requireNonNull(formatter,"formatter"),this._appendInternal(formatter._toPrinterParser(!1)),this},_proto.toFormatter=function(resolverStyle){for(void 0===resolverStyle&&(resolverStyle=ResolverStyle.SMART);null!=this._active._parent;)this.optionalEnd();var pp=new CompositePrinterParser(this._printerParsers,!1);return new DateTimeFormatter(pp,null,DecimalStyle.STANDARD,resolverStyle,null,null,null)},DateTimeFormatterBuilder}(),SECONDS_PER_10000_YEARS=31556952e4,SECONDS_0000_TO_1970=62167219200,InstantPrinterParser=function(){function InstantPrinterParser(fractionalDigits){this.fractionalDigits=fractionalDigits}var _proto2=InstantPrinterParser.prototype;return _proto2.print=function(context,buf){var inSecs=context.getValue(ChronoField.INSTANT_SECONDS),inNanos=0;if(context.temporal().isSupported(ChronoField.NANO_OF_SECOND)&&(inNanos=context.temporal().getLong(ChronoField.NANO_OF_SECOND)),null==inSecs)return!1;var inSec=inSecs,inNano=ChronoField.NANO_OF_SECOND.checkValidIntValue(inNanos);if(inSec>=-SECONDS_0000_TO_1970){var zeroSecs=inSec-SECONDS_PER_10000_YEARS+SECONDS_0000_TO_1970,hi=MathUtil.floorDiv(zeroSecs,SECONDS_PER_10000_YEARS)+1,lo=MathUtil.floorMod(zeroSecs,SECONDS_PER_10000_YEARS),ldt=LocalDateTime.ofEpochSecond(lo-SECONDS_0000_TO_1970,0,ZoneOffset.UTC);hi>0&&buf.append("+").append(hi),buf.append(ldt.toString()),0===ldt.second()&&buf.append(":00")}else{var _zeroSecs=inSec+SECONDS_0000_TO_1970,_hi=MathUtil.intDiv(_zeroSecs,SECONDS_PER_10000_YEARS),_lo=MathUtil.intMod(_zeroSecs,SECONDS_PER_10000_YEARS),_ldt=LocalDateTime.ofEpochSecond(_lo-SECONDS_0000_TO_1970,0,ZoneOffset.UTC),pos=buf.length();buf.append(_ldt.toString()),0===_ldt.second()&&buf.append(":00"),_hi<0&&(-1e4===_ldt.year()?buf.replace(pos,pos+2,""+(_hi-1)):0===_lo?buf.insert(pos,_hi):buf.insert(pos+1,Math.abs(_hi)))}if(-2===this.fractionalDigits)0!==inNano&&(buf.append("."),0===MathUtil.intMod(inNano,1e6)?buf.append((""+(MathUtil.intDiv(inNano,1e6)+1e3)).substring(1)):0===MathUtil.intMod(inNano,1e3)?buf.append((""+(MathUtil.intDiv(inNano,1e3)+1e6)).substring(1)):buf.append((""+(inNano+1e9)).substring(1)));else if(this.fractionalDigits>0||-1===this.fractionalDigits&&inNano>0){buf.append(".");for(var div=1e8,i=0;-1===this.fractionalDigits&&inNano>0||i<this.fractionalDigits;i++){var digit=MathUtil.intDiv(inNano,div);buf.append(digit),inNano-=digit*div,div=MathUtil.intDiv(div,10)}}return buf.append("Z"),!0},_proto2.parse=function(context,text,position){var newContext=context.copy(),minDigits=this.fractionalDigits<0?0:this.fractionalDigits,maxDigits=this.fractionalDigits<0?9:this.fractionalDigits,pos=(new DateTimeFormatterBuilder).append(DateTimeFormatter.ISO_LOCAL_DATE).appendLiteral("T").appendValue(ChronoField.HOUR_OF_DAY,2).appendLiteral(":").appendValue(ChronoField.MINUTE_OF_HOUR,2).appendLiteral(":").appendValue(ChronoField.SECOND_OF_MINUTE,2).appendFraction(ChronoField.NANO_OF_SECOND,minDigits,maxDigits,!0).appendLiteral("Z").toFormatter()._toPrinterParser(!1).parse(newContext,text,position);if(pos<0)return pos;var instantSecs,yearParsed=newContext.getParsed(ChronoField.YEAR),month=newContext.getParsed(ChronoField.MONTH_OF_YEAR),day=newContext.getParsed(ChronoField.DAY_OF_MONTH),hour=newContext.getParsed(ChronoField.HOUR_OF_DAY),min=newContext.getParsed(ChronoField.MINUTE_OF_HOUR),secVal=newContext.getParsed(ChronoField.SECOND_OF_MINUTE),nanoVal=newContext.getParsed(ChronoField.NANO_OF_SECOND),sec=null!=secVal?secVal:0,nano=null!=nanoVal?nanoVal:0,year=MathUtil.intMod(yearParsed,1e4),days=0;24===hour&&0===min&&0===sec&&0===nano?(hour=0,days=1):23===hour&&59===min&&60===sec&&(context.setParsedLeapSecond(),sec=59);try{instantSecs=LocalDateTime.of(year,month,day,hour,min,sec,0).plusDays(days).toEpochSecond(ZoneOffset.UTC),instantSecs+=MathUtil.safeMultiply(MathUtil.intDiv(yearParsed,1e4),SECONDS_PER_10000_YEARS)}catch(ex){return~position}var successPos=pos;return successPos=context.setParsedField(ChronoField.INSTANT_SECONDS,instantSecs,position,successPos),context.setParsedField(ChronoField.NANO_OF_SECOND,nano,position,successPos)},_proto2.toString=function(){return"Instant()"},InstantPrinterParser}();
/*
 * @copyright (c) 2016, Philipp Thürwächter, Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function _init$e(){ReducedPrinterParser.BASE_DATE=LocalDate.of(2e3,1,1),DateTimeFormatterBuilder.CompositePrinterParser=CompositePrinterParser,DateTimeFormatterBuilder.PadPrinterParserDecorator=PadPrinterParserDecorator,DateTimeFormatterBuilder.SettingsParser=SettingsParser,DateTimeFormatterBuilder.CharLiteralPrinterParser=StringLiteralPrinterParser,DateTimeFormatterBuilder.StringLiteralPrinterParser=StringLiteralPrinterParser,DateTimeFormatterBuilder.CharLiteralPrinterParser=CharLiteralPrinterParser,DateTimeFormatterBuilder.NumberPrinterParser=NumberPrinterParser,DateTimeFormatterBuilder.ReducedPrinterParser=ReducedPrinterParser,DateTimeFormatterBuilder.FractionPrinterParser=FractionPrinterParser,DateTimeFormatterBuilder.OffsetIdPrinterParser=OffsetIdPrinterParser,DateTimeFormatterBuilder.ZoneIdPrinterParser=ZoneIdPrinterParser}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var StringBuilder=function(){function StringBuilder(){this._str=""}var _proto=StringBuilder.prototype;return _proto.append=function(str){return this._str+=str,this},_proto.appendChar=function(str){return this._str+=str[0],this},_proto.insert=function(offset,str){return this._str=this._str.slice(0,offset)+str+this._str.slice(offset),this},_proto.replace=function(start,end,str){return this._str=this._str.slice(0,start)+str+this._str.slice(end),this},_proto.length=function(){return this._str.length},_proto.setLength=function(length){return this._str=this._str.slice(0,length),this},_proto.toString=function(){return this._str},StringBuilder}(),DateTimeFormatter=function(){function DateTimeFormatter(printerParser,locale,decimalStyle,resolverStyle,resolverFields,chrono,zone){void 0===chrono&&(chrono=IsoChronology.INSTANCE),assert(null!=printerParser),assert(null!=decimalStyle),assert(null!=resolverStyle),this._printerParser=printerParser,this._locale=locale,this._decimalStyle=decimalStyle,this._resolverStyle=resolverStyle,this._resolverFields=resolverFields,this._chrono=chrono,this._zone=zone}DateTimeFormatter.parsedExcessDays=function(){return DateTimeFormatter.PARSED_EXCESS_DAYS},DateTimeFormatter.parsedLeapSecond=function(){return DateTimeFormatter.PARSED_LEAP_SECOND},DateTimeFormatter.ofPattern=function(pattern){return(new DateTimeFormatterBuilder).appendPattern(pattern).toFormatter()};var _proto=DateTimeFormatter.prototype;return _proto.locale=function(){return this._locale},_proto.decimalStyle=function(){return this._decimalStyle},_proto.chronology=function(){return this._chrono},_proto.withChronology=function(chrono){return null!=this._chrono&&this._chrono.equals(chrono)?this:new DateTimeFormatter(this._printerParser,this._locale,this._decimalStyle,this._resolverStyle,this._resolverFields,chrono,this._zone)},_proto.withLocale=function(){return this},_proto.withResolverStyle=function(resolverStyle){return requireNonNull(resolverStyle,"resolverStyle"),resolverStyle.equals(this._resolverStyle)?this:new DateTimeFormatter(this._printerParser,this._locale,this._decimalStyle,resolverStyle,this._resolverFields,this._chrono,this._zone)},_proto.format=function(temporal){var buf=new StringBuilder(32);return this._formatTo(temporal,buf),buf.toString()},_proto._formatTo=function(temporal,appendable){requireNonNull(temporal,"temporal"),requireNonNull(appendable,"appendable");var context=new DateTimePrintContext(temporal,this);this._printerParser.print(context,appendable)},_proto.parse=function(text,type){return 1===arguments.length?this.parse1(text):this.parse2(text,type)},_proto.parse1=function(text){requireNonNull(text,"text");try{return this._parseToBuilder(text,null).resolve(this._resolverStyle,this._resolverFields)}catch(ex){throw ex instanceof DateTimeParseException?ex:this._createError(text,ex)}},_proto.parse2=function(text,type){requireNonNull(text,"text"),requireNonNull(type,"type");try{return this._parseToBuilder(text,null).resolve(this._resolverStyle,this._resolverFields).build(type)}catch(ex){throw ex instanceof DateTimeParseException?ex:this._createError(text,ex)}},_proto._createError=function(text,ex){var abbr="";return abbr=text.length>64?text.substring(0,64)+"...":text,new DateTimeParseException("Text '"+abbr+"' could not be parsed: "+ex.message,text,0,ex)},_proto._parseToBuilder=function(text,position){var pos=null!=position?position:new ParsePosition(0),result=this._parseUnresolved0(text,pos);if(null==result||pos.getErrorIndex()>=0||null==position&&pos.getIndex()<text.length){var abbr="";throw abbr=text.length>64?text.substr(0,64).toString()+"...":text,pos.getErrorIndex()>=0?new DateTimeParseException("Text '"+abbr+"' could not be parsed at index "+pos.getErrorIndex(),text,pos.getErrorIndex()):new DateTimeParseException("Text '"+abbr+"' could not be parsed, unparsed text found at index "+pos.getIndex(),text,pos.getIndex())}return result.toBuilder()},_proto.parseUnresolved=function(text,position){return this._parseUnresolved0(text,position)},_proto._parseUnresolved0=function(text,position){assert(null!=text,"text",NullPointerException),assert(null!=position,"position",NullPointerException);var context=new DateTimeParseContext(this),pos=position.getIndex();return(pos=this._printerParser.parse(context,text,pos))<0?(position.setErrorIndex(~pos),null):(position.setIndex(pos),context.toParsed())},_proto._toPrinterParser=function(optional){return this._printerParser.withOptional(optional)},_proto.toString=function(){var pattern=this._printerParser.toString();return 0===pattern.indexOf("[")?pattern:pattern.substring(1,pattern.length-1)},DateTimeFormatter}();
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function _init$d(){DateTimeFormatter.ISO_LOCAL_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-").appendValue(ChronoField.MONTH_OF_YEAR,2).appendLiteral("-").appendValue(ChronoField.DAY_OF_MONTH,2).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_LOCAL_TIME=(new DateTimeFormatterBuilder).appendValue(ChronoField.HOUR_OF_DAY,2).appendLiteral(":").appendValue(ChronoField.MINUTE_OF_HOUR,2).optionalStart().appendLiteral(":").appendValue(ChronoField.SECOND_OF_MINUTE,2).optionalStart().appendFraction(ChronoField.NANO_OF_SECOND,0,9,!0).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_LOCAL_DATE_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).appendLiteral("T").append(DateTimeFormatter.ISO_LOCAL_TIME).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_INSTANT=(new DateTimeFormatterBuilder).parseCaseInsensitive().appendInstant().toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_OFFSET_DATE_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE_TIME).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_ZONED_DATE_TIME=(new DateTimeFormatterBuilder).append(DateTimeFormatter.ISO_OFFSET_DATE_TIME).optionalStart().appendLiteral("[").parseCaseSensitive().appendZoneId().appendLiteral("]").toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.BASIC_ISO_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendValue(ChronoField.MONTH_OF_YEAR,2).appendValue(ChronoField.DAY_OF_MONTH,2).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_OFFSET_DATE=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_OFFSET_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_TIME).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_ORDINAL_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-").appendValue(ChronoField.DAY_OF_YEAR).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_WEEK_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-W").appendValue(ChronoField.ALIGNED_WEEK_OF_YEAR).appendLiteral("-").appendValue(ChronoField.DAY_OF_WEEK).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_DATE=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_TIME).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_DATE_TIME=(new DateTimeFormatterBuilder).append(DateTimeFormatter.ISO_LOCAL_DATE_TIME).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.PARSED_EXCESS_DAYS=createTemporalQuery("PARSED_EXCESS_DAYS",(function(temporal){return temporal instanceof DateTimeBuilder?temporal.excessDays:Period.ZERO})),DateTimeFormatter.PARSED_LEAP_SECOND=createTemporalQuery("PARSED_LEAP_SECOND",(function(temporal){return temporal instanceof DateTimeBuilder&&temporal.leapSecond}))}var PARSER$2,MonthDay=function(_TemporalAccessor){function MonthDay(month,dayOfMonth){var _this;return(_this=_TemporalAccessor.call(this)||this)._month=MathUtil.safeToInt(month),_this._day=MathUtil.safeToInt(dayOfMonth),_this}_inheritsLoose(MonthDay,_TemporalAccessor),MonthDay.now=function(zoneIdOrClock){return 0===arguments.length?MonthDay.now0():1===arguments.length&&zoneIdOrClock instanceof ZoneId?MonthDay.nowZoneId(zoneIdOrClock):MonthDay.nowClock(zoneIdOrClock)},MonthDay.now0=function(){return this.nowClock(Clock.systemDefaultZone())},MonthDay.nowZoneId=function(zone){return requireNonNull(zone,"zone"),this.nowClock(Clock.system(zone))},MonthDay.nowClock=function(clock){requireNonNull(clock,"clock");var now=LocalDate.now(clock);return MonthDay.of(now.month(),now.dayOfMonth())},MonthDay.of=function(monthOrNumber,number){return 2===arguments.length&&monthOrNumber instanceof Month?MonthDay.ofMonthNumber(monthOrNumber,number):MonthDay.ofNumberNumber(monthOrNumber,number)},MonthDay.ofMonthNumber=function(month,dayOfMonth){if(requireNonNull(month,"month"),ChronoField.DAY_OF_MONTH.checkValidValue(dayOfMonth),dayOfMonth>month.maxLength())throw new DateTimeException("Illegal value for DayOfMonth field, value "+dayOfMonth+" is not valid for month "+month.toString());return new MonthDay(month.value(),dayOfMonth)},MonthDay.ofNumberNumber=function(month,dayOfMonth){return requireNonNull(month,"month"),requireNonNull(dayOfMonth,"dayOfMonth"),MonthDay.of(Month.of(month),dayOfMonth)},MonthDay.from=function(temporal){if(requireNonNull(temporal,"temporal"),requireInstance(temporal,TemporalAccessor,"temporal"),temporal instanceof MonthDay)return temporal;try{return MonthDay.of(temporal.get(ChronoField.MONTH_OF_YEAR),temporal.get(ChronoField.DAY_OF_MONTH))}catch(ex){throw new DateTimeException("Unable to obtain MonthDay from TemporalAccessor: "+temporal+", type "+(temporal&&null!=temporal.constructor?temporal.constructor.name:""))}},MonthDay.parse=function(text,formatter){return 1===arguments.length?MonthDay.parseString(text):MonthDay.parseStringFormatter(text,formatter)},MonthDay.parseString=function(text){return MonthDay.parseStringFormatter(text,PARSER$2)},MonthDay.parseStringFormatter=function(text,formatter){return requireNonNull(text,"text"),requireNonNull(formatter,"formatter"),requireInstance(formatter,DateTimeFormatter,"formatter"),formatter.parse(text,MonthDay.FROM)};var _proto=MonthDay.prototype;return _proto.monthValue=function(){return this._month},_proto.month=function(){return Month.of(this._month)},_proto.dayOfMonth=function(){return this._day},_proto.isSupported=function(field){return field instanceof ChronoField?field===ChronoField.MONTH_OF_YEAR||field===ChronoField.DAY_OF_MONTH:null!=field&&field.isSupportedBy(this)},_proto.range=function(field){return field===ChronoField.MONTH_OF_YEAR?field.range():field===ChronoField.DAY_OF_MONTH?ValueRange.of(1,this.month().minLength(),this.month().maxLength()):_TemporalAccessor.prototype.range.call(this,field)},_proto.get=function(field){return this.range(field).checkValidIntValue(this.getLong(field),field)},_proto.getLong=function(field){if(requireNonNull(field,"field"),field instanceof ChronoField){switch(field){case ChronoField.DAY_OF_MONTH:return this._day;case ChronoField.MONTH_OF_YEAR:return this._month}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.getFrom(this)},_proto.isValidYear=function(year){return!1==(29===this._day&&2===this._month&&!1===Year.isLeap(year))},_proto.withMonth=function(month){return this.with(Month.of(month))},_proto.with=function(month){if(requireNonNull(month,"month"),month.value()===this._month)return this;var day=Math.min(this._day,month.maxLength());return new MonthDay(month.value(),day)},_proto.withDayOfMonth=function(dayOfMonth){return dayOfMonth===this._day?this:MonthDay.of(this._month,dayOfMonth)},_proto.query=function(_query){return requireNonNull(_query,"query"),requireInstance(_query,TemporalQuery,"query"),_query===TemporalQueries.chronology()?IsoChronology.INSTANCE:_TemporalAccessor.prototype.query.call(this,_query)},_proto.adjustInto=function(temporal){return requireNonNull(temporal,"temporal"),(temporal=temporal.with(ChronoField.MONTH_OF_YEAR,this._month)).with(ChronoField.DAY_OF_MONTH,Math.min(temporal.range(ChronoField.DAY_OF_MONTH).maximum(),this._day))},_proto.atYear=function(year){return LocalDate.of(year,this._month,this.isValidYear(year)?this._day:28)},_proto.compareTo=function(other){requireNonNull(other,"other"),requireInstance(other,MonthDay,"other");var cmp=this._month-other.monthValue();return 0===cmp&&(cmp=this._day-other.dayOfMonth()),cmp},_proto.isAfter=function(other){return requireNonNull(other,"other"),requireInstance(other,MonthDay,"other"),this.compareTo(other)>0},_proto.isBefore=function(other){return requireNonNull(other,"other"),requireInstance(other,MonthDay,"other"),this.compareTo(other)<0},_proto.equals=function(obj){if(this===obj)return!0;if(obj instanceof MonthDay){var other=obj;return this.monthValue()===other.monthValue()&&this.dayOfMonth()===other.dayOfMonth()}return!1},_proto.toString=function(){return"--"+(this._month<10?"0":"")+this._month+(this._day<10?"-0":"-")+this._day},_proto.toJSON=function(){return this.toString()},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),requireInstance(formatter,DateTimeFormatter,"formatter"),formatter.format(this)},MonthDay}(TemporalAccessor);function _init$c(){PARSER$2=(new DateTimeFormatterBuilder).appendLiteral("--").appendValue(ChronoField.MONTH_OF_YEAR,2).appendLiteral("-").appendValue(ChronoField.DAY_OF_MONTH,2).toFormatter(),MonthDay.FROM=createTemporalQuery("MonthDay.FROM",(function(temporal){return MonthDay.from(temporal)}))}var PARSER$1,YearMonth=function(_Temporal){function YearMonth(year,month){var _this;return(_this=_Temporal.call(this)||this)._year=MathUtil.safeToInt(year),_this._month=MathUtil.safeToInt(month),_this}_inheritsLoose(YearMonth,_Temporal),YearMonth.now=function(zoneIdOrClock){return 0===arguments.length?YearMonth.now0():1===arguments.length&&zoneIdOrClock instanceof ZoneId?YearMonth.nowZoneId(zoneIdOrClock):YearMonth.nowClock(zoneIdOrClock)},YearMonth.now0=function(){return YearMonth.nowClock(Clock.systemDefaultZone())},YearMonth.nowZoneId=function(zone){return YearMonth.nowClock(Clock.system(zone))},YearMonth.nowClock=function(clock){var now=LocalDate.now(clock);return YearMonth.of(now.year(),now.month())},YearMonth.of=function(year,monthOrNumber){return 2===arguments.length&&monthOrNumber instanceof Month?YearMonth.ofNumberMonth(year,monthOrNumber):YearMonth.ofNumberNumber(year,monthOrNumber)},YearMonth.ofNumberMonth=function(year,month){return requireNonNull(month,"month"),requireInstance(month,Month,"month"),YearMonth.ofNumberNumber(year,month.value())},YearMonth.ofNumberNumber=function(year,month){return requireNonNull(year,"year"),requireNonNull(month,"month"),ChronoField.YEAR.checkValidValue(year),ChronoField.MONTH_OF_YEAR.checkValidValue(month),new YearMonth(year,month)},YearMonth.from=function(temporal){if(requireNonNull(temporal,"temporal"),temporal instanceof YearMonth)return temporal;try{return YearMonth.of(temporal.get(ChronoField.YEAR),temporal.get(ChronoField.MONTH_OF_YEAR))}catch(ex){throw new DateTimeException("Unable to obtain YearMonth from TemporalAccessor: "+temporal+", type "+(temporal&&null!=temporal.constructor?temporal.constructor.name:""))}},YearMonth.parse=function(text,formatter){return 1===arguments.length?YearMonth.parseString(text):YearMonth.parseStringFormatter(text,formatter)},YearMonth.parseString=function(text){return YearMonth.parseStringFormatter(text,PARSER$1)},YearMonth.parseStringFormatter=function(text,formatter){return requireNonNull(formatter,"formatter"),formatter.parse(text,YearMonth.FROM)};var _proto=YearMonth.prototype;return _proto.isSupported=function(fieldOrUnit){return 1===arguments.length&&fieldOrUnit instanceof TemporalField?this.isSupportedField(fieldOrUnit):this.isSupportedUnit(fieldOrUnit)},_proto.isSupportedField=function(field){return field instanceof ChronoField?field===ChronoField.YEAR||field===ChronoField.MONTH_OF_YEAR||field===ChronoField.PROLEPTIC_MONTH||field===ChronoField.YEAR_OF_ERA||field===ChronoField.ERA:null!=field&&field.isSupportedBy(this)},_proto.isSupportedUnit=function(unit){return unit instanceof ChronoUnit?unit===ChronoUnit.MONTHS||unit===ChronoUnit.YEARS||unit===ChronoUnit.DECADES||unit===ChronoUnit.CENTURIES||unit===ChronoUnit.MILLENNIA||unit===ChronoUnit.ERAS:null!=unit&&unit.isSupportedBy(this)},_proto.range=function(field){return field===ChronoField.YEAR_OF_ERA?this.year()<=0?ValueRange.of(1,Year.MAX_VALUE+1):ValueRange.of(1,Year.MAX_VALUE):_Temporal.prototype.range.call(this,field)},_proto.get=function(field){return requireNonNull(field,"field"),requireInstance(field,TemporalField,"field"),this.range(field).checkValidIntValue(this.getLong(field),field)},_proto.getLong=function(field){if(requireNonNull(field,"field"),requireInstance(field,TemporalField,"field"),field instanceof ChronoField){switch(field){case ChronoField.MONTH_OF_YEAR:return this._month;case ChronoField.PROLEPTIC_MONTH:return this._getProlepticMonth();case ChronoField.YEAR_OF_ERA:return this._year<1?1-this._year:this._year;case ChronoField.YEAR:return this._year;case ChronoField.ERA:return this._year<1?0:1}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.getFrom(this)},_proto._getProlepticMonth=function(){return MathUtil.safeAdd(MathUtil.safeMultiply(this._year,12),this._month-1)},_proto.year=function(){return this._year},_proto.monthValue=function(){return this._month},_proto.month=function(){return Month.of(this._month)},_proto.isLeapYear=function(){return IsoChronology.isLeapYear(this._year)},_proto.isValidDay=function(dayOfMonth){return dayOfMonth>=1&&dayOfMonth<=this.lengthOfMonth()},_proto.lengthOfMonth=function(){return this.month().length(this.isLeapYear())},_proto.lengthOfYear=function(){return this.isLeapYear()?366:365},_proto.with=function(adjusterOrField,value){return 1===arguments.length?this._withAdjuster(adjusterOrField):this._withField(adjusterOrField,value)},_proto._withField=function(field,newValue){if(requireNonNull(field,"field"),requireInstance(field,TemporalField,"field"),field instanceof ChronoField){var f=field;switch(f.checkValidValue(newValue),f){case ChronoField.MONTH_OF_YEAR:return this.withMonth(newValue);case ChronoField.PROLEPTIC_MONTH:return this.plusMonths(newValue-this.getLong(ChronoField.PROLEPTIC_MONTH));case ChronoField.YEAR_OF_ERA:return this.withYear(this._year<1?1-newValue:newValue);case ChronoField.YEAR:return this.withYear(newValue);case ChronoField.ERA:return this.getLong(ChronoField.ERA)===newValue?this:this.withYear(1-this._year)}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.adjustInto(this,newValue)},_proto.withYear=function(year){return ChronoField.YEAR.checkValidValue(year),new YearMonth(year,this._month)},_proto.withMonth=function(month){return ChronoField.MONTH_OF_YEAR.checkValidValue(month),new YearMonth(this._year,month)},_proto._plusUnit=function(amountToAdd,unit){if(requireNonNull(unit,"unit"),requireInstance(unit,TemporalUnit,"unit"),unit instanceof ChronoUnit){switch(unit){case ChronoUnit.MONTHS:return this.plusMonths(amountToAdd);case ChronoUnit.YEARS:return this.plusYears(amountToAdd);case ChronoUnit.DECADES:return this.plusYears(MathUtil.safeMultiply(amountToAdd,10));case ChronoUnit.CENTURIES:return this.plusYears(MathUtil.safeMultiply(amountToAdd,100));case ChronoUnit.MILLENNIA:return this.plusYears(MathUtil.safeMultiply(amountToAdd,1e3));case ChronoUnit.ERAS:return this.with(ChronoField.ERA,MathUtil.safeAdd(this.getLong(ChronoField.ERA),amountToAdd))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.addTo(this,amountToAdd)},_proto.plusYears=function(yearsToAdd){if(0===yearsToAdd)return this;var newYear=ChronoField.YEAR.checkValidIntValue(this._year+yearsToAdd);return this.withYear(newYear)},_proto.plusMonths=function(monthsToAdd){if(0===monthsToAdd)return this;var calcMonths=12*this._year+(this._month-1)+monthsToAdd;return new YearMonth(ChronoField.YEAR.checkValidIntValue(MathUtil.floorDiv(calcMonths,12)),MathUtil.floorMod(calcMonths,12)+1)},_proto.minusYears=function(yearsToSubtract){return yearsToSubtract===MathUtil.MIN_SAFE_INTEGER?this.plusYears(MathUtil.MIN_SAFE_INTEGER).plusYears(1):this.plusYears(-yearsToSubtract)},_proto.minusMonths=function(monthsToSubtract){return monthsToSubtract===MathUtil.MIN_SAFE_INTEGER?this.plusMonths(Math.MAX_SAFE_INTEGER).plusMonths(1):this.plusMonths(-monthsToSubtract)},_proto.query=function(_query){return requireNonNull(_query,"query"),requireInstance(_query,TemporalQuery,"query"),_query===TemporalQueries.chronology()?IsoChronology.INSTANCE:_query===TemporalQueries.precision()?ChronoUnit.MONTHS:_query===TemporalQueries.localDate()||_query===TemporalQueries.localTime()||_query===TemporalQueries.zone()||_query===TemporalQueries.zoneId()||_query===TemporalQueries.offset()?null:_Temporal.prototype.query.call(this,_query)},_proto.adjustInto=function(temporal){return requireNonNull(temporal,"temporal"),requireInstance(temporal,Temporal,"temporal"),temporal.with(ChronoField.PROLEPTIC_MONTH,this._getProlepticMonth())},_proto.until=function(endExclusive,unit){requireNonNull(endExclusive,"endExclusive"),requireNonNull(unit,"unit"),requireInstance(endExclusive,Temporal,"endExclusive"),requireInstance(unit,TemporalUnit,"unit");var end=YearMonth.from(endExclusive);if(unit instanceof ChronoUnit){var monthsUntil=end._getProlepticMonth()-this._getProlepticMonth();switch(unit){case ChronoUnit.MONTHS:return monthsUntil;case ChronoUnit.YEARS:return MathUtil.intDiv(monthsUntil,12);case ChronoUnit.DECADES:return MathUtil.intDiv(monthsUntil,120);case ChronoUnit.CENTURIES:return MathUtil.intDiv(monthsUntil,1200);case ChronoUnit.MILLENNIA:return MathUtil.intDiv(monthsUntil,12e3);case ChronoUnit.ERAS:return end.getLong(ChronoField.ERA)-this.getLong(ChronoField.ERA)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.between(this,end)},_proto.atDay=function(dayOfMonth){return requireNonNull(dayOfMonth,"dayOfMonth"),LocalDate.of(this._year,this._month,dayOfMonth)},_proto.atEndOfMonth=function(){return LocalDate.of(this._year,this._month,this.lengthOfMonth())},_proto.compareTo=function(other){requireNonNull(other,"other"),requireInstance(other,YearMonth,"other");var cmp=this._year-other.year();return 0===cmp&&(cmp=this._month-other.monthValue()),cmp},_proto.isAfter=function(other){return this.compareTo(other)>0},_proto.isBefore=function(other){return this.compareTo(other)<0},_proto.equals=function(obj){if(this===obj)return!0;if(obj instanceof YearMonth){var other=obj;return this.year()===other.year()&&this.monthValue()===other.monthValue()}return!1},_proto.toString=function(){return PARSER$1.format(this)},_proto.toJSON=function(){return this.toString()},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),formatter.format(this)},YearMonth}(Temporal);function _init$b(){PARSER$1=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-").appendValue(ChronoField.MONTH_OF_YEAR,2).toFormatter(),YearMonth.FROM=createTemporalQuery("YearMonth.FROM",(function(temporal){return YearMonth.from(temporal)}))}var PARSER,Year=function(_Temporal){function Year(value){var _this;return(_this=_Temporal.call(this)||this)._year=MathUtil.safeToInt(value),_this}_inheritsLoose(Year,_Temporal);var _proto=Year.prototype;return _proto.value=function(){return this._year},Year.now=function(zoneIdOrClock){return void 0===zoneIdOrClock&&(zoneIdOrClock=void 0),void 0===zoneIdOrClock?Year.now0():zoneIdOrClock instanceof ZoneId?Year.nowZoneId(zoneIdOrClock):Year.nowClock(zoneIdOrClock)},Year.now0=function(){return Year.nowClock(Clock.systemDefaultZone())},Year.nowZoneId=function(zone){return requireNonNull(zone,"zone"),requireInstance(zone,ZoneId,"zone"),Year.nowClock(Clock.system(zone))},Year.nowClock=function(clock){requireNonNull(clock,"clock"),requireInstance(clock,Clock,"clock");var now=LocalDate.now(clock);return Year.of(now.year())},Year.of=function(isoYear){return requireNonNull(isoYear,"isoYear"),ChronoField.YEAR.checkValidValue(isoYear),new Year(isoYear)},Year.from=function(temporal){if(requireNonNull(temporal,"temporal"),requireInstance(temporal,TemporalAccessor,"temporal"),temporal instanceof Year)return temporal;try{return Year.of(temporal.get(ChronoField.YEAR))}catch(ex){throw new DateTimeException("Unable to obtain Year from TemporalAccessor: "+temporal+", type "+(temporal&&null!=temporal.constructor?temporal.constructor.name:""))}},Year.parse=function(text,formatter){return arguments.length<=1?Year.parseText(text):Year.parseTextFormatter(text,formatter)},Year.parseText=function(text){return requireNonNull(text,"text"),Year.parse(text,PARSER)},Year.parseTextFormatter=function(text,formatter){return void 0===formatter&&(formatter=PARSER),requireNonNull(text,"text"),requireNonNull(formatter,"formatter"),requireInstance(formatter,DateTimeFormatter,"formatter"),formatter.parse(text,Year.FROM)},Year.isLeap=function(year){return 0===MathUtil.intMod(year,4)&&(0!==MathUtil.intMod(year,100)||0===MathUtil.intMod(year,400))},_proto.isSupported=function(fieldOrUnit){return 1===arguments.length&&fieldOrUnit instanceof TemporalField?this.isSupportedField(fieldOrUnit):this.isSupportedUnit(fieldOrUnit)},_proto.isSupportedField=function(field){return field instanceof ChronoField?field===ChronoField.YEAR||field===ChronoField.YEAR_OF_ERA||field===ChronoField.ERA:null!=field&&field.isSupportedBy(this)},_proto.isSupportedUnit=function(unit){return unit instanceof ChronoUnit?unit===ChronoUnit.YEARS||unit===ChronoUnit.DECADES||unit===ChronoUnit.CENTURIES||unit===ChronoUnit.MILLENNIA||unit===ChronoUnit.ERAS:null!=unit&&unit.isSupportedBy(this)},_proto.range=function(field){if(this.isSupported(field))return field.range();if(field instanceof ChronoField)throw new UnsupportedTemporalTypeException("Unsupported field: "+field);return _Temporal.prototype.range.call(this,field)},_proto.get=function(field){return this.range(field).checkValidIntValue(this.getLong(field),field)},_proto.getLong=function(field){if(requireNonNull(field,"field"),field instanceof ChronoField){switch(field){case ChronoField.YEAR_OF_ERA:return this._year<1?1-this._year:this._year;case ChronoField.YEAR:return this._year;case ChronoField.ERA:return this._year<1?0:1}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.getFrom(this)},_proto.isLeap=function(){return Year.isLeap(this._year)},_proto._withField=function(field,newValue){if(requireNonNull(field,"field"),requireInstance(field,TemporalField,"field"),field instanceof ChronoField){switch(field.checkValidValue(newValue),field){case ChronoField.YEAR_OF_ERA:return Year.of(this._year<1?1-newValue:newValue);case ChronoField.YEAR:return Year.of(newValue);case ChronoField.ERA:return this.getLong(ChronoField.ERA)===newValue?this:Year.of(1-this._year)}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.adjustInto(this,newValue)},_proto._plusUnit=function(amountToAdd,unit){if(requireNonNull(amountToAdd,"amountToAdd"),requireNonNull(unit,"unit"),requireInstance(unit,TemporalUnit,"unit"),unit instanceof ChronoUnit){switch(unit){case ChronoUnit.YEARS:return this.plusYears(amountToAdd);case ChronoUnit.DECADES:return this.plusYears(MathUtil.safeMultiply(amountToAdd,10));case ChronoUnit.CENTURIES:return this.plusYears(MathUtil.safeMultiply(amountToAdd,100));case ChronoUnit.MILLENNIA:return this.plusYears(MathUtil.safeMultiply(amountToAdd,1e3));case ChronoUnit.ERAS:return this.with(ChronoField.ERA,MathUtil.safeAdd(this.getLong(ChronoField.ERA),amountToAdd))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.addTo(this,amountToAdd)},_proto.plusYears=function(yearsToAdd){return 0===yearsToAdd?this:Year.of(ChronoField.YEAR.checkValidIntValue(MathUtil.safeAdd(this._year,yearsToAdd)))},_proto.minusYears=function(yearsToSubtract){return yearsToSubtract===MathUtil.MIN_SAFE_INTEGER?this.plusYears(MathUtil.MAX_SAFE_INTEGER).plusYears(1):this.plusYears(-yearsToSubtract)},_proto.adjustInto=function(temporal){return requireNonNull(temporal,"temporal"),temporal.with(ChronoField.YEAR,this._year)},_proto.isValidMonthDay=function(monthDay){return null!=monthDay&&monthDay.isValidYear(this._year)},_proto.length=function(){return this.isLeap()?366:365},_proto.atDay=function(dayOfYear){return LocalDate.ofYearDay(this._year,dayOfYear)},_proto.atMonth=function(monthOrNumber){return 1===arguments.length&&monthOrNumber instanceof Month?this.atMonthMonth(monthOrNumber):this.atMonthNumber(monthOrNumber)},_proto.atMonthMonth=function(month){return requireNonNull(month,"month"),requireInstance(month,Month,"month"),YearMonth.of(this._year,month)},_proto.atMonthNumber=function(month){return requireNonNull(month,"month"),YearMonth.of(this._year,month)},_proto.atMonthDay=function(monthDay){return requireNonNull(monthDay,"monthDay"),requireInstance(monthDay,MonthDay,"monthDay"),monthDay.atYear(this._year)},_proto.query=function(_query){return requireNonNull(_query,"query()"),requireInstance(_query,TemporalQuery,"query()"),_query===TemporalQueries.chronology()?IsoChronology.INSTANCE:_query===TemporalQueries.precision()?ChronoUnit.YEARS:_query===TemporalQueries.localDate()||_query===TemporalQueries.localTime()||_query===TemporalQueries.zone()||_query===TemporalQueries.zoneId()||_query===TemporalQueries.offset()?null:_Temporal.prototype.query.call(this,_query)},_proto.compareTo=function(other){return requireNonNull(other,"other"),requireInstance(other,Year,"other"),this._year-other._year},_proto.isAfter=function(other){return requireNonNull(other,"other"),requireInstance(other,Year,"other"),this._year>other._year},_proto.isBefore=function(other){return requireNonNull(other,"other"),requireInstance(other,Year,"other"),this._year<other._year},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),requireInstance(formatter,DateTimeFormatter,"formatter"),formatter.format(this)},_proto.equals=function(other){return this===other||other instanceof Year&&this.value()===other.value()},_proto.toString=function(){return""+this._year},_proto.toJSON=function(){return this.toString()},_proto.until=function(endExclusive,unit){var end=Year.from(endExclusive);if(unit instanceof ChronoUnit){var yearsUntil=end.value()-this.value();switch(unit){case ChronoUnit.YEARS:return yearsUntil;case ChronoUnit.DECADES:return MathUtil.intDiv(yearsUntil,10);case ChronoUnit.CENTURIES:return MathUtil.intDiv(yearsUntil,100);case ChronoUnit.MILLENNIA:return MathUtil.intDiv(yearsUntil,1e3);case ChronoUnit.ERAS:return end.getLong(ChronoField.ERA)-this.getLong(ChronoField.ERA)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.between(this,end)},Year}(Temporal);function _init$a(){Year.MIN_VALUE=YearConstants.MIN_VALUE,Year.MAX_VALUE=YearConstants.MAX_VALUE,PARSER=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).toFormatter(),Year.FROM=createTemporalQuery("Year.FROM",(function(temporal){return Year.from(temporal)}))}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var TemporalAdjuster=function(){function TemporalAdjuster(){}return TemporalAdjuster.prototype.adjustInto=function(temporal){abstractMethodFail("adjustInto")},TemporalAdjuster}(),TemporalAdjusters=function(){function TemporalAdjusters(){}return TemporalAdjusters.firstDayOfMonth=function(){return Impl.FIRST_DAY_OF_MONTH},TemporalAdjusters.lastDayOfMonth=function(){return Impl.LAST_DAY_OF_MONTH},TemporalAdjusters.firstDayOfNextMonth=function(){return Impl.FIRST_DAY_OF_NEXT_MONTH},TemporalAdjusters.firstDayOfYear=function(){return Impl.FIRST_DAY_OF_YEAR},TemporalAdjusters.lastDayOfYear=function(){return Impl.LAST_DAY_OF_YEAR},TemporalAdjusters.firstDayOfNextYear=function(){return Impl.FIRST_DAY_OF_NEXT_YEAR},TemporalAdjusters.firstInMonth=function(dayOfWeek){return requireNonNull(dayOfWeek,"dayOfWeek"),new DayOfWeekInMonth(1,dayOfWeek)},TemporalAdjusters.lastInMonth=function(dayOfWeek){return requireNonNull(dayOfWeek,"dayOfWeek"),new DayOfWeekInMonth(-1,dayOfWeek)},TemporalAdjusters.dayOfWeekInMonth=function(ordinal,dayOfWeek){return requireNonNull(dayOfWeek,"dayOfWeek"),new DayOfWeekInMonth(ordinal,dayOfWeek)},TemporalAdjusters.next=function(dayOfWeek){return new RelativeDayOfWeek(2,dayOfWeek)},TemporalAdjusters.nextOrSame=function(dayOfWeek){return new RelativeDayOfWeek(0,dayOfWeek)},TemporalAdjusters.previous=function(dayOfWeek){return new RelativeDayOfWeek(3,dayOfWeek)},TemporalAdjusters.previousOrSame=function(dayOfWeek){return new RelativeDayOfWeek(1,dayOfWeek)},TemporalAdjusters}(),Impl=function(_TemporalAdjuster){function Impl(ordinal){var _this;return(_this=_TemporalAdjuster.call(this)||this)._ordinal=ordinal,_this}return _inheritsLoose(Impl,_TemporalAdjuster),Impl.prototype.adjustInto=function(temporal){switch(this._ordinal){case 0:return temporal.with(ChronoField.DAY_OF_MONTH,1);case 1:return temporal.with(ChronoField.DAY_OF_MONTH,temporal.range(ChronoField.DAY_OF_MONTH).maximum());case 2:return temporal.with(ChronoField.DAY_OF_MONTH,1).plus(1,ChronoUnit.MONTHS);case 3:return temporal.with(ChronoField.DAY_OF_YEAR,1);case 4:return temporal.with(ChronoField.DAY_OF_YEAR,temporal.range(ChronoField.DAY_OF_YEAR).maximum());case 5:return temporal.with(ChronoField.DAY_OF_YEAR,1).plus(1,ChronoUnit.YEARS)}throw new IllegalStateException("Unreachable")},Impl}(TemporalAdjuster);Impl.FIRST_DAY_OF_MONTH=new Impl(0),Impl.LAST_DAY_OF_MONTH=new Impl(1),Impl.FIRST_DAY_OF_NEXT_MONTH=new Impl(2),Impl.FIRST_DAY_OF_YEAR=new Impl(3),Impl.LAST_DAY_OF_YEAR=new Impl(4),Impl.FIRST_DAY_OF_NEXT_YEAR=new Impl(5);var DayOfWeekInMonth=function(_TemporalAdjuster2){function DayOfWeekInMonth(ordinal,dow){var _this2;return(_this2=_TemporalAdjuster2.call(this)||this)._ordinal=ordinal,_this2._dowValue=dow.value(),_this2}return _inheritsLoose(DayOfWeekInMonth,_TemporalAdjuster2),DayOfWeekInMonth.prototype.adjustInto=function(temporal){if(this._ordinal>=0){var temp=temporal.with(ChronoField.DAY_OF_MONTH,1),curDow=temp.get(ChronoField.DAY_OF_WEEK),dowDiff=MathUtil.intMod(this._dowValue-curDow+7,7);return dowDiff+=7*(this._ordinal-1),temp.plus(dowDiff,ChronoUnit.DAYS)}var _temp=temporal.with(ChronoField.DAY_OF_MONTH,temporal.range(ChronoField.DAY_OF_MONTH).maximum()),_curDow=_temp.get(ChronoField.DAY_OF_WEEK),daysDiff=this._dowValue-_curDow;return daysDiff=0===daysDiff?0:daysDiff>0?daysDiff-7:daysDiff,daysDiff-=7*(-this._ordinal-1),_temp.plus(daysDiff,ChronoUnit.DAYS)},DayOfWeekInMonth}(TemporalAdjuster),RelativeDayOfWeek=function(_TemporalAdjuster3){function RelativeDayOfWeek(relative,dayOfWeek){var _this3;return _this3=_TemporalAdjuster3.call(this)||this,requireNonNull(dayOfWeek,"dayOfWeek"),_this3._relative=relative,_this3._dowValue=dayOfWeek.value(),_this3}return _inheritsLoose(RelativeDayOfWeek,_TemporalAdjuster3),RelativeDayOfWeek.prototype.adjustInto=function(temporal){var calDow=temporal.get(ChronoField.DAY_OF_WEEK);if(this._relative<2&&calDow===this._dowValue)return temporal;if(0==(1&this._relative)){var daysDiff=calDow-this._dowValue;return temporal.plus(daysDiff>=0?7-daysDiff:-daysDiff,ChronoUnit.DAYS)}var _daysDiff=this._dowValue-calDow;return temporal.minus(_daysDiff>=0?7-_daysDiff:-_daysDiff,ChronoUnit.DAYS)},RelativeDayOfWeek}(TemporalAdjuster),IsoChronology=function(_Enum){function IsoChronology(){return _Enum.apply(this,arguments)||this}_inheritsLoose(IsoChronology,_Enum),IsoChronology.isLeapYear=function(prolepticYear){return 0==(3&prolepticYear)&&(prolepticYear%100!=0||prolepticYear%400==0)};var _proto=IsoChronology.prototype;return _proto._updateResolveMap=function(fieldValues,field,value){requireNonNull(fieldValues,"fieldValues"),requireNonNull(field,"field");var current=fieldValues.get(field);if(null!=current&&current!==value)throw new DateTimeException("Invalid state, field: "+field+" "+current+" conflicts with "+field+" "+value);fieldValues.put(field,value)},_proto.resolveDate=function(fieldValues,resolverStyle){if(fieldValues.containsKey(ChronoField.EPOCH_DAY))return LocalDate.ofEpochDay(fieldValues.remove(ChronoField.EPOCH_DAY));var prolepticMonth=fieldValues.remove(ChronoField.PROLEPTIC_MONTH);null!=prolepticMonth&&(resolverStyle!==ResolverStyle.LENIENT&&ChronoField.PROLEPTIC_MONTH.checkValidValue(prolepticMonth),this._updateResolveMap(fieldValues,ChronoField.MONTH_OF_YEAR,MathUtil.floorMod(prolepticMonth,12)+1),this._updateResolveMap(fieldValues,ChronoField.YEAR,MathUtil.floorDiv(prolepticMonth,12)));var yoeLong=fieldValues.remove(ChronoField.YEAR_OF_ERA);if(null!=yoeLong){resolverStyle!==ResolverStyle.LENIENT&&ChronoField.YEAR_OF_ERA.checkValidValue(yoeLong);var era=fieldValues.remove(ChronoField.ERA);if(null==era){var year=fieldValues.get(ChronoField.YEAR);resolverStyle===ResolverStyle.STRICT?null!=year?this._updateResolveMap(fieldValues,ChronoField.YEAR,year>0?yoeLong:MathUtil.safeSubtract(1,yoeLong)):fieldValues.put(ChronoField.YEAR_OF_ERA,yoeLong):this._updateResolveMap(fieldValues,ChronoField.YEAR,null==year||year>0?yoeLong:MathUtil.safeSubtract(1,yoeLong))}else if(1===era)this._updateResolveMap(fieldValues,ChronoField.YEAR,yoeLong);else{if(0!==era)throw new DateTimeException("Invalid value for era: "+era);this._updateResolveMap(fieldValues,ChronoField.YEAR,MathUtil.safeSubtract(1,yoeLong))}}else fieldValues.containsKey(ChronoField.ERA)&&ChronoField.ERA.checkValidValue(fieldValues.get(ChronoField.ERA));if(fieldValues.containsKey(ChronoField.YEAR)){if(fieldValues.containsKey(ChronoField.MONTH_OF_YEAR)&&fieldValues.containsKey(ChronoField.DAY_OF_MONTH)){var y=ChronoField.YEAR.checkValidIntValue(fieldValues.remove(ChronoField.YEAR)),moy=fieldValues.remove(ChronoField.MONTH_OF_YEAR),dom=fieldValues.remove(ChronoField.DAY_OF_MONTH);if(resolverStyle===ResolverStyle.LENIENT){var months=moy-1,days=dom-1;return LocalDate.of(y,1,1).plusMonths(months).plusDays(days)}return resolverStyle===ResolverStyle.SMART?(ChronoField.DAY_OF_MONTH.checkValidValue(dom),4===moy||6===moy||9===moy||11===moy?dom=Math.min(dom,30):2===moy&&(dom=Math.min(dom,Month.FEBRUARY.length(Year.isLeap(y)))),LocalDate.of(y,moy,dom)):LocalDate.of(y,moy,dom)}if(fieldValues.containsKey(ChronoField.DAY_OF_YEAR)){var _y=ChronoField.YEAR.checkValidIntValue(fieldValues.remove(ChronoField.YEAR));if(resolverStyle===ResolverStyle.LENIENT){var _days=MathUtil.safeSubtract(fieldValues.remove(ChronoField.DAY_OF_YEAR),1);return LocalDate.ofYearDay(_y,1).plusDays(_days)}var doy=ChronoField.DAY_OF_YEAR.checkValidIntValue(fieldValues.remove(ChronoField.DAY_OF_YEAR));return LocalDate.ofYearDay(_y,doy)}if(fieldValues.containsKey(ChronoField.ALIGNED_WEEK_OF_YEAR)){if(fieldValues.containsKey(ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR)){var _y2=ChronoField.YEAR.checkValidIntValue(fieldValues.remove(ChronoField.YEAR));if(resolverStyle===ResolverStyle.LENIENT){var weeks=MathUtil.safeSubtract(fieldValues.remove(ChronoField.ALIGNED_WEEK_OF_YEAR),1),_days2=MathUtil.safeSubtract(fieldValues.remove(ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR),1);return LocalDate.of(_y2,1,1).plusWeeks(weeks).plusDays(_days2)}var aw=ChronoField.ALIGNED_WEEK_OF_YEAR.checkValidIntValue(fieldValues.remove(ChronoField.ALIGNED_WEEK_OF_YEAR)),ad=ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR.checkValidIntValue(fieldValues.remove(ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR)),date=LocalDate.of(_y2,1,1).plusDays(7*(aw-1)+(ad-1));if(resolverStyle===ResolverStyle.STRICT&&date.get(ChronoField.YEAR)!==_y2)throw new DateTimeException("Strict mode rejected date parsed to a different year");return date}if(fieldValues.containsKey(ChronoField.DAY_OF_WEEK)){var _y3=ChronoField.YEAR.checkValidIntValue(fieldValues.remove(ChronoField.YEAR));if(resolverStyle===ResolverStyle.LENIENT){var _weeks=MathUtil.safeSubtract(fieldValues.remove(ChronoField.ALIGNED_WEEK_OF_YEAR),1),_days3=MathUtil.safeSubtract(fieldValues.remove(ChronoField.DAY_OF_WEEK),1);return LocalDate.of(_y3,1,1).plusWeeks(_weeks).plusDays(_days3)}var _aw=ChronoField.ALIGNED_WEEK_OF_YEAR.checkValidIntValue(fieldValues.remove(ChronoField.ALIGNED_WEEK_OF_YEAR)),dow=ChronoField.DAY_OF_WEEK.checkValidIntValue(fieldValues.remove(ChronoField.DAY_OF_WEEK)),_date=LocalDate.of(_y3,1,1).plusWeeks(_aw-1).with(TemporalAdjusters.nextOrSame(DayOfWeek.of(dow)));if(resolverStyle===ResolverStyle.STRICT&&_date.get(ChronoField.YEAR)!==_y3)throw new DateTimeException("Strict mode rejected date parsed to a different month");return _date}}}return null},_proto.date=function(temporal){return LocalDate.from(temporal)},IsoChronology}(Enum);function _init$9(){IsoChronology.INSTANCE=new IsoChronology("IsoChronology")}var OffsetTime=function(_Temporal){function OffsetTime(time,offset){var _this;return _this=_Temporal.call(this)||this,requireNonNull(time,"time"),requireInstance(time,LocalTime,"time"),requireNonNull(offset,"offset"),requireInstance(offset,ZoneOffset,"offset"),_this._time=time,_this._offset=offset,_this}_inheritsLoose(OffsetTime,_Temporal),OffsetTime.from=function(temporal){if(requireNonNull(temporal,"temporal"),temporal instanceof OffsetTime)return temporal;if(temporal instanceof OffsetDateTime)return temporal.toOffsetTime();try{return new OffsetTime(LocalTime.from(temporal),ZoneOffset.from(temporal))}catch(ex){throw new DateTimeException("Unable to obtain OffsetTime TemporalAccessor: "+temporal+", type "+(null!=temporal.constructor?temporal.constructor.name:""))}},OffsetTime.now=function(clockOrZone){return 0===arguments.length?OffsetTime._now(Clock.systemDefaultZone()):clockOrZone instanceof Clock?OffsetTime._now(clockOrZone):OffsetTime._now(Clock.system(clockOrZone))},OffsetTime._now=function(clock){requireNonNull(clock,"clock");var now=clock.instant();return OffsetTime.ofInstant(now,clock.zone().rules().offset(now))},OffsetTime.of=function(){return arguments.length<=2?OffsetTime.ofTimeAndOffset.apply(this,arguments):OffsetTime.ofNumbers.apply(this,arguments)},OffsetTime.ofNumbers=function(hour,minute,second,nanoOfSecond,offset){return new OffsetTime(LocalTime.of(hour,minute,second,nanoOfSecond),offset)},OffsetTime.ofTimeAndOffset=function(time,offset){return new OffsetTime(time,offset)},OffsetTime.ofInstant=function(instant,zone){requireNonNull(instant,"instant"),requireInstance(instant,Instant,"instant"),requireNonNull(zone,"zone"),requireInstance(zone,ZoneId,"zone");var offset=zone.rules().offset(instant),secsOfDay=instant.epochSecond()%LocalTime.SECONDS_PER_DAY;return(secsOfDay=(secsOfDay+offset.totalSeconds())%LocalTime.SECONDS_PER_DAY)<0&&(secsOfDay+=LocalTime.SECONDS_PER_DAY),new OffsetTime(LocalTime.ofSecondOfDay(secsOfDay,instant.nano()),offset)},OffsetTime.parse=function(text,formatter){return void 0===formatter&&(formatter=DateTimeFormatter.ISO_OFFSET_TIME),requireNonNull(formatter,"formatter"),formatter.parse(text,OffsetTime.FROM)};var _proto=OffsetTime.prototype;return _proto.adjustInto=function(temporal){return temporal.with(ChronoField.NANO_OF_DAY,this._time.toNanoOfDay()).with(ChronoField.OFFSET_SECONDS,this.offset().totalSeconds())},_proto.atDate=function(date){return OffsetDateTime.of(date,this._time,this._offset)},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),formatter.format(this,OffsetTime.FROM)},_proto.get=function(field){return _Temporal.prototype.get.call(this,field)},_proto.getLong=function(field){return field instanceof ChronoField?field===ChronoField.OFFSET_SECONDS?this._offset.totalSeconds():this._time.getLong(field):field.getFrom(this)},_proto.hour=function(){return this._time.hour()},_proto.minute=function(){return this._time.minute()},_proto.second=function(){return this._time.second()},_proto.nano=function(){return this._time.nano()},_proto.offset=function(){return this._offset},_proto.isAfter=function(other){return requireNonNull(other,"other"),this._toEpochNano()>other._toEpochNano()},_proto.isBefore=function(other){return requireNonNull(other,"other"),this._toEpochNano()<other._toEpochNano()},_proto.isEqual=function(other){return requireNonNull(other,"other"),this._toEpochNano()===other._toEpochNano()},_proto.isSupported=function(fieldOrUnit){return fieldOrUnit instanceof ChronoField?fieldOrUnit.isTimeBased()||fieldOrUnit===ChronoField.OFFSET_SECONDS:fieldOrUnit instanceof ChronoUnit?fieldOrUnit.isTimeBased():null!=fieldOrUnit&&fieldOrUnit.isSupportedBy(this)},_proto.minusHours=function(hours){return this._withLocalTimeOffset(this._time.minusHours(hours),this._offset)},_proto.minusMinutes=function(minutes){return this._withLocalTimeOffset(this._time.minusMinutes(minutes),this._offset)},_proto.minusSeconds=function(seconds){return this._withLocalTimeOffset(this._time.minusSeconds(seconds),this._offset)},_proto.minusNanos=function(nanos){return this._withLocalTimeOffset(this._time.minusNanos(nanos),this._offset)},_proto._minusAmount=function(amount){return requireNonNull(amount),amount.subtractFrom(this)},_proto._minusUnit=function(amountToSubtract,unit){return this.plus(-1*amountToSubtract,unit)},_proto._plusAmount=function(amount){return requireNonNull(amount),amount.addTo(this)},_proto._plusUnit=function(amountToAdd,unit){return unit instanceof ChronoUnit?this._withLocalTimeOffset(this._time.plus(amountToAdd,unit),this._offset):unit.addTo(this,amountToAdd)},_proto.plusHours=function(hours){return this._withLocalTimeOffset(this._time.plusHours(hours),this._offset)},_proto.plusMinutes=function(minutes){return this._withLocalTimeOffset(this._time.plusMinutes(minutes),this._offset)},_proto.plusSeconds=function(seconds){return this._withLocalTimeOffset(this._time.plusSeconds(seconds),this._offset)},_proto.plusNanos=function(nanos){return this._withLocalTimeOffset(this._time.plusNanos(nanos),this._offset)},_proto.query=function(_query){return requireNonNull(_query,"query"),_query===TemporalQueries.precision()?ChronoUnit.NANOS:_query===TemporalQueries.offset()||_query===TemporalQueries.zone()?this.offset():_query===TemporalQueries.localTime()?this._time:_query===TemporalQueries.chronology()||_query===TemporalQueries.localDate()||_query===TemporalQueries.zoneId()?null:_Temporal.prototype.query.call(this,_query)},_proto.range=function(field){return field instanceof ChronoField?field===ChronoField.OFFSET_SECONDS?field.range():this._time.range(field):field.rangeRefinedBy(this)},_proto.toLocalTime=function(){return this._time},_proto.truncatedTo=function(unit){return this._withLocalTimeOffset(this._time.truncatedTo(unit),this._offset)},_proto.until=function(endExclusive,unit){requireNonNull(endExclusive,"endExclusive"),requireNonNull(unit,"unit");var end=OffsetTime.from(endExclusive);if(unit instanceof ChronoUnit){var nanosUntil=end._toEpochNano()-this._toEpochNano();switch(unit){case ChronoUnit.NANOS:return nanosUntil;case ChronoUnit.MICROS:return MathUtil.intDiv(nanosUntil,1e3);case ChronoUnit.MILLIS:return MathUtil.intDiv(nanosUntil,1e6);case ChronoUnit.SECONDS:return MathUtil.intDiv(nanosUntil,LocalTime.NANOS_PER_SECOND);case ChronoUnit.MINUTES:return MathUtil.intDiv(nanosUntil,LocalTime.NANOS_PER_MINUTE);case ChronoUnit.HOURS:return MathUtil.intDiv(nanosUntil,LocalTime.NANOS_PER_HOUR);case ChronoUnit.HALF_DAYS:return MathUtil.intDiv(nanosUntil,12*LocalTime.NANOS_PER_HOUR)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.between(this,end)},_proto.withHour=function(hour){return this._withLocalTimeOffset(this._time.withHour(hour),this._offset)},_proto.withMinute=function(minute){return this._withLocalTimeOffset(this._time.withMinute(minute),this._offset)},_proto.withSecond=function(second){return this._withLocalTimeOffset(this._time.withSecond(second),this._offset)},_proto.withNano=function(nano){return this._withLocalTimeOffset(this._time.withNano(nano),this._offset)},_proto.withOffsetSameInstant=function(offset){if(requireNonNull(offset,"offset"),offset.equals(this._offset))return this;var difference=offset.totalSeconds()-this._offset.totalSeconds();return new OffsetTime(this._time.plusSeconds(difference),offset)},_proto.withOffsetSameLocal=function(offset){return null!=offset&&offset.equals(this._offset)?this:new OffsetTime(this._time,offset)},_proto._toEpochNano=function(){return this._time.toNanoOfDay()-this._offset.totalSeconds()*LocalTime.NANOS_PER_SECOND},_proto._withAdjuster=function(adjuster){return requireNonNull(adjuster,"adjuster"),adjuster instanceof LocalTime?this._withLocalTimeOffset(adjuster,this._offset):adjuster instanceof ZoneOffset?this._withLocalTimeOffset(this._time,adjuster):adjuster instanceof OffsetTime?adjuster:adjuster.adjustInto(this)},_proto._withField=function(field,newValue){return requireNonNull(field,"field"),field instanceof ChronoField?field===ChronoField.OFFSET_SECONDS?this._withLocalTimeOffset(this._time,ZoneOffset.ofTotalSeconds(field.checkValidIntValue(newValue))):this._withLocalTimeOffset(this._time.with(field,newValue),this._offset):field.adjustInto(this,newValue)},_proto._withLocalTimeOffset=function(time,offset){return this._time===time&&this._offset.equals(offset)?this:new OffsetTime(time,offset)},_proto.compareTo=function(other){if(requireNonNull(other,"other"),requireInstance(other,OffsetTime,"other"),this._offset.equals(other._offset))return this._time.compareTo(other._time);var compare=MathUtil.compareNumbers(this._toEpochNano(),other._toEpochNano());return 0===compare?this._time.compareTo(other._time):compare},_proto.equals=function(other){return this===other||other instanceof OffsetTime&&(this._time.equals(other._time)&&this._offset.equals(other._offset))},_proto.hashCode=function(){return this._time.hashCode()^this._offset.hashCode()},_proto.toString=function(){return this._time.toString()+this._offset.toString()},_proto.toJSON=function(){return this.toString()},OffsetTime}(Temporal);function _init$8(){OffsetTime.MIN=OffsetTime.ofNumbers(0,0,0,0,ZoneOffset.MAX),OffsetTime.MAX=OffsetTime.ofNumbers(23,59,59,999999999,ZoneOffset.MIN),OffsetTime.FROM=createTemporalQuery("OffsetTime.FROM",(function(temporal){return OffsetTime.from(temporal)}))}var ChronoZonedDateTime=function(_Temporal){function ChronoZonedDateTime(){return _Temporal.apply(this,arguments)||this}_inheritsLoose(ChronoZonedDateTime,_Temporal);var _proto=ChronoZonedDateTime.prototype;return _proto.query=function(_query){return _query===TemporalQueries.zoneId()||_query===TemporalQueries.zone()?this.zone():_query===TemporalQueries.chronology()?this.toLocalDate().chronology():_query===TemporalQueries.precision()?ChronoUnit.NANOS:_query===TemporalQueries.offset()?this.offset():_query===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toLocalDate().toEpochDay()):_query===TemporalQueries.localTime()?this.toLocalTime():_Temporal.prototype.query.call(this,_query)},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),formatter.format(this)},_proto.toInstant=function(){return Instant.ofEpochSecond(this.toEpochSecond(),this.toLocalTime().nano())},_proto.toEpochSecond=function(){var secs=86400*this.toLocalDate().toEpochDay()+this.toLocalTime().toSecondOfDay();return secs-=this.offset().totalSeconds()},_proto.compareTo=function(other){requireNonNull(other,"other");var cmp=MathUtil.compareNumbers(this.toEpochSecond(),other.toEpochSecond());return 0===cmp&&0===(cmp=this.toLocalTime().nano()-other.toLocalTime().nano())&&0===(cmp=this.toLocalDateTime().compareTo(other.toLocalDateTime()))&&(cmp=strcmp(this.zone().id(),other.zone().id())),cmp},_proto.isAfter=function(other){requireNonNull(other,"other");var thisEpochSec=this.toEpochSecond(),otherEpochSec=other.toEpochSecond();return thisEpochSec>otherEpochSec||thisEpochSec===otherEpochSec&&this.toLocalTime().nano()>other.toLocalTime().nano()},_proto.isBefore=function(other){requireNonNull(other,"other");var thisEpochSec=this.toEpochSecond(),otherEpochSec=other.toEpochSecond();return thisEpochSec<otherEpochSec||thisEpochSec===otherEpochSec&&this.toLocalTime().nano()<other.toLocalTime().nano()},_proto.isEqual=function(other){return requireNonNull(other,"other"),this.toEpochSecond()===other.toEpochSecond()&&this.toLocalTime().nano()===other.toLocalTime().nano()},_proto.equals=function(other){return this===other||other instanceof ChronoZonedDateTime&&0===this.compareTo(other)},ChronoZonedDateTime}(Temporal);function strcmp(a,b){return a<b?-1:a>b?1:0}var ZonedDateTime=function(_ChronoZonedDateTime){function ZonedDateTime(dateTime,offset,zone){var _this;return requireNonNull(dateTime,"dateTime"),requireNonNull(offset,"offset"),requireNonNull(zone,"zone"),(_this=_ChronoZonedDateTime.call(this)||this)._dateTime=dateTime,_this._offset=offset,_this._zone=zone,_this}_inheritsLoose(ZonedDateTime,_ChronoZonedDateTime),ZonedDateTime.now=function(clockOrZone){var clock;return clock=clockOrZone instanceof ZoneId?Clock.system(clockOrZone):null==clockOrZone?Clock.systemDefaultZone():clockOrZone,ZonedDateTime.ofInstant(clock.instant(),clock.zone())},ZonedDateTime.of=function(){return arguments.length<=2?ZonedDateTime.of2.apply(this,arguments):3===arguments.length&&arguments[0]instanceof LocalDate?ZonedDateTime.of3.apply(this,arguments):ZonedDateTime.of8.apply(this,arguments)},ZonedDateTime.of3=function(date,time,zone){return ZonedDateTime.of2(LocalDateTime.of(date,time),zone)},ZonedDateTime.of2=function(localDateTime,zone){return ZonedDateTime.ofLocal(localDateTime,zone,null)},ZonedDateTime.of8=function(year,month,dayOfMonth,hour,minute,second,nanoOfSecond,zone){var dt=LocalDateTime.of(year,month,dayOfMonth,hour,minute,second,nanoOfSecond);return ZonedDateTime.ofLocal(dt,zone,null)},ZonedDateTime.ofLocal=function(localDateTime,zone,preferredOffset){if(requireNonNull(localDateTime,"localDateTime"),requireNonNull(zone,"zone"),zone instanceof ZoneOffset)return new ZonedDateTime(localDateTime,zone,zone);var offset=null,rules=zone.rules(),validOffsets=rules.validOffsets(localDateTime);if(1===validOffsets.length)offset=validOffsets[0];else if(0===validOffsets.length){var trans=rules.transition(localDateTime);localDateTime=localDateTime.plusSeconds(trans.duration().seconds()),offset=trans.offsetAfter()}else offset=null!=preferredOffset&&validOffsets.some((function(validOffset){return validOffset.equals(preferredOffset)}))?preferredOffset:requireNonNull(validOffsets[0],"offset");return new ZonedDateTime(localDateTime,offset,zone)},ZonedDateTime.ofInstant=function(){return 2===arguments.length?ZonedDateTime.ofInstant2.apply(this,arguments):ZonedDateTime.ofInstant3.apply(this,arguments)},ZonedDateTime.ofInstant2=function(instant,zone){return requireNonNull(instant,"instant"),requireNonNull(zone,"zone"),ZonedDateTime._create(instant.epochSecond(),instant.nano(),zone)},ZonedDateTime.ofInstant3=function(localDateTime,offset,zone){return requireNonNull(localDateTime,"localDateTime"),requireNonNull(offset,"offset"),requireNonNull(zone,"zone"),ZonedDateTime._create(localDateTime.toEpochSecond(offset),localDateTime.nano(),zone)},ZonedDateTime._create=function(epochSecond,nanoOfSecond,zone){var rules=zone.rules(),instant=Instant.ofEpochSecond(epochSecond,nanoOfSecond),offset=rules.offset(instant);return new ZonedDateTime(LocalDateTime.ofEpochSecond(epochSecond,nanoOfSecond,offset),offset,zone)},ZonedDateTime.ofStrict=function(localDateTime,offset,zone){requireNonNull(localDateTime,"localDateTime"),requireNonNull(offset,"offset"),requireNonNull(zone,"zone");var rules=zone.rules();if(!1===rules.isValidOffset(localDateTime,offset)){var trans=rules.transition(localDateTime);if(null!=trans&&trans.isGap())throw new DateTimeException("LocalDateTime "+localDateTime+" does not exist in zone "+zone+" due to a gap in the local time-line, typically caused by daylight savings");throw new DateTimeException('ZoneOffset "'+offset+'" is not valid for LocalDateTime "'+localDateTime+'" in zone "'+zone+'"')}return new ZonedDateTime(localDateTime,offset,zone)},ZonedDateTime.ofLenient=function(localDateTime,offset,zone){if(requireNonNull(localDateTime,"localDateTime"),requireNonNull(offset,"offset"),requireNonNull(zone,"zone"),zone instanceof ZoneOffset&&!1===offset.equals(zone))throw new IllegalArgumentException("ZoneId must match ZoneOffset");return new ZonedDateTime(localDateTime,offset,zone)},ZonedDateTime.from=function(temporal){if(requireNonNull(temporal,"temporal"),temporal instanceof ZonedDateTime)return temporal;var zone=ZoneId.from(temporal);if(temporal.isSupported(ChronoField.INSTANT_SECONDS)){var zdt=ZonedDateTime._from(temporal,zone);if(null!=zdt)return zdt}var ldt=LocalDateTime.from(temporal);return ZonedDateTime.of2(ldt,zone)},ZonedDateTime._from=function(temporal,zone){try{return ZonedDateTime.__from(temporal,zone)}catch(ex){if(!(ex instanceof DateTimeException))throw ex}},ZonedDateTime.__from=function(temporal,zone){var epochSecond=temporal.getLong(ChronoField.INSTANT_SECONDS),nanoOfSecond=temporal.get(ChronoField.NANO_OF_SECOND);return ZonedDateTime._create(epochSecond,nanoOfSecond,zone)},ZonedDateTime.parse=function(text,formatter){return void 0===formatter&&(formatter=DateTimeFormatter.ISO_ZONED_DATE_TIME),requireNonNull(formatter,"formatter"),formatter.parse(text,ZonedDateTime.FROM)};var _proto=ZonedDateTime.prototype;return _proto._resolveLocal=function(newDateTime){return requireNonNull(newDateTime,"newDateTime"),ZonedDateTime.ofLocal(newDateTime,this._zone,this._offset)},_proto._resolveInstant=function(newDateTime){return ZonedDateTime.ofInstant3(newDateTime,this._offset,this._zone)},_proto._resolveOffset=function(offset){return!1===offset.equals(this._offset)&&this._zone.rules().isValidOffset(this._dateTime,offset)?new ZonedDateTime(this._dateTime,offset,this._zone):this},_proto.isSupported=function(fieldOrUnit){return fieldOrUnit instanceof ChronoField||(fieldOrUnit instanceof ChronoUnit?fieldOrUnit.isDateBased()||fieldOrUnit.isTimeBased():null!=fieldOrUnit&&fieldOrUnit.isSupportedBy(this))},_proto.range=function(field){return field instanceof ChronoField?field===ChronoField.INSTANT_SECONDS||field===ChronoField.OFFSET_SECONDS?field.range():this._dateTime.range(field):field.rangeRefinedBy(this)},_proto.get=function(field){return this.getLong(field)},_proto.getLong=function(field){if(field instanceof ChronoField){switch(field){case ChronoField.INSTANT_SECONDS:return this.toEpochSecond();case ChronoField.OFFSET_SECONDS:return this._offset.totalSeconds()}return this._dateTime.getLong(field)}return requireNonNull(field,"field"),field.getFrom(this)},_proto.offset=function(){return this._offset},_proto.withEarlierOffsetAtOverlap=function(){var trans=this._zone.rules().transition(this._dateTime);if(null!=trans&&trans.isOverlap()){var earlierOffset=trans.offsetBefore();if(!1===earlierOffset.equals(this._offset))return new ZonedDateTime(this._dateTime,earlierOffset,this._zone)}return this},_proto.withLaterOffsetAtOverlap=function(){var trans=this._zone.rules().transition(this.toLocalDateTime());if(null!=trans){var laterOffset=trans.offsetAfter();if(!1===laterOffset.equals(this._offset))return new ZonedDateTime(this._dateTime,laterOffset,this._zone)}return this},_proto.zone=function(){return this._zone},_proto.withZoneSameLocal=function(zone){return requireNonNull(zone,"zone"),this._zone.equals(zone)?this:ZonedDateTime.ofLocal(this._dateTime,zone,this._offset)},_proto.withZoneSameInstant=function(zone){return requireNonNull(zone,"zone"),this._zone.equals(zone)?this:ZonedDateTime._create(this._dateTime.toEpochSecond(this._offset),this._dateTime.nano(),zone)},_proto.withFixedOffsetZone=function(){return this._zone.equals(this._offset)?this:new ZonedDateTime(this._dateTime,this._offset,this._offset)},_proto.year=function(){return this._dateTime.year()},_proto.monthValue=function(){return this._dateTime.monthValue()},_proto.month=function(){return this._dateTime.month()},_proto.dayOfMonth=function(){return this._dateTime.dayOfMonth()},_proto.dayOfYear=function(){return this._dateTime.dayOfYear()},_proto.dayOfWeek=function(){return this._dateTime.dayOfWeek()},_proto.hour=function(){return this._dateTime.hour()},_proto.minute=function(){return this._dateTime.minute()},_proto.second=function(){return this._dateTime.second()},_proto.nano=function(){return this._dateTime.nano()},_proto._withAdjuster=function(adjuster){if(adjuster instanceof LocalDate)return this._resolveLocal(LocalDateTime.of(adjuster,this._dateTime.toLocalTime()));if(adjuster instanceof LocalTime)return this._resolveLocal(LocalDateTime.of(this._dateTime.toLocalDate(),adjuster));if(adjuster instanceof LocalDateTime)return this._resolveLocal(adjuster);if(adjuster instanceof Instant){var instant=adjuster;return ZonedDateTime._create(instant.epochSecond(),instant.nano(),this._zone)}return adjuster instanceof ZoneOffset?this._resolveOffset(adjuster):_ChronoZonedDateTime.prototype._withAdjuster.call(this,adjuster)},_proto._withField=function(field,newValue){if(field instanceof ChronoField){switch(field){case ChronoField.INSTANT_SECONDS:return ZonedDateTime._create(newValue,this.nano(),this._zone);case ChronoField.OFFSET_SECONDS:var offset=ZoneOffset.ofTotalSeconds(field.checkValidIntValue(newValue));return this._resolveOffset(offset)}return this._resolveLocal(this._dateTime.with(field,newValue))}return field.adjustInto(this,newValue)},_proto.withYear=function(year){return this._resolveLocal(this._dateTime.withYear(year))},_proto.withMonth=function(month){return this._resolveLocal(this._dateTime.withMonth(month))},_proto.withDayOfMonth=function(dayOfMonth){return this._resolveLocal(this._dateTime.withDayOfMonth(dayOfMonth))},_proto.withDayOfYear=function(dayOfYear){return this._resolveLocal(this._dateTime.withDayOfYear(dayOfYear))},_proto.withHour=function(hour){return this._resolveLocal(this._dateTime.withHour(hour))},_proto.withMinute=function(minute){return this._resolveLocal(this._dateTime.withMinute(minute))},_proto.withSecond=function(second){return this._resolveLocal(this._dateTime.withSecond(second))},_proto.withNano=function(nanoOfSecond){return this._resolveLocal(this._dateTime.withNano(nanoOfSecond))},_proto.truncatedTo=function(unit){return this._resolveLocal(this._dateTime.truncatedTo(unit))},_proto._plusUnit=function(amountToAdd,unit){return unit instanceof ChronoUnit?unit.isDateBased()?this._resolveLocal(this._dateTime.plus(amountToAdd,unit)):this._resolveInstant(this._dateTime.plus(amountToAdd,unit)):(requireNonNull(unit,"unit"),unit.addTo(this,amountToAdd))},_proto.plusYears=function(years){return this._resolveLocal(this._dateTime.plusYears(years))},_proto.plusMonths=function(months){return this._resolveLocal(this._dateTime.plusMonths(months))},_proto.plusWeeks=function(weeks){return this._resolveLocal(this._dateTime.plusWeeks(weeks))},_proto.plusDays=function(days){return this._resolveLocal(this._dateTime.plusDays(days))},_proto.plusHours=function(hours){return this._resolveInstant(this._dateTime.plusHours(hours))},_proto.plusMinutes=function(minutes){return this._resolveInstant(this._dateTime.plusMinutes(minutes))},_proto.plusSeconds=function(seconds){return this._resolveInstant(this._dateTime.plusSeconds(seconds))},_proto.plusNanos=function(nanos){return this._resolveInstant(this._dateTime.plusNanos(nanos))},_proto._minusUnit=function(amountToSubtract,unit){return this._plusUnit(-1*amountToSubtract,unit)},_proto.minusYears=function(years){return this.plusYears(-1*years)},_proto.minusMonths=function(months){return this.plusMonths(-1*months)},_proto.minusWeeks=function(weeks){return this.plusWeeks(-1*weeks)},_proto.minusDays=function(days){return this.plusDays(-1*days)},_proto.minusHours=function(hours){return this.plusHours(-1*hours)},_proto.minusMinutes=function(minutes){return this.plusMinutes(-1*minutes)},_proto.minusSeconds=function(seconds){return this.plusSeconds(-1*seconds)},_proto.minusNanos=function(nanos){return this.plusNanos(-1*nanos)},_proto.query=function(_query){return _query===TemporalQueries.localDate()?this.toLocalDate():(requireNonNull(_query,"query"),_ChronoZonedDateTime.prototype.query.call(this,_query))},_proto.until=function(endExclusive,unit){var end=ZonedDateTime.from(endExclusive);if(unit instanceof ChronoUnit){if(end=end.withZoneSameInstant(this._zone),unit.isDateBased())return this._dateTime.until(end._dateTime,unit);var difference=this._offset.totalSeconds()-end._offset.totalSeconds(),adjustedEnd=end._dateTime.plusSeconds(difference);return this._dateTime.until(adjustedEnd,unit)}return unit.between(this,end)},_proto.toLocalDateTime=function(){return this._dateTime},_proto.toLocalDate=function(){return this._dateTime.toLocalDate()},_proto.toLocalTime=function(){return this._dateTime.toLocalTime()},_proto.toOffsetDateTime=function(){return OffsetDateTime.of(this._dateTime,this._offset)},_proto.equals=function(other){return this===other||other instanceof ZonedDateTime&&(this._dateTime.equals(other._dateTime)&&this._offset.equals(other._offset)&&this._zone.equals(other._zone))},_proto.hashCode=function(){return MathUtil.hashCode(this._dateTime.hashCode(),this._offset.hashCode(),this._zone.hashCode())},_proto.toString=function(){var str=this._dateTime.toString()+this._offset.toString();return this._offset!==this._zone&&(str+="["+this._zone.toString()+"]"),str},_proto.toJSON=function(){return this.toString()},_proto.format=function(formatter){return _ChronoZonedDateTime.prototype.format.call(this,formatter)},ZonedDateTime}(ChronoZonedDateTime);function _init$7(){ZonedDateTime.FROM=createTemporalQuery("ZonedDateTime.FROM",(function(temporal){return ZonedDateTime.from(temporal)}))}var OffsetDateTime=function(_Temporal){function OffsetDateTime(dateTime,offset){var _this;return _this=_Temporal.call(this)||this,requireNonNull(dateTime,"dateTime"),requireInstance(dateTime,LocalDateTime,"dateTime"),requireNonNull(offset,"offset"),requireInstance(offset,ZoneOffset,"offset"),_this._dateTime=dateTime,_this._offset=offset,_this}_inheritsLoose(OffsetDateTime,_Temporal),OffsetDateTime.from=function(temporal){if(requireNonNull(temporal,"temporal"),temporal instanceof OffsetDateTime)return temporal;try{var offset=ZoneOffset.from(temporal);try{var ldt=LocalDateTime.from(temporal);return OffsetDateTime.of(ldt,offset)}catch(_){var instant=Instant.from(temporal);return OffsetDateTime.ofInstant(instant,offset)}}catch(ex){throw new DateTimeException("Unable to obtain OffsetDateTime TemporalAccessor: "+temporal+", type "+(null!=temporal.constructor?temporal.constructor.name:""))}},OffsetDateTime.now=function(clockOrZone){if(0===arguments.length)return OffsetDateTime.now(Clock.systemDefaultZone());if(requireNonNull(clockOrZone,"clockOrZone"),clockOrZone instanceof ZoneId)return OffsetDateTime.now(Clock.system(clockOrZone));if(clockOrZone instanceof Clock){var now=clockOrZone.instant();return OffsetDateTime.ofInstant(now,clockOrZone.zone().rules().offset(now))}throw new IllegalArgumentException("clockOrZone must be an instance of ZoneId or Clock")},OffsetDateTime.of=function(){return arguments.length<=2?OffsetDateTime.ofDateTime.apply(this,arguments):3===arguments.length?OffsetDateTime.ofDateAndTime.apply(this,arguments):OffsetDateTime.ofNumbers.apply(this,arguments)},OffsetDateTime.ofDateTime=function(dateTime,offset){return new OffsetDateTime(dateTime,offset)},OffsetDateTime.ofDateAndTime=function(date,time,offset){return new OffsetDateTime(LocalDateTime.of(date,time),offset)},OffsetDateTime.ofNumbers=function(year,month,dayOfMonth,hour,minute,second,nanoOfSecond,offset){return void 0===hour&&(hour=0),void 0===minute&&(minute=0),void 0===second&&(second=0),void 0===nanoOfSecond&&(nanoOfSecond=0),new OffsetDateTime(LocalDateTime.of(year,month,dayOfMonth,hour,minute,second,nanoOfSecond),offset)},OffsetDateTime.ofInstant=function(instant,zone){requireNonNull(instant,"instant"),requireNonNull(zone,"zone");var offset=zone.rules().offset(instant);return new OffsetDateTime(LocalDateTime.ofEpochSecond(instant.epochSecond(),instant.nano(),offset),offset)},OffsetDateTime.parse=function(text,formatter){return void 0===formatter&&(formatter=DateTimeFormatter.ISO_OFFSET_DATE_TIME),requireNonNull(formatter,"formatter"),formatter.parse(text,OffsetDateTime.FROM)};var _proto=OffsetDateTime.prototype;return _proto.adjustInto=function(temporal){return temporal.with(ChronoField.EPOCH_DAY,this.toLocalDate().toEpochDay()).with(ChronoField.NANO_OF_DAY,this.toLocalTime().toNanoOfDay()).with(ChronoField.OFFSET_SECONDS,this.offset().totalSeconds())},_proto.until=function(endExclusive,unit){var end=OffsetDateTime.from(endExclusive);return unit instanceof ChronoUnit?(end=end.withOffsetSameInstant(this._offset),this._dateTime.until(end._dateTime,unit)):unit.between(this,end)},_proto.atZoneSameInstant=function(zone){return ZonedDateTime.ofInstant(this._dateTime,this._offset,zone)},_proto.atZoneSimilarLocal=function(zone){return ZonedDateTime.ofLocal(this._dateTime,zone,this._offset)},_proto.query=function(_query){return requireNonNull(_query,"query"),_query===TemporalQueries.chronology()?IsoChronology.INSTANCE:_query===TemporalQueries.precision()?ChronoUnit.NANOS:_query===TemporalQueries.offset()||_query===TemporalQueries.zone()?this.offset():_query===TemporalQueries.localDate()?this.toLocalDate():_query===TemporalQueries.localTime()?this.toLocalTime():_query===TemporalQueries.zoneId()?null:_Temporal.prototype.query.call(this,_query)},_proto.get=function(field){if(field instanceof ChronoField){switch(field){case ChronoField.INSTANT_SECONDS:throw new DateTimeException("Field too large for an int: "+field);case ChronoField.OFFSET_SECONDS:return this.offset().totalSeconds()}return this._dateTime.get(field)}return _Temporal.prototype.get.call(this,field)},_proto.getLong=function(field){if(field instanceof ChronoField){switch(field){case ChronoField.INSTANT_SECONDS:return this.toEpochSecond();case ChronoField.OFFSET_SECONDS:return this.offset().totalSeconds()}return this._dateTime.getLong(field)}return field.getFrom(this)},_proto.offset=function(){return this._offset},_proto.year=function(){return this._dateTime.year()},_proto.monthValue=function(){return this._dateTime.monthValue()},_proto.month=function(){return this._dateTime.month()},_proto.dayOfMonth=function(){return this._dateTime.dayOfMonth()},_proto.dayOfYear=function(){return this._dateTime.dayOfYear()},_proto.dayOfWeek=function(){return this._dateTime.dayOfWeek()},_proto.hour=function(){return this._dateTime.hour()},_proto.minute=function(){return this._dateTime.minute()},_proto.second=function(){return this._dateTime.second()},_proto.nano=function(){return this._dateTime.nano()},_proto.toLocalDateTime=function(){return this._dateTime},_proto.toLocalDate=function(){return this._dateTime.toLocalDate()},_proto.toLocalTime=function(){return this._dateTime.toLocalTime()},_proto.toOffsetTime=function(){return OffsetTime.of(this._dateTime.toLocalTime(),this._offset)},_proto.toZonedDateTime=function(){return ZonedDateTime.of(this._dateTime,this._offset)},_proto.toInstant=function(){return this._dateTime.toInstant(this._offset)},_proto.toEpochSecond=function(){return this._dateTime.toEpochSecond(this._offset)},_proto.isSupported=function(fieldOrUnit){return fieldOrUnit instanceof ChronoField||fieldOrUnit instanceof ChronoUnit?fieldOrUnit.isDateBased()||fieldOrUnit.isTimeBased():null!=fieldOrUnit&&fieldOrUnit.isSupportedBy(this)},_proto.range=function(field){return field instanceof ChronoField?field===ChronoField.INSTANT_SECONDS||field===ChronoField.OFFSET_SECONDS?field.range():this._dateTime.range(field):field.rangeRefinedBy(this)},_proto._withAdjuster=function(adjuster){return requireNonNull(adjuster),adjuster instanceof LocalDate||adjuster instanceof LocalTime||adjuster instanceof LocalDateTime?this._withDateTimeOffset(this._dateTime.with(adjuster),this._offset):adjuster instanceof Instant?OffsetDateTime.ofInstant(adjuster,this._offset):adjuster instanceof ZoneOffset?this._withDateTimeOffset(this._dateTime,adjuster):adjuster instanceof OffsetDateTime?adjuster:adjuster.adjustInto(this)},_proto._withField=function(field,newValue){if(requireNonNull(field),field instanceof ChronoField){var f=field;switch(f){case ChronoField.INSTANT_SECONDS:return OffsetDateTime.ofInstant(Instant.ofEpochSecond(newValue,this.nano()),this._offset);case ChronoField.OFFSET_SECONDS:return this._withDateTimeOffset(this._dateTime,ZoneOffset.ofTotalSeconds(f.checkValidIntValue(newValue)))}return this._withDateTimeOffset(this._dateTime.with(field,newValue),this._offset)}return field.adjustInto(this,newValue)},_proto._withDateTimeOffset=function(dateTime,offset){return this._dateTime===dateTime&&this._offset.equals(offset)?this:new OffsetDateTime(dateTime,offset)},_proto.withYear=function(year){return this._withDateTimeOffset(this._dateTime.withYear(year),this._offset)},_proto.withMonth=function(month){return this._withDateTimeOffset(this._dateTime.withMonth(month),this._offset)},_proto.withDayOfMonth=function(dayOfMonth){return this._withDateTimeOffset(this._dateTime.withDayOfMonth(dayOfMonth),this._offset)},_proto.withDayOfYear=function(dayOfYear){return this._withDateTimeOffset(this._dateTime.withDayOfYear(dayOfYear),this._offset)},_proto.withHour=function(hour){return this._withDateTimeOffset(this._dateTime.withHour(hour),this._offset)},_proto.withMinute=function(minute){return this._withDateTimeOffset(this._dateTime.withMinute(minute),this._offset)},_proto.withSecond=function(second){return this._withDateTimeOffset(this._dateTime.withSecond(second),this._offset)},_proto.withNano=function(nanoOfSecond){return this._withDateTimeOffset(this._dateTime.withNano(nanoOfSecond),this._offset)},_proto.withOffsetSameLocal=function(offset){return requireNonNull(offset,"offset"),this._withDateTimeOffset(this._dateTime,offset)},_proto.withOffsetSameInstant=function(offset){if(requireNonNull(offset,"offset"),offset.equals(this._offset))return this;var difference=offset.totalSeconds()-this._offset.totalSeconds();return new OffsetDateTime(this._dateTime.plusSeconds(difference),offset)},_proto.truncatedTo=function(unit){return this._withDateTimeOffset(this._dateTime.truncatedTo(unit),this._offset)},_proto._plusAmount=function(amount){return requireNonNull(amount,"amount"),amount.addTo(this)},_proto._plusUnit=function(amountToAdd,unit){return unit instanceof ChronoUnit?this._withDateTimeOffset(this._dateTime.plus(amountToAdd,unit),this._offset):unit.addTo(this,amountToAdd)},_proto.plusYears=function(years){return this._withDateTimeOffset(this._dateTime.plusYears(years),this._offset)},_proto.plusMonths=function(months){return this._withDateTimeOffset(this._dateTime.plusMonths(months),this._offset)},_proto.plusWeeks=function(weeks){return this._withDateTimeOffset(this._dateTime.plusWeeks(weeks),this._offset)},_proto.plusDays=function(days){return this._withDateTimeOffset(this._dateTime.plusDays(days),this._offset)},_proto.plusHours=function(hours){return this._withDateTimeOffset(this._dateTime.plusHours(hours),this._offset)},_proto.plusMinutes=function(minutes){return this._withDateTimeOffset(this._dateTime.plusMinutes(minutes),this._offset)},_proto.plusSeconds=function(seconds){return this._withDateTimeOffset(this._dateTime.plusSeconds(seconds),this._offset)},_proto.plusNanos=function(nanos){return this._withDateTimeOffset(this._dateTime.plusNanos(nanos),this._offset)},_proto._minusAmount=function(amount){return requireNonNull(amount),amount.subtractFrom(this)},_proto._minusUnit=function(amountToSubtract,unit){return this.plus(-1*amountToSubtract,unit)},_proto.minusYears=function(years){return this._withDateTimeOffset(this._dateTime.minusYears(years),this._offset)},_proto.minusMonths=function(months){return this._withDateTimeOffset(this._dateTime.minusMonths(months),this._offset)},_proto.minusWeeks=function(weeks){return this._withDateTimeOffset(this._dateTime.minusWeeks(weeks),this._offset)},_proto.minusDays=function(days){return this._withDateTimeOffset(this._dateTime.minusDays(days),this._offset)},_proto.minusHours=function(hours){return this._withDateTimeOffset(this._dateTime.minusHours(hours),this._offset)},_proto.minusMinutes=function(minutes){return this._withDateTimeOffset(this._dateTime.minusMinutes(minutes),this._offset)},_proto.minusSeconds=function(seconds){return this._withDateTimeOffset(this._dateTime.minusSeconds(seconds),this._offset)},_proto.minusNanos=function(nanos){return this._withDateTimeOffset(this._dateTime.minusNanos(nanos),this._offset)},_proto.compareTo=function(other){if(requireNonNull(other,"other"),requireInstance(other,OffsetDateTime,"other"),this.offset().equals(other.offset()))return this.toLocalDateTime().compareTo(other.toLocalDateTime());var cmp=MathUtil.compareNumbers(this.toEpochSecond(),other.toEpochSecond());return 0===cmp&&0===(cmp=this.toLocalTime().nano()-other.toLocalTime().nano())&&(cmp=this.toLocalDateTime().compareTo(other.toLocalDateTime())),cmp},_proto.isAfter=function(other){requireNonNull(other,"other");var thisEpochSec=this.toEpochSecond(),otherEpochSec=other.toEpochSecond();return thisEpochSec>otherEpochSec||thisEpochSec===otherEpochSec&&this.toLocalTime().nano()>other.toLocalTime().nano()},_proto.isBefore=function(other){requireNonNull(other,"other");var thisEpochSec=this.toEpochSecond(),otherEpochSec=other.toEpochSecond();return thisEpochSec<otherEpochSec||thisEpochSec===otherEpochSec&&this.toLocalTime().nano()<other.toLocalTime().nano()},_proto.isEqual=function(other){return requireNonNull(other,"other"),this.toEpochSecond()===other.toEpochSecond()&&this.toLocalTime().nano()===other.toLocalTime().nano()},_proto.equals=function(other){return this===other||other instanceof OffsetDateTime&&(this._dateTime.equals(other._dateTime)&&this._offset.equals(other._offset))},_proto.hashCode=function(){return this._dateTime.hashCode()^this._offset.hashCode()},_proto.toString=function(){return this._dateTime.toString()+this._offset.toString()},_proto.toJSON=function(){return this.toString()},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),formatter.format(this)},OffsetDateTime}(Temporal);function _init$6(){OffsetDateTime.MIN=LocalDateTime.MIN.atOffset(ZoneOffset.MAX),OffsetDateTime.MAX=LocalDateTime.MAX.atOffset(ZoneOffset.MIN),OffsetDateTime.FROM=createTemporalQuery("OffsetDateTime.FROM",(function(temporal){return OffsetDateTime.from(temporal)}))}var DAYS_PER_CYCLE=146097,DAYS_0000_TO_1970=5*DAYS_PER_CYCLE-10957,LocalDate=function(_ChronoLocalDate){function LocalDate(year,month,dayOfMonth){var _this;return _this=_ChronoLocalDate.call(this)||this,requireNonNull(year,"year"),requireNonNull(month,"month"),requireNonNull(dayOfMonth,"dayOfMonth"),month instanceof Month&&(month=month.value()),_this._year=MathUtil.safeToInt(year),_this._month=MathUtil.safeToInt(month),_this._day=MathUtil.safeToInt(dayOfMonth),LocalDate._validate(_this._year,_this._month,_this._day),_this}_inheritsLoose(LocalDate,_ChronoLocalDate),LocalDate.now=function(clockOrZone){var clock;return clock=null==clockOrZone?Clock.systemDefaultZone():clockOrZone instanceof ZoneId?Clock.system(clockOrZone):clockOrZone,LocalDate.ofInstant(clock.instant(),clock.zone())},LocalDate.ofInstant=function(instant,zone){void 0===zone&&(zone=ZoneId.systemDefault()),requireNonNull(instant,"instant");var offset=zone.rules().offset(instant),epochSec=instant.epochSecond()+offset.totalSeconds(),epochDay=MathUtil.floorDiv(epochSec,LocalTime.SECONDS_PER_DAY);return LocalDate.ofEpochDay(epochDay)},LocalDate.of=function(year,month,dayOfMonth){return new LocalDate(year,month,dayOfMonth)},LocalDate.ofYearDay=function(year,dayOfYear){ChronoField.YEAR.checkValidValue(year);var leap=IsoChronology.isLeapYear(year);366===dayOfYear&&!1===leap&&assert(!1,"Invalid date 'DayOfYear 366' as '"+year+"' is not a leap year",DateTimeException);var moy=Month.of(Math.floor((dayOfYear-1)/31+1));dayOfYear>moy.firstDayOfYear(leap)+moy.length(leap)-1&&(moy=moy.plus(1));var dom=dayOfYear-moy.firstDayOfYear(leap)+1;return new LocalDate(year,moy.value(),dom)},LocalDate.ofEpochDay=function(epochDay){var adjust,adjustCycles,doyEst,yearEst,zeroDay;void 0===epochDay&&(epochDay=0),zeroDay=epochDay+DAYS_0000_TO_1970,adjust=0,(zeroDay-=60)<0&&(adjust=400*(adjustCycles=MathUtil.intDiv(zeroDay+1,DAYS_PER_CYCLE)-1),zeroDay+=-adjustCycles*DAYS_PER_CYCLE),(doyEst=zeroDay-(365*(yearEst=MathUtil.intDiv(400*zeroDay+591,DAYS_PER_CYCLE))+MathUtil.intDiv(yearEst,4)-MathUtil.intDiv(yearEst,100)+MathUtil.intDiv(yearEst,400)))<0&&(doyEst=zeroDay-(365*--yearEst+MathUtil.intDiv(yearEst,4)-MathUtil.intDiv(yearEst,100)+MathUtil.intDiv(yearEst,400))),yearEst+=adjust;var marchDoy0=doyEst,marchMonth0=MathUtil.intDiv(5*marchDoy0+2,153),month=(marchMonth0+2)%12+1,dom=marchDoy0-MathUtil.intDiv(306*marchMonth0+5,10)+1;return new LocalDate(yearEst+=MathUtil.intDiv(marchMonth0,10),month,dom)},LocalDate.from=function(temporal){requireNonNull(temporal,"temporal");var date=temporal.query(TemporalQueries.localDate());if(null==date)throw new DateTimeException("Unable to obtain LocalDate from TemporalAccessor: "+temporal+", type "+(null!=temporal.constructor?temporal.constructor.name:""));return date},LocalDate.parse=function(text,formatter){return void 0===formatter&&(formatter=DateTimeFormatter.ISO_LOCAL_DATE),assert(null!=formatter,"formatter",NullPointerException),formatter.parse(text,LocalDate.FROM)},LocalDate._resolvePreviousValid=function(year,month,day){switch(month){case 2:day=Math.min(day,IsoChronology.isLeapYear(year)?29:28);break;case 4:case 6:case 9:case 11:day=Math.min(day,30)}return LocalDate.of(year,month,day)},LocalDate._validate=function(year,month,dayOfMonth){var dom;if(ChronoField.YEAR.checkValidValue(year),ChronoField.MONTH_OF_YEAR.checkValidValue(month),ChronoField.DAY_OF_MONTH.checkValidValue(dayOfMonth),dayOfMonth>28){switch(dom=31,month){case 2:dom=IsoChronology.isLeapYear(year)?29:28;break;case 4:case 6:case 9:case 11:dom=30}dayOfMonth>dom&&assert(!1,29===dayOfMonth?"Invalid date 'February 29' as '"+year+"' is not a leap year":"Invalid date '"+year+"' '"+month+"' '"+dayOfMonth+"'",DateTimeException)}};var _proto=LocalDate.prototype;return _proto.isSupported=function(field){return _ChronoLocalDate.prototype.isSupported.call(this,field)},_proto.range=function(field){if(field instanceof ChronoField){if(field.isDateBased()){switch(field){case ChronoField.DAY_OF_MONTH:return ValueRange.of(1,this.lengthOfMonth());case ChronoField.DAY_OF_YEAR:return ValueRange.of(1,this.lengthOfYear());case ChronoField.ALIGNED_WEEK_OF_MONTH:return ValueRange.of(1,this.month()===Month.FEBRUARY&&!1===this.isLeapYear()?4:5);case ChronoField.YEAR_OF_ERA:return this._year<=0?ValueRange.of(1,Year.MAX_VALUE+1):ValueRange.of(1,Year.MAX_VALUE)}return field.range()}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.rangeRefinedBy(this)},_proto.get=function(field){return this.getLong(field)},_proto.getLong=function(field){return assert(null!=field,"",NullPointerException),field instanceof ChronoField?this._get0(field):field.getFrom(this)},_proto._get0=function(field){switch(field){case ChronoField.DAY_OF_WEEK:return this.dayOfWeek().value();case ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH:return MathUtil.intMod(this._day-1,7)+1;case ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR:return MathUtil.intMod(this.dayOfYear()-1,7)+1;case ChronoField.DAY_OF_MONTH:return this._day;case ChronoField.DAY_OF_YEAR:return this.dayOfYear();case ChronoField.EPOCH_DAY:return this.toEpochDay();case ChronoField.ALIGNED_WEEK_OF_MONTH:return MathUtil.intDiv(this._day-1,7)+1;case ChronoField.ALIGNED_WEEK_OF_YEAR:return MathUtil.intDiv(this.dayOfYear()-1,7)+1;case ChronoField.MONTH_OF_YEAR:return this._month;case ChronoField.PROLEPTIC_MONTH:return this._prolepticMonth();case ChronoField.YEAR_OF_ERA:return this._year>=1?this._year:1-this._year;case ChronoField.YEAR:return this._year;case ChronoField.ERA:return this._year>=1?1:0}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)},_proto._prolepticMonth=function(){return 12*this._year+(this._month-1)},_proto.chronology=function(){return IsoChronology.INSTANCE},_proto.year=function(){return this._year},_proto.monthValue=function(){return this._month},_proto.month=function(){return Month.of(this._month)},_proto.dayOfMonth=function(){return this._day},_proto.dayOfYear=function(){return this.month().firstDayOfYear(this.isLeapYear())+this._day-1},_proto.dayOfWeek=function(){var dow0=MathUtil.floorMod(this.toEpochDay()+3,7);return DayOfWeek.of(dow0+1)},_proto.isLeapYear=function(){return IsoChronology.isLeapYear(this._year)},_proto.lengthOfMonth=function(){switch(this._month){case 2:return this.isLeapYear()?29:28;case 4:case 6:case 9:case 11:return 30;default:return 31}},_proto.lengthOfYear=function(){return this.isLeapYear()?366:365},_proto._withAdjuster=function(adjuster){return requireNonNull(adjuster,"adjuster"),adjuster instanceof LocalDate?adjuster:_ChronoLocalDate.prototype._withAdjuster.call(this,adjuster)},_proto._withField=function(field,newValue){if(assert(null!=field,"field",NullPointerException),field instanceof ChronoField){var f=field;switch(f.checkValidValue(newValue),f){case ChronoField.DAY_OF_WEEK:return this.plusDays(newValue-this.dayOfWeek().value());case ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH:return this.plusDays(newValue-this.getLong(ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH));case ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR:return this.plusDays(newValue-this.getLong(ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR));case ChronoField.DAY_OF_MONTH:return this.withDayOfMonth(newValue);case ChronoField.DAY_OF_YEAR:return this.withDayOfYear(newValue);case ChronoField.EPOCH_DAY:return LocalDate.ofEpochDay(newValue);case ChronoField.ALIGNED_WEEK_OF_MONTH:return this.plusWeeks(newValue-this.getLong(ChronoField.ALIGNED_WEEK_OF_MONTH));case ChronoField.ALIGNED_WEEK_OF_YEAR:return this.plusWeeks(newValue-this.getLong(ChronoField.ALIGNED_WEEK_OF_YEAR));case ChronoField.MONTH_OF_YEAR:return this.withMonth(newValue);case ChronoField.PROLEPTIC_MONTH:return this.plusMonths(newValue-this.getLong(ChronoField.PROLEPTIC_MONTH));case ChronoField.YEAR_OF_ERA:return this.withYear(this._year>=1?newValue:1-newValue);case ChronoField.YEAR:return this.withYear(newValue);case ChronoField.ERA:return this.getLong(ChronoField.ERA)===newValue?this:this.withYear(1-this._year)}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.adjustInto(this,newValue)},_proto.withYear=function(year){return this._year===year?this:(ChronoField.YEAR.checkValidValue(year),LocalDate._resolvePreviousValid(year,this._month,this._day))},_proto.withMonth=function(month){var m=month instanceof Month?month.value():month;return this._month===m?this:(ChronoField.MONTH_OF_YEAR.checkValidValue(m),LocalDate._resolvePreviousValid(this._year,m,this._day))},_proto.withDayOfMonth=function(dayOfMonth){return this._day===dayOfMonth?this:LocalDate.of(this._year,this._month,dayOfMonth)},_proto.withDayOfYear=function(dayOfYear){return this.dayOfYear()===dayOfYear?this:LocalDate.ofYearDay(this._year,dayOfYear)},_proto._plusUnit=function(amountToAdd,unit){if(requireNonNull(amountToAdd,"amountToAdd"),requireNonNull(unit,"unit"),unit instanceof ChronoUnit){switch(unit){case ChronoUnit.DAYS:return this.plusDays(amountToAdd);case ChronoUnit.WEEKS:return this.plusWeeks(amountToAdd);case ChronoUnit.MONTHS:return this.plusMonths(amountToAdd);case ChronoUnit.YEARS:return this.plusYears(amountToAdd);case ChronoUnit.DECADES:return this.plusYears(MathUtil.safeMultiply(amountToAdd,10));case ChronoUnit.CENTURIES:return this.plusYears(MathUtil.safeMultiply(amountToAdd,100));case ChronoUnit.MILLENNIA:return this.plusYears(MathUtil.safeMultiply(amountToAdd,1e3));case ChronoUnit.ERAS:return this.with(ChronoField.ERA,MathUtil.safeAdd(this.getLong(ChronoField.ERA),amountToAdd))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.addTo(this,amountToAdd)},_proto.plusYears=function(yearsToAdd){if(0===yearsToAdd)return this;var newYear=ChronoField.YEAR.checkValidIntValue(this._year+yearsToAdd);return LocalDate._resolvePreviousValid(newYear,this._month,this._day)},_proto.plusMonths=function(monthsToAdd){if(0===monthsToAdd)return this;var calcMonths=12*this._year+(this._month-1)+monthsToAdd,newYear=ChronoField.YEAR.checkValidIntValue(MathUtil.floorDiv(calcMonths,12)),newMonth=MathUtil.floorMod(calcMonths,12)+1;return LocalDate._resolvePreviousValid(newYear,newMonth,this._day)},_proto.plusWeeks=function(weeksToAdd){return this.plusDays(MathUtil.safeMultiply(weeksToAdd,7))},_proto.plusDays=function(daysToAdd){if(0===daysToAdd)return this;var mjDay=MathUtil.safeAdd(this.toEpochDay(),daysToAdd);return LocalDate.ofEpochDay(mjDay)},_proto._minusUnit=function(amountToSubtract,unit){return requireNonNull(amountToSubtract,"amountToSubtract"),requireNonNull(unit,"unit"),this._plusUnit(-1*amountToSubtract,unit)},_proto.minusYears=function(yearsToSubtract){return this.plusYears(-1*yearsToSubtract)},_proto.minusMonths=function(monthsToSubtract){return this.plusMonths(-1*monthsToSubtract)},_proto.minusWeeks=function(weeksToSubtract){return this.plusWeeks(-1*weeksToSubtract)},_proto.minusDays=function(daysToSubtract){return this.plusDays(-1*daysToSubtract)},_proto.query=function(_query){return requireNonNull(_query,"query"),_query===TemporalQueries.localDate()?this:_ChronoLocalDate.prototype.query.call(this,_query)},_proto.adjustInto=function(temporal){return _ChronoLocalDate.prototype.adjustInto.call(this,temporal)},_proto.until=function(p1,p2){return arguments.length<2?this.until1(p1):this.until2(p1,p2)},_proto.until2=function(endExclusive,unit){var end=LocalDate.from(endExclusive);if(unit instanceof ChronoUnit){switch(unit){case ChronoUnit.DAYS:return this.daysUntil(end);case ChronoUnit.WEEKS:return MathUtil.intDiv(this.daysUntil(end),7);case ChronoUnit.MONTHS:return this._monthsUntil(end);case ChronoUnit.YEARS:return MathUtil.intDiv(this._monthsUntil(end),12);case ChronoUnit.DECADES:return MathUtil.intDiv(this._monthsUntil(end),120);case ChronoUnit.CENTURIES:return MathUtil.intDiv(this._monthsUntil(end),1200);case ChronoUnit.MILLENNIA:return MathUtil.intDiv(this._monthsUntil(end),12e3);case ChronoUnit.ERAS:return end.getLong(ChronoField.ERA)-this.getLong(ChronoField.ERA)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.between(this,end)},_proto.daysUntil=function(end){return end.toEpochDay()-this.toEpochDay()},_proto._monthsUntil=function(end){var packed1=32*this._prolepticMonth()+this.dayOfMonth(),packed2=32*end._prolepticMonth()+end.dayOfMonth();return MathUtil.intDiv(packed2-packed1,32)},_proto.until1=function(endDate){var end=LocalDate.from(endDate),totalMonths=end._prolepticMonth()-this._prolepticMonth(),days=end._day-this._day;if(totalMonths>0&&days<0){totalMonths--;var calcDate=this.plusMonths(totalMonths);days=end.toEpochDay()-calcDate.toEpochDay()}else totalMonths<0&&days>0&&(totalMonths++,days-=end.lengthOfMonth());var years=MathUtil.intDiv(totalMonths,12),months=MathUtil.intMod(totalMonths,12);return Period.of(years,months,days)},_proto.atTime=function(){return 1===arguments.length?this.atTime1.apply(this,arguments):this.atTime4.apply(this,arguments)},_proto.atTime1=function(time){if(requireNonNull(time,"time"),time instanceof LocalTime)return LocalDateTime.of(this,time);if(time instanceof OffsetTime)return this._atTimeOffsetTime(time);throw new IllegalArgumentException("time must be an instance of LocalTime or OffsetTime"+(time&&time.constructor&&time.constructor.name?", but is "+time.constructor.name:""))},_proto.atTime4=function(hour,minute,second,nanoOfSecond){return void 0===second&&(second=0),void 0===nanoOfSecond&&(nanoOfSecond=0),this.atTime1(LocalTime.of(hour,minute,second,nanoOfSecond))},_proto._atTimeOffsetTime=function(time){return OffsetDateTime.of(LocalDateTime.of(this,time.toLocalTime()),time.offset())},_proto.atStartOfDay=function(zone){return null!=zone?this._atStartOfDayWithZone(zone):LocalDateTime.of(this,LocalTime.MIDNIGHT)},_proto._atStartOfDayWithZone=function(zone){requireNonNull(zone,"zone");var ldt=this.atTime(LocalTime.MIDNIGHT);if(zone instanceof ZoneOffset==!1){var trans=zone.rules().transition(ldt);null!=trans&&trans.isGap()&&(ldt=trans.dateTimeAfter())}return ZonedDateTime.of(ldt,zone)},_proto.toEpochDay=function(){var y=this._year,m=this._month,total=0;return total+=365*y,y>=0?total+=MathUtil.intDiv(y+3,4)-MathUtil.intDiv(y+99,100)+MathUtil.intDiv(y+399,400):total-=MathUtil.intDiv(y,-4)-MathUtil.intDiv(y,-100)+MathUtil.intDiv(y,-400),total+=MathUtil.intDiv(367*m-362,12),total+=this.dayOfMonth()-1,m>2&&(total--,IsoChronology.isLeapYear(y)||total--),total-DAYS_0000_TO_1970},_proto.compareTo=function(other){return requireNonNull(other,"other"),requireInstance(other,LocalDate,"other"),this._compareTo0(other)},_proto._compareTo0=function(otherDate){var cmp=this._year-otherDate._year;return 0===cmp&&0===(cmp=this._month-otherDate._month)&&(cmp=this._day-otherDate._day),cmp},_proto.isAfter=function(other){return this.compareTo(other)>0},_proto.isBefore=function(other){return this.compareTo(other)<0},_proto.isEqual=function(other){return 0===this.compareTo(other)},_proto.equals=function(other){return this===other||other instanceof LocalDate&&0===this._compareTo0(other)},_proto.hashCode=function(){var yearValue=this._year,monthValue=this._month,dayValue=this._day;return MathUtil.hash(4294965248&yearValue^(yearValue<<11)+(monthValue<<6)+dayValue)},_proto.toString=function(){var yearValue=this._year,monthValue=this._month,dayValue=this._day;return(Math.abs(yearValue)<1e3?yearValue<0?"-"+(""+(yearValue-1e4)).slice(-4):(""+(yearValue+1e4)).slice(-4):yearValue>9999?"+"+yearValue:""+yearValue)+(monthValue<10?"-0"+monthValue:"-"+monthValue)+(dayValue<10?"-0"+dayValue:"-"+dayValue)},_proto.toJSON=function(){return this.toString()},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),requireInstance(formatter,DateTimeFormatter,"formatter"),_ChronoLocalDate.prototype.format.call(this,formatter)},LocalDate}(ChronoLocalDate);function _init$5(){LocalDate.MIN=LocalDate.of(YearConstants.MIN_VALUE,1,1),LocalDate.MAX=LocalDate.of(YearConstants.MAX_VALUE,12,31),LocalDate.EPOCH_0=LocalDate.ofEpochDay(0),LocalDate.FROM=createTemporalQuery("LocalDate.FROM",(function(temporal){return LocalDate.from(temporal)}))}var ChronoLocalDateTime=function(_Temporal){function ChronoLocalDateTime(){return _Temporal.apply(this,arguments)||this}_inheritsLoose(ChronoLocalDateTime,_Temporal);var _proto=ChronoLocalDateTime.prototype;return _proto.chronology=function(){return this.toLocalDate().chronology()},_proto.query=function(_query){return _query===TemporalQueries.chronology()?this.chronology():_query===TemporalQueries.precision()?ChronoUnit.NANOS:_query===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toLocalDate().toEpochDay()):_query===TemporalQueries.localTime()?this.toLocalTime():_query===TemporalQueries.zone()||_query===TemporalQueries.zoneId()||_query===TemporalQueries.offset()?null:_Temporal.prototype.query.call(this,_query)},_proto.adjustInto=function(temporal){return temporal.with(ChronoField.EPOCH_DAY,this.toLocalDate().toEpochDay()).with(ChronoField.NANO_OF_DAY,this.toLocalTime().toNanoOfDay())},_proto.toInstant=function(offset){return requireInstance(offset,ZoneOffset,"zoneId"),Instant.ofEpochSecond(this.toEpochSecond(offset),this.toLocalTime().nano())},_proto.toEpochSecond=function(offset){requireNonNull(offset,"offset");var secs=86400*this.toLocalDate().toEpochDay()+this.toLocalTime().toSecondOfDay();return secs-=offset.totalSeconds(),MathUtil.safeToInt(secs)},ChronoLocalDateTime}(Temporal),LocalDateTime=function(_ChronoLocalDateTime){function LocalDateTime(date,time){var _this;return _this=_ChronoLocalDateTime.call(this)||this,requireInstance(date,LocalDate,"date"),requireInstance(time,LocalTime,"time"),_this._date=date,_this._time=time,_this}_inheritsLoose(LocalDateTime,_ChronoLocalDateTime),LocalDateTime.now=function(clockOrZone){return null==clockOrZone?LocalDateTime._now(Clock.systemDefaultZone()):clockOrZone instanceof Clock?LocalDateTime._now(clockOrZone):LocalDateTime._now(Clock.system(clockOrZone))},LocalDateTime._now=function(clock){return requireNonNull(clock,"clock"),LocalDateTime.ofInstant(clock.instant(),clock.zone())},LocalDateTime._ofEpochMillis=function(epochMilli,offset){var localSecond=MathUtil.floorDiv(epochMilli,1e3)+offset.totalSeconds(),localEpochDay=MathUtil.floorDiv(localSecond,LocalTime.SECONDS_PER_DAY),secsOfDay=MathUtil.floorMod(localSecond,LocalTime.SECONDS_PER_DAY),nanoOfSecond=1e6*MathUtil.floorMod(epochMilli,1e3);return new LocalDateTime(LocalDate.ofEpochDay(localEpochDay),LocalTime.ofSecondOfDay(secsOfDay,nanoOfSecond))},LocalDateTime.of=function(){return arguments.length<=2?LocalDateTime.ofDateAndTime.apply(this,arguments):LocalDateTime.ofNumbers.apply(this,arguments)},LocalDateTime.ofNumbers=function(year,month,dayOfMonth,hour,minute,second,nanoOfSecond){return void 0===hour&&(hour=0),void 0===minute&&(minute=0),void 0===second&&(second=0),void 0===nanoOfSecond&&(nanoOfSecond=0),new LocalDateTime(LocalDate.of(year,month,dayOfMonth),LocalTime.of(hour,minute,second,nanoOfSecond))},LocalDateTime.ofDateAndTime=function(date,time){return requireNonNull(date,"date"),requireNonNull(time,"time"),new LocalDateTime(date,time)},LocalDateTime.ofInstant=function(instant,zone){void 0===zone&&(zone=ZoneId.systemDefault()),requireNonNull(instant,"instant"),requireInstance(instant,Instant,"instant"),requireNonNull(zone,"zone");var offset=zone.rules().offset(instant);return LocalDateTime.ofEpochSecond(instant.epochSecond(),instant.nano(),offset)},LocalDateTime.ofEpochSecond=function(epochSecond,nanoOfSecond,offset){void 0===epochSecond&&(epochSecond=0),void 0===nanoOfSecond&&(nanoOfSecond=0),2===arguments.length&&nanoOfSecond instanceof ZoneOffset&&(offset=nanoOfSecond,nanoOfSecond=0),requireNonNull(offset,"offset");var localSecond=epochSecond+offset.totalSeconds(),localEpochDay=MathUtil.floorDiv(localSecond,LocalTime.SECONDS_PER_DAY),secsOfDay=MathUtil.floorMod(localSecond,LocalTime.SECONDS_PER_DAY);return new LocalDateTime(LocalDate.ofEpochDay(localEpochDay),LocalTime.ofSecondOfDay(secsOfDay,nanoOfSecond))},LocalDateTime.from=function(temporal){if(requireNonNull(temporal,"temporal"),temporal instanceof LocalDateTime)return temporal;if(temporal instanceof ZonedDateTime)return temporal.toLocalDateTime();try{return new LocalDateTime(LocalDate.from(temporal),LocalTime.from(temporal))}catch(ex){throw new DateTimeException("Unable to obtain LocalDateTime TemporalAccessor: "+temporal+", type "+(null!=temporal.constructor?temporal.constructor.name:""))}},LocalDateTime.parse=function(text,formatter){return void 0===formatter&&(formatter=DateTimeFormatter.ISO_LOCAL_DATE_TIME),requireNonNull(formatter,"formatter"),formatter.parse(text,LocalDateTime.FROM)};var _proto=LocalDateTime.prototype;return _proto._withDateTime=function(newDate,newTime){return this._date.equals(newDate)&&this._time.equals(newTime)?this:new LocalDateTime(newDate,newTime)},_proto.isSupported=function(fieldOrUnit){return fieldOrUnit instanceof ChronoField||fieldOrUnit instanceof ChronoUnit?fieldOrUnit.isDateBased()||fieldOrUnit.isTimeBased():null!=fieldOrUnit&&fieldOrUnit.isSupportedBy(this)},_proto.range=function(field){return field instanceof ChronoField?field.isTimeBased()?this._time.range(field):this._date.range(field):field.rangeRefinedBy(this)},_proto.get=function(field){return field instanceof ChronoField?field.isTimeBased()?this._time.get(field):this._date.get(field):_ChronoLocalDateTime.prototype.get.call(this,field)},_proto.getLong=function(field){return requireNonNull(field,"field"),field instanceof ChronoField?field.isTimeBased()?this._time.getLong(field):this._date.getLong(field):field.getFrom(this)},_proto.year=function(){return this._date.year()},_proto.monthValue=function(){return this._date.monthValue()},_proto.month=function(){return this._date.month()},_proto.dayOfMonth=function(){return this._date.dayOfMonth()},_proto.dayOfYear=function(){return this._date.dayOfYear()},_proto.dayOfWeek=function(){return this._date.dayOfWeek()},_proto.hour=function(){return this._time.hour()},_proto.minute=function(){return this._time.minute()},_proto.second=function(){return this._time.second()},_proto.nano=function(){return this._time.nano()},_proto._withAdjuster=function(adjuster){return requireNonNull(adjuster,"adjuster"),adjuster instanceof LocalDate?this._withDateTime(adjuster,this._time):adjuster instanceof LocalTime?this._withDateTime(this._date,adjuster):adjuster instanceof LocalDateTime?adjuster:_ChronoLocalDateTime.prototype._withAdjuster.call(this,adjuster)},_proto._withField=function(field,newValue){return requireNonNull(field,"field"),field instanceof ChronoField?field.isTimeBased()?this._withDateTime(this._date,this._time.with(field,newValue)):this._withDateTime(this._date.with(field,newValue),this._time):field.adjustInto(this,newValue)},_proto.withYear=function(year){return this._withDateTime(this._date.withYear(year),this._time)},_proto.withMonth=function(month){return this._withDateTime(this._date.withMonth(month),this._time)},_proto.withDayOfMonth=function(dayOfMonth){return this._withDateTime(this._date.withDayOfMonth(dayOfMonth),this._time)},_proto.withDayOfYear=function(dayOfYear){return this._withDateTime(this._date.withDayOfYear(dayOfYear),this._time)},_proto.withHour=function(hour){var newTime=this._time.withHour(hour);return this._withDateTime(this._date,newTime)},_proto.withMinute=function(minute){var newTime=this._time.withMinute(minute);return this._withDateTime(this._date,newTime)},_proto.withSecond=function(second){var newTime=this._time.withSecond(second);return this._withDateTime(this._date,newTime)},_proto.withNano=function(nanoOfSecond){var newTime=this._time.withNano(nanoOfSecond);return this._withDateTime(this._date,newTime)},_proto.truncatedTo=function(unit){return this._withDateTime(this._date,this._time.truncatedTo(unit))},_proto._plusUnit=function(amountToAdd,unit){if(requireNonNull(unit,"unit"),unit instanceof ChronoUnit){switch(unit){case ChronoUnit.NANOS:return this.plusNanos(amountToAdd);case ChronoUnit.MICROS:return this.plusDays(MathUtil.intDiv(amountToAdd,LocalTime.MICROS_PER_DAY)).plusNanos(1e3*MathUtil.intMod(amountToAdd,LocalTime.MICROS_PER_DAY));case ChronoUnit.MILLIS:return this.plusDays(MathUtil.intDiv(amountToAdd,LocalTime.MILLIS_PER_DAY)).plusNanos(1e6*MathUtil.intMod(amountToAdd,LocalTime.MILLIS_PER_DAY));case ChronoUnit.SECONDS:return this.plusSeconds(amountToAdd);case ChronoUnit.MINUTES:return this.plusMinutes(amountToAdd);case ChronoUnit.HOURS:return this.plusHours(amountToAdd);case ChronoUnit.HALF_DAYS:return this.plusDays(MathUtil.intDiv(amountToAdd,256)).plusHours(12*MathUtil.intMod(amountToAdd,256))}return this._withDateTime(this._date.plus(amountToAdd,unit),this._time)}return unit.addTo(this,amountToAdd)},_proto.plusYears=function(years){var newDate=this._date.plusYears(years);return this._withDateTime(newDate,this._time)},_proto.plusMonths=function(months){var newDate=this._date.plusMonths(months);return this._withDateTime(newDate,this._time)},_proto.plusWeeks=function(weeks){var newDate=this._date.plusWeeks(weeks);return this._withDateTime(newDate,this._time)},_proto.plusDays=function(days){var newDate=this._date.plusDays(days);return this._withDateTime(newDate,this._time)},_proto.plusHours=function(hours){return this._plusWithOverflow(this._date,hours,0,0,0,1)},_proto.plusMinutes=function(minutes){return this._plusWithOverflow(this._date,0,minutes,0,0,1)},_proto.plusSeconds=function(seconds){return this._plusWithOverflow(this._date,0,0,seconds,0,1)},_proto.plusNanos=function(nanos){return this._plusWithOverflow(this._date,0,0,0,nanos,1)},_proto._minusUnit=function(amountToSubtract,unit){return requireNonNull(unit,"unit"),this._plusUnit(-1*amountToSubtract,unit)},_proto.minusYears=function(years){return this.plusYears(-1*years)},_proto.minusMonths=function(months){return this.plusMonths(-1*months)},_proto.minusWeeks=function(weeks){return this.plusWeeks(-1*weeks)},_proto.minusDays=function(days){return this.plusDays(-1*days)},_proto.minusHours=function(hours){return this._plusWithOverflow(this._date,hours,0,0,0,-1)},_proto.minusMinutes=function(minutes){return this._plusWithOverflow(this._date,0,minutes,0,0,-1)},_proto.minusSeconds=function(seconds){return this._plusWithOverflow(this._date,0,0,seconds,0,-1)},_proto.minusNanos=function(nanos){return this._plusWithOverflow(this._date,0,0,0,nanos,-1)},_proto._plusWithOverflow=function(newDate,hours,minutes,seconds,nanos,sign){if(0===hours&&0===minutes&&0===seconds&&0===nanos)return this._withDateTime(newDate,this._time);var totDays=MathUtil.intDiv(nanos,LocalTime.NANOS_PER_DAY)+MathUtil.intDiv(seconds,LocalTime.SECONDS_PER_DAY)+MathUtil.intDiv(minutes,LocalTime.MINUTES_PER_DAY)+MathUtil.intDiv(hours,LocalTime.HOURS_PER_DAY);totDays*=sign;var totNanos=MathUtil.intMod(nanos,LocalTime.NANOS_PER_DAY)+MathUtil.intMod(seconds,LocalTime.SECONDS_PER_DAY)*LocalTime.NANOS_PER_SECOND+MathUtil.intMod(minutes,LocalTime.MINUTES_PER_DAY)*LocalTime.NANOS_PER_MINUTE+MathUtil.intMod(hours,LocalTime.HOURS_PER_DAY)*LocalTime.NANOS_PER_HOUR,curNoD=this._time.toNanoOfDay();totNanos=totNanos*sign+curNoD,totDays+=MathUtil.floorDiv(totNanos,LocalTime.NANOS_PER_DAY);var newNoD=MathUtil.floorMod(totNanos,LocalTime.NANOS_PER_DAY),newTime=newNoD===curNoD?this._time:LocalTime.ofNanoOfDay(newNoD);return this._withDateTime(newDate.plusDays(totDays),newTime)},_proto.query=function(_query){return requireNonNull(_query,"query"),_query===TemporalQueries.localDate()?this.toLocalDate():_ChronoLocalDateTime.prototype.query.call(this,_query)},_proto.adjustInto=function(temporal){return _ChronoLocalDateTime.prototype.adjustInto.call(this,temporal)},_proto.until=function(endExclusive,unit){requireNonNull(endExclusive,"endExclusive"),requireNonNull(unit,"unit");var end=LocalDateTime.from(endExclusive);if(unit instanceof ChronoUnit){if(unit.isTimeBased()){var daysUntil=this._date.daysUntil(end._date),timeUntil=end._time.toNanoOfDay()-this._time.toNanoOfDay();daysUntil>0&&timeUntil<0?(daysUntil--,timeUntil+=LocalTime.NANOS_PER_DAY):daysUntil<0&&timeUntil>0&&(daysUntil++,timeUntil-=LocalTime.NANOS_PER_DAY);var amount=daysUntil;switch(unit){case ChronoUnit.NANOS:return amount=MathUtil.safeMultiply(amount,LocalTime.NANOS_PER_DAY),MathUtil.safeAdd(amount,timeUntil);case ChronoUnit.MICROS:return amount=MathUtil.safeMultiply(amount,LocalTime.MICROS_PER_DAY),MathUtil.safeAdd(amount,MathUtil.intDiv(timeUntil,1e3));case ChronoUnit.MILLIS:return amount=MathUtil.safeMultiply(amount,LocalTime.MILLIS_PER_DAY),MathUtil.safeAdd(amount,MathUtil.intDiv(timeUntil,1e6));case ChronoUnit.SECONDS:return amount=MathUtil.safeMultiply(amount,LocalTime.SECONDS_PER_DAY),MathUtil.safeAdd(amount,MathUtil.intDiv(timeUntil,LocalTime.NANOS_PER_SECOND));case ChronoUnit.MINUTES:return amount=MathUtil.safeMultiply(amount,LocalTime.MINUTES_PER_DAY),MathUtil.safeAdd(amount,MathUtil.intDiv(timeUntil,LocalTime.NANOS_PER_MINUTE));case ChronoUnit.HOURS:return amount=MathUtil.safeMultiply(amount,LocalTime.HOURS_PER_DAY),MathUtil.safeAdd(amount,MathUtil.intDiv(timeUntil,LocalTime.NANOS_PER_HOUR));case ChronoUnit.HALF_DAYS:return amount=MathUtil.safeMultiply(amount,2),MathUtil.safeAdd(amount,MathUtil.intDiv(timeUntil,12*LocalTime.NANOS_PER_HOUR))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}var endDate=end._date,endTime=end._time;return endDate.isAfter(this._date)&&endTime.isBefore(this._time)?endDate=endDate.minusDays(1):endDate.isBefore(this._date)&&endTime.isAfter(this._time)&&(endDate=endDate.plusDays(1)),this._date.until(endDate,unit)}return unit.between(this,end)},_proto.atOffset=function(offset){return OffsetDateTime.of(this,offset)},_proto.atZone=function(zone){return ZonedDateTime.of(this,zone)},_proto.toLocalDate=function(){return this._date},_proto.toLocalTime=function(){return this._time},_proto.compareTo=function(other){return requireNonNull(other,"other"),requireInstance(other,LocalDateTime,"other"),this._compareTo0(other)},_proto._compareTo0=function(other){var cmp=this._date.compareTo(other.toLocalDate());return 0===cmp&&(cmp=this._time.compareTo(other.toLocalTime())),cmp},_proto.isAfter=function(other){return this.compareTo(other)>0},_proto.isBefore=function(other){return this.compareTo(other)<0},_proto.isEqual=function(other){return 0===this.compareTo(other)},_proto.equals=function(other){return this===other||other instanceof LocalDateTime&&(this._date.equals(other._date)&&this._time.equals(other._time))},_proto.hashCode=function(){return this._date.hashCode()^this._time.hashCode()},_proto.toString=function(){return this._date.toString()+"T"+this._time.toString()},_proto.toJSON=function(){return this.toString()},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),formatter.format(this)},LocalDateTime}(ChronoLocalDateTime);function _init$4(){LocalDateTime.MIN=LocalDateTime.of(LocalDate.MIN,LocalTime.MIN),LocalDateTime.MAX=LocalDateTime.of(LocalDate.MAX,LocalTime.MAX),LocalDateTime.FROM=createTemporalQuery("LocalDateTime.FROM",(function(temporal){return LocalDateTime.from(temporal)}))}var LocalTime=function(_Temporal){function LocalTime(hour,minute,second,nanoOfSecond){var _this;void 0===hour&&(hour=0),void 0===minute&&(minute=0),void 0===second&&(second=0),void 0===nanoOfSecond&&(nanoOfSecond=0),_this=_Temporal.call(this)||this;var _hour=MathUtil.safeToInt(hour),_minute=MathUtil.safeToInt(minute),_second=MathUtil.safeToInt(second),_nanoOfSecond=MathUtil.safeToInt(nanoOfSecond);return LocalTime._validate(_hour,_minute,_second,_nanoOfSecond),0===_minute&&0===_second&&0===_nanoOfSecond?(LocalTime.HOURS[_hour]||(_this._hour=_hour,_this._minute=_minute,_this._second=_second,_this._nano=_nanoOfSecond,LocalTime.HOURS[_hour]=_assertThisInitialized(_this)),LocalTime.HOURS[_hour]||_assertThisInitialized(_this)):(_this._hour=_hour,_this._minute=_minute,_this._second=_second,_this._nano=_nanoOfSecond,_this)}_inheritsLoose(LocalTime,_Temporal),LocalTime.now=function(clockOrZone){return null==clockOrZone?LocalTime._now(Clock.systemDefaultZone()):clockOrZone instanceof Clock?LocalTime._now(clockOrZone):LocalTime._now(Clock.system(clockOrZone))},LocalTime._now=function(clock){return void 0===clock&&(clock=Clock.systemDefaultZone()),requireNonNull(clock,"clock"),LocalTime.ofInstant(clock.instant(),clock.zone())},LocalTime.ofInstant=function(instant,zone){void 0===zone&&(zone=ZoneId.systemDefault());var offset=zone.rules().offset(instant),secsOfDay=MathUtil.intMod(instant.epochSecond(),LocalTime.SECONDS_PER_DAY);return(secsOfDay=MathUtil.intMod(secsOfDay+offset.totalSeconds(),LocalTime.SECONDS_PER_DAY))<0&&(secsOfDay+=LocalTime.SECONDS_PER_DAY),LocalTime.ofSecondOfDay(secsOfDay,instant.nano())},LocalTime.of=function(hour,minute,second,nanoOfSecond){return new LocalTime(hour,minute,second,nanoOfSecond)},LocalTime.ofSecondOfDay=function(secondOfDay,nanoOfSecond){void 0===secondOfDay&&(secondOfDay=0),void 0===nanoOfSecond&&(nanoOfSecond=0),ChronoField.SECOND_OF_DAY.checkValidValue(secondOfDay),ChronoField.NANO_OF_SECOND.checkValidValue(nanoOfSecond);var hours=MathUtil.intDiv(secondOfDay,LocalTime.SECONDS_PER_HOUR);secondOfDay-=hours*LocalTime.SECONDS_PER_HOUR;var minutes=MathUtil.intDiv(secondOfDay,LocalTime.SECONDS_PER_MINUTE);return new LocalTime(hours,minutes,secondOfDay-=minutes*LocalTime.SECONDS_PER_MINUTE,nanoOfSecond)},LocalTime.ofNanoOfDay=function(nanoOfDay){void 0===nanoOfDay&&(nanoOfDay=0),ChronoField.NANO_OF_DAY.checkValidValue(nanoOfDay);var hours=MathUtil.intDiv(nanoOfDay,LocalTime.NANOS_PER_HOUR);nanoOfDay-=hours*LocalTime.NANOS_PER_HOUR;var minutes=MathUtil.intDiv(nanoOfDay,LocalTime.NANOS_PER_MINUTE);nanoOfDay-=minutes*LocalTime.NANOS_PER_MINUTE;var seconds=MathUtil.intDiv(nanoOfDay,LocalTime.NANOS_PER_SECOND);return new LocalTime(hours,minutes,seconds,nanoOfDay-=seconds*LocalTime.NANOS_PER_SECOND)},LocalTime.from=function(temporal){requireNonNull(temporal,"temporal");var time=temporal.query(TemporalQueries.localTime());if(null==time)throw new DateTimeException("Unable to obtain LocalTime TemporalAccessor: "+temporal+", type "+(null!=temporal.constructor?temporal.constructor.name:""));return time},LocalTime.parse=function(text,formatter){return void 0===formatter&&(formatter=DateTimeFormatter.ISO_LOCAL_TIME),requireNonNull(formatter,"formatter"),formatter.parse(text,LocalTime.FROM)},LocalTime._validate=function(hour,minute,second,nanoOfSecond){ChronoField.HOUR_OF_DAY.checkValidValue(hour),ChronoField.MINUTE_OF_HOUR.checkValidValue(minute),ChronoField.SECOND_OF_MINUTE.checkValidValue(second),ChronoField.NANO_OF_SECOND.checkValidValue(nanoOfSecond)};var _proto=LocalTime.prototype;return _proto.isSupported=function(fieldOrUnit){return fieldOrUnit instanceof ChronoField||fieldOrUnit instanceof ChronoUnit?fieldOrUnit.isTimeBased():null!=fieldOrUnit&&fieldOrUnit.isSupportedBy(this)},_proto.range=function(field){return requireNonNull(field),_Temporal.prototype.range.call(this,field)},_proto.get=function(field){return this.getLong(field)},_proto.getLong=function(field){return requireNonNull(field,"field"),field instanceof ChronoField?this._get0(field):field.getFrom(this)},_proto._get0=function(field){switch(field){case ChronoField.NANO_OF_SECOND:return this._nano;case ChronoField.NANO_OF_DAY:return this.toNanoOfDay();case ChronoField.MICRO_OF_SECOND:return MathUtil.intDiv(this._nano,1e3);case ChronoField.MICRO_OF_DAY:return MathUtil.intDiv(this.toNanoOfDay(),1e3);case ChronoField.MILLI_OF_SECOND:return MathUtil.intDiv(this._nano,1e6);case ChronoField.MILLI_OF_DAY:return MathUtil.intDiv(this.toNanoOfDay(),1e6);case ChronoField.SECOND_OF_MINUTE:return this._second;case ChronoField.SECOND_OF_DAY:return this.toSecondOfDay();case ChronoField.MINUTE_OF_HOUR:return this._minute;case ChronoField.MINUTE_OF_DAY:return 60*this._hour+this._minute;case ChronoField.HOUR_OF_AMPM:return MathUtil.intMod(this._hour,12);case ChronoField.CLOCK_HOUR_OF_AMPM:var ham=MathUtil.intMod(this._hour,12);return ham%12==0?12:ham;case ChronoField.HOUR_OF_DAY:return this._hour;case ChronoField.CLOCK_HOUR_OF_DAY:return 0===this._hour?24:this._hour;case ChronoField.AMPM_OF_DAY:return MathUtil.intDiv(this._hour,12)}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)},_proto.hour=function(){return this._hour},_proto.minute=function(){return this._minute},_proto.second=function(){return this._second},_proto.nano=function(){return this._nano},_proto._withAdjuster=function(adjuster){return requireNonNull(adjuster,"adjuster"),adjuster instanceof LocalTime?adjuster:_Temporal.prototype._withAdjuster.call(this,adjuster)},_proto._withField=function(field,newValue){if(requireNonNull(field,"field"),requireInstance(field,TemporalField,"field"),field instanceof ChronoField){switch(field.checkValidValue(newValue),field){case ChronoField.NANO_OF_SECOND:return this.withNano(newValue);case ChronoField.NANO_OF_DAY:return LocalTime.ofNanoOfDay(newValue);case ChronoField.MICRO_OF_SECOND:return this.withNano(1e3*newValue);case ChronoField.MICRO_OF_DAY:return LocalTime.ofNanoOfDay(1e3*newValue);case ChronoField.MILLI_OF_SECOND:return this.withNano(1e6*newValue);case ChronoField.MILLI_OF_DAY:return LocalTime.ofNanoOfDay(1e6*newValue);case ChronoField.SECOND_OF_MINUTE:return this.withSecond(newValue);case ChronoField.SECOND_OF_DAY:return this.plusSeconds(newValue-this.toSecondOfDay());case ChronoField.MINUTE_OF_HOUR:return this.withMinute(newValue);case ChronoField.MINUTE_OF_DAY:return this.plusMinutes(newValue-(60*this._hour+this._minute));case ChronoField.HOUR_OF_AMPM:return this.plusHours(newValue-MathUtil.intMod(this._hour,12));case ChronoField.CLOCK_HOUR_OF_AMPM:return this.plusHours((12===newValue?0:newValue)-MathUtil.intMod(this._hour,12));case ChronoField.HOUR_OF_DAY:return this.withHour(newValue);case ChronoField.CLOCK_HOUR_OF_DAY:return this.withHour(24===newValue?0:newValue);case ChronoField.AMPM_OF_DAY:return this.plusHours(12*(newValue-MathUtil.intDiv(this._hour,12)))}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.adjustInto(this,newValue)},_proto.withHour=function(hour){return void 0===hour&&(hour=0),this._hour===hour?this:new LocalTime(hour,this._minute,this._second,this._nano)},_proto.withMinute=function(minute){return void 0===minute&&(minute=0),this._minute===minute?this:new LocalTime(this._hour,minute,this._second,this._nano)},_proto.withSecond=function(second){return void 0===second&&(second=0),this._second===second?this:new LocalTime(this._hour,this._minute,second,this._nano)},_proto.withNano=function(nanoOfSecond){return void 0===nanoOfSecond&&(nanoOfSecond=0),this._nano===nanoOfSecond?this:new LocalTime(this._hour,this._minute,this._second,nanoOfSecond)},_proto.truncatedTo=function(unit){if(requireNonNull(unit,"unit"),unit===ChronoUnit.NANOS)return this;var unitDur=unit.duration();if(unitDur.seconds()>LocalTime.SECONDS_PER_DAY)throw new DateTimeException("Unit is too large to be used for truncation");var dur=unitDur.toNanos();if(0!==MathUtil.intMod(LocalTime.NANOS_PER_DAY,dur))throw new DateTimeException("Unit must divide into a standard day without remainder");var nod=this.toNanoOfDay();return LocalTime.ofNanoOfDay(MathUtil.intDiv(nod,dur)*dur)},_proto._plusUnit=function(amountToAdd,unit){if(requireNonNull(unit,"unit"),unit instanceof ChronoUnit){switch(unit){case ChronoUnit.NANOS:return this.plusNanos(amountToAdd);case ChronoUnit.MICROS:return this.plusNanos(1e3*MathUtil.intMod(amountToAdd,LocalTime.MICROS_PER_DAY));case ChronoUnit.MILLIS:return this.plusNanos(1e6*MathUtil.intMod(amountToAdd,LocalTime.MILLIS_PER_DAY));case ChronoUnit.SECONDS:return this.plusSeconds(amountToAdd);case ChronoUnit.MINUTES:return this.plusMinutes(amountToAdd);case ChronoUnit.HOURS:return this.plusHours(amountToAdd);case ChronoUnit.HALF_DAYS:return this.plusHours(12*MathUtil.intMod(amountToAdd,2))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.addTo(this,amountToAdd)},_proto.plusHours=function(hoursToAdd){return 0===hoursToAdd?this:new LocalTime(MathUtil.intMod(MathUtil.intMod(hoursToAdd,LocalTime.HOURS_PER_DAY)+this._hour+LocalTime.HOURS_PER_DAY,LocalTime.HOURS_PER_DAY),this._minute,this._second,this._nano)},_proto.plusMinutes=function(minutesToAdd){if(0===minutesToAdd)return this;var mofd=this._hour*LocalTime.MINUTES_PER_HOUR+this._minute,newMofd=MathUtil.intMod(MathUtil.intMod(minutesToAdd,LocalTime.MINUTES_PER_DAY)+mofd+LocalTime.MINUTES_PER_DAY,LocalTime.MINUTES_PER_DAY);return mofd===newMofd?this:new LocalTime(MathUtil.intDiv(newMofd,LocalTime.MINUTES_PER_HOUR),MathUtil.intMod(newMofd,LocalTime.MINUTES_PER_HOUR),this._second,this._nano)},_proto.plusSeconds=function(secondsToAdd){if(0===secondsToAdd)return this;var sofd=this._hour*LocalTime.SECONDS_PER_HOUR+this._minute*LocalTime.SECONDS_PER_MINUTE+this._second,newSofd=MathUtil.intMod(MathUtil.intMod(secondsToAdd,LocalTime.SECONDS_PER_DAY)+sofd+LocalTime.SECONDS_PER_DAY,LocalTime.SECONDS_PER_DAY);return sofd===newSofd?this:new LocalTime(MathUtil.intDiv(newSofd,LocalTime.SECONDS_PER_HOUR),MathUtil.intMod(MathUtil.intDiv(newSofd,LocalTime.SECONDS_PER_MINUTE),LocalTime.MINUTES_PER_HOUR),MathUtil.intMod(newSofd,LocalTime.SECONDS_PER_MINUTE),this._nano)},_proto.plusNanos=function(nanosToAdd){if(0===nanosToAdd)return this;var nofd=this.toNanoOfDay(),newNofd=MathUtil.intMod(MathUtil.intMod(nanosToAdd,LocalTime.NANOS_PER_DAY)+nofd+LocalTime.NANOS_PER_DAY,LocalTime.NANOS_PER_DAY);return nofd===newNofd?this:new LocalTime(MathUtil.intDiv(newNofd,LocalTime.NANOS_PER_HOUR),MathUtil.intMod(MathUtil.intDiv(newNofd,LocalTime.NANOS_PER_MINUTE),LocalTime.MINUTES_PER_HOUR),MathUtil.intMod(MathUtil.intDiv(newNofd,LocalTime.NANOS_PER_SECOND),LocalTime.SECONDS_PER_MINUTE),MathUtil.intMod(newNofd,LocalTime.NANOS_PER_SECOND))},_proto._minusUnit=function(amountToSubtract,unit){return requireNonNull(unit,"unit"),this._plusUnit(-1*amountToSubtract,unit)},_proto.minusHours=function(hoursToSubtract){return this.plusHours(-1*MathUtil.intMod(hoursToSubtract,LocalTime.HOURS_PER_DAY))},_proto.minusMinutes=function(minutesToSubtract){return this.plusMinutes(-1*MathUtil.intMod(minutesToSubtract,LocalTime.MINUTES_PER_DAY))},_proto.minusSeconds=function(secondsToSubtract){return this.plusSeconds(-1*MathUtil.intMod(secondsToSubtract,LocalTime.SECONDS_PER_DAY))},_proto.minusNanos=function(nanosToSubtract){return this.plusNanos(-1*MathUtil.intMod(nanosToSubtract,LocalTime.NANOS_PER_DAY))},_proto.query=function(_query){return requireNonNull(_query,"query"),_query===TemporalQueries.precision()?ChronoUnit.NANOS:_query===TemporalQueries.localTime()?this:_query===TemporalQueries.chronology()||_query===TemporalQueries.zoneId()||_query===TemporalQueries.zone()||_query===TemporalQueries.offset()||_query===TemporalQueries.localDate()?null:_query.queryFrom(this)},_proto.adjustInto=function(temporal){return temporal.with(LocalTime.NANO_OF_DAY,this.toNanoOfDay())},_proto.until=function(endExclusive,unit){requireNonNull(endExclusive,"endExclusive"),requireNonNull(unit,"unit");var end=LocalTime.from(endExclusive);if(unit instanceof ChronoUnit){var nanosUntil=end.toNanoOfDay()-this.toNanoOfDay();switch(unit){case ChronoUnit.NANOS:return nanosUntil;case ChronoUnit.MICROS:return MathUtil.intDiv(nanosUntil,1e3);case ChronoUnit.MILLIS:return MathUtil.intDiv(nanosUntil,1e6);case ChronoUnit.SECONDS:return MathUtil.intDiv(nanosUntil,LocalTime.NANOS_PER_SECOND);case ChronoUnit.MINUTES:return MathUtil.intDiv(nanosUntil,LocalTime.NANOS_PER_MINUTE);case ChronoUnit.HOURS:return MathUtil.intDiv(nanosUntil,LocalTime.NANOS_PER_HOUR);case ChronoUnit.HALF_DAYS:return MathUtil.intDiv(nanosUntil,12*LocalTime.NANOS_PER_HOUR)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.between(this,end)},_proto.atDate=function(date){return LocalDateTime.of(date,this)},_proto.atOffset=function(offset){return OffsetTime.of(this,offset)},_proto.toSecondOfDay=function(){var total=this._hour*LocalTime.SECONDS_PER_HOUR;return total+=this._minute*LocalTime.SECONDS_PER_MINUTE,total+=this._second},_proto.toNanoOfDay=function(){var total=this._hour*LocalTime.NANOS_PER_HOUR;return total+=this._minute*LocalTime.NANOS_PER_MINUTE,total+=this._second*LocalTime.NANOS_PER_SECOND,total+=this._nano},_proto.compareTo=function(other){requireNonNull(other,"other"),requireInstance(other,LocalTime,"other");var cmp=MathUtil.compareNumbers(this._hour,other._hour);return 0===cmp&&0===(cmp=MathUtil.compareNumbers(this._minute,other._minute))&&0===(cmp=MathUtil.compareNumbers(this._second,other._second))&&(cmp=MathUtil.compareNumbers(this._nano,other._nano)),cmp},_proto.isAfter=function(other){return this.compareTo(other)>0},_proto.isBefore=function(other){return this.compareTo(other)<0},_proto.equals=function(other){return this===other||other instanceof LocalTime&&(this._hour===other._hour&&this._minute===other._minute&&this._second===other._second&&this._nano===other._nano)},_proto.hashCode=function(){var nod=this.toNanoOfDay();return MathUtil.hash(nod)},_proto.toString=function(){var buf="",hourValue=this._hour,minuteValue=this._minute,secondValue=this._second,nanoValue=this._nano;return buf+=hourValue<10?"0":"",buf+=hourValue,buf+=minuteValue<10?":0":":",buf+=minuteValue,(secondValue>0||nanoValue>0)&&(buf+=secondValue<10?":0":":",buf+=secondValue,nanoValue>0&&(buf+=".",0===MathUtil.intMod(nanoValue,1e6)?buf+=(""+(MathUtil.intDiv(nanoValue,1e6)+1e3)).substring(1):0===MathUtil.intMod(nanoValue,1e3)?buf+=(""+(MathUtil.intDiv(nanoValue,1e3)+1e6)).substring(1):buf+=(""+(nanoValue+1e9)).substring(1))),buf},_proto.toJSON=function(){return this.toString()},_proto.format=function(formatter){return requireNonNull(formatter,"formatter"),formatter.format(this)},LocalTime}(Temporal);function _init$3(){LocalTime.HOURS=[];for(var hour=0;hour<24;hour++)LocalTime.of(hour,0,0,0);LocalTime.MIN=LocalTime.HOURS[0],LocalTime.MAX=new LocalTime(23,59,59,999999999),LocalTime.MIDNIGHT=LocalTime.HOURS[0],LocalTime.NOON=LocalTime.HOURS[12],LocalTime.FROM=createTemporalQuery("LocalTime.FROM",(function(temporal){return LocalTime.from(temporal)}))}LocalTime.HOURS_PER_DAY=24,LocalTime.MINUTES_PER_HOUR=60,LocalTime.MINUTES_PER_DAY=LocalTime.MINUTES_PER_HOUR*LocalTime.HOURS_PER_DAY,LocalTime.SECONDS_PER_MINUTE=60,LocalTime.SECONDS_PER_HOUR=LocalTime.SECONDS_PER_MINUTE*LocalTime.MINUTES_PER_HOUR,LocalTime.SECONDS_PER_DAY=LocalTime.SECONDS_PER_HOUR*LocalTime.HOURS_PER_DAY,LocalTime.MILLIS_PER_DAY=1e3*LocalTime.SECONDS_PER_DAY,LocalTime.MICROS_PER_DAY=1e6*LocalTime.SECONDS_PER_DAY,LocalTime.NANOS_PER_SECOND=1e9,LocalTime.NANOS_PER_MINUTE=LocalTime.NANOS_PER_SECOND*LocalTime.SECONDS_PER_MINUTE,LocalTime.NANOS_PER_HOUR=LocalTime.NANOS_PER_MINUTE*LocalTime.MINUTES_PER_HOUR,LocalTime.NANOS_PER_DAY=LocalTime.NANOS_PER_HOUR*LocalTime.HOURS_PER_DAY;var NANOS_PER_MILLI=1e6,Instant=function(_Temporal){function Instant(seconds,nanoOfSecond){var _this;return _this=_Temporal.call(this)||this,Instant._validate(seconds,nanoOfSecond),_this._seconds=MathUtil.safeToInt(seconds),_this._nanos=MathUtil.safeToInt(nanoOfSecond),_this}_inheritsLoose(Instant,_Temporal),Instant.now=function(clock){return void 0===clock&&(clock=Clock.systemUTC()),clock.instant()},Instant.ofEpochSecond=function(epochSecond,nanoAdjustment){void 0===nanoAdjustment&&(nanoAdjustment=0);var secs=epochSecond+MathUtil.floorDiv(nanoAdjustment,LocalTime.NANOS_PER_SECOND),nos=MathUtil.floorMod(nanoAdjustment,LocalTime.NANOS_PER_SECOND);return Instant._create(secs,nos)},Instant.ofEpochMilli=function(epochMilli){var secs=MathUtil.floorDiv(epochMilli,1e3),mos=MathUtil.floorMod(epochMilli,1e3);return Instant._create(secs,1e6*mos)},Instant.ofEpochMicro=function(epochMicro){var secs=MathUtil.floorDiv(epochMicro,1e6),mos=MathUtil.floorMod(epochMicro,1e6);return Instant._create(secs,1e3*mos)},Instant.from=function(temporal){try{var instantSecs=temporal.getLong(ChronoField.INSTANT_SECONDS),nanoOfSecond=temporal.get(ChronoField.NANO_OF_SECOND);return Instant.ofEpochSecond(instantSecs,nanoOfSecond)}catch(ex){throw new DateTimeException("Unable to obtain Instant from TemporalAccessor: "+temporal+", type "+typeof temporal,ex)}},Instant.parse=function(text){return DateTimeFormatter.ISO_INSTANT.parse(text,Instant.FROM)},Instant._create=function(seconds,nanoOfSecond){return 0===seconds&&0===nanoOfSecond?Instant.EPOCH:new Instant(seconds,nanoOfSecond)},Instant._validate=function(seconds,nanoOfSecond){if(seconds<Instant.MIN_SECONDS||seconds>Instant.MAX_SECONDS)throw new DateTimeException("Instant exceeds minimum or maximum instant");if(nanoOfSecond<0||nanoOfSecond>LocalTime.NANOS_PER_SECOND)throw new DateTimeException("Instant exceeds minimum or maximum instant")};var _proto=Instant.prototype;return _proto.isSupported=function(fieldOrUnit){return fieldOrUnit instanceof ChronoField?fieldOrUnit===ChronoField.INSTANT_SECONDS||fieldOrUnit===ChronoField.NANO_OF_SECOND||fieldOrUnit===ChronoField.MICRO_OF_SECOND||fieldOrUnit===ChronoField.MILLI_OF_SECOND:fieldOrUnit instanceof ChronoUnit?fieldOrUnit.isTimeBased()||fieldOrUnit===ChronoUnit.DAYS:null!=fieldOrUnit&&fieldOrUnit.isSupportedBy(this)},_proto.range=function(field){return _Temporal.prototype.range.call(this,field)},_proto.get=function(field){return this.getLong(field)},_proto.getLong=function(field){if(field instanceof ChronoField){switch(field){case ChronoField.NANO_OF_SECOND:return this._nanos;case ChronoField.MICRO_OF_SECOND:return MathUtil.intDiv(this._nanos,1e3);case ChronoField.MILLI_OF_SECOND:return MathUtil.intDiv(this._nanos,NANOS_PER_MILLI);case ChronoField.INSTANT_SECONDS:return this._seconds}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.getFrom(this)},_proto.epochSecond=function(){return this._seconds},_proto.nano=function(){return this._nanos},_proto._withField=function(field,newValue){if(requireNonNull(field,"field"),field instanceof ChronoField){switch(field.checkValidValue(newValue),field){case ChronoField.MILLI_OF_SECOND:var nval=newValue*NANOS_PER_MILLI;return nval!==this._nanos?Instant._create(this._seconds,nval):this;case ChronoField.MICRO_OF_SECOND:var _nval=1e3*newValue;return _nval!==this._nanos?Instant._create(this._seconds,_nval):this;case ChronoField.NANO_OF_SECOND:return newValue!==this._nanos?Instant._create(this._seconds,newValue):this;case ChronoField.INSTANT_SECONDS:return newValue!==this._seconds?Instant._create(newValue,this._nanos):this}throw new UnsupportedTemporalTypeException("Unsupported field: "+field)}return field.adjustInto(this,newValue)},_proto.truncatedTo=function(unit){if(requireNonNull(unit,"unit"),unit===ChronoUnit.NANOS)return this;var unitDur=unit.duration();if(unitDur.seconds()>LocalTime.SECONDS_PER_DAY)throw new DateTimeException("Unit is too large to be used for truncation");var dur=unitDur.toNanos();if(0!==MathUtil.intMod(LocalTime.NANOS_PER_DAY,dur))throw new DateTimeException("Unit must divide into a standard day without remainder");var nod=MathUtil.intMod(this._seconds,LocalTime.SECONDS_PER_DAY)*LocalTime.NANOS_PER_SECOND+this._nanos,result=MathUtil.intDiv(nod,dur)*dur;return this.plusNanos(result-nod)},_proto._plusUnit=function(amountToAdd,unit){if(requireNonNull(amountToAdd,"amountToAdd"),requireNonNull(unit,"unit"),requireInstance(unit,TemporalUnit),unit instanceof ChronoUnit){switch(unit){case ChronoUnit.NANOS:return this.plusNanos(amountToAdd);case ChronoUnit.MICROS:return this.plusMicros(amountToAdd);case ChronoUnit.MILLIS:return this.plusMillis(amountToAdd);case ChronoUnit.SECONDS:return this.plusSeconds(amountToAdd);case ChronoUnit.MINUTES:return this.plusSeconds(MathUtil.safeMultiply(amountToAdd,LocalTime.SECONDS_PER_MINUTE));case ChronoUnit.HOURS:return this.plusSeconds(MathUtil.safeMultiply(amountToAdd,LocalTime.SECONDS_PER_HOUR));case ChronoUnit.HALF_DAYS:return this.plusSeconds(MathUtil.safeMultiply(amountToAdd,LocalTime.SECONDS_PER_DAY/2));case ChronoUnit.DAYS:return this.plusSeconds(MathUtil.safeMultiply(amountToAdd,LocalTime.SECONDS_PER_DAY))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.addTo(this,amountToAdd)},_proto.plusSeconds=function(secondsToAdd){return this._plus(secondsToAdd,0)},_proto.plusMillis=function(millisToAdd){return this._plus(MathUtil.intDiv(millisToAdd,1e3),MathUtil.intMod(millisToAdd,1e3)*NANOS_PER_MILLI)},_proto.plusNanos=function(nanosToAdd){return this._plus(0,nanosToAdd)},_proto.plusMicros=function(microsToAdd){return this._plus(MathUtil.intDiv(microsToAdd,1e6),1e3*MathUtil.intMod(microsToAdd,1e6))},_proto._plus=function(secondsToAdd,nanosToAdd){if(0===secondsToAdd&&0===nanosToAdd)return this;var epochSec=this._seconds+secondsToAdd;epochSec+=MathUtil.intDiv(nanosToAdd,LocalTime.NANOS_PER_SECOND);var nanoAdjustment=this._nanos+nanosToAdd%LocalTime.NANOS_PER_SECOND;return Instant.ofEpochSecond(epochSec,nanoAdjustment)},_proto._minusUnit=function(amountToSubtract,unit){return this._plusUnit(-1*amountToSubtract,unit)},_proto.minusSeconds=function(secondsToSubtract){return this.plusSeconds(-1*secondsToSubtract)},_proto.minusMillis=function(millisToSubtract){return this.plusMillis(-1*millisToSubtract)},_proto.minusNanos=function(nanosToSubtract){return this.plusNanos(-1*nanosToSubtract)},_proto.minusMicros=function(microsToSubtract){return this.plusMicros(-1*microsToSubtract)},_proto.query=function(_query){return requireNonNull(_query,"query"),_query===TemporalQueries.precision()?ChronoUnit.NANOS:_query===TemporalQueries.localDate()||_query===TemporalQueries.localTime()||_query===TemporalQueries.chronology()||_query===TemporalQueries.zoneId()||_query===TemporalQueries.zone()||_query===TemporalQueries.offset()?null:_query.queryFrom(this)},_proto.adjustInto=function(temporal){return requireNonNull(temporal,"temporal"),temporal.with(ChronoField.INSTANT_SECONDS,this._seconds).with(ChronoField.NANO_OF_SECOND,this._nanos)},_proto.until=function(endExclusive,unit){requireNonNull(endExclusive,"endExclusive"),requireNonNull(unit,"unit");var end=Instant.from(endExclusive);if(unit instanceof ChronoUnit){switch(unit){case ChronoUnit.NANOS:return this._nanosUntil(end);case ChronoUnit.MICROS:return this._microsUntil(end);case ChronoUnit.MILLIS:return MathUtil.safeSubtract(end.toEpochMilli(),this.toEpochMilli());case ChronoUnit.SECONDS:return this._secondsUntil(end);case ChronoUnit.MINUTES:return MathUtil.intDiv(this._secondsUntil(end),LocalTime.SECONDS_PER_MINUTE);case ChronoUnit.HOURS:return MathUtil.intDiv(this._secondsUntil(end),LocalTime.SECONDS_PER_HOUR);case ChronoUnit.HALF_DAYS:return MathUtil.intDiv(this._secondsUntil(end),12*LocalTime.SECONDS_PER_HOUR);case ChronoUnit.DAYS:return MathUtil.intDiv(this._secondsUntil(end),LocalTime.SECONDS_PER_DAY)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+unit)}return unit.between(this,end)},_proto._microsUntil=function(end){var secsDiff=MathUtil.safeSubtract(end.epochSecond(),this.epochSecond()),totalMicros=MathUtil.safeMultiply(secsDiff,1e6);return MathUtil.safeAdd(totalMicros,MathUtil.intDiv(end.nano()-this.nano(),1e3))},_proto._nanosUntil=function(end){var secsDiff=MathUtil.safeSubtract(end.epochSecond(),this.epochSecond()),totalNanos=MathUtil.safeMultiply(secsDiff,LocalTime.NANOS_PER_SECOND);return MathUtil.safeAdd(totalNanos,end.nano()-this.nano())},_proto._secondsUntil=function(end){var secsDiff=MathUtil.safeSubtract(end.epochSecond(),this.epochSecond()),nanosDiff=end.nano()-this.nano();return secsDiff>0&&nanosDiff<0?secsDiff--:secsDiff<0&&nanosDiff>0&&secsDiff++,secsDiff},_proto.atOffset=function(offset){return OffsetDateTime.ofInstant(this,offset)},_proto.atZone=function(zone){return ZonedDateTime.ofInstant(this,zone)},_proto.toEpochMilli=function(){return MathUtil.safeMultiply(this._seconds,1e3)+MathUtil.intDiv(this._nanos,NANOS_PER_MILLI)},_proto.compareTo=function(otherInstant){requireNonNull(otherInstant,"otherInstant"),requireInstance(otherInstant,Instant,"otherInstant");var cmp=MathUtil.compareNumbers(this._seconds,otherInstant._seconds);return 0!==cmp?cmp:this._nanos-otherInstant._nanos},_proto.isAfter=function(otherInstant){return this.compareTo(otherInstant)>0},_proto.isBefore=function(otherInstant){return this.compareTo(otherInstant)<0},_proto.equals=function(other){return this===other||other instanceof Instant&&(this.epochSecond()===other.epochSecond()&&this.nano()===other.nano())},_proto.hashCode=function(){return MathUtil.hashCode(this._seconds,this._nanos)},_proto.toString=function(){return DateTimeFormatter.ISO_INSTANT.format(this)},_proto.toJSON=function(){return this.toString()},Instant}(Temporal);function _init$2(){Instant.MIN_SECONDS=-31619119219200,Instant.MAX_SECONDS=31494816403199,Instant.EPOCH=new Instant(0,0),Instant.MIN=Instant.ofEpochSecond(Instant.MIN_SECONDS,0),Instant.MAX=Instant.ofEpochSecond(Instant.MAX_SECONDS,999999999),Instant.FROM=createTemporalQuery("Instant.FROM",(function(temporal){return Instant.from(temporal)}))}var Clock=function(){function Clock(){}Clock.systemUTC=function(){return new SystemClock(ZoneOffset.UTC)},Clock.systemDefaultZone=function(){return new SystemClock(ZoneId.systemDefault())},Clock.system=function(zone){return new SystemClock(zone)},Clock.fixed=function(fixedInstant,zoneId){return new FixedClock(fixedInstant,zoneId)},Clock.offset=function(baseClock,duration){return new OffsetClock(baseClock,duration)};var _proto=Clock.prototype;return _proto.millis=function(){abstractMethodFail("Clock.millis")},_proto.instant=function(){abstractMethodFail("Clock.instant")},_proto.zone=function(){abstractMethodFail("Clock.zone")},_proto.withZone=function(){abstractMethodFail("Clock.withZone")},Clock}(),SystemClock=function(_Clock){function SystemClock(zone){var _this;return requireNonNull(zone,"zone"),(_this=_Clock.call(this)||this)._zone=zone,_this}_inheritsLoose(SystemClock,_Clock);var _proto2=SystemClock.prototype;return _proto2.zone=function(){return this._zone},_proto2.millis=function(){return(new Date).getTime()},_proto2.instant=function(){return Instant.ofEpochMilli(this.millis())},_proto2.equals=function(obj){return obj instanceof SystemClock&&this._zone.equals(obj._zone)},_proto2.withZone=function(zone){return zone.equals(this._zone)?this:new SystemClock(zone)},_proto2.toString=function(){return"SystemClock["+this._zone.toString()+"]"},SystemClock}(Clock),FixedClock=function(_Clock2){function FixedClock(fixedInstant,zoneId){var _this2;return(_this2=_Clock2.call(this)||this)._instant=fixedInstant,_this2._zoneId=zoneId,_this2}_inheritsLoose(FixedClock,_Clock2);var _proto3=FixedClock.prototype;return _proto3.instant=function(){return this._instant},_proto3.millis=function(){return this._instant.toEpochMilli()},_proto3.zone=function(){return this._zoneId},_proto3.toString=function(){return"FixedClock[]"},_proto3.equals=function(obj){return obj instanceof FixedClock&&(this._instant.equals(obj._instant)&&this._zoneId.equals(obj._zoneId))},_proto3.withZone=function(zone){return zone.equals(this._zoneId)?this:new FixedClock(this._instant,zone)},FixedClock}(Clock),OffsetClock=function(_Clock3){function OffsetClock(baseClock,offset){var _this3;return(_this3=_Clock3.call(this)||this)._baseClock=baseClock,_this3._offset=offset,_this3}_inheritsLoose(OffsetClock,_Clock3);var _proto4=OffsetClock.prototype;return _proto4.zone=function(){return this._baseClock.zone()},_proto4.withZone=function(zone){return zone.equals(this._baseClock.zone())?this:new OffsetClock(this._baseClock.withZone(zone),this._offset)},_proto4.millis=function(){return this._baseClock.millis()+this._offset.toMillis()},_proto4.instant=function(){return this._baseClock.instant().plus(this._offset)},_proto4.equals=function(obj){return obj instanceof OffsetClock&&(this._baseClock.equals(obj._baseClock)&&this._offset.equals(obj._offset))},_proto4.toString=function(){return"OffsetClock["+this._baseClock+","+this._offset+"]"},OffsetClock}(Clock),ZoneOffsetTransition=function(){function ZoneOffsetTransition(transition,offsetBefore,offsetAfter){if(requireNonNull(transition,"transition"),requireNonNull(offsetBefore,"offsetBefore"),requireNonNull(offsetAfter,"offsetAfter"),offsetBefore.equals(offsetAfter))throw new IllegalArgumentException("Offsets must not be equal");if(0!==transition.nano())throw new IllegalArgumentException("Nano-of-second must be zero");this._transition=transition instanceof LocalDateTime?transition:LocalDateTime.ofEpochSecond(transition,0,offsetBefore),this._offsetBefore=offsetBefore,this._offsetAfter=offsetAfter}ZoneOffsetTransition.of=function(transition,offsetBefore,offsetAfter){return new ZoneOffsetTransition(transition,offsetBefore,offsetAfter)};var _proto=ZoneOffsetTransition.prototype;return _proto.instant=function(){return this._transition.toInstant(this._offsetBefore)},_proto.toEpochSecond=function(){return this._transition.toEpochSecond(this._offsetBefore)},_proto.dateTimeBefore=function(){return this._transition},_proto.dateTimeAfter=function(){return this._transition.plusSeconds(this.durationSeconds())},_proto.offsetBefore=function(){return this._offsetBefore},_proto.offsetAfter=function(){return this._offsetAfter},_proto.duration=function(){return Duration.ofSeconds(this.durationSeconds())},_proto.durationSeconds=function(){return this._offsetAfter.totalSeconds()-this._offsetBefore.totalSeconds()},_proto.isGap=function(){return this._offsetAfter.totalSeconds()>this._offsetBefore.totalSeconds()},_proto.isOverlap=function(){return this._offsetAfter.totalSeconds()<this._offsetBefore.totalSeconds()},_proto.isValidOffset=function(offset){return!this.isGap()&&(this._offsetBefore.equals(offset)||this._offsetAfter.equals(offset))},_proto.validOffsets=function(){return this.isGap()?[]:[this._offsetBefore,this._offsetAfter]},_proto.compareTo=function(transition){return this.instant().compareTo(transition.instant())},_proto.equals=function(other){if(other===this)return!0;if(other instanceof ZoneOffsetTransition){var d=other;return this._transition.equals(d._transition)&&this._offsetBefore.equals(d.offsetBefore())&&this._offsetAfter.equals(d.offsetAfter())}return!1},_proto.hashCode=function(){return this._transition.hashCode()^this._offsetBefore.hashCode()^this._offsetAfter.hashCode()>>>16},_proto.toString=function(){return"Transition["+(this.isGap()?"Gap":"Overlap")+" at "+this._transition.toString()+this._offsetBefore.toString()+" to "+this._offsetAfter+"]"},ZoneOffsetTransition}();
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
function _init$1(){TemporalQueries.ZONE_ID=createTemporalQuery("ZONE_ID",(function(temporal){return temporal.query(TemporalQueries.ZONE_ID)})),TemporalQueries.CHRONO=createTemporalQuery("CHRONO",(function(temporal){return temporal.query(TemporalQueries.CHRONO)})),TemporalQueries.PRECISION=createTemporalQuery("PRECISION",(function(temporal){return temporal.query(TemporalQueries.PRECISION)})),TemporalQueries.OFFSET=createTemporalQuery("OFFSET",(function(temporal){return temporal.isSupported(ChronoField.OFFSET_SECONDS)?ZoneOffset.ofTotalSeconds(temporal.get(ChronoField.OFFSET_SECONDS)):null})),TemporalQueries.ZONE=createTemporalQuery("ZONE",(function(temporal){var zone=temporal.query(TemporalQueries.ZONE_ID);return null!=zone?zone:temporal.query(TemporalQueries.OFFSET)})),TemporalQueries.LOCAL_DATE=createTemporalQuery("LOCAL_DATE",(function(temporal){return temporal.isSupported(ChronoField.EPOCH_DAY)?LocalDate.ofEpochDay(temporal.getLong(ChronoField.EPOCH_DAY)):null})),TemporalQueries.LOCAL_TIME=createTemporalQuery("LOCAL_TIME",(function(temporal){return temporal.isSupported(ChronoField.NANO_OF_DAY)?LocalTime.ofNanoOfDay(temporal.getLong(ChronoField.NANO_OF_DAY)):null}))}var SystemDefaultZoneRules=function(_ZoneRules){function SystemDefaultZoneRules(){return _ZoneRules.apply(this,arguments)||this}_inheritsLoose(SystemDefaultZoneRules,_ZoneRules);var _proto=SystemDefaultZoneRules.prototype;return _proto.isFixedOffset=function(){return!1},_proto.offsetOfInstant=function(instant){var offsetInMinutes=new Date(instant.toEpochMilli()).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*offsetInMinutes)},_proto.offsetOfEpochMilli=function(epochMilli){var offsetInMinutes=new Date(epochMilli).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*offsetInMinutes)},_proto.offsetOfLocalDateTime=function(localDateTime){var epochMilli=1e3*localDateTime.toEpochSecond(ZoneOffset.UTC),offsetInMinutesBeforePossibleTransition=new Date(epochMilli).getTimezoneOffset(),offsetInMinutesAfterPossibleTransition=new Date(epochMilli+6e4*offsetInMinutesBeforePossibleTransition).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*offsetInMinutesAfterPossibleTransition)},_proto.validOffsets=function(localDateTime){return[this.offsetOfLocalDateTime(localDateTime)]},_proto.transition=function(){return null},_proto.standardOffset=function(instant){return this.offsetOfInstant(instant)},_proto.daylightSavings=function(){this._throwNotSupported()},_proto.isDaylightSavings=function(){this._throwNotSupported()},_proto.isValidOffset=function(dateTime,offset){return this.offsetOfLocalDateTime(dateTime).equals(offset)},_proto.nextTransition=function(){this._throwNotSupported()},_proto.previousTransition=function(){this._throwNotSupported()},_proto.transitions=function(){this._throwNotSupported()},_proto.transitionRules=function(){this._throwNotSupported()},_proto._throwNotSupported=function(){throw new DateTimeException("not supported operation")},_proto.equals=function(other){return this===other||other instanceof SystemDefaultZoneRules},_proto.toString=function(){return"SYSTEM"},SystemDefaultZoneRules}(ZoneRules),SystemDefaultZoneId=function(_ZoneId){function SystemDefaultZoneId(){var _this;return(_this=_ZoneId.call(this)||this)._rules=new SystemDefaultZoneRules,_this}_inheritsLoose(SystemDefaultZoneId,_ZoneId);var _proto=SystemDefaultZoneId.prototype;return _proto.rules=function(){return this._rules},_proto.equals=function(other){return this===other},_proto.id=function(){return"SYSTEM"},SystemDefaultZoneId}(ZoneId),ZoneIdFactory=function(){function ZoneIdFactory(){}return ZoneIdFactory.systemDefault=function(){return SYSTEM_DEFAULT_ZONE_ID_INSTANCE},ZoneIdFactory.getAvailableZoneIds=function(){return ZoneRulesProvider.getAvailableZoneIds()},ZoneIdFactory.of=function(zoneId){if(requireNonNull(zoneId,"zoneId"),"Z"===zoneId)return ZoneOffset.UTC;if(1===zoneId.length)throw new DateTimeException("Invalid zone: "+zoneId);if(StringUtil.startsWith(zoneId,"+")||StringUtil.startsWith(zoneId,"-"))return ZoneOffset.of(zoneId);if("UTC"===zoneId||"GMT"===zoneId||"GMT0"===zoneId||"UT"===zoneId)return new ZoneRegion(zoneId,ZoneOffset.UTC.rules());if(StringUtil.startsWith(zoneId,"UTC+")||StringUtil.startsWith(zoneId,"GMT+")||StringUtil.startsWith(zoneId,"UTC-")||StringUtil.startsWith(zoneId,"GMT-")){var offset=ZoneOffset.of(zoneId.substring(3));return 0===offset.totalSeconds()?new ZoneRegion(zoneId.substring(0,3),offset.rules()):new ZoneRegion(zoneId.substring(0,3)+offset.id(),offset.rules())}if(StringUtil.startsWith(zoneId,"UT+")||StringUtil.startsWith(zoneId,"UT-")){var _offset=ZoneOffset.of(zoneId.substring(2));return 0===_offset.totalSeconds()?new ZoneRegion("UT",_offset.rules()):new ZoneRegion("UT"+_offset.id(),_offset.rules())}return"SYSTEM"===zoneId?ZoneId.systemDefault():ZoneRegion.ofId(zoneId)},ZoneIdFactory.ofOffset=function(prefix,offset){if(requireNonNull(prefix,"prefix"),requireNonNull(offset,"offset"),0===prefix.length)return offset;if("GMT"===prefix||"UTC"===prefix||"UT"===prefix)return 0===offset.totalSeconds()?new ZoneRegion(prefix,offset.rules()):new ZoneRegion(prefix+offset.id(),offset.rules());throw new IllegalArgumentException("Invalid prefix, must be GMT, UTC or UT: "+prefix)},ZoneIdFactory.from=function(temporal){requireNonNull(temporal,"temporal");var obj=temporal.query(TemporalQueries.zone());if(null==obj)throw new DateTimeException("Unable to obtain ZoneId from TemporalAccessor: "+temporal+", type "+(null!=temporal.constructor?temporal.constructor.name:""));return obj},ZoneIdFactory}(),SYSTEM_DEFAULT_ZONE_ID_INSTANCE=null;function _init(){SYSTEM_DEFAULT_ZONE_ID_INSTANCE=new SystemDefaultZoneId,ZoneId.systemDefault=ZoneIdFactory.systemDefault,ZoneId.getAvailableZoneIds=ZoneIdFactory.getAvailableZoneIds,ZoneId.of=ZoneIdFactory.of,ZoneId.ofOffset=ZoneIdFactory.ofOffset,ZoneId.from=ZoneIdFactory.from,ZoneOffset.from=ZoneIdFactory.from,ZoneId.SYSTEM=SYSTEM_DEFAULT_ZONE_ID_INSTANCE,ZoneId.UTC=ZoneOffset.ofTotalSeconds(0)}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var isInit=!1;function init(){isInit||(isInit=!0,_init$m(),_init$n(),_init$l(),_init$k(),_init$3(),_init$f(),_init$1(),_init$j(),_init$2(),_init$5(),_init$4(),_init$a(),_init$i(),_init$b(),_init$c(),_init$h(),_init$g(),_init$7(),_init(),_init$9(),_init$d(),_init$e(),_init$6(),_init$8())}init();
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var ToNativeJsConverter=function(){function ToNativeJsConverter(temporal,zone){var zonedDateTime;if(temporal instanceof Instant)this.instant=temporal;else{if(temporal instanceof LocalDate)zone=null==zone?ZoneId.systemDefault():zone,zonedDateTime=temporal.atStartOfDay(zone);else if(temporal instanceof LocalDateTime)zone=null==zone?ZoneId.systemDefault():zone,zonedDateTime=temporal.atZone(zone);else{if(!(temporal instanceof ZonedDateTime))throw new IllegalArgumentException("unsupported instance for convert operation:"+temporal);zonedDateTime=null==zone?temporal:temporal.withZoneSameInstant(zone)}this.instant=zonedDateTime.toInstant()}}var _proto=ToNativeJsConverter.prototype;return _proto.toDate=function(){return new Date(this.instant.toEpochMilli())},_proto.toEpochMilli=function(){return this.instant.toEpochMilli()},ToNativeJsConverter}();function convert(temporal,zone){return new ToNativeJsConverter(temporal,zone)}
/*
 * @copyright (c) 2015-present, Philipp Thürwächter, Pattrick Hüper & js-joda contributors
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function nativeJs(date,zone){if(void 0===zone&&(zone=ZoneId.systemDefault()),requireNonNull(date,"date"),requireNonNull(zone,"zone"),date instanceof Date)return Instant.ofEpochMilli(date.getTime()).atZone(zone);if("function"==typeof date.toDate&&date.toDate()instanceof Date)return Instant.ofEpochMilli(date.toDate().getTime()).atZone(zone);throw new IllegalArgumentException("date must be a javascript Date or a moment instance")}function bindUse(jsJoda){var used=[];return function(fn){return~used.indexOf(fn)||(fn(jsJoda),used.push(fn)),jsJoda}}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var _={assert:assert$1,DateTimeBuilder:DateTimeBuilder,DateTimeParseContext:DateTimeParseContext,DateTimePrintContext:DateTimePrintContext,MathUtil:MathUtil,StringUtil:StringUtil,StringBuilder:StringBuilder},jsJodaExports={_:_,convert:convert,nativeJs:nativeJs,ArithmeticException:ArithmeticException,DateTimeException:DateTimeException,DateTimeParseException:DateTimeParseException,IllegalArgumentException:IllegalArgumentException,IllegalStateException:IllegalStateException,UnsupportedTemporalTypeException:UnsupportedTemporalTypeException,NullPointerException:NullPointerException,Clock:Clock,DayOfWeek:DayOfWeek,Duration:Duration,Instant:Instant,LocalDate:LocalDate,LocalTime:LocalTime,LocalDateTime:LocalDateTime,OffsetTime:OffsetTime,OffsetDateTime:OffsetDateTime,Month:Month,MonthDay:MonthDay,ParsePosition:ParsePosition,Period:Period,Year:Year,YearConstants:YearConstants,YearMonth:YearMonth,ZonedDateTime:ZonedDateTime,ZoneOffset:ZoneOffset,ZoneId:ZoneId,ZoneRegion:ZoneRegion,ZoneOffsetTransition:ZoneOffsetTransition,ZoneRules:ZoneRules,ZoneRulesProvider:ZoneRulesProvider,ChronoLocalDate:ChronoLocalDate,ChronoLocalDateTime:ChronoLocalDateTime,ChronoZonedDateTime:ChronoZonedDateTime,IsoChronology:IsoChronology,ChronoField:ChronoField,ChronoUnit:ChronoUnit,IsoFields:IsoFields,Temporal:Temporal,TemporalAccessor:TemporalAccessor,TemporalAdjuster:TemporalAdjuster,TemporalAdjusters:TemporalAdjusters,TemporalAmount:TemporalAmount,TemporalField:TemporalField,TemporalQueries:TemporalQueries,TemporalQuery:TemporalQuery,TemporalUnit:TemporalUnit,ValueRange:ValueRange,DateTimeFormatter:DateTimeFormatter,DateTimeFormatterBuilder:DateTimeFormatterBuilder,DecimalStyle:DecimalStyle,ResolverStyle:ResolverStyle,SignStyle:SignStyle,TextStyle:TextStyle},use=bindUse(jsJodaExports);jsJodaExports.use=use,exports.ArithmeticException=ArithmeticException,exports.ChronoField=ChronoField,exports.ChronoLocalDate=ChronoLocalDate,exports.ChronoLocalDateTime=ChronoLocalDateTime,exports.ChronoUnit=ChronoUnit,exports.ChronoZonedDateTime=ChronoZonedDateTime,exports.Clock=Clock,exports.DateTimeException=DateTimeException,exports.DateTimeFormatter=DateTimeFormatter,exports.DateTimeFormatterBuilder=DateTimeFormatterBuilder,exports.DateTimeParseException=DateTimeParseException,exports.DayOfWeek=DayOfWeek,exports.DecimalStyle=DecimalStyle,exports.Duration=Duration,exports.IllegalArgumentException=IllegalArgumentException,exports.IllegalStateException=IllegalStateException,exports.Instant=Instant,exports.IsoChronology=IsoChronology,exports.IsoFields=IsoFields,exports.LocalDate=LocalDate,exports.LocalDateTime=LocalDateTime,exports.LocalTime=LocalTime,exports.Month=Month,exports.MonthDay=MonthDay,exports.NullPointerException=NullPointerException,exports.OffsetDateTime=OffsetDateTime,exports.OffsetTime=OffsetTime,exports.ParsePosition=ParsePosition,exports.Period=Period,exports.ResolverStyle=ResolverStyle,exports.SignStyle=SignStyle,exports.Temporal=Temporal,exports.TemporalAccessor=TemporalAccessor,exports.TemporalAdjuster=TemporalAdjuster,exports.TemporalAdjusters=TemporalAdjusters,exports.TemporalAmount=TemporalAmount,exports.TemporalField=TemporalField,exports.TemporalQueries=TemporalQueries,exports.TemporalQuery=TemporalQuery,exports.TemporalUnit=TemporalUnit,exports.TextStyle=TextStyle,exports.UnsupportedTemporalTypeException=UnsupportedTemporalTypeException,exports.ValueRange=ValueRange,exports.Year=Year,exports.YearConstants=YearConstants,exports.YearMonth=YearMonth,exports.ZoneId=ZoneId,exports.ZoneOffset=ZoneOffset,exports.ZoneOffsetTransition=ZoneOffsetTransition,exports.ZoneRegion=ZoneRegion,exports.ZoneRules=ZoneRules,exports.ZoneRulesProvider=ZoneRulesProvider,exports.ZonedDateTime=ZonedDateTime,exports._=_,exports.convert=convert,exports.nativeJs=nativeJs,exports.use=use;