/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{ArithmeticException}from"./errors";export const MAX_SAFE_INTEGER=9007199254740991;export const MIN_SAFE_INTEGER=-9007199254740991;export class MathUtil{static intDiv(x,y){let r=x/y;return r=MathUtil.roundDown(r),MathUtil.safeZero(r)}static intMod(x,y){let r=x-MathUtil.intDiv(x,y)*y;return r=MathUtil.roundDown(r),MathUtil.safeZero(r)}static roundDown(r){return r<0?Math.ceil(r):Math.floor(r)}static floorDiv(x,y){const r=Math.floor(x/y);return MathUtil.safeZero(r)}static floorMod(x,y){const r=x-MathUtil.floorDiv(x,y)*y;return MathUtil.safeZero(r)}static safeAdd(x,y){if(MathUtil.verifyInt(x),MathUtil.verifyInt(y),0===x)return MathUtil.safeZero(y);if(0===y)return MathUtil.safeZero(x);const r=MathUtil.safeToInt(x+y);if(r===x||r===y)throw new ArithmeticException("Invalid addition beyond MAX_SAFE_INTEGER!");return r}static safeSubtract(x,y){return MathUtil.verifyInt(x),MathUtil.verifyInt(y),0===x&&0===y?0:0===x?MathUtil.safeZero(-1*y):0===y?MathUtil.safeZero(x):MathUtil.safeToInt(x-y)}static safeMultiply(x,y){if(MathUtil.verifyInt(x),MathUtil.verifyInt(y),1===x)return MathUtil.safeZero(y);if(1===y)return MathUtil.safeZero(x);if(0===x||0===y)return 0;const r=MathUtil.safeToInt(x*y);if(r/y!==x||x===MIN_SAFE_INTEGER&&-1===y||y===MIN_SAFE_INTEGER&&-1===x)throw new ArithmeticException(`Multiplication overflows: ${x} * ${y}`);return r}static parseInt(value){const r=parseInt(value);return MathUtil.safeToInt(r)}static safeToInt(value){return MathUtil.verifyInt(value),MathUtil.safeZero(value)}static verifyInt(value){if(null==value)throw new ArithmeticException(`Invalid value: '${value}', using null or undefined as argument`);if(isNaN(value))throw new ArithmeticException("Invalid int value, using NaN as argument");if(value%1!=0)throw new ArithmeticException(`Invalid value: '${value}' is a float`);if(value>MAX_SAFE_INTEGER||value<MIN_SAFE_INTEGER)throw new ArithmeticException(`Calculation overflows an int: ${value}`)}static safeZero(value){return 0===value?0:+value}static compareNumbers(a,b){return a<b?-1:a>b?1:0}static smi(int){return int>>>1&1073741824|3221225471&int}static hash(number){if(number!=number||number===1/0)return 0;let result=number;for(;number>4294967295;)result^=number/=4294967295;return MathUtil.smi(result)}static hashCode(...numbers){let result=17;for(const n of numbers)result=(result<<5)-result+MathUtil.hash(n);return MathUtil.hash(result)}}MathUtil.MAX_SAFE_INTEGER=MAX_SAFE_INTEGER,MathUtil.MIN_SAFE_INTEGER=MIN_SAFE_INTEGER;