/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"./assert";import{DateTimeException,IllegalArgumentException}from"./errors";import{StringUtil}from"./StringUtil";import{ZoneOffset}from"./ZoneOffset";import{ZoneRegion}from"./ZoneRegion";import{ZoneId}from"./ZoneId";import{TemporalQueries}from"./temporal/TemporalQueries";import{SystemDefaultZoneId}from"./zone/SystemDefaultZoneId";import{ZoneRulesProvider}from"./zone/ZoneRulesProvider";export class ZoneIdFactory{static systemDefault(){return SYSTEM_DEFAULT_ZONE_ID_INSTANCE}static getAvailableZoneIds(){return ZoneRulesProvider.getAvailableZoneIds()}static of(zoneId){if(requireNonNull(zoneId,"zoneId"),"Z"===zoneId)return ZoneOffset.UTC;if(1===zoneId.length)throw new DateTimeException(`Invalid zone: ${zoneId}`);if(StringUtil.startsWith(zoneId,"+")||StringUtil.startsWith(zoneId,"-"))return ZoneOffset.of(zoneId);if("UTC"===zoneId||"GMT"===zoneId||"GMT0"===zoneId||"UT"===zoneId)return new ZoneRegion(zoneId,ZoneOffset.UTC.rules());if(StringUtil.startsWith(zoneId,"UTC+")||StringUtil.startsWith(zoneId,"GMT+")||StringUtil.startsWith(zoneId,"UTC-")||StringUtil.startsWith(zoneId,"GMT-")){const offset=ZoneOffset.of(zoneId.substring(3));return 0===offset.totalSeconds()?new ZoneRegion(zoneId.substring(0,3),offset.rules()):new ZoneRegion(zoneId.substring(0,3)+offset.id(),offset.rules())}if(StringUtil.startsWith(zoneId,"UT+")||StringUtil.startsWith(zoneId,"UT-")){const offset=ZoneOffset.of(zoneId.substring(2));return 0===offset.totalSeconds()?new ZoneRegion("UT",offset.rules()):new ZoneRegion(`UT${offset.id()}`,offset.rules())}return"SYSTEM"===zoneId?ZoneId.systemDefault():ZoneRegion.ofId(zoneId)}static ofOffset(prefix,offset){if(requireNonNull(prefix,"prefix"),requireNonNull(offset,"offset"),0===prefix.length)return offset;if("GMT"===prefix||"UTC"===prefix||"UT"===prefix)return 0===offset.totalSeconds()?new ZoneRegion(prefix,offset.rules()):new ZoneRegion(prefix+offset.id(),offset.rules());throw new IllegalArgumentException(`Invalid prefix, must be GMT, UTC or UT: ${prefix}`)}static from(temporal){requireNonNull(temporal,"temporal");const obj=temporal.query(TemporalQueries.zone());if(null==obj)throw new DateTimeException(`Unable to obtain ZoneId from TemporalAccessor: ${temporal}, type ${null!=temporal.constructor?temporal.constructor.name:""}`);return obj}}let SYSTEM_DEFAULT_ZONE_ID_INSTANCE=null;export function _init(){SYSTEM_DEFAULT_ZONE_ID_INSTANCE=new SystemDefaultZoneId,ZoneId.systemDefault=ZoneIdFactory.systemDefault,ZoneId.getAvailableZoneIds=ZoneIdFactory.getAvailableZoneIds,ZoneId.of=ZoneIdFactory.of,ZoneId.ofOffset=ZoneIdFactory.ofOffset,ZoneId.from=ZoneIdFactory.from,ZoneOffset.from=ZoneIdFactory.from,ZoneId.SYSTEM=SYSTEM_DEFAULT_ZONE_ID_INSTANCE,ZoneId.UTC=ZoneOffset.ofTotalSeconds(0)}