/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../assert";import{Instant}from"../Instant";import{LocalDate}from"../LocalDate";import{MathUtil}from"../MathUtil";import{ChronoUnit}from"../temporal/ChronoUnit";import{Temporal}from"../temporal/Temporal";import{TemporalQueries}from"../temporal/TemporalQueries";export class ChronoZonedDateTime extends Temporal{query(query){return query===TemporalQueries.zoneId()||query===TemporalQueries.zone()?this.zone():query===TemporalQueries.chronology()?this.toLocalDate().chronology():query===TemporalQueries.precision()?ChronoUnit.NANOS:query===TemporalQueries.offset()?this.offset():query===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toLocalDate().toEpochDay()):query===TemporalQueries.localTime()?this.toLocalTime():super.query(query)}format(formatter){return requireNonNull(formatter,"formatter"),formatter.format(this)}toInstant(){return Instant.ofEpochSecond(this.toEpochSecond(),this.toLocalTime().nano())}toEpochSecond(){let secs=86400*this.toLocalDate().toEpochDay()+this.toLocalTime().toSecondOfDay();return secs-=this.offset().totalSeconds(),secs}compareTo(other){requireNonNull(other,"other");let cmp=MathUtil.compareNumbers(this.toEpochSecond(),other.toEpochSecond());return 0===cmp&&(cmp=this.toLocalTime().nano()-other.toLocalTime().nano(),0===cmp&&(cmp=this.toLocalDateTime().compareTo(other.toLocalDateTime()),0===cmp&&(cmp=strcmp(this.zone().id(),other.zone().id())))),cmp}isAfter(other){requireNonNull(other,"other");const thisEpochSec=this.toEpochSecond(),otherEpochSec=other.toEpochSecond();return thisEpochSec>otherEpochSec||thisEpochSec===otherEpochSec&&this.toLocalTime().nano()>other.toLocalTime().nano()}isBefore(other){requireNonNull(other,"other");const thisEpochSec=this.toEpochSecond(),otherEpochSec=other.toEpochSecond();return thisEpochSec<otherEpochSec||thisEpochSec===otherEpochSec&&this.toLocalTime().nano()<other.toLocalTime().nano()}isEqual(other){return requireNonNull(other,"other"),this.toEpochSecond()===other.toEpochSecond()&&this.toLocalTime().nano()===other.toLocalTime().nano()}equals(other){return this===other||other instanceof ChronoZonedDateTime&&0===this.compareTo(other)}}function strcmp(a,b){return a<b?-1:a>b?1:0}