/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../../assert";import{IllegalArgumentException}from"../../errors";import{MathUtil}from"../../MathUtil";export class FractionPrinterParser{constructor(field,minWidth,maxWidth,decimalPoint){if(requireNonNull(field,"field"),!1===field.range().isFixed())throw new IllegalArgumentException(`Field must have a fixed set of values: ${field}`);if(minWidth<0||minWidth>9)throw new IllegalArgumentException(`Minimum width must be from 0 to 9 inclusive but was ${minWidth}`);if(maxWidth<1||maxWidth>9)throw new IllegalArgumentException(`Maximum width must be from 1 to 9 inclusive but was ${maxWidth}`);if(maxWidth<minWidth)throw new IllegalArgumentException(`Maximum width must exceed or equal the minimum width but ${maxWidth} < ${minWidth}`);this.field=field,this.minWidth=minWidth,this.maxWidth=maxWidth,this.decimalPoint=decimalPoint}print(context,buf){const value=context.getValue(this.field);if(null===value)return!1;const symbols=context.symbols();if(0===value){if(this.minWidth>0){this.decimalPoint&&buf.append(symbols.decimalSeparator());for(let i=0;i<this.minWidth;i++)buf.append(symbols.zeroDigit())}}else{let fraction=this.convertToFraction(value,symbols.zeroDigit());const outputScale=Math.min(Math.max(fraction.length,this.minWidth),this.maxWidth);if(fraction=fraction.substr(0,outputScale),1*fraction>0)for(;fraction.length>this.minWidth&&"0"===fraction[fraction.length-1];)fraction=fraction.substr(0,fraction.length-1);let str=fraction;str=symbols.convertNumberToI18N(str),this.decimalPoint&&buf.append(symbols.decimalSeparator()),buf.append(str)}return!0}parse(context,text,position){const effectiveMin=context.isStrict()?this.minWidth:0,effectiveMax=context.isStrict()?this.maxWidth:9,length=text.length;if(position===length)return effectiveMin>0?~position:position;if(this.decimalPoint){if(text[position]!==context.symbols().decimalSeparator())return effectiveMin>0?~position:position;position++}const minEndPos=position+effectiveMin;if(minEndPos>length)return~position;const maxEndPos=Math.min(position+effectiveMax,length);let total=0,pos=position;for(;pos<maxEndPos;){const ch=text.charAt(pos++),digit=context.symbols().convertToDigit(ch);if(digit<0){if(pos<minEndPos)return~position;pos--;break}total=10*total+digit}const moveLeft=pos-position,scale=Math.pow(10,moveLeft),value=this.convertFromFraction(total,scale);return context.setParsedField(this.field,value,position,pos)}convertToFraction(value,zeroDigit){const range=this.field.range();range.checkValidValue(value,this.field);const _min=range.minimum(),_range=range.maximum()-_min+1,_value=value-_min;let fraction=`${MathUtil.intDiv(1e9*_value,_range)}`;for(;fraction.length<9;)fraction=zeroDigit+fraction;return fraction}convertFromFraction(total,scale){const range=this.field.range(),_min=range.minimum(),_range=range.maximum()-_min+1;return MathUtil.intDiv(total*_range,scale)}toString(){const decimal=this.decimalPoint?",DecimalPoint":"";return`Fraction(${this.field},${this.minWidth},${this.maxWidth}${decimal})`}}