/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{ZoneOffset}from"../../ZoneOffset";import{ZoneId}from"../../ZoneId";import{ZoneRegion}from"../../ZoneRegion";import{ChronoField}from"../../temporal/ChronoField";import{ZoneRulesProvider}from"../../zone/ZoneRulesProvider";import{OffsetIdPrinterParser}from"./OffsetIdPrinterParser";export class ZoneIdPrinterParser{constructor(query,description){this.query=query,this.description=description}print(context,buf){const zone=context.getValueQuery(this.query);return null!=zone&&(buf.append(zone.id()),!0)}parse(context,text,position){const length=text.length;if(position>length)return~position;if(position===length)return~position;const nextChar=text.charAt(position);if("+"===nextChar||"-"===nextChar){const newContext=context.copy(),endPos=OffsetIdPrinterParser.INSTANCE_ID.parse(newContext,text,position);if(endPos<0)return endPos;const offset=newContext.getParsed(ChronoField.OFFSET_SECONDS),zone=ZoneOffset.ofTotalSeconds(offset);return context.setParsedZone(zone),endPos}if(length>=position+2){const nextNextChar=text.charAt(position+1);if(context.charEquals(nextChar,"U")&&context.charEquals(nextNextChar,"T"))return length>=position+3&&context.charEquals(text.charAt(position+2),"C")?this._parsePrefixedOffset(context,text,position,position+3):this._parsePrefixedOffset(context,text,position,position+2);if(context.charEquals(nextChar,"G")&&length>=position+3&&context.charEquals(nextNextChar,"M")&&context.charEquals(text.charAt(position+2),"T"))return this._parsePrefixedOffset(context,text,position,position+3)}if("SYSTEM"===text.substr(position,6))return context.setParsedZone(ZoneId.systemDefault()),position+6;if(context.charEquals(nextChar,"Z"))return context.setParsedZone(ZoneOffset.UTC),position+1;const availableZoneIds=ZoneRulesProvider.getAvailableZoneIds();zoneIdTree.size!==availableZoneIds.length&&(zoneIdTree=ZoneIdTree.createTreeMap(availableZoneIds));const maxParseLength=length-position;let treeMap=zoneIdTree.treeMap,parsedZoneId=null,parseLength=0;for(;null!=treeMap;){const parsedSubZoneId=text.substr(position,Math.min(treeMap.length,maxParseLength));treeMap=treeMap.get(parsedSubZoneId),null!=treeMap&&treeMap.isLeaf&&(parsedZoneId=parsedSubZoneId,parseLength=treeMap.length)}return null!=parsedZoneId?(context.setParsedZone(ZoneRegion.ofId(parsedZoneId)),position+parseLength):~position}_parsePrefixedOffset(context,text,prefixPos,position){const prefix=text.substring(prefixPos,position).toUpperCase(),newContext=context.copy();if(position<text.length&&context.charEquals(text.charAt(position),"Z"))return context.setParsedZone(ZoneId.ofOffset(prefix,ZoneOffset.UTC)),position;const endPos=OffsetIdPrinterParser.INSTANCE_ID.parse(newContext,text,position);if(endPos<0)return context.setParsedZone(ZoneId.ofOffset(prefix,ZoneOffset.UTC)),position;const offsetSecs=newContext.getParsed(ChronoField.OFFSET_SECONDS),offset=ZoneOffset.ofTotalSeconds(offsetSecs);return context.setParsedZone(ZoneId.ofOffset(prefix,offset)),endPos}toString(){return this.description}}class ZoneIdTree{static createTreeMap(availableZoneIds){const sortedZoneIds=availableZoneIds.sort(((a,b)=>a.length-b.length)),treeMap=new ZoneIdTreeMap(sortedZoneIds[0].length,!1);for(let i=0;i<sortedZoneIds.length;i++)treeMap.add(sortedZoneIds[i]);return new ZoneIdTree(sortedZoneIds.length,treeMap)}constructor(size,treeMap){this.size=size,this.treeMap=treeMap}}class ZoneIdTreeMap{constructor(length=0,isLeaf=!1){this.length=length,this.isLeaf=isLeaf,this._treeMap={}}add(zoneId){const idLength=zoneId.length;if(idLength===this.length)this._treeMap[zoneId]=new ZoneIdTreeMap(idLength,!0);else if(idLength>this.length){const subZoneId=zoneId.substr(0,this.length);let subTreeMap=this._treeMap[subZoneId];null==subTreeMap&&(subTreeMap=new ZoneIdTreeMap(idLength,!1),this._treeMap[subZoneId]=subTreeMap),subTreeMap.add(zoneId)}}get(zoneId){return this._treeMap[zoneId]}}let zoneIdTree=new ZoneIdTree([]);