/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{assert,abstractMethodFail,requireInstance,requireNonNull}from"../assert";import{IllegalArgumentException}from"../errors";import{TemporalAccessor}from"./TemporalAccessor";import{TemporalAmount}from"./TemporalAmount";import{TemporalUnit}from"./TemporalUnit";export class Temporal extends TemporalAccessor{isSupported(fieldOrUnit){abstractMethodFail("isSupported")}minus(amount,unit){return arguments.length<2?this._minusAmount(amount):this._minusUnit(amount,unit)}_minusAmount(amount){return requireNonNull(amount,"amount"),requireInstance(amount,TemporalAmount,"amount"),amount.subtractFrom(this)}_minusUnit(amountToSubtract,unit){return requireNonNull(amountToSubtract,"amountToSubtract"),requireNonNull(unit,"unit"),requireInstance(unit,TemporalUnit,"unit"),this._plusUnit(-amountToSubtract,unit)}plus(amount,unit){return arguments.length<2?this._plusAmount(amount):this._plusUnit(amount,unit)}_plusAmount(amount){return requireNonNull(amount,"amount"),requireInstance(amount,TemporalAmount,"amount"),amount.addTo(this)}_plusUnit(amountToAdd,unit){abstractMethodFail("_plusUnit")}until(endTemporal,unit){abstractMethodFail("until")}with(adjusterOrField,newValue){return arguments.length<2?this._withAdjuster(adjusterOrField):this._withField(adjusterOrField,newValue)}_withAdjuster(adjuster){return requireNonNull(adjuster,"adjuster"),assert("function"==typeof adjuster.adjustInto,"adjuster must be a TemporalAdjuster",IllegalArgumentException),adjuster.adjustInto(this)}_withField(field,newValue){abstractMethodFail("_withField")}}"undefined"!=typeof Symbol&&Symbol.toPrimitive&&(Temporal.prototype[Symbol.toPrimitive]=function(hint){if("number"!==hint)return this.toString();throw new TypeError("A conversion from Temporal to a number is not allowed. To compare use the methods .equals(), .compareTo(), .isBefore() or one that is more suitable to your use case.")});