/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{assert}from"../assert";import{DateTimeException,IllegalArgumentException}from"../errors";import{MathUtil}from"../MathUtil";export class ValueRange{constructor(minSmallest,minLargest,maxSmallest,maxLargest){assert(!(minSmallest>minLargest),`Smallest minimum value '${minSmallest}' must be less than largest minimum value '${minLargest}'`,IllegalArgumentException),assert(!(maxSmallest>maxLargest),`Smallest maximum value '${maxSmallest}' must be less than largest maximum value '${maxLargest}'`,IllegalArgumentException),assert(!(minLargest>maxLargest),`Minimum value '${minLargest}' must be less than maximum value '${maxLargest}'`,IllegalArgumentException),this._minSmallest=minSmallest,this._minLargest=minLargest,this._maxLargest=maxLargest,this._maxSmallest=maxSmallest}isFixed(){return this._minSmallest===this._minLargest&&this._maxSmallest===this._maxLargest}minimum(){return this._minSmallest}largestMinimum(){return this._minLargest}maximum(){return this._maxLargest}smallestMaximum(){return this._maxSmallest}isValidValue(value){return this.minimum()<=value&&value<=this.maximum()}checkValidValue(value,field){let msg;return this.isValidValue(value)?value:(msg=null!=field?`Invalid value for ${field} (valid values ${this.toString()}): ${value}`:`Invalid value (valid values ${this.toString()}): ${value}`,assert(!1,msg,DateTimeException))}checkValidIntValue(value,field){if(!1===this.isValidIntValue(value))throw new DateTimeException(`Invalid int value for ${field}: ${value}`);return value}isValidIntValue(value){return this.isIntValue()&&this.isValidValue(value)}isIntValue(){return this.minimum()>=MathUtil.MIN_SAFE_INTEGER&&this.maximum()<=MathUtil.MAX_SAFE_INTEGER}equals(other){return other===this||other instanceof ValueRange&&(this._minSmallest===other._minSmallest&&this._minLargest===other._minLargest&&this._maxSmallest===other._maxSmallest&&this._maxLargest===other._maxLargest)}hashCode(){return MathUtil.hashCode(this._minSmallest,this._minLargest,this._maxSmallest,this._maxLargest)}toString(){let str=this.minimum()+(this.minimum()!==this.largestMinimum()?`/${this.largestMinimum()}`:"");return str+=" - ",str+=this.smallestMaximum()+(this.smallestMaximum()!==this.maximum()?`/${this.maximum()}`:""),str}static of(){return 2===arguments.length?new ValueRange(arguments[0],arguments[0],arguments[1],arguments[1]):3===arguments.length?new ValueRange(arguments[0],arguments[0],arguments[1],arguments[2]):4===arguments.length?new ValueRange(arguments[0],arguments[1],arguments[2],arguments[3]):assert(!1,`Invalid number of arguments ${arguments.length}`,IllegalArgumentException)}}