/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{ZoneRules}from"./ZoneRules";import{ZoneOffset}from"../ZoneOffset";import{DateTimeException}from"../errors";export class SystemDefaultZoneRules extends ZoneRules{isFixedOffset(){return!1}offsetOfInstant(instant){const offsetInMinutes=new Date(instant.toEpochMilli()).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*offsetInMinutes)}offsetOfEpochMilli(epochMilli){const offsetInMinutes=new Date(epochMilli).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*offsetInMinutes)}offsetOfLocalDateTime(localDateTime){const epochMilli=1e3*localDateTime.toEpochSecond(ZoneOffset.UTC),offsetInMinutesBeforePossibleTransition=new Date(epochMilli).getTimezoneOffset(),offsetInMinutesAfterPossibleTransition=new Date(epochMilli+6e4*offsetInMinutesBeforePossibleTransition).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*offsetInMinutesAfterPossibleTransition)}validOffsets(localDateTime){return[this.offsetOfLocalDateTime(localDateTime)]}transition(){return null}standardOffset(instant){return this.offsetOfInstant(instant)}daylightSavings(){this._throwNotSupported()}isDaylightSavings(){this._throwNotSupported()}isValidOffset(dateTime,offset){return this.offsetOfLocalDateTime(dateTime).equals(offset)}nextTransition(){this._throwNotSupported()}previousTransition(){this._throwNotSupported()}transitions(){this._throwNotSupported()}transitionRules(){this._throwNotSupported()}_throwNotSupported(){throw new DateTimeException("not supported operation")}equals(other){return this===other||other instanceof SystemDefaultZoneRules}toString(){return"SYSTEM"}}