/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../assert";import{IllegalArgumentException}from"../errors";import{Duration}from"../Duration";import{LocalDateTime}from"../LocalDateTime";export class ZoneOffsetTransition{static of(transition,offsetBefore,offsetAfter){return new ZoneOffsetTransition(transition,offsetBefore,offsetAfter)}constructor(transition,offsetBefore,offsetAfter){if(requireNonNull(transition,"transition"),requireNonNull(offsetBefore,"offsetBefore"),requireNonNull(offsetAfter,"offsetAfter"),offsetBefore.equals(offsetAfter))throw new IllegalArgumentException("Offsets must not be equal");if(0!==transition.nano())throw new IllegalArgumentException("Nano-of-second must be zero");this._transition=transition instanceof LocalDateTime?transition:LocalDateTime.ofEpochSecond(transition,0,offsetBefore),this._offsetBefore=offsetBefore,this._offsetAfter=offsetAfter}instant(){return this._transition.toInstant(this._offsetBefore)}toEpochSecond(){return this._transition.toEpochSecond(this._offsetBefore)}dateTimeBefore(){return this._transition}dateTimeAfter(){return this._transition.plusSeconds(this.durationSeconds())}offsetBefore(){return this._offsetBefore}offsetAfter(){return this._offsetAfter}duration(){return Duration.ofSeconds(this.durationSeconds())}durationSeconds(){return this._offsetAfter.totalSeconds()-this._offsetBefore.totalSeconds()}isGap(){return this._offsetAfter.totalSeconds()>this._offsetBefore.totalSeconds()}isOverlap(){return this._offsetAfter.totalSeconds()<this._offsetBefore.totalSeconds()}isValidOffset(offset){return!this.isGap()&&(this._offsetBefore.equals(offset)||this._offsetAfter.equals(offset))}validOffsets(){return this.isGap()?[]:[this._offsetBefore,this._offsetAfter]}compareTo(transition){return this.instant().compareTo(transition.instant())}equals(other){if(other===this)return!0;if(other instanceof ZoneOffsetTransition){const d=other;return this._transition.equals(d._transition)&&this._offsetBefore.equals(d.offsetBefore())&&this._offsetAfter.equals(d.offsetAfter())}return!1}hashCode(){return this._transition.hashCode()^this._offsetBefore.hashCode()^this._offsetAfter.hashCode()>>>16}toString(){return`Transition[${this.isGap()?"Gap":"Overlap"} at ${this._transition.toString()}${this._offsetBefore.toString()} to ${this._offsetAfter}]`}}