/*!
 * body-parser
 * Copyright(c) 2014 Jonathan Ong
 * Copyright(c) 2014-2015 Douglas Christopher Wilson
 * MIT Licensed
 */
"use strict";var bytes=require("bytes"),contentType=require("content-type"),createError=require("http-errors"),debug=require("debug")("body-parser:json"),read=require("../read"),typeis=require("type-is");module.exports=json;var FIRST_CHAR_REGEXP=/^[\x20\x09\x0a\x0d]*([^\x20\x09\x0a\x0d])/;function json(options){var opts=options||{},limit="number"!=typeof opts.limit?bytes.parse(opts.limit||"100kb"):opts.limit,inflate=!1!==opts.inflate,reviver=opts.reviver,strict=!1!==opts.strict,type=opts.type||"application/json",verify=opts.verify||!1;if(!1!==verify&&"function"!=typeof verify)throw new TypeError("option verify must be function");var shouldParse="function"!=typeof type?typeChecker(type):type;function parse(body){if(0===body.length)return{};if(strict){var first=firstchar(body);if("{"!==first&&"["!==first)throw debug("strict violation"),createStrictSyntaxError(body,first)}try{return debug("parse json"),JSON.parse(body,reviver)}catch(e){throw normalizeJsonSyntaxError(e,{message:e.message,stack:e.stack})}}return function(req,res,next){if(req._body)return debug("body already parsed"),void next();if(req.body=req.body||{},!typeis.hasBody(req))return debug("skip empty body"),void next();if(debug("content-type %j",req.headers["content-type"]),!shouldParse(req))return debug("skip parsing"),void next();var charset=getCharset(req)||"utf-8";if("utf-"!==charset.slice(0,4))return debug("invalid charset"),void next(createError(415,'unsupported charset "'+charset.toUpperCase()+'"',{charset:charset,type:"charset.unsupported"}));read(req,res,next,parse,debug,{encoding:charset,inflate:inflate,limit:limit,verify:verify})}}function createStrictSyntaxError(str,char){var index=str.indexOf(char),partial=-1!==index?str.substring(0,index)+"#":"";try{throw JSON.parse(partial),new SyntaxError("strict violation")}catch(e){return normalizeJsonSyntaxError(e,{message:e.message.replace("#",char),stack:e.stack})}}function firstchar(str){var match=FIRST_CHAR_REGEXP.exec(str);return match?match[1]:void 0}function getCharset(req){try{return(contentType.parse(req).parameters.charset||"").toLowerCase()}catch(e){return}}function normalizeJsonSyntaxError(error,obj){for(var keys=Object.getOwnPropertyNames(error),i=0;i<keys.length;i++){var key=keys[i];"stack"!==key&&"message"!==key&&delete error[key]}return error.stack=obj.stack.replace(error.message,obj.message),error.message=obj.message,error}function typeChecker(type){return function(req){return Boolean(typeis(req,type))}}