"use strict";var common=require("./common"),EventEmitter=require("../").EventEmitter,once=require("../").once,has=require("has"),assert=require("assert");function Event(type){this.type=type}function EventTargetMock(){this.events={},this.addEventListener=common.mustCall(this.addEventListener),this.removeEventListener=common.mustCall(this.removeEventListener)}function onceAnEvent(){var ee=new EventEmitter;return process.nextTick((function(){ee.emit("myevent",42)})),once(ee,"myevent").then((function(args){var value=args[0];assert.strictEqual(value,42),assert.strictEqual(ee.listenerCount("error"),0),assert.strictEqual(ee.listenerCount("myevent"),0)}))}function onceAnEventWithTwoArgs(){var ee=new EventEmitter;return process.nextTick((function(){ee.emit("myevent",42,24)})),once(ee,"myevent").then((function(value){assert.strictEqual(value.length,2),assert.strictEqual(value[0],42),assert.strictEqual(value[1],24)}))}function catchesErrors(){var ee=new EventEmitter,expected=new Error("kaboom");return process.nextTick((function(){ee.emit("error",expected)})),once(ee,"myevent").then((function(){throw new Error("should reject")}),(function(err){assert.strictEqual(err,expected),assert.strictEqual(ee.listenerCount("error"),0),assert.strictEqual(ee.listenerCount("myevent"),0)}))}function stopListeningAfterCatchingError(){var ee=new EventEmitter,expected=new Error("kaboom");return process.nextTick((function(){ee.emit("error",expected),ee.emit("myevent",42,24)})),once(ee,"myevent").then(common.mustNotCall,(function(err){assert.strictEqual(err,expected),assert.strictEqual(ee.listenerCount("error"),0),assert.strictEqual(ee.listenerCount("myevent"),0)}))}function onceError(){var ee=new EventEmitter,expected=new Error("kaboom");process.nextTick((function(){ee.emit("error",expected)}));var promise=once(ee,"error");return assert.strictEqual(ee.listenerCount("error"),1),promise.then((function(args){var err=args[0];assert.strictEqual(err,expected),assert.strictEqual(ee.listenerCount("error"),0),assert.strictEqual(ee.listenerCount("myevent"),0)}))}function onceWithEventTarget(){var et=new EventTargetMock,event=new Event("myevent");return process.nextTick((function(){et.dispatchEvent(event)})),once(et,"myevent").then((function(args){var value=args[0];assert.strictEqual(value,event),assert.strictEqual(has(et.events,"myevent"),!1)}))}function onceWithEventTargetError(){var et=new EventTargetMock,error=new Event("error");return process.nextTick((function(){et.dispatchEvent(error)})),once(et,"error").then((function(args){var err=args[0];assert.strictEqual(err,error),assert.strictEqual(has(et.events,"error"),!1)}))}function prioritizesEventEmitter(){var ee=new EventEmitter;return ee.addEventListener=assert.fail,ee.removeAllListeners=assert.fail,process.nextTick((function(){ee.emit("foo")})),once(ee,"foo")}EventTargetMock.prototype.addEventListener=function(name,listener,options){name in this.events||(this.events[name]={listeners:[],options:options||{}}),this.events[name].listeners.push(listener)},EventTargetMock.prototype.removeEventListener=function(name,callback){if(name in this.events)for(var stack=this.events[name].listeners,i=0,l=stack.length;i<l;i++)if(stack[i]===callback)return stack.splice(i,1),void(0===stack.length&&delete this.events[name])},EventTargetMock.prototype.dispatchEvent=function(arg){if(!(arg.type in this.events))return!0;for(var event=this.events[arg.type],stack=event.listeners.slice(),i=0,l=stack.length;i<l;i++)stack[i].call(null,arg),event.options.once&&this.removeEventListener(arg.type,stack[i]);return!arg.defaultPrevented};var allTests=[onceAnEvent(),onceAnEventWithTwoArgs(),catchesErrors(),stopListeningAfterCatchingError(),onceError(),onceWithEventTarget(),onceWithEventTargetError(),prioritizesEventEmitter()],hasBrowserEventTarget=!1;try{hasBrowserEventTarget="function"==typeof(new window.EventTarget).addEventListener&&"xyz"===new window.Event("xyz").type}catch(err){}if(hasBrowserEventTarget){var onceWithBrowserEventTarget=function(){var et=new window.EventTarget,event=new window.Event("myevent");return process.nextTick((function(){et.dispatchEvent(event)})),once(et,"myevent").then((function(args){var value=args[0];assert.strictEqual(value,event),assert.strictEqual(has(et.events,"myevent"),!1)}))},onceWithBrowserEventTargetError=function(){var et=new window.EventTarget,error=new window.Event("error");return process.nextTick((function(){et.dispatchEvent(error)})),once(et,"error").then((function(args){var err=args[0];assert.strictEqual(err,error),assert.strictEqual(has(et.events,"error"),!1)}))};common.test.comment("Testing with browser built-in EventTarget"),allTests.push([onceWithBrowserEventTarget(),onceWithBrowserEventTargetError()])}module.exports=Promise.all(allTests);