/*!
 * finalhandler
 * Copyright(c) 2014-2022 Douglas Christopher Wilson
 * MIT Licensed
 */
"use strict";var debug=require("debug")("finalhandler"),encodeUrl=require("encodeurl"),escapeHtml=require("escape-html"),onFinished=require("on-finished"),parseUrl=require("parseurl"),statuses=require("statuses"),unpipe=require("unpipe"),DOUBLE_SPACE_REGEXP=/\x20{2}/g,NEWLINE_REGEXP=/\n/g,defer="function"==typeof setImmediate?setImmediate:function(fn){process.nextTick(fn.bind.apply(fn,arguments))},isFinished=onFinished.isFinished;function createHtmlDocument(message){return'<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>Error</title>\n</head>\n<body>\n<pre>'+escapeHtml(message).replace(NEWLINE_REGEXP,"<br>").replace(DOUBLE_SPACE_REGEXP," &nbsp;")+"</pre>\n</body>\n</html>\n"}function finalhandler(req,res,options){var opts=options||{},env=opts.env||process.env.NODE_ENV||"development",onerror=opts.onerror;return function(err){var headers,msg,status;if(err||!headersSent(res)){if(err?(void 0===(status=getErrorStatusCode(err))?status=getResponseStatusCode(res):headers=getErrorHeaders(err),msg=getErrorMessage(err,status,env)):(status=404,msg="Cannot "+req.method+" "+encodeUrl(getResourceName(req))),debug("default %s",status),err&&onerror&&defer(onerror,err,req,res),headersSent(res))return debug("cannot %d after headers sent",status),void req.socket.destroy();send(req,res,status,headers,msg)}else debug("cannot 404 after headers sent")}}function getErrorHeaders(err){if(err.headers&&"object"==typeof err.headers){for(var headers=Object.create(null),keys=Object.keys(err.headers),i=0;i<keys.length;i++){var key=keys[i];headers[key]=err.headers[key]}return headers}}function getErrorMessage(err,status,env){var msg;return"production"!==env&&((msg=err.stack)||"function"!=typeof err.toString||(msg=err.toString())),msg||statuses.message[status]}function getErrorStatusCode(err){return"number"==typeof err.status&&err.status>=400&&err.status<600?err.status:"number"==typeof err.statusCode&&err.statusCode>=400&&err.statusCode<600?err.statusCode:void 0}function getResourceName(req){try{return parseUrl.original(req).pathname}catch(e){return"resource"}}function getResponseStatusCode(res){var status=res.statusCode;return("number"!=typeof status||status<400||status>599)&&(status=500),status}function headersSent(res){return"boolean"!=typeof res.headersSent?Boolean(res._header):res.headersSent}function send(req,res,status,headers,message){function write(){var body=createHtmlDocument(message);res.statusCode=status,res.statusMessage=statuses.message[status],res.removeHeader("Content-Encoding"),res.removeHeader("Content-Language"),res.removeHeader("Content-Range"),setHeaders(res,headers),res.setHeader("Content-Security-Policy","default-src 'none'"),res.setHeader("X-Content-Type-Options","nosniff"),res.setHeader("Content-Type","text/html; charset=utf-8"),res.setHeader("Content-Length",Buffer.byteLength(body,"utf8")),"HEAD"!==req.method?res.end(body,"utf8"):res.end()}isFinished(req)?write():(unpipe(req),onFinished(req,write),req.resume())}function setHeaders(res,headers){if(headers)for(var keys=Object.keys(headers),i=0;i<keys.length;i++){var key=keys[i];res.setHeader(key,headers[key])}}module.exports=finalhandler;