/**
 * [js-md4]{@link https://github.com/emn178/js-md4}
 *
 * @namespace md4
 * @version 0.3.2
 * @author Yi-Cyuan Chen [emn178@gmail.com]
 * @copyright Yi-Cyuan Chen 2015-2027
 * @license MIT
 */
!function(){"use strict";var root="object"==typeof window?window:{},NODE_JS=!root.JS_MD4_NO_NODE_JS&&"object"==typeof process&&process.versions&&process.versions.node;NODE_JS&&(root=global);var buffer8,COMMON_JS=!root.JS_MD4_NO_COMMON_JS&&"object"==typeof module&&module.exports,AMD="function"==typeof define&&define.amd,ARRAY_BUFFER=!root.JS_MD4_NO_ARRAY_BUFFER&&"undefined"!=typeof ArrayBuffer,HEX_CHARS="0123456789abcdef".split(""),EXTRA=[128,32768,8388608,-2147483648],SHIFT=[0,8,16,24],OUTPUT_TYPES=["hex","array","digest","buffer","arrayBuffer"],blocks=[];if(ARRAY_BUFFER){var buffer=new ArrayBuffer(68);buffer8=new Uint8Array(buffer),blocks=new Uint32Array(buffer)}var createOutputMethod=function(outputType){return function(message){return new Md4(!0).update(message)[outputType]()}},createMethod=function(){var method=createOutputMethod("hex");NODE_JS&&(method=nodeWrap(method)),method.create=function(){return new Md4},method.update=function(message){return method.create().update(message)};for(var i=0;i<OUTPUT_TYPES.length;++i){var type=OUTPUT_TYPES[i];method[type]=createOutputMethod(type)}return method},nodeWrap=function(method){var crypto=require("crypto"),Buffer=require("buffer").Buffer;return function(message){if("string"==typeof message)return crypto.createHash("md4").update(message,"utf8").digest("hex");if(ARRAY_BUFFER&&message instanceof ArrayBuffer)message=new Uint8Array(message);else if(void 0===message.length)return method(message);return crypto.createHash("md4").update(new Buffer(message)).digest("hex")}};function Md4(sharedMemory){if(sharedMemory)blocks[0]=blocks[16]=blocks[1]=blocks[2]=blocks[3]=blocks[4]=blocks[5]=blocks[6]=blocks[7]=blocks[8]=blocks[9]=blocks[10]=blocks[11]=blocks[12]=blocks[13]=blocks[14]=blocks[15]=0,this.blocks=blocks,this.buffer8=buffer8;else if(ARRAY_BUFFER){var buffer=new ArrayBuffer(68);this.buffer8=new Uint8Array(buffer),this.blocks=new Uint32Array(buffer)}else this.blocks=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];this.h0=this.h1=this.h2=this.h3=this.start=this.bytes=0,this.finalized=this.hashed=!1,this.first=!0}Md4.prototype.update=function(message){if(!this.finalized){var notString="string"!=typeof message;notString&&ARRAY_BUFFER&&message instanceof ArrayBuffer&&(message=new Uint8Array(message));for(var code,i,index=0,length=message.length||0,blocks=this.blocks,buffer8=this.buffer8;index<length;){if(this.hashed&&(this.hashed=!1,blocks[0]=blocks[16],blocks[16]=blocks[1]=blocks[2]=blocks[3]=blocks[4]=blocks[5]=blocks[6]=blocks[7]=blocks[8]=blocks[9]=blocks[10]=blocks[11]=blocks[12]=blocks[13]=blocks[14]=blocks[15]=0),notString)if(ARRAY_BUFFER)for(i=this.start;index<length&&i<64;++index)buffer8[i++]=message[index];else for(i=this.start;index<length&&i<64;++index)blocks[i>>2]|=message[index]<<SHIFT[3&i++];else if(ARRAY_BUFFER)for(i=this.start;index<length&&i<64;++index)(code=message.charCodeAt(index))<128?buffer8[i++]=code:code<2048?(buffer8[i++]=192|code>>6,buffer8[i++]=128|63&code):code<55296||code>=57344?(buffer8[i++]=224|code>>12,buffer8[i++]=128|code>>6&63,buffer8[i++]=128|63&code):(code=65536+((1023&code)<<10|1023&message.charCodeAt(++index)),buffer8[i++]=240|code>>18,buffer8[i++]=128|code>>12&63,buffer8[i++]=128|code>>6&63,buffer8[i++]=128|63&code);else for(i=this.start;index<length&&i<64;++index)(code=message.charCodeAt(index))<128?blocks[i>>2]|=code<<SHIFT[3&i++]:code<2048?(blocks[i>>2]|=(192|code>>6)<<SHIFT[3&i++],blocks[i>>2]|=(128|63&code)<<SHIFT[3&i++]):code<55296||code>=57344?(blocks[i>>2]|=(224|code>>12)<<SHIFT[3&i++],blocks[i>>2]|=(128|code>>6&63)<<SHIFT[3&i++],blocks[i>>2]|=(128|63&code)<<SHIFT[3&i++]):(code=65536+((1023&code)<<10|1023&message.charCodeAt(++index)),blocks[i>>2]|=(240|code>>18)<<SHIFT[3&i++],blocks[i>>2]|=(128|code>>12&63)<<SHIFT[3&i++],blocks[i>>2]|=(128|code>>6&63)<<SHIFT[3&i++],blocks[i>>2]|=(128|63&code)<<SHIFT[3&i++]);this.lastByteIndex=i,this.bytes+=i-this.start,i>=64?(this.start=i-64,this.hash(),this.hashed=!0):this.start=i}return this}},Md4.prototype.finalize=function(){if(!this.finalized){this.finalized=!0;var blocks=this.blocks,i=this.lastByteIndex;blocks[i>>2]|=EXTRA[3&i],i>=56&&(this.hashed||this.hash(),blocks[0]=blocks[16],blocks[16]=blocks[1]=blocks[2]=blocks[3]=blocks[4]=blocks[5]=blocks[6]=blocks[7]=blocks[8]=blocks[9]=blocks[10]=blocks[11]=blocks[12]=blocks[13]=blocks[14]=blocks[15]=0),blocks[14]=this.bytes<<3,this.hash()}},Md4.prototype.hash=function(){var a,b,c,d,ab,bc,cd,da,blocks=this.blocks;this.first?b=(b=((c=(c=((d=(d=(4023233417&(a=(a=blocks[0]-1)<<3|a>>>29)|2562383102&~a)+blocks[1]+271733878)<<7|d>>>25)&a|4023233417&~d)+blocks[2]-1732584194)<<11|c>>>21)&d|~c&a)+blocks[3]-271733879)<<19|b>>>13:(a=this.h0,b=this.h1,c=this.h2,d=this.h3,b=(b+=((c=(c+=((d=(d+=((a=(a+=(b&c|~b&d)+blocks[0])<<3|a>>>29)&b|~a&c)+blocks[1])<<7|d>>>25)&a|~d&b)+blocks[2])<<11|c>>>21)&d|~c&a)+blocks[3])<<19|b>>>13),b=(b+=((c=(c+=((d=(d+=((a=(a+=(b&c|~b&d)+blocks[4])<<3|a>>>29)&b|~a&c)+blocks[5])<<7|d>>>25)&a|~d&b)+blocks[6])<<11|c>>>21)&d|~c&a)+blocks[7])<<19|b>>>13,b=(b+=((c=(c+=((d=(d+=((a=(a+=(b&c|~b&d)+blocks[8])<<3|a>>>29)&b|~a&c)+blocks[9])<<7|d>>>25)&a|~d&b)+blocks[10])<<11|c>>>21)&d|~c&a)+blocks[11])<<19|b>>>13,b=(b+=((c=(c+=((d=(d+=((a=(a+=(b&c|~b&d)+blocks[12])<<3|a>>>29)&b|~a&c)+blocks[13])<<7|d>>>25)&a|~d&b)+blocks[14])<<11|c>>>21)&d|~c&a)+blocks[15])<<19|b>>>13,b=(b+=((cd=(c=(c+=((da=(d=(d+=((ab=(a=(a+=((bc=b&c)|b&d|c&d)+blocks[0]+1518500249)<<3|a>>>29)&b)|a&c|bc)+blocks[4]+1518500249)<<5|d>>>27)&a)|d&b|ab)+blocks[8]+1518500249)<<9|c>>>23)&d)|c&a|da)+blocks[12]+1518500249)<<13|b>>>19,b=(b+=((cd=(c=(c+=((da=(d=(d+=((ab=(a=(a+=((bc=b&c)|b&d|cd)+blocks[1]+1518500249)<<3|a>>>29)&b)|a&c|bc)+blocks[5]+1518500249)<<5|d>>>27)&a)|d&b|ab)+blocks[9]+1518500249)<<9|c>>>23)&d)|c&a|da)+blocks[13]+1518500249)<<13|b>>>19,b=(b+=((cd=(c=(c+=((da=(d=(d+=((ab=(a=(a+=((bc=b&c)|b&d|cd)+blocks[2]+1518500249)<<3|a>>>29)&b)|a&c|bc)+blocks[6]+1518500249)<<5|d>>>27)&a)|d&b|ab)+blocks[10]+1518500249)<<9|c>>>23)&d)|c&a|da)+blocks[14]+1518500249)<<13|b>>>19,b=(b+=((c=(c+=((da=(d=(d+=((ab=(a=(a+=((bc=b&c)|b&d|cd)+blocks[3]+1518500249)<<3|a>>>29)&b)|a&c|bc)+blocks[7]+1518500249)<<5|d>>>27)&a)|d&b|ab)+blocks[11]+1518500249)<<9|c>>>23)&d|c&a|da)+blocks[15]+1518500249)<<13|b>>>19,b=(b+=((da=(d=(d+=((bc=b^c)^(a=(a+=(bc^d)+blocks[0]+1859775393)<<3|a>>>29))+blocks[8]+1859775393)<<9|d>>>23)^a)^(c=(c+=(da^b)+blocks[4]+1859775393)<<11|c>>>21))+blocks[12]+1859775393)<<15|b>>>17,b=(b+=((da=(d=(d+=((bc=b^c)^(a=(a+=(bc^d)+blocks[2]+1859775393)<<3|a>>>29))+blocks[10]+1859775393)<<9|d>>>23)^a)^(c=(c+=(da^b)+blocks[6]+1859775393)<<11|c>>>21))+blocks[14]+1859775393)<<15|b>>>17,b=(b+=((da=(d=(d+=((bc=b^c)^(a=(a+=(bc^d)+blocks[1]+1859775393)<<3|a>>>29))+blocks[9]+1859775393)<<9|d>>>23)^a)^(c=(c+=(da^b)+blocks[5]+1859775393)<<11|c>>>21))+blocks[13]+1859775393)<<15|b>>>17,b=(b+=((da=(d=(d+=((bc=b^c)^(a=(a+=(bc^d)+blocks[3]+1859775393)<<3|a>>>29))+blocks[11]+1859775393)<<9|d>>>23)^a)^(c=(c+=(da^b)+blocks[7]+1859775393)<<11|c>>>21))+blocks[15]+1859775393)<<15|b>>>17,this.first?(this.h0=a+1732584193<<0,this.h1=b-271733879<<0,this.h2=c-1732584194<<0,this.h3=d+271733878<<0,this.first=!1):(this.h0=this.h0+a<<0,this.h1=this.h1+b<<0,this.h2=this.h2+c<<0,this.h3=this.h3+d<<0)},Md4.prototype.hex=function(){this.finalize();var h0=this.h0,h1=this.h1,h2=this.h2,h3=this.h3;return HEX_CHARS[h0>>4&15]+HEX_CHARS[15&h0]+HEX_CHARS[h0>>12&15]+HEX_CHARS[h0>>8&15]+HEX_CHARS[h0>>20&15]+HEX_CHARS[h0>>16&15]+HEX_CHARS[h0>>28&15]+HEX_CHARS[h0>>24&15]+HEX_CHARS[h1>>4&15]+HEX_CHARS[15&h1]+HEX_CHARS[h1>>12&15]+HEX_CHARS[h1>>8&15]+HEX_CHARS[h1>>20&15]+HEX_CHARS[h1>>16&15]+HEX_CHARS[h1>>28&15]+HEX_CHARS[h1>>24&15]+HEX_CHARS[h2>>4&15]+HEX_CHARS[15&h2]+HEX_CHARS[h2>>12&15]+HEX_CHARS[h2>>8&15]+HEX_CHARS[h2>>20&15]+HEX_CHARS[h2>>16&15]+HEX_CHARS[h2>>28&15]+HEX_CHARS[h2>>24&15]+HEX_CHARS[h3>>4&15]+HEX_CHARS[15&h3]+HEX_CHARS[h3>>12&15]+HEX_CHARS[h3>>8&15]+HEX_CHARS[h3>>20&15]+HEX_CHARS[h3>>16&15]+HEX_CHARS[h3>>28&15]+HEX_CHARS[h3>>24&15]},Md4.prototype.toString=Md4.prototype.hex,Md4.prototype.digest=function(){this.finalize();var h0=this.h0,h1=this.h1,h2=this.h2,h3=this.h3;return[255&h0,h0>>8&255,h0>>16&255,h0>>24&255,255&h1,h1>>8&255,h1>>16&255,h1>>24&255,255&h2,h2>>8&255,h2>>16&255,h2>>24&255,255&h3,h3>>8&255,h3>>16&255,h3>>24&255]},Md4.prototype.array=Md4.prototype.digest,Md4.prototype.arrayBuffer=function(){this.finalize();var buffer=new ArrayBuffer(16),blocks=new Uint32Array(buffer);return blocks[0]=this.h0,blocks[1]=this.h1,blocks[2]=this.h2,blocks[3]=this.h3,buffer},Md4.prototype.buffer=Md4.prototype.arrayBuffer;var exports=createMethod();COMMON_JS?module.exports=exports:(root.md4=exports,AMD&&define((function(){return exports})))}();