const timespan=require("./lib/timespan"),PS_SUPPORTED=require("./lib/psSupported"),validateAsymmetricKey=require("./lib/validateAsymmetricKey"),jws=require("jws"),{includes:includes,isBoolean:isBoolean,isInteger:isInteger,isNumber:isNumber,isPlainObject:isPlainObject,isString:isString,once:once}=require("lodash"),{KeyObject:KeyObject,createSecretKey:createSecretKey,createPrivateKey:createPrivateKey}=require("crypto"),SUPPORTED_ALGS=["RS256","RS384","RS512","ES256","ES384","ES512","HS256","HS384","HS512","none"];PS_SUPPORTED&&SUPPORTED_ALGS.splice(3,0,"PS256","PS384","PS512");const sign_options_schema={expiresIn:{isValid:function(value){return isInteger(value)||isString(value)&&value},message:'"expiresIn" should be a number of seconds or string representing a timespan'},notBefore:{isValid:function(value){return isInteger(value)||isString(value)&&value},message:'"notBefore" should be a number of seconds or string representing a timespan'},audience:{isValid:function(value){return isString(value)||Array.isArray(value)},message:'"audience" must be a string or array'},algorithm:{isValid:includes.bind(null,SUPPORTED_ALGS),message:'"algorithm" must be a valid string enum value'},header:{isValid:isPlainObject,message:'"header" must be an object'},encoding:{isValid:isString,message:'"encoding" must be a string'},issuer:{isValid:isString,message:'"issuer" must be a string'},subject:{isValid:isString,message:'"subject" must be a string'},jwtid:{isValid:isString,message:'"jwtid" must be a string'},noTimestamp:{isValid:isBoolean,message:'"noTimestamp" must be a boolean'},keyid:{isValid:isString,message:'"keyid" must be a string'},mutatePayload:{isValid:isBoolean,message:'"mutatePayload" must be a boolean'},allowInsecureKeySizes:{isValid:isBoolean,message:'"allowInsecureKeySizes" must be a boolean'},allowInvalidAsymmetricKeyTypes:{isValid:isBoolean,message:'"allowInvalidAsymmetricKeyTypes" must be a boolean'}},registered_claims_schema={iat:{isValid:isNumber,message:'"iat" should be a number of seconds'},exp:{isValid:isNumber,message:'"exp" should be a number of seconds'},nbf:{isValid:isNumber,message:'"nbf" should be a number of seconds'}};function validate(schema,allowUnknown,object,parameterName){if(!isPlainObject(object))throw new Error('Expected "'+parameterName+'" to be a plain object.');Object.keys(object).forEach((function(key){const validator=schema[key];if(validator){if(!validator.isValid(object[key]))throw new Error(validator.message)}else if(!allowUnknown)throw new Error('"'+key+'" is not allowed in "'+parameterName+'"')}))}function validateOptions(options){return validate(sign_options_schema,!1,options,"options")}function validatePayload(payload){return validate(registered_claims_schema,!0,payload,"payload")}const options_to_payload={audience:"aud",issuer:"iss",subject:"sub",jwtid:"jti"},options_for_objects=["expiresIn","notBefore","noTimestamp","audience","issuer","subject","jwtid"];module.exports=function(payload,secretOrPrivateKey,options,callback){"function"==typeof options?(callback=options,options={}):options=options||{};const isObjectPayload="object"==typeof payload&&!Buffer.isBuffer(payload),header=Object.assign({alg:options.algorithm||"HS256",typ:isObjectPayload?"JWT":void 0,kid:options.keyid},options.header);function failure(err){if(callback)return callback(err);throw err}if(!secretOrPrivateKey&&"none"!==options.algorithm)return failure(new Error("secretOrPrivateKey must have a value"));if(null!=secretOrPrivateKey&&!(secretOrPrivateKey instanceof KeyObject))try{secretOrPrivateKey=createPrivateKey(secretOrPrivateKey)}catch(_){try{secretOrPrivateKey=createSecretKey("string"==typeof secretOrPrivateKey?Buffer.from(secretOrPrivateKey):secretOrPrivateKey)}catch(_){return failure(new Error("secretOrPrivateKey is not valid key material"))}}if(header.alg.startsWith("HS")&&"secret"!==secretOrPrivateKey.type)return failure(new Error(`secretOrPrivateKey must be a symmetric key when using ${header.alg}`));if(/^(?:RS|PS|ES)/.test(header.alg)){if("private"!==secretOrPrivateKey.type)return failure(new Error(`secretOrPrivateKey must be an asymmetric key when using ${header.alg}`));if(!options.allowInsecureKeySizes&&!header.alg.startsWith("ES")&&void 0!==secretOrPrivateKey.asymmetricKeyDetails&&secretOrPrivateKey.asymmetricKeyDetails.modulusLength<2048)return failure(new Error(`secretOrPrivateKey has a minimum key size of 2048 bits for ${header.alg}`))}if(void 0===payload)return failure(new Error("payload is required"));if(isObjectPayload){try{validatePayload(payload)}catch(error){return failure(error)}options.mutatePayload||(payload=Object.assign({},payload))}else{const invalid_options=options_for_objects.filter((function(opt){return void 0!==options[opt]}));if(invalid_options.length>0)return failure(new Error("invalid "+invalid_options.join(",")+" option for "+typeof payload+" payload"))}if(void 0!==payload.exp&&void 0!==options.expiresIn)return failure(new Error('Bad "options.expiresIn" option the payload already has an "exp" property.'));if(void 0!==payload.nbf&&void 0!==options.notBefore)return failure(new Error('Bad "options.notBefore" option the payload already has an "nbf" property.'));try{validateOptions(options)}catch(error){return failure(error)}if(!options.allowInvalidAsymmetricKeyTypes)try{validateAsymmetricKey(header.alg,secretOrPrivateKey)}catch(error){return failure(error)}const timestamp=payload.iat||Math.floor(Date.now()/1e3);if(options.noTimestamp?delete payload.iat:isObjectPayload&&(payload.iat=timestamp),void 0!==options.notBefore){try{payload.nbf=timespan(options.notBefore,timestamp)}catch(err){return failure(err)}if(void 0===payload.nbf)return failure(new Error('"notBefore" should be a number of seconds or string representing a timespan eg: "1d", "20h", 60'))}if(void 0!==options.expiresIn&&"object"==typeof payload){try{payload.exp=timespan(options.expiresIn,timestamp)}catch(err){return failure(err)}if(void 0===payload.exp)return failure(new Error('"expiresIn" should be a number of seconds or string representing a timespan eg: "1d", "20h", 60'))}Object.keys(options_to_payload).forEach((function(key){const claim=options_to_payload[key];if(void 0!==options[key]){if(void 0!==payload[claim])return failure(new Error('Bad "options.'+key+'" option. The payload already has an "'+claim+'" property.'));payload[claim]=options[key]}}));const encoding=options.encoding||"utf8";if("function"!=typeof callback){let signature=jws.sign({header:header,payload:payload,secret:secretOrPrivateKey,encoding:encoding});if(!options.allowInsecureKeySizes&&/^(?:RS|PS)/.test(header.alg)&&signature.length<256)throw new Error(`secretOrPrivateKey has a minimum key size of 2048 bits for ${header.alg}`);return signature}callback=callback&&once(callback),jws.createSign({header:header,privateKey:secretOrPrivateKey,payload:payload,encoding:encoding}).once("error",callback).once("done",(function(signature){if(!options.allowInsecureKeySizes&&/^(?:RS|PS)/.test(header.alg)&&signature.length<256)return callback(new Error(`secretOrPrivateKey has a minimum key size of 2048 bits for ${header.alg}`));callback(null,signature)}))};