"use strict";var utils=require("../utils"),GenericWorker=require("../stream/GenericWorker"),utf8=require("../utf8"),crc32=require("../crc32"),signature=require("../signature"),decToHex=function(dec,bytes){var i,hex="";for(i=0;i<bytes;i++)hex+=String.fromCharCode(255&dec),dec>>>=8;return hex},generateUnixExternalFileAttr=function(unixPermissions,isDir){var result=unixPermissions;return unixPermissions||(result=isDir?16893:33204),(65535&result)<<16},generateDosExternalFileAttr=function(dosPermissions){return 63&(dosPermissions||0)},generateZipParts=function(streamInfo,streamedContent,streamingEnded,offset,platform,encodeFileName){var dosTime,dosDate,file=streamInfo.file,compression=streamInfo.compression,useCustomEncoding=encodeFileName!==utf8.utf8encode,encodedFileName=utils.transformTo("string",encodeFileName(file.name)),utfEncodedFileName=utils.transformTo("string",utf8.utf8encode(file.name)),comment=file.comment,encodedComment=utils.transformTo("string",encodeFileName(comment)),utfEncodedComment=utils.transformTo("string",utf8.utf8encode(comment)),useUTF8ForFileName=utfEncodedFileName.length!==file.name.length,useUTF8ForComment=utfEncodedComment.length!==comment.length,extraFields="",unicodePathExtraField="",unicodeCommentExtraField="",dir=file.dir,date=file.date,dataInfo={crc32:0,compressedSize:0,uncompressedSize:0};streamedContent&&!streamingEnded||(dataInfo.crc32=streamInfo.crc32,dataInfo.compressedSize=streamInfo.compressedSize,dataInfo.uncompressedSize=streamInfo.uncompressedSize);var bitflag=0;streamedContent&&(bitflag|=8),useCustomEncoding||!useUTF8ForFileName&&!useUTF8ForComment||(bitflag|=2048);var extFileAttr=0,versionMadeBy=0;dir&&(extFileAttr|=16),"UNIX"===platform?(versionMadeBy=798,extFileAttr|=generateUnixExternalFileAttr(file.unixPermissions,dir)):(versionMadeBy=20,extFileAttr|=generateDosExternalFileAttr(file.dosPermissions,dir)),dosTime=date.getUTCHours(),dosTime<<=6,dosTime|=date.getUTCMinutes(),dosTime<<=5,dosTime|=date.getUTCSeconds()/2,dosDate=date.getUTCFullYear()-1980,dosDate<<=4,dosDate|=date.getUTCMonth()+1,dosDate<<=5,dosDate|=date.getUTCDate(),useUTF8ForFileName&&(unicodePathExtraField=decToHex(1,1)+decToHex(crc32(encodedFileName),4)+utfEncodedFileName,extraFields+="up"+decToHex(unicodePathExtraField.length,2)+unicodePathExtraField),useUTF8ForComment&&(unicodeCommentExtraField=decToHex(1,1)+decToHex(crc32(encodedComment),4)+utfEncodedComment,extraFields+="uc"+decToHex(unicodeCommentExtraField.length,2)+unicodeCommentExtraField);var header="";return header+="\n\0",header+=decToHex(bitflag,2),header+=compression.magic,header+=decToHex(dosTime,2),header+=decToHex(dosDate,2),header+=decToHex(dataInfo.crc32,4),header+=decToHex(dataInfo.compressedSize,4),header+=decToHex(dataInfo.uncompressedSize,4),header+=decToHex(encodedFileName.length,2),header+=decToHex(extraFields.length,2),{fileRecord:signature.LOCAL_FILE_HEADER+header+encodedFileName+extraFields,dirRecord:signature.CENTRAL_FILE_HEADER+decToHex(versionMadeBy,2)+header+decToHex(encodedComment.length,2)+"\0\0\0\0"+decToHex(extFileAttr,4)+decToHex(offset,4)+encodedFileName+extraFields+encodedComment}},generateCentralDirectoryEnd=function(entriesCount,centralDirLength,localDirLength,comment,encodeFileName){var encodedComment=utils.transformTo("string",encodeFileName(comment));return signature.CENTRAL_DIRECTORY_END+"\0\0\0\0"+decToHex(entriesCount,2)+decToHex(entriesCount,2)+decToHex(centralDirLength,4)+decToHex(localDirLength,4)+decToHex(encodedComment.length,2)+encodedComment},generateDataDescriptors=function(streamInfo){return signature.DATA_DESCRIPTOR+decToHex(streamInfo.crc32,4)+decToHex(streamInfo.compressedSize,4)+decToHex(streamInfo.uncompressedSize,4)};function ZipFileWorker(streamFiles,comment,platform,encodeFileName){GenericWorker.call(this,"ZipFileWorker"),this.bytesWritten=0,this.zipComment=comment,this.zipPlatform=platform,this.encodeFileName=encodeFileName,this.streamFiles=streamFiles,this.accumulate=!1,this.contentBuffer=[],this.dirRecords=[],this.currentSourceOffset=0,this.entriesCount=0,this.currentFile=null,this._sources=[]}utils.inherits(ZipFileWorker,GenericWorker),ZipFileWorker.prototype.push=function(chunk){var currentFilePercent=chunk.meta.percent||0,entriesCount=this.entriesCount,remainingFiles=this._sources.length;this.accumulate?this.contentBuffer.push(chunk):(this.bytesWritten+=chunk.data.length,GenericWorker.prototype.push.call(this,{data:chunk.data,meta:{currentFile:this.currentFile,percent:entriesCount?(currentFilePercent+100*(entriesCount-remainingFiles-1))/entriesCount:100}}))},ZipFileWorker.prototype.openedSource=function(streamInfo){this.currentSourceOffset=this.bytesWritten,this.currentFile=streamInfo.file.name;var streamedContent=this.streamFiles&&!streamInfo.file.dir;if(streamedContent){var record=generateZipParts(streamInfo,streamedContent,!1,this.currentSourceOffset,this.zipPlatform,this.encodeFileName);this.push({data:record.fileRecord,meta:{percent:0}})}else this.accumulate=!0},ZipFileWorker.prototype.closedSource=function(streamInfo){this.accumulate=!1;var streamedContent=this.streamFiles&&!streamInfo.file.dir,record=generateZipParts(streamInfo,streamedContent,!0,this.currentSourceOffset,this.zipPlatform,this.encodeFileName);if(this.dirRecords.push(record.dirRecord),streamedContent)this.push({data:generateDataDescriptors(streamInfo),meta:{percent:100}});else for(this.push({data:record.fileRecord,meta:{percent:0}});this.contentBuffer.length;)this.push(this.contentBuffer.shift());this.currentFile=null},ZipFileWorker.prototype.flush=function(){for(var localDirLength=this.bytesWritten,i=0;i<this.dirRecords.length;i++)this.push({data:this.dirRecords[i],meta:{percent:100}});var centralDirLength=this.bytesWritten-localDirLength,dirEnd=generateCentralDirectoryEnd(this.dirRecords.length,centralDirLength,localDirLength,this.zipComment,this.encodeFileName);this.push({data:dirEnd,meta:{percent:100}})},ZipFileWorker.prototype.prepareNextSource=function(){this.previous=this._sources.shift(),this.openedSource(this.previous.streamInfo),this.isPaused?this.previous.pause():this.previous.resume()},ZipFileWorker.prototype.registerPrevious=function(previous){this._sources.push(previous);var self=this;return previous.on("data",(function(chunk){self.processChunk(chunk)})),previous.on("end",(function(){self.closedSource(self.previous.streamInfo),self._sources.length?self.prepareNextSource():self.end()})),previous.on("error",(function(e){self.error(e)})),this},ZipFileWorker.prototype.resume=function(){return!!GenericWorker.prototype.resume.call(this)&&(!this.previous&&this._sources.length?(this.prepareNextSource(),!0):this.previous||this._sources.length||this.generatedError?void 0:(this.end(),!0))},ZipFileWorker.prototype.error=function(e){var sources=this._sources;if(!GenericWorker.prototype.error.call(this,e))return!1;for(var i=0;i<sources.length;i++)try{sources[i].error(e)}catch(e){}return!0},ZipFileWorker.prototype.lock=function(){GenericWorker.prototype.lock.call(this);for(var sources=this._sources,i=0;i<sources.length;i++)sources[i].lock()},module.exports=ZipFileWorker;