"use strict";const{EventEmitter:EventEmitter}=require("events"),debug=require("debug")("mssql:base"),{parseSqlConnectionString:parseSqlConnectionString}=require("@tediousjs/connection-string"),tarn=require("tarn"),{IDS:IDS}=require("../utils"),ConnectionError=require("../error/connection-error"),shared=require("../shared"),clone=require("rfdc/default"),{MSSQLError:MSSQLError}=require("../error");class ConnectionPool extends EventEmitter{constructor(config,callback){if(super(),IDS.add(this,"ConnectionPool"),debug("pool(%d): created",IDS.get(this)),this._connectStack=[],this._closeStack=[],this._connected=!1,this._connecting=!1,this._healthy=!1,"string"==typeof config)try{this.config=this.constructor.parseConnectionString(config)}catch(ex){if("function"==typeof callback)return setImmediate(callback,ex);throw ex}else this.config=clone(config);if(this.config.port=this.config.port||1433,this.config.options=this.config.options||{},this.config.stream=this.config.stream||!1,this.config.parseJSON=this.config.parseJSON||!1,this.config.arrayRowMode=this.config.arrayRowMode||!1,this.config.validateConnection=!("validateConnection"in this.config)||this.config.validateConnection,/^(.*)\\(.*)$/.exec(this.config.server)&&(this.config.server=RegExp.$1,this.config.options.instanceName=RegExp.$2),void 0!==this.config.options.useColumnNames&&!0!==this.config.options.useColumnNames){const ex=new MSSQLError("Invalid options `useColumnNames`, use `arrayRowMode` instead");if("function"==typeof callback)return setImmediate(callback,ex);throw ex}"function"==typeof callback&&this.connect(callback)}get connected(){return this._connected}get connecting(){return this._connecting}get healthy(){return this._healthy}static parseConnectionString(connectionString){return this._parseConnectionString(connectionString)}static _parseConnectionString(connectionString){const parsed=parseSqlConnectionString(connectionString,!0,!0);return Object.entries(parsed).reduce(((config,[key,value])=>{switch(key){case"application name":case"asynchronous processing":case"attachdbfilename":case"authentication":case"column encryption setting":case"connection lifetime":case"connectretrycount":case"context connection":case"enlist":case"failover partner":case"integrated security":case"multipleactiveresultsets":case"network library":case"persist security info":case"poolblockingperiod":case"pooling":case"replication":case"transparentnetworkipresolution":case"type system version":case"user instance":break;case"applicationintent":Object.assign(config.options,{readOnlyIntent:"readonly"===value});break;case"connection timeout":Object.assign(config,{connectionTimeout:1e3*value});break;case"connectretryinterval":Object.assign(config.options,{connectionRetryInterval:1e3*value});break;case"current language":Object.assign(config.options,{language:value});break;case"data source":{let instanceName,server=value,port=1433;if(/^np:/i.test(server))throw new Error("Connection via Named Pipes is not supported.");/^tcp:/i.test(server)&&(server=server.substr(4)),/^(.*)\\(.*)$/.exec(server)&&(server=RegExp.$1,instanceName=RegExp.$2),/^(.*),(.*)$/.exec(server)&&(server=RegExp.$1.trim(),port=parseInt(RegExp.$2.trim(),10)),"."!==server&&"(.)"!==server&&"(localdb)"!==server.toLowerCase()&&"(local)"!==server.toLowerCase()||(server="localhost"),Object.assign(config,{port:port,server:server}),Object.assign(config.options,{instanceName:instanceName});break}case"encrypt":Object.assign(config.options,{encrypt:!!value});break;case"initial catalog":Object.assign(config,{database:value});break;case"max pool size":Object.assign(config.pool,{max:value});break;case"min pool size":Object.assign(config.pool,{min:value});break;case"multisubnetfailover":Object.assign(config.options,{multiSubnetFailover:value});break;case"packet size":Object.assign(config.options,{packetSize:value});break;case"password":Object.assign(config,{password:value});break;case"transaction binding":Object.assign(config.options,{enableImplicitTransactions:"implicit unbind"===value.toLowerCase()});break;case"trustservercertificate":Object.assign(config.options,{trustServerCertificate:value});break;case"user id":{let domain,user=value;/^(.*)\\(.*)$/.exec(user)&&(domain=RegExp.$1,user=RegExp.$2),Object.assign(config,{domain:domain,user:user});break}case"workstation id":Object.assign(config.options,{workstationId:value});break;case"request timeout":Object.assign(config,{requestTimeout:parseInt(value,10)});break;case"stream":Object.assign(config,{stream:!!value});break;case"useutc":Object.assign(config.options,{useUTC:!!value});break;case"parsejson":Object.assign(config,{parseJSON:!!value})}return config}),{options:{},pool:{}})}acquire(requester,callback){const acquirePromise=shared.Promise.resolve(this._acquire().promise).catch((err=>{throw this.emit("error",err),err}));return"function"==typeof callback?(acquirePromise.then((connection=>callback(null,connection,this.config))).catch(callback),this):acquirePromise}_acquire(){return this.pool?this.pool.destroyed?shared.Promise.reject(new ConnectionError("Connection is closing","ENOTOPEN")):this.pool.acquire():shared.Promise.reject(new ConnectionError("Connection not yet open.","ENOTOPEN"))}release(connection){return debug("connection(%d): released",IDS.get(connection)),this.pool&&this.pool.release(connection),this}connect(callback){return"function"==typeof callback?(this._connect(callback),this):new shared.Promise(((resolve,reject)=>this._connect((err=>{if(err)return reject(err);resolve(this)}))))}_connect(callback){if(this._connected)return debug("pool(%d): already connected, executing connect callback immediately",IDS.get(this)),setImmediate(callback,null,this);this._connectStack.push(callback),this._connecting||(this._connecting=!0,debug("pool(%d): connecting",IDS.get(this)),this._poolCreate().then((connection=>(debug("pool(%d): connected",IDS.get(this)),this._healthy=!0,this._poolDestroy(connection).then((()=>{this.pool=new tarn.Pool(Object.assign({create:()=>this._poolCreate().then((connection=>(this._healthy=!0,connection))).catch((err=>{throw this.pool.numUsed()+this.pool.numFree()<=0&&(this._healthy=!1),err})),validate:this._poolValidate.bind(this),destroy:this._poolDestroy.bind(this),max:10,min:0,idleTimeoutMillis:3e4,propagateCreateError:!0},this.config.pool)),this._connecting=!1,this._connected=!0}))))).then((()=>{this._connectStack.forEach((cb=>{setImmediate(cb,null,this)}))})).catch((err=>{this._connecting=!1,this._connectStack.forEach((cb=>{setImmediate(cb,err)}))})).then((()=>{this._connectStack=[]})))}get size(){return this.pool.numFree()+this.pool.numUsed()+this.pool.numPendingCreates()}get available(){return this.pool.numFree()}get pending(){return this.pool.numPendingAcquires()}get borrowed(){return this.pool.numUsed()}close(callback){return"function"==typeof callback?(this._close(callback),this):new shared.Promise(((resolve,reject)=>{this._close((err=>{if(err)return reject(err);resolve(this)}))}))}_close(callback){if(this._connecting&&(debug("pool(%d): close called while connecting",IDS.get(this)),setImmediate(callback,new ConnectionError("Cannot close a pool while it is connecting"))),!this.pool)return debug("pool(%d): already closed, executing close callback immediately",IDS.get(this)),setImmediate(callback,null);this._closeStack.push(callback),this.pool.destroyed||(this._connecting=this._connected=this._healthy=!1,this.pool.destroy().then((()=>{debug("pool(%d): pool closed, removing pool reference and executing close callbacks",IDS.get(this)),this.pool=null,this._closeStack.forEach((cb=>{setImmediate(cb,null)}))})).catch((err=>{this.pool=null,this._closeStack.forEach((cb=>{setImmediate(cb,err)}))})).then((()=>{this._closeStack=[]})))}request(){return new shared.driver.Request(this)}transaction(){return new shared.driver.Transaction(this)}query(){if("string"==typeof arguments[0])return new shared.driver.Request(this).query(arguments[0],arguments[1]);const values=Array.prototype.slice.call(arguments),strings=values.shift();return new shared.driver.Request(this)._template(strings,values,"query")}batch(){if("string"==typeof arguments[0])return new shared.driver.Request(this).batch(arguments[0],arguments[1]);const values=Array.prototype.slice.call(arguments),strings=values.shift();return new shared.driver.Request(this)._template(strings,values,"batch")}}module.exports=ConnectionPool;