"use strict";const debug=require("debug")("mssql:base"),{EventEmitter:EventEmitter}=require("events"),{IDS:IDS,objectHasProperty:objectHasProperty}=require("../utils"),globalConnection=require("../global-connection"),{TransactionError:TransactionError,PreparedStatementError:PreparedStatementError}=require("../error"),shared=require("../shared"),{TYPES:TYPES,declare:declare}=require("../datatypes");class PreparedStatement extends EventEmitter{constructor(parent){super(),IDS.add(this,"PreparedStatement"),debug("ps(%d): created",IDS.get(this)),this.parent=parent||globalConnection.pool,this._handle=0,this.prepared=!1,this.parameters={}}get config(){return this.parent.config}get connected(){return this.parent.connected}acquire(request,callback){return this._acquiredConnection?this._activeRequest?(setImmediate(callback,new TransactionError("Can't acquire connection for the request. There is another request in progress.","EREQINPROG")),this):(this._activeRequest=request,setImmediate(callback,null,this._acquiredConnection,this._acquiredConfig),this):(setImmediate(callback,new PreparedStatementError("Statement is not prepared. Call prepare() first.","ENOTPREPARED")),this)}release(connection){return connection===this._acquiredConnection&&(this._activeRequest=null),this}input(name,type){if(/(--| |\/\*|\*\/|')/.test(name))throw new PreparedStatementError(`SQL injection warning for param '${name}'`,"EINJECT");if(arguments.length<2)throw new PreparedStatementError("Invalid number of arguments. 2 arguments expected.","EARGS");if(type instanceof Function&&(type=type()),objectHasProperty(this.parameters,name))throw new PreparedStatementError(`The parameter name ${name} has already been declared. Parameter names must be unique`,"EDUPEPARAM");return this.parameters[name]={name:name,type:type.type,io:1,length:type.length,scale:type.scale,precision:type.precision,tvpType:type.tvpType},this}replaceInput(name,type,value){return delete this.parameters[name],this.input(name,type,value)}output(name,type){if(/(--| |\/\*|\*\/|')/.test(name))throw new PreparedStatementError(`SQL injection warning for param '${name}'`,"EINJECT");if(arguments.length<2)throw new PreparedStatementError("Invalid number of arguments. 2 arguments expected.","EARGS");if(type instanceof Function&&(type=type()),objectHasProperty(this.parameters,name))throw new PreparedStatementError(`The parameter name ${name} has already been declared. Parameter names must be unique`,"EDUPEPARAM");return this.parameters[name]={name:name,type:type.type,io:2,length:type.length,scale:type.scale,precision:type.precision},this}replaceOutput(name,type){return delete this.parameters[name],this.output(name,type)}prepare(statement,callback){return"function"==typeof callback?(this._prepare(statement,callback),this):new shared.Promise(((resolve,reject)=>{this._prepare(statement,(err=>{if(err)return reject(err);resolve(this)}))}))}_prepare(statement,callback){if(debug("ps(%d): prepare",IDS.get(this)),"function"==typeof statement&&(callback=statement,statement=void 0),this.prepared)return setImmediate(callback,new PreparedStatementError("Statement is already prepared.","EALREADYPREPARED"));this.statement=statement||this.statement,this.parent.acquire(this,((err,connection,config)=>{if(err)return callback(err);this._acquiredConnection=connection,this._acquiredConfig=config;const req=new shared.driver.Request(this);req.stream=!1,req.output("handle",TYPES.Int),req.input("params",TYPES.NVarChar,(()=>{const result=[];for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];result.push(`@${name} ${declare(param.type,param)}${2===param.io?" output":""}`)}return result})().join(",")),req.input("stmt",TYPES.NVarChar,this.statement),req.execute("sp_prepare",((err,result)=>{if(err)return this.parent.release(this._acquiredConnection),this._acquiredConnection=null,this._acquiredConfig=null,callback(err);debug("ps(%d): prepared",IDS.get(this)),this._handle=result.output.handle,this.prepared=!0,callback(null)}))}))}execute(values,callback){return this.stream||"function"==typeof callback?this._execute(values,callback):new shared.Promise(((resolve,reject)=>{this._execute(values,((err,recordset)=>{if(err)return reject(err);resolve(recordset)}))}))}_execute(values,callback){const req=new shared.driver.Request(this);req.stream=this.stream,req.arrayRowMode=this.arrayRowMode,req.input("handle",TYPES.Int,this._handle);for(const name in this.parameters){if(!objectHasProperty(this.parameters,name))continue;const param=this.parameters[name];req.parameters[name]={name:name,type:param.type,io:param.io,value:values[name],length:param.length,scale:param.scale,precision:param.precision}}return req.execute("sp_execute",((err,result)=>{if(err)return callback(err);callback(null,result)})),req}unprepare(callback){return"function"==typeof callback?(this._unprepare(callback),this):new shared.Promise(((resolve,reject)=>{this._unprepare((err=>{if(err)return reject(err);resolve()}))}))}_unprepare(callback){if(debug("ps(%d): unprepare",IDS.get(this)),!this.prepared)return setImmediate(callback,new PreparedStatementError("Statement is not prepared. Call prepare() first.","ENOTPREPARED"));if(this._activeRequest)return setImmediate(callback,new TransactionError("Can't unprepare the statement. There is a request in progress.","EREQINPROG"));const req=new shared.driver.Request(this);req.stream=!1,req.input("handle",TYPES.Int,this._handle),req.execute("sp_unprepare",(err=>err?callback(err):(this.parent.release(this._acquiredConnection),this._acquiredConnection=null,this._acquiredConfig=null,this._handle=0,this.prepared=!1,debug("ps(%d): unprepared",IDS.get(this)),callback(null))))}}module.exports=PreparedStatement;