"use strict";const debug=require("debug")("mssql:base"),{EventEmitter:EventEmitter}=require("events"),{IDS:IDS}=require("../utils"),globalConnection=require("../global-connection"),{TransactionError:TransactionError}=require("../error"),shared=require("../shared"),ISOLATION_LEVEL=require("../isolationlevel");class Transaction extends EventEmitter{constructor(parent){super(),IDS.add(this,"Transaction"),debug("transaction(%d): created",IDS.get(this)),this.parent=parent||globalConnection.pool,this.isolationLevel=Transaction.defaultIsolationLevel,this.name=""}get config(){return this.parent.config}get connected(){return this.parent.connected}acquire(request,callback){return this._acquiredConnection?this._activeRequest?(setImmediate(callback,new TransactionError("Can't acquire connection for the request. There is another request in progress.","EREQINPROG")),this):(this._activeRequest=request,setImmediate(callback,null,this._acquiredConnection,this._acquiredConfig),this):(setImmediate(callback,new TransactionError("Transaction has not begun. Call begin() first.","ENOTBEGUN")),this)}release(connection){return connection===this._acquiredConnection&&(this._activeRequest=null),this}begin(isolationLevel,callback){return isolationLevel instanceof Function&&(callback=isolationLevel,isolationLevel=void 0),"function"==typeof callback?(this._begin(isolationLevel,(err=>{err||this.emit("begin"),callback(err)})),this):new shared.Promise(((resolve,reject)=>{this._begin(isolationLevel,(err=>{if(err)return reject(err);this.emit("begin"),resolve(this)}))}))}_begin(isolationLevel,callback){if(this._acquiredConnection)return setImmediate(callback,new TransactionError("Transaction has already begun.","EALREADYBEGUN"));if(this._aborted=!1,this._rollbackRequested=!1,isolationLevel){if(!Object.keys(ISOLATION_LEVEL).some((key=>ISOLATION_LEVEL[key]===isolationLevel)))throw new TransactionError("Invalid isolation level.");this.isolationLevel=isolationLevel}setImmediate(callback)}commit(callback){return"function"==typeof callback?(this._commit((err=>{err||this.emit("commit"),callback(err)})),this):new shared.Promise(((resolve,reject)=>{this._commit((err=>{if(err)return reject(err);this.emit("commit"),resolve()}))}))}_commit(callback){return this._aborted?setImmediate(callback,new TransactionError("Transaction has been aborted.","EABORT")):this._acquiredConnection?this._activeRequest?setImmediate(callback,new TransactionError("Can't commit transaction. There is a request in progress.","EREQINPROG")):void setImmediate(callback):setImmediate(callback,new TransactionError("Transaction has not begun. Call begin() first.","ENOTBEGUN"))}request(){return new shared.driver.Request(this)}rollback(callback){return"function"==typeof callback?(this._rollback((err=>{err||this.emit("rollback",this._aborted),callback(err)})),this):new shared.Promise(((resolve,reject)=>this._rollback((err=>{if(err)return reject(err);this.emit("rollback",this._aborted),resolve()}))))}_rollback(callback){return this._aborted?setImmediate(callback,new TransactionError("Transaction has been aborted.","EABORT")):this._acquiredConnection?this._activeRequest?setImmediate(callback,new TransactionError("Can't rollback transaction. There is a request in progress.","EREQINPROG")):(this._rollbackRequested=!0,void setImmediate(callback)):setImmediate(callback,new TransactionError("Transaction has not begun. Call begin() first.","ENOTBEGUN"))}}Transaction.defaultIsolationLevel=ISOLATION_LEVEL.READ_COMMITTED,module.exports=Transaction;