"use strict";const TYPES=require("./datatypes").TYPES,declareType=require("./datatypes").declare,objectHasProperty=require("./utils").objectHasProperty,MAX=65535,JSON_COLUMN_ID="JSON_F52E2B61-18A1-11d1-B105-00805F49916B";function Table(name){if(name){const parsed=Table.parseName(name);this.name=parsed.name,this.schema=parsed.schema,this.database=parsed.database,this.path=(this.database?`[${this.database}].`:"")+(this.schema?`[${this.schema}].`:"")+`[${this.name}]`,this.temporary="#"===this.name.charAt(0)}this.columns=[],this.rows=[],Object.defineProperty(this.columns,"add",{value(name,column,options){if(null==column)throw new Error("Column data type is not defined.");return column instanceof Function&&(column=column()),options=options||{},column.name=name,["nullable","primary","identity","readOnly","length"].forEach((prop=>{objectHasProperty(options,prop)&&(column[prop]=options[prop])})),this.push(column)}}),Object.defineProperty(this.rows,"add",{value(){return this.push(Array.prototype.slice.call(arguments))}}),Object.defineProperty(this.rows,"clear",{value(){return this.splice(0,this.length)}})}Table.prototype._makeBulk=function(){for(let i=0;i<this.columns.length;i++){const col=this.columns[i];switch(col.type){case TYPES.Date:case TYPES.DateTime:case TYPES.DateTime2:for(let j=0;j<this.rows.length;j++){const dateValue=this.rows[j][i];if("string"==typeof dateValue||"number"==typeof dateValue){const date=new Date(dateValue);if(isNaN(date.getDate()))throw new TypeError("Invalid date value passed to bulk rows");this.rows[j][i]=date}}break;case TYPES.Xml:col.type=TYPES.NVarChar(MAX).type;break;case TYPES.UDT:case TYPES.Geography:case TYPES.Geometry:col.type=TYPES.VarBinary(MAX).type}}return this},Table.prototype.declare=function(){const pkey=this.columns.filter((col=>!0===col.primary)).map((col=>`[${col.name}]`)),cols=this.columns.map((col=>{const def=[`[${col.name}] ${declareType(col.type,col)}`];return!0===col.nullable?def.push("null"):!1===col.nullable&&def.push("not null"),!0===col.primary&&1===pkey.length&&def.push("primary key"),def.join(" ")})),constraint=pkey.length>1?`, constraint [PK_${this.temporary?this.name.substr(1):this.name}] primary key (${pkey.join(", ")})`:"";return`create table ${this.path} (${cols.join(", ")}${constraint})`},Table.fromRecordset=function(recordset,name){const t=new this(name);for(const colName in recordset.columns)if(objectHasProperty(recordset.columns,colName)){const col=recordset.columns[colName];t.columns.add(colName,{type:col.type,length:col.length,scale:col.scale,precision:col.precision},{nullable:col.nullable,identity:col.identity,readOnly:col.readOnly})}if(1===t.columns.length&&t.columns[0].name===JSON_COLUMN_ID)for(let i=0;i<recordset.length;i++)t.rows.add(JSON.stringify(recordset[i]));else for(let i=0;i<recordset.length;i++)t.rows.add.apply(t.rows,t.columns.map((col=>recordset[i][col.name])));return t},Table.parseName=function(name){const length=name.length;let cursor=-1,buffer="",escaped=!1;const path=[];for(;++cursor<length;){const char=name.charAt(cursor);if("["===char)escaped?buffer+=char:escaped=!0;else if("]"===char){if(!escaped)throw new Error("Invalid table name.");escaped=!1}else"."===char?escaped?buffer+=char:(path.push(buffer),buffer=""):buffer+=char}switch(buffer&&path.push(buffer),path.length){case 1:return{name:path[0],schema:null,database:null};case 2:return{name:path[1],schema:path[0],database:null};case 3:return{name:path[2],schema:path[1],database:path[0]};default:throw new Error("Invalid table name.")}},module.exports=Table;