var Pool=require("./Pool"),PoolConfig=require("./PoolConfig"),PoolNamespace=require("./PoolNamespace"),PoolSelector=require("./PoolSelector"),Util=require("util"),EventEmitter=require("events").EventEmitter;function PoolCluster(config){EventEmitter.call(this),config=config||{},this._canRetry=void 0===config.canRetry||config.canRetry,this._defaultSelector=config.defaultSelector||"RR",this._removeNodeErrorCount=config.removeNodeErrorCount||5,this._restoreNodeTimeout=config.restoreNodeTimeout||0,this._closed=!1,this._findCaches=Object.create(null),this._lastId=0,this._namespaces=Object.create(null),this._nodes=Object.create(null)}function getMonotonicMilliseconds(){var ms;return ms="function"==typeof process.hrtime?1e3*(ms=process.hrtime())[0]+1e-6*ms[1]:1e3*process.uptime(),Math.floor(ms)}function isRegExp(val){return"object"==typeof val&&"[object RegExp]"===Object.prototype.toString.call(val)}function patternRegExp(pattern){if(isRegExp(pattern))return pattern;var source=pattern.replace(/([.+?^=!:${}()|\[\]\/\\])/g,"\\$1").replace(/\*/g,".*");return new RegExp("^"+source+"$")}function _cb(err){if(err)throw err}function _noop(){}module.exports=PoolCluster,Util.inherits(PoolCluster,EventEmitter),PoolCluster.prototype.add=function(id,config){if(this._closed)throw new Error("PoolCluster is closed.");var nodeId="object"==typeof id?"CLUSTER::"+ ++this._lastId:String(id);if(void 0!==this._nodes[nodeId])throw new Error('Node ID "'+nodeId+'" is already defined in PoolCluster.');var poolConfig=new PoolConfig("object"!=typeof id?config:id);this._nodes[nodeId]={id:nodeId,errorCount:0,pool:new Pool({config:poolConfig}),_offlineUntil:0},this._clearFindCaches()},PoolCluster.prototype.end=function(callback){var cb=void 0!==callback?callback:_cb;if("function"!=typeof cb)throw TypeError("callback argument must be a function");if(this._closed)process.nextTick(cb);else{this._closed=!0;for(var calledBack=!1,nodeIds=Object.keys(this._nodes),waitingClose=0,i=0;i<nodeIds.length;i++){var nodeId=nodeIds[i],node=this._nodes[nodeId];waitingClose++,node.pool.end(onEnd)}0===waitingClose&&process.nextTick(onEnd)}function onEnd(err){!calledBack&&(err||--waitingClose<=0)&&(calledBack=!0,cb(err))}},PoolCluster.prototype.of=function(pattern,selector){pattern=pattern||"*",selector=(selector=selector||this._defaultSelector).toUpperCase(),void 0===PoolSelector[selector]&&(selector=this._defaultSelector);var key=pattern+selector;return void 0===this._namespaces[key]&&(this._namespaces[key]=new PoolNamespace(this,pattern,selector)),this._namespaces[key]},PoolCluster.prototype.remove=function(pattern){for(var foundNodeIds=this._findNodeIds(pattern,!0),i=0;i<foundNodeIds.length;i++){var node=this._getNode(foundNodeIds[i]);node&&this._removeNode(node)}},PoolCluster.prototype.getConnection=function(pattern,selector,cb){var namespace;"function"==typeof pattern?(cb=pattern,namespace=this.of()):("function"==typeof selector&&(cb=selector,selector=this._defaultSelector),namespace=this.of(pattern,selector)),namespace.getConnection(cb)},PoolCluster.prototype._clearFindCaches=function(){this._findCaches=Object.create(null)},PoolCluster.prototype._decreaseErrorCount=function(node){var errorCount=node.errorCount;errorCount>this._removeNodeErrorCount&&(errorCount=this._removeNodeErrorCount),errorCount<1&&(errorCount=1),node.errorCount=errorCount-1,node._offlineUntil&&(node._offlineUntil=0,this.emit("online",node.id))},PoolCluster.prototype._findNodeIds=function(pattern,includeOffline){var currentTime=0,foundNodeIds=this._findCaches[pattern];if(void 0===foundNodeIds){var expression=patternRegExp(pattern);foundNodeIds=Object.keys(this._nodes).filter((function(id){return id.match(expression)})),this._findCaches[pattern]=foundNodeIds}return includeOffline?foundNodeIds:foundNodeIds.filter((function(nodeId){var node=this._getNode(nodeId);return!node._offlineUntil||(currentTime||(currentTime=getMonotonicMilliseconds()),node._offlineUntil<=currentTime)}),this)},PoolCluster.prototype._getNode=function(id){return this._nodes[id]||null},PoolCluster.prototype._increaseErrorCount=function(node){var errorCount=++node.errorCount;if(!(this._removeNodeErrorCount>errorCount)){if(this._restoreNodeTimeout>0)return node._offlineUntil=getMonotonicMilliseconds()+this._restoreNodeTimeout,void this.emit("offline",node.id);this._removeNode(node),this.emit("remove",node.id)}},PoolCluster.prototype._getConnection=function(node,cb){var self=this;node.pool.getConnection((function(err,connection){if(err)return self._increaseErrorCount(node),void cb(err);self._decreaseErrorCount(node),connection._clusterId=node.id,cb(null,connection)}))},PoolCluster.prototype._removeNode=function(node){delete this._nodes[node.id],this._clearFindCaches(),node.pool.end(_noop)};