var PacketHeader=require("./PacketHeader"),BigNumber=require("bignumber.js"),Buffer=require("safe-buffer").Buffer,BufferList=require("./BufferList"),MAX_PACKET_LENGTH=Math.pow(2,24)-1,MUL_32BIT=Math.pow(2,32),PACKET_HEADER_LENGTH=4;function Parser(options){options=options||{},this._supportBigNumbers=options.config&&options.config.supportBigNumbers,this._buffer=Buffer.alloc(0),this._nextBuffers=new BufferList,this._longPacketBuffers=new BufferList,this._offset=0,this._packetEnd=null,this._packetHeader=null,this._packetOffset=null,this._onError=options.onError||function(err){throw err},this._onPacket=options.onPacket||function(){},this._nextPacketNumber=0,this._encoding="utf-8",this._paused=!1}module.exports=Parser,Parser.prototype.write=function(chunk){for(this._nextBuffers.push(chunk);!this._paused;){var packetHeader=this._tryReadPacketHeader();if(!packetHeader)break;if(!this._combineNextBuffers(packetHeader.length))break;this._parsePacket(packetHeader)}},Parser.prototype.append=function(chunk){if(chunk&&0!==chunk.length){for(var sliceEnd=this._buffer.length,sliceStart=null===this._packetOffset?this._offset:this._packetOffset,sliceLength=sliceEnd-sliceStart,buffer=null,chunks=chunk instanceof Array||Array.isArray(chunk)?chunk:[chunk],length=0,offset=0,i=0;i<chunks.length;i++)length+=chunks[i].length;if(0!==sliceLength){buffer=Buffer.allocUnsafe(sliceLength+length),offset=0,offset+=this._buffer.copy(buffer,0,sliceStart,sliceEnd);for(i=0;i<chunks.length;i++)offset+=chunks[i].copy(buffer,offset)}else if(chunks.length>1){buffer=Buffer.allocUnsafe(length),offset=0;for(i=0;i<chunks.length;i++)offset+=chunks[i].copy(buffer,offset)}else buffer=chunks[0];this._buffer=buffer,this._offset=this._offset-sliceStart,this._packetEnd=null!==this._packetEnd?this._packetEnd-sliceStart:null,this._packetOffset=null!==this._packetOffset?this._packetOffset-sliceStart:null}},Parser.prototype.pause=function(){this._paused=!0},Parser.prototype.resume=function(){this._paused=!1,process.nextTick(this.write.bind(this))},Parser.prototype.peak=function(offset){return this._buffer[this._offset+(offset>>>0)]},Parser.prototype.parseUnsignedNumber=function(bytes){if(1===bytes)return this._buffer[this._offset++];var buffer=this._buffer,offset=this._offset+bytes-1,value=0;if(bytes>4){var err=new Error("parseUnsignedNumber: Supports only up to 4 bytes");throw err.offset=this._offset-this._packetOffset-1,err.code="PARSER_UNSIGNED_TOO_LONG",err}for(;offset>=this._offset;)value=(value<<8|buffer[offset])>>>0,offset--;return this._offset+=bytes,value},Parser.prototype.parseLengthCodedString=function(){var length=this.parseLengthCodedNumber();return null===length?null:this.parseString(length)},Parser.prototype.parseLengthCodedBuffer=function(){var length=this.parseLengthCodedNumber();return null===length?null:this.parseBuffer(length)},Parser.prototype.parseLengthCodedNumber=function(){if(this._offset>=this._buffer.length)throw(err=new Error("Parser: read past end")).offset=this._offset-this._packetOffset,err.code="PARSER_READ_PAST_END",err;var bits=this._buffer[this._offset++];if(bits<=250)return bits;switch(bits){case 251:return null;case 252:return this.parseUnsignedNumber(2);case 253:return this.parseUnsignedNumber(3);case 254:break;default:throw(err=new Error("Unexpected first byte"+(bits?": 0x"+bits.toString(16):""))).offset=this._offset-this._packetOffset-1,err.code="PARSER_BAD_LENGTH_BYTE",err}var value,low=this.parseUnsignedNumber(4),high=this.parseUnsignedNumber(4);if(high>>>21){if(value=BigNumber(MUL_32BIT).times(high).plus(low).toString(),this._supportBigNumbers)return value;var err;throw(err=new Error('parseLengthCodedNumber: JS precision range exceeded, number is >= 53 bit: "'+value+'"')).offset=this._offset-this._packetOffset-8,err.code="PARSER_JS_PRECISION_RANGE_EXCEEDED",err}return value=low+MUL_32BIT*high},Parser.prototype.parseFiller=function(length){return this.parseBuffer(length)},Parser.prototype.parseNullTerminatedBuffer=function(){var end=this._nullByteOffset(),value=this._buffer.slice(this._offset,end);return this._offset=end+1,value},Parser.prototype.parseNullTerminatedString=function(){var end=this._nullByteOffset(),value=this._buffer.toString(this._encoding,this._offset,end);return this._offset=end+1,value},Parser.prototype._nullByteOffset=function(){for(var offset=this._offset;0!==this._buffer[offset];)if(++offset>=this._buffer.length){var err=new Error("Offset of null terminated string not found.");throw err.offset=this._offset-this._packetOffset,err.code="PARSER_MISSING_NULL_BYTE",err}return offset},Parser.prototype.parsePacketTerminatedBuffer=function(){var length=this._packetEnd-this._offset;return this.parseBuffer(length)},Parser.prototype.parsePacketTerminatedString=function(){var length=this._packetEnd-this._offset;return this.parseString(length)},Parser.prototype.parseBuffer=function(length){var response=Buffer.alloc(length);return this._buffer.copy(response,0,this._offset,this._offset+length),this._offset+=length,response},Parser.prototype.parseString=function(length){var offset=this._offset,end=offset+length,value=this._buffer.toString(this._encoding,offset,end);return this._offset=end,value},Parser.prototype.parseGeometryValue=function(){var buffer=this.parseLengthCodedBuffer(),offset=4;if(null===buffer||!buffer.length)return null;function parseGeometry(){var result=null,byteOrder=buffer.readUInt8(offset);offset+=1;var wkbType=byteOrder?buffer.readUInt32LE(offset):buffer.readUInt32BE(offset);switch(offset+=4,wkbType){case 1:var x=byteOrder?buffer.readDoubleLE(offset):buffer.readDoubleBE(offset);offset+=8;var y=byteOrder?buffer.readDoubleLE(offset):buffer.readDoubleBE(offset);offset+=8,result={x:x,y:y};break;case 2:var numPoints=byteOrder?buffer.readUInt32LE(offset):buffer.readUInt32BE(offset);offset+=4,result=[];for(var i=numPoints;i>0;i--){x=byteOrder?buffer.readDoubleLE(offset):buffer.readDoubleBE(offset);offset+=8;y=byteOrder?buffer.readDoubleLE(offset):buffer.readDoubleBE(offset);offset+=8,result.push({x:x,y:y})}break;case 3:var numRings=byteOrder?buffer.readUInt32LE(offset):buffer.readUInt32BE(offset);offset+=4,result=[];for(i=numRings;i>0;i--){numPoints=byteOrder?buffer.readUInt32LE(offset):buffer.readUInt32BE(offset);offset+=4;for(var line=[],j=numPoints;j>0;j--){x=byteOrder?buffer.readDoubleLE(offset):buffer.readDoubleBE(offset);offset+=8;y=byteOrder?buffer.readDoubleLE(offset):buffer.readDoubleBE(offset);offset+=8,line.push({x:x,y:y})}result.push(line)}break;case 4:case 5:case 6:case 7:var num=byteOrder?buffer.readUInt32LE(offset):buffer.readUInt32BE(offset);offset+=4;for(result=[],i=num;i>0;i--)result.push(parseGeometry())}return result}return parseGeometry()},Parser.prototype.reachedPacketEnd=function(){return this._offset===this._packetEnd},Parser.prototype.incrementPacketNumber=function(){var currentPacketNumber=this._nextPacketNumber;return this._nextPacketNumber=(this._nextPacketNumber+1)%256,currentPacketNumber},Parser.prototype.resetPacketNumber=function(){this._nextPacketNumber=0},Parser.prototype.packetLength=function(){return this._packetHeader?this._packetHeader.length+this._longPacketBuffers.size:null},Parser.prototype._combineNextBuffers=function(bytes){var length=this._buffer.length-this._offset;if(length>=bytes)return!0;if(length+this._nextBuffers.size<bytes)return!1;for(var buffers=[],bytesNeeded=bytes-length;bytesNeeded>0;){var buffer=this._nextBuffers.shift();buffers.push(buffer),bytesNeeded-=buffer.length}return this.append(buffers),!0},Parser.prototype._combineLongPacketBuffers=function(){if(this._longPacketBuffers.size){for(var remainingBytes=this._buffer.length-this._offset,trailingPacketBytes=this._buffer.length-this._packetEnd,buf=null,buffer=Buffer.allocUnsafe(remainingBytes+this._longPacketBuffers.size),offset=0;buf=this._longPacketBuffers.shift();)offset+=buf.copy(buffer,offset);this._buffer.copy(buffer,offset,this._offset),this._buffer=buffer,this._offset=0,this._packetEnd=this._buffer.length-trailingPacketBytes,this._packetOffset=0}},Parser.prototype._parsePacket=function(packetHeader){if(this._packetEnd=this._offset+packetHeader.length,this._packetOffset=this._offset,packetHeader.length===MAX_PACKET_LENGTH)return this._longPacketBuffers.push(this._buffer.slice(this._packetOffset,this._packetEnd)),void this._advanceToNextPacket();this._combineLongPacketBuffers();var hadException=!0;try{this._onPacket(packetHeader),hadException=!1}catch(err){if(!err||"string"!=typeof err.code||"PARSER_"!==err.code.substr(0,7))throw err;this._onError(err),hadException=!1}finally{this._advanceToNextPacket(),hadException&&process.nextTick(this.write.bind(this))}},Parser.prototype._tryReadPacketHeader=function(){if(this._packetHeader)return this._packetHeader;if(!this._combineNextBuffers(PACKET_HEADER_LENGTH))return null;if(this._packetHeader=new PacketHeader(this.parseUnsignedNumber(3),this.parseUnsignedNumber(1)),this._packetHeader.number!==this._nextPacketNumber){var err=new Error("Packets out of order. Got: "+this._packetHeader.number+" Expected: "+this._nextPacketNumber);err.code="PROTOCOL_PACKETS_OUT_OF_ORDER",err.fatal=!0,this._onError(err)}return this.incrementPacketNumber(),this._packetHeader},Parser.prototype._advanceToNextPacket=function(){this._offset=this._packetEnd,this._packetHeader=null,this._packetEnd=null,this._packetOffset=null};