var Parser=require("./Parser"),Sequences=require("./sequences"),Packets=require("./packets"),Stream=require("stream").Stream,Util=require("util"),PacketWriter=require("./PacketWriter");function Protocol(options){Stream.call(this),options=options||{},this.readable=!0,this.writable=!0,this._config=options.config||{},this._connection=options.connection,this._callback=null,this._fatalError=null,this._quitSequence=null,this._handshake=!1,this._handshaked=!1,this._ended=!1,this._destroyed=!1,this._queue=[],this._handshakeInitializationPacket=null,this._parser=new Parser({onError:this.handleParserError.bind(this),onPacket:this._parsePacket.bind(this),config:this._config})}module.exports=Protocol,Util.inherits(Protocol,Stream),Protocol.prototype.write=function(buffer){return this._parser.write(buffer),!0},Protocol.prototype.handshake=function(options,callback){"function"==typeof options&&(callback=options,options={}),(options=options||{}).config=this._config;var sequence=this._enqueue(new Sequences.Handshake(options,callback));return this._handshake=!0,sequence},Protocol.prototype.query=function(options,callback){return this._enqueue(new Sequences.Query(options,callback))},Protocol.prototype.changeUser=function(options,callback){return this._enqueue(new Sequences.ChangeUser(options,callback))},Protocol.prototype.ping=function(options,callback){return"function"==typeof options&&(callback=options,options={}),this._enqueue(new Sequences.Ping(options,callback))},Protocol.prototype.stats=function(options,callback){return"function"==typeof options&&(callback=options,options={}),this._enqueue(new Sequences.Statistics(options,callback))},Protocol.prototype.quit=function(options,callback){"function"==typeof options&&(callback=options,options={});var self=this,sequence=this._enqueue(new Sequences.Quit(options,callback));return sequence.on("end",(function(){self.end()})),this._quitSequence=sequence},Protocol.prototype.end=function(){if(!this._ended){if(this._ended=!0,this._quitSequence&&(this._quitSequence._ended||this._queue[0]===this._quitSequence))return this._quitSequence.end(),void this.emit("end");var err=new Error("Connection lost: The server closed the connection.");err.fatal=!0,err.code="PROTOCOL_CONNECTION_LOST",this._delegateError(err)}},Protocol.prototype.pause=function(){this._parser.pause();var seq=this._queue[0];seq&&seq.emit&&seq.emit("pause")},Protocol.prototype.resume=function(){this._parser.resume();var seq=this._queue[0];seq&&seq.emit&&seq.emit("resume")},Protocol.prototype._enqueue=function(sequence){if(!this._validateEnqueue(sequence))return sequence;this._config.trace&&(sequence._callSite=sequence._callSite||new Error),this._queue.push(sequence),this.emit("enqueue",sequence);var self=this;return sequence.on("error",(function(err){self._delegateError(err,sequence)})).on("packet",(function(packet){sequence._timer.active(),self._emitPacket(packet)})).on("timeout",(function(){var err=new Error(sequence.constructor.name+" inactivity timeout");err.code="PROTOCOL_SEQUENCE_TIMEOUT",err.fatal=!0,err.timeout=sequence._timeout,self._delegateError(err,sequence)})),sequence.constructor===Sequences.Handshake&&(sequence.on("start-tls",(function(){sequence._timer.active(),self._connection._startTLS((function(err){if(err)return err.code="HANDSHAKE_SSL_ERROR",err.fatal=!0,void sequence.end(err);sequence._timer.active(),sequence._tlsUpgradeCompleteHandler()}))})),sequence.on("end",(function(){self._handshaked=!0,self._fatalError||self.emit("handshake",self._handshakeInitializationPacket)}))),sequence.on("end",(function(){self._dequeue(sequence)})),1===this._queue.length&&(this._parser.resetPacketNumber(),this._startSequence(sequence)),sequence},Protocol.prototype._validateEnqueue=function(sequence){var err,prefix="Cannot enqueue "+sequence.constructor.name;if(this._fatalError)(err=new Error(prefix+" after fatal error.")).code="PROTOCOL_ENQUEUE_AFTER_FATAL_ERROR";else if(this._quitSequence)(err=new Error(prefix+" after invoking quit.")).code="PROTOCOL_ENQUEUE_AFTER_QUIT";else if(this._destroyed)(err=new Error(prefix+" after being destroyed.")).code="PROTOCOL_ENQUEUE_AFTER_DESTROY";else{if(!this._handshake&&!this._handshaked||sequence.constructor!==Sequences.Handshake)return!0;(err=new Error(prefix+" after already enqueuing a Handshake.")).code="PROTOCOL_ENQUEUE_HANDSHAKE_TWICE"}var self=this;return err.fatal=!1,sequence.on("error",(function(err){self._delegateError(err,sequence)})),process.nextTick((function(){sequence.end(err)})),!1},Protocol.prototype._parsePacket=function(){var sequence=this._queue[0];if(!sequence)return(err=new Error("Received packet with no active sequence.")).code="PROTOCOL_STRAY_PACKET",err.fatal=!0,void this._delegateError(err);var err,Packet=this._determinePacket(sequence),packet=new Packet({protocol41:this._config.protocol41}),packetName=Packet.name;return Packet===Packets.RowDataPacket?(sequence.RowDataPacket(packet,this._parser,this._connection),void(this._config.debug&&this._debugPacket(!0,packet))):(this._config.debug?this._parsePacketDebug(packet):packet.parse(this._parser),Packet===Packets.HandshakeInitializationPacket&&(this._handshakeInitializationPacket=packet,this.emit("initialize",packet)),sequence._timer.active(),sequence[packetName]?void sequence[packetName](packet):((err=new Error("Received packet in the wrong sequence.")).code="PROTOCOL_INCORRECT_PACKET_SEQUENCE",err.fatal=!0,void this._delegateError(err)))},Protocol.prototype._parsePacketDebug=function(packet){try{packet.parse(this._parser)}finally{this._debugPacket(!0,packet)}},Protocol.prototype._emitPacket=function(packet){var packetWriter=new PacketWriter;packet.write(packetWriter),this.emit("data",packetWriter.toBuffer(this._parser)),this._config.debug&&this._debugPacket(!1,packet)},Protocol.prototype._determinePacket=function(sequence){var firstByte=this._parser.peak();if(sequence.determinePacket){var Packet=sequence.determinePacket(firstByte,this._parser);if(Packet)return Packet}switch(firstByte){case 0:return Packets.OkPacket;case 254:return Packets.EofPacket;case 255:return Packets.ErrorPacket}throw new Error("Could not determine packet, firstByte = "+firstByte)},Protocol.prototype._dequeue=function(sequence){(sequence._timer.stop(),this._fatalError)||(this._queue.shift(),(sequence=this._queue[0])?(this._parser.resetPacketNumber(),this._startSequence(sequence)):this.emit("drain"))},Protocol.prototype._startSequence=function(sequence){sequence._timeout>0&&isFinite(sequence._timeout)&&sequence._timer.start(sequence._timeout),sequence.constructor===Sequences.ChangeUser?sequence.start(this._handshakeInitializationPacket):sequence.start()},Protocol.prototype.handleNetworkError=function(err){err.fatal=!0;var sequence=this._queue[0];sequence?sequence.end(err):this._delegateError(err)},Protocol.prototype.handleParserError=function(err){var sequence=this._queue[0];sequence?sequence.end(err):this._delegateError(err)},Protocol.prototype._delegateError=function(err,sequence){if(!this._fatalError){if(err.fatal&&(this._fatalError=err),this._shouldErrorBubbleUp(err,sequence))this.emit("unhandledError",err);else if(err.fatal){var queue=this._queue;process.nextTick((function(){queue.forEach((function(sequence){sequence.end(err)})),queue.length=0}))}err.fatal&&this.emit("end",err)}},Protocol.prototype._shouldErrorBubbleUp=function(err,sequence){if(sequence){if(sequence.hasErrorHandler())return!1;if(!err.fatal)return!0}return err.fatal&&!this._hasPendingErrorHandlers()},Protocol.prototype._hasPendingErrorHandlers=function(){return this._queue.some((function(sequence){return sequence.hasErrorHandler()}))},Protocol.prototype.destroy=function(){this._destroyed=!0,this._parser.pause(),"disconnected"!==this._connection.state&&(this._ended||this.end())},Protocol.prototype._debugPacket=function(incoming,packet){var connection=this._connection,direction=incoming?"<--":"--\x3e",packetName=packet.constructor.name,threadId=connection&&null!==connection.threadId?" ("+connection.threadId+")":"";if(!Array.isArray(this._config.debug)||-1!==this._config.debug.indexOf(packetName)){var packetPayload=Util.inspect(packet).replace(/^[^{]+/,"");console.log("%s%s %s %s\n",direction,threadId,packetName,packetPayload)}};