"use strict";const EventEmitter=require("events").EventEmitter,NOOP=function(){},removeWhere=(list,predicate)=>{const i=list.findIndex(predicate);return-1===i?void 0:list.splice(i,1)[0]};class IdleItem{constructor(client,idleListener,timeoutId){this.client=client,this.idleListener=idleListener,this.timeoutId=timeoutId}}class PendingItem{constructor(callback){this.callback=callback}}function throwOnDoubleRelease(){throw new Error("Release called on client which has already been released to the pool.")}function promisify(Promise,callback){if(callback)return{callback:callback,result:void 0};let rej,res;return{callback:function(err,client){err?rej(err):res(client)},result:new Promise((function(resolve,reject){res=resolve,rej=reject}))}}function makeIdleListener(pool,client){return function idleListener(err){err.client=client,client.removeListener("error",idleListener),client.on("error",(()=>{pool.log("additional client error after disconnection due to error",err)})),pool._remove(client),pool.emit("error",err,client)}}class Pool extends EventEmitter{constructor(options,Client){super(),this.options=Object.assign({},options),null!=options&&"password"in options&&Object.defineProperty(this.options,"password",{configurable:!0,enumerable:!1,writable:!0,value:options.password}),null!=options&&options.ssl&&options.ssl.key&&Object.defineProperty(this.options.ssl,"key",{enumerable:!1}),this.options.max=this.options.max||this.options.poolSize||10,this.options.maxUses=this.options.maxUses||1/0,this.options.allowExitOnIdle=this.options.allowExitOnIdle||!1,this.options.maxLifetimeSeconds=this.options.maxLifetimeSeconds||0,this.log=this.options.log||function(){},this.Client=this.options.Client||Client||require("pg").Client,this.Promise=this.options.Promise||global.Promise,void 0===this.options.idleTimeoutMillis&&(this.options.idleTimeoutMillis=1e4),this._clients=[],this._idle=[],this._expired=new WeakSet,this._pendingQueue=[],this._endCallback=void 0,this.ending=!1,this.ended=!1}_isFull(){return this._clients.length>=this.options.max}_pulseQueue(){if(this.log("pulse queue"),this.ended)return void this.log("pulse queue ended");if(this.ending)return this.log("pulse queue on ending"),this._idle.length&&this._idle.slice().map((item=>{this._remove(item.client)})),void(this._clients.length||(this.ended=!0,this._endCallback()));if(!this._pendingQueue.length)return void this.log("no queued requests");if(!this._idle.length&&this._isFull())return;const pendingItem=this._pendingQueue.shift();if(this._idle.length){const idleItem=this._idle.pop();clearTimeout(idleItem.timeoutId);const client=idleItem.client;client.ref&&client.ref();const idleListener=idleItem.idleListener;return this._acquireClient(client,pendingItem,idleListener,!1)}if(!this._isFull())return this.newClient(pendingItem);throw new Error("unexpected condition")}_remove(client){const removed=removeWhere(this._idle,(item=>item.client===client));void 0!==removed&&clearTimeout(removed.timeoutId),this._clients=this._clients.filter((c=>c!==client)),client.end(),this.emit("remove",client)}connect(cb){if(this.ending){const err=new Error("Cannot use a pool after calling end on the pool");return cb?cb(err):this.Promise.reject(err)}const response=promisify(this.Promise,cb),result=response.result;if(this._isFull()||this._idle.length){if(this._idle.length&&process.nextTick((()=>this._pulseQueue())),!this.options.connectionTimeoutMillis)return this._pendingQueue.push(new PendingItem(response.callback)),result;const queueCallback=(err,res,done)=>{clearTimeout(tid),response.callback(err,res,done)},pendingItem=new PendingItem(queueCallback),tid=setTimeout((()=>{removeWhere(this._pendingQueue,(i=>i.callback===queueCallback)),pendingItem.timedOut=!0,response.callback(new Error("timeout exceeded when trying to connect"))}),this.options.connectionTimeoutMillis);return this._pendingQueue.push(pendingItem),result}return this.newClient(new PendingItem(response.callback)),result}newClient(pendingItem){const client=new this.Client(this.options);this._clients.push(client);const idleListener=makeIdleListener(this,client);let tid;this.log("checking client timeout");let timeoutHit=!1;this.options.connectionTimeoutMillis&&(tid=setTimeout((()=>{this.log("ending client due to timeout"),timeoutHit=!0,client.connection?client.connection.stream.destroy():client.end()}),this.options.connectionTimeoutMillis)),this.log("connecting new client"),client.connect((err=>{if(tid&&clearTimeout(tid),client.on("error",idleListener),!err){if(this.log("new client connected"),0!==this.options.maxLifetimeSeconds){const maxLifetimeTimeout=setTimeout((()=>{this.log("ending client due to expired lifetime"),this._expired.add(client);-1!==this._idle.findIndex((idleItem=>idleItem.client===client))&&this._acquireClient(client,new PendingItem(((err,client,clientRelease)=>clientRelease())),idleListener,!1)}),1e3*this.options.maxLifetimeSeconds);maxLifetimeTimeout.unref(),client.once("end",(()=>clearTimeout(maxLifetimeTimeout)))}return this._acquireClient(client,pendingItem,idleListener,!0)}this.log("client failed to connect",err),this._clients=this._clients.filter((c=>c!==client)),timeoutHit&&(err.message="Connection terminated due to connection timeout"),this._pulseQueue(),pendingItem.timedOut||pendingItem.callback(err,void 0,NOOP)}))}_acquireClient(client,pendingItem,idleListener,isNew){isNew&&this.emit("connect",client),this.emit("acquire",client),client.release=this._releaseOnce(client,idleListener),client.removeListener("error",idleListener),pendingItem.timedOut?isNew&&this.options.verify?this.options.verify(client,client.release):client.release():isNew&&this.options.verify?this.options.verify(client,(err=>{if(err)return client.release(err),pendingItem.callback(err,void 0,NOOP);pendingItem.callback(void 0,client,client.release)})):pendingItem.callback(void 0,client,client.release)}_releaseOnce(client,idleListener){let released=!1;return err=>{released&&throwOnDoubleRelease(),released=!0,this._release(client,idleListener,err)}}_release(client,idleListener,err){if(client.on("error",idleListener),client._poolUseCount=(client._poolUseCount||0)+1,this.emit("release",err,client),err||this.ending||!client._queryable||client._ending||client._poolUseCount>=this.options.maxUses)return client._poolUseCount>=this.options.maxUses&&this.log("remove expended client"),this._remove(client),void this._pulseQueue();if(this._expired.has(client))return this.log("remove expired client"),this._expired.delete(client),this._remove(client),void this._pulseQueue();let tid;this.options.idleTimeoutMillis&&(tid=setTimeout((()=>{this.log("remove idle client"),this._remove(client)}),this.options.idleTimeoutMillis),this.options.allowExitOnIdle&&tid.unref()),this.options.allowExitOnIdle&&client.unref(),this._idle.push(new IdleItem(client,idleListener,tid)),this._pulseQueue()}query(text,values,cb){if("function"==typeof text){const response=promisify(this.Promise,text);return setImmediate((function(){return response.callback(new Error("Passing a function as the first parameter to pool.query is not supported"))})),response.result}"function"==typeof values&&(cb=values,values=void 0);const response=promisify(this.Promise,cb);return cb=response.callback,this.connect(((err,client)=>{if(err)return cb(err);let clientReleased=!1;const onError=err=>{clientReleased||(clientReleased=!0,client.release(err),cb(err))};client.once("error",onError),this.log("dispatching query");try{client.query(text,values,((err,res)=>{if(this.log("query dispatched"),client.removeListener("error",onError),!clientReleased)return clientReleased=!0,client.release(err),err?cb(err):cb(void 0,res)}))}catch(err){return client.release(err),cb(err)}})),response.result}end(cb){if(this.log("ending"),this.ending){const err=new Error("Called end on pool more than once");return cb?cb(err):this.Promise.reject(err)}this.ending=!0;const promised=promisify(this.Promise,cb);return this._endCallback=promised.callback,this._pulseQueue(),promised.result}get waitingCount(){return this._pendingQueue.length}get idleCount(){return this._idle.length}get expiredCount(){return this._clients.reduce(((acc,client)=>acc+(this._expired.has(client)?1:0)),0)}get totalCount(){return this._clients.length}}module.exports=Pool;