"use strict";const expect=require("expect.js"),_=require("lodash"),describe=require("mocha").describe,it=require("mocha").it,Pool=require("../");describe("pool",(function(){describe("with callbacks",(function(){it("works totally unconfigured",(function(done){const pool=new Pool;pool.connect((function(err,client,release){if(err)return done(err);client.query("SELECT NOW()",(function(err,res){if(release(),err)return done(err);expect(res.rows).to.have.length(1),pool.end(done)}))}))})),it("passes props to clients",(function(done){const pool=new Pool({binary:!0});pool.connect((function(err,client,release){if(release(),err)return done(err);expect(client.binary).to.eql(!0),pool.end(done)}))})),it("can run a query with a callback without parameters",(function(done){const pool=new Pool;pool.query("SELECT 1 as num",(function(err,res){expect(res.rows[0]).to.eql({num:1}),pool.end((function(){done(err)}))}))})),it("can run a query with a callback",(function(done){const pool=new Pool;pool.query("SELECT $1::text as name",["brianc"],(function(err,res){expect(res.rows[0]).to.eql({name:"brianc"}),pool.end((function(){done(err)}))}))})),it("passes connection errors to callback",(function(done){const pool=new Pool({port:53922});pool.query("SELECT $1::text as name",["brianc"],(function(err,res){expect(res).to.be(void 0),expect(err).to.be.an(Error),expect(pool.totalCount).to.equal(0),pool.end((function(err){done(err)}))}))})),it("does not pass client to error callback",(function(done){const pool=new Pool({port:58242});pool.connect((function(err,client,release){expect(err).to.be.an(Error),expect(client).to.be(void 0),expect(release).to.be.a(Function),pool.end(done)}))})),it("removes client if it errors in background",(function(done){const pool=new Pool;pool.connect((function(err,client,release){if(release(),err)return done(err);client.testString="foo",setTimeout((function(){client.emit("error",new Error("on purpose"))}),10)})),pool.on("error",(function(err){expect(err.message).to.be("on purpose"),expect(err.client).to.not.be(void 0),expect(err.client.testString).to.be("foo"),err.client.connection.stream.on("end",(function(){pool.end(done)}))}))})),it("should not change given options",(function(done){const options={max:10},pool=new Pool(options);pool.connect((function(err,client,release){if(release(),err)return done(err);expect(options).to.eql({max:10}),pool.end(done)}))})),it("does not create promises when connecting",(function(done){const pool=new Pool,returnValue=pool.connect((function(err,client,release){if(release(),err)return done(err);pool.end(done)}));expect(returnValue).to.be(void 0)})),it("does not create promises when querying",(function(done){const pool=new Pool,returnValue=pool.query("SELECT 1 as num",(function(err){pool.end((function(){done(err)}))}));expect(returnValue).to.be(void 0)})),it("does not create promises when ending",(function(done){const returnValue=(new Pool).end(done);expect(returnValue).to.be(void 0)})),it("never calls callback syncronously",(function(done){const pool=new Pool;pool.connect(((err,client)=>{if(err)throw err;client.release(),setImmediate((()=>{let called=!1;pool.connect(((err,client)=>{if(err)throw err;called=!0,client.release(),setImmediate((()=>{pool.end(done)}))})),expect(called).to.equal(!1)}))}))}))})),describe("with promises",(function(){it("connects, queries, and disconnects",(function(){const pool=new Pool;return pool.connect().then((function(client){return client.query("select $1::text as name",["hi"]).then((function(res){return expect(res.rows).to.eql([{name:"hi"}]),client.release(),pool.end()}))}))})),it("executes a query directly",(()=>{const pool=new Pool;return pool.query("SELECT $1::text as name",["hi"]).then((res=>(expect(res.rows).to.have.length(1),expect(res.rows[0].name).to.equal("hi"),pool.end())))})),it("properly pools clients",(function(){const pool=new Pool({poolSize:9}),promises=_.times(30,(function(){return pool.connect().then((function(client){return client.query("select $1::text as name",["hi"]).then((function(res){return client.release(),res}))}))}));return Promise.all(promises).then((function(res){return expect(res).to.have.length(30),expect(pool.totalCount).to.be(9),pool.end()}))})),it("supports just running queries",(function(){const pool=new Pool({poolSize:9}),query={text:"select $1::text as name",values:["hi"]},promises=_.times(30,(()=>pool.query(query)));return Promise.all(promises).then((function(queries){return expect(queries).to.have.length(30),pool.end()}))})),it("recovers from query errors",(function(){const pool=new Pool,errors=[],promises=_.times(30,(()=>pool.query("SELECT asldkfjasldkf").catch((function(e){errors.push(e)}))));return Promise.all(promises).then((()=>(expect(errors).to.have.length(30),expect(pool.totalCount).to.equal(0),expect(pool.idleCount).to.equal(0),pool.query("SELECT $1::text as name",["hi"]).then((function(res){return expect(res.rows).to.eql([{name:"hi"}]),pool.end()})))))}))}))}));