"use strict";var EventEmitter=require("events").EventEmitter,utils=require("./utils"),sasl=require("./crypto/sasl"),TypeOverrides=require("./type-overrides"),ConnectionParameters=require("./connection-parameters"),Query=require("./query"),defaults=require("./defaults"),Connection=require("./connection");const crypto=require("./crypto/utils");class Client extends EventEmitter{constructor(config){super(),this.connectionParameters=new ConnectionParameters(config),this.user=this.connectionParameters.user,this.database=this.connectionParameters.database,this.port=this.connectionParameters.port,this.host=this.connectionParameters.host,Object.defineProperty(this,"password",{configurable:!0,enumerable:!1,writable:!0,value:this.connectionParameters.password}),this.replication=this.connectionParameters.replication;var c=config||{};this._Promise=c.Promise||global.Promise,this._types=new TypeOverrides(c.types),this._ending=!1,this._ended=!1,this._connecting=!1,this._connected=!1,this._connectionError=!1,this._queryable=!0,this.connection=c.connection||new Connection({stream:c.stream,ssl:this.connectionParameters.ssl,keepAlive:c.keepAlive||!1,keepAliveInitialDelayMillis:c.keepAliveInitialDelayMillis||0,encoding:this.connectionParameters.client_encoding||"utf8"}),this.queryQueue=[],this.binary=c.binary||defaults.binary,this.processID=null,this.secretKey=null,this.ssl=this.connectionParameters.ssl||!1,this.ssl&&this.ssl.key&&Object.defineProperty(this.ssl,"key",{enumerable:!1}),this._connectionTimeoutMillis=c.connectionTimeoutMillis||0}_errorAllQueries(err){const enqueueError=query=>{process.nextTick((()=>{query.handleError(err,this.connection)}))};this.activeQuery&&(enqueueError(this.activeQuery),this.activeQuery=null),this.queryQueue.forEach(enqueueError),this.queryQueue.length=0}_connect(callback){var self=this,con=this.connection;if(this._connectionCallback=callback,this._connecting||this._connected){const err=new Error("Client has already been connected. You cannot reuse a client.");process.nextTick((()=>{callback(err)}))}else this._connecting=!0,this.connectionTimeoutHandle,this._connectionTimeoutMillis>0&&(this.connectionTimeoutHandle=setTimeout((()=>{con._ending=!0,con.stream.destroy(new Error("timeout expired"))}),this._connectionTimeoutMillis)),this.host&&0===this.host.indexOf("/")?con.connect(this.host+"/.s.PGSQL."+this.port):con.connect(this.port,this.host),con.on("connect",(function(){self.ssl?con.requestSsl():con.startup(self.getStartupConf())})),con.on("sslconnect",(function(){con.startup(self.getStartupConf())})),this._attachListeners(con),con.once("end",(()=>{const error=this._ending?new Error("Connection terminated"):new Error("Connection terminated unexpectedly");clearTimeout(this.connectionTimeoutHandle),this._errorAllQueries(error),this._ended=!0,this._ending||(this._connecting&&!this._connectionError?this._connectionCallback?this._connectionCallback(error):this._handleErrorEvent(error):this._connectionError||this._handleErrorEvent(error)),process.nextTick((()=>{this.emit("end")}))}))}connect(callback){if(!callback)return new this._Promise(((resolve,reject)=>{this._connect((error=>{error?reject(error):resolve()}))}));this._connect(callback)}_attachListeners(con){con.on("authenticationCleartextPassword",this._handleAuthCleartextPassword.bind(this)),con.on("authenticationMD5Password",this._handleAuthMD5Password.bind(this)),con.on("authenticationSASL",this._handleAuthSASL.bind(this)),con.on("authenticationSASLContinue",this._handleAuthSASLContinue.bind(this)),con.on("authenticationSASLFinal",this._handleAuthSASLFinal.bind(this)),con.on("backendKeyData",this._handleBackendKeyData.bind(this)),con.on("error",this._handleErrorEvent.bind(this)),con.on("errorMessage",this._handleErrorMessage.bind(this)),con.on("readyForQuery",this._handleReadyForQuery.bind(this)),con.on("notice",this._handleNotice.bind(this)),con.on("rowDescription",this._handleRowDescription.bind(this)),con.on("dataRow",this._handleDataRow.bind(this)),con.on("portalSuspended",this._handlePortalSuspended.bind(this)),con.on("emptyQuery",this._handleEmptyQuery.bind(this)),con.on("commandComplete",this._handleCommandComplete.bind(this)),con.on("parseComplete",this._handleParseComplete.bind(this)),con.on("copyInResponse",this._handleCopyInResponse.bind(this)),con.on("copyData",this._handleCopyData.bind(this)),con.on("notification",this._handleNotification.bind(this))}_checkPgPass(cb){const con=this.connection;if("function"==typeof this.password)this._Promise.resolve().then((()=>this.password())).then((pass=>{if(void 0!==pass){if("string"!=typeof pass)return void con.emit("error",new TypeError("Password must be a string"));this.connectionParameters.password=this.password=pass}else this.connectionParameters.password=this.password=null;cb()})).catch((err=>{con.emit("error",err)}));else if(null!==this.password)cb();else try{require("pgpass")(this.connectionParameters,(pass=>{void 0!==pass&&(this.connectionParameters.password=this.password=pass),cb()}))}catch(e){this.emit("error",e)}}_handleAuthCleartextPassword(msg){this._checkPgPass((()=>{this.connection.password(this.password)}))}_handleAuthMD5Password(msg){this._checkPgPass((async()=>{try{const hashedPassword=await crypto.postgresMd5PasswordHash(this.user,this.password,msg.salt);this.connection.password(hashedPassword)}catch(e){this.emit("error",e)}}))}_handleAuthSASL(msg){this._checkPgPass((()=>{try{this.saslSession=sasl.startSession(msg.mechanisms),this.connection.sendSASLInitialResponseMessage(this.saslSession.mechanism,this.saslSession.response)}catch(err){this.connection.emit("error",err)}}))}async _handleAuthSASLContinue(msg){try{await sasl.continueSession(this.saslSession,this.password,msg.data),this.connection.sendSCRAMClientFinalMessage(this.saslSession.response)}catch(err){this.connection.emit("error",err)}}_handleAuthSASLFinal(msg){try{sasl.finalizeSession(this.saslSession,msg.data),this.saslSession=null}catch(err){this.connection.emit("error",err)}}_handleBackendKeyData(msg){this.processID=msg.processID,this.secretKey=msg.secretKey}_handleReadyForQuery(msg){this._connecting&&(this._connecting=!1,this._connected=!0,clearTimeout(this.connectionTimeoutHandle),this._connectionCallback&&(this._connectionCallback(null,this),this._connectionCallback=null),this.emit("connect"));const{activeQuery:activeQuery}=this;this.activeQuery=null,this.readyForQuery=!0,activeQuery&&activeQuery.handleReadyForQuery(this.connection),this._pulseQueryQueue()}_handleErrorWhileConnecting(err){if(!this._connectionError){if(this._connectionError=!0,clearTimeout(this.connectionTimeoutHandle),this._connectionCallback)return this._connectionCallback(err);this.emit("error",err)}}_handleErrorEvent(err){if(this._connecting)return this._handleErrorWhileConnecting(err);this._queryable=!1,this._errorAllQueries(err),this.emit("error",err)}_handleErrorMessage(msg){if(this._connecting)return this._handleErrorWhileConnecting(msg);const activeQuery=this.activeQuery;activeQuery?(this.activeQuery=null,activeQuery.handleError(msg,this.connection)):this._handleErrorEvent(msg)}_handleRowDescription(msg){this.activeQuery.handleRowDescription(msg)}_handleDataRow(msg){this.activeQuery.handleDataRow(msg)}_handlePortalSuspended(msg){this.activeQuery.handlePortalSuspended(this.connection)}_handleEmptyQuery(msg){this.activeQuery.handleEmptyQuery(this.connection)}_handleCommandComplete(msg){this.activeQuery.handleCommandComplete(msg,this.connection)}_handleParseComplete(msg){this.activeQuery.name&&(this.connection.parsedStatements[this.activeQuery.name]=this.activeQuery.text)}_handleCopyInResponse(msg){this.activeQuery.handleCopyInResponse(this.connection)}_handleCopyData(msg){this.activeQuery.handleCopyData(msg,this.connection)}_handleNotification(msg){this.emit("notification",msg)}_handleNotice(msg){this.emit("notice",msg)}getStartupConf(){var params=this.connectionParameters,data={user:params.user,database:params.database},appName=params.application_name||params.fallback_application_name;return appName&&(data.application_name=appName),params.replication&&(data.replication=""+params.replication),params.statement_timeout&&(data.statement_timeout=String(parseInt(params.statement_timeout,10))),params.lock_timeout&&(data.lock_timeout=String(parseInt(params.lock_timeout,10))),params.idle_in_transaction_session_timeout&&(data.idle_in_transaction_session_timeout=String(parseInt(params.idle_in_transaction_session_timeout,10))),params.options&&(data.options=params.options),data}cancel(client,query){if(client.activeQuery===query){var con=this.connection;this.host&&0===this.host.indexOf("/")?con.connect(this.host+"/.s.PGSQL."+this.port):con.connect(this.port,this.host),con.on("connect",(function(){con.cancel(client.processID,client.secretKey)}))}else-1!==client.queryQueue.indexOf(query)&&client.queryQueue.splice(client.queryQueue.indexOf(query),1)}setTypeParser(oid,format,parseFn){return this._types.setTypeParser(oid,format,parseFn)}getTypeParser(oid,format){return this._types.getTypeParser(oid,format)}escapeIdentifier(str){return utils.escapeIdentifier(str)}escapeLiteral(str){return utils.escapeLiteral(str)}_pulseQueryQueue(){if(!0===this.readyForQuery)if(this.activeQuery=this.queryQueue.shift(),this.activeQuery){this.readyForQuery=!1,this.hasExecuted=!0;const queryError=this.activeQuery.submit(this.connection);queryError&&process.nextTick((()=>{this.activeQuery.handleError(queryError,this.connection),this.readyForQuery=!0,this._pulseQueryQueue()}))}else this.hasExecuted&&(this.activeQuery=null,this.emit("drain"))}query(config,values,callback){var query,result,readTimeout,readTimeoutTimer,queryCallback;if(null==config)throw new TypeError("Client was passed a null or undefined query");return"function"==typeof config.submit?(readTimeout=config.query_timeout||this.connectionParameters.query_timeout,result=query=config,"function"==typeof values&&(query.callback=query.callback||values)):(readTimeout=this.connectionParameters.query_timeout,(query=new Query(config,values,callback)).callback||(result=new this._Promise(((resolve,reject)=>{query.callback=(err,res)=>err?reject(err):resolve(res)})))),readTimeout&&(queryCallback=query.callback,readTimeoutTimer=setTimeout((()=>{var error=new Error("Query read timeout");process.nextTick((()=>{query.handleError(error,this.connection)})),queryCallback(error),query.callback=()=>{};var index=this.queryQueue.indexOf(query);index>-1&&this.queryQueue.splice(index,1),this._pulseQueryQueue()}),readTimeout),query.callback=(err,res)=>{clearTimeout(readTimeoutTimer),queryCallback(err,res)}),this.binary&&!query.binary&&(query.binary=!0),query._result&&!query._result._types&&(query._result._types=this._types),this._queryable?this._ending?(process.nextTick((()=>{query.handleError(new Error("Client was closed and is not queryable"),this.connection)})),result):(this.queryQueue.push(query),this._pulseQueryQueue(),result):(process.nextTick((()=>{query.handleError(new Error("Client has encountered a connection error and is not queryable"),this.connection)})),result)}ref(){this.connection.ref()}unref(){this.connection.unref()}end(cb){if(this._ending=!0,!this.connection._connecting||this._ended){if(!cb)return this._Promise.resolve();cb()}if(this.activeQuery||!this._queryable?this.connection.stream.destroy():this.connection.end(),!cb)return new this._Promise((resolve=>{this.connection.once("end",resolve)}));this.connection.once("end",cb)}}Client.Query=Query,module.exports=Client;