"use strict";var Native;try{Native=require("pg-native")}catch(e){throw e}var TypeOverrides=require("../type-overrides"),EventEmitter=require("events").EventEmitter,util=require("util"),ConnectionParameters=require("../connection-parameters"),NativeQuery=require("./query"),Client=module.exports=function(config){EventEmitter.call(this),config=config||{},this._Promise=config.Promise||global.Promise,this._types=new TypeOverrides(config.types),this.native=new Native({types:this._types}),this._queryQueue=[],this._ending=!1,this._connecting=!1,this._connected=!1,this._queryable=!0;var cp=this.connectionParameters=new ConnectionParameters(config);this.user=cp.user,Object.defineProperty(this,"password",{configurable:!0,enumerable:!1,writable:!0,value:cp.password}),this.database=cp.database,this.host=cp.host,this.port=cp.port,this.namedQueries={}};Client.Query=NativeQuery,util.inherits(Client,EventEmitter),Client.prototype._errorAllQueries=function(err){const enqueueError=query=>{process.nextTick((()=>{query.native=this.native,query.handleError(err)}))};this._hasActiveQuery()&&(enqueueError(this._activeQuery),this._activeQuery=null),this._queryQueue.forEach(enqueueError),this._queryQueue.length=0},Client.prototype._connect=function(cb){var self=this;this._connecting?process.nextTick((()=>cb(new Error("Client has already been connected. You cannot reuse a client.")))):(this._connecting=!0,this.connectionParameters.getLibpqConnectionString((function(err,conString){if(err)return cb(err);self.native.connect(conString,(function(err){if(err)return self.native.end(),cb(err);self._connected=!0,self.native.on("error",(function(err){self._queryable=!1,self._errorAllQueries(err),self.emit("error",err)})),self.native.on("notification",(function(msg){self.emit("notification",{channel:msg.relname,payload:msg.extra})})),self.emit("connect"),self._pulseQueryQueue(!0),cb()}))})))},Client.prototype.connect=function(callback){if(!callback)return new this._Promise(((resolve,reject)=>{this._connect((error=>{error?reject(error):resolve()}))}));this._connect(callback)},Client.prototype.query=function(config,values,callback){var query,result,readTimeout,readTimeoutTimer,queryCallback;if(null==config)throw new TypeError("Client was passed a null or undefined query");if("function"==typeof config.submit)readTimeout=config.query_timeout||this.connectionParameters.query_timeout,result=query=config,"function"==typeof values&&(config.callback=values);else if(readTimeout=this.connectionParameters.query_timeout,!(query=new NativeQuery(config,values,callback)).callback){let resolveOut,rejectOut;result=new this._Promise(((resolve,reject)=>{resolveOut=resolve,rejectOut=reject})),query.callback=(err,res)=>err?rejectOut(err):resolveOut(res)}return readTimeout&&(queryCallback=query.callback,readTimeoutTimer=setTimeout((()=>{var error=new Error("Query read timeout");process.nextTick((()=>{query.handleError(error,this.connection)})),queryCallback(error),query.callback=()=>{};var index=this._queryQueue.indexOf(query);index>-1&&this._queryQueue.splice(index,1),this._pulseQueryQueue()}),readTimeout),query.callback=(err,res)=>{clearTimeout(readTimeoutTimer),queryCallback(err,res)}),this._queryable?this._ending?(query.native=this.native,process.nextTick((()=>{query.handleError(new Error("Client was closed and is not queryable"))})),result):(this._queryQueue.push(query),this._pulseQueryQueue(),result):(query.native=this.native,process.nextTick((()=>{query.handleError(new Error("Client has encountered a connection error and is not queryable"))})),result)},Client.prototype.end=function(cb){var result,self=this;return this._ending=!0,this._connected||this.once("connect",this.end.bind(this,cb)),cb||(result=new this._Promise((function(resolve,reject){cb=err=>err?reject(err):resolve()}))),this.native.end((function(){self._errorAllQueries(new Error("Connection terminated")),process.nextTick((()=>{self.emit("end"),cb&&cb()}))})),result},Client.prototype._hasActiveQuery=function(){return this._activeQuery&&"error"!==this._activeQuery.state&&"end"!==this._activeQuery.state},Client.prototype._pulseQueryQueue=function(initialConnection){if(this._connected&&!this._hasActiveQuery()){var query=this._queryQueue.shift();if(query){this._activeQuery=query,query.submit(this);var self=this;query.once("_done",(function(){self._pulseQueryQueue()}))}else initialConnection||this.emit("drain")}},Client.prototype.cancel=function(query){this._activeQuery===query?this.native.cancel((function(){})):-1!==this._queryQueue.indexOf(query)&&this._queryQueue.splice(this._queryQueue.indexOf(query),1)},Client.prototype.ref=function(){},Client.prototype.unref=function(){},Client.prototype.setTypeParser=function(oid,format,parseFn){return this._types.setTypeParser(oid,format,parseFn)},Client.prototype.getTypeParser=function(oid,format){return this._types.getTypeParser(oid,format)};