"use strict";const fs=require("fs"),child_process=require("child_process"),{PerformanceObserver:PerformanceObserver,constants:{NODE_PERFORMANCE_GC_INCREMENTAL:NODE_PERFORMANCE_GC_INCREMENTAL,NODE_PERFORMANCE_GC_MAJOR:NODE_PERFORMANCE_GC_MAJOR,NODE_PERFORMANCE_GC_MINOR:NODE_PERFORMANCE_GC_MINOR}}=require("perf_hooks");require("@babel/register")({extensions:[".ts"]});const{Connection:Connection}=require("../src/tedious");function Benchmark(fn,configs,options){this.name=require.main.filename.slice(__dirname.length+1);const parsed_args=this._parseArgs(process.argv.slice(2),configs);if(this.options=parsed_args.cli,this.extra_options=parsed_args.extra,this.queue=this._queue(this.options),this.config=this.queue[0],this.flags=[],options&&options.flags&&(this.flags=this.flags.concat(options.flags)),process.env.NODE_BENCHMARK_FLAGS){const flags=process.env.NODE_BENCHMARK_FLAGS.split(/\s+/);this.flags=this.flags.concat(flags)}this._time=[0,0],this._started=!1,this._gcStats={[NODE_PERFORMANCE_GC_INCREMENTAL]:{count:0,totalDuration:0},[NODE_PERFORMANCE_GC_MINOR]:{count:0,totalDuration:0},[NODE_PERFORMANCE_GC_MAJOR]:{count:0,totalDuration:0}},this._observer=new PerformanceObserver((list=>{const entries=list.getEntries(),length=entries.length;for(let i=0;i<length;i++){const entry=entries[i],stats=this._gcStats[entry.kind];stats&&(stats.count+=1,stats.totalDuration+=entry.duration)}})),process.env.hasOwnProperty("NODE_RUN_BENCHMARK_FN")?process.nextTick((()=>fn(this.config))):process.nextTick((()=>this._run()))}function formatResult(data){let conf="";for(const key of Object.keys(data.conf))conf+=` ${key}=${JSON.stringify(data.conf[key])}`;var gcInfo,rate=data.rate.toString().split(".");return rate[0]=rate[0].replace(/(\d)(?=(?:\d\d\d)+(?!\d))/g,"$1,"),rate=rate[1]?rate.join("."):rate[0],gcInfo=`(minor: ${data.gcStats[NODE_PERFORMANCE_GC_MINOR].count} - ${data.gcStats[NODE_PERFORMANCE_GC_MINOR].totalDuration}ms,`,gcInfo+=` major: ${data.gcStats[NODE_PERFORMANCE_GC_MAJOR].count} - ${data.gcStats[NODE_PERFORMANCE_GC_MAJOR].totalDuration}ms,`,gcInfo+=` incremental: ${data.gcStats[NODE_PERFORMANCE_GC_INCREMENTAL].count} - ${data.gcStats[NODE_PERFORMANCE_GC_INCREMENTAL].totalDuration}ms)`,`${data.name}${conf}: ${rate} ${gcInfo}`}function sendResult(data){process.send?process.send(data):console.log(formatResult(data))}function createBenchmark(fn,configs,options){return new Benchmark(fn,configs,options)}function createConnection(cb){var config=JSON.parse(fs.readFileSync(require("os").homedir()+"/.tedious/test-connection.json","utf8")).config,connection=new Connection(config);connection.connect((function(){cb(connection)}))}Benchmark.prototype._parseArgs=function(argv,configs){const cliOptions={},extraOptions={},validArgRE=/^(.+?)=([\s\S]*)$/;for(const arg of argv){const match=arg.match(validArgRE);match||(console.error(`bad argument: ${arg}`),process.exit(1));const config=match[1];if(configs[config]){const value="number"==typeof configs[config][0]?+match[2]:match[2];cliOptions[config]||(cliOptions[config]=[]),cliOptions[config].push(value)}else extraOptions[config]=match[2]}return{cli:Object.assign({},configs,cliOptions),extra:extraOptions}},Benchmark.prototype._queue=function(options){const queue=[],keys=Object.keys(options);function recursive(keyIndex,prevConfig){const key=keys[keyIndex],values=options[key],type=typeof values[0];for(const value of values){if("number"!=typeof value&&"string"!=typeof value)throw new TypeError(`configuration "${key}" had type ${typeof value}`);if(typeof value!==type)throw new TypeError(`configuration "${key}" has mixed types`);const currConfig=Object.assign({[key]:value},prevConfig);keyIndex+1<keys.length?recursive(keyIndex+1,currConfig):queue.push(currConfig)}}return keys.length>0?recursive(0,{}):queue.push({}),queue},Benchmark.prototype._run=function(){const self=this;process.send&&process.send({type:"config",name:this.name,queueLength:this.queue.length}),function recursive(queueIndex){const config=self.queue[queueIndex],childEnv=Object.assign({},process.env);childEnv.NODE_RUN_BENCHMARK_FN="";const childArgs=[];for(const key of Object.keys(config))childArgs.push(`${key}=${config[key]}`);for(const key of Object.keys(self.extra_options))childArgs.push(`${key}=${self.extra_options[key]}`);const child=child_process.fork(require.main.filename,childArgs,{env:childEnv,execArgv:self.flags.concat(process.execArgv)});child.on("message",sendResult),child.on("close",(code=>{code&&process.exit(code),queueIndex+1<self.queue.length&&recursive(queueIndex+1)}))}(0)},Benchmark.prototype.start=function(){if(this._started)throw new Error("Called start more than once in a single benchmark");this._started=!0,this._observer.observe({entryTypes:["gc"],buffered:!1}),this._time=process.hrtime()},Benchmark.prototype.end=function(operations){const elapsed=process.hrtime(this._time);if(!this._started)throw new Error("called end without start");if("number"!=typeof operations)throw new Error("called end() without specifying operation count");if(!process.env.NODEJS_BENCHMARK_ZERO_ALLOWED&&operations<=0)throw new Error("called end() with operation count <= 0");if(0===elapsed[0]&&0===elapsed[1]){if(!process.env.NODEJS_BENCHMARK_ZERO_ALLOWED)throw new Error("insufficient clock precision for short benchmark");elapsed[1]=1}this._observer.disconnect();const rate=operations/(elapsed[0]+elapsed[1]/1e9);this.report(rate,elapsed)},Benchmark.prototype.report=function(rate,elapsed){sendResult({name:this.name,conf:this.config,rate:rate,time:elapsed[0]+elapsed[1]/1e9,type:"report",gcStats:this._gcStats})},module.exports.createBenchmark=createBenchmark,module.exports.createConnection=createConnection;