"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _events=require("events"),_writableTrackingBuffer=_interopRequireDefault(require("./tracking-buffer/writable-tracking-buffer")),_stream=require("stream"),_token=require("./token/token");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}const FLAGS={nullable:1,caseSen:2,updateableReadWrite:4,updateableUnknown:8,identity:16,computed:32,fixedLenCLRType:256,sparseColumnSet:1024,hidden:8192,key:16384,nullableUnknown:32768},DONE_STATUS={FINAL:0,MORE:1,ERROR:2,INXACT:4,COUNT:16,ATTN:32,SRVERROR:256},rowTokenBuffer=Buffer.from([_token.TYPE.ROW]),textPointerAndTimestampBuffer=Buffer.from([16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]),textPointerNullBuffer=Buffer.from([0]);class RowTransform extends _stream.Transform{constructor(bulkLoad){super({writableObjectMode:!0}),this.columnMetadataWritten=void 0,this.bulkLoad=void 0,this.mainOptions=void 0,this.columns=void 0,this.bulkLoad=bulkLoad,this.mainOptions=bulkLoad.options,this.columns=bulkLoad.columns,this.columnMetadataWritten=!1}_transform(row,_encoding,callback){this.columnMetadataWritten||(this.push(this.bulkLoad.getColMetaData()),this.columnMetadataWritten=!0),this.push(rowTokenBuffer);for(let i=0;i<this.columns.length;i++){const c=this.columns[i];let value=Array.isArray(row)?row[i]:row[c.objName];if(!this.bulkLoad.firstRowWritten)try{value=c.type.validate(value,c.collation)}catch(error){return callback(error)}const parameter={length:c.length,scale:c.scale,precision:c.precision,value:value};if("Text"===c.type.name||"Image"===c.type.name||"NText"===c.type.name){if(null==value){this.push(textPointerNullBuffer);continue}this.push(textPointerAndTimestampBuffer)}this.push(c.type.generateParameterLength(parameter,this.mainOptions));for(const chunk of c.type.generateParameterData(parameter,this.mainOptions))this.push(chunk)}process.nextTick(callback)}_flush(callback){this.push(this.bulkLoad.createDoneToken()),process.nextTick(callback)}}class BulkLoad extends _events.EventEmitter{constructor(table,collation,connectionOptions,{checkConstraints:checkConstraints=!1,fireTriggers:fireTriggers=!1,keepNulls:keepNulls=!1,lockTable:lockTable=!1,order:order={}},callback){if("boolean"!=typeof checkConstraints)throw new TypeError('The "options.checkConstraints" property must be of type boolean.');if("boolean"!=typeof fireTriggers)throw new TypeError('The "options.fireTriggers" property must be of type boolean.');if("boolean"!=typeof keepNulls)throw new TypeError('The "options.keepNulls" property must be of type boolean.');if("boolean"!=typeof lockTable)throw new TypeError('The "options.lockTable" property must be of type boolean.');if("object"!=typeof order||null===order)throw new TypeError('The "options.order" property must be of type object.');for(const[column,direction]of Object.entries(order))if("ASC"!==direction&&"DESC"!==direction)throw new TypeError('The value of the "'+column+'" key in the "options.order" object must be either "ASC" or "DESC".');super(),this.error=void 0,this.canceled=void 0,this.executionStarted=void 0,this.streamingMode=void 0,this.table=void 0,this.timeout=void 0,this.options=void 0,this.callback=void 0,this.columns=void 0,this.columnsByName=void 0,this.firstRowWritten=void 0,this.rowToPacketTransform=void 0,this.bulkOptions=void 0,this.connection=void 0,this.rows=void 0,this.rst=void 0,this.rowCount=void 0,this.collation=void 0,this.error=void 0,this.canceled=!1,this.executionStarted=!1,this.collation=collation,this.table=table,this.options=connectionOptions,this.callback=callback,this.columns=[],this.columnsByName={},this.firstRowWritten=!1,this.streamingMode=!1,this.rowToPacketTransform=new RowTransform(this),this.bulkOptions={checkConstraints:checkConstraints,fireTriggers:fireTriggers,keepNulls:keepNulls,lockTable:lockTable,order:order}}addColumn(name,type,{output:output=!1,length:length,precision:precision,scale:scale,objName:objName=name,nullable:nullable=!0}){if(this.firstRowWritten)throw new Error("Columns cannot be added to bulk insert after the first row has been written.");if(this.executionStarted)throw new Error("Columns cannot be added to bulk insert after execution has started.");const column={type:type,name:name,value:null,output:output,length:length,precision:precision,scale:scale,objName:objName,nullable:nullable,collation:this.collation};32==(48&type.id)&&null==column.length&&type.resolveLength&&(column.length=type.resolveLength(column)),type.resolvePrecision&&null==column.precision&&(column.precision=type.resolvePrecision(column)),type.resolveScale&&null==column.scale&&(column.scale=type.resolveScale(column)),this.columns.push(column),this.columnsByName[name]=column}getOptionsSql(){const addOptions=[];if(this.bulkOptions.checkConstraints&&addOptions.push("CHECK_CONSTRAINTS"),this.bulkOptions.fireTriggers&&addOptions.push("FIRE_TRIGGERS"),this.bulkOptions.keepNulls&&addOptions.push("KEEP_NULLS"),this.bulkOptions.lockTable&&addOptions.push("TABLOCK"),this.bulkOptions.order){const orderColumns=[];for(const[column,direction]of Object.entries(this.bulkOptions.order))orderColumns.push(`${column} ${direction}`);orderColumns.length&&addOptions.push(`ORDER (${orderColumns.join(", ")})`)}return addOptions.length>0?` WITH (${addOptions.join(",")})`:""}getBulkInsertSql(){let sql="insert bulk "+this.table+"(";for(let i=0,len=this.columns.length;i<len;i++){const c=this.columns[i];0!==i&&(sql+=", "),sql+="["+c.name+"] "+c.type.declaration(c)}return sql+=")",sql+=this.getOptionsSql(),sql}getTableCreationSql(){let sql="CREATE TABLE "+this.table+"(\n";for(let i=0,len=this.columns.length;i<len;i++){const c=this.columns[i];0!==i&&(sql+=",\n"),sql+="["+c.name+"] "+c.type.declaration(c),void 0!==c.nullable&&(sql+=" "+(c.nullable?"NULL":"NOT NULL"))}return sql+="\n)",sql}getColMetaData(){const tBuf=new _writableTrackingBuffer.default(100,null,!0);tBuf.writeUInt8(_token.TYPE.COLMETADATA),tBuf.writeUInt16LE(this.columns.length);for(let j=0,len=this.columns.length;j<len;j++){const c=this.columns[j];this.options.tdsVersion<"7_2"?tBuf.writeUInt16LE(0):tBuf.writeUInt32LE(0);let flags=FLAGS.updateableReadWrite;c.nullable?flags|=FLAGS.nullable:void 0===c.nullable&&this.options.tdsVersion>="7_2"&&(flags|=FLAGS.nullableUnknown),tBuf.writeUInt16LE(flags),tBuf.writeBuffer(c.type.generateTypeInfo(c,this.options)),c.type.hasTableName&&tBuf.writeUsVarchar(this.table,"ucs2"),tBuf.writeBVarchar(c.name,"ucs2")}return tBuf.data}setTimeout(timeout){this.timeout=timeout}createDoneToken(){const tBuf=new _writableTrackingBuffer.default(this.options.tdsVersion<"7_2"?9:13);tBuf.writeUInt8(_token.TYPE.DONE);const status=DONE_STATUS.FINAL;return tBuf.writeUInt16LE(status),tBuf.writeUInt16LE(0),tBuf.writeUInt32LE(0),this.options.tdsVersion>="7_2"&&tBuf.writeUInt32LE(0),tBuf.data}cancel(){this.canceled||(this.canceled=!0,this.emit("cancel"))}}var _default=BulkLoad;exports.default=_default,module.exports=BulkLoad;