"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.connectInParallel=connectInParallel,exports.connectInSequence=connectInSequence,exports.lookupAllAddresses=lookupAllAddresses;var _net=_interopRequireDefault(require("net")),punycode=_interopRequireWildcard(require("punycode")),_abortError=_interopRequireDefault(require("./errors/abort-error")),_esAggregateError=_interopRequireDefault(require("es-aggregate-error"));function _getRequireWildcardCache(nodeInterop){if("function"!=typeof WeakMap)return null;var cacheBabelInterop=new WeakMap,cacheNodeInterop=new WeakMap;return(_getRequireWildcardCache=function(nodeInterop){return nodeInterop?cacheNodeInterop:cacheBabelInterop})(nodeInterop)}function _interopRequireWildcard(obj,nodeInterop){if(!nodeInterop&&obj&&obj.__esModule)return obj;if(null===obj||"object"!=typeof obj&&"function"!=typeof obj)return{default:obj};var cache=_getRequireWildcardCache(nodeInterop);if(cache&&cache.has(obj))return cache.get(obj);var newObj={},hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj)if("default"!==key&&Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;desc&&(desc.get||desc.set)?Object.defineProperty(newObj,key,desc):newObj[key]=obj[key]}return newObj.default=obj,cache&&cache.set(obj,newObj),newObj}function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}async function connectInParallel(options,lookup,signal){if(signal.aborted)throw new _abortError.default;const addresses=await lookupAllAddresses(options.host,lookup,signal);return await new Promise(((resolve,reject)=>{const sockets=new Array(addresses.length),errors=[];function onError(err){errors.push(err),this.removeListener("error",onError),this.removeListener("connect",onConnect),this.destroy(),errors.length===addresses.length&&(signal.removeEventListener("abort",onAbort),reject(new _esAggregateError.default(errors,"Could not connect (parallel)")))}function onConnect(){signal.removeEventListener("abort",onAbort);for(let j=0;j<sockets.length;j++){const socket=sockets[j];this!==socket&&(socket.removeListener("error",onError),socket.removeListener("connect",onConnect),socket.destroy())}resolve(this)}const onAbort=()=>{for(let j=0;j<sockets.length;j++){const socket=sockets[j];socket.removeListener("error",onError),socket.removeListener("connect",onConnect),socket.destroy()}reject(new _abortError.default)};for(let i=0,len=addresses.length;i<len;i++){const socket=sockets[i]=_net.default.connect({...options,host:addresses[i].address,family:addresses[i].family});socket.on("error",onError),socket.on("connect",onConnect)}signal.addEventListener("abort",onAbort,{once:!0})}))}async function connectInSequence(options,lookup,signal){if(signal.aborted)throw new _abortError.default;const errors=[],addresses=await lookupAllAddresses(options.host,lookup,signal);for(const address of addresses)try{return await new Promise(((resolve,reject)=>{const socket=_net.default.connect({...options,host:address.address,family:address.family}),onAbort=()=>{socket.removeListener("error",onError),socket.removeListener("connect",onConnect),socket.destroy(),reject(new _abortError.default)},onError=err=>{signal.removeEventListener("abort",onAbort),socket.removeListener("error",onError),socket.removeListener("connect",onConnect),socket.destroy(),reject(err)},onConnect=()=>{signal.removeEventListener("abort",onAbort),socket.removeListener("error",onError),socket.removeListener("connect",onConnect),resolve(socket)};signal.addEventListener("abort",onAbort,{once:!0}),socket.on("error",onError),socket.on("connect",onConnect)}))}catch(err){if(err instanceof Error&&"AbortError"===err.name)throw err;errors.push(err);continue}throw new _esAggregateError.default(errors,"Could not connect (sequence)")}async function lookupAllAddresses(host,lookup,signal){if(signal.aborted)throw new _abortError.default;return _net.default.isIPv6(host)?[{address:host,family:6}]:_net.default.isIPv4(host)?[{address:host,family:4}]:await new Promise(((resolve,reject)=>{const onAbort=()=>{reject(new _abortError.default)};signal.addEventListener("abort",onAbort),lookup(punycode.toASCII(host),{all:!0},((err,addresses)=>{signal.removeEventListener("abort",onAbort),err?reject(err):resolve(addresses)}))}))}