"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.instanceLookup=instanceLookup,exports.parseBrowserResponse=parseBrowserResponse;var _dns=_interopRequireDefault(require("dns")),_abortError=_interopRequireDefault(require("./errors/abort-error")),_sender=require("./sender"),_withTimeout=require("./utils/with-timeout");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}const SQL_SERVER_BROWSER_PORT=1434,TIMEOUT=2e3,RETRIES=3,MYSTERY_HEADER_LENGTH=3;async function instanceLookup(options){const server=options.server;if("string"!=typeof server)throw new TypeError('Invalid arguments: "server" must be a string');const instanceName=options.instanceName;if("string"!=typeof instanceName)throw new TypeError('Invalid arguments: "instanceName" must be a string');const timeout=void 0===options.timeout?TIMEOUT:options.timeout;if("number"!=typeof timeout)throw new TypeError('Invalid arguments: "timeout" must be a number');const retries=void 0===options.retries?RETRIES:options.retries;if("number"!=typeof retries)throw new TypeError('Invalid arguments: "retries" must be a number');if(void 0!==options.lookup&&"function"!=typeof options.lookup)throw new TypeError('Invalid arguments: "lookup" must be a function');const lookup=options.lookup??_dns.default.lookup;if(void 0!==options.port&&"number"!=typeof options.port)throw new TypeError('Invalid arguments: "port" must be a number');const port=options.port??SQL_SERVER_BROWSER_PORT,signal=options.signal;if(signal.aborted)throw new _abortError.default;let response;for(let i=0;i<=retries;i++)try{response=await(0,_withTimeout.withTimeout)(timeout,(async signal=>{const request=Buffer.from([2]);return await(0,_sender.sendMessage)(options.server,port,lookup,signal,request)}),signal)}catch(err){if(!signal.aborted&&err instanceof Error&&"TimeoutError"===err.name)continue;throw err}if(!response)throw new Error("Failed to get response from SQL Server Browser on "+server);const foundPort=parseBrowserResponse(response.toString("ascii",MYSTERY_HEADER_LENGTH),instanceName);if(!foundPort)throw new Error("Port for "+instanceName+" not found in "+options.server);return foundPort}function parseBrowserResponse(response,instanceName){let getPort;const instances=response.split(";;");for(let i=0,len=instances.length;i<len;i++){const parts=instances[i].split(";");for(let p=0,partsLen=parts.length;p<partsLen;p+=2){const name=parts[p],value=parts[p+1];if("tcp"===name&&getPort){return parseInt(value,10)}"InstanceName"===name&&(getPort=value.toUpperCase()===instanceName.toUpperCase())}}}