"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _nativeDuplexpair=_interopRequireDefault(require("native-duplexpair")),tls=_interopRequireWildcard(require("tls")),_events=require("events"),_message=_interopRequireDefault(require("./message")),_packet=require("./packet"),_incomingMessageStream=_interopRequireDefault(require("./incoming-message-stream")),_outgoingMessageStream=_interopRequireDefault(require("./outgoing-message-stream"));function _getRequireWildcardCache(nodeInterop){if("function"!=typeof WeakMap)return null;var cacheBabelInterop=new WeakMap,cacheNodeInterop=new WeakMap;return(_getRequireWildcardCache=function(nodeInterop){return nodeInterop?cacheNodeInterop:cacheBabelInterop})(nodeInterop)}function _interopRequireWildcard(obj,nodeInterop){if(!nodeInterop&&obj&&obj.__esModule)return obj;if(null===obj||"object"!=typeof obj&&"function"!=typeof obj)return{default:obj};var cache=_getRequireWildcardCache(nodeInterop);if(cache&&cache.has(obj))return cache.get(obj);var newObj={},hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj)if("default"!==key&&Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;desc&&(desc.get||desc.set)?Object.defineProperty(newObj,key,desc):newObj[key]=obj[key]}return newObj.default=obj,cache&&cache.set(obj,newObj),newObj}function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}class MessageIO extends _events.EventEmitter{constructor(socket,packetSize,debug){super(),this.socket=void 0,this.debug=void 0,this.tlsNegotiationComplete=void 0,this.incomingMessageStream=void 0,this.outgoingMessageStream=void 0,this.securePair=void 0,this.incomingMessageIterator=void 0,this.socket=socket,this.debug=debug,this.tlsNegotiationComplete=!1,this.incomingMessageStream=new _incomingMessageStream.default(this.debug),this.incomingMessageIterator=this.incomingMessageStream[Symbol.asyncIterator](),this.outgoingMessageStream=new _outgoingMessageStream.default(this.debug,{packetSize:packetSize}),this.socket.pipe(this.incomingMessageStream),this.outgoingMessageStream.pipe(this.socket)}packetSize(...args){if(args.length>0){const packetSize=args[0];this.debug.log("Packet size changed from "+this.outgoingMessageStream.packetSize+" to "+packetSize),this.outgoingMessageStream.packetSize=packetSize}return this.securePair&&this.securePair.cleartext.setMaxSendFragment(this.outgoingMessageStream.packetSize),this.outgoingMessageStream.packetSize}startTls(credentialsDetails,hostname,trustServerCertificate){credentialsDetails.maxVersion&&["TLSv1.2","TLSv1.1","TLSv1"].includes(credentialsDetails.maxVersion)||(credentialsDetails.maxVersion="TLSv1.2");const secureContext=tls.createSecureContext(credentialsDetails);return new Promise(((resolve,reject)=>{const duplexpair=new _nativeDuplexpair.default,securePair=this.securePair={cleartext:tls.connect({socket:duplexpair.socket1,servername:hostname,secureContext:secureContext,rejectUnauthorized:!trustServerCertificate}),encrypted:duplexpair.socket2},onSecureConnect=()=>{securePair.encrypted.removeListener("readable",onReadable),securePair.cleartext.removeListener("error",onError),securePair.cleartext.removeListener("secureConnect",onSecureConnect),securePair.cleartext.once("error",(err=>{this.socket.destroy(err)}));const cipher=securePair.cleartext.getCipher();cipher&&this.debug.log("TLS negotiated ("+cipher.name+", "+cipher.version+")"),this.emit("secure",securePair.cleartext),securePair.cleartext.setMaxSendFragment(this.outgoingMessageStream.packetSize),this.outgoingMessageStream.unpipe(this.socket),this.socket.unpipe(this.incomingMessageStream),this.socket.pipe(securePair.encrypted),securePair.encrypted.pipe(this.socket),securePair.cleartext.pipe(this.incomingMessageStream),this.outgoingMessageStream.pipe(securePair.cleartext),this.tlsNegotiationComplete=!0,resolve()},onError=err=>{securePair.encrypted.removeListener("readable",onReadable),securePair.cleartext.removeListener("error",onError),securePair.cleartext.removeListener("secureConnect",onSecureConnect),securePair.cleartext.destroy(),securePair.encrypted.destroy(),reject(err)},onReadable=()=>{const message=new _message.default({type:_packet.TYPE.PRELOGIN,resetConnection:!1});let chunk;for(;chunk=securePair.encrypted.read();)message.write(chunk);this.outgoingMessageStream.write(message),message.end(),this.readMessage().then((async response=>{securePair.encrypted.once("readable",onReadable);for await(const data of response)securePair.encrypted.write(data)})).catch(onError)};securePair.cleartext.once("error",onError),securePair.cleartext.once("secureConnect",onSecureConnect),securePair.encrypted.once("readable",onReadable)}))}sendMessage(packetType,data,resetConnection){const message=new _message.default({type:packetType,resetConnection:resetConnection});return message.end(data),this.outgoingMessageStream.write(message),message}async readMessage(){const result=await this.incomingMessageIterator.next();if(result.done)throw new Error("unexpected end of message stream");return result.value}}var _default=MessageIO;exports.default=_default,module.exports=MessageIO;